package provide app-AppMain 1.0

####
####
#Copyright 2003-2012 M. Wayne Davis
#All rights reserved
#Not for redistribution

#windows printing and metafile extensions
#Original Author: Michael I. Schwartz, mschwart@nyx.net



#set version number here
set version 2.0.46

#to do:

#todo: pcr tool, edit features from treeview, arrow edit tool, edit and save graphic data in feature libraries

#Bug: Selection only, digest; digestion shows the end-start fragment

## **** virtual PCR tool
## list primers window- list fwd, reverse, position, Tm (total and homologous), name and notes.
## save sequence window as svg for html display
## feature treeview widget in sequence window
## gibson tool
## feature find mismatches
##bug: unlink isn't working for graphic maps
#bug: moving ladders between digest windows

# search directory for sequence matches (AND, OR, NOT with multiple boxes)- return list of files to open
# add feature to library (single and multiple from list)

# com.apple.recentitems.plist to get recent items global value
# make analysis windows (translate, align, etc.) size to the last size of that type.

##link canvas data: COMMENT image {base64 data} (jpg, gif, tiff)

# autosave
# reopen files from quit
# fix about dialog, quit on last close
# make feature library from genbank file (read file, parse, create_window separately

#############
##virtual Golden Gate tool
#proc: search all enzymes for external overhang
proc golden_gate_enzymes {} {

#ggtctc 1/5 BsaI Bso31I Eco31I
#cgtctc 1/5 BsmBI Esp3I
#gaagac 2/6 BbsI BpiI BpuAI BstV2I
#cacctgc 4/8 AarI
#acctgc 4/8 Acc36I BfuAI BspMI BveI
#gcgatg 10/14 BtgZI

  global enzymes enzinfo
  set result [list]
  foreach enzyme $enzymes {
    set pattern $enzinfo(flatpat,$enzyme)
    set cs $enzinfo(enz_cut_sites,$enzyme)
    if {([lindex $cs 0] > [string length $pattern]) && ([lindex $cs 1] > [string length $pattern]) && ([expr {abs([lindex $cs 0] -[lindex $cs 1])}] > 3) && ([string length $pattern] > 5) && ![regexp {[^ACGT]} $pattern]} {
      lappend result $enzyme
    }
  }
  return $result
}

### return all gg fragment possibilities, window, frst index, both overhangs
proc golden_gate_fragments {enzyme} {
  global enzinfo info
  set result [list]
  foreach w $info(dnawindows_list) {
    if {!$info($w,scanned)} {findenzymes $w}
    for {set i 0} {$i < [expr {[llength $info($w,$enzyme)] - 1}] } {incr i} {
      if {[lindex  $info($w,enzdir,$enzyme) $i] == 0 && [lindex  $info($w,enzdir,$enzyme) [expr {$i +1}]] == 1} {
        set t [golden_gate_fragment $w $enzyme  $i [expr {$i +1}]]
        lappend result [list $w $i [string length [lindex $t 0]] [lindex $t 1]]
      }
    }
    if {$info($w,circular) eq "circular"} {
      if {[lindex  $info($w,enzdir,$enzyme) $i] == 0 && [lindex  $info($w,enzdir,$enzyme) 0] == 1} {
        set t [golden_gate_fragment $w $enzyme  $i 0]
        lappend result [list $w $i [string length [lindex $t 0]] [lindex $t 1]]
      }
    }
  }
  return $result
}

#proc: given window, enzyme and index of site1 and site2, return: site1 overhang, site1->site2 sequence (as list of 2 if split), site2 overhang 
proc golden_gate_fragment {w enzyme site1 site2} {
  global info enzinfo
  if {!$info($w,scanned)} {findenzymes $w}
  set text [textarea_get $w.textarea 1.0 end-1chars]
  set text0 $text
  set len [string length $text]
  set coff 0
  if {$info($w,circular) eq "circular"} {
    set text [string range $text end-24 end]$text[string range $text 0 24]
    set coff [expr {min(25, [string length [string range $text end-24 end]])}]
  }
  set ilist [list]
  set ohlist [list]
  foreach site [list $site1 $site2] {
    if {[lindex $info($w,enzdir,$enzyme) $site]} {
      #site is in reverse
      set i [expr {[lindex $info($w,$enzyme) $site]+ $coff + [string length $enzinfo(flatpat,$enzyme)] - [lindex $enzinfo(enz_cut_sites,$enzyme) 1] -1}]
    } else {
      #site is forward
      set i [expr {([lindex $info($w,$enzyme) $site]+ $coff + [lindex $enzinfo(enz_cut_sites,$enzyme) 0] -1)}]
    }
    lappend ilist [expr {($i - $coff) % $len}]
    if {[lindex $enzinfo(enz_cut_sites,$enzyme) 0] > [lindex $enzinfo(enz_cut_sites,$enzyme) 1]} {
      set oh [string range $text [expr {$i % ($len)}] [expr {$i % ($len)+[lindex $enzinfo(enz_cut_sites,$enzyme) 0]-[lindex $enzinfo(enz_cut_sites,$enzyme) 1] - 1}]]
    } else {
      set oh [string range $text [expr {$i % ($len)}] [expr {$i % ($len)+[lindex $enzinfo(enz_cut_sites,$enzyme) 1]-[lindex $enzinfo(enz_cut_sites,$enzyme) 0] - 1}]]
    }
    lappend ohlist [string toupper $oh]
  }
  if {[lindex $info($w,enzdir,$enzyme) $site1]} {
    if {[lindex $ilist 0] > [lindex $ilist 1]} {
      return [list [list [string range $text0 [lindex $ilist 1] [lindex $ilist 0]]] $ohlist]
    } else {
      return [list [list [string range $text0 0 [lindex $ilist 0]] [string range $text0 [lindex $ilist 1] end]] $ohlist]
    }
  } else {
    if {[lindex $ilist 0] < [lindex $ilist 1]} {
      return [list [list [string range $text0 [lindex $ilist 0] [lindex $ilist 1]]] $ohlist]
    } else {
      return [list [list [string range $text0 [lindex $ilist 0] end] [string range $text0 0 [lindex $ilist 1]]] $ohlist]
    }
  }
}

####
proc golden_gate_dialog {w} {
  global info modifier dialogblock modstring
  global ok gg_enz gg_info

  if {$dialogblock == 1} {return}
  set dialogblock 1
 
  set s [toplevel .gg_dialog]
  wm title $s [mc "Golden Gate Reaction..."]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"
  if {$w != "."} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry $s "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  }
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }
  set ok 0
  
  grid [frame $s.enzframe] -row 0 -column 0 -sticky nswe
  grid [menubutton $s.enzframe.menub -menu $s.enzframe.menub.m -textvariable gg_enz] -row 0 -column 1 -sticky nsew

  menu $s.enzframe.menub.m
  set gg_info(enz) ""
  set enz_list [golden_gate_enzymes]
  if {[llength $enz_list] == 0} {
    set gg_enz [mc "No Suitable Enzymes Available"]
  } elseif {[llength $enz_list] == 1} {
    set gg_enz [lindex $enz_list 0]
    set gg_info(enz) [lindex $enz_list 0]
  } else {
    set gg_enz [mc "Chose an Enzyme..."]
    foreach enz [golden_gate_enzymes] {
      $s.enzframe.menub.m add command -label "$enz" -command "set gg_enz $enz; set gg_info(enz) $enz; golden_gate_fill_dialog 0"
    }
  }

  grid [frame $s.seqsframe] -row 1 -column 0 -sticky nswe
  for {set i 0} {$i <20} {incr i} {
    grid [frame $s.seqsframe.seqframe$i] -row $i -column 0 -sticky nswe
    grid [label $s.seqsframe.seqframe$i.label -textvariable gg_info(seq,$i)] -row 0 -column 0 -sticky nsew
    grid [menubutton $s.seqsframe.seqframe$i.menub -menu $s.seqsframe.seqframe$i.menub.m -textvariable gg_info(seq,$i)] -row 0 -column 0 -sticky nsew
    set gg_info(seq,$i) ""
    set gg_info(w,$i) ""
    set gg_info(oh3,$i) ""
    set gg_info(oh5,$i) ""
    set gg_info(index,$i) ""
    set gg_info(dir,$i) ""
    menu $s.seqsframe.seqframe$i.menub.m
    $s.seqsframe.seqframe$i.menub.m add command -label "test $i"
    grid remove $s.seqsframe.seqframe$i.label
    grid remove $s.seqsframe.seqframe$i
  }

  grid [frame $s.okframe] -row 3 -column 0 -sticky nswe
  grid [button $s.okframe.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 0 -sticky nw -padx 10 -pady 3
  grid [button $s.okframe.ok -text [mc "OK"] -command "set ok 1" -default active -state disabled] -row 1 -column 1 -sticky nw -padx 10 -pady 3

  if {[llength $enz_list] == 1} {
    golden_gate_fill_dialog 0
  }

  vwait ok

  destroy $s
  set dialogblock 0
  bind . <<RaiseDialogs>> ""

  if {$ok == 1} {
    set seq_and_tags [golden_gate_seq_and_tags $gg_info(w,0) $gg_info(enz) $gg_info(index,0) $gg_info(dir,0)]
    set dna [lindex $seq_and_tags 1 0] 
    set tags [lindex $seq_and_tags 1 1]
    set lastdna [lindex $seq_and_tags 0 0] 
    set last_tags [lindex $seq_and_tags 0 1]
    for {set i 1} {($gg_info(w,$i) ne "") && ($i < 20)} {incr i} {
      set seq_and_tags [golden_gate_seq_and_tags $gg_info(w,$i) $gg_info(enz) $gg_info(index,$i) $gg_info(dir,$i)]
      foreach seq_and_tag $seq_and_tags {
        set end [string length $dna]
        append dna [lindex $seq_and_tag 0]
        set new_tags [lindex $seq_and_tag 1]
        foreach {tag data} $new_tags {
          lset data 0 [list [expr {$end + [lindex $data 0 0]}] [expr {$end + [lindex $data 0 1]}]]
          lappend tags $tag $data
        }
      }
    }
    set end [string length $dna]
    append dna $lastdna
    foreach {tag data} $last_tags {
      lset data 0 [list [expr {$end + [lindex $data 0 0]}] [expr {$end + [lindex $data 0 1]}]]
      lappend tags $tag $data
    }
    create_window $dna "" "" "circular" 1 0 New_DNA $tags {} genbank
  }
  unset ok gg_enz gg_info
}

proc golden_gate_fill_dialog {pos} {
  global gg_info
  set s .gg_dialog
  if {$gg_info(enz) == ""} return
  if {($pos > 0) && ($gg_info(oh5,0) == $gg_info(oh3,[expr {$pos-1}]))} {
    #check pos-1 3' end for closing the circle- set ok to active and grid remove from pos to end then return
    for {set i [expr {$pos}]} {$i <20} {incr i} {
      grid remove $s.seqsframe.seqframe$i
      set gg_info(oh3,$i) ""
      set gg_info(oh5,$i) ""
      set gg_info(seq,$i) ""
      set gg_info(w,$i) ""
      set gg_info(index,$i) ""
      set gg_info(dir,$i) ""
    }
    $s.okframe.ok configure -state normal
    return
  }
  set frag_list [lsort -index 2 -integer [golden_gate_fragments $gg_info(enz)]];## can pass this down the recursion
  if {($pos > 0)} {
    set oh3 $gg_info(oh3,[expr {$pos-1}])
  } else {
    set oh3 ""
  }
  set new_frag_list [list]
  set new_frag_match 1;# make 0 if 3' ends don't all match
  set last_oh3 ""
  foreach frag $frag_list {
    set oh_list [lindex $frag 3]
    if {($oh3 == "") || ([lindex $oh_list 0] == $oh3)} {
      lappend new_frag_list [list [lindex $frag 0] [lindex $oh_list 0] [lindex $oh_list 1] [lindex $frag 1] 0]
      if {$last_oh3 == ""} {
        set last_oh3 [lindex $oh_list 1]
      } elseif {$last_oh3 ne [lindex $oh_list 1]} {
        set new_frag_match 0
      }
    }
    if {[revcom [lindex $oh_list 1]] == $oh3} {
      lappend new_frag_list [list [lindex $frag 0] [revcom [lindex $oh_list 1]] [revcom [lindex $oh_list 0]] [lindex $frag 1] 1]
      if {$last_oh3 == ""} {
        set last_oh3 [revcom [lindex $oh_list 0]]
      } elseif {$last_oh3 ne [revcom [lindex $oh_list 0]]} {
        set new_frag_match 0
      }
    }
      ##needs to save list elements: window, oh5, oh3, index0, dir
  }


#find all fragments that are compatible with pos-1 3' end, add them to menubutton (or label, if only 1)
#for all new 3' ends, check if they are all the same- if so, check if they match pos+1 5' ends, if so stop, if not fill pos+1, if not the same grid remove pos+1 to end and reset ends 
  grid configure $s.seqsframe.seqframe$pos
  if {([llength $new_frag_list] > 0) && ($pos < 19)} {
    if {[llength $new_frag_list] > 1} {
      $s.seqsframe.seqframe$pos.menub.m delete 0 end
      grid configure $s.seqsframe.seqframe$pos.menub
      grid remove $s.seqsframe.seqframe0.label
      if {$new_frag_match} {
        foreach frag $new_frag_list {
          $s.seqsframe.seqframe$pos.menub.m add command -label [wm title [lindex $frag 0]] -command "set gg_info(seq,$pos) \{[wm title [lindex $frag 0]]\}; set gg_info(w,$pos) [lindex $frag 0]; set gg_info(oh3,$pos) [lindex $frag 2]; set gg_info(index,$pos) [lindex $frag 3]; set gg_info(dir,$pos) [lindex $frag 4]"
        }
        set gg_info(seq,$pos) [wm title [lindex [lindex $new_frag_list 0] 0]]
        set gg_info(w,$pos) [lindex [lindex $new_frag_list 0] 0]
        set gg_info(oh3,$pos) [lindex [lindex $new_frag_list 0] 2]
        set gg_info(oh5,$pos) [lindex [lindex $new_frag_list 0] 1]
        set gg_info(index,$pos) [lindex [lindex $new_frag_list 0] 3]
        set gg_info(dir,$pos) [lindex [lindex $new_frag_list 0] 4]
        if {$gg_info(oh3,$pos) ne $gg_info(oh5,[expr {$pos+1}])} {
          golden_gate_fill_dialog [expr {$pos +1}]
        }
      } else {
        foreach frag $new_frag_list {
          $s.seqsframe.seqframe$pos.menub.m add command -label [wm title [lindex $frag 0]] -command "set gg_info(seq,$pos) \{[wm title [lindex $frag 0]]\}; set gg_info(w,$pos) [lindex $frag 0]; set gg_info(oh5,$pos) [lindex $frag 1]; set gg_info(oh3,$pos) [lindex $frag 2]; set gg_info(index,$pos) [lindex $frag 3]; set gg_info(dir,$pos) [lindex $frag 4]; golden_gate_fill_dialog [expr {$pos+1}]"
        }
        set gg_info(seq,$pos) [mc "Choose a Fragment"]
        set gg_info(w,$pos) ""
        set gg_info(oh3,$pos) ""
        set gg_info(index,$pos) ""
        set gg_info(dir,$pos) ""
        for {set i [expr {$pos +1}]} {$i <20} {incr i} {
          grid remove $s.seqsframe.seqframe$i
          set gg_info(oh3,$i) ""
          set gg_info(oh5,$i) ""
          set gg_info(seq,$i) ""
          set gg_info(w,$i) ""
          set gg_info(index,$i) ""
          set gg_info(dir,$i) ""
        }
        $s.okframe.ok configure -state disabled
      }
    } else {
      #single match
      set gg_info(seq,$pos) [wm title [lindex [lindex $new_frag_list 0] 0]]
      set gg_info(w,$pos) [lindex [lindex $new_frag_list 0] 0]
      set gg_info(oh5,$pos) [lindex [lindex $new_frag_list 0] 1]
      set gg_info(oh3,$pos) [lindex [lindex $new_frag_list 0] 2]
      set gg_info(index,$pos) [lindex [lindex $new_frag_list 0] 3]
      set gg_info(dir,$pos) [lindex [lindex $new_frag_list 0] 4]
      grid remove $s.seqsframe.seqframe$pos.menub
      grid configure $s.seqsframe.seqframe$pos.label
      if {$gg_info(oh3,$pos) ne $gg_info(oh5,[expr {$pos+1}])} {
        golden_gate_fill_dialog [expr {$pos +1}]
      }
    }
  } else {
#no fragments match the 3' end
    grid remove $s.seqsframe.seqframe$pos.menub
    grid configure $s.seqsframe.seqframe$pos.label
    set gg_info(seq,$pos) [mc "No Matching Fragments"]
    set gg_info(w,$pos) ""
    for {set i [expr {$pos +1}]} {$i <20} {incr i} {
      grid remove $s.seqsframe.seqframe$i
      set gg_info(oh3,$i) ""
      set gg_info(oh5,$i) ""
      set gg_info(seq,$i) ""
      set gg_info(w,$i) ""
      set gg_info(index,$i) ""
      set gg_info(dir,$i) ""
    }
    $s.okframe.ok configure -state disabled
  }

}

##### return fragments as DNA and tags suitable for create_window
proc golden_gate_seq_and_tags {w enzyme site1 dir} {
  global enzinfo info
  #site is forward
  if {$enzyme eq ""} return
  set i1 [expr {([lindex $info($w,$enzyme) $site1]+ [lindex $enzinfo(enz_cut_sites,$enzyme) $dir] -1)}]
  set site2 [expr {($site1 + 1)% [llength  $info($w,$enzyme)]}]
  #site is in reverse
  set i2 [expr {[lindex $info($w,$enzyme) $site2] + [string length $enzinfo(flatpat,$enzyme)] - [lindex $enzinfo(enz_cut_sites,$enzyme) [expr {!$dir}]] -1}]

  if {$site2 > 0} {
    set newdna  [textarea_get $w.textarea [bp2ix $w.textarea $i1] [bp2ix $w.textarea $i2]]
    set new_tags [get_tags $w.textarea [list [bp2ix $w.textarea $i1] [bp2ix $w.textarea $i2]] [expr {$dir?"reverse":"forward"}]]
    return [list [list] [list [expr {$dir?[revcom $newdna]:$newdna}] $new_tags]]
  } else {
    if {$i2 <= 0} {
      set newdna  [textarea_get $w.textarea [bp2ix $w.textarea $i1] [bp2ix $w.textarea [expr {[ix2bp $w.textarea  [$w.textarea index end]] + $i2}]]]
      set new_tags [get_tags $w.textarea [list [bp2ix $w.textarea $i1] [bp2ix $w.textarea [expr {[ix2bp $w.textarea  [$w.textarea index end]] + $i2}] ]]  [expr {$dir?"reverse":"forward"}]]
      return [list [list [expr {$dir?[revcom $newdna]:$newdna}] $new_tags] [list]]
    }
    if {$i1 > [ix2bp $w.textarea  [$w.textarea index end]]} {
      set i1 [expr {$i1 - [ix2bp $w.textarea [$w.textarea index end]]}]
      set newdna  [textarea_get $w.textarea [bp2ix $w.textarea $i1] [bp2ix $w.textarea $i2]]
      set new_tags [get_tags $w.textarea [list [bp2ix $w.textarea $i1] [bp2ix $w.textarea $i2]] [expr {$dir?"reverse":"forward"}]]
      return [list  [list] [list [expr {$dir?[revcom $newdna]:$newdna}] $new_tags]] 
    }
    #return both fragments
      set newdna  [textarea_get $w.textarea [bp2ix $w.textarea $i1] end]
      set new_tags [get_tags $w.textarea [list [bp2ix $w.textarea $i1] end] [expr {$dir?"reverse":"forward"}]]
      set newdna1  [textarea_get $w.textarea [bp2ix $w.textarea 0] [bp2ix $w.textarea $i2]]
      set new_tags1 [get_tags $w.textarea [list [bp2ix $w.textarea 0] [bp2ix $w.textarea $i2]] [expr {$dir?"reverse":"forward"}]]
      if {$dir} {
        return [list  [list [revcom $newdna1] $new_tags] [list [revcom $newdna] $new_tags1]] 
      } else {
        return [list  [list $newdna $new_tags] [list $newdna1 $new_tags1]] 
      }
  }
}


#################
## virtual PCR tool: primers 1 and  2 (
# add drop downs to select primer features already in the sequence
# add primer name entry box (fills from feature)
# add find from selection frame (show frame as last option on feature dropdown)- min size, target Tm, 
# add button to add restriction site (menubutton, uses selected enzymes, or >6 non-degenerate if no selected enzymes)- possibly in the more oprtions frame
# add template menubutton
# if multiple binding show dropdown or radiobuttons for which site- show Tm1, Tm2 and mismatches for each site
# add revcom and reverse to popup menus
# add swap primers button
# output a new file . show Tm of matching and final (add to comment window of new file).  
# Option to load features file of primer sites. primer_bind qualifier: /PCR_conditions="text" to store primer and Tms

proc pcr_reaction_dialog {w} {
  global info modifier dialogblock modstring
  global ok

  if {$dialogblock == 1} {return}
  set dialogblock 1
 
  set s [toplevel .pcr_dialog]
  wm title $s [mc "PCR Reaction..."]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"
  if {$w != "."} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry $s "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  }
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }
  set ok 0
  

  grid [frame $s.source] -row 0 -column 0 -sticky nswe
  grid [label $s.source.parent_info -text "[mc {Template:}] $info($w,win_title)"] -row 0 -column 0 -sticky nswe

  #primer 1
  grid [frame $s.source.primer1_frame] -row 1 -column 0 -sticky nwe
  grid [label $s.source.primer1_frame.primer1_label -text [mc {Primer1:}]] -row 0 -column 0 -sticky nwe
  grid [entry $s.source.primer1_frame.primer1 -width 50 -textvariable info(pcr_dialog_primer1) -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color) -font dnafont ] -row 0 -column 1 -sticky nwe
  bind $s.source.primer1_frame.primer1 <FocusOut> "pcr_reaction_dialog_update $w $s" 
  grid [label $s.source.primer1_frame.primer1_info -justify left] -row 1 -column 0 -columnspan 3 -sticky nw
  set popupmenu [menu $s.source.primer1_frame.primer1.popupmenu]
  $popupmenu add command -label [mc "Cut"]  -accelerator "$modstring+X" -command "event generate $s.source.primer1_frame.primer1 <<Cut>>"
  $popupmenu add command -label [mc "Copy"]  -accelerator "$modstring+C" -command "event generate $s.source.primer1_frame.primer1 <<Copy>>"
  $popupmenu add command -label [mc "Paste"]  -accelerator "$modstring+V" -command "event generate $s.source.primer1_frame.primer1 <<Paste>>"
##options: paste rev-com, rev-com, insert selection, insert selection rev-com (use max 25 bp of selection)
  if {[tk windowingsystem] != "aqua"} {
    bind $s.source.primer1_frame.primer1 <Button-3> "tk_popup $popupmenu %X %Y"
  } else {
    bind $s.source.primer1_frame.primer1 <Button-2> "tk_popup $popupmenu %X %Y"
    bind $s.source.primer1_frame.primer1 <Control-Button-1> [bind $w.textarea <Button-2>]
  }

  #primer 2
  grid [frame $s.source.primer2_frame] -row 2 -column 0 -sticky nwe
  grid [label $s.source.primer2_frame.primer2_label -text [mc {Primer2:}]] -row 0 -column 0 -sticky nwe
  grid [entry $s.source.primer2_frame.primer2 -width 50 -textvariable info(pcr_dialog_primer2) -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color) -font dnafont] -row 0 -column 1 -sticky nwe
  bind $s.source.primer2_frame.primer2 <FocusOut> "pcr_reaction_dialog_update $w $s" 
  grid [label $s.source.primer2_frame.primer2_info -justify left -text {}] -row 1 -column 0 -columnspan 3 -sticky nw
  set popupmenu [menu $s.source.primer2_frame.primer2.popupmenu]
  $popupmenu add command -label [mc "Cut"]  -accelerator "$modstring+X" -command "event generate $s.source.primer2_frame.primer2 <<Cut>>"
  $popupmenu add command -label [mc "Copy"]  -accelerator "$modstring+C" -command "event generate $s.source.primer2_frame.primer2 <<Copy>>"
  $popupmenu add command -label [mc "Paste"]  -accelerator "$modstring+V" -command "event generate $s.source.primer2_frame.primer2 <<Paste>>"
  if {[tk windowingsystem] != "aqua"} {
    bind $s.source.primer2_frame.primer2 <Button-3> "tk_popup $popupmenu %X %Y"
  } else {
    bind $s.source.primer2_frame.primer2 <Button-2> "tk_popup $popupmenu %X %Y"
    bind $s.source.primer2_frame.primer2 <Control-Button-1> [bind $s.source.primer2_frame.primer2 <Button-2>]
  }

  #parameters
  grid [frame $s.parameters_frame -relief ridge -bd 3] -row 2 -column 0 -sticky nswe
  grid [label $s.parameters_frame.3primematch_label -text [mc {Minimum 3' match:}]] -row 0 -column 0 -sticky ne  
  grid [menubutton $s.parameters_frame.3primematch -menu $s.parameters_frame.3primematch.menu -textvariable info(pcr_dialog_3_prime_match)] -row 0 -column 1 -sticky nw
  menu $s.parameters_frame.3primematch.menu
  for {set a 10} {$a <26} {incr a} {
    $s.parameters_frame.3primematch.menu add radiobutton -label $a -variable info(pcr_dialog_3_prime_match) -value $a -command "pcr_reaction_dialog_update $w $s"
  }
  grid [label $s.parameters_frame.3primemismatch_label -text [mc {Maximum mismatch:}]] -row 1 -column 0 -sticky ne  
  grid [menubutton $s.parameters_frame.3primemismatch -menu $s.parameters_frame.3primemismatch.menu -textvariable info(pcr_dialog_3_prime_mismatch)] -row 1 -column 1 -sticky nw
  menu $s.parameters_frame.3primemismatch.menu
  foreach a {0 1 2 3 4 5 6} {
    $s.parameters_frame.3primemismatch.menu add radiobutton -label $a -variable info(pcr_dialog_3_prime_mismatch) -value $a -command "pcr_reaction_dialog_update $w $s"
  }

  grid [frame $s.okframe] -row 3 -column 0 -sticky nswe
  grid [button $s.okframe.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 0 -sticky nw -padx 10 -pady 3
  grid [button $s.okframe.ok -text [mc "OK"] -command "set ok 1" -default active -state disabled] -row 1 -column 1 -sticky nw -padx 10 -pady 3

  pcr_reaction_dialog_update $w $s
  vwait ok

  destroy $s
  set dialogblock 0
  bind . <<RaiseDialogs>> ""

  if {$ok == 1} {

  }
  unset ok
}
 
set info(pcr_dialog_3_prime_match) 10
set info(pcr_dialog_3_prime_mismatch) 0
proc pcr_reaction_dialog_update {w s} {
  global info
  if {![winfo exists $s] || ![winfo exists $w]} return
  set text [textarea_get $w.textarea 1.0 end-1c]

  set reslist [list]
  foreach i_var {pcr_dialog_primer1 pcr_dialog_primer2} label_item [list $s.source.primer1_frame.primer1_info $s.source.primer2_frame.primer2_info] {
    set search [string range $info($i_var) "end-$info(pcr_dialog_3_prime_match)" end]
    regsub -all -nocase {[^abcdghkmnrstvwy]} $search "" search
    if {[string length $search] >= $info(pcr_dialog_3_prime_match)} {
      set text2 $text
      if {$info($w,circular) eq "circular"} {
        append text2 [string range $text2 0 [expr {[string length $search] -1}]]
      }
      set f_reslist [search_with_mm $search $text2 $info(pcr_dialog_3_prime_mismatch)]
      set r_reslist [search_with_mm [revcom $search] $text2 $info(pcr_dialog_3_prime_mismatch)]
      $label_item configure -text "[llength $f_reslist] fwd; [llength $r_reslist] rev"
##show Tm of matching and non-matching segments (expand match- use max mismatch??)
      lappend reslist $f_reslist $r_reslist
    } else {
      $label_item configure -text [mc {Primer length <minimum.}]
      lappend reslist {} {}
    }
  }
  if {(([llength [lindex $reslist 0]] == 1) && ([llength [lindex $reslist 3]] == 1)) || (([llength [lindex $reslist 1]] == 1) && ([llength [lindex $reslist 2]] ==1)) } {
    $s.okframe.ok configure -state normal
  } else {
    $s.okframe.ok configure -state disabled
  }

}


#######multi-fragment loxP
proc lox_recombination_window {w} {
  global info modifier dialogblock 
  global ok loxP_acceptor  loxP_acceptor_win loxP_donor

  if {$dialogblock == 1} {return}
  set dialogblock 1
 
  set loxP_acceptor ""
  set a [toplevel .dialog]
  wm title .dialog [mc "Mutifragment Cre Reaction..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  if {$w != "."} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  }
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0

  grid [frame $a.acceptorframe -relief ridge -borderwidth 2] -row 1 -column 1 -sticky nswe
  grid [menubutton $a.acceptorframe.menubutton -textvariable loxP_acceptor_win -menu $a.acceptorframe.menubutton.menu -indicator on -relief raised] -row 1 -column 1
  set loxP_acceptor_win [mc "Chose an Acceptor Vector"]
  menu $a.acceptorframe.menubutton.menu
  set maxwidth 25
  set loxP_acceptor ""
  foreach {win} [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
    set window [string range $win 0 end-1]
    set text [textarea_get $window.textarea 1.0 end-1c]
    set len [string length $text]
    if {$info($window,circular) == "circular"} {
      append text [string range $text 0 33]
    }
    set loxP_list  [dict get $info(recomb,sites) loxP]
    set loxP_site [regsubpattern "[lindex $loxP_list 0][lindex $loxP_list 1][lindex $loxP_list 2]"]
    set index_list1 [regexp -all -indices -nocase -inline $loxP_site $text]
    if {[llength $index_list1] > 1 && [lindex $index_list1 1 0] >= $len} {
      set index_list1 [lrange  $index_list1 0 0]
    }
    set loxP_site [revcom_regexp $loxP_site]
    set index_list2 [regexp -all -indices -nocase -inline $loxP_site $text]
    if {[llength $index_list2] > 1 && [lindex $index_list2 1 1] >= $len} {
      set index_list2 [lrange  $index_list2 0 0]
    }
    if {[llength $index_list1] == 1 && [llength $index_list2] == 0} {
      $a.acceptorframe.menubutton.menu add radiobutton -label $info($window,win_title) -variable loxP_acceptor -value "$window,$index_list1,0" -command "fill_loxP_frame; set loxP_acceptor_win \"$info($window,win_title)\""
      if {[string length $info($window,win_title)] > $maxwidth} {set maxwidth [string length $info($window,win_title)]}   
    } elseif {[llength $index_list1] == 0 && [llength $index_list2] == 1} {
      $a.acceptorframe.menubutton.menu add radiobutton -label $info($window,win_title) -variable loxP_acceptor -value "$window,$index_list2,1" -command "fill_loxP_frame; set loxP_acceptor_win \"$info($window,win_title)\""
      if {[string length $info($window,win_title)] > $maxwidth} {set maxwidth [string length $info($window,win_title)]}   
    }
  }
  set loxP_acceptor ""
  incr maxwidth 3
  if {$maxwidth > 200} {set maxwidth 200}
  $a.acceptorframe.menubutton configure -width $maxwidth
  grid [labelframe $a.donorframe -relief ridge -borderwidth 2 -text [mc "Donor Vectors"]] -row 2 -column 1 -sticky nswe
  grid [frame $a.okframe] -row 3 -column 1 -sticky nswe
  grid [button $a.okframe.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 0 -sticky nw -padx 10 -pady 3
  grid [button $a.okframe.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 1 -sticky nw -padx 10 -pady 3


  vwait ok

  destroy $a
  set dialogblock 0
  bind . <<RaiseDialogs>> ""
  if {$ok == 1 && ([regexp {(.+),(.+),([0-1])} $loxP_acceptor blank loxP_acceptor_win loxP_acceptor_ix loxP_acceptor_dir])} {
    set w $loxP_acceptor_win
    set acceptor_title [file rootname $info($w,win_title)]
    if {$loxP_acceptor_dir} {
      set loxP_acceptor_ix [expr {[lindex $loxP_acceptor_ix 0 1]+2}]
      set first_dna [revcom [textarea_get $w.textarea [bp2ix $w.textarea [expr $loxP_acceptor_ix]] end]]
      set first_tags [get_tags $w.textarea [list [bp2ix $w.textarea [expr $loxP_acceptor_ix]] end] "reverse"]
      set last_dna [revcom [textarea_get $w.textarea [bp2ix $w.textarea 0] [bp2ix $w.textarea [expr $loxP_acceptor_ix]]]]
      set last_tags [get_tags $w.textarea [list 1.0 [bp2ix $w.textarea [expr $loxP_acceptor_ix]]] "reverse"]
    } else {
      set loxP_acceptor_ix [lindex $loxP_acceptor_ix 0 0]
      set first_dna  [textarea_get $w.textarea [bp2ix $w.textarea 0] [bp2ix $w.textarea $loxP_acceptor_ix]]
      set first_tags [get_tags $w.textarea [list [bp2ix $w.textarea 0] [bp2ix $w.textarea $loxP_acceptor_ix]] "forward"]
      set last_dna  [textarea_get $w.textarea [bp2ix $w.textarea $loxP_acceptor_ix] end]
      set last_tags [get_tags $w.textarea [list [bp2ix $w.textarea $loxP_acceptor_ix] end] "forward"]
    }
    set loxplist [list]
    foreach p [array names loxP_donor] {
      if {$loxP_donor($p) ne 0} {
         lappend loxplist $loxP_donor($p)
       }
    }
    set new_win_list [list]
    foreach loxplist2 [combinations $loxplist] {
      set dna $first_dna
      set tags $first_tags
      set new_title $acceptor_title 
      foreach loxp_donor $loxplist2 {
        if {![regexp {(.+),(.+),([0-1])} $loxp_donor blank loxp_donor_win loxp_donor_ix loxp_donor_dir]} {
          continue
        }
        set end [string length $dna]
        set w $loxp_donor_win
        if {$loxp_donor_dir} {
          set loxp_donor_ix [expr {[lindex $loxp_donor_ix 0 1]+2}]
          set d1_dna [revcom [textarea_get $w.textarea [bp2ix $w.textarea [expr $loxp_donor_ix]] end]]
          set d1_tags [get_tags $w.textarea [list [bp2ix $w.textarea [expr $loxp_donor_ix]] end] "reverse"]
          set d2_dna [revcom [textarea_get $w.textarea [bp2ix $w.textarea 0] [bp2ix $w.textarea [expr $loxp_donor_ix]]]]
          set d2_tags [get_tags $w.textarea [list 1.0 [bp2ix $w.textarea [expr $loxp_donor_ix]]] "reverse"]
        } else {
          set loxp_donor_ix [lindex $loxp_donor_ix 0 0]
          set d1_dna  [textarea_get $w.textarea [bp2ix $w.textarea 0] [bp2ix $w.textarea $loxp_donor_ix]]
          set d1_tags [get_tags $w.textarea [list [bp2ix $w.textarea 0] [bp2ix $w.textarea $loxp_donor_ix]] "forward"]
          set d2_dna  [textarea_get $w.textarea [bp2ix $w.textarea $loxp_donor_ix] end]
          set d2_tags [get_tags $w.textarea [list [bp2ix $w.textarea $loxp_donor_ix] end] "forward"]
        }
        append dna $d1_dna
        foreach {tag data} $d1_tags {
          lset data 0 [list [expr {$end + [lindex $data 0 0]}] [expr {$end + [lindex $data 0 1]}]]
          lappend tags $tag $data
        }
        set end [string length $dna]
        append dna $d2_dna
        foreach {tag data} $d2_tags {
          lset data 0 [list [expr {$end + [lindex $data 0 0]}] [expr {$end + [lindex $data 0 1]}]]
          lappend tags $tag $data
        }
        append new_title _ [file rootname $info($w,win_title)]
      }
      set end [string length $dna]
      append dna $last_dna
      foreach {tag data} $last_tags {
        lset data 0 [list [expr {$end + [lindex $data 0 0]}] [expr {$end + [lindex $data 0 1]}]]
        lappend tags $tag $data
      }
      lappend new_win_list [create_window $dna "" "" "circular" 1 0 $new_title $tags {} Genbank]
    }
    set savedir [tk_chooseDirectory]
    if {$savedir ne ""} {
      foreach w $new_win_list {
        save_file $w Save Genbank [file join $savedir $info($w,win_title)]
      }
    }
  }
 
  unset -nocomplain ok loxP_acceptor loxP_acceptor_win loxP_donor
}

######
proc combinations {l} {
  if {[llength $l] == 1} {
    return [list $l]
  } else {
    set reslist [list]
    for {set i 0} {$i < [llength $l]} {incr i} {
      foreach l2 [combinations [lreplace $l $i $i]] {
        lappend reslist [concat [list [lindex $l $i]] $l2]
      }
    }
    return $reslist
  }
}

###
proc fill_loxP_frame {} {
  global loxP_acceptor loxP_donor info
  set a .dialog
  set i 0
  foreach {win} [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
    set window [string range $win 0 end-1]
    if {[regexp "$window," $loxP_acceptor]} continue
    set text [textarea_get $window.textarea 1.0 end-1c]
    set len [string length $text]
    if {$info($window,circular) == "circular"} {
      append text [string range $text 0 33]
    }
    set loxP_list  [dict get $info(recomb,sites) loxP]
    set loxP_site [regsubpattern "[lindex $loxP_list 0][lindex $loxP_list 1][lindex $loxP_list 2]"]
    set index_list1 [regexp -all -indices -nocase -inline $loxP_site $text]
    if {[llength $index_list1] > 1 && [lindex $index_list1 1 0] >= $len} {
      set index_list1  [lrange $index_list1 0 0]
    }
    set loxP_site [revcom_regexp $loxP_site]
    set index_list2 [regexp -all -indices -nocase -inline $loxP_site $text]
    if {[llength $index_list2] > 1 && [lindex $index_list2 1 0] >= $len} {
      set index_list2  [lrange $index_list2 0 0]
    }
    if {[llength $index_list1] == 1 && [llength $index_list2] == 0} {
      catch {destroy $a.donorframe.c$i}
      grid [checkbutton $a.donorframe.c$i -text $info($window,win_title) -variable loxP_donor($i) -onvalue "$window,$index_list1,0" -selectcolor white] -row $i -column 0 -sticky w
      set loxP_donor($i) 0
      incr i
    } elseif {[llength $index_list1] == 0 && [llength $index_list2] == 1} {
      catch {destroy $a.donorframe.c$i}
      grid [checkbutton $a.donorframe.c$i -text $info($window,win_title) -variable loxP_donor($i) -onvalue "$window,$index_list2,1" -selectcolor white] -row $i -column 0 -sticky w
      set loxP_donor($i) 0
      incr i
    }
  }
  while {[winfo exists $a.donorframe.c$i]} {
    catch {destroy $a.donorframe.c$i}
    array unset loxP_donor $i
    incr i
  }
}

###
proc digest_open_windows {} {
  global info
  set dnawinlist []
  foreach window [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
    lappend dnawinlist [string range $window 0 end-1]
  }
sputs $dnawinlist
  set a [new_analysis_window $dnawinlist "Multi-digest $info(enz_currently_selected)"]
  create_textframe $a 100
  set outputmenu [add_output_menu $a.textframe.text "Text" text .]
  $a.textframe.text insert end "Digest: [join $info(enz_currently_selected) ,]\n"
  foreach window $dnawinlist {
    set w $window
    findenzymes $w
    set start 1
    set total_length [ix2bp $w.textarea [$w.textarea index end-1chars]]
    if {$total_length < 1} continue
    set end $total_length
    set templist [list]
    foreach enzyme $info(enz_currently_selected) {
      if {($info($w,circular) != "circular")} {
        ##on linear fragments reject sites that CUT outside the range
        foreach site $info($w,$enzyme) dir $info($w,enzdir,$enzyme) {
          if {$site >= $end} {break}
          if {$site >= $start} {
            set cutsitelist [enz_cut_offset $enzyme $site $dir]
            if {([lindex $cutsitelist 0] >= $start) && ([lindex $cutsitelist 1] >= $start) && ([lindex $cutsitelist 0] <= $end) && ([lindex $cutsitelist 1] <= $end)} {
              lappend templist [list $site $enzyme $dir]
            }
          }
        }
      } else {
        foreach site $info($w,$enzyme) dir $info($w,enzdir,$enzyme) {
          if {$site >= $end} {break}
          if {$site >= $start} {lappend templist [list $site $enzyme $dir]}
        }
      }
    }
    if {($info($w,circular) != "circular")} {
      lappend templist [list $start "Start" 0]
      lappend templist [list $end "End" 0]
    }
    set templist [lsort -integer -index 0 $templist]
    set fraglist [list]
    set i 0
    set lastsite [lindex [lindex $templist 0] 0]
    set lastenz [lindex [lindex $templist 0] 1]
    set lastsitedir [lindex [lindex $templist 0] 2]
    foreach pair [lrange $templist 1 end] {
      if {[expr {[lindex $pair 0]- $lastsite}] > 0} {
        lappend fraglist [list [expr {[lindex $pair 0]- $lastsite}] $lastenz $lastsite [lindex $pair 1] [lindex $pair 0] $i [expr {round(100.0*([lindex $pair 0]- $lastsite)/$total_length)}] $lastsitedir [lindex $pair 2]]
        set lastsite [lindex $pair 0]
        set lastenz [lindex $pair 1]
        set lastsitedir [lindex $pair 2]
        incr i
      }
    }
    if {($info($w,circular) == "circular")} {
      if {$templist != [list]} {
        lappend fraglist [list [expr {[lindex [lindex $templist 0] 0]+ $total_length - $lastsite}] $lastenz $lastsite [lindex [lindex $templist 0] 1] [lindex [lindex $templist 0] 0] $i [expr {round(100.0*([lindex [lindex $templist 0] 0]+ $total_length - $lastsite)/$total_length)}] $lastsitedir [lindex [lindex $templist 0] 2]]
      } else {    
        lappend fraglist [list  $total_length uncut 0 "" 0 0 100 0 0]
      }
    }
    set fraglist [lsort -integer -index 0 -decreasing $fraglist]
    set fragout [list]
    foreach frag $fraglist {
      if {[lindex $frag 1] ne "uncut"} {
        lappend fragout [lindex $frag 0]
      } else {
        lappend fragout "[lindex $frag 0] (uncut)"
      }
    }
    $a.textframe.text insert end "$info($w,win_title): [join $fragout ,]\n"
  }
}



### drag and drop cloning: selecting a digest band or enzyme in a map causes storing of marks for the bottom strand anchor and insert (anything that sets the anchor or insert marks needs to set the bottom marks too), can drag the selection to a sequence window and it will check for compatibility with the 5' and 3' overhang data (if it is linear). Will check for ligatability and/ or gibson ability. Will add it together and update the overhang data if compatible- needs GUI input if the fragment is compatible with both ends, or in both orientations. Will open a cloning dialog to process the ends of the incoming fragment if not compatible. Select-all and double-click should select the overhangs too, while drag select will select blunt fragments. No selection D&D will do same as select all. Should also work from digest bands.  Add history data to the comments? #2 Graphic map- needs to know the direction of the site- set the top and bottom selection using that. #1 Digest needs to know the top and bottom index for both ends.

# Needs 5' and 3' overhang data (+ or - recess length) for linear sequences. Ability to process the ends to modify this data (needs GUI elements). Saving/loading needs to preserve this data. How to deal with edits: insert/delete/paste at the ends, rev-com involving only one end, make circular (can do it all in the textarea_insert and textarea_delete procs)? End processing dialog. Show ends as non-blunt



## overhang feature/ ligate tool: overhang made from digest, phosphate- in feature, or separate feature?, bottom strand bases in feature (5'->3', or reverse the bases when the feature is revered?) (take out overhangs not at the end? when?) (edit overhangs tool- fill w/ bases, 3' trim w bases, 5' trim) (ligate tool)
## restriction cloner (GG cloning)- select sequence window, then site, then direction, then site2
## ok: partial digest (shift): select %, can choose a fragment to maximize (drop down), closed circles at 50% size.
## homology cloner- pick one sequence- fills in as many as possible; presents drop down whenever multiple possible (check both directions?); treat all as linear, but warn if circular; no ok button until possible.

## mismatch in feature definitions: postfix number indicating mismatches allowed in the previous range. "+" and "#" break ranges.

### do_find_mm needs find prev updating for wrapped lines.
## add hide feature to popup menu
## hide feature- make bg color transparent- linear draw, printing, save svg, save eps, copy wmf
## save svg/eps- cascade menu on aqua
## read gff3 file: ask for fasta or clipboard sequence
## save keynote
## graphic map- configure features, enzymes, circles/lines


## translate feature with right click or in edit.
## make new sequence from feature (right click, edit features)
## metafile export- make blank background centered on circle


## make all abi into sequences.

## fix alignment
## ok: alignment translate cds
## defaults button
## ok: 3 frame translate in tooltip
## ok: alignment tooltips (seq window of origin, base)


# bug: Scrolling down with the mouse-wheel is not working, you can only scroll up. Windows 7
# source feature- what to do with it?


# esc key to close dialogs

# align multiple to reference sequence
#   generate alignment score to decide to use fwd or reverse alignment
#   select/all fwd/rev/best lists
#   blackout unattempted
# 
#   ok: align window- abi_text tag, enter leave events abi tooltip create_abi_tooltip
#   ok: show translation of cds in reference sequence alignments
#   ok: use block_align3 algorithm in align_two_sequences

# make and use textarea_tag_delete proc, textarea_tag_add proc 
# add_transparency proc (features, foundf/r, enzyme as separate transparency layers), accepts range to work with, adds trans tags
# configure_transparency proc (to set the correct colors for features and trans tags when trans % changes), called from add_transparency
# call add_transparency from textarea_tag_delete and textarea_tag_add, highlight enzymes, highlight found
# clear trans when clear found and clear enz
# get_tags gets trans tags too
# put_tags puts and renames trans tags
# copy_tags copies trans tags
# alt key to set transparency- popup with slider and mode setting (all, overlap, mouseover), mousewheel event to set % transparency


#use raise/lower list for edit ladders, enzyme groups (see delete groups for dialog), edit feature library, see text map for example
# change the way ladders are stored in info array - store a number as info(current_ladder), store list of info(ladder_names) and list of info(ladder_bands), or maybe a dict of info(ladder_dict)

# edit library, edit features: do get_tags or store library list, do changes live, restore from stored copy on cancel
# change from mem array to mem list
# write a mover proc using mem array for drag and drop on these lists
# sort by size

# multi-gel digest window drag (digest_move_lane)
#   $modifier KeyPress to activate the plusarrow cursor

# arrange enzyme sets with drag and drop list

# add to start or end (sel_plus)- based on which is closer

# graphic map
# make graphic map theme files (sets default values)

# features
# see above for list updates (mem)
# add arrow data to libraries and features
# add group data to features
# change find to use linear scan for exons (allows mismatch), find best combination of exons to generate feature (pick second exon, find next closest first and third, then closest fourth etc., until max mismatch is exceeded, find best combinations that use each exon.
# this should fix the bug that takes so long in regexp search for features in long texts


# next orf: dialog to set atg/stop, minimum size ORF, frame (radio: +all, +1, +2, +3, -all, -1 -2 -3) find next, previous, highlight all.
# live link ORF map
# ORF start and stop uses codon table

# add features to translation window (above, below or none)

# features, enzyme sites, index line as boxdrawing characters in text map (and translation), or underline
# color feature text 


# copy special- uppercase only, cds only??

# shift select features to select range including feature (forward or reverse)
# feature list: live link to subranges
# shift select exons and introns on graphic map


#vista
#   cmd.exe /c echo %APPDATA%
#   registry get {HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders} {Appdata}


# install option on Windows- if not in program files and no user preferences
# xp shortcuts: http://ss64.com/nt/shortcut.html
#vista shortcuts: runas administrator mklink
#   Set oWS = WScript.CreateObject("WScript.Shell")
#   sLinkFile = "C:\Documents and Settings\Wayne\Desktop\sht.lnk"
#   Set oLink = oWS.CreateShortcut(sLinkFile)
#  
#   oLink.TargetPath = "C:\Program Files\ApE\ApE.exe"
#   '    oLink.Arguments = ""
#   '    oLink.Description = "MyProgram"
#   '    oLink.HotKey = "ALT+CTRL+F"
#   '    oLink.IconLocation = "C:\Program Files\MyApp\MyProgram.EXE, 2"
#   '    oLink.WindowStyle = "1"
#   '    oLink.WorkingDirectory = "C:\Program Files\MyApp"
#   oLink.Save
#exec CSCRIPT //H:CScript {C:\Documents and Settings\Wayne\Desktop\Document.vbs}
#install wizard pages- Intro, license, install location, file associations, shortcut on desktop/ shortcut in start menu, install

# file type associations (Xp, Vista??) http://ss64.com/nt/ftype.html
# uninstal option on all platforms
#need to set the HKLM\\Software\\Classes\\.ape, HKEY_LOCAL_MACHINE\\Software\\Classes\\ApE.DNA.file\\shell\\open\\command etc. OR HKEY_CURRENT_USER (needs admin privledge on Vista+ to write to HKLM, should go to HKCU. Add option to set for current user or machine.)



# select_region (also textarea_get, get_tags, put_tags, copy_tags?) needs to do bp2ix in the proc

# close all, close orphan analysis, dialog option to close all when quitting,

# delete all in selected region in abi files

# aa feature definitions

####bigger projects:
#project files: 
#  manage project files dialog: 
# file list: 
#     above each slot: filename of project; menu button: open project file,  open recent project file, save as, create new blank project file (save as dialog); open second project file (becomes close second after open)
#     below each slot: remove selected files; add folder to project file (folder dialog); add open file to project file (menu button); add file (file dialog)
#     select all, select none, toggle selected absolute directory references
#     between: copy (left and right), move (left and right)
# autosave project files while dialog open
# proc open_project_file
# project files: (1)magic number; folder fields; file fields; feature libraries, ladder files, enzyme files

## pretty graphic maps

#linear map: new <Configure> proc that doesn't require aspect ratio, and that adjusts labelbox items to their texts
#linear map: bup all texts proc, moves labels to their features then bumps them all
# linear map: move feature proc, bumps label after each move- sets current label to the first bumped

#pretty graphic maps- arrow types, define each feature type to have a default arrow type at each end, default color, default thickness. Can set that value for each feature in edit feature. can right click on a feature to edit the feature. color code feature labels.
#preferences: window size (linear and circular), features in/on/out of circle (fwd/rev, short/long), width of circle, color of circle, feature numbers and lines on/off,  default feature text color (option of feature color), feature text highlight color, unique and selected enz text color, show enz coord, show enz numbers.
#features (library, edit features): width, fwd/rev arrow type (no arrow, block, narrow, half)
#features (live): move in/out
# map (live- right click, menu item): all lines on/off; feature indices on/off; enz indices on/off; enz counts on/off; (show/ hide texts- how?); unhide items (submenu); show comment; show feature table; make current format default.
# map (live- right click on feature, menu item): fwd, rev arrow; width; show label, indices, line; hide; hide all of type
# map (live- right click on text, menu item): points, color, bold, underline, show label, indices, line
# texts (live- right click, menu item): format text item (font, size, color, on/off, numbers on/off, text hidden), same format options for their group (unique enzyme, selected enzyme, same enzyme, features)
# live drag of texts- respace all other texts, change anchor point based on position of text relative to feature line.
# potential feature metadata (circular): radius position (-1, 0 ,1), direction (0,1), angle indices, arrow data (fwd+rev), tick angle, feature bp, default color
# arrows- x,y of three points (12 numbers); or: length of arrow, inner width, outer width (6 numbers)
# non-arrow features- circle, triangle (up down left right), 5, 6, 8 sided, start arrow. height, width, justification (centered start end)
# procs:  move feature in and out (move coords of all arcs and arrows, including backgrounds), change arrow coord points to change arrow type (also background coords), change feature width, move texts and their lines, bump texts (and their lines) (bump features first, only relative to feature labels, then bump enzyme labels), turn lines on/off, turn coords on/off, turn enz counts on/off, dialog to change text formatting (font, points, color, bold, underline). 

#########need to update these to include graphic formatting:
##metadata here
#ok: adding features:   proc feature_scan {w} {
#ok: proc add_sel_feature_file {w} {
#ok: proc rename_recolor_window_feature {parent w feature} {
#ok: reading genbank:   proc feature_table_to_taglist {table {circular 0} {dna_length 0}} {
#ok: writing genbank:   proc genbank_text {w} {

##feature library
#>>proc read_feature_library {filename} {
#proc edit_feature {w feature_number} {
#proc save_feature_library {{filename ""}} {
#proc add_sel_feature_library {w} {

##link back to sequence metadata when edited in the graphic map
##set up a formatting file that contains default formatting and colors for features by type (fonts, flip offset?), enzymes by count (fonts, colors)
##apply/edit defaults in edit features
##apply defaults in edit configure graphic map
 
##############
# <<Metadata>> (1) dict: arrow_data (list: fwd, rev, flip), width, offset (show as symbol?, flip offset?)
#<<Metadata>>:(0)name, (1)format_info, (2)type, (3)fwd/rev, (4)annotations_string
#<<Revcolors>>: binding used for the color if the sequence is reversed
#file format(tab sep): (0)name (1)plain_text_def (2)type (3)fwd_color (4)rev_color (5)graphic_format (6)ital (7)annotations_string
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)graphic_format (10)ital (11)annotations_string
#set info(feature_default_type_gformat)

# all popup menus have disabled line at top showing what is being edited
# right click on background to show/hide center label, center bp count, feature list, enzyme list, comment, unhide hidden features or enzymes
# right click on circle to configure width and color
# right click on any text to change color, point size, underline, bold, italic
# right click on enzyme texts adds show/hide index, show/hide count, show/hide line
# ctrl-right click on enz text applies changes to all of that enzyme, and adds hide all
# shift-right click on enzyme text applies to all enzyme texts, and adds hide all
# right click on feature text adds show/hide index, show/hide line, tick length, edit arrow points
# ctrl-right on feature text applies to all text of that feature type
# shift-right on feature text applies to all feature texts
# right click on feature to change width, show/hide label, configure arrow dialog, hide
# ctrl-right on feature applies to all of that feature type
# features can be dragged in and out, all texts can be dragged (with lines following them)

# <<metadata>> in enz_text: label, bp, count, color (dict used for %substitutions in labels, finding associated elements, <Leave> events)
# <<metadata>> in feature_text: label, bp_start, bp_end, feature_fg_color, text_color, (dict used for % substitution, unhiding, <Leave> events)
# ok: modifier-click move
# right-click to bring up edit text/ feature/ class dialog, include checkbox option to apply to all of type and all of class
# put show/hide items into main menu and popup menu- dialog with checkboxes for texts (center label, center bp count, feature list, enzyme list, comment), enzymes (list), features (list)
# ok: arrow redraw function that can be called for changing feature width, initial setup, arrow edits- sets coord values for both arrow polygons (and arrow_bg polygons)
# ok: tags: label, type (exon, intron, arrow_f, arrow_r, foreground, outline, feature_text, feature_text_line, feature_text_tick, enz_text, enz_text_line, enz_text_tick), 
# ok: use -state hidden rather than visible tag 
# make feature text line just point to nearest point on feature (change anchor point if feature text is inside arc)
# enzyme and feature label %substitutions
# background color for texts
# circles (width, color, bg color): set radius of features circle relative to enz circle, boolean: flip rev features; tic circle; %GC circle; 

## virtual cloner- 
# flowchart, boxes are procedures, arrows are samples. samples with multiple DNA fragments are wider lines
## 0-in 1-out functions
# new sequence box at top- can be an open file, or synthetic sequence (both strands, phos or not)
## 1-in 1-out functions
# PCR function (two primers)
# enzyme cut (optional partial)
# dephos
# trim
# fill in (all bases, or some)
# gel purify
## 1-in 2-out functions
# split sample - makes new sample line adjacent (duplicates sample)
## many-in 1-out functions
# ligate box (can be extended to multiple fragments)
# homology cloning (in-fusion, SLIC, PIPE, LIC)
## special output
# make sequence from sample
# make gel from sample


## alternate virtual cloner, homology cloner and PCR dialogs
# each fragment: dropdown for sequence window, option of PCR on that sequence (opens primer1 primer2 entry boxes); enzyme1, option of partial, 5'-option of fill (all or some), 5' & 3'-option of trim (T4 or mung bean), option of tail (A, C, G, T); enzyme2, same, button to apply same processing as enz1; dropdown for selecting fragment (gel purify); button to make sequence; button to make gel
# action box homology cloning, ligate; checkbox to show all/ one product, minimum homology
# maybe just a processing dropdown after selecting the fragment- options: PCR (primers, polymerase), restrict (enzyme (menu of: selected, alphabetical, frequency), partial, percent), T4 pol (nucleotides), mung bean, Taq (nucleotides), terminal transferase (nucleotides, length), gel purify (fragment), define ori feature, define selection feature, phosphatase, make sequence, make gel



#infinite undo
# make and use textarea_tag_delete proc, textarea_tag_add proc 
# textarea_insert needs to break and split tags (calling tag_delete and tag_insert so that it registers in the undo queue)
# textarea_delete needs to call tag_delete so that it registers in the undo queue
# textarea insert/delete, tag delete/insert register in the undo queue
# insert separators into undo queue for every activity that calls textarea insert/delete, tag insert/delete

# rework find primers function
# find primer pairs flanking selection (max before and after, must include sequence from x to y) (option to maintain frame 5' and 3')
# change to optional Tm calculations
# database of optional primer additions (gateway etc)
# output is in primer pairs
# option in results to generate PCR product for primer pairs
# option to add primer bind features to sequence (including primer sequence sub-feature)

# use NCBI primer blast

# ok; show tooltip for self and other alignments.

# text map- export rtf (bold, background, underline). need to figure out properties of the text at each tag change.

# features rewrite (see file for starting point) to tag each feature with group, so you can turn them on and off as sets
# new feature library from file (might be part of feature reorganization)

# dialog to change the gateway recombination reactions in drop down, include all known possibilities in software, still add on the user specified (or have a dialog to add new user specified)

# Modify start index in display (updates all output to add the start base in) use a modified ix2bp proc

# ok(see **): enzymes cut sites index, instead of site start. change the readenzymes proc (and addhexarray and delete_enzyme proc) to add 0 or 1 to the last character of the name in hexlist and longnme list. make a new array value that has the distance to the cut site for forward and reverse (using pat info). take the character off when extracting and save new element (a list as long as the sites list) in enzinfo that has the distance to the cut site.** check the distance to make sure it's still in the sequence. Distances will be updated by rescanning. **Use distance info in graphic map and in text map.
#may need to update save_enzymes- either take the direction info out (hexlist and longnames) when saving, or read a new format file in read_enzymes, and save the direction info.

#arrows:
#side arrow: 0 -1 1 0 .5 0 .5 1 -.5 1 -.5 0 -1 0
#min arrow: 0 .5 1.5 0 0 -.5
#half arrow: -.5 1 1 -.5 -.5 -.5
#spike arrow:0 .5 -.5 1 -.5 1.1 1.6 0 -.5 -1.1 -.5 -1 0 -.5 
#fins: 0 .5 1 1.3 1 1 0 0 1 -1 1 -1.3 0 -.5
#half block: 0 4 .3 4 .3 -.5 0 -.5


set errorInfo ""
set errorCode ""
package require Tk 8.5

set time0 [clock clicks -milliseconds]
wm withdraw .
#if {[winfo exists .]} {
#  if {[tk windowingsystem] != "aqua"} {
#    wm withdraw .
#  } else {
#    wm geometry . 1x1+0+0
#  }
#}
###TIP 242 for tk_getSaveFile -typevariable option not implemented yet

if {0} {
proc bgerror {msg} {
  global errorInfo dialogblock my_debug
  sputs $errorInfo
  if {[tk windowingsystem] == "win32"} {
    set mail_program [registry get {HKEY_CURRENT_USER\Software\Clients\Mail} {}]
    if {![catch {set mail_command [registry get "HKEY_LOCAL_MACHINE\\Software\\Clients\\Mail\\$mail_program\\Protocols\\mailto\\shell\\open\\command" {}]}]} { 
      regsub "%1" $mail_command "" mail_command
      regsub -all {\\} $mail_command {\\\\} mail_command
    } else {
      set mail_command ""
    }
  } elseif {[tk windowingsystem] == "aqua"} {
    set mail_command "open"
  } else {
    set mail_command ""
  }
  if {($mail_command != "") && (![info exists my_debug])} {
    if {[tk_messageBox -message "Sorry, ApE has encountered an internal error.\nWould you like to email an error log to assist in preventing this problem in the future?\n(Include any info you can about what was happening at the time of the error)" -type yesno -default yes] =="yes"} {
      if {[catch {eval exec $mail_command {"mailto:wdavis@biology.utah.edu?subject=ApE error&body=$errorInfo"} &}]} {
        bgerror2 $msg
      }
    }
  } elseif {[info exists my_debug]} {
    console show
  } else {
    tk_messageBox -message "Sorry, ApE has encountered an internal error.\n[string range $errorInfo 0 50]" -type ok
  }
  set dialogblock 0
  if {[ bind . <<RaiseDialogs>>] != {}} {bind . <<RaiseDialogs>> {}}  
}
}


proc sputs {args} {
global info tcl_platform
  if {$info(suppress_output)} return
  if {($tcl_platform(platform) == "windows") || ([tk windowingsystem] == "aqua")} {
    puts $args
  } else {
    puts stdout $args
    puts stderr $args
  }
}

if {[tk windowingsystem] == "aqua"} {
  proc ::tk::mac::OpenDocument {args} {
    foreach filename $args {
      open_file $filename
    }
  }
  proc ::tk::mac::OnShow {args} {
  }
  proc ::tk::mac::PrintDocument {args} {
    foreach filename $args {
      open_file $filename
    }
  }
}

package require msgcat
namespace import msgcat::mc
##set ::msgcat::Loclist to get a list of loaded locales
set needs_translation [list]
proc ::msgcat::mcunknown {args} {
  if {[llength $args] > 2} {
    if {[string first % $args] == -1} {
      sputs "msgcat error (too many args): $args"
      set text [lrange $args 1 end]
    } else {
      set text [eval format [lrange $args 1 end]]
    }
  } else {
    set text [lindex $args 1]
  }
  set locale [lindex $args 0]
  global ::needs_translation
  if {[lsearch -exact $::needs_translation [lindex $args 1]] == -1} {
    lappend ::needs_translation [lindex $args 1]
  }
  return $text
}



############
## DNA edit window creator
############
proc create_window {{newdna ""} {filename ""} {filecomment ""} {circular linear} {methylated -1} {startindex 1} {title "New DNA"} {tags ""} {genbank_header_list {}} {filetype "None"} {abi_data {}}} {
  global info
  global fea_info
  global winum
  global modifier
  global modstring tk_patchLevel
  global toolbar_images

  set reuse_startup 0
  if {($newdna == -1)} {
    if {$winum > 0} {
      #trying to open a blank startup window after a window is already open
      return 
    } else {
      set newdna ""
    }
  } else {
    if {[winfo exists .dna_window0] && ([.dna_window0.comframe.comtextframe.text get 1.0 end-1char] == "") && ([.dna_window0.textarea get 1.0 end-1char] == "") && ($info(.dna_window0,saved) == 1) && ($info(.dna_window0,filename) == "")} {
      #first window is still blank - reuse it
      set reuse_startup 1
    }
    incr winum
  }

  set w .dna_window$winum

# variables refering to the DNA
  set info($w,startindex) $startindex
  if {$genbank_header_list != [list]} {
    set info($w,genbank_header_list) $genbank_header_list
  } else {
    set info($w,genbank_header_list) $info(empty_genbank_header)
  }
  set info($w,linked_abi_list) $abi_data

  set info($w,circular) $circular
  if {$methylated > -1} {
    set info($w,Dam_Dcm_methylated) $methylated
  } else {
    set info($w,Dam_Dcm_methylated) $info(methylated_default)
  }
  set info($w,filename) $filename
  set info($w,filetype) $filetype
  if {$newdna == "" || ($filename !="")} {
    set info($w,saved) 1
  } else {
    set info($w,saved) 0
  }

  if {$title == "New DNA"} {set title [mc $title]}
  if {[lsearch -exact $info(dnatitles_list) $title] > -1 } {
    set i 1
    while {[lsearch -exact $info(dnatitles_list) "$title\($i\)"] > -1 } {incr i}
    set title "$title\($i\)"
  }
set info($w,scanned) 0
set info($w,locked) [expr {[file isfile $info($w,filename)] && ![file writable $info($w,filename)]}]
toplevel $w 
if {[tk windowingsystem] == "aqua"} {
  #::tk::unsupported::MacWindowStyle style $w document {closeBox collapseBox horizontalZoom unifiedTitleAndToolbar resizable liveResize toolbarButton}
   ::tk::unsupported::MacWindowStyle style $w document {closeBox collapseBox horizontalZoom resizable liveResize toolbarButton};#{noTitleBar resizable} to add unified menu - needs to define the file menu and the close colapse and zoom buttons 
}

wm title $w $title
set info($w,win_title) $title
if {[tk windowingsystem] == "aqua"} {
  wm attributes $w -modified 0 
  if {[file exists $filename]} {
    wm attributes $w -titlepath $filename
  }
}

lappend info(dnawindows_list) $w
lappend info(dnatitles_list) $title
set info($w,insert_loc) ""
set info($w,sel_start) ""
set info($w,sel_end) ""
set info($w,sel_start2) ""
set info($w,sel_end2) ""

wm protocol $w WM_DELETE_WINDOW "if {!\$dialogblock} {closewindow $w}"

menu $w.menubar


#define file menu
menu  $w.menubar.filemenu 
$w.menubar add cascade -menu $w.menubar.filemenu -label [mc "File"] -underline 0
$w.menubar.filemenu add command -label [mc "New"] -accelerator "$modstring+N" -command "create_window" -underline 0
$w.menubar.filemenu add command -label [mc "Open..."] -accelerator "$modstring+O"  -command "open_file_dialog"
menu $w.menubar.filemenu.open_previous
$w.menubar.filemenu add cascade -label [mc "Open Recent Files"] -menu $w.menubar.filemenu.open_previous
$w.menubar.filemenu add command -label [mc "Duplicate Selection"]  -accelerator "$modstring+D"  -command "duplicate_window $w selection" -underline 0
$w.menubar.filemenu add command -label [mc "Duplicate Full Sequence"]  -accelerator "$modstring+Shift+D"  -command "duplicate_window $w all"
$w.menubar.filemenu add command -label [mc "Close"] -accelerator "$modstring+W" -command "closewindow $w"
$w.menubar.filemenu add separator
$w.menubar.filemenu add command -label [mc "Save"]  -accelerator "$modstring+S" -command "save_file $w Save"
$w.menubar.filemenu add command -label [mc "Save As..."] -command "save_file $w Save_as"

#exit is added below in the platform specific code

#define edit menu
menu  $w.menubar.edit 
$w.menubar add cascade -menu $w.menubar.edit -label [mc "Edit"]
$w.menubar.edit add command -label [mc "Can't Undo"] -state disabled -accelerator "$modstring+Z" -command "undo $w"
$w.menubar.edit add command -label [mc "Cut"]  -accelerator "$modstring+X" -command "clip_cut_copy $w cut"
$w.menubar.edit add command -label [mc "Copy"]  -accelerator "$modstring+C" -command "clip_cut_copy $w copy"
$w.menubar.edit add command -label [mc "Paste"]  -accelerator "$modstring+V" -command "clip_paste $w"
$w.menubar.edit add separator
$w.menubar.edit add command -label [mc "Cut Rev-Com"]  -accelerator "$modstring+Shift+X" -command "clip_cut_copy $w cut rev-com"
$w.menubar.edit add command -label [mc "Copy Rev-Com"]  -accelerator "$modstring+Shift+C" -command "clip_cut_copy $w copy rev-com"
$w.menubar.edit add command -label [mc "Paste Rev-Com"]  -accelerator "$modstring+Shift+V" -command "clip_paste $w rev-com"
$w.menubar.edit add separator
  menu $w.menubar.edit.copy_special -postcommand "update_copy_features_menu $w"
  $w.menubar.edit add cascade -menu $w.menubar.edit.copy_special -label [mc "Copy Special"]
  $w.menubar.edit.copy_special add command -label [mc "Copy All as Genbank"] -command "clipboard clear;clipboard append -displayof $w \[genbank_text $w\]"
  $w.menubar.edit.copy_special add separator
  $w.menubar.edit.copy_special add command -label [mc "Copy Uppercase"] -command "clip_copy_special $w upper"
  $w.menubar.edit.copy_special add command -label [mc "Copy Uppercase Rev-Com"] -command "clip_copy_special $w upper rev_com"
  $w.menubar.edit.copy_special add separator
  $w.menubar.edit.copy_special add command -label [mc "Copy Translated"] -command "clip_copy_special $w translated"
  $w.menubar.edit.copy_special add command -label [mc "Copy Uppercase Translated"] -command "clip_copy_special $w translated_uc"
  $w.menubar.edit.copy_special add command -label [mc "Copy Translated Rev-Com"] -command "clip_copy_special $w translated rev_com"
  $w.menubar.edit.copy_special add command -label [mc "Copy Uppercase Translated Rev-Com"] -command "clip_copy_special $w translated_uc rev_com"
  $w.menubar.edit.copy_special add separator
  $w.menubar.edit.copy_special add command -label [mc "Copy Reverse (NOT A GOOD IDEA)"] -command "clip_copy_special $w reverse"
  $w.menubar.edit.copy_special add command -label [mc "Copy Complement (NOT A GOOD IDEA)"] -command "clip_copy_special $w complement"
  $w.menubar.edit.copy_special add separator
  $w.menubar.edit.copy_special add command -label [mc "Copy Features as NCBI Bankit table"] -command "clipboard clear;clipboard append -displayof $w \[bankit_text $w\]"
$w.menubar.edit add separator
if {[tk windowingsystem] != "aqua"} {
  $w.menubar.edit add command -label [mc "Preferences..."]  -command "configure_preferences $w"  -accelerator "$modstring+,"
  $w.menubar.edit add separator
}

$w.menubar.edit add command -label [mc "Select All"]  -accelerator "$modstring+A" -command "select_all $w"
$w.menubar.edit add command -label [mc "Select From-To..."]  -accelerator "$modstring+Shift+A" -command "select_from_to $w"
$w.menubar.edit add command -label [mc "Jump To..."]  -accelerator "$modstring+J" -command "jump_to $w"
$w.menubar.edit add separator
$w.menubar.edit add command -label [mc "Find..."]  -accelerator "$modstring+F" -command "find_dialog $w"
$w.menubar.edit add command -label [mc "Find Again"]  -accelerator "$modstring+G" -command "do_find $w again"
$w.menubar.edit add command -label [mc "Clear Find Highlighting"]  -accelerator "" -command "$w.textarea tag delete foundf; $w.textarea tag delete foundr"
$w.menubar.edit add separator
$w.menubar.edit add command -label [mc "Convert to UPPERCASE"]  -accelerator "$modstring++" -command "change_case $w upper"
$w.menubar.edit add command -label [mc "Convert to lowercase"]  -accelerator "$modstring+-" -command "change_case $w lower"
$w.menubar.edit add command -label [mc "UPPER<->lower"] -accelerator "$modstring+=" -command "change_case $w exchange"
$w.menubar.edit add separator
$w.menubar.edit add command -label [mc "Reverse-Complement"]  -accelerator "$modstring+/" -command "rev_com_window $w"
$w.menubar.edit add separator
$w.menubar.edit add command -label [mc "Circular<->Linear"] -command "toggle_circ $w"
$w.menubar.edit add command -label [mc "Set Origin"]  -accelerator "$modstring+I" -command "set_origin $w"
$w.menubar.edit add command -label [mc "Linearize @ insert site"] -command "linearize $w"

#add enzymes menu
menu  $w.menubar.enzymes
$w.menubar add cascade -menu $w.menubar.enzymes -label [mc "Enzymes"]
$w.menubar.enzymes add command -label [mc "Enzyme Selector..."] -accelerator "$modstring+E" -command "enzyme_selection_dialog $w"
$w.menubar.enzymes add separator
$w.menubar.enzymes add checkbutton -label [mc "Selection Only"] -accelerator "$modstring+Shift-E" -onvalue "selection" -offvalue "all" -variable info(analyze_selection)

$w.menubar.enzymes add separator
$w.menubar.enzymes add command -label [mc "Graphic Map"] -accelerator "$modstring+Y" -command "enz_graphic_map $w"
$w.menubar.enzymes add command -label [mc "Graphic Map +U"] -accelerator "$modstring+Shift+Y" -command "enz_graphic_map $w {==1}"
$w.menubar.enzymes add separator
$w.menubar.enzymes add command -label [mc "Highlight"] -command "highlight_enzymes $w \$info(enz_currently_selected)";#uses selected
$w.menubar.enzymes add command -label [mc "Clear Highlighting"] -command "foreach enzyme \$enzymes {$w.textarea tag delete \$enzyme}"
$w.menubar.enzymes add separator
$w.menubar.enzymes add command -label [mc "Digestion"] -accelerator "$modstring+R" -command "enz_digest $w \$info(enz_currently_selected) \$info(analyze_selection)"
$w.menubar.enzymes add command -label [mc "Partial Digestion"] -accelerator "$modstring+Shift+R" -command "enz_digest_partial_dialog $w"
$w.menubar.enzymes add cascade -label [mc "Ladder"] -menu [menu $w.menubar.enzymes.ladders]
$w.menubar.enzymes add separator
$w.menubar.enzymes add command -label [mc "List Enzymes..."] -command "list_enzymes_dialog $w"
menu $w.menubar.enzymes.lists
  $w.menubar.enzymes.lists add command -label [mc "Site Usage"] -command "findenzymes $w; list_enzymes_window $w 1 all"
  $w.menubar.enzymes.lists add command -label [mc "Unique Sites"] -command "findenzymes $w; list_enzymes_window $w 0 unique"
  $w.menubar.enzymes.lists add command -label [mc "Absent Sites"] -command "findenzymes $w; list_enzymes_window $w 0 absent"
$w.menubar.enzymes add cascade -label [mc "Quick Lists"] -menu $w.menubar.enzymes.lists
$w.menubar.enzymes add separator
$w.menubar.enzymes add command -label [mc "Silent Sites"]  -command "silent_sites $w \$info(enz_currently_selected)"
$w.menubar.enzymes add separator
$w.menubar.enzymes add command -label [mc "Text Map..."] -accelerator "$modstring+Shift+T" -command "enz_text_map $w "

#add ORFs menu
menu  $w.menubar.orf
$w.menubar add cascade -menu $w.menubar.orf -label [mc "ORFs"]
  $w.menubar.orf add command -label [mc "Find Next"] -accelerator "$modstring+>" -command "next_ORF $w forward"
  $w.menubar.orf add command -label [mc "Find Previous"] -accelerator "$modstring+<" -command "next_ORF $w reverse"
  #$w.menubar.orf add command  -label [mc "Highlight all"] -command "next_ORF $w all"
  menu $w.menubar.orf.start
  $w.menubar.orf add cascade -menu $w.menubar.orf.start -label [mc "ORF Starts With"]
    $w.menubar.orf.start add radiobutton -label [mc "Met"] -variable info(find_orf_starts) -value "Met"
    $w.menubar.orf.start add radiobutton -label [mc "Stop+1"] -variable info(find_orf_starts) -value "Stop+1"
  menu $w.menubar.orf.search_strand
  $w.menubar.orf add cascade -menu $w.menubar.orf.search_strand -label [mc "Search Strand"]
    $w.menubar.orf.search_strand add radiobutton -label [mc "Top"] -variable info(find_orf_strand) -value 1
    $w.menubar.orf.search_strand add radiobutton -label [mc "Bottom"] -variable info(find_orf_strand) -value -1
    $w.menubar.orf.search_strand add radiobutton -label [mc "Both"] -variable info(find_orf_strand) -value 0
  menu $w.menubar.orf.min_orf
    foreach min [list 0 30 60 90 180 300 600 900 1200 1500] {
      $w.menubar.orf.min_orf add radiobutton -label $min -variable info(find_orf_min) -value $min
    }
  $w.menubar.orf add cascade -menu $w.menubar.orf.min_orf -label [mc "Minimum bp"]
  $w.menubar.orf add separator
  $w.menubar.orf add command -label [mc "Translate..."] -accelerator "$modstring+T" -command "translation_window $w"
  $w.menubar.orf add separator
  $w.menubar.orf add command -label [mc "ORF map"] -command "orf_map $w \$info(analyze_selection)"
  $w.menubar.orf add separator
  #$w.menubar.orf add checkbutton -label "Selection Translate" -variable info(selection_shows_Trans) -onvalue 1 -offvalue 0 -command "selection_manager $w"
  $w.menubar.orf add checkbutton -label [mc "Selection Translate"] -variable info($w,selection_shows_Trans) -onvalue 1 -offvalue 0 -command "if {\$info($w,selection_shows_Trans)} {grid propagate $w.infoframe 1; grid configure $w.infoframe.trans;update; grid propagate $w.infoframe 0; selection_manager $w} else {grid propagate $w.infoframe 1; grid remove $w.infoframe.trans; update; grid propagate $w.infoframe 0}"
  set info($w,selection_shows_Trans) $info(selection_shows_Trans)
  #$w.menubar.orf add command -label "Codon Usage" -state disabled
  #$w.menubar.orf add command -label "Compare Codon Bias" -state disabled
  #$w.menubar.orf add command -label "Open Codon Bias Table" -state disabled
  #$w.menubar.orf add separator

#add features menu
menu  $w.menubar.features
$w.menubar add cascade -menu $w.menubar.features -label [mc "Features"]
  $w.menubar.features add command -label [mc "New Feature..."] -accelerator "$modstring+." -command "add_sel_feature_file $w"
  $w.menubar.features add command -label [mc "List Features"] -command "list_features $w"
  $w.menubar.features add command -label [mc "Edit Features..."] -command "configure_features $w"
  $w.menubar.features add command -label [mc "Clear Features"] -accelerator "$modstring+Shift+K" -command "feature_clear $w"
  $w.menubar.features add separator
  $w.menubar.features add command -label [mc "Edit Feature Library..."] -command "edit_feature_library $w"
  $w.menubar.features add command -label [mc "New Feature in Library..."] -command "add_sel_feature_library $w"
  $w.menubar.features add command -label [mc "Open Feature Library..."] -command "open_feature_library {} new 1"
  $w.menubar.features add command -label [mc "Annotate Features using Library"] -accelerator "$modstring+K" -command "feature_scan $w"
  $w.menubar.features add separator
  $w.menubar.features add command -label [mc "Add Features from GFF3 file..."] -command "add_gff_annotations $w"


#add Tools menu
menu  $w.menubar.tools
$w.menubar add cascade -menu $w.menubar.tools -label [mc "Tools"]
  $w.menubar.tools add command -label [mc "Find Primers..."] -command "primer_window $w"
  $w.menubar.tools add separator
  $w.menubar.tools add command -label [mc "Align Sequences..."] -accelerator "$modstring+L" -command "align_dialog2 $w"
  $w.menubar.tools add command -label [mc "Align Two Sequences..."] -command "align_dialog $w"
  $w.menubar.tools add separator
  $w.menubar.tools add command -label [mc "Recombination Tool..."] -accelerator "" -command "recombination_window $w"
  $w.menubar.tools add separator
  if  {([lsearch -glob [info loaded] "*TclSpeech2.0.dylib*"] > -1) && $info(speak_use_aqua)} {
    $w.menubar.tools add command -label [mc "Start/Stop Speak Text..."] -accelerator "" -command "speak_dialog $w"
    $w.menubar.tools add separator
  }
  $w.menubar.tools add command -label [mc "BLAST Sequences At NCBI..."] -accelerator "$modstring+B" -command "NCBI_Blast $w"
 # $w.menubar.tools add command -label [mc "BLAST Sequences At Wormbase..."] -command "Wormbase_Blast $w"
  $w.menubar.tools add command -label [mc "Download sequences From NCBI..."] -command "entrez_dialog $w"
  $w.menubar.tools add separator
  $w.menubar.tools add command -label [mc "Calculator..."] -accelerator "$modstring+1" -command "calc" 
  $w.menubar.tools add separator
  $w.menubar.tools add command -label [mc "Insert Repeat Sequence..."] -command "insert_repeat $w"
  $w.menubar.tools add separator
  $w.menubar.tools add command -label [mc "Multi-Cre Recombination..."] -command "lox_recombination_window $w" 
  $w.menubar.tools add separator
  $w.menubar.tools add command -label [mc "Digest All Open Windows"] -command "digest_open_windows" 
  $w.menubar.tools add separator
  $w.menubar.tools add command -label [mc "Golden Gate Reaction"] -command "golden_gate_dialog $w"

#add Windows menu stub (menu items are maintained by update_windows_menu procedure)
menu $w.menubar.windows 
  $w.menubar add cascade -menu $w.menubar.windows -label [mc "Window"]
if {[catch {update_windows_menu} err]} {tk_messageBox  -message "windows menu: $err"}
if {[catch {update_open_previous_menu} err]} {tk_messageBox  -message "open previous: $err"}
if {[catch {update_ladders_menu $w} err]} {tk_messageBox  -message "ladders menu: $err"}



set popupmenu [menu $w.popupmenu]
$popupmenu add command -label [mc "Cut"]  -accelerator "$modstring+X" -command "clip_cut_copy $w cut"
$popupmenu add command -label [mc "Copy"]  -accelerator "$modstring+C" -command "clip_cut_copy $w copy"
$popupmenu add command -label [mc "Paste"]  -accelerator "$modstring+V" -command "clip_paste $w"
$popupmenu add separator
$popupmenu add command -label [mc "Cut Rev-Com"]  -accelerator "$modstring+Shift+X" -command "clip_cut_copy $w cut rev-com"
$popupmenu add command -label [mc "Copy Rev-Com"]  -accelerator "$modstring+Shift+C" -command "clip_cut_copy $w copy rev-com"
$popupmenu add command -label [mc "Paste Rev-Com"]  -accelerator "$modstring+Shift+V" -command "clip_paste $w rev-com"
$popupmenu add separator
$popupmenu add command -label [mc "Find..."]  -accelerator "$modstring+F" -command "find_dialog $w"
$popupmenu add command -label [mc "Reverse-Complement"]  -accelerator "$modstring+/" -command "rev_com_window $w"
$popupmenu add separator
$popupmenu add command -label [mc "Graphic Map +U"] -accelerator "$modstring+Shift+Y" -command "enz_graphic_map $w {==1}"
$popupmenu add separator
$popupmenu add command -label [mc "New Feature..."] -command "add_sel_feature_file $w"
menu $popupmenu.edit_feature
$popupmenu add cascade -label [mc "Edit Feature"] -menu $popupmenu.edit_feature -state disabled
menu $popupmenu.hide_feature
$popupmenu add cascade -label [mc "Hide Feature"] -menu $popupmenu.hide_feature -state disabled
menu $popupmenu.delete_feature
$popupmenu add cascade -label [mc "Delete Feature"] -menu $popupmenu.delete_feature -state disabled
$popupmenu add separator
$popupmenu add command -label [mc "BLAST Sequences at NCBI..."] -accelerator "$modstring+B" -command "NCBI_Blast $w"
#$popupmenu add command -label [mc "BLAST Sequences at Wormbase..."] -command "Wormbase_Blast $w"

#add Help menu
menu  $w.menubar.help1 
$w.menubar add cascade -menu $w.menubar.help1 -label [mc "Help"]
  $w.menubar.help1 add command -label [mc "Standard Genetic Code"] -command "genetic_code_dialog $w"
  $w.menubar.help1 add command -label [mc "AA Info"] -command "aa_info_dialog $w"


  #add windows/Aqua specific items
  if {[tk windowingsystem] != "aqua"} {
    #Exit is automatically on the apple menu in Aqua
    $w.menubar.filemenu add separator
    $w.menubar.filemenu add command -label [mc "Exit"] -accelerator "$modstring+Q" -command close_all_windows

    #About... goes on the apple menu in aqua
    $w.menubar.help1 add separator
    $w.menubar.help1 add command -label [mc "About ApE..."] -command "about_dialog $w"
    #$w.menubar.help1 add command -label [mc "Check for Updates"] -command "web_version_check 1"

    #add menu icons
    set iconlist [list $w.menubar.filemenu [mc New] new $w.menubar.filemenu [mc Open...] open $w.menubar.filemenu [mc Save] save $w.menubar.edit [mc "Cut"] cut $w.menubar.edit [mc "Copy"] copy $w.menubar.edit [mc "Paste"] paste $w.menubar.edit [mc "Cut Rev-Com"] cut $w.menubar.edit [mc "Copy Rev-Com"] copy $w.menubar.edit [mc "Paste Rev-Com"] paste $w.menubar.edit [mc "Select From-To..."] select $w.menubar.edit [mc "Jump To..."] jump $w.menubar.edit [mc "Find..."] find $w.menubar.edit [mc "Convert to UPPERCASE"] uppercase $w.menubar.edit [mc "Convert to lowercase"] lowercase $w.menubar.edit [mc "UPPER<->lower"] swap_case $w.menubar.edit [mc "Reverse-Complement"] reverse_com $w.menubar.edit [mc "Set Origin"] origin $w.menubar.enzymes [mc "Enzyme Selector..."] enzymes $w.menubar.enzymes [mc "Graphic Map"] graphic_map $w.menubar.enzymes [mc "Graphic Map +U"] graphic_map_u $w.menubar.enzymes [mc "Highlight"] highlight_enzymes $w.menubar.enzymes [mc "Clear Highlighting"] clear_highlighting $w.menubar.enzymes [mc "Digestion"] digest $w.menubar.enzymes [mc "Text Map..."] text_map $w.menubar.tools [mc "Find Primers..."] find_primers $w.menubar.tools [mc "Align Sequences..."] align $w.menubar.tools [mc "BLAST Sequences at NCBI..."] ncbi $w.menubar.tools [mc "BLAST Sequences at Wormbase..."] wormbase $w.menubar.tools [mc "Download sequences from NCBI..."] ncbi]
    foreach {menu item icon} $iconlist {
      catch {$menu entryconfigure $item  -compound left -image $toolbar_images($icon)} err
      #sputs $err
    }
  } else {
    #define the apple menu
    menu $w.menubar.apple 
    $w.menubar add cascade -menu $w.menubar.apple
    $w.menubar.apple add command -label [mc "About ApE"] -command "about_dialog $w"
    #$w.menubar.apple add command -label [mc "Check for Updates"] -command "web_version_check 1"
    $w.menubar.apple add separator
    #$w.menubar.apple add command -label [mc "Preferences..."]  -command "configure_preferences $w" -accelerator "$modstring+,"
    proc ::tk::mac::ShowPreferences {} configure_preferences
    catch {.menubar.filemenu entryconfigure [mc "New"] -state disabled}
    catch {.menubar.filemenu entryconfigure [mc "Open..."] -state disabled}
   catch { .menubar.filemenu entryconfigure [mc "Open Recent Files"] -state disabled}
    #.menubar.apple entryconfigure [mc "Preferences..."] -state disabled
    catch {.menubar.apple entryconfigure [mc "About ApE"] -state disabled}
    #bind . <Command-KeyPress-o> ""
    #bind . <Command-KeyPress-n> ""
    #bind . <Command-KeyPress-q> ""

    ##set the new window coordinates
    wm geometry $w "+$info(newaquax)+$info(newaquay)"
    incr info(newaquax) 20
    incr info(newaquay) 20
    if {$info(newaquax) > 100} {set info(newaquax) 20}
    if {$info(newaquay) > 100} {set info(newaquay) 20}
  }

#add menubar to the window
$w configure -menu $w.menubar



frame $w.toolbar -borderwidth 0 -height 100 -relief flat
pack propagate $w.toolbar 0
fill_toolbar $w

#bind $w <<ToolbarButton>> "if {\[grid info $w.toolbar\] == \"\"} {grid configure $w.toolbar} else {grid remove $w.toolbar; focus $w.textarea}"
bind $w <<ToolbarButton>> "if {\[grid info $w.toolbar\] == \"\"} {grid configure $w.toolbar; $w.toolbar configure -height 0; update idletasks; for {set i 0} {\$i <=30} {incr i 5} {$w.toolbar configure -height \$i; update}; grid configure $w.sep} else  {for {set i 30} {\$i >= 0} {incr i -5} {$w.toolbar configure -height \$i; update idletasks}; grid remove $w.toolbar;; grid remove $w.sep; focus $w.textarea}"

if {[tk windowingsystem] == "aqua"} {
  frame $w.infoframe -borderwidth 2 -relief flat
    set over_relief solid
    set press_relief solid
    set normal_relief flat
    set over_color $info(aqua_active_bg_color); #$info(bg_color)
    set press_color [gray_color $info(bg_color)]
    set normal_color $info(bg_color);#$info(bg_color)
} else {
  frame $w.infoframe -borderwidth 2 -relief ridge 
    set over_relief solid
    set press_relief solid
    set normal_relief flat
    set over_color $info(menu_bg_color)
    set press_color $info(menu_select_bg_color)
    set normal_color $info(bg_color)
}





  if {!$info(use_tile)} {
    label $w.infoframe.locked -image $toolbar_images([expr {$info($w,locked)?"locked":"unlocked"}]) -borderwidth 1
    bind $w.infoframe.locked <B1-Enter> "$w.infoframe.locked configure -bg $press_color -relief $press_relief"
    bind $w.infoframe.locked <Enter> "$w.infoframe.locked configure -bg $over_color -relief $over_relief; tooltip_enter $w.infoframe.locked \{[mc Lock/Unlock]\n[mc File]\}"
    bind $w.infoframe.locked <Leave> "$w.infoframe.locked configure -bg $normal_color -relief $normal_relief; tooltip_leave $w.infoframe.locked"
    bind $w.infoframe.locked <Button-1> "$w.infoframe.locked configure -bg $press_color -relief $press_relief"
    bind $w.infoframe.locked <ButtonRelease-1> "if \{\[$w.infoframe.locked cget -relief\] == \"$press_relief\"\} \{$w.infoframe.locked configure -bg $over_color -relief $over_relief; toggle_locked $w\} else \{$w.infoframe.locked configure -bg $normal_color -relief $normal_relief\}"
    #bind  $w.infoframe.locked <ButtonRelease> "toggle_locked $w"
    #tooltip_install $w.infoframe.locked "[mc Lock/Unlock]\n[mc File]"
  } else {
    ttk::checkbutton $w.infoframe.locked -style TexturedRoundedBezelStyle.TCheckbutton -image [list $toolbar_images(unlocked) selected $toolbar_images(locked)] -command "toggle_locked $w" -variable info($w,locked) -onvalue 1 -offvalue 0 
    tooltip_install $w.infoframe.locked "[mc Lock/Unlock]\n[mc File]"
  }  

  label $w.infoframe.linked_abi -image "" -borderwidth 0 -relief flat
  if {$info($w,linked_abi_list) != [list]} {
    $w.infoframe.linked_abi configure -image $toolbar_images(link)
    bind $w.infoframe.linked_abi <Enter> " tooltip_enter %W \{Right-click to see [llength $info($w,linked_abi_list)] linked abi files.\}"
    bind $w.infoframe.linked_abi <Leave> "tooltip_leave %W"
  }
  menu $w.infoframe.linked_abi.popupmenu
  bind $w.infoframe.linked_abi <Button-1> "linked_abi_popup $w %X %Y"
  if {[tk windowingsystem] != "aqua"} {
    bind $w.infoframe.linked_abi <Button-3> "linked_abi_popup $w %X %Y"
  } else {
    bind $w.infoframe.linked_abi <Button-2> "linked_abi_popup $w %X %Y"
    bind $w.infoframe.linked_abi <Control-Button-1> [bind $w.infoframe.linked_abi <Button-2>]
  }


  #checkbutton $w.infoframe.saved -text [mc "Saved"]  -variable info($w,saved) -onvalue 1 -offvalue 0 -selectcolor white -activebackground $info(bg_color) -disabledforeground $info(label_fg_color) -state normal -command  "if {!\[save_file $w Save\]} {set info($w,saved) \[expr {!\$info($w,saved)}\]}"
  #tooltip_install $w.infoframe.saved [mc {Click to Save File}]
  label $w.infoframe.totallenlabel -text [mc "Sequence"]  -height 1 
  label $w.infoframe.totallen  -height 1  
  label $w.infoframe.startlabel -text [mc "Start"]  -height 1  
  label $w.infoframe.start  -height 1   
  label $w.infoframe.sellenlabel -text [mc "Length"] -height 1  
  label $w.infoframe.sellen -height 1  
  label $w.infoframe.endlabel -text [mc "End"] -height 1  
  label $w.infoframe.end -height 1  
  label $w.infoframe.orflabel -text [mc "ORF"] -height 1  
  label $w.infoframe.orf -height 1  
  label $w.infoframe.tmlabel -text "Tm"  -height 1  
  label $w.infoframe.tm -height 1  
  label $w.infoframe.gclabel -text "%GC"  -height 1  
  label $w.infoframe.gc -height 1  
  label $w.infoframe.trans -height 1  -justify center 
  if {!$info(use_tile)} {
    label $w.infoframe.circular -textvariable info($w,circular_text)  -borderwidth 1 -compound left -image [expr {($info($w,circular) eq "circular") ? $toolbar_images(circular):""}]
    bind $w.infoframe.circular <B1-Enter> "$w.infoframe.circular configure -bg $press_color -relief $press_relief"
    bind $w.infoframe.circular <Enter> "$w.infoframe.circular configure -bg $over_color -relief $over_relief; tooltip_enter $w.infoframe.circular \{[mc Linear/Circular]\}"
    bind $w.infoframe.circular <Leave> "$w.infoframe.circular configure -bg $normal_color -relief $normal_relief; tooltip_leave $w.infoframe.circular"
    bind $w.infoframe.circular <Button-1> "$w.infoframe.circular configure -bg $press_color -relief $press_relief"
    bind $w.infoframe.circular <ButtonRelease-1> "if \{\[$w.infoframe.circular cget -relief\] == \"$press_relief\"\} \{$w.infoframe.circular configure -bg $over_color -relief $over_relief; toggle_circ $w\} else \{$w.infoframe.circular configure -bg $normal_color -relief $normal_relief\}" 
    #bind  $w.infoframe.circular <ButtonRelease> "toggle_circ $w"
  } else {
    ttk::button $w.infoframe.circular -textvariable info($w,circular_text) -style TextPopup.TexturedRoundedBezelStyle.TButton -command "toggle_circ $w"
  }
  set info($w,circular_text) [mc $info($w,circular)]
  #$w.infoframe.circular configure -height 1  -pady 0 -border 2
  checkbutton $w.infoframe.methylation -text "Dam/Dcm" -onvalue 1 -offvalue 0  -variable info($w,Dam_Dcm_methylated) -command "toggle_methylation $w" -selectcolor white -activebackground $info(bg_color)


  grid $w.infoframe.locked -row 0 -column 1
  #grid $w.infoframe.saved -row 0 -column 2
  grid columnconfigure $w.infoframe 2 -minsize [font measure labelfont 9999999]
  grid $w.infoframe.linked_abi  -row 1 -column 1
  grid [label $w.infoframe.mouseindex -text {} -justify left] -row 1 -column 2  -sticky nwe
  grid $w.infoframe.totallenlabel -row 0 -column 4
  grid $w.infoframe.totallen  -row 1 -column 4
  grid $w.infoframe.startlabel -row 0 -column 5
  grid $w.infoframe.start -row 1  -column 5
  grid $w.infoframe.sellenlabel -row 0 -column 6
  grid $w.infoframe.sellen -row 1  -column 6
  grid $w.infoframe.endlabel  -row 0 -column 7
  grid $w.infoframe.end  -row 1 -column 7
  grid $w.infoframe.orflabel  -row 0 -column 8
  grid $w.infoframe.orf  -row 1 -column 8
  grid $w.infoframe.tmlabel  -row 0 -column 9
  grid $w.infoframe.tm  -row 1 -column 9
  grid $w.infoframe.gclabel  -row 0 -column 10
  grid $w.infoframe.gc  -row 1 -column 10
  grid $w.infoframe.circular -row 0 -column 11 -sticky n;# -ipady 2
  grid $w.infoframe.methylation -row 1 -column 11
  grid $w.infoframe.trans -row 2 -column 1 -columnspan 11 -sticky ew
  if {!$info($w,selection_shows_Trans)} {grid remove $w.infoframe.trans}
  for {set infocol 3} {$infocol<12} {incr infocol} {
    grid columnconfigure $w.infoframe $infocol -weight 1
  }

  add_featuretable $w [expr {($tags != {}) && $info(show_FeatureTable)}]


if {[tk windowingsystem] eq "aqua"} {
  foreach j [list $w.infoframe {*}[winfo children $w.infoframe]] {
   # bind $j <Deactivate> "$j configure -background $info(bg_color)"
   # bind $j <Activate> "$j configure -background $info(aqua_active_bg_color)"
   # $j configure -background $info(aqua_active_bg_color)
  }
}


  label $w.infobox -width 1

  set iline ""
  set count 10
  while {[string length $iline] < $info(default_textarea_width)} {
    set iline "$iline    *[string repeat " " [expr {5-[string length $count]}]]$count"
    incr count 10
  }
#define the index windows above, below and left of the sequence
text $w.horzindex -font dnafont -width $info(default_textarea_width) -height 1 -background $info(bg_color) -fg $info(label_fg_color) -wrap none -relief flat -cursor arrow
$w.horzindex insert 1.0 $iline
bindtags $w.horzindex {$w.horzindex}

text $w.horzindex2 -font dnafont -width $info(default_textarea_width) -height 1 -background $info(bg_color) -fg $info(label_fg_color) -wrap none -relief flat -cursor arrow
$w.horzindex2 insert 1.0 $iline
bindtags $w.horzindex2 {$w.horzindex2}

text $w.vertindex -font dnafont -width 8 -background $info(bg_color) -fg $info(label_fg_color) -relief flat -cursor arrow
$w.vertindex insert 1.0 "1" allvertindex
$w.vertindex tag configure allvertindex -justify right
bindtags $w.vertindex {$w.vertindex}



#define textarea (sequence area) and bindings
text $w.textarea -font dnafont -width $info(default_textarea_width) -wrap char -borderwidth 1 -highlightthickness 1 -highlightcolor gray30 -padx 0 -setgrid true -inactiveselectbackground $info(text_select2_bg_color)
bind $w.textarea <Any-Motion> "mouseover_info $w \[$w.textarea index @%x,%y\]"
bind $w.textarea <Any-Leave> "mouseover_info $w -1"
bind $w.textarea <KeyPress> "keyevent_manager $w None %K ; break"
bind $w.textarea <KeyPress-space> "if {\[info exists info($w,seq_tooltip)]} {set info($w,seq_tooltip) \[expr {!\$info($w,seq_tooltip)}]} else {set info($w,seq_tooltip) 1}; if {\$info($w,seq_tooltip)} {seq_tooltip_post $w %x %y} else {catch {destroy $w.seqtooltip}}"
bind $w.textarea <Alt-KeyPress> #
bind $w <$modifier-KeyPress> "keyevent_manager $w Control %K ; break"
bind $w.textarea <$modifier-KeyPress> "keyevent_manager $w Control %K ; break"
bind $w.textarea <Shift-$modifier-KeyPress> "keyevent_manager $w ShiftControl %K ; break"
bind $w.textarea <Key-Left> "textarea_move_cursor $w Left; break"
bind $w.textarea <Key-Right> "textarea_move_cursor $w Right; break"
bind $w.textarea <Key-Down> "textarea_move_cursor $w Down; break"
bind $w.textarea <Key-Up> "textarea_move_cursor $w Up; break"
bind $w.textarea <MouseWheel> "vertscrollmanager $w scroll \[expr {int(1.0 * %D/-\$info(mousewheelunits))}\] units; mouseover_info $w \[$w.textarea index @%x,%y\]; break"
if {[tk windowingsystem] != "aqua"} {
  bind $w.textarea <B1-MouseWheel> "vertscrollmanager $w scroll \[expr {int(1.0 * %D/-\$info(mousewheelunits))}\] units; text_select_xy $w %x %y"
  bind $w.textarea <Button-3> "sequence_window_popup $w $popupmenu %X %Y"
  #bind $w.textarea <Button-2> "clip_paste $w; break"
} else {
  bind $w.textarea <B1-MouseWheel> "vertscrollmanager $w scroll \[expr {int(1.0 * %D/-\$info(mousewheelunits))}\] units; mouseover_info $w \[$w.textarea index @%x,%y\]; break"
  bind $w.textarea <Button-2> "sequence_window_popup $w $popupmenu %X %Y"
  bind $w.textarea <Control-Button-1> [bind $w.textarea <Button-2>]
  #bind $w.textarea <Button-3> "clip_paste $w; break"
}
bind $w.textarea <Shift-Key-Left> "textkeyselect $w Left; break"
bind $w.textarea <Shift-Key-Right> "textkeyselect $w Right; break"
bind $w.textarea <Shift-Key-Down> "textkeyselect $w Down; break"
bind $w.textarea <Shift-Key-Up> "textkeyselect $w Up; break"
#need to set the cursor only if it already has the focus
bind $w.textarea <Button-1> "if {(\[focus\] != \"$w.textarea\") && (\$dialogblock == 0)} {focus $w.textarea} else {textsetcursor $w \[text_closest_gap $w.textarea %x %y\]}"
bind $w.textarea <Key-Tab> "if {\[grid info $w.comframe\] == \"\"} {toggle_comment $w};focus $w.comframe.comtextframe.text; break"
bind $w.textarea <Double-Button-1> "select_region $w 1.0 end-1c"
bind $w.textarea <Shift-Button-1> "[bind Text <Shift-Button-1>]; selection_manager $w"
bind $w.textarea <Button1-Leave> "mouse_left_DNA $w %x %y; break"
bind $w.textarea <Button1-Enter> "cancel_scrolling_DNA"
bind $w.textarea <ButtonRelease-1> "cancel_scrolling_DNA"
bind $w.textarea <Button1-Motion> "text_select_xy $w %x %y; break"
#aqua bug: actvate doesn't focus corectly
bind $w.textarea <FocusIn> "set info($w,focuswin) textarea"
bind $w.textarea <Activate> "focus $w.\$info($w,focuswin)"

bindtags $w.textarea [list $w.textarea . all]
set info($w,focuswin) "textarea"
scrollbar $w.vertscroll -command "vertscrollmanager $w" -relief flat -width 16


grid columnconfigure $w 1 -weight 1
grid columnconfigure $w 2 -weight 0 -minsize 17

grid rowconfigure $w 0 -weight 0
grid rowconfigure $w 1 -weight 0
grid rowconfigure $w 2  -weight 0
grid rowconfigure $w 4  -weight 0
grid rowconfigure $w 5  -weight 0
grid rowconfigure $w 6 -minsize 2c -weight 1
grid rowconfigure $w 7  -minsize 16 -weight 0
grid rowconfigure $w 8 -weight 0
grid rowconfigure $w 9 -minsize 7 -weight 0

grid $w.toolbar -row 0 -column 0 -columnspan 3 -sticky new
grid [frame $w.sep -relief ridge -border 1 -height 2] -row 1 -column 0 -columnspan 3 -sticky nwe
grid $w.infoframe -row 2  -column 0 -columnspan 3 -sticky new
grid $w.infobox -row 4  -column 0  -columnspan 3  -sticky new
grid $w.horzindex -row 5 -column 1  -sticky nwe
grid  $w.vertindex -row 6 -column 0 -sticky nsw
grid $w.textarea -row 6 -column 1 -sticky nswe
grid $w.vertscroll -row 6 -column 2 -sticky nsw
grid $w.horzindex2 -row 7 -column 1  -sticky swe

#grid [button $w.show_header_info -height 15 -width 15 -borderwidth 0 -image $toolbar_images(info_button) -command "toggle_comment $w"] -row 3 -column 0
if {!$info(use_tile)} {
  grid [label $w.transparency -borderwidth 0 -image $toolbar_images(transparent)] -row 5 -column 0 -sticky n
} else {
  grid [ttk::button $w.transparency -style IconPopdown.TexturedRoundedBezelStyle.TButton -image $toolbar_images(transparent) -takefocus 0] -row 5 -column 0 -sticky n
}

tooltip_install $w.transparency [mc "Show Feature List"]
if {[tk windowingsystem] != "aqua"} {
  bind $w.transparency <Button-3> "toggle_features_treeview $w"
  bind $w.transparency <Button-1> "toggle_features_treeview $w"
} else {
  bind $w.transparency <Button-2> "toggle_features_treeview $w"
  bind $w.transparency <Control-Button-1> "toggle_features_treeview $w"
  bind $w.transparency <Button-1> "toggle_features_treeview $w"
}

if {0} {
##### old transparency code
tooltip_install $w.transparency [mc "Transparency Setting"]
menu $w.transparency.popup 
$w.transparency.popup add radiobutton -variable info(sequence_transparency) -value 0 -label 0
$w.transparency.popup add radiobutton -variable info(sequence_transparency) -value 10 -label 10
$w.transparency.popup add radiobutton -variable info(sequence_transparency) -value 25 -label 25
$w.transparency.popup add radiobutton -variable info(sequence_transparency) -value 50 -label 50
$w.transparency.popup add radiobutton -variable info(sequence_transparency) -value 75 -label 75
$w.transparency.popup add radiobutton -variable info(sequence_transparency) -value 90 -label 90
$w.transparency.popup add separator
$w.transparency.popup add radiobutton -variable info(sequence_transparency_mode) -value all -label [mc "All"]
$w.transparency.popup add radiobutton -variable info(sequence_transparency_mode) -value overlap -label [mc "Overlap"]
$w.transparency.popup add radiobutton -variable info(sequence_transparency_mode) -value overlap-all -label [mc "Overlap-All"]
if {[tk windowingsystem] != "aqua"} {
  bind $w.transparency <Button-3> "tk_popup $w.transparency.popup %X %Y"
  bind $w.transparency <Button-1> "tk_popup $w.transparency.popup %X %Y"
} else {
  bind $w.transparency <Button-2> "tk_popup $w.transparency.popup %X %Y"
  bind $w.transparency <Control-Button-1> "tk_popup $w.transparency.popup %X %Y"
  bind $w.transparency <Button-1> "tk_popup $w.transparency.popup %X %Y"
}



bind $w.transparency <Enter> "+ trans_enter $w"
bind $w.transparency <Leave> "+ foreach tag \[lsearch -inline -all -regexp \[$w.textarea tag names\] {trans\[0-9\]+#}\] {
    $w.textarea tag remove \$tag 1.0 end
  }; configure_transparency $w 0"
##### old transparency code
}


  if {!$info(use_tile)} {
    grid [label $w.showcomment -height 16 -width 15 -borderwidth 0 -image $toolbar_images(comment_button)] -row 7 -column 0 -ipadx 1
    bind $w.showcomment <B1-Enter> "$w.showcomment configure -bg $press_color -relief $press_relief"
    bind $w.showcomment <Enter> "$w.showcomment configure -bg $over_color -relief $over_relief; tooltip_enter $w.showcomment \"\[mc Show/Hide\]\n\[mc \{File Comment\}\]\""
    bind $w.showcomment <Leave> "$w.showcomment configure -bg $normal_color -relief $normal_relief; tooltip_leave $w.showcomment"
    bind $w.showcomment <Button-1> "$w.showcomment configure -bg $press_color -relief $press_relief"
    bind $w.showcomment <ButtonRelease-1> "if \{\[$w.showcomment cget -relief\] == \"$press_relief\"\} \{$w.showcomment configure -bg $over_color -relief $over_relief; toggle_comment $w\} else \{$w.showcomment configure -bg $normal_color -relief $normal_relief\}" 
    #bind "$w.showcomment" <B1-ButtonRelease> "toggle_comment $w"
    #tooltip_install $w.showcomment "[mc Show/Hide]\n[mc {File Comment}]"
  } else {
    grid [ttk::checkbutton $w.showcomment -image $toolbar_images(comment_button) -style IconDisclosure.TexturedRoundedBezelStyle.TCheckbutton -command "toggle_comment $w"] -row 7 -column 0 -ipadx 1
    tooltip_install $w.showcomment "[mc Show/Hide]\n[mc {File Comment}]"
  }

grid [ttk::frame $w.comframe -style Roundframe] -row 8 -column 0 -columnspan 3 -sticky nwe  -padx 5
grid [frame  $w.comframe.comtextframe] -row 1 -column 1 -sticky nwe -padx 10 -pady 10;# -style Textbgframe
grid [text $w.comframe.comtextframe.text -yscrollcommand "optionscrollbar $w.comframe.comtextframe.scrolly" -wrap char -width 1  -height $info(comment_height) -font labelfont  -borderwidth 1 -highlightthickness 1 -highlightcolor gray30] -row 0 -column 0 -sticky nswe -padx 2 -pady 3
grid [scrollbar $w.comframe.comtextframe.scrolly -orient vertical -command "$w.comframe.comtextframe.text yview"] -row 0 -column 1 -sticky nse
  if {[tk windowingsystem] == "aqua"} {
    set resize_cursor resizeupdown
  } elseif {[tk windowingsystem] == "win32"} {
    set resize_cursor resizeupdown
  } else {
    set resize_cursor sb_v_double_arrow
  }
grid [frame  $w.comframe.comtextframe.resize -height 3 -bg $info(bg_color) -cursor $resize_cursor] -row 1 -column 0 -columnspan 2 -sticky nwe 
grid configure $w.comframe.comtextframe.text -pady 0
  bind  $w.comframe.comtextframe.resize <ButtonPress-1> "bind $w.comframe.comtextframe.text <<resizeY>> %Y; bind $w.comframe.comtextframe.text <<resizeHeight>> \[$w.comframe.comtextframe.text cget -height\]"
  bind  $w.comframe.comtextframe.resize <Button1-Motion> "comment_resize $w.comframe.comtextframe.text %Y"

grid columnconfigure $w.comframe 1 -weight 1
grid rowconfigure $w.comframe 1 -weight 1
grid columnconfigure $w.comframe.comtextframe 0 -weight 1
grid rowconfigure $w.comframe.comtextframe 0 -weight 1
if {!$info(show_comment)} {
  grid remove $w.comframe
}


$w.comframe.comtextframe.text insert 1.0 $filecomment
bind $w.comframe.comtextframe.text <$modifier-KeyPress> "comment_keyevent_manager $w Control %K ; break"
bind $w.comframe.comtextframe.text <Shift-$modifier-KeyPress> "comment_keyevent_manager $w ShiftControl %K ; break"
bind $w.comframe.comtextframe.text <Key> "if {\[string equal %A \"\"\] || \[file_lock_check $w\]} {break} else {set info($w,saved) 0;  if {\[tk windowingsystem\] == \"aqua\"} {wm attributes $w -modified 1}}" 
bind $w.comframe.comtextframe.text <Delete> "if {\[file_lock_check $w\]} {break} else {set info($w,saved) 0;if {\[tk windowingsystem\] == \"aqua\"} {wm attributes $w -modified 1}}"
bind $w.comframe.comtextframe.text <Key-BackSpace> "if {\[file_lock_check $w\]} {break} else {set info($w,saved) 0;if {\[tk windowingsystem\] == \"aqua\"} {wm attributes $w -modified 1}}"
bind $w.comframe.comtextframe.text <Key-Return> "if {\[file_lock_check $w\]} {break} else {set info($w,saved) 0;if {\[tk windowingsystem\] == \"aqua\"} {wm attributes $w -modified 1}}"
bind $w.comframe.comtextframe.text <Key-Tab> "focus $w.textarea; break"
bind $w.comframe.comtextframe.text <FocusIn> "set info($w,focuswin) comframe.comtextframe.text"
bind $w.comframe.comtextframe.text <<Cut>> "if {\[file_lock_check $w\]} {break} else {set info($w,saved) 0;if {\[tk windowingsystem\] == \"aqua\"} {wm attributes $w -modified 1}}"
bind $w.comframe.comtextframe.text <<Paste>> "if {\[file_lock_check $w\]} {break} else {set info($w,saved) 0;if {\[tk windowingsystem\] == \"aqua\"} {wm attributes $w -modified 1}}"
foreach event [list <Shift-Key-Down> <Shift-Key-Up> <Shift-Key-Right> <Shift-Key-Left> <Key-Down> <Key-Up> <Key-Right> <Key-Left>] {
  bind $w.comframe.comtextframe.text $event #
}
bindtags $w.comframe.comtextframe.text [list $w.comframe.comtextframe.text Text all]

register_undo $w cant

#grid [label $w.filename -textvariable info($w,filename)  -justify right -width 1] -row 8 -column 1 -columnspan 1 -sticky nwe
#grid [label $w.mouseindex -text {} -justify left] -row 8 -column 0  -sticky nwe

#weird bug in the deiconify proc, need to raise all the windows to get the topmost activated
#bind $w <Map> "if {\[winfo class %W\]  == \"Toplevel\"} {event generate . <<RaiseDialogs>>; catch {foreach wx \[wm stackorder .\] {raise \$wx}}}"
bind $w <Map> "if {\[winfo class %W\]  == \"Toplevel\"} {event generate . <<RaiseDialogs>>}"
bind $w <FocusIn> "if {\[winfo class %W\]  == \"Toplevel\"} {after 200 event generate . <<RaiseDialogs>>}"
bind $w <Activate> "if {\[winfo class %W\]  == \"Toplevel\"} {after 200 event generate . <<RaiseDialogs>>}"

if {$reuse_startup && [winfo exists .dna_window0]} {
    catch {wm geometry $w [regexp -inline {[+-].*} [wm geometry .dna_window0]]}
}
wm deiconify $w
focus $w.textarea


if {[regexp -nocase {[^ABCDGHKMNRSTVWYabcdghkmnrstvwy*]} $newdna]} {
  tk_messageBox -message "error: Bad dna into create new window." -type "ok"
}

set newdna "[join [regexp -inline -all [string repeat . $info(default_textarea_width)] $newdna] \n]\n[string range $newdna end-[expr {[string length $newdna] % $info(default_textarea_width) - 1}] end]"
set info($w,textwidth) $info(default_textarea_width)

textarea_insert $w.textarea 1.0 $newdna

#don't know why this update is necessary for large texts (Mb) with many tags
update
#have to put the features in after recalculating the width so that the reline proc is called
set fea_info($w,count) 0
if {$tags != {}} {
  put_tags $w.textarea {1.0 end-2c} $tags forward 1
}


$w.textarea mark set insert 1.0
#textarea_width_changed $w
if {![winfo exists $w]} {return}


set info($w,scanned) 0
set info($w,linked_events) [list]
$w.textarea tag configure sel -background $info(text_select_bg_color) -foreground $info(text_select_fg_color) -relief flat
$w.textarea tag configure tempsel -background $info(text_select2_bg_color) -foreground $info(text_select2_fg_color)
$w.textarea tag lower tempsel

global tcl_platform
if {($tcl_platform(platform) == "unix") && ([tk windowingsystem] != "aqua")} {
    selection handle -type UTF8_STRING -selection CUT_BUFFER0 $w unix_cubuffer_handler
    selection handle -type STRING -selection CUT_BUFFER0 $w unix_cubuffer_handler
    selection handle -type UTF8_STRING -selection CLIPBOARD $w unix_cubuffer_handler
    selection handle -type STRING -selection CLIPBOARD $w unix_cubuffer_handler
} elseif {$tcl_platform(platform) == "windows"} {
    wm deiconify $w
    if {([lsearch -exact [package names] "tkdnd"] > -1)} {
      dnd bindtarget $w Files <Drop> {HandleFileDrop  %D %T}
    }
}
if {($tcl_platform(platform) != "unix") || ([tk windowingsystem] == "aqua")} {
    bind $w <Shift-Button-3> {console show}
    bind $w.textarea <Shift-Button-3> {
      console show
      set w [lindex [winfo children .] 0]
    }
  event generate $w <Activate>
}
bind $w.textarea <Configure> "textarea_width_changed $w"

$w.textarea mark set insert 1.0
$w.textarea mark set anchor 1.0
$w.textarea mark set tk::anchor$w.textarea 1.0

window_on_screen $w


vertindexbalancer $w
selection_manager $w

# have to make the info box and toolbar as narrow as possible, then turn off grid propagation, so that they don't make the window wider than the text box
update
$w.infoframe configure -width 1 -height [winfo height $w.infoframe]
foreach f [winfo children $w.infoframe] {grid remove $f}
grid propagate $w.infoframe 0
foreach f [winfo children $w.infoframe] {grid configure $f}


focus -force $w.textarea
event generate $w.textarea <Button-1> -x 1 -y 1
event generate $w.textarea <ButtonRelease-1> -x 1 -y 1
if {$reuse_startup && [winfo exists .dna_window0]} {
    wm withdraw .dna_window0
#odd aqua bug- can't close the window too soon after it is made- problem if you start ApE by double clicking a file- opens blank, and window1 at same time, closing blank too soon and crashing
  if {[tk windowingsystem] == "aqua"} {
    if {[catch {update_windows_menu} err]} {tk_messageBox  -message "windows menu: $err"}
    after 3000 {catch {closewindow .dna_window0}}
  } else {
    catch {closewindow .dna_window0}
  }
}

return $w
}

##############
## add the feature table treeview to a window
##############
# right-click to edit data, proc to then update feature data
# double click feature name to bring up old edit dialog
# right click popup menu in headings to set visible columns, move current column left or right (can't move feature name), set number of rows displayed
# right click popup on items: 0: edit data 1: configure graphics:  arrow names that are pre-set and editable, width, color; 2: raise, and lower to right-click popup
# "new sub-feature" row

## feature_group column
## right click menu in feaure_group column heading to apply tag to selected ("new tag..." option)
## hidden column
## can do a list, hide or add tag to selected items
## right click menu in type column heading to select all of a type- 
proc add_featuretable {w {show 1}} {
  global info
  set f [frame $w.tvframe]
  set t $f.tv
  set sc $f.sc
  ttk::treeview $t -yscrollcommand "optionscrollbar $sc" -height 3
  scrollbar $sc -orient vertical -command "treeview_do_entry_edit $t; $t yview"
  if {[tk windowingsystem] == "aqua"} {
    set resize_cursor resizeupdown
  } elseif {[tk windowingsystem] == "win32"} {
    set resize_cursor resizeupdown
  } else {
    set resize_cursor sb_v_double_arrow
  }
  frame $w.tvframe.resize -height 3 -bg $info(bg_color) -cursor $resize_cursor
  bind $t <MouseWheel> "treeview_do_entry_edit $t"
  grid $f -row 3 -column 0 -columnspan 3 -sticky ew  -padx 5
  grid $f.tv -row 0 -column 0  -sticky nsew
  grid $f.sc -row 0 -column 1 -sticky nsw
  grid $w.tvframe.resize -row 1 -column 0 -columnspan 2 -sticky ew
  grid columnconfigure $f 0 -weight 1
  $t configure -columns {Direction Type Location}
  $t heading #0 -text "Feature" -command "treeview_sort $t {}"
  $t column #0 -width 200 -minwidth 50 -stretch 1 -anchor e
  $t heading Direction -text Direction -command "treeview_sort $t Direction"
  $t column Direction -width 60 -minwidth 50 -stretch 0 -anchor c
  $t heading Type -text Type  -command "treeview_sort $t Type"
  $t column Type -width 150 -minwidth 50 -stretch 0 -anchor c
  $t heading Location -text "Location  \u2193"  -command "treeview_sort $t Location"
  $t column Location -minwidth 50 -stretch 1 -anchor c
  if {!$show} {
    grid remove $f
  }

  bind $t <<TreeviewSelect>> "treeview_manageselection $t"
  bind $t <<OldSelection>> {}
  $t tag configure sel -background $info(text_select_bg_color)
  bind $t <<Sort_column>> Location
  bind $t <<Sort_direction>> 1
  bind $t <Button-2> "sputs button2 \[$t identify column %x %y]  \[$t identify row %x %y]"
  bind $t <Button-2> "treeview_rightclick $w %x %y"
  bind $w.tvframe.resize <ButtonPress-1> "bind $t <<resizeY>> %Y; bind $t <<resizeHeight>> \[$t cget -height\]"
  bind $w.tvframe.resize <Button1-Motion> "treeview_resize $t %Y"
}
## some style configurations
# components: Treeview Item Cell Heading Row
# ttk::style configure Treeview -rowheight 18
# ttk::style configure Row -background red
# Heading backgrounds:
#    set id2 [image create photo -width 3 -height 15]
#    $id2 blank
#    $id2 put {{blue blue blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue red blue} {blue blue blue}}
#    ttk::style element create Treehaeding.field6 image $id2 -border [list 1 1 1 1] -sticky nsew; # need to define images for pressed and normal
#    ttk::style layout Heading {Treehaeding.field6 -sticky we Treeheading.image -side right -sticky {} Treeheading.text -sticky {}}
# Fonts:
#    ttk::style configure Heading -font {Courier 24}
#    ttk::style configure Heading -font {Helvetica 11 bold} -foreground gray40; # iTunes11
#    ttk::style configure Treeview.Item -font {Courier 12}; # sets only the 0# column
#    ttk::style configure Treeview.Cell -font {Courier 12}; # sets all but 0# column
#

##############
## toggle visiblity of the feature table treeview
##############
proc toggle_features_treeview {w} {
  if {[grid info $w.tvframe] == ""} {
    grid configure $w.tvframe
    update
  } else {
    grid remove $w.tvframe
    update
  }
}

##############
## add sel tag to all selections in the feature table treeview (normal selection highlight is below tag backgrounds)
##############
proc treeview_manageselection {t} {
  foreach item [bind $t <<OldSelection>>] {
    if {[set i [lsearch [$t item $item -tags] sel]] > -1} {
      $t item $item -tags [lreplace [$t item $item -tags] $i $i]  
    }
  }
  foreach item [$t selection] {
     $t item $item -tags [list {*}[$t item $item -tags] sel]
  }
  bind $t <<OldSelection>> [$t selection]
}

##############
## resize feature table by dragging resize frame
##############
proc treeview_resize {t y} {
  set deltaY [expr {$y-[bind $t <<resizeY>>]}]
  set w [winfo toplevel $t]
  set newHeight [expr {[bind $t <<resizeHeight>>] + $deltaY / [ttk::style configure Treeview -rowheight]}]
  if {[$t cget -height] != $newHeight && $newHeight > 2} {
    grid propagate $w.tvframe 0
    $t configure -height $newHeight
    $w.tvframe configure -height [expr {[winfo reqheight $t]+4}]
  }
}

##############
## add all textarea features to the feature table treeview
##############
# call features_to_tree_view after: #put_tags #feature_scan #rename_recolor_window_feature #feature_cleanup #feature_clear #delete_feature
    #<<Metadata>>:(0)name, (1)format_info, (2)type, (3)fwd/rev, (4)annotations_string
proc features_to_tree_view {w} {
  set tv $w.tvframe.tv
  set text $w.textarea
  set taglist [lsearch -inline -regexp -all -not [$text tag names] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|foundf|foundr}]
  $tv delete [$tv children {}]
  set new_taglist [list]
  foreach tag $taglist {
    #<<Metadata>>:(0)name, (1)format_info, (2)type, (3)fwd/rev, (4)annotations_string
    set meta [$text tag bind $tag <<Metadata>>]
    lappend new_taglist [list $tag [lindex $meta 0] [lindex $meta 3] [lindex $meta 2] [feature_coords_text $w $tag]  [lindex $meta 4]]

  }
  foreach tag_record [lsort -dictionary -index [lsearch [list tag {} Direction Type Location subfeatures] [bind $tv <<Sort_column>>]] {*}-[expr {[bind $tv <<Sort_direction>>]?"increasing":"decreasing"}] $new_taglist] {
    set tag [lindex $tag_record 0]
    if {[set ranges [$w.textarea tag ranges $tag]] == {}} {continue}
    catch {$tv insert {} end -id $tag -text [lindex $tag_record 1] -tag $tag} 
    $tv set $tag Direction [expr {[lindex $tag_record 2]?"<<<":">>>"}]
    $tv set $tag Type [lindex $tag_record 3]
    $tv set $tag Location [lindex $tag_record 4]
    if {[llength $ranges] > 2} {
      $tv tag bind  $tag <Shift-Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 2]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 3]]\]; $w.textarea see [lindex $ranges 2]" 
    }
    set i 0
    foreach {subfeature data}  [lindex $tag_record 5] {
      $tv insert $tag end -id "$tag.$i#" 
      $tv set "$tag.$i#" Type $subfeature
      $tv set "$tag.$i#" Location $data
      incr i
    }
    $tv tag configure $tag -background [$w.textarea tag cget $tag -background]
    $tv tag bind $tag <Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges end]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 0]]\] ; $w.textarea see [lindex $ranges 0]" 
  }
}

##############
## sort feature table treeview
##############
proc treeview_sort {t column} {
  global toolbar_images
  if {([bind $t <<Sort_column>>] == $column)} {
    set direction [expr {![bind $t <<Sort_direction>>]}]
  } else {
    set direction 1
  }
  set l [list]
  foreach item [$t children {}] {
    if {$column != {}} {
      lappend l [list $item [$t set $item $column]]
    } else {
      lappend l [list $item [$t item $item -text]]
    }
  }
  set o [list]
  foreach pair [lsort -dictionary -index 1 {*}-[expr {$direction?"increasing":"decreasing"}] $l] {
      lappend o [lindex $pair 0]
  }
  $t children {} $o

  #remove the arrow on the old sort column
  set ccolumn [bind $t <<Sort_column>>]
  if {[bind $t <<Sort_column>>] == {}} {
    $t heading #0 -text "Feature"  
  } else {
    $t heading $ccolumn -text [$t column $ccolumn -id]
  }

  #add the arrow to the new column
  if {$column == {}} {set ctext "Feature"; set ccolumn #0} else {set ctext [$t column $column -id]; set ccolumn $column}
  if {$direction} {
   $t heading $ccolumn -text "$ctext \u2193"
  } else {
   $t heading $ccolumn -text "$ctext \u2191"
  }
  bind $t <<Sort_column>> $column
  bind $t <<Sort_direction>> $direction
}

##############
## process right-click events in the feature table treeview
##############
proc treeview_rightclick {w x y} {
  set f $w.tvframe
  set t $w.tvframe.tv
  set column [$t identify column $x $y]  
  set row [$t identify row $x $y]
  if {($row !={}) && ([$t bbox $row] == {})} {set row {}}
  set column [$t column $column -id]
sputs rightclick $w $row $column
  if {($row != {}) && (![regexp {#\.} $row])} {
    if {[winfo exists $t.popupmenu]} {
      destroy $t.popupmenu
    }
    #right click on items
    set metadata [$w.textarea tag bind $row <<Metadata>>]
    set popupmenu [menu $t.popupmenu]
    $t.popupmenu add command -label [lindex $metadata 0] -state disabled
    $t.popupmenu add separator
    if {($column == {})} {
      $t.popupmenu add command -label [mc "Edit Feature Name"] -command "treeview_edit_item $t $row #0; bind $t <<CellEntryEdit>> \"featuretable_edit_name \""
      $t.popupmenu add cascade -label [mc "Edit Appearance"] -menu $t.popupmenu.popup1
        menu $t.popupmenu.popup1
        $t.popupmenu.popup1 add command -label [mc "Change Color"] -command "featuretable_edit_items $w $row color"
          menu $t.popupmenu.popup1.a
          $t.popupmenu.popup1 add cascade -label [mc "Arrow Style"] -menu $t.popupmenu.popup1.a
      $t.popupmenu add cascade -label [mc "Arrange"] -menu $t.popupmenu.popup2
        menu $t.popupmenu.popup2
        $t.popupmenu.popup2 add command -label [mc "Bring to Top"] -state disabled
        $t.popupmenu.popup2 add command -label [mc "Send to Bottom"] -state disabled
      $t.popupmenu add command -label [mc "Add Subfeature"] -state disabled
      $t.popupmenu add command -label [mc "Delete Feature"]  -command "featuretable_edit_items $w $row delete"
    } elseif {($column == "Direction")} {
      $t.popupmenu add command -label [mc "Reverse Feature"] -state disabled
    } elseif {($column == "Type")} {
      $t.popupmenu add cascade -label [mc "Feature Type"] -menu $t.popupmenu.popup1
        $t.popupmenu.popup1 add command -label [mc "Set New Type Here"] -state disabled
    } elseif {($column == "Location")} {
      $t.popupmenu add command -label [mc "Uppercase Only"] -command "featuretable_change_loc $w $row upper"
      $t.popupmenu add command -label [mc "Feature Plus Selection"] -command "featuretable_change_loc $w $row plus_sel"
      $t.popupmenu add command -label [mc "Feature Minus Selection"] -command "featuretable_change_loc $w $row minus_sel"
    }
    tk_popup $t.popupmenu [winfo pointerx $w] [winfo pointery $w]
  } elseif {[regexp {#\.} $row]} {
#right click on subfeature
sputs right click on subfeature
  } else {
# right click popup menu in headings to set visible columns, move current column left or right (can't move feature name), set number of rows displayed
sputs right click on heading
  }
}

##############
## utility proc for editing texts in feature table callback proc for <<CellEntryEdit>> event
##############
proc featuretable_edit_name {tv feature column} {
  set w [winfo toplevel $tv]
  
  if {([$w.textarea tag ranges $feature] != {}) && ($column == "#0")} {
    set metadata [$w.textarea tag bind $feature <<Metadata>>]
    lset metadata 0 [$tv item $feature -text]
    $w.textarea tag bind $feature <<Metadata>> $metadata
    set info($w,saved) 0
    if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
  }
}

##############
## utility proc for editing feature locations
##############
proc featuretable_change_loc {w feature function} {
  set old_loc [feature_coords_text $w $feature]
  switch $function {
    "upper" {
      set new_loc [locations_upper $w $old_loc]
    }
    "plus_sel" {
      set new_loc [locations_plus_selection $w $old_loc plus_sel]
    }
    "minus_sel" {
      set new_loc [locations_plus_selection $w $old_loc minus_sel]
    }
  }
  set loc_list [split [regsub -all {\.+} $new_loc ,] ".,"]
  $w.textarea tag remove $feature 1.0 end
  foreach {a b} $loc_list {
    incr a -1
    $w.textarea tag add $feature [bp2ix $w.textarea $a] [bp2ix $w.textarea $b]
  }
  if {([llength [$w.textarea tag ranges $feature]] == 2) || (([llength [$w.textarea tag ranges $feature]] == 4) && ([lindex $loc_list 0] > [lindex $loc_list end])) } {
    $w.textarea tag delete [regsub f $feature fn]
  } elseif {([lindex $loc_list 0] > [lindex $loc_list end])} {
    $w.textarea tag add [regsub f $feature fn] [bp2ix $w.textarea [expr {[lindex $loc_list 0] -1}]] [$w.textarea index end-1c]
    $w.textarea tag add [regsub f $feature fn] 1.0 [bp2ix $w.textarea [lindex $loc_list end]]
  } else {
    $w.textarea tag add [regsub f $feature fn] [bp2ix $w.textarea [expr {[lindex $loc_list 0] -1}]] [bp2ix $w.textarea [lindex $loc_list end]]
  }
  $w.tvframe.tv set $feature Location $new_loc
  set info($w,saved) 0
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
}

##############
## 
##############
proc featuretable_edit_items {w feature column args} {
  set t $w.tvframe.tv
  if {[regexp {f[0-9]+#\.[0-9]+#} $feature]} {
    edit sub-features here
  } elseif {([regexp {f[0-9]+#} $feature]) && ([$w.textarea tag ranges $feature] != {})} {
    set metadata [$w.textarea tag bind $feature <<Metadata>>]
    switch $column {
      "delete" {
        set info($w,saved) 0
        if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
        $w.textarea tag delete $feature
        $w.textarea tag delete [regsub "f" $feature "fn"]
        $t delete $feature
      }
      "color" {
        if {[set newColor [tk_chooseColor -parent $w -title "Choose New Color"]] != {}} {
          set dir [lindex $metadata 3]
          set colorlist [$w.textarea tag bind $feature <<Revcolors>>]
          lset colorlist $dir $newColor
          $w.textarea tag bind $feature <<Revcolors>> $colorlist
          if {[$w.textarea tag cget $feature -background] != {}} {
            $w.textarea tag configure $feature -background [lindex $colorlist $dir]
          }
          $t tag configure $feature -background [lindex $colorlist $dir]
          set info($w,saved) 0
          if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
        }
      }
      "raise" {

      }
      "lower" {

      }
      "gformat" {

      }
      "direction" {

      }
      "type" {

      }
    }
    $w.textarea tag bind $feature <<Metadata>> $metadata
  }
}

##############
## utility proc for editing texts in a treeview
##############
proc treeview_edit_item {t row column} {
  if {[$t bbox $row $column] == {}} return
  if {[winfo exists $t.entry]} {
    treeview_do_entry_edit $t
  }
  if {![winfo exists $t.entry]} {
    place [entry $t.entry -highlightthickness 2 -borderwidth 0] -x 0 -y 0
    bind $t.entry <Key-Return> "focus \[winfo toplevel %W\]"
    bind $t.entry <FocusOut> "treeview_do_entry_edit $t"
  } else {
    return
  }
  foreach {x0 y0 x1 y1} [$t bbox $row $column] {}
  place configure $t.entry -x $x0 -y [expr {$y0-2}] -relwidth [expr {1.0*($x1-$x0)/([winfo width $t]+8)}]
  $t.entry delete 0 end
  $t.entry insert 0 [$t item $row -text]
  bind $t.entry <<row>> $row
  bind $t.entry <<column>> $column
  update
  focus $t.entry
}

##############
## utility proc for editing texts in a treeview
##############
proc treeview_do_entry_edit {treeview} {
  set entry $treeview.entry
  if {[winfo exists $entry]} {
    set text [$entry get]
    set row [bind $entry <<row>>]
    set column [bind $entry <<column>>]
    destroy $entry
    if {$column == "#0" || $column == {}} {
      $treeview item $row -text $text
    } else {
      $treeview set $row $column $text
    }
    catch {{*}[bind $treeview <<CellEntryEdit>>] $treeview $row $column}
  }
}


##############
## read the toolbar button images
##############
proc read_toolbar_images {} {
  global toolbar_images tooltip_after
  #global argv0
  global info

  image create photo blank -height 16 -width 16
  blank blank

  set tooltip_after "not_showing"

  #set toolbar_images(separator) [image create photo -height 16 -width 3]
  #$toolbar_images(separator) put {{gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30} {gray90 gray90 gray30}}

  set toolbar_images(separator) [image create photo -height 16 -width 1]
  $toolbar_images(separator) put {{gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90} {gray90}}
  set image_dir [file join $info(Accdir) "Icons and images"]
  if {![file isdirectory $image_dir]} {
    warning_dialog "Please put the toolbar button images in: $image_dir"
    set error 1
  } else {
    set error 0
  }

  foreach button [list new open duplicate save cut copy paste select jump find find_again clear_find uppercase lowercase swap_case reverse_com  origin enzymes enzymes_sonly graphic_map graphic_map_u highlight_enzymes clear_highlighting digest text_map find_primers align circular linear ncbi wormbase dna_win abi_win ana_win comment_button locked unlocked link transparent info_button error info question warning monkey_icon more_arrow ] {
    if {(![file isfile "$image_dir/$button.png"]) || ([catch {set toolbar_images($button) [image create photo -file "$image_dir/$button.png"]}] != 0)} {
      if {(![file isfile "$image_dir/$button.gif"]) || ([catch {set toolbar_images($button) [image create photo -file "$image_dir/$button.gif"]}] != 0)} {
        set toolbar_images($button) [image create photo -height 16 -width 16]
        $toolbar_images($button) copy blank
      }
    } 
  }
  set toolbar_images(blank) [image create photo -height 16 -width 16]
  $toolbar_images(blank) copy blank
  image delete blank

  set toolbar_images(enzymes_all) [image create photo -height 16 -width 16]
  $toolbar_images(enzymes_all) copy $toolbar_images(enzymes)
##change the toolbar image when select only is toggled"
  trace add variable info(analyze_selection) write {
    if {$info(analyze_selection)== "selection"} {
      $toolbar_images(enzymes) blank
      $toolbar_images(enzymes) copy $toolbar_images(enzymes_sonly)
    } else {
      $toolbar_images(enzymes) blank;
      $toolbar_images(enzymes) copy $toolbar_images(enzymes_all)
    }
  #  }

  #### ttk styles for sequence window button elements
  if {[file exists "$image_dir/button_backgrounds"]} {
    foreach image [list active.regular active.pressed.regular active.on.regular active.on.pressed.regular inactive.regular inactive.on.regular popup.arrows.regular popup.arrows.disabled.regular popdown.arrow.regular disclosuretriangle.close disclosuretriangle.close.pressed disclosuretriangle.open.pressed disclosuretriangle.open groupbox.active.primary textfield.active.outline.regular] {
      if {(![file isfile "$image_dir/button_backgrounds/$image.png"]) || ([catch {set toolbar_images($image) [image create photo -file "$image_dir/button_backgrounds/$image.png"]}])} {
        if {(![file isfile "$image_dir/button_backgrounds/$image.gif"]) || ([catch {set toolbar_images($image) [image create photo -file "$image_dir/button_backgrounds/$image.gif"]}])} {
          set toolbar_images($image) [image create photo -height 16 -width 16]
          $toolbar_images($image) copy $toolbar_images(blank)
        }
      } 
    }

    #bg_color background
    image create photo image_osxbg -width 16 -height 16
    if {[tk windowingsystem] eq "aqua"} {
      image_osxbg put $info(bg_color) -to 0 0 16 16
    } else {
      image_osxbg blank
    }
    ttk::style element create OSXBackground image image_osxbg -border {1 1 1 1} -padding {0} -sticky news

    #plain icon button
    ttk::style configure TexturedRoundedBezelStyle.TButton -relief flat -anchor center
    ttk::style element create TexturedRoundedBezelStyle.TButton.backbutton image [list $toolbar_images(active.regular) disabled $toolbar_images(active.regular) pressed $toolbar_images(active.pressed.regular) active $toolbar_images(active.regular) background $toolbar_images(inactive.regular)] -border [list 5 5 5 5] -sticky nsew
    ttk::style layout TexturedRoundedBezelStyle.TButton "OSXBackground TexturedRoundedBezelStyle.TButton.backbutton -sticky nswe Button.image -sticky {}"

    #popup text button
    ttk::style configure TextPopup.TexturedRoundedBezelStyle.TButton -relief flat -anchor center
    ttk::style element create TextPopup.TexturedRoundedBezelStyle.TButton.PopupArrows image [list $toolbar_images(popup.arrows.regular) disabled $toolbar_images(popup.arrows.disabled.regular) pressed $toolbar_images(popup.arrows.regular) active $toolbar_images(popup.arrows.regular) background $toolbar_images(popup.arrows.disabled.regular)] -border [list 0 0 0 0] -sticky e
    ttk::style element create TexturedRoundedBezelStyle.spacing image $toolbar_images(blank) -sticky nswe  -padding {4 0 4 0}
    ttk::style map TextPopup.TexturedRoundedBezelStyle.TButton -foreground [list pressed black background black]
    ttk::style layout TextPopup.TexturedRoundedBezelStyle.TButton "OSXBackground TexturedRoundedBezelStyle.TButton.backbutton -sticky nswe TexturedRoundedBezelStyle.spacing -children {TextPopup.TexturedRoundedBezelStyle.TButton.text -side left -sticky {} TextPopup.TexturedRoundedBezelStyle.TButton.PopupArrows -side right -sticky w} -sticky {}"

  #popdown icon button
    ttk::style configure IconPopdown.TexturedRoundedBezelStyle.TButton -relief flat -anchor center
    ttk::style element create IconPopdown.TexturedRoundedBezelStyle.TButton.popdownarrow image [list $toolbar_images(popdown.arrow.regular) disabled $toolbar_images(popdown.arrow.regular) pressed $toolbar_images(popdown.arrow.regular) active $toolbar_images(popdown.arrow.regular) background $toolbar_images(popdown.arrow.regular)] -sticky w
    ttk::style layout IconPopdown.TexturedRoundedBezelStyle.TButton "OSXBackground TexturedRoundedBezelStyle.TButton.backbutton -sticky nswe  TexturedRoundedBezelStyle.spacing -children {Button.image -side left -sticky {} IconPopdown.TexturedRoundedBezelStyle.TButton.popdownarrow -side left -sticky w} -sticky {}"

  #basic checkbutton functionality
    ttk::style configure TexturedRoundedBezelStyle.TCheckbutton -relief flat -anchor center
    ttk::style element create TexturedRoundedBezelStyle.TCheckbutton.backbutton image [list $toolbar_images(active.regular) disabled $toolbar_images(active.regular) {pressed !selected} $toolbar_images(active.pressed.regular)  {pressed selected} $toolbar_images(active.on.pressed.regular) {active selected} $toolbar_images(active.on.regular) {active !selected} $toolbar_images(active.regular) {background selected} $toolbar_images(inactive.on.regular) background $toolbar_images(inactive.regular) selected $toolbar_images(active.on.regular)] -border [list 5 5 5 5] -sticky nsew
    ttk::style layout TexturedRoundedBezelStyle.TCheckbutton "OSXBackground TexturedRoundedBezelStyle.TCheckbutton.backbutton -sticky nswe Button.image -sticky {}"


    #icon disclosure button
    ttk::style configure IconDisclosure.TexturedRoundedBezelStyle.TCheckbutton -relief flat -anchor center
    ttk::style element create IconDisclosure.TexturedRoundedBezelStyle.TCheckbutton.arrow image [list $toolbar_images(disclosuretriangle.close) {pressed !selected} $toolbar_images(disclosuretriangle.close.pressed)  {pressed selected} $toolbar_images(disclosuretriangle.open.pressed)  selected $toolbar_images(disclosuretriangle.open)] -border [list 0 0 0 0] -sticky {}
    ttk::style layout IconDisclosure.TexturedRoundedBezelStyle.TCheckbutton "OSXBackground TexturedRoundedBezelStyle.TButton.backbutton -sticky nswe TexturedRoundedBezelStyle.spacing -sticky nswe -children {IconDisclosure.TexturedRoundedBezelStyle.TCheckbutton.arrow -side left -sticky w Button.image -side left -sticky w}"

    #radio buttons - requires flat ended button pattern
    ttk::style configure TexturedRoundedBezelStyle.TRadiobutton -relief flat -anchor center

    #shaded toolbar with configurable icon buttons
    unset -nocomplain j
    set toolbar_images(tool_back) [image create photo -height 30 -width 24]
    for {set i 75} {$i >60} {incr i -1} {
      lappend j [list gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i] [list gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i]
    }
    $toolbar_images(tool_back) put $j
    unset  -nocomplain j
    set toolbar_images(tool_back_inactive) [image create photo -height 30 -width 24]
    for {set i 91} {$i >76} {incr i -1} {
      lappend j [list gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i] [list gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i]
    }
    $toolbar_images(tool_back_inactive) put $j
    ttk::style element create toolbarbackground image [list $toolbar_images(tool_back) background $toolbar_images(tool_back_inactive)] -border {1 9 1 20} -padding {0} -sticky news
    ttk::style layout Toolbarframe {toolbarbackground}
    #toplevel .t
    #grid [ttk::frame .t.tool -style Toolbarframe -width 30 -height 30] -row 0 -column -0 -sticky nwe
    #grid columnconfigure .t 0 -weight 1

    #toolbar buttons
    ttk::style layout Toolstyle.TButton "toolbarbackground  -sticky nswe  -children { bback.button Button.image -sticky n Button.text -side bottom -sticky n}"
    #ttk::style layout Toolstyle.TButton "toolbarbackground  -sticky nswe  -children { bback.button Button.image -sticky {}}"
    #ttk::style layout Toolstyle.TButton "toolbarbackground  -sticky nswe  -children {Button.text -sticky {}}"
    ttk::style configure Toolstyle.TButton -font {"Lucida Grande" 11} -foreground gray25
    ttk::style map Toolstyle.TButton -foreground [list pressed black]
    #grid [ttk::button .t.tool.b1 -style Toolstyle.TButton -text Align -image $toolbar_images(align)] -row 1 -column 1


    #rounded groupbox (bg color =gray88)
    unset  -nocomplain j
    set toolbar_images(round_back) [image create photo -height 30 -width 24]
    set k 70; set i 70
    lappend j [list gray99 gray99 gray$k gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$k gray99 gray99];#
    set i 75
    lappend j [list gray99 gray$k gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$k gray99];#
    set i 85
    lappend j [list gray$k gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$k];#
    set i 88
    for {set t 0} {$t < 24} {incr t} {
      lappend j [list gray$k gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$k];#
    }
    lappend j [list gray99 gray$k gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$k gray99];#
    set i 75
    lappend j [list gray99 gray99 gray$k gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$i gray$k gray99 gray99];#
    $toolbar_images(round_back) put $j
    for {set x 0} {$x < 24} {incr x} {
      for {set y 0} {$y < 30} {incr y} {
        if {[$toolbar_images(round_back) get $x $y] == {252 252 252}} {$toolbar_images(round_back) transparency set $x $y 1}
      }
    }

    ttk::style element create roundframe2 image [list $toolbar_images(groupbox.active.primary)] -border {6 6 6 6} -sticky news
    ttk::style layout Roundframe {OSXBackground roundframe2}
    ttk::style element create roundframe3 image [list $toolbar_images(round_back)] -border {3 3 3 3} -sticky news
    ttk::style layout Roundframe {OSXBackground roundframe3}


    #textbox dropshadow
    ttk::style element create textbg image [list $toolbar_images(textfield.active.outline.regular)] -border {3 4 3 4} -padding {0} -sticky news
    image create photo image_white -width 16 -height 16
    image_white put white -to 0 0 16 16
    ttk::style element create WtBackground image image_white -border {0 0 0 0} -padding {0} -sticky news
    ttk::style layout Textbgframe {WtBackground -sticky nswe textbg -sticky nswe}
  }
}

##############
## make the images for unmapped buttons blank, image for the last mapped image an arrow and put the unmapped in a dropdown menu
##############
proc toolbar_extend {w} {
  global toolbar_images
  set mapped [list]
  set unmapped [list]
  foreach button [pack slaves $w.toolbar] {
    if {![regexp separator $button]} {
      if {(![winfo ismapped $button]) || ([winfo width $button] < 16)} {
        lappend unmapped $button
      } else {
        lappend mapped $button
      }
    }
  }

  #  sputs textend [lindex $mapped end]


  if {($unmapped != [list]) && ($mapped != [list])} {
$w.toolbar.more_arrow.menu delete 0 end
    foreach button [concat [lindex $mapped end] $unmapped] {
      foreach {tooltip c1 c2} [bind $button <<More_Menu>>] {
        if {[regexp "(.*)\n[mc Shift:](.*)" $tooltip none tooltip1 tooltip2]} {
          $w.toolbar.more_arrow.menu add command -label $tooltip1 -command $c1
          $w.toolbar.more_arrow.menu add command -label $tooltip2 -command $c2
        } else {
          $w.toolbar.more_arrow.menu add command -label $tooltip -command $c1
        }
      }
    }
    place $w.toolbar.more_arrow -relx 1.0 -rely 0 -anchor ne
    $w.toolbar.more_arrow configure -width [expr {[winfo width $w.toolbar] - [winfo x [lindex $mapped end]] -3}]
  } else {
    place forget $w.toolbar.more_arrow
  }
}



##############
## add buttons to the toolbar
##############
## toolbar list is a list of lists, each button element is a list of image name, tooltip, command
proc fill_toolbar w {
  global tcl_platform
  global toolbarlist
  global toolbar_images
  global info

  if {$toolbarlist == [list]} {
    $w.toolbar configure -height 1
    return
  }

  #set up the binding to make the button images change if the toolbar is shorter than can hold all of the buttons
  bind $w.toolbar <Configure> "toolbar_extend $w"

  if {[tk windowingsystem] == "aqua"} {
    set but_size 28
    set but_bd 1
    set over_relief solid
    set press_relief solid
    set normal_relief flat
    set over_color $info(aqua_active_bg_color); #$info(bg_color)
    set press_color [gray_color $info(bg_color)]
    set normal_color $info(aqua_active_bg_color);#$info(bg_color)
    #set normal_color gray70
    set inactive_color $info(bg_color)
    set separator_width 6
    set padx 0
    set pady 0
  } elseif {$tcl_platform(os) == "Windows NT"} {
    set but_size 20
    set but_bd 1
    set over_relief solid
    set press_relief solid
    set normal_relief flat
    set over_color $info(menu_bg_color)
    set press_color $info(menu_select_bg_color)
    set normal_color $info(bg_color)
    set inactive_color $normal_color
    set separator_width 6
    set padx 2
    set pady 2
  } else {
    set but_size 16
    set but_bd 2
    set over_relief raised
    set press_relief sunken
    set normal_relief flat
    set over_color $info(bg_color)
    set press_color $info(bg_color)
    set normal_color $info(bg_color)
    set separator_width 3
    set padx 0
    set pady 0
  }

  if {[$toolbar_images(new) cget -height] > $but_size} {
    set but_size [$toolbar_images(new) cget -height]
  }

  if {[tk windowingsystem] == "aqua"} {
    $w.toolbar configure -bg $normal_color
    bind $w.toolbar <Deactivate> "$w.toolbar configure -bg $inactive_color"
    bind $w.toolbar <Activate> "$w.toolbar configure -bg $normal_color"
    bind $w.toolbar <Button-1> "set movewinx \[expr {\[winfo x $w\] -%X}\]; set movewiny \[expr {\[winfo y $w\]- %Y}\]"
    bind $w.toolbar <ButtonRelease-1> "unset movewinx movewiny"
    bind $w.toolbar <Button1-Motion> "if {\[info exists movewinx\]} {wm geometry $w +\[expr {\$movewinx +%X}\]+\[expr {max (22,\$movewiny +%Y)}\]}"
  } else {
    $w.toolbar configure -bg $normal_color
  }

  set i 0
  if {[tk windowingsystem] != "aqua"} {
    set secbut 3
  } else {
    set secbut 2
  }
  foreach button [concat $toolbarlist more_arrow] {
    set command2 ""
    switch $button {
      separator {set button_type separator}
      new {set button_type button; set tooltip "[mc {New File}] \n[mc Shift:][mc {Duplicate Selection}] "; set command "create_window"; set command2 "duplicate_window $w selection"}
      open {set button_type button; set tooltip [mc "Open File"]; set command "open_file_dialog"}
      duplicate {set button_type button; set tooltip "[mc "Duplicate Selection"]\n[mc "Duplicate All"]"; set command "duplicate_window $w selection"; set command2 "duplicate_window $w all"}
      save {set button_type button; set tooltip "[mc {Save File}] \n[mc Shift:][mc {Save As}] "; set command "save_file $w Save"; set command2 "save_file $w Save_as"}
      cut {set button_type button; set tooltip "[mc {Cut to Clipboard}] \n[mc Shift:][mc {Cut Rev-Com}]"; set command "clip_cut_copy $w cut"; set command2 "clip_cut_copy $w cut rev-com"}
      copy {set button_type button; set tooltip "[mc {Copy to Clipboard}] \n[mc Shift:][mc {Copy Rev-Com}]"; set command "clip_cut_copy $w copy"; set command2 "clip_cut_copy $w copy rev-com"}
      paste {set button_type button; set tooltip "[mc {Paste from Clipboard}] \n[mc Shift:][mc {Paste Rev-Com}]"; set command "clip_paste $w"; set command2 "clip_paste $w rev-com"}
      cut_rc {set button_type button; set tooltip [mc "Cut(RC) to Clipboard"]; set command "clip_cut_copy $w cut rev-com"}
      copy_rc {set button_type button; set tooltip [mc "Copy(RC) to Clipboard"]; set command "clip_cut_copy $w copy rev-com"}
      paste_rc {set button_type button; set tooltip [mc "Paste(RC) from Clipboard"]; set command "clip_paste $w rev-com"}
      select {set button_type button; set tooltip "[mc {Select From-To}] \n[mc Shift:][mc {Jump to}]"; set command "select_from_to $w"; set command2 "jump_to $w"}
      jump {set button_type button; set tooltip [mc "Jump To"]; set command "jump_to $w"}
      find {set button_type button; set tooltip "[mc {Find...}] \n[mc Shift:][mc {Clear Find Highlighting}]"; set command "find_dialog $w"; set command2 "$w.textarea tag delete foundf; $w.textarea tag delete foundr"}
      find_again {set button_type button; set tooltip [mc "Find Again"]; set command "do_find $w again"}
      clear_find {set button_type button; set tooltip [mc "Remove Find Highlighting"]; set command "$w.textarea tag delete foundf; $w.textarea tag delete foundr"}
      uppercase {set button_type button; set tooltip "[mc {Change to Uppercase}] \n[mc Shift:][mc {UPPER<->lower Exchange}]"; set command "change_case $w upper"; set command2 "change_case $w exchange"}
      lowercase {set button_type button; set tooltip "[mc "Change to Lowercase"] \n[mc Shift:][mc {UPPER<->lower Exchange}]"; set command "change_case $w lower"; set command2 "change_case $w exchange"}
      swap_case {set button_type button; set tooltip [mc "UPPER<->lower Exchange"]; set command "change_case $w exchange"}
      reverse_com {set button_type button; set tooltip [mc "Reverse Complement"]; set command "rev_com_window $w"}
      origin {set button_type button; set tooltip [mc "Set Origin"]; set command "set_origin $w"}
      enzymes {set button_type button; set tooltip "[mc {Enzyme Selection Dialog}]\n[mc Shift:][mc {Toggle Selected Only}]"; set command "enzyme_selection_dialog $w"; set command2 "if {\$info(analyze_selection)== \"all\"} {set info(analyze_selection) selection} else {set info(analyze_selection) all}"}
      graphic_map {set button_type button; set tooltip "[mc {Graphic Map}] \n[mc Shift:][mc {+Unique}]"; set command "enz_graphic_map $w"; set command2 "enz_graphic_map $w {==1}"}
      graphic_map_u {set button_type button; set tooltip [mc "Graphic Map +Unique Enzymes"]; set command "enz_graphic_map $w {==1}"}
      highlight_enzymes {set button_type button; set tooltip "[mc {Highlight Selected Enzymes}] \n[mc Shift:][mc {Clear Highlight}]"; set command "highlight_enzymes $w \$info(enz_currently_selected)"; set command2 "foreach enzyme \$enzymes {$w.textarea tag delete \$enzyme}"}
      clear_highlighting {set button_type button; set tooltip [mc "Clear Enzyme Highlighting"]; set command "foreach enzyme \$enzymes {$w.textarea tag delete \$enzyme}"}
      digest {set button_type button; set tooltip [mc "Digestion Window"]; set command "enz_digest $w \$info(enz_currently_selected) \$info(analyze_selection)"; set command2 "enz_digest_partial_dialog $w"}
      text_map {set button_type button; set tooltip [mc "Text Map"]; set command "enz_text_map $w"}
      find_primers {set button_type button; set tooltip [mc "Find Primers"]; set command "primer_window $w"}
      align {set button_type button; set tooltip "[mc {Align Sequences}] \n[mc Shift:][mc {Align Two Sequences}]"; set command "align_dialog2 $w"; set command2 "align_dialog $w"}
      more_arrow {set button_type menu; set tooltip "more tools"; set command "";}
      temp {set tooltip ""; set command ""}
      default {set button_type button; set tootip "Unknown button type $button"; set command ""}
    }
    switch $button_type {
      button {
        #pack [button "$w.toolbar.$button" -image $toolbar_images($button) -relief flat -highlightthickness 0 -width 16 -height 16 -command $command] -side left -padx 0
        pack [label "$w.toolbar.$button" -image $toolbar_images($button) -bg $normal_color -relief $normal_relief -highlightthickness 0 -bd $but_bd -width $but_size -height $but_size] -side left -padx $padx -pady $pady
        bind "$w.toolbar.$button" <<More_Menu>> [list $tooltip $command $command2]
        bind "$w.toolbar.$button" <B1-Enter> "$w.toolbar.$button configure -bg $press_color -relief $press_relief"
        bind "$w.toolbar.$button" <Enter> "$w.toolbar.$button configure -bg $over_color -relief $over_relief; tooltip_enter $w.toolbar.$button \{$tooltip\}"
        bind "$w.toolbar.$button" <Leave> "$w.toolbar.$button configure -bg \[$w.toolbar cget -bg\] -relief $normal_relief; tooltip_leave $w.toolbar.$button"
        bind "$w.toolbar.$button" <Button-1> "$w.toolbar.$button configure -bg $press_color -relief $press_relief"
        bind "$w.toolbar.$button" <ButtonRelease-1> "if \{\[$w.toolbar.$button cget -relief\] == \"$press_relief\"\} \{$w.toolbar.$button configure -bg $over_color -relief $over_relief; $command\}"
        if {[tk windowingsystem] == "aqua"} {
          bind "$w.toolbar.$button" <Activate> "$w.toolbar.$button configure -bg $normal_color"
          bind "$w.toolbar.$button" <Deactivate> "$w.toolbar.$button configure -bg $inactive_color"
        }
        if {$command2 != ""} {
          bind "$w.toolbar.$button" <Shift-ButtonRelease-1> "if \{\[$w.toolbar.$button cget -relief\] == \"$press_relief\"\} \{$command2\}; $w.toolbar.$button configure -bg $over_color -relief $over_relief"
          bind "$w.toolbar.$button" <B$secbut-Enter> "$w.toolbar.$button configure -bg $press_color -relief $press_relief"
          bind "$w.toolbar.$button" <Button-$secbut> "$w.toolbar.$button configure -bg $press_color -relief $press_relief"
          bind "$w.toolbar.$button" <ButtonRelease-$secbut> "if \{\[$w.toolbar.$button cget -relief\] == \"$press_relief\"\} \{$w.toolbar.$button configure -bg $over_color -relief $over_relief; $command2\}"
          if {[tk windowingsystem] == "aqua"} {
            bind "$w.toolbar.$button" <Control-B1-Enter> "event generate %W <Control-B2-Enter> -rootx %X -rooty %Y -x %x -y %y"
            bind "$w.toolbar.$button" <Control-Button-1> "event generate %W <Control-Button-2> -rootx %X -rooty %Y -x %x -y %y"
            bind "$w.toolbar.$button" <Control-ButtonRelease-1> "event generate %W <ButtonRelease-2> -rootx %X -rooty %Y -x %x -y %y"
          }
        }

        bindtags "$w.toolbar.$button" "$w.toolbar.$button"
      }
      separator {
        pack [label "$w.toolbar.separator$i" -image $toolbar_images(separator)  -bg $normal_color -relief flat -border 0 -width $separator_width -height $but_size] -side left -padx 0
        if {[tk windowingsystem] == "aqua"} {
          bind "$w.toolbar.separator$i" <Activate> "$w.toolbar.separator$i configure -bg $normal_color"
          bind "$w.toolbar.separator$i" <Deactivate> "$w.toolbar.separator$i configure -bg $inactive_color"
        }
        incr i
      }
      menu {
        pack [label "$w.toolbar.$button" -image $toolbar_images($button) -bg $normal_color -relief $normal_relief -highlightthickness 0 -bd $but_bd -width $but_size -height $but_size] -side left -padx $padx -pady $pady
        menu $w.toolbar.$button.menu
        bind "$w.toolbar.$button" <B1-Enter> "$w.toolbar.$button configure -bg $press_color -relief $press_relief"
        bind "$w.toolbar.$button" <Enter> "$w.toolbar.$button configure -bg $over_color -relief $over_relief; tooltip_enter $w.toolbar.$button \{$tooltip\}"
        bind "$w.toolbar.$button" <Leave> "$w.toolbar.$button configure -bg $normal_color -relief $normal_relief; tooltip_leave $w.toolbar.$button"
        bind "$w.toolbar.$button" <Button-1> "$w.toolbar.$button configure -bg $press_color -relief $press_relief; tooltip_leave $w.toolbar.$button; tk_popup $w.toolbar.$button.menu %X %Y"
        bind "$w.toolbar.$button" <ButtonRelease-1> "if \{\[$w.toolbar.$button cget -relief\] == \"$press_relief\"\} \{$w.toolbar.$button configure -bg $over_color -relief $over_relief; $command\}"
        if {[tk windowingsystem] == "aqua"} {
          bind "$w.toolbar.$button" <Activate> "$w.toolbar.$button configure -bg $normal_color"
          bind "$w.toolbar.$button" <Deactivate> "$w.toolbar.$button configure -bg $inactive_color"
        }
        bindtags "$w.toolbar.$button" "$w.toolbar.$button"
      }
    }
  }

  #pack [frame $w.toolbar.f -width 100 -height 2 -relief ridge -borderwidth 2 -pady 0] -side bottom -anchor w -fill x -pady 0 -ipady 0

  if {[winfo exists $w.toolbar.more_arrow]} {pack forget $w.toolbar.more_arrow}
  #prevents flicker on configuration of the toolbar (it resets to requested height briefly before collapsing back to size of buttons
  #I don't know where the extra 2 pixels come from
  $w.toolbar configure -height [expr {$but_size + 2}]
}

##############
## procedure called to display a tooltip
##############
proc tooltip_show {window tip {at_mouse 0} {font ""}} {
  global tooltip_after
  global tcl_platform

  #if {([tk windowingsystem] == "aqua")} {
  #  return
  #}
  if {![winfo exists $window] || ($tip eq "")} {return}
  set tooltip_after showing
  if {[winfo exists .tooltip]} {destroy .tooltip}
  toplevel .tooltip -borderwidth 1 -background black

  if {([tk windowingsystem] == "aqua")} {
    tk::unsupported::MacWindowStyle style .tooltip help {noActivates noUpdates}
  } else {
    wm overrideredirect .tooltip 1
  }
  if {$at_mouse} {
    wm geometry .tooltip "+[expr {[winfo pointerx $window]}]+[expr {[winfo pointery $window]}]"
  } else {
    wm geometry .tooltip "+[expr {[winfo rootx $window]+[winfo height $window]/2}]+[expr {[winfo rooty $window]+[winfo height $window]}]"
  }
  if {$font ne ""} {
    pack [label .tooltip.label1 -text $tip -background #ffffd8 -foreground black -border 0 -font $font] -padx 0 -pady 0 -ipadx 0 -ipady 0
  } else {
    pack [label .tooltip.label1 -text $tip -background #ffffd8 -foreground black -border 0] -padx 0 -pady 0 -ipadx 0 -ipady 0
  }
}

##############
## procedure called on leaving object with a tooltip
##############
proc tooltip_leave {window} {
  global tooltip_after


  if {[winfo exists .tooltip]} {destroy .tooltip}
  if {[string equal -length 5 $tooltip_after "after"] == 1} {
    after cancel $tooltip_after
  } else {
    set tooltip_after "showing_[after 300 {set tooltip_after "not_showing"}]"
  }  
}

##############
## procedure called on entering object with a tooltip
##############
proc tooltip_enter {window tip {at_mouse 0}  {font ""}} {
  global tooltip_after

  if {[winfo exists .tooltip]} {destroy .tooltip}

  if {[string equal -length 7 $tooltip_after "showing"] == 1} {
    tooltip_show $window $tip $at_mouse $font
    after cancel {set tooltip_after "not_showing"}
  } else {
    set tooltip_after [after 1200 [list tooltip_show $window $tip $at_mouse $font]]
  }
}

##############
## procedure called on entering object with a tooltip
##############
proc tooltip_install {w tip} {
  bind $w <Enter> "+; tooltip_enter %W \{$tip\}"
  bind $w <Leave> "+; tooltip_leave %W"
}




##############
## popup menu on sequence windows- add feature edit cascade if relevant
##############
proc sequence_window_popup {w popupmenu rootx rooty} {
  set tags [$w.textarea tag names @[expr {$rootx-[winfo rootx $w.textarea]}],[expr {$rooty-[winfo rooty $w.textarea]}]]
  set result [list]
  foreach text_tag $tags {
    if {([regexp {f[0-9]+#} $text_tag])} {
      lappend result $text_tag
    }
  }
  if {[winfo exists $popupmenu.edit_feature]} {
    if {$result != {}} {
      catch {[$popupmenu entryconfigure [mc "Edit Feature"] -state normal]} msg
      $popupmenu.edit_feature delete 0 end
      foreach feature $result {
        $popupmenu.edit_feature add command -label [lindex [$w.textarea tag bind $feature <<Metadata>>] 0] -command "rename_recolor_window_feature $w $w $feature"
      }
    } else {
      catch {[$popupmenu entryconfigure [mc "Edit Feature"] -state disabled]}
    }
  }

  if {[winfo exists $popupmenu.delete_feature]} {
    if {$result != {}} {
      catch {[$popupmenu entryconfigure [mc "Delete Feature"] -state normal]} msg
      $popupmenu.delete_feature delete 0 end
      foreach feature $result {
        $popupmenu.delete_feature add command -label [lindex [$w.textarea tag bind $feature <<Metadata>>] 0] -command "delete_feature $w $feature"
      }
    } else {
      catch {[$popupmenu entryconfigure [mc "Delete Feature"] -state disabled]}
    }
  }

  if {[winfo exists $popupmenu.hide_feature]} {
    if {$result != {}} {
      catch {[$popupmenu entryconfigure [mc "Hide Feature"] -state normal]} msg
      $popupmenu.hide_feature delete 0 end
      foreach feature $result {
        $popupmenu.hide_feature add command -label [lindex [$w.textarea tag bind $feature <<Metadata>>] 0] -command "$w.textarea tag configure $feature -background \"\""
      }
    } else {
      catch {[$popupmenu entryconfigure [mc "Hide Feature"] -state disabled]}
    }
  }

  tk_popup $popupmenu $rootx $rooty
}


##############
## generate a random pallette of N color values- all with same Saturation and Lightness, equally spaced Hue
##############
proc random_pallette {{widgetbase .t} {n 5}  {lperc 0} {shademin 0.3} {lwidth 0.4}} {
  global palettereslist
  for {set i 0} {$i<$n} {incr i} {
    catch {destroy $widgetbase.f$i}
    grid [frame $widgetbase.f$i -height 350 -width [expr {([winfo width .t]-20*$n)/$n}]] -row 0 -column $i -padx 10 -sticky nswe
  }
  while {[winfo exists $widgetbase.f$i]} {
    catch {destroy $widgetbase.f$i}
    incr i
  }
  set palettereslist [list]
  foreach {h s l u} [list [expr {rand()}] [expr {rand()*(1-$shademin)+$shademin}] [expr {rand()*$lwidth+(1-$lwidth)/2.0}] [expr {(rand()*(1.0/6-1/(5*$n))+(1.0/(5*$n)))*(rand()>0.5?1:-1)}]] {}
  for {set i 0} {$i<$n} {incr i} {
    if {[expr {rand()< ($lperc/100.0)}]} {
      set l2 [expr {(rand()+rand())/2.0}]
    } else {
      set l2 $l
    }
    $widgetbase.f$i configure -background [hsl2rgb $h $s $l2]
    set palettereslist [linsert $palettereslist end [hsl2rgb $h $s $l2]]
    set h [expr {($h+$u)}]
    set h [expr {($h> 1)?($h-1):$h}]
    set h [expr {($h< 0)?($h+1):$h}]
  }
  set palettereslist [lsort -command "random_num" $palettereslist]
  return $palettereslist
}

proc random_num {x y} {return [expr {(rand()>.5?-1:1)}]}
if {0} {
#proc initialize: set up the frames widgets, clear palettelist, set index to 0, showpallette
#proc showpallette: if index is out of range add new pallette to palettelist (in index == -1 add to beginning of list and set index to 0), fill in the frames based on the index into palettelist
# next button: incr index, showpallette
# prev button: icr index -1, showpallette
# initialize when number is changed, lightness variation, or base color is changed
# .t <Configure>: confiure width of frames
# copy: copy index of palettelist
# prefs: spacing, bg_color, randomize order
  toplevel .t
  wm title .t "Random Pallette Generator"
  grid [frame .t.labels] -row 1 -column 1 -sticky nwe
  grid rowconfigure .t.labels 1 -weight 1
  for {set i 0} {$i<10} {incr i} {
   grid columnconfigure .t.labels $i -weight 1
  }
  grid columnconfigure .t 1 -weight 1
  grid [frame .t.controls] -row 2 -column 1 -sticky nwe
  grid rowconfigure .t 1 -weight 1

  grid [frame .t.controls.colornumf] -row 0 -column 1 -sticky nwe
  grid [label .t.controls.colornumf.l0  -text "Number Of Colors" ] -row 0 -column 0 -sticky nw
  grid [ttk::scale .t.controls.colornumf.num  -orient horizontal -from 3 -to 10 -variable colornum -command "set colornum \[expr {int(\$colornum)}\];#"] -row 0 -column 1 -sticky nw
  set colornum 4
  grid [label .t.controls.colornumf.numl  -textvariable colornum ] -row 0 -column 2 -sticky nw
  grid [frame .t.controls.lpercf] -row 1 -column 1 -sticky nwe
  grid [label .t.controls.lpercf.l1  -text "Lightness Variation"] -row 0 -column 0 -sticky nw
  grid [ttk::scale .t.controls.lpercf.num  -orient horizontal -from 0 -to 100 -variable lpercent -command "set lpercent \[expr {int(\$lpercent)}\];#" -value 0] -row 0 -column 1 -sticky nw
  set lpercent 30
  grid [label .t.controls.lpercf.numl  -textvariable lpercent ] -row 0 -column 2 -sticky nw
  grid [button .t.controls.go -command "random_pallette .t.labels \$colornum \$lpercent" -text "Make Pallette"] -row 4 -column 1 -sticky nw
  grid [button .t.controls.copy -command "clipboard clear; clipboard append \$palettereslist" -text "Copy Pallette"] -row 5 -column 1 -sticky nw
  set palettereslist ""
}
#http://serennu.com/colour/rgbtohsl.php
##############
## RGB in 3 number values to HSL list
##############
proc rgb2hsv {var_r var_g var_b} {
  set var_min [expr {min($var_r,$var_g,$var_b)}]
  set var_max [expr {max($var_r,$var_g,$var_b)}]
  set del_max [expr {$var_max - $var_min}]

  set l [expr { 1.0* ($var_max + $var_min) / 2.0}]

  if {($del_max == 0)} {
    set h  0
    set s  0
  } else {
    if {($l < 0.5)} {
      set s [expr {1.0 * del_max / ($var_max + $var_min)}]
    } else {
      set s [expr {1.0 * $del_max / (2 - $var_max - $var_min)}]
    }

    set del_r [expr {1.0* ((($var_max - $var_r) / 6.0) + ($del_max / 2)) / $del_max}]
    set del_g [expr {1.0* ((($var_max - $var_g) / 6.0) + ($del_max / 2)) / $del_max}]
    set del_b [expr {1.0* ((($var_max - $var_b) / 6.0) + ($del_max / 2)) / $del_max}]

    if {$var_r == $var_max} {
      set h [expr {$del_b - $del_g}]
    } elseif {$var_g == $var_max} {
      set h [expr {(1.0 / 3) + $del_r - $del_b}]
    } elseif {$var_b == $var_max}  {
      set h [expr { (2.0 / 3) + $del_g - $del_r}]
    }

    if {$h < 0}  {
       set h [expr {$h +1}]
    }
    if {$h > 1}  {
       set h [expr {$h -1}]
    }
  }
  return [list $h $s $l]
}

##############
## HSL color list to RGB # formatted
##############
proc hsl2rgb {h2 s l} {
  if {$s == 0} {
    set r  [expr {$l * 255}]
    set g  [expr {$l * 255}]
    set b  [expr {$l * 255}]
  } else {
    if {$l < 0.5}  {
      set var_2 [expr {$l * (1 + $s)}]
    }  else {
      set var_2 [expr {($l + $s) - ($s * $l)}]
    }
    set var_1  [expr {2 * $l - $var_2}]
    set r [expr {int(255 * [hue_2_rgb $var_1 $var_2 [expr {$h2 + (1.0 / 3)}]])}]
    set g [expr {int(255 * [hue_2_rgb $var_1 $var_2 $h2])}]
    set b [expr {int(255 * [hue_2_rgb $var_1 $var_2 [expr {$h2 - (1.0 / 3)}] ])}]
  }
  return [format "\#%02X%02X%02X" $r $g $b]
}

##############
## hue in 0-1 number to RGB
##############
proc hue_2_rgb {v1 v2 vh} {
  if {$vh < 0} {
     set vh [expr {$vh +1}]
  }
  if {$vh > 1} {
    set vh [expr {$vh -1}]
  }
  if {(6 * $vh) < 1} {
    return [expr {$v1 + ($v2 - $v1) * 6.0 * $vh}]
  }
  if {(2 * $vh) < 1} {
    return $v2
  }
  if {(3 * $vh) < 2} {
    return [expr {$v1 + ($v2 - $v1) * ((2.0 / 3 - $vh) * 6)}]
  }
  return $v1
}

##############
## save an RTF format of a text window
##############
##need to set underline and bold
proc text_to_rtf {textarea {keep_breaks 0}} {
  global info
  set tagdepth 0
  set colortable "colortbl;"
  set text ""
  set i 1
  set last_ix 1.0
  foreach {a b c} [lrange [$textarea dump -tag 1.0 end] 0 end-3] {d e f} [lrange [$textarea dump -tag 1.0 end] 3 end] {
    if {($c != $f) && ([llength [set taglist [lsearch -inline -regexp -all -not [$textarea tag names $c] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|ls[0-9]+_[0-9]+|dnatag}]]] > $tagdepth)} {
      set color [get_tag_color $textarea [lindex $taglist end]]
      if {$color eq ""} {continue}
      foreach {r g b} [winfo rgb . $color] {}
      ##sputs $taglist $c $f "\\red[expr {$r>>8}]\\green[expr {$g>>8}]\\blue[expr {$b>>8}]" $r $g $b $color
      append colortable "\\red[expr {$r>>8}]\\green[expr {$g>>8}]\\blue[expr {$b>>8}];"
      if {$c != $last_ix} {
        append text "{[$textarea get $last_ix $c]}"
      }
      append text "{\\chshdng0\\chcbpat$i\\cb$i [$textarea get $c $f]}"
      incr i
      set last_ix $f
    }
  }
  if {[$textarea compare end > $last_ix]} {
    append text "{[$textarea get $last_ix end]}"
  }
  sputs lastix $last_ix
  if {$keep_breaks} {
    regsub -all \n $text "\\par" text
  }
  return "{\\rtf1\\ansi{\\fonttbl\\f0\\fmodern Courier;}{\\$colortable}\\f0\\pard
$text\\par}"
}

##############
## save an HTML format of a text window
##############
##need to set underline and bold
proc seq_to_html {textarea {keep_breaks 0}} {
  global info
  set tagdepth 0
  set text ""
  set last_ix 1.0
  foreach {a b c} [lrange [$textarea dump -tag 1.0 end] 0 end-3] {d e f} [lrange [$textarea dump -tag 1.0 end] 3 end] {
    if {($c != $f) && ([llength [set taglist [lsearch -inline -regexp -all -not [$textarea tag names $c] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|ls[0-9]+_[0-9]+|dnatag}]]] > $tagdepth)} {
      set color [get_tag_color $textarea [lindex $taglist end]]
      set color [string toupper [color_to_svgrgb $color]]
      if {$color eq ""} {continue}
      if {$c != $last_ix} {
        set temp_text "[$textarea get $last_ix $c]"
        regsub -all " " $temp_text "\\&nbsp;" temp_text
        append text $temp_text
      }
      set temp_text [$textarea get $c $f]
      regsub -all " " $temp_text "\\&nbsp;" temp_text
      append text "<span style=\"background-color:$color;\">$temp_text</span>"
      set last_ix $f
    }
  }
  if {[$textarea compare end > $last_ix]} {
    set temp_text "[$textarea get $last_ix end]"
    regsub -all " " $temp_text "\\&nbsp;" temp_text
    append text $temp_text
  }
  set text "<span style=\"font-family:courier\">$text</span>"
  if {$keep_breaks} {
    regsub -all \n $text "<br>\n" text
    set text "<html>\n<body>\n$text\n</html>\n</body>"
  } else {
    regsub -all \n $text "" text
    set text "<html>\n<body>\n<div style=\"word-wrap:break-word;\">\n$text\n</div>\n</html>\n</body>"
  }

  set filename [tk_getSaveFile]
  set fid [open $filename w]
  puts $fid $text
  close $fid
}

##############
## sequence window to svg (should work for any non-wrapping text area)
##############
proc seq_to_svg {t startline endline} {
 set bg_formatted_tags [list]
  foreach tag [$t tag names] {
    if {([$t tag cget $tag -background] != "") && ($tag ne "sel")} {
      lappend bg_formatted_tags $tag
    }
  }
  #set io [$t index @0,0]
  #set char_x [$t count -xpixels $io $io+1char]
  #set char_y [$t count -ypixels $io $io+1line]
  set text_font [$t cget -font]
  set char_x [font measure $text_font A]
  set char_y [font metrics $text_font -linespace]
  set linewidth [$t cget -width]

  set c [canvas .c]
  foreach tag $bg_formatted_tags {
    set color [$t tag cget $tag -background]
    foreach {row1 col1 row2 col2} [split [$t tag ranges $tag] ". "] {
      for {set i $row1} {$i < $row2} {incr i} {
        if {($i < $startline)} {set col1 0; continue}
        if {($i > $endline)} break
        $c create rectangle [expr {$col1*$char_x}] [expr {($i-$startline)*$char_y}] [expr {($linewidth*$char_x)}] [expr {($i-$startline+1)*$char_y}] -fill $color -outline $color
        set col1 0
      }
      if {($i >= $startline) && ($i<= $endline)} {
        $c create rectangle [expr {$col1*$char_x}] [expr {($i-$startline)*$char_y}] [expr {($col2*$char_x)}] [expr {($i-$startline+1)*$char_y}] -fill $color -outline $color
      }
    } 
  }
  for {set i $startline} {$i <= $endline} {incr i} {
    for {set j 0} {$j< $linewidth} {incr j} {
      $c create text [expr {$j*$char_x}] [expr {($i-$startline)*$char_y-3}] -text [$t get $i.$j] -anchor nw -font $text_font
    }
  }
  set result [canvas_to_svg $c]
  destroy $c
  return $result
}

if {0} {
##test
  set t $w.textarea
  set filename [tk_getSaveFile -defaultextension ".svg" -title [mc "Save Seq Image"]  -parent [winfo toplevel $t]]
  set file [open $filename w]
  puts $file [seq_to_svg $t 1 40]
  close $file
}

##############
## add trans tags to a sequence textarea
##############
proc make_transparent {w} {
  global info
  set tagdepth [expr {$info(sequence_transparency_mode) == "overlap"?1:0}]
  foreach tag [lsearch -inline -all -regexp [$w.textarea tag names] {trans[0-9]+#}] {
    $w.textarea tag remove $tag 1.0 end
  }
  set i 0
  set toptags [list]
  foreach {a b c} [lrange [$w.textarea dump -tag 1.0 end] 0 end-3] {d e f} [lrange [$w.textarea dump -tag 1.0 end] 3 end] {
    if {($c != $f) && ([llength [set taglist [lsearch -inline -regexp -all -not [$w.textarea tag names $c] {trans[0-9]+#|fn[0-9]+#|tempsel|sel}]]] > $tagdepth)} {
      foreach tag [lrange $taglist 1 end] {
        dict set toptags $tag 1
      }
      $w.textarea tag add trans$i\# $c $f
      $w.textarea tag configure trans$i\# -background {}
      $w.textarea tag raise trans$i\#
      incr i
    }
  }
  bind $w.textarea <<Toptags>> [dict keys $toptags *]
}

##############
## get the color of a sequence textarea tag
##############
proc get_tag_color {textarea tag} {
  global enzymes info
        if {$tag == "foundf"} {
          ##found tags don't bind <<Metadata>>
          set color [lindex [$textarea tag bind $tag <<Revcolors>>] 0]
        } elseif {$tag == "foundr"} {
          set color [lindex [$textarea tag bind $tag <<Revcolors>>] 1]
        } elseif {[regexp {f[0-9]+#} $tag]} {
          #set color [lindex [$textarea tag bind $tag <<Revcolors>>] [lindex [$textarea tag bind $tag <<Metadata>>] 3]]
          set color [$textarea tag cget $tag -background]
        } elseif {[lsearch -exact $enzymes $tag] > -1} {
          set color $info(enzyme_highlight_color)
        } elseif {$tag == "sel"} {
          set color ""
        } else {
          set color [$textarea tag cget $tag -background]
          #sputs configure transparent unknown tag $tag
        }
}

##############
## calculate and set the transparency color values for each trans text tag
##############
proc configure_transparency {w t} {
  global info

  foreach {r0 g0 b0} [winfo rgb . [$w.textarea cget -background]] {}
  set t [expr {int($t)}]
  #set color of trans tags
  foreach t_tag [lsearch -inline -all -regexp [$w.textarea tag names] {trans[0-9]+#}] {
    if {[$w.textarea tag ranges $t_tag] != [list]} {
      set taglist [lsearch -inline -regexp -all -not [$w.textarea tag names $t_tag.first] {fn[0-9]+#|tempsel|sel|trans[0-9]+#}]
      if {$info(sequence_transparency_mode) == "all"} {
        set r $r0; set g $g0; set b $b0
        set start_index 0
      } elseif {$info(sequence_transparency_mode) == "overlap"} {
        set i 0
        while {($i < [llength $taglist]) && ([set color [get_tag_color $w.textarea [lindex $taglist $i]]] == "")} {
          incr i
        }
        if {$i == [llength $taglist]} continue
        foreach {r g b} [winfo rgb . $color] {}
        set start_index [incr i]
      }  elseif {$info(sequence_transparency_mode) == "overlap-all"}  {
        set toptags [bind $w.textarea <<Toptags>>]
        set r $r0; set g $g0; set b $b0
        set i 0
        while {($i < [llength $taglist]) && ([set color [get_tag_color $w.textarea [lindex $taglist $i]]] == "")} {
          incr i
        }
        if {$i == [llength $taglist]} continue
        if {[lsearch -exact $toptags [lindex $taglist $i]] == -1} {
          foreach {r g b} [winfo rgb . $color] {}
          set start_index [incr i]
        } else {
          set start_index $i
        }
      } else {
        return
      }
      foreach tag [lrange $taglist $start_index end] {
        set color [get_tag_color $w.textarea $tag]
        if {$color != ""} {
          foreach {r2 g2 b2} [winfo rgb .  $color] {
            set r [expr {$r * ($t /100.0) + $r2 * ((100-$t) /100.0)}]
            set g [expr {$g * ($t /100.0) + $g2 * ((100-$t) /100.0)}]
            set b [expr {$b * ($t /100.0) + $b2 * ((100-$t) /100.0)}]
          }
        }
      }
      $w.textarea tag configure $t_tag -background [format "\#%04X%04X%04X" [expr {int($r)}] [expr {int($g)}] [expr {int($b)}]]
    }
  }

  #set color of f tags
  #if {$info(sequence_transparency_mode) == "all"} {
  #  foreach tag [lsearch -inline -all -regexp [$w.textarea tag names] {f[0-9]+#|foundf}] {
  #    foreach {r g b} [winfo rgb . [lindex [$w.textarea tag bind $tag <<Revcolors>>] [lindex [$w.textarea tag bind $tag <<Metadata>>] 3]]] {
  #      set r [expr {$r0 * ($t /100.0) + $r * ((100-$t) /100.0)}]
  #      set g [expr {$g0 * ($t /100.0) + $g * ((100-$t) /100.0)}]
  #      set b [expr {$b0 * ($t /100.0) + $b * ((100-$t) /100.0)}]
  #    }
  #    $w.textarea tag configure $tag -background [format "\#%04X%04X%04X" [expr {int($r)}] [expr {int($g)}] [expr {int($b)}]]
  #  }
  #} 
}

##############
## for transparency button binding
##############
proc trans_enter {w} {
  global info
  if {$info(sequence_transparency) > 0} {
    make_transparent $w
    configure_transparency $w $info(sequence_transparency)
  } 
}


##############
## open a file
##############
#recognizes fasta, plain and strider files

proc open_file_dialog {{filename ""}} {
  global info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1
  while {![file isdirectory $info(default_dnadir)]} {
    set info(default_dnadir) [file dirname $info(default_dnadir)]
    if {[file dirname $info(default_dnadir)] == $info(default_dnadir)} {
      set info(default_dnadir) [valid_default_dir]
    }
  }
  if {$filename == ""} {
    set focus_win [focus]
    if {$focus_win == ""} {
      set focus_win .
      set filename [tk_getOpenFile -initialdir $info(default_dnadir) -title "open DNA file" -multiple 1]
    } else {
      set filename [tk_getOpenFile -initialdir $info(default_dnadir) -title "open DNA file" -parent $focus_win -multiple 1]
    }
    if {([winfo exists $focus_win]) && ($focus_win != ".")} {
      wm deiconify [winfo toplevel $focus_win]
      focus $focus_win
    }
    update
  } else {
    if {[tk windowingsystem] == "win32"} {
      regsub -all {\\} $filename {/} filename
    }
  }

  foreach file $filename {
    open_file $file
  }
  set dialogblock 0
}

##############
## open a file
##############
#recognizes fasta, plain and strider files
proc open_file {filename} {
  global info header
  if {$filename != ""} {
    if {[tk windowingsystem] == "win32"} {
      regsub -all {\\} $filename {/} filename
    }
    foreach win $info(dnawindows_list) {
      if {$info($win,filename) == $filename} {
        wm deiconify $win
        raise $win
        focus $win
        tk_messageBox -message [mc "The file is already being edited."] -type ok -icon info
        update
        return
      }
    }
    if {![catch {open $filename r} fileid err]} {
      #read in the 1st header line and determine filetype (storing info from the line)
      fconfigure $fileid -translation binary
      set striderheader [read $fileid 112]
      fconfigure $fileid -translation auto
      seek $fileid 0
      set a [gets $fileid]
      if {[eof $fileid] != 1} {
        set b [gets $fileid]
      } else {
        set b ""
      }
      seek $fileid 0
      set a [gets $fileid]
#sputs a:$a
      #if the string is long enough to be a strider file, extract the strider header info
        set strversion -1; set strtype -1
        binary scan $striderheader cccx14cx10IIx60I strversion strtype strtopology strmet strlength strminus strcomlength
        binary scan $striderheader I4x12Ix* gck_magnum gck_seq_len
        binary scan $striderheader H64Ix* macvec_magnum macvec_seq_len
#sputs  strversion $strversion  strtype $strtype  strtopology $strtopology  strmet $strmet  strlength $strlength strminus $strminus strcomlength $strcomlength
      #check for header types
      if {$striderheader == ""} {
        set filetype "empty"
      } elseif {[string index $a 0] == ">"} {
        set filetype "fasta"
        set filecomment [string range $a 1 end]
      } elseif {[string range $a 0 4] == "LOCUS"} {
         set filetype "genbank"
      } elseif {[string range $a 0 1] == "ID"} {
         set filetype "embl"
      } elseif {([string first "Created:" $a] > -1) && ($b == "^^")} {  
         set filetype "editseq"
      } elseif {($strversion == 0) && (($strtype == 1) || ($strtype == 2) || ($strtype == 3) || ($strtype == 4))} {
         set filetype "strider"
      } elseif {([string first "VERSION  pDRAW" $a] > -1)} {
         set filetype "pdraw"
      } elseif {($gck_magnum == {18 18 0 0}) || $gck_magnum == {19 19 0 0}} {
         set filetype "gck"
      } elseif {[regexp {0000000.01014} $macvec_magnum]} {
         set filetype "macvector"
      } elseif {([string length $a] > 10) && ([regexp -nocase {[^ACGTN*BDHKMRSVWY 0-9]} $a] == 0)} {
         set filetype "plain"
      } elseif {[string range $a 0 3] == "ABIF"} {
         set filetype "abi"
      } elseif {[string range $a 0 3] == ".scf"} {
         set filetype "scf"
      } elseif {$a eq "!!NA_SEQUENCE 1.0"} {
         set filetype "gcg"
      } elseif {[regexp {##gff-version\s+3} $a]} {
         set filetype "gff3"
      } else {
          set filetype "unknown"
          tk_messageBox -message [mc "The file is not a recognised fasta, plain, genbank, EMBL, editseq, gcg or strider file."] -type ok -icon warning -default ok
          if {(([lsearch [winfo children .] ".dna_window*"] != -1) || ([lsearch [winfo children .] ".abi_window*"] != -1))} {
            close $fileid
            set dialogblock 0
            return error
          } else {
sputs open_error 0
            set filetype "empty" 
          }
      }
#sputs filetype:$filetype
      #read in DNA and comment for each file type
      set genbank_features [list]
      set genbank_header_info [list]
      set linked_abi_list [list]

      switch $filetype {
        empty {
          set newdna ""
          set filecomment ""
          set startindex 1
          set circular "linear"
          set methylated $info(methylated_default)
          set new_tags [list]
          set new_title [mc "New DNA"]
          set filetype "None"
        }
        fasta {
          #sputs "fasta: $filename"
          set newdna ""
          set filecomment $a
          while {![eof $fileid]} {append newdna [gets $fileid]}
          if {[set gt [string first ">" $newdna]] > -1} {
            set newdna [string range $newdna 0 $gt]
          }
          set startindex 1
          set circular "linear"
          set methylated $info(methylated_default)
          set new_tags [list]
          set new_title [file tail $filename]
          set filetype "Fasta"
        }
        plain {
          #sputs "plain: $filename"
          set newdna $a
          while {[eof $fileid] != 1} {append newdna [gets $fileid]}
          set filecomment ""
          set startindex 1
          set circular "linear"
          set methylated $info(methylated_default)
          set new_tags [list]
          set new_title [file tail $filename]
          set filetype "Plain Text"
        }
        strider {
          #sputs "strider: $filename"
          seek $fileid 112
          set newdna [read $fileid $strlength]
          #regsub -all {\*} $newdna "N" newdna
          set filecomment [read $fileid $strcomlength]
          set startindex [expr {1+$strminus}]
          set circular [expr ($strtopology?"circular":"linear")]
          if {($strmet != 0) && ($strmet != 1)} {set strmet 0}
          set methylated $strmet
          set new_tags [list]
          set new_title [file tail $filename]
#sputs new_title $new_title
          if {$strtype == 3} {
            set newdna [string map {u t U T} $newdna]
          }
          if {$strtype == 4} {
            set filecomment ">$filecomment"
            append filecomment \n $newdna 
            set newdna [reverse_translate $newdna]
          }
          set filetype "DNA Strider"
        } 
        macvector {
          seek $fileid 36
          binary scan [read $fileid $macvec_seq_len] H* newdna
          set newdna [string map {01 A 02 C 03 M 04 G 05 R 06 S 07 V 08 T 09 W 0a Y 0b H 0c K 0d D 0e B 0f N} $newdna]
          set filecomment ""
          set startindex 1
          set circular "linear"
          set strmet 0
          set methylated $strmet
          set new_tags [list]
          set new_title [file tail $filename]
          set filetype "MacVector"
        }
        gck {
          #sputs "strider: $filename"
          seek $fileid 32
          set newdna [read $fileid $gck_seq_len]
          #regsub -all {\*} $newdna "N" newdna
          set filecomment ""
          set startindex 1
          set circular "linear"
          set strmet 0
          set methylated $strmet
          set new_tags [list]
          set new_title [file tail $filename]
          set filetype "GCK"
        }
        abi {
          #sputs "abi: $filename"
          close $fileid
          set error_status [open_abi $filename]
          if {($error_status == "ok") && $info(dnadir_follows_open)} {
            set info(default_dnadir) [file dirname $filename]
          }
          set dialogblock 0
          return ok
        }
        scf {
          #sputs "scf: $filename"
          close $fileid
          set error_status [open_abi $filename]
          if {($error_status == "ok") && $info(dnadir_follows_open)} {
            set info(default_dnadir) [file dirname $filename]
          }
          set dialogblock 0
          return ok
        }
        gcg {
          set filecomment ""
          while {([gets $fileid nextline] != -1) && ([string first ".." $nextline] == -1)} {
            append filecomment $nextline
          }

          set newdna ""
          while {([gets $fileid nextline] != -1)} {
            append newdna $nextline
       
          }
          regsub -all {[\n ]} $newdna "" newdna
          regsub -all {<.*?<} $newdna "" newdna
          regsub -all {>.*?>} $newdna "" newdna
          regsub -all {$.*?$} $newdna "" newdna
          set startindex 1
          set circular "linear"
          set methylated $info(methylated_default)
          set new_tags [list]
          set new_title [file tail $filename]
          set filetype "GCG"
        }
        pdraw {
          while {([gets $fileid nextline] != -1) && ([string first ".." $nextline] == -1)} {
            append fileheader $nextline\n
          }

          set newdna ""
          while {([gets $fileid nextline] != -1)} {
            append newdna $nextline
       
          }
          regsub -all {[[:space:]0-9\n]} $newdna "" newdna
          set startindex 1
          set filecomment ""
          if {[regexp -nocase {IScircular +YES} $fileheader]} {
            set circular "circular"
          } else {
            set circular "linear"
          }
          set methylated $info(methylated_default)
          set new_tags [list]
          set pdraw_features_list [list]
          foreach fline [regexp -all -inline {Element[[:space:]]+.{30}[-0-9]+[[:space:]]+[-0-9]+[[:space:]]+[0-9]+[[:space:]]+[-0-9]+[[:space:]]+\n} $fileheader] {
            if {[regexp {Element[[:space:]]+(.{30})([-0-9]+)[[:space:]]+([-0-9]+)[[:space:]]+([0-9]+)[[:space:]]+([-0-9]+)[[:space:]]+\n} $fline fline fname fstart fend ftype frev]} {
              lappend pdraw_features_list [list [string trimright $fname " "] $fstart $fend $ftype $frev]
            }
          }
          foreach fline [regexp -all -inline {Annotation_Name [^\n]*\nAnnotation_Start [-0-9]+\nAnnotation_End [-0-9]+\nAnnotation_Type [0-9]\nAnnotation_Orientation [-0-1]+} $fileheader] {
            if {[regexp {Annotation_Name ([^\n]*)\nAnnotation_Start ([-0-9]+)\nAnnotation_End ([-0-9]+)\nAnnotation_Type ([0-9])\nAnnotation_Orientation ([-0-1]+)} $fline fline fname fstart fend ftype frev]} {
              lappend pdraw_features_list [list [string trimright $fname " "] $fstart $fend $ftype $frev]
sputs pdwfh $fstart $fend $ftype $frev
            }
          }
          set new_tags [pdraw_features_to_taglist $pdraw_features_list]
          set new_title [file tail $filename]
          set filetype "pDraw"
#VERSION  pDRAW 1.0 v2/beta
#DNAname
#IScircular YES/NO
#v2 features
#Annotation_Number 	1
#Annotation_Name BSD
#Annotation_Start 4236
#Annotation_End 4631
#Annotation_Type 0 #0-3?
#Annotation_Orientation -1/0 (fwd/reverse)
#Annotation_ArrowLength 0
#Annotation_ArrowWidth 0
#Annotation_Custom False
#v beta features
#Element   CMV                           212       816       2    -1 (start end type orientation:0=rev:-1=fwd)
#HEADER comment lines
#Sequence ..

        }
        genbank {
          #sputs "genbank: $filename"
          set filecomment ""
          set methylated $info(methylated_default)

          if {![regexp {LOCUS       (.*) ([0-9]*) bp (   |ss-|ds-|ms-)(NA    |DNA   |RNA   |tRNA  |rRNA  |mRNA  |uRNA  |snRNA |snoRNA)[ ]*(linear  |circular|        )[ ]*([ A-Z]{3})[ ]*(..-...-....)} $a x name size stranded type circular div date] || $circular== "        "} {
            set circular "linear"
            set name "Untitled"
          }  
          regsub -all {[^a-zA-Z0-9]} $name _ name
          regsub -all {[[:space:]]} $circular "" circular     
          set header $a\n
          set newdna ""
          set dna_started 0
          while {([gets $fileid nextline] != -1) && ($nextline ne "//")} {
            if {!(([string range $nextline 0 5] eq "ORIGIN") || ([string range $nextline 0 9] eq "BASE COUNT"))} {
              if {$dna_started} {
                append newdna $nextline\n
              } else {
                append header $nextline\n
              }
            } elseif {[string range $nextline 0 5] eq "ORIGIN"} {
              set dna_started 1
            }
          }
          if {($newdna == "") && ($nextline ne "//")} {
            tk_messageBox -message "Can't parse genbank format" -icon error -type ok
          }
          #read in subsequent records
          set postscript ""
          while {([gets $fileid nextline] != -1)} {
            append postscript $nextline
          }
          if {[llength [set t [regexp -all -inline {LOCUS       linked_abi.*?//} $postscript]]] > 0} {
            set linked_abi_list [list]
            foreach e $t {
              lappend linked_abi_list [decode_abi $e]
            }
          }
          #interpret genbank header
          if {![regexp -indices {(.*)(FEATURES             Location/Qualifiers\n)} $header temp genbank_header_indices feature_indices]} {
            set genbank_header $header
            set feature_table ""
          } else {
            set genbank_header [string range $header 0 [lindex $genbank_header_indices 1]]
            set feature_table [string range $header [lindex $feature_indices 1] end]     
          }
          set genbank_header_info [list]
          set vnti 0
          #this parses header into fields
          foreach record [regexp -inline -all {(?:(?:[\ A-Z]{3}[A-Z][\ A-Z]{8}[^\n]*?\n)(?:\s{12}[^\n]*\n)+)|(?:[\ A-Z]{3}[A-Z][\ A-Z]{8}[^\n]*?\n)} $genbank_header] {
            regexp {(.{12})(.*)\n} $record junk type data
            if {$type == "COMMENT     "} {
              if {$vnti} continue
              if {[string first "This file is created by Vector NTI" $data] == 0} {
                set vnti 1
                continue
              }
              if {[regexp {ApEinfo:methylated:(1|0)} $data temp methylated]} {
                continue
              }
              regsub -all {([^\s]{67})\n\s{12}} $data {\1} data
              regsub -all {\n\s{12}} $data " " data
              if {[set ntistart [string first "This file is created by Vector NTI" $data]] >= 0} {
                set data [string range $data 0 [expr {$ntistart-1}]]
              }
              append filecomment "$data\n"
            } else {
              regsub -all {\n\s{12}} $data " " data
              lappend genbank_header_info $type $data
            }

          }
          regsub \n\n$ $filecomment ""  filecomment
          regsub -all {[[:space:]0-9\n]} $newdna "" newdna
          if {[regexp {[^abcdghkmnrstvwyABCDGHKMNRSTVWY*]} $newdna]} {
            tk_messageBox -message "Eror: bad dna sequence in genbank" -icon error -type ok
          }
          set new_tags [feature_table_to_taglist [split $feature_table \n] $circular [string length $newdna]]
          set startindex 1
          set new_title [file tail $filename]
          set filetype "Genbank"
        }
        genbank2 {
          #sputs "genbank: $filename"
          set filecomment ""
          set methylated $info(methylated_default)

          if {![regexp {LOCUS       (.*) ([0-9]*) bp (   |ss-|ds-|ms-)(NA    |DNA   |RNA   |tRNA  |rRNA  |mRNA  |uRNA  |snRNA |snoRNA)[ ]*(linear  |circular|        )[ ]*([ A-Z]{3})[ ]*(..-...-....)} $a x name size stranded type circular div date] || $circular== "        "} {
            set circular "linear"
          }  
          regsub -all {[^a-zA-Z0-9]} $name _ name
          regsub -all {[[:space:]]} $circular "" circular          
          set genbank_type_array(0) "LOCUS       "
          set genbank_data_array(0) [string range $a 12 end]
          set i 0
          set text ""
          while {([gets $fileid nextline] != -1) && ([string range $nextline 0 7] != "FEATURES") && ([string range $nextline 0 5] != "ORIGIN") && ([string range $nextline 0 9] != "BASE COUNT")} {
            set lastlen [string length $text]
            set text [string range $nextline 12 end]
            set type [string range $nextline 0 11]

            if {$type == "            "} {
              if {($lastlen + [string first " " "$text "]) > 66 } {
                append genbank_data_array($i) " " $text
              } else {
                append genbank_data_array($i) \n $text
              }
            } else {
              incr i
              set genbank_type_array($i) $type
              set genbank_data_array($i) $text
            }
          }
          set genbank_header_info [list]
          set vnti 0
          for {set j 0} {$j <= $i} {incr j} {
            if {$genbank_type_array($j) == "COMMENT     "} {
              if {[string first "This file is created by Vector NTI" $genbank_data_array($j)] == 0} {
                set vnti 1
              }
              if {$vnti} continue
              if {[regexp {ApEinfo:methylated:(1|0)} $genbank_data_array($j) temp methylated]} {
                unset temp
                continue
              }
              append filecomment $genbank_data_array($j)
            }
            lappend genbank_header_info $genbank_type_array($j) $genbank_data_array($j)
          }
          unset i j
          array unset genbank_type_array
          array unset genbank_data_array

          if {[string range $nextline 0 7] == "FEATURES"} {
            while {([gets $fileid nextline] != -1) && ([string range $nextline 0 5] != "ORIGIN")} {
              lappend genbank_features $nextline
            }
          } else {
            while {([gets $fileid nextline] != -1) && ([string range $nextline 0 5] != "ORIGIN")} {
              lappend genbank_features $nextline
            }
          }
          set newdna ""
          while {([gets $fileid nextline] != -1) && ($nextline != "//")} {
            set newdna "$newdna$nextline"
          }
#sputs $genbank_features
          regsub -all {[^abcdghkmnrstvwyABCDGHKMNRSTVWY*]} $newdna "" newdna

          set new_tags [feature_table_to_taglist $genbank_features $circular [string length $newdna]]
          
          set startindex 1

          set new_title [file tail $filename]
          set filetype "Genbank"
        }
        embl {
          #sputs "embl: $filename"
          if {([string match "*;*circular*;*" $a])} { 
            set circular "circular"
          } else {
            set circular "linear"
          }
          set filecomment $a
          while {([gets $fileid nextline] != -1) && ([regexp {([A-Z]{2})\ *(.*)} $nextline nextline type text])} {
            if {$type == "FT"} {
              lappend genbank_features "  [string range $nextline 2 end]"
            } elseif {$type == "SQ"} {
              break
            }  else {
              set filecomment "$filecomment\n$nextline" 
            }
          }
          set newdna ""
          while {([gets $fileid nextline] != -1) && ($nextline != "//")} {
            set newdna "$newdna$nextline"
          }
          regsub -all {[^abcdghkmnrstvwyABCDGHKMNRSTVWY*]} $newdna "" newdna
          set new_tags [feature_table_to_taglist $genbank_features $circular [string length $newdna]]
          set startindex 1
          set methylated $info(methylated_default)
          set new_title [file tail $filename]
          set filetype "EMBL"
        }
        editseq {
          #sputs "editseq: $filename"
          set newdna ""
          set filecomment $a
          gets $fileid
          while {[eof $fileid] != 1} {append newdna [gets $fileid]}
          if {[regexp -nocase {[^ACGTN*BDHKMRSVWY 0-9]} $newdna] == 0} {
            set startindex 1
            set circular "linear"
            set methylated $info(methylated_default)
            set new_tags [list]
            set new_title [file tail $filename]
            set filetype "Editseq"
          } else {
            close $fileid
            tk_messageBox -message [mc "This editseq file contains protein sequence. I can't open it. Sorry."] -title [mc "Can't open protein sequences"] -icon info -type ok
            set dialogblock 0
            return error
          }
        }
        gff3 {
          global gff3file

          set methylated 0
          set startindex 1
          set new_title [file tail $filename]
          set genbank_header_info [list]
          set gff3file [list]
          while {[eof $fileid] != 1} {lappend gff3file [gets $fileid]}
          foreach {newdna filecomment circular startindex seqlength new_tags error} [parse_gff_file $gff3file] {}
          if {$error != ""} {
            close $fileid
            tk_messageBox -message [mc "Error opening GFF file: $error"] -title [mc "Error opening GFF file"] -icon info -type ok
            set dialogblock 0
            return error
          }
          #if newdna is empty, dialog for fasta file, or n's
          if {$newdna == ""} {
            set newdna [string repeat N $seqlength]
          }
        }
        default {
          sputs "unknown filetype: $filename"
          set dialogblock 0
          close $fileid
          return error
        }  
      }
      close $fileid
      regsub -all {[^abcdghkmnrstvwyABCDGHKMNRSTVWY*]} $newdna "" newdna
      if {$info(dnadir_follows_open)} {
        set info(default_dnadir) [file dirname $filename]
      }
      set info(open_previous) [linsert $info(open_previous) 0 $filename]
      return [create_window $newdna $filename $filecomment $circular $methylated $startindex $new_title $new_tags $genbank_header_info $filetype $linked_abi_list]
    } else {
      if {![file exists $filename]} {
        tk_messageBox -message [mc "Sorry, that file doesn't exist. It may have been deleted or moved."] -type ok -icon warning
sputs doesn't exist:$filename
      } elseif {![file readable $filename]} {
        tk_messageBox -message [mc "Sorry, that file is not readable. You may not have the correct permissions for the file."] -type ok -icon warning
      }
      sputs  open error:$filename [file exists $filename] [file readable $filename]
      update_open_previous_menu
      return error
    }
  } else {
    sputs filename == ""
    return error
  }
}




set SOFA_dict {SO:0000000 Sequence_Ontology SO:0000001 region SO:0000004 interior_coding_exon SO:0000006 PCR_product SO:0000007 read_pair SO:0000013 scRNA SO:0000038 match_set SO:0000039 match_part SO:0000050 gene_part SO:0000057 operator SO:0000101 transposable_element SO:0000102 expressed_sequence_match SO:0000103 clone_insert_end SO:0000104 polypeptide SO:0000358 SO:0000109 sequence_variant_obs SO:0000110 sequence_feature SO:0000112 primer SO:0000113 proviral_region SO:0000114 methylated_C SO:0000120 protein_coding_primary_transcript SO:0000139 ribosome_entry_site SO:0000140 attenuator SO:0000141 terminator SO:0000143 assembly_component SO:0000147 exon SO:0000148 supercontig SO:0000149 contig SO:0000150 read SO:0000151 clone SO:0000159 deletion SO:0000161 methylated_A SO:0000162 splice_site SO:0000163 five_prime_cis_splice_site SO:0000164 three_prime_cis_splice_site SO:0000165 enhancer SO:0000167 promoter SO:0000177 cross_genome_match SO:0000178 operon SO:0000179 clone_insert_start SO:0000181 translated_nucleotide_match SO:0000183 non_transcribed_region SO:0000185 primary_transcript SO:0000187 repeat_family SO:0000188 intron SO:0000193 RFLP_fragment SO:0000196 five_prime_coding_exon_coding_region SO:0000197 {three_prime_coding exon_coding_region} SO:0000198 noncoding_exon SO:0000203 UTR SO:0000204 five_prime_UTR SO:0000205 three_prime_UTR SO:0000233 mature_transcript SO:0000234 mRNA SO:0000235 TF_binding_site SO:0000236 ORF SO:0000239 flanking_region SO:0000252 rRNA SO:0000253 tRNA SO:0000274 snRNA SO:0000275 snoRNA SO:0000276 miRNA SO:0000289 microsatellite SO:0000294 inverted_repeat SO:0000296 origin_of_replication SO:0000303 clip SO:0000305 modified_base_site SO:0000306 methylated_base_feature SO:0000307 CpG_island SO:0000314 direct_repeat SO:0000315 TSS SO:0000316 CDS SO:0000318 start_codon SO:0000319 stop_codon SO:0000324 tag SO:0000326 SAGE_tag SO:0000330 conserved_region SO:0000331 STS SO:0000332 coding_conserved_region SO:0000333 exon_junction SO:0000334 nc_conserved_region SO:0000336 pseudogene SO:0000337 RNAi_reagent SO:0000340 chromosome SO:0000341 chromosome_band SO:0000343 match SO:0000344 splice_enhancer SO:0000345 EST SO:0000347 nucleotide_match SO:0000349 protein_match SO:0000353 sequence_assembly SO:0000360 codon SO:0000366 insertion_site SO:0000368 transposable_element_insertion_site SO:0000370 small_regulatory_ncRNA SO:0000372 enzymatic_RNA SO:0000374 ribozyme SO:0000375 rRNA_5_8S SO:0000380 hammerhead_ribozyme SO:0000385 RNase_MRP_RNA SO:0000386 RNase_P_RNA SO:0000390 telomerase_RNA SO:0000391 U1_snRNA SO:0000392 U2_snRNA SO:0000393 U4_snRNA SO:0000394 U4atac_snRNA SO:0000395 U5_snRNA SO:0000396 U6_snRNA SO:0000397 U6atac_snRNA SO:0000398 U11_snRNA SO:0000399 U12_snRNA SO:0000403 U14_snoRNA SO:0005839 SO:0000404 vault_RNA SO:0000405 Y_RNA SO:0000407 rRNA_18S SO:0000409 binding_site BS:00033 SO:0000412 restriction_fragment SO:0000413 sequence_difference SO:0000418 signal_peptide BS:00159 SO:0000419 mature_protein_region BS:00149 SO:0000436 ARS SO:0000454 rasiRNA SO:0000462 pseudogenic_region SO:0000464 decayed_exon SO:0000468 golden_path_fragment SO:0000472 tiling_path SO:0000474 tiling_path_fragment SO:0000483 nc_primary_transcript SO:0000484 three_prime_coding_exon_noncoding_region SO:0000486 five_prime_coding_exon_noncoding_region SO:0000499 virtual_sequence SO:0000502 transcribed_region SO:0000551 polyA_signal_sequence SO:0000553 polyA_site SO:0000577 centromere SO:0000581 cap SO:0000587 group_I_intron SO:0000588 autocatalytically_spliced_intron SO:0000590 SRP_RNA SO:0000602 guide_RNA SO:0000603 group_II_intron SO:0000605 intergenic_region SO:0000610 polyA_sequence SO:0000611 branch_site SO:0000612 polypyrimidine_tract SO:0000616 transcription_end_site SO:0000624 telomere SO:0000625 silencer SO:0000627 insulator SO:0000628 chromosomal_structural_element SO:0000643 minisatellite SO:0000644 antisense_RNA SO:0000645 antisense_primary_transcript SO:0000646 siRNA SO:0000649 stRNA SO:0000650 small_subunit_rRNA SO:0000651 large_subunit_rRNA SO:0000652 rRNA_5S SO:0000653 rRNA_28S SO:0000655 ncRNA SO:0000657 repeat_region SO:0000658 dispersed_repeat SO:0000662 spliceosomal_intron SO:0000667 insertion SO:0000668 EST_match SO:0000673 transcript SO:0000684 nuclease_sensitive_site SO:0000687 deletion_junction SO:0000688 golden_path SO:0000689 cDNA_match SO:0000694 SNP SO:0000695 reagent SO:0000696 oligo SO:0000699 junction SO:0000700 remark SO:0000701 possible_base_call_error SO:0000702 possible_assembly_error SO:0000703 experimental_result_region SO:0000704 gene SO:0000705 tandem_repeat SO:0000706 trans_splice_acceptor_site SO:0000714 nucleotide_motif SO:0000717 reading_frame SO:0000719 ultracontig SO:0000724 oriT SO:0000725 transit_peptide BS:00055 SO:0000730 gap SO:0000752 gene_group_regulatory_region SO:0000777 pseudogenic_rRNA SO:0000778 pseudogenic_tRNA SO:0000830 chromosome_part SO:0000831 gene_member_region SO:0000833 transcript_region SO:0000834 mature_transcript_region SO:0000835 primary_transcript_region SO:0000836 mRNA_region SO:0000837 UTR_region SO:0000839 polypeptide_region BS:00124 BS:00331 SO:0000841 spliceosomal_intron_region SO:0000842 gene_component_region SO:0000851 CDS_region SO:0001000 rRNA_16S SO:0001001 rRNA_23S SO:0001002 rRNA_25S SO:0005836 regulatory_region SO:0005855 gene_group SO:1000002 substitution SO:1000005 complex_substitution SO:1000008 point_mutation SO:1000036 inversion SO:1001284 regulon SO:2000061 databank_entry}

###############
## parse gff file- returns list: newdna filecomment circular startindex new_tags 
###############
proc parse_gff_file {gff3file} {
  global info
  set error ""
  if {[set fastasplit [lsearch -regexp $gff3file {^>.*}]] > 0} {
    set headerlist [lrange $gff3file 0 [expr {$fastasplit-1}]]
    set dna_list [lrange $gff3file $fastasplit end]
  } else {
    set headerlist $gff3file
    #get dnalist from file, from clipboard, or fill with n's
    set dna_list [list]
  }
  set dna [join [lrange $dna_list 1 end] ""]

  set filecomment [join [lsearch -regexp -inline -all $headerlist {^#[^#].*}] \n]
  set startindex 0
  set seqstart 1
  set seqend [string length $dna]
  foreach sequence_region_line [lsearch -all -regexp -inline $headerlist {##sequence-region}] {
    if {[regexp {##sequence-region[\s:]+([^\s:]+)[\s:]+([0-9]+)[\s\.]+([0-9]+)} $sequence_region_line x seqid seqstart seqend]} {
      set seqregion_array($seqid) [list $seqstart $seqend]
    }
  }


  set features_list [lsearch -regexp -inline -all $headerlist {^[a-zA-Z0-9.:^*$@!+_?-|]+\t(.+\t){7}.+}]
  if {[lsearch -regexp $features_list {^[a-zA-Z0-9.:^*$@!+_?-|]+\t(.+\t){7}.*Is_circular=true.*}] > -1} {
    set circular "circular"
  } else {
    set circular "linear"
  }

  ##parse features into tag list
  set nextid 1
  set seqid_list [list]
  set parent_list [list]
  ##generate data arrays for each line
  foreach feature_line $features_list {
    if {[regexp {([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)} $feature_line line seqid source type start end score strand phase attributes]} {
      lappend seqid_list $seqid
      if {[expr {[llength [set attrdict [split $attributes ";="]]] % 2}]} {set attrdict [list]}
      if {[catch {set id [dict get $attrdict ID]}]} {
        set id $nextid
        incr nextid
      }
      if {[catch {set name [dict get $attrdict Name]}]} {
        set name ""
      }
      if {[dict exists $attrdict Parent]} {
        set parentlist [split [dict get $attrdict Parent] ","]
      } else {
        set parentlist [list {}]
      }
      foreach p $parentlist {
        lappend loc_array($seqid,$type,$id,$p) [list $start $end]
        set info_array($seqid,$type,$id,$p) [dict create type $type strand $strand parent $p name $name id $id]
        if {$p != {}} {
          lappend typep_array($type,$p) "$seqid,$type,$id,$p"
          lappend parent_list $p
        }
      }
    }
  }


  # if multiple seqids in file, pick one and delete all the others
  if {[llength [lsort -unique $seqid_list]] > 1} {
    #chose seqid here- use #0 for now
    set seqid [lindex $seqid_list 0]
  } else {
    set seqid [lindex $seqid_list 0]
  }
  if {[catch {set seqregion $seqregion_array($seqid)}]} {
    set seqregion {1 1}
  }
  set seqstart [lindex $seqregion 0]
  set seqend [lindex $seqregion 1]
  if {$seqstart > $seqend} {
    sputs "end of gff seq region is less than start?"
    set seqtemp $seqstart
    set seqstart $seqend
    set seqend $seqtemp 
  }
  set seqlength [expr {$seqend - $seqstart}]
  set length_from_seqregion [expr {$seqend > 1}]

  #combine all features with the same type and parent, unless there are already multiple ranges due to the same ID used to combine them
  foreach tp [array names typep_array] {
    set keylist [lsort -unique $typep_array($tp)]
    if {[llength $loc_array([lindex $keylist 0])] == 1} {
      foreach key [lrange $keylist 1 end] {
        lappend loc_array([lindex $keylist 0]) [lindex $loc_array($key) 0]
        array unset loc_array $key 
      }
    }
  }
  
  #take out parent features, if requested
  if {($parent_list != [list])  && ([tk_messageBox -message [mc "Do you want to remove all parent features from the GFF file?"] -type yesno -icon question] == "yes" )} {
    foreach p $parent_list {
      array unset loc_array *,*,$p,*
    }
  }

  #look up the parent tree to find a name if possible- assign the topmost ID if no name in the tree. Needs to add derives_from keys for branching parent trees
  foreach n [array names loc_array] {
    if {[dict get $info_array($n) name] ==""} {
      set parent_key $n
      while {([dict get $info_array($parent_key) name] == "") && ([set p [dict get $info_array($parent_key) parent]] != "")} {
        if {[set new_parent_key [array names info_array "*,*,$p,*"]] == ""} {break}
        set parent_key $new_parent_key
      }
      if {([set new_name [dict get $info_array($parent_key) name]] == "") && ([set new_name [dict get $info_array($parent_key) id]] == "")} {
        set new_name [dict get $info_array($n) id]
      }
      dict set info_array($n) name "$new_name\_[dict get $info_array($n) type]"
    }
  }

  set tags [list]
  set i 0

  foreach n [array names loc_array] {
    set type [dict get $info_array($n) type]
    set name [dict get $info_array($n) name]
    set dir [expr {[dict get $info_array($n) strand] eq "-"}]
    if {[set color_index [lsearch -exact $info(feature_default_type_colors) $type]] != -1} {
       set clist [lindex $info(feature_default_type_colors) [expr {$color_index+1}]]
    } else {
       set clist {#5fd5a3 #5fd5a3}
    }
    set fwd_color [lindex $clist 0]
    set rev_color [lindex $clist 1]
    if {$dir == 0} {
      set formatlist [list $fwd_color {} {}]
    } else {
       set formatlist [list $rev_color {} {}]
    }
    set bindlist [list <<Revcolors>> <<Metadata>>]
    if {[catch {set Apeinfo_gformat [dict get $info(feature_default_type_gformat) $type]}]} {
      set Apeinfo_gformat $info(feature_default_gformat)
    }
    set actionlist [list [list $fwd_color $rev_color] [list $name $Apeinfo_gformat $type $dir [list]]]


    set new_range [list]
    foreach loclist $loc_array($n) {
      foreach {a b} $loclist {
        set b [expr {$b +1}]
        if {($length_from_seqregion)} {
          if {$b > [expr {$seqend + 1}]} {
            if {($circular== "circular")} {
              lappend new_range [expr {$a - $seqstart}] [expr {$seqend + 1}] 0  [expr {$b - $seqend}]
              continue
            } else {
              sputs bad gff3 format- feature past end:$name $b $seqend
              set b [expr {$seqend + 1}]
            }
          }
        } else {
          set seqend [expr {max ($seqend, $b)}]
        }
        lappend new_range [expr {$a - $seqstart}]  [expr {$b - $seqstart}]
      } 
    }
##don't know what do do about unsorted range- needs to be sorted in the file to deal with split features that span the origin
    if {([lindex $new_range 0] > [lindex $new_range end])} {
      set new_range [lsort -integer $new_range ]
    }
        if {[llength $new_range] > 0} { 
          if {[llength $new_range] > 2} {
            if {($circular== "circular") && ([lindex $new_range 0] > [lindex $new_range end])} {
              #crosses the origin
              if {([llength $new_range] == 4) && ([lindex $new_range 1]== [expr {$seqend + 1}]) && ([lindex $new_range 2]== 0)} {
                #single range, just crosses the origin
                lappend tags "f$i#" [list $new_range $formatlist $bindlist $actionlist]
              } else {
                #multi-range feature, that crosses the origin
                lappend tags "f$i#" [list $new_range $formatlist $bindlist $actionlist]
                lappend tags "fn$i#" [list [list [lindex $new_range 0] $dna_length 0 [lindex $new_range end]] [list {} {} {}] [list] [list]]
              }
            } else {
              #multi-range feature, doesn't cross the origin
              lappend tags "f$i#" [list $new_range $formatlist $bindlist $actionlist]
              lappend tags "fn$i#" [list [list [lindex $new_range 0] [lindex $new_range end]] [list {} {} {}] [list] [list]]
            }
          } else {
            #simple 1 range feature
            lappend tags "f$i#" [list $new_range $formatlist $bindlist $actionlist]
          }
          incr i
       }

  }
  if {!$length_from_seqregion} {
    set seqlength [expr {$seqend - $seqstart}]
  }

  return [list $dna $filecomment $circular $startindex $seqlength $tags $error]
}

###########
## Make a new window from selection (duplicate all if no selection)
###########
proc duplicate_window {w {region selection}} {
  global info
  if {([llength [$w.textarea tag ranges sel]] > 0) && ($region == "selection")} {
    set start [$w.textarea index sel.first]
    set end [$w.textarea index sel.last]
    set circ linear
  } else {
    set start 1.0
    set end [$w.textarea index end-1c]
    set circ $info($w,circular)
  }
  set dna [textarea_get $w.textarea $start $end]
  set tags [get_tags $w.textarea [list $start $end] forward]
  # {newdna ""} {filename ""} {filecomment ""} {circular linear} {methylated 1} {startindex 1} {title [mc "New DNA"]} {tags ""}
  create_window $dna "" "[expr {($info($w,filename) eq "")?[wm title $w]:[file tail [file rootname $info($w,filename)]]}] from [expr {[ix2bp $w.textarea $start]+1}] to [ix2bp $w.textarea $end]\n[$w.comframe.comtextframe.text get 1.0 end-1char]" $circ $info($w,Dam_Dcm_methylated) 0 [mc "New DNA"] $tags $info($w,genbank_header_list)
}

###########
## Get a list of fixed fonts on the system (in the background)
###########
proc get_fixed_fonts {{i 0}} {
  global info temp_info fixed_fonts_block

  if {$i == 0} {
    set info(fixedfontlist) [list]
  }
  set target_i [expr {min([llength [font families]], $i+20)}]
  while {$i < $target_i} {
    set font [lindex [font families] $i]
    if {![regexp {[^a-z,0-9,A-Z,\ ,\}\{\_\(\)\-]} \{$font\}]} {
      if [font metrics \{$font\} -fixed] {
        lappend info(fixedfontlist) $font
      }
    } else {
    }
    incr i
  }
  if {$i < [llength [font families]]} {
    #after 1 "get_fixed_fonts [expr {$i}]"
update
get_fixed_fonts [expr {$i}]

  } else {
    if {[llength $info(fixedfontlist)] == 0} {lappend info(fixedfontlist) courier}
    if {[winfo exists .dialog.tabsframe.generaloptions.f1.menubutton1.menu]} {
      .dialog.tabsframe.generaloptions.f1.menubutton1.menu delete 0
      foreach fontfam $info(fixedfontlist) {
        .dialog.tabsframe.generaloptions.f1.menubutton1.menu add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(textfontfamily) -font [list $fontfam 10]
      }
    }
  }
}

###########
## Get a list of fixed fonts on the system
###########
proc get_fixed_fonts2 {{i 0}} {
  global info temp_info 
  set info(fixedfontlist) [list]
  foreach font [font families] {
    if {(![regexp {[^a-z,0-9,A-Z,\ ,\}\{\_\(\)]} \{$font\}]) && ([font metrics \{$font\} -fixed])} {
        lappend info(fixedfontlist) $font
    }
  }
  if {[llength $info(fixedfontlist)] == 0} {
    lappend info(fixedfontlist) courier
  }
  if {[winfo exists .dialog.tabsframe.generaloptions.f1.menubutton1.menu]} {
    .dialog.tabsframe.generaloptions.f1.menubutton1.menu delete 0
    foreach fontfam $info(fixedfontlist) {
      .dialog.tabsframe.generaloptions.f1.menubutton1.menu add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(textfontfamily) -font [list $fontfam 10]
    }
  }
}

###########
## tk_messageBox needs to reset the focus
###########
rename tk_messageBox old_tk_messageBox

proc tk_messageBox {args} {
  global tk_patchLevel

  set focus_store [focus]

  if {([tk windowingsystem] == "aqua") && (($tk_patchLevel == "8.4.13") ||($tk_patchLevel == "8.4.14"))} {
    set temp_args [list]
    foreach {x y} $args {
      if {($x == "-default") && (($y== "no") || ($y == "cancel"))} {
        sputs aqua dialog bug detected
      } else {
        lappend temp_args $x $y
      }
    }
    set args $temp_args
  } 

  set ret [eval old_tk_messageBox $args]
  focus $focus_store
  return $ret
}

###########
## replace tk::PostOverPoint, so that it makes the menu upwards, rather than just at bottom of screen
###########
proc tk::PostOverPoint {menu x y {entry {}}} {
    global tcl_platform
    if {[string compare $entry {}]} {
	if {$entry == [$menu index last]} {
	    incr y [expr {-([$menu yposition $entry]  + [winfo reqheight $menu])/2}]
	} else {
	    incr y [expr {-([$menu yposition $entry]  + [$menu yposition [expr {$entry+1}]])/2}]
	}
	incr x [expr {-[winfo reqwidth $menu]/2}]
    }

    if {$tcl_platform(platform) == "windows"} {
	# We need to fix some problems with menu posting on Windows.
	set yoffset [expr {[winfo screenheight $menu]  - $y - [winfo reqheight $menu]}]
	if {$yoffset < 0} {
	    # The bottom of the menu is offscreen, so adjust upwards
            #incr yoffset -5
	    #incr y $yoffset
	    incr y [expr {-[winfo reqheight $menu]}]
	    if {$y < 0} { set y 0 }
	}
	# If we're off the top of the screen (either because we were
	# originally or because we just adjusted too far upwards),
	# then make the menu popup on the top edge.
	if {$y < 0} {
	    set y 0
	}
    }
    $menu post $x $y
    if {$entry ne "" && [$menu entrycget $entry -state] ne "disabled"} {
	$menu activate $entry
	GenerateMenuSelect $menu
    }
}

###########
## creates a color picker button
###########
proc color_button {name variable {color ""} {size 12}} {
  global [regsub {\(.*\)} $variable ""] info
  #if {[info exists $variable]} {eval "set color $$variable"}
  if {[info exists $variable]} {set color [subst $$variable]}
  if {[catch {winfo rgb . $color}]} {set color $info(text_bg_color)}
  set $variable $color
  set rgb_color [eval format "\#%04X%04X%04X" [winfo rgb . $color]] 
  set new_image [image create photo]
  $new_image put [string repeat "{[string repeat "$rgb_color " $size] } " $size]
  if {[info commands tk_button] == {}} {
    button $name -image $new_image -width $size -height $size
  } else {
    #non-tile button
    tk_button $name -image $new_image -width $size -height $size
  }
  $name configure -command "
    set button_priv \[tk_chooseColor -initialcolor \$$variable\];
    if \{\$button_priv != \"\"\} \{
      set $variable \$button_priv
      event generate $name <<color_picked>>
    \}"

  bind $name <<updatevar>> "$new_image put  \[string repeat \"{\[string repeat \"\[eval format #%%04X%%04X%%04X \[winfo rgb . \$$variable\]\]  \" $size] } \" $size\]"
  trace add variable $variable write "event generate $name <<updatevar>>; #"
  bind $name <Destroy> "image delete $new_image;trace remove variable $variable write \"event generate $name <<updatevar>>; #\""
  return $name
}

###########
## Program Preferences dialog
###########

#####old version without tile
proc non_tile_configure_preferences {{w .}} {
  global info temp_info abi_info temp_abi
  global keysubst
  global allowedkeys possible_extensions

  global ok
  global selectedframe dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  #this is called with $w=="." on the mac when ::tk::mac::ShowPreferences is called
  if {$w=="."} {
    set w [lindex [wm stackorder .] end]
    if {$w == ""} {
      set w .
    }
  }

  toplevel .dialog
  wm title .dialog [mc "Preferences..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
  ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0



  ##frame selector frame
  grid [frame .dialog.frameselect -relief ridge -borderwidth 2] -row 0 -column 0 -sticky ns
  grid [listbox .dialog.frameselect.list -background white -foreground black -width 9 -exportselection 0] -row 0 -column 0 -sticky ns
  grid rowconfigure .dialog.frameselect 0 -weight 1
  .dialog.frameselect.list insert end [mc General]
  .dialog.frameselect.list insert end [mc Color]
  .dialog.frameselect.list insert end [mc ABI]
  if  {([lsearch -glob [info loaded] "*TclSpeech2.0.dylib*"] > -1)} {
    .dialog.frameselect.list insert end [mc Speech]
  }
  .dialog.frameselect.list insert end [mc Files]
  if {[tk windowingsystem] == "win32"} {
    .dialog.frameselect.list insert end [mc Filetypes]
  }
  .dialog.frameselect.list selection set 0
  bind .dialog.frameselect.list <Button-1> {
    grid remove $selectedframe
    switch [.dialog.frameselect.list get [.dialog.frameselect.list index @%x,%y]] "
      [mc General] {
        set selectedframe .dialog.generaloptions
      }
      [mc Color] {
        set selectedframe .dialog.coloroptions
      }
      [mc ABI] {
        set selectedframe .dialog.abioptions
      }
      [mc Speech] {
        set selectedframe .dialog.speech
      }
      [mc Files] {
        set selectedframe .dialog.files
      }
      [mc Filetypes] {
        set selectedframe .dialog.filetypes
      }
    "
    grid configure $selectedframe
  }

  ###general options frame
  array set temp $info(keysubstmap)
  set keysubst(A) ""
  set keysubst(C) ""
  set keysubst(G) ""
  set keysubst(T) ""
  foreach sub [array names temp] {
    if {([string is upper $sub]) || (![string is alpha $sub])} {
      append keysubst($temp($sub)) $sub
    }
  }
  set allowedkeys [string map {"ACGTacgt" "ACGT" "ACGTNacgtn*" "ACGTN" "ABCDGHKMNRSTVWYabcdghkmnrstvwy*" "degenerate code" "ACGUacgu" "ACGU" "ACGUNacgun*" "ACGUN"} $info(allowedkeys)]

  foreach element [list print_formatted print_abi_lines_per_page dnafontsize textfontfamily graphicfontsize graphicfontfamily locale find_orf_starts draw_graphic_connectors circ_map_feature_names_centered show_comment comment_height selection_shows_Trans enzyme_highlight_font enzyme_highlight_underline enzyme_highlight_transparent methylated_default genbank_strict_genbank genbank_skip_blank mac_antialias_limit leopard_dialog_bug] {
    set temp_info($element) $info($element)
  }


  grid [frame .dialog.generaloptions  -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  grid [frame .dialog.generaloptions.f1 -relief ridge -borderwidth 3] -row 1 -column 0 -columnspan 2 -sticky nwe
  grid [label .dialog.generaloptions.f1.label1 -text [mc "Text font:"]] -row 0 -column 0 -sticky w

  grid [menubutton .dialog.generaloptions.f1.menubutton -textvariable temp_info(dnafontsize) -menu .dialog.generaloptions.f1.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1 -sticky w
  menu .dialog.generaloptions.f1.menubutton.menu 
    foreach fontsize [lsort -unique -integer [concat [list 8 10 12 14 18] $temp_info(dnafontsize)]] {
      .dialog.generaloptions.f1.menubutton.menu add radiobutton -label $fontsize -indicatoron 1 -value $fontsize -variable temp_info(dnafontsize)
    }
  bind .dialog.generaloptions.f1.menubutton.menu <<MenuSelect>> "focus .dialog"
  grid [label .dialog.generaloptions.f1.label2 -text "pt"] -row 0 -column 2 -sticky w
  grid [menubutton .dialog.generaloptions.f1.menubutton1 -textvariable temp_info(textfontfamily) -menu .dialog.generaloptions.f1.menubutton1.menu -indicatoron 1 -relief raised] -row 0 -column 3 -sticky w
  menu .dialog.generaloptions.f1.menubutton1.menu 
  bind .dialog.generaloptions.f1.menubutton1.menu <<MenuSelect>> "focus .dialog"
  grid [label .dialog.generaloptions.f1.label3 -text [mc "Graphic font:"]] -row 1 -column 0 -sticky w
  grid [menubutton .dialog.generaloptions.f1.menubutton2 -textvariable temp_info(graphicfontsize) -menu .dialog.generaloptions.f1.menubutton2.menu -indicatoron 1 -relief raised] -row 1 -column 1 -sticky w
  menu .dialog.generaloptions.f1.menubutton2.menu 
    foreach fontsize [lsort -unique -integer [concat [list 8 10 12 14 18] $temp_info(graphicfontsize)]] {
      .dialog.generaloptions.f1.menubutton2.menu add radiobutton -label $fontsize -indicatoron 1 -value $fontsize -variable temp_info(graphicfontsize)
    }
  bind .dialog.generaloptions.f1.menubutton2.menu <<MenuSelect>> "focus .dialog"
  grid [label .dialog.generaloptions.f1.label4 -text "pt"] -row 1 -column 2 -sticky w
  grid [menubutton .dialog.generaloptions.f1.menubutton3 -textvariable temp_info(graphicfontfamily) -menu .dialog.generaloptions.f1.menubutton3.menu -indicatoron 1 -relief raised] -row 1 -column 3 -sticky w
  menu .dialog.generaloptions.f1.menubutton3.menu 
    if {[llength $info(allfontlist)] <= 20} {
      foreach fontfam info(allfontlist) {
        .dialog.generaloptions.f1.menubutton3.menu add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(graphicfontfamily) -font [list $fontfam 10]
      }
    } else {
      for {set fi 0} {$fi < [llength $info(allfontlist)]} {incr fi 20} {
        if {[set fj [expr {$fi + 19}]] > [llength $info(allfontlist)]} {set fj [expr {[llength $info(allfontlist)]-1}]}
        .dialog.generaloptions.f1.menubutton3.menu add cascade -label "[lindex $info(allfontlist) $fi]-[lindex $info(allfontlist) $fj]" -menu .dialog.generaloptions.f1.menubutton3.menu$fi 
        menu .dialog.generaloptions.f1.menubutton3.menu$fi
        foreach fontfam [lrange $info(allfontlist) $fi $fj] {
          .dialog.generaloptions.f1.menubutton3.menu$fi add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(graphicfontfamily);# -font [list $fontfam 10]
        }
      }
    }
  bind .dialog.generaloptions.f1.menubutton3.menu <<MenuSelect>> "focus .dialog"
  grid [label .dialog.generaloptions.f1.label8 -text [mc "Locale:"]] -row 3 -column 0 -sticky w
  grid [menubutton .dialog.generaloptions.f1.menubutton5 -textvariable temp_info(locale) -menu .dialog.generaloptions.f1.menubutton5.menu -indicatoron 1 -relief raised] -row 3 -column 1 -sticky w

  menu .dialog.generaloptions.f1.menubutton5.menu 
    foreach localefile [glob -directory [file join $info(Accdir) Msgs] *.msg] {
      set localefile [string tolower [file rootname [file tail $localefile]]]
      .dialog.generaloptions.f1.menubutton5.menu add radiobutton -label $localefile -indicatoron 1 -value $localefile -variable temp_info(locale)
    }
  bind .dialog.generaloptions.f1.menubutton5.menu <<MenuSelect>> "focus .dialog"
   

  grid columnconfigure .dialog.generaloptions.f1 3 -weight 1 -pad 0

  grid [frame .dialog.generaloptions.f2 -relief ridge -borderwidth 3] -row 2 -column 0 -columnspan 2 -sticky nwe
  grid [label .dialog.generaloptions.f2.label1 -text [mc "Allowed keys:"]] -row 0 -column 0  -sticky w
  grid [menubutton .dialog.generaloptions.f2.menubutton -textvariable allowedkeys -menu .dialog.generaloptions.f2.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1  -sticky w
  menu .dialog.generaloptions.f2.menubutton.menu 
    .dialog.generaloptions.f2.menubutton.menu add radiobutton -label "ACGT" -value "ACGT" -variable allowedkeys -state active
    .dialog.generaloptions.f2.menubutton.menu add radiobutton -label "ACGTN" -value "ACGTN" -variable allowedkeys
    .dialog.generaloptions.f2.menubutton.menu add radiobutton -label "degenerate code" -value "degenerate code" -variable allowedkeys
    .dialog.generaloptions.f2.menubutton.menu add radiobutton -label "ACGU" -value "ACGU" -variable allowedkeys
    .dialog.generaloptions.f2.menubutton.menu add radiobutton -label "ACGUN" -value "ACGUN" -variable allowedkeys
  bind .dialog.generaloptions.f2.menubutton.menu <<MenuSelect>> "focus .dialog"
  grid [frame .dialog.generaloptions.f2.f1 -relief flat -borderwidth 3] -row 2 -column 0  -columnspan 2 -sticky nwe
  grid [label .dialog.generaloptions.f2.f1.label2 -text [mc "Key substitutions:"]] -row 1 -column 0  -sticky w
  grid [entry .dialog.generaloptions.f2.f1.entryA -textvariable keysubst(A) -width 3 -justify right] -row 1 -column 1 -sticky w
  grid [label .dialog.generaloptions.f2.f1.label3 -text "=A,  "] -row 1 -column 2  -sticky w
  grid [entry .dialog.generaloptions.f2.f1.entryC -textvariable keysubst(C) -width 3 -justify right] -row 1 -column 3 -sticky w
  grid [label .dialog.generaloptions.f2.f1.label4 -text "=C,  "] -row 1 -column 4  -sticky w
  grid [entry .dialog.generaloptions.f2.f1.entryG -textvariable keysubst(G) -width 3 -justify right] -row 1 -column 5 -sticky w
  grid [label .dialog.generaloptions.f2.f1.label5 -text "=G,  "] -row 1 -column 6  -sticky w
  grid [entry .dialog.generaloptions.f2.f1.entryT -textvariable keysubst(T) -width 3 -justify right] -row 1 -column 7 -sticky w
  grid [label .dialog.generaloptions.f2.f1.label6 -text "=T.  "] -row 1 -column 8  -sticky w
  grid columnconfigure .dialog.generaloptions.f2 1 -weight 1

  grid [frame .dialog.generaloptions.f3 -relief ridge -borderwidth 3] -row 3 -column 0 -columnspan 2 -sticky nwe
  grid [checkbutton .dialog.generaloptions.f3.print_formatted -text [mc "Print Text with color Formatting (slower)"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(print_formatted)] -row 0 -column 0 -columnspan 3 -sticky nw
  if {[tk windowingsystem] == "aqua"} {
    tk_optionMenu .dialog.generaloptions.f3.antialiased temp_info(mac_antialias_limit) 0 1 2 3 4 5 6
    grid [label .dialog.generaloptions.f3.antialiased_label -text "Core Graphics Anti-alias limit"] -row 1 -column 0 -sticky nw
    grid .dialog.generaloptions.f3.antialiased -row 1 -column 1 -sticky w
    grid [checkbutton .dialog.generaloptions.f3.leopard_bug -text [mc "Activate Leopard bug workaround"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(leopard_dialog_bug)] -row 2 -column 0 -columnspan 3 -sticky nw
  }
  grid columnconfigure .dialog.generaloptions.f3 1 -weight 1

  grid [frame .dialog.generaloptions.f4 -relief ridge -borderwidth 3] -row 4 -column 0 -columnspan 2 -sticky nwe
  grid [label .dialog.generaloptions.f4.label1 -text [mc "Find ORFs starting with:"]] -row 0 -column 0  -sticky w
  grid [menubutton .dialog.generaloptions.f4.menubutton -textvariable temp_info(find_orf_starts) -menu .dialog.generaloptions.f4.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1
    menu .dialog.generaloptions.f4.menubutton.menu
    .dialog.generaloptions.f4.menubutton.menu add radiobutton -label "Met" -value "Met" -variable temp_info(find_orf_starts)
    .dialog.generaloptions.f4.menubutton.menu add radiobutton -label "Stop+1" -value "Stop+1" -variable temp_info(find_orf_starts)
  bind .dialog.generaloptions.f4.menubutton.menu <<MenuSelect>> "focus .dialog"
  grid columnconfigure .dialog.generaloptions.f4 2 -weight 1 -pad 0

  grid [frame .dialog.generaloptions.f5 -relief ridge -borderwidth 3] -row 5 -column 0 -columnspan 2 -sticky nwe
  grid [checkbutton .dialog.generaloptions.f5.connectors -text [mc "Draw Connectors in Graphic Map"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(draw_graphic_connectors)] -row 0 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton .dialog.generaloptions.f5.center_labels -text [mc "Center Feature Labels on Graphic Map"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(circ_map_feature_names_centered)] -row 1 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton .dialog.generaloptions.f5.meth -text [mc "Dam/Dcm default"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(methylated_default)] -row 2 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton .dialog.generaloptions.f5.comment -text [mc "Show File Comment"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(show_comment)] -row 3 -column 0 -sticky nw
  grid [label .dialog.generaloptions.f5.label1 -text [mc "Comment Height"]] -row 3 -column 1 -sticky ne
  grid [entry .dialog.generaloptions.f5.commheight -textvariable temp_info(comment_height) -validate key -vcmd "check_char %S" -width 3 -justify right] -row 3 -column 2 -sticky nw
  grid [checkbutton .dialog.generaloptions.f5.transel -text [mc "Translate Selection"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(selection_shows_Trans)] -row 4 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton .dialog.generaloptions.f5.enzhighfont -text [mc "Enzyme Highlight Bold"] -selectcolor white -onvalue bolddnafont -offvalue dnafont -variable temp_info(enzyme_highlight_font)] -row 5 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton .dialog.generaloptions.f5.enzhighunderl -text [mc "Enzyme Highlight Underline"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(enzyme_highlight_underline)] -row 6 -column 0 -columnspan 3 -sticky nw

  grid rowconfigure .dialog.generaloptions 0 -weight 1
  grid rowconfigure .dialog.generaloptions 1 -weight 1
  grid rowconfigure .dialog.generaloptions 2 -weight 1
  set selectedframe .dialog.generaloptions

  ###color options frame
  grid [frame .dialog.coloroptions  -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  grid [label .dialog.coloroptions.l1  -text [mc "Background"]] -row 0 -column 1 -sticky n
  grid [label .dialog.coloroptions.l2  -text [mc "Foreground"]] -row 0 -column 2 -sticky n
  grid [label .dialog.coloroptions.l3  -text [mc "Program"]] -row 1 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b1  temp_info(bg_color) $info(bg_color)] -row 1 -column 1 -sticky n
  if {[tk windowingsystem] != "aqua"} { 
    grid [label .dialog.coloroptions.l4  -text [mc "Menu"]] -row 2 -column 0 -sticky nw
    grid [color_button .dialog.coloroptions.b2  temp_info(menu_bg_color) $info(menu_bg_color)] -row 2 -column 1 -sticky n
    grid [color_button .dialog.coloroptions.b3  temp_info(menu_fg_color) $info(menu_fg_color)] -row 2 -column 2 -sticky n
    grid [label .dialog.coloroptions.l5  -text [mc "Menu (selected)"]] -row 3 -column 0 -sticky nw
    grid [color_button .dialog.coloroptions.b4  temp_info(menu_select_bg_color) $info(menu_select_bg_color)] -row 3 -column 1 -sticky n
    grid [color_button .dialog.coloroptions.b5  temp_info(menu_select_fg_color) $info(menu_select_fg_color)] -row 3 -column 2 -sticky n
  } else {
    #Aqua menus don't set colors
  }
  grid [label .dialog.coloroptions.l6  -text [mc "Text"]] -row 4 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b6  temp_info(text_bg_color) $info(text_bg_color)] -row 4 -column 1 -sticky n
  grid [color_button .dialog.coloroptions.b7  temp_info(text_fg_color) $info(text_fg_color)] -row 4 -column 2 -sticky n
  grid [label .dialog.coloroptions.l7  -text [mc "Text (selected)"]] -row 5 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b8  temp_info(text_select_bg_color) $info(text_select_bg_color)] -row 5 -column 1 -sticky n
  grid [color_button .dialog.coloroptions.b9  temp_info(text_select_fg_color) $info(text_select_fg_color)] -row 5 -column 2 -sticky n
  grid [label .dialog.coloroptions.l8  -text [mc "Text (background)"]] -row 6 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b10  temp_info(text_select2_bg_color) $info(text_select2_bg_color)] -row 6 -column 1 -sticky n
  grid [color_button .dialog.coloroptions.b11  temp_info(text_select2_fg_color) $info(text_select2_fg_color)] -row 6 -column 2 -sticky n

  grid [label .dialog.coloroptions.l9  -text [mc "Find(forward)"]] -row 7 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b12  temp_info(find_forward_highlight) $info(find_forward_highlight)] -row 7 -column 1 -sticky n
  grid [label .dialog.coloroptions.l10  -text [mc "Find(reverse)"]] -row 8 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b13  temp_info(find_reverse_highlight) $info(find_reverse_highlight)] -row 8 -column 1 -sticky n

  grid [label .dialog.coloroptions.l11  -text [mc "Feature default (fwd)"]] -row 7 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b14  temp_info(feature_default_fcolor) $info(feature_default_fcolor)] -row 7 -column 1 -sticky n
  grid [label .dialog.coloroptions.l12  -text [mc "Feature default (rev)"]] -row 8 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b15  temp_info(feature_default_rcolor) $info(feature_default_rcolor)] -row 8 -column 1 -sticky n

  grid [label .dialog.coloroptions.l13  -text [mc "Enzyme highlight"]] -row 9 -column 0 -sticky nw
  grid [color_button .dialog.coloroptions.b16  temp_info(enzyme_highlight_color) $info(enzyme_highlight_color)] -row 9 -column 1 -sticky n
  grid [checkbutton .dialog.coloroptions.b17 -text [mc "No Enzyme Color"] -selectcolor white -variable temp_info(enzyme_highlight_transparent) -onvalue 1 -offvalue 0] -row 10 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton .dialog.coloroptions.enzhighfont -text [mc "Enzyme Highlight Bold"] -selectcolor white -onvalue bolddnafont -offvalue dnafont -variable temp_info(enzyme_highlight_font)] -row 11 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton .dialog.coloroptions.enzhighunderl -text [mc "Enzyme Highlight Underline"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(enzyme_highlight_underline)] -row 12 -column 0 -columnspan 3 -sticky nw


  grid [button .dialog.coloroptions.bdefaults -text [mc "Restore Program Defaults"] -command "
    foreach {var color} {$info(system_default_colors)} {
      set temp_info(\$var) \$color
    }
  "] -row 13 -column 0 -columnspan 3

  grid remove .dialog.coloroptions

  ###ABI options frame
  grid [frame .dialog.abioptions -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  foreach base [list A C G T N] row [list 1 2 3 4 5] {
    set temp_abi($base) $abi_info(colors,$base)
    grid [label .dialog.abioptions.label$base -justify left -text "$base\:" ] -row $row -column 0 -sticky nw
    grid [color_button .dialog.abioptions.button$base  temp_abi($base) $temp_abi($base)] -row $row -column 1 -sticky nw
  }
  set temp_abi(non) $abi_info(colors,B)
  grid [label .dialog.abioptions.labelnon -justify left -text "BDHKMRSVWY\:" ] -row 6 -column 0 -sticky nw
  grid [color_button .dialog.abioptions.buttonnon  temp_abi(non) $temp_abi(non)] -row 6 -column 1 -sticky nw
  grid [frame .dialog.abioptions.abi_print_options -relief ridge -borderwidth 2] -row 7 -column 0 -columnspan 2 -sticky nswe
  grid [label .dialog.abioptions.abi_print_options.l1 -text [mc "Print lines per page:"]] -row 0 -column 0 -sticky w
  grid [menubutton .dialog.abioptions.abi_print_options.menubutton -textvariable temp_info(print_abi_lines_per_page) -menu .dialog.abioptions.abi_print_options.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1  -sticky w
  menu .dialog.abioptions.abi_print_options.menubutton.menu 
  foreach menuitem [list 2 3 4 5 6 7 8] {
    .dialog.abioptions.abi_print_options.menubutton.menu add radiobutton -label $menuitem -value $menuitem -variable temp_info(print_abi_lines_per_page) -state active
  }
  bind .dialog.abioptions.abi_print_options.menubutton.menu <<MenuSelect>> "focus .dialog"
  grid remove .dialog.abioptions

  ###Speech options frame
  foreach var [list speak_use_aqua speak_use_words speak_voice speak_delay] {
    set temp_info($var) $info($var)
  }
  grid [frame .dialog.speech -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  grid [frame .dialog.speech.f0 -relief ridge -borderwidth 2] -row 0 -column 0 -sticky nswe
  grid [label .dialog.speech.f0.dellabel -text [mc "Delay (ms):"]] -row 0 -column 0 -sticky nswe
  grid [entry .dialog.speech.f0.del -textvariable temp_info(speak_delay) -validate key -vcmd "check_char %S" -width 5 -justify right] -row 0 -column 1 -sticky nw
  if  {([lsearch -glob [info loaded] "*TclSpeech2.0.dylib*"] > -1)} {
    grid [frame .dialog.speech.f2 -relief ridge -borderwidth 2] -row 1 -column 0 -sticky nswe
    grid [checkbutton .dialog.speech.f2.native -text [mc "Use Mac Native Speech"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(speak_use_aqua)] -row 1 -column 1
    grid [menubutton .dialog.speech.f2.menubutton -textvariable temp_info(speak_voice) -menu .dialog.speech.f2.menubutton.menu -indicatoron 1 -relief raised] -row 2 -column 1 -sticky w
    menu .dialog.speech.f2.menubutton.menu 
    foreach menuitem [speech::speakers] {
      .dialog.speech.f2.menubutton.menu add radiobutton -label $menuitem -value $menuitem -variable temp_info(speak_voice) -state active -command "speech::speak {$menuitem} -voice {$menuitem}"
    }
    if {[lsearch -exact [speech::speakers] $temp_info(speak_voice)] ==-1} {
      set temp_info(speak_voice) [lindex [speech::speakers] 0]
    }
    grid [checkbutton .dialog.speech.f2.words -text [mc "Use NATO phonetics"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(speak_use_words)] -row 3 -column 1
  }
  grid remove .dialog.speech

  ###Files options frame
  foreach var [list default_dnadir dnadir_follows_open default_featuredir featuredir_follows_open default_enzymedir default_file_format save_file_format_warning default_file_extension max_open_previous] {
    set temp_info($var) $info($var)
  }
  grid [frame .dialog.files -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  grid [frame .dialog.files.f1 -relief ridge -borderwidth 2] -row 0 -column 0 -sticky nswe
  grid [label .dialog.files.f1.dnalabel -text [mc "Default DNA Directory:"]] -row 0 -column 0 -sticky w
  grid [label .dialog.files.f1.dnadir -textvariable temp_info(default_dnadir)] -row 1 -column 0 -columnspan 2 -sticky nsw
  grid [button .dialog.files.f1.changednadir -text [mc "Change Directory"] -command {set temp_info(default_dnadir) [tk_chooseDirectory -initialdir $temp_info(default_dnadir) -mustexist 1 -title "Chose New DNA Directory..." -parent .dialog]}] -row 2 -column 0 -sticky w
  grid [checkbutton .dialog.files.f1.follows -text [mc "Follows Last Opened File"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(dnadir_follows_open)] -row 2 -column 1 -sticky w
  grid columnconfigure .dialog.files.f1 1 -weight 1 -uniform 1
  grid [frame .dialog.files.f2 -relief ridge -borderwidth 2] -row 1 -column 0 -sticky nswe
  grid [label .dialog.files.f2.dnalabel -text [mc "Default Feature Directory:"]] -row 0 -column 0 -sticky w
  grid [label .dialog.files.f2.dnadir -textvariable temp_info(default_featuredir)] -row 1 -column 0 -columnspan 2 -sticky nsw
  grid [button .dialog.files.f2.changednadir -text [mc "Change Directory"] -command {set temp_info(default_featuredir) [tk_chooseDirectory -initialdir $temp_info(default_featuredir) -mustexist 1 -title "Chose New Feature Directory..." -parent .dialog]}] -row 2 -column 0 -sticky w
  if {1} {
    grid [button .dialog.files.f2.exportfeatures -text [mc "Create Default Feature File"] -command {
      if {(![file exists [file join $temp_info(default_featuredir) "Default_Features.txt"]]) || ([tk_messageBox -message [mc {Replace Default_Features.txt in directory %1$s?} $temp_info(default_featuredir)] -title [mc "Default Features file exists"] -icon question -type yesno -default no] == "yes")} {
          file copy -force [file join $info(Accdir) "Features" "Default_Features.txt"] [file join $temp_info(default_featuredir) "Default_Features.txt"]
      }
    }] -row 3 -column 0 -sticky w
  }
  grid [checkbutton .dialog.files.f2.follows -text [mc "Follows Last Opened File"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(featuredir_follows_open)] -row 2 -column 1 -sticky w
  grid columnconfigure .dialog.files.f2 1 -weight 1 -uniform 1
  grid [frame .dialog.files.f3 -relief ridge -borderwidth 2] -row 2 -column 0 -sticky nswe
  grid [label .dialog.files.f3.dnalabel -text [mc "Default Enzyme Directory:"]] -row 0 -column 0 -sticky w
  grid [label .dialog.files.f3.dnadir -textvariable temp_info(default_enzymedir)] -row 1 -column 0 -columnspan 2 -sticky nsw
  grid [button .dialog.files.f3.changednadir -text [mc "Change Directory"] -command {set temp_info(default_enzymedir) [tk_chooseDirectory -initialdir $temp_info(default_enzymedir) -mustexist 1 -title "Chose New Enzyme Directory..." -parent .dialog]}] -row 2 -column 0 -sticky w
  if {1} {
    grid [button .dialog.files.f3.exportenzymes -text [mc "Create Default Enzyme File"] -command {
      if {(![file exists [file join $temp_info(default_enzymedir) "Default_Enzymes.txt"]]) || ([tk_messageBox -message [mc {Replace Default_Enzymes.txt in directory %1$s?} $temp_info(default_enzymedir)] -title [mc "Default Enzymess file exists"] -icon question -type yesno -default no] == "yes")} {
          file copy -force [file join $info(Accdir) "Enzymes" "Default_Enzymes.txt"] [file join $temp_info(default_enzymedir) "Default_Enzymes.txt"]
      }
    }] -row 2 -column 1 -sticky w
  }
  grid columnconfigure .dialog.files.f3 1 -weight 1 -uniform 1
  grid [frame .dialog.files.f4 -relief ridge -borderwidth 2] -row 3 -column 0 -sticky nswe
  grid [label .dialog.files.f4.formatlabel -text [mc "Save Files in Format:"]] -row 0 -column 0 -sticky wn
  tk_optionMenu .dialog.files.f4.format temp_info(default_file_format) Genbank {DNA Strider} FASTA
  grid .dialog.files.f4.format -row 0 -column 1 -sticky wn
  grid [checkbutton .dialog.files.f4.formatwarning -text [mc "Warn if Changing File Formats"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(save_file_format_warning)] -row 1 -column 0 -sticky nw -columnspan 2
  grid [checkbutton .dialog.files.f4.strictformat -text [mc "Strict Genbank Format (Feature formatting won't be saved)"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(genbank_strict_genbank)] -row 2 -column 0 -sticky nw -columnspan 2
  grid [checkbutton .dialog.files.f4.skipblankgenbank -text [mc "Skip Blank Fields in Genbank"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(genbank_skip_blank)] -row 3 -column 0 -sticky nw -columnspan 2
  grid [label .dialog.files.f4.extensionlabel -text [mc "Default File Extension"]] -row 4 -column 0 -sticky wn
  eval "tk_optionMenu .dialog.files.f4.extension temp_info(default_file_extension) $possible_extensions"
  grid .dialog.files.f4.extension -row 4 -column 1 -sticky wn
  grid [label .dialog.files.f4.rfileslabel -text [mc "Recently used files list"]] -row 5 -column 0 -sticky wn
  tk_optionMenu .dialog.files.f4.rfiles temp_info(max_open_previous) 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20  21 22 23 24 25 26 27 28 29 30
  grid .dialog.files.f4.rfiles -row 5 -column 1 -sticky wn

  grid columnconfigure .dialog.files.f4 1 -weight 1 -uniform 1
  grid remove .dialog.files

  ###Filetypes options frame
  if {[tk windowingsystem] == "win32"} {
    global possible_extensions
    grid [frame .dialog.filetypes  -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
    set registered [get_registered_types]
    set ape_registered [lindex $registered 0]
    set other_registered [lindex $registered 1]
    set other_appl [lindex $registered 2]
    set r 0
    foreach extension $possible_extensions {
      if {[lsearch -exact $ape_registered $extension] > -1} {
        set temp_info($extension,selected) 2
        grid [checkbutton .dialog.filetypes.button$r -text "$extension"  -selectcolor white -variable temp_info($extension,selected) -onvalue 2 -offvalue 0] -row $r -column 0 -sticky w
      } elseif {[set pos [lsearch $other_registered $extension]] > -1} {
        set temp_info($extension,selected) -3
        grid [label .dialog.filetypes.button$r -text [format [mc {%1$s is already: %2$s}] $extension [lindex $other_appl $pos]] -fg red] -row $r -column 0 -sticky w
      } else {
        set temp_info($extension,selected) -1
        grid [checkbutton .dialog.filetypes.button$r -text "$extension" -selectcolor white -variable temp_info($extension,selected) -onvalue 1 -offvalue -1] -row $r -column 0 -sticky w
      }
      incr r
    }
    grid remove .dialog.filetypes
  }

  ###ok buttons frame
  grid [frame .dialog.f3 -relief flat] -row 1 -column 0 -columnspan 2
  grid [button .dialog.f3.ok -command "set ok 1" -text [mc "OK"] -default active] -row 0 -column 1 -padx 10 -pady 3
  bind .dialog <Key-Return> "set ok 1" 
  grid [button .dialog.f3.cancel -command "set ok -1" -text [mc "Cancel"]] -row 0 -column 0 -padx 10
  grid columnconfigure .dialog.f3 0 -weight 1 -uniform 1
  grid columnconfigure .dialog.f3 1 -weight 1 -uniform 1


  grid columnconfigure .dialog 1 -weight 1
  grid rowconfigure .dialog 0 -weight 1
  #wm resizable .dialog 0 0

  update idletasks



  if {[tk windowingsystem] == "aqua"} {
    set width [winfo reqwidth .dialog]
    set height [winfo reqheight .dialog]
    set x [expr { ( [winfo vrootwidth  .dialog] - $width  ) / 2 }]
    set y [expr { ( [winfo vrootheight .dialog] - $height ) / 2 }]
    wm geometry .dialog ${width}x${height}+${x}+${y}
  } else {
    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .dialog "+$winx+$winy"
    update
  }


  focus .dialog
  if {[llength $info(fixedfontlist)] == 0} {
    .dialog.generaloptions.f1.menubutton1.menu add command -label [mc "Searching for fixed fonts on the system, please wait..."]
    get_fixed_fonts
  } else {
    foreach fontfam $info(fixedfontlist) {
      .dialog.generaloptions.f1.menubutton1.menu add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(textfontfamily) -font [list $fontfam 10]
    }
  }

  vwait ok
  destroy .dialog
  set dialogblock 0
  bind . <<RaiseDialogs>> ""

  ###execute changes
  if {$ok == 1} {
    #text changes
    if {$temp_info(dnafontsize) != $info(dnafontsize)} {
      font configure dnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
      font configure bolddnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
      font configure labelfont -size $temp_info(dnafontsize)
      font configure boldlabelfont -size $temp_info(dnafontsize)
      font configure entryfont -size $temp_info(dnafontsize)
    } elseif {$temp_info(textfontfamily) != $info(textfontfamily)} {
      font configure dnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
      font configure bolddnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
    }
    if {($temp_info(graphicfontfamily) != $info(graphicfontfamily)) || ($temp_info(graphicfontsize) != $info(graphicfontsize))} {
      font configure graphicfont -family $temp_info(graphicfontfamily) -size $temp_info(graphicfontsize)
    }


    if {($temp_info(locale) != $info(locale))} {
      mclocale $temp_info(locale)

      sputs "Loaded [mcload [file join $info(Accdir) Msgs]] msg files"
    }

    if {(![string is integer $temp_info(comment_height)]) || ($temp_info(comment_height) > 10) ||($temp_info(comment_height) <0)} {
      set temp_info(comment_height) $info(comment_height)
    }

    foreach element [array names temp_info] {
      set info($element) $temp_info($element)
    }

    set info(allowedkeys) [string map {"ACGTN" "ACGTNacgtn*" "ACGT" "ACGTacgt" "degenerate code" "ABCDGHKMNRSTVWYabcdghkmnrstvwy*" "ACGU" "ACGUacgu" "ACGUN" "ACGUNacgun*"} $allowedkeys] 
    set info(keysubstmap) [list]
    foreach sub [array names keysubst] {
      foreach char [split $keysubst($sub)] {
        if {[string is alpha $char]} {
          lappend info(keysubstmap) [string toupper $char] $sub [string tolower $char] [string tolower $sub]
        } else {
          lappend info(keysubstmap) $char $sub
        }
      }
    }

    #color changes
    #tk_setPalette background $info(bg_color) activeBackground $info(bg_color) activeForeground black selectForeground $info(text_select_fg_color) selectBackground $info(text_select_bg_color);#selectColor white
    #unset checkbutton

    foreach {option color} [list background $info(bg_color) highlightBackground $info(bg_color) troughColor gray50 activeBackground $info(bg_color) activeForeground black selectForeground $info(text_select_fg_color) selectBackground $info(text_select_bg_color)] {
      option add *$option $color
    }
    catch {style default -background  $info(bg_color)}

    option add *Label.foreground $info(label_fg_color)
    option add *Checkbutton.foreground $info(label_fg_color)
    option add *Radiobutton.foreground $info(label_fg_color)
    option add *Labelframe.foreground $info(label_fg_color)

    option add *Text.background $info(text_bg_color)
    option add *Text.foreground $info(text_fg_color)
    option add *Entry.background $info(text_bg_color)
    option add *Entry.foreground $info(text_fg_color)

    option add *Menu*foreground $info(menu_fg_color)
    option add *Menu*background $info(menu_bg_color)
    option add *Menu*activeBackground $info(menu_select_bg_color)
    option add *Menu*activeForeground $info(menu_select_fg_color)

    option add *Checkbutton.activeBackground $info(bg_color)
    option add *Button.selectColor white
    option add *Radiobutton.activeBackground $info(bg_color)

    label .temp
    set info(label_fg_color) [.temp cget -foreground]
    destroy .temp

    foreach w [winfo children .] {
      if {[winfo exists $w.menubar]} {
        recolor_menu $w.menubar
      }
      if {[winfo exists $w.textframe.text]} {
        $w.textframe.text configure -background $info(text_bg_color) -foreground $info(text_fg_color)
        $w.textframe.text tag configure sel -background $info(text_select_bg_color) -foreground $info(text_select_fg_color) -relief flat
      }
      if {[winfo exists $w.text]} {
        $w.text configure -background $info(text_bg_color) -foreground $info(text_fg_color)
        $w.text tag configure sel -background $info(text_select_bg_color) -foreground $info(text_select_fg_color) -relief flat
      }
    }
    foreach w [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
      set w [string range $w 0 end-1]
      if {[winfo exists $w.textarea]} {
        $w.textarea configure -background $info(text_bg_color) -foreground $info(text_fg_color)
        $w.textarea tag configure sel -background $info(text_select_bg_color) -foreground $info(text_select_fg_color) -relief flat
        $w.textarea tag configure tempsel -background $info(text_select2_bg_color) -foreground $info(text_select2_fg_color)
        $w.textarea tag configure foundf -background $info(find_forward_highlight)
        $w.textarea tag configure foundr -background $info(find_reverse_highlight)
        $w.horzindex configure -background $info(bg_color) -fg $info(label_fg_color)
        $w.horzindex2 configure -background $info(bg_color) -fg $info(label_fg_color)
        $w.vertindex configure -background $info(bg_color) -fg $info(label_fg_color)
        #$w.infoframe.saved configure -disabledforeground $info(label_fg_color)
        $w.comframe.comtextframe.text configure -background $info(text_bg_color) -foreground $info(text_fg_color)
      }
    }

    #ABI changes
    foreach base [list A C G T N] {
      set abi_info(colors,$base) $temp_abi($base)
    }
    foreach base [list B D H K M R S V W Y] {
      set abi_info(colors,$base) $temp_abi(non)
    }
    foreach window [winfo children .] { 
      if {([string match ".abi_window*" $window]) && (![string match "*analysis*" $window])} {
        if {$abi_info($window,rev_com)} {
          foreach base [list A C G T N B D H K M R S V W Y] rc_base [list T G C A N V H D K H Y W B S R] {
            $window.c itemconfigure $base -fill $abi_info(colors,$rc_base)
          }
        } else {
          foreach base [list A C G T N B D H K M R S V W Y] {
            $window.c itemconfigure $base -fill $abi_info(colors,$base)
          }
        }
      }
    }
    #filetype changes
    if {[tk windowingsystem] == "win32"} {
      set on_list [list]
      set off_list [list]
      set tot_on 0
      foreach extension $possible_extensions {
        if {$temp_info($extension,selected) > 0} {incr tot_on}
        if {$temp_info($extension,selected) == 0} {lappend off_list $extension}
        if {$temp_info($extension,selected) == 1} {lappend on_list $extension}
      }
      file_typer $on_list $off_list [expr {$tot_on==0}]
    }

    save_defaults
  }

  array unset keysubst
  array unset temp_info
  array unset temp_abi
  unset allowedkeys

  unset ok
  unset selectedframe
}


if {1} {
###############
## Preferences dialog
###############
###new version with tile
proc configure_preferences {{w .}} {
  global info temp_info abi_info temp_abi
  global keysubst
  global allowedkeys possible_extensions

  global ok current_NCBI_translation_code
  global dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  #this is called with $w=="." on the mac when ::tk::mac::ShowPreferences is called
  if {$w=="."} {
    set w [lindex [wm stackorder .] end]
    if {$w == ""} {
      set w .
    }
  }

  toplevel .dialog
  wm title .dialog [mc "Preferences..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  if {$w != "."} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  }
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0


  grid [set t [ttk::notebook .dialog.tabsframe]] -row 0 -column 0 -sticky nswe


  ###general options frame
  $t add [frame $t.generaloptions] -text [mc General] -sticky nswe
  array set temp $info(keysubstmap)
  set keysubst(A) ""
  set keysubst(C) ""
  set keysubst(G) ""
  set keysubst(T) ""
  foreach sub [array names temp] {
    if {([string is upper $sub]) || (![string is alpha $sub])} {
      append keysubst($temp($sub)) $sub
    }
  }
  set allowedkeys [string map {"ACGTacgt" "ACGT" "ACGTNacgtn*" "ACGTN" "ABCDGHKMNRSTVWYabcdghkmnrstvwy*" "degenerate code" "ACGUacgu" "ACGU" "ACGUNacgun*" "ACGUN"} $info(allowedkeys)]

  foreach element [list print_formatted print_abi_lines_per_page dnafontsize textfontfamily default_textarea_width graphicfontsize graphicfontfamily locale find_orf_starts draw_graphic_connectors circ_map_feature_names_centered show_comment comment_height circ_map_radius selection_shows_Trans enzyme_highlight_font enzyme_highlight_underline enzyme_highlight_transparent methylated_default genbank_strict_genbank genbank_skip_blank mac_antialias_limit leopard_dialog_bug translation_code] {
    set temp_info($element) $info($element)
  }


  grid [frame $t.generaloptions.f1 -relief flat -borderwidth 3 -bg $info(bg_color)] -row 1 -column 0 -columnspan 2 -sticky nwe
  grid [label $t.generaloptions.f1.label1 -text [mc "Text font:"]] -row 0 -column 0 -sticky w

  grid [menubutton $t.generaloptions.f1.menubutton -textvariable temp_info(dnafontsize) -menu $t.generaloptions.f1.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1 -sticky w
  menu $t.generaloptions.f1.menubutton.menu 
    foreach fontsize [lsort -unique -integer [concat [list 8 9 10 11 12 13 14 16 18] $temp_info(dnafontsize)]] {
      $t.generaloptions.f1.menubutton.menu add radiobutton -label $fontsize -indicatoron 1 -value $fontsize -variable temp_info(dnafontsize)
    }
  bind $t.generaloptions.f1.menubutton.menu <<MenuSelect>> "focus .dialog"
  grid [label $t.generaloptions.f1.label2 -text "pt"] -row 0 -column 2 -sticky w
  grid [menubutton $t.generaloptions.f1.menubutton1 -textvariable temp_info(textfontfamily) -menu $t.generaloptions.f1.menubutton1.menu -indicatoron 1 -relief raised] -row 0 -column 3 -sticky w
  menu $t.generaloptions.f1.menubutton1.menu 
  bind $t.generaloptions.f1.menubutton1.menu <<MenuSelect>> "focus .dialog"
  grid [label $t.generaloptions.f1.label3 -text [mc "Graphic font:"]] -row 1 -column 0 -sticky w
  grid [menubutton $t.generaloptions.f1.menubutton2 -textvariable temp_info(graphicfontsize) -menu $t.generaloptions.f1.menubutton2.menu -indicatoron 1 -relief raised] -row 1 -column 1 -sticky w
  menu $t.generaloptions.f1.menubutton2.menu 
    foreach fontsize [lsort -unique -integer [concat [list 8 9 10 11 12 13 14 16 18] $temp_info(graphicfontsize)]] {
      $t.generaloptions.f1.menubutton2.menu add radiobutton -label $fontsize -indicatoron 1 -value $fontsize -variable temp_info(graphicfontsize)
    }
  bind $t.generaloptions.f1.menubutton2.menu <<MenuSelect>> "focus .dialog"
  grid [label $t.generaloptions.f1.label4 -text "pt"] -row 1 -column 2 -sticky w
  grid [menubutton $t.generaloptions.f1.menubutton3 -textvariable temp_info(graphicfontfamily) -menu $t.generaloptions.f1.menubutton3.menu -indicatoron 1 -relief raised] -row 1 -column 3 -sticky w
  menu $t.generaloptions.f1.menubutton3.menu 
    if {[llength $info(allfontlist)] <= 20} {
      foreach fontfam info(allfontlist) {
        $t.generaloptions.f1.menubutton3.menu add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(graphicfontfamily) -font [list $fontfam 10]
      }
    } else {
      for {set fi 0} {$fi < [llength $info(allfontlist)]} {incr fi 20} {
        if {[set fj [expr {$fi + 19}]] > [llength $info(allfontlist)]} {set fj [expr {[llength $info(allfontlist)]-1}]}
        $t.generaloptions.f1.menubutton3.menu add cascade -label "[lindex $info(allfontlist) $fi]-[lindex $info(allfontlist) $fj]" -menu $t.generaloptions.f1.menubutton3.menu$fi 
        menu $t.generaloptions.f1.menubutton3.menu$fi
        foreach fontfam [lrange $info(allfontlist) $fi $fj] {
          $t.generaloptions.f1.menubutton3.menu$fi add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(graphicfontfamily);# -font [list $fontfam 10]
        }
      }
    }
  bind $t.generaloptions.f1.menubutton3.menu <<MenuSelect>> "focus .dialog"

  grid [label $t.generaloptions.f1.label9 -text [mc "Default Sequence Width"]] -row 3 -column 0 -sticky w
  grid [entry $t.generaloptions.f1.textwidthentry  -textvariable temp_info(default_textarea_width) -validate key -vcmd "check_char %S" -width 3 -justify left] -row 3 -column 1 -sticky w
  grid [label $t.generaloptions.f1.label8 -text [mc "Locale:"]] -row 4 -column 0 -sticky w
  grid [menubutton $t.generaloptions.f1.menubutton5 -textvariable temp_info(locale) -menu $t.generaloptions.f1.menubutton5.menu -indicatoron 1 -relief raised] -row 4 -column 1 -sticky w

  menu $t.generaloptions.f1.menubutton5.menu 
    foreach localefile [glob -directory [file join $info(Accdir) Msgs] *.msg] {
      set localefile [string tolower [file rootname [file tail $localefile]]]
      $t.generaloptions.f1.menubutton5.menu add radiobutton -label $localefile -indicatoron 1 -value $localefile -variable temp_info(locale)
    }
  bind $t.generaloptions.f1.menubutton5.menu <<MenuSelect>> "focus .dialog"

  grid [ttk::separator $t.generaloptions.f1.s1 -orient horizontal] -row 5 -column 0 -columnspan 4 -sticky we

  grid columnconfigure $t.generaloptions.f1 3 -weight 1 -pad 0

  grid [frame $t.generaloptions.f2 -relief flat -borderwidth 3] -row 2 -column 0 -columnspan 2 -sticky nwe
  grid [label $t.generaloptions.f2.label1 -text [mc "Allowed keys:"]] -row 0 -column 0  -sticky w
  grid [menubutton $t.generaloptions.f2.menubutton -textvariable allowedkeys -menu $t.generaloptions.f2.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1  -sticky w
  menu $t.generaloptions.f2.menubutton.menu 
    $t.generaloptions.f2.menubutton.menu add radiobutton -label "ACGT" -value "ACGT" -variable allowedkeys -state active
    $t.generaloptions.f2.menubutton.menu add radiobutton -label "ACGTN" -value "ACGTN" -variable allowedkeys
    $t.generaloptions.f2.menubutton.menu add radiobutton -label "degenerate code" -value "degenerate code" -variable allowedkeys
    $t.generaloptions.f2.menubutton.menu add radiobutton -label "ACGU" -value "ACGU" -variable allowedkeys
    $t.generaloptions.f2.menubutton.menu add radiobutton -label "ACGUN" -value "ACGUN" -variable allowedkeys
  bind $t.generaloptions.f2.menubutton.menu <<MenuSelect>> "focus .dialog"
  grid [frame $t.generaloptions.f2.f1 -relief flat -borderwidth 3] -row 2 -column 0  -columnspan 2 -sticky nwe
  grid [label $t.generaloptions.f2.f1.label2 -text [mc "Key substitutions:"]] -row 1 -column 0  -sticky w
  grid [entry $t.generaloptions.f2.f1.entryA -textvariable keysubst(A) -width 3 -justify right] -row 1 -column 1 -sticky w
  grid [label $t.generaloptions.f2.f1.label3 -text "=A,  "] -row 1 -column 2  -sticky w
  grid [entry $t.generaloptions.f2.f1.entryC -textvariable keysubst(C) -width 3 -justify right] -row 1 -column 3 -sticky w
  grid [label $t.generaloptions.f2.f1.label4 -text "=C,  "] -row 1 -column 4  -sticky w
  grid [entry $t.generaloptions.f2.f1.entryG -textvariable keysubst(G) -width 3 -justify right] -row 1 -column 5 -sticky w
  grid [label $t.generaloptions.f2.f1.label5 -text "=G,  "] -row 1 -column 6  -sticky w
  grid [entry $t.generaloptions.f2.f1.entryT -textvariable keysubst(T) -width 3 -justify right] -row 1 -column 7 -sticky w
  grid [label $t.generaloptions.f2.f1.label6 -text "=T.  "] -row 1 -column 8  -sticky w
  grid [ttk::separator $t.generaloptions.f2.s1 -orient horizontal] -row 2 -column 0 -columnspan 8 -sticky swe
  grid columnconfigure $t.generaloptions.f2 1 -weight 1

  grid [frame $t.generaloptions.f3 -relief flat -borderwidth 3] -row 3 -column 0 -columnspan 2 -sticky nwe
  grid [checkbutton $t.generaloptions.f3.print_formatted -text [mc "Print Text with color Formatting (slower)"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(print_formatted)] -row 0 -column 0 -columnspan 3 -sticky nw
  if {[tk windowingsystem] == "aqua"} {
    tk_optionMenu $t.generaloptions.f3.antialiased temp_info(mac_antialias_limit) 0 1 2 3 4 5 6
    grid [label $t.generaloptions.f3.antialiased_label -text "Core Graphics Anti-alias limit"] -row 1 -column 0 -sticky nw
    grid $t.generaloptions.f3.antialiased -row 1 -column 1 -sticky w
    #grid [checkbutton $t.generaloptions.f3.leopard_bug -text [mc "Activate Leopard bug workaround"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(leopard_dialog_bug)] -row 2 -column 0 -columnspan 3 -sticky nw
  }
  grid [ttk::separator $t.generaloptions.f3.s1 -orient horizontal] -row 3 -column 0 -columnspan 3 -sticky swe
  grid columnconfigure $t.generaloptions.f3 1 -weight 1

  grid [frame $t.generaloptions.f4 -relief flat -borderwidth 3] -row 4 -column 0 -columnspan 2 -sticky nwe
  grid [label $t.generaloptions.f4.label1 -text [mc "Find ORFs starting with:"]] -row 0 -column 0  -sticky nw
  grid [menubutton $t.generaloptions.f4.menubutton -textvariable temp_info(find_orf_starts) -menu $t.generaloptions.f4.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1 -sticky nw
    menu $t.generaloptions.f4.menubutton.menu
    $t.generaloptions.f4.menubutton.menu add radiobutton -label "Met" -value "Met" -variable temp_info(find_orf_starts)
    $t.generaloptions.f4.menubutton.menu add radiobutton -label "Stop+1" -value "Stop+1" -variable temp_info(find_orf_starts)
  bind $t.generaloptions.f4.menubutton.menu <<MenuSelect>> "focus .dialog"
  grid [frame $t.generaloptions.f4.traslation_code -relief flat -borderwidth 3] -row 1 -column 0 -columnspan 3 -sticky nswe
    grid [menubutton $t.generaloptions.f4.traslation_code.menubutton -textvariable current_NCBI_translation_code -menu $t.generaloptions.f4.traslation_code.menubutton.menu -indicatoron 1 -relief raised] -row 1 -column 1 -sticky nwe
    set current_NCBI_translation_code [get_ncbi_translation_code $temp_info(translation_code)]
    menu $t.generaloptions.f4.traslation_code.menubutton.menu
    ##** NCBI translation code goes here
    foreach {name code} $info(NCBI_translation_code_list) {
      $t.generaloptions.f4.traslation_code.menubutton.menu add command -label $name -command "set temp_info(translation_code) $code; set current_NCBI_translation_code \[get_ncbi_translation_code $code\]"
    }
    ##* need to add vcode to change current_NCBI_translation_code when code is changed and to make sure that the code is 64 char long
    grid [label $t.generaloptions.f4.traslation_code.code_entry -textvariable temp_info(translation_code) -width 65 -justify left -font dnafont] -row 2 -column 1 -sticky nwe
    grid [label $t.generaloptions.f4.traslation_code.line1 -text {TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG} -width 65 -justify left -font dnafont] -row 3 -column 1 -sticky nwe
    grid [label $t.generaloptions.f4.traslation_code.line2 -text {TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG} -width 65 -justify left -font dnafont] -row 4 -column 1 -sticky nwe
    grid [label $t.generaloptions.f4.traslation_code.line3 -text {TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG} -width 65 -justify left -font dnafont] -row 5 -column 1 -sticky nwe

  grid [ttk::separator $t.generaloptions.f4.s1 -orient horizontal] -row 2 -column 0 -columnspan 3 -sticky swe
  grid columnconfigure $t.generaloptions.f4 2 -weight 1 -pad 0

  grid [frame $t.generaloptions.f5 -relief flat -borderwidth 3] -row 5 -column 0 -columnspan 2 -sticky nwe
  grid [checkbutton $t.generaloptions.f5.connectors -text [mc "Draw Connectors in Graphic Map"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(draw_graphic_connectors)] -row 0 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.generaloptions.f5.center_labels -text [mc "Center Feature Labels on Graphic Map"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(circ_map_feature_names_centered)] -row 1 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.generaloptions.f5.bump_labels -text [mc "Bump Feature Labels on Linear Map"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(linear_map_bump_label)] -row 2 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.generaloptions.f5.meth -text [mc "Dam/Dcm default"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(methylated_default)] -row 3 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.generaloptions.f5.comment -text [mc "Show File Comment"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(show_comment)] -row 4 -column 0 -sticky nw
  grid [label $t.generaloptions.f5.label1 -text [mc "Comment Height"]] -row 4 -column 1 -sticky ne -padx 30
  grid [entry $t.generaloptions.f5.commheight -textvariable temp_info(comment_height) -validate key -vcmd "check_char %S" -width 3 -justify right] -row 4 -column 2 -columnspan 2 -sticky nw
  grid [checkbutton $t.generaloptions.f5.transel -text [mc "Translate Selection"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(selection_shows_Trans)] -row 6 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.generaloptions.f5.enzhighfont -text [mc "Enzyme Highlight Bold"] -selectcolor white -onvalue bolddnafont -offvalue dnafont -variable temp_info(enzyme_highlight_font)] -row 7 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.generaloptions.f5.enzhighunderl -text [mc "Enzyme Highlight Underline"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(enzyme_highlight_underline)] -row 8 -column 0 -columnspan 3 -sticky nw
  grid [label $t.generaloptions.f5.circradlabel -text [mc "Circular Map Radius"]] -row 9 -column 0 -columnspan 1 -sticky nw
  grid [entry $t.generaloptions.f5.circrad -textvariable temp_info(circ_map_radius) -validate key -vcmd "check_char %S" -width 3 -justify right] -row 9 -column 1 -columnspan 2 -sticky nw


  grid rowconfigure $t.generaloptions 0 -weight 1
  grid rowconfigure $t.generaloptions 1 -weight 1
  grid rowconfigure $t.generaloptions 2 -weight 1


  ###color options frame
  $t add [frame $t.coloroptions] -text [mc Color] -sticky nswe
  grid [label $t.coloroptions.l1  -text [mc "Background"]] -row 0 -column 1 -sticky n
  grid [label $t.coloroptions.l2  -text [mc "Foreground"]] -row 0 -column 2 -sticky n
  if {([tk windowingsystem] ne "none") || !$info(use_tile)} {
    #can't set bg color in aqua tile theme
    grid [label $t.coloroptions.l3  -text [mc "Program"]] -row 1 -column 0 -sticky nw
    grid [color_button $t.coloroptions.b1  temp_info(bg_color) $info(bg_color)] -row 1 -column 1 -sticky n
  } else {
    set temp_info(bg_color) gray91
  }
  if {[tk windowingsystem] != "aqua"} { 
    #Aqua menus don't set colors
    grid [label $t.coloroptions.l4  -text [mc "Menu"]] -row 2 -column 0 -sticky nw
    grid [color_button $t.coloroptions.b2  temp_info(menu_bg_color) $info(menu_bg_color)] -row 2 -column 1 -sticky n
    grid [color_button $t.coloroptions.b3  temp_info(menu_fg_color) $info(menu_fg_color)] -row 2 -column 2 -sticky n
    grid [label $t.coloroptions.l5  -text [mc "Menu (selected)"]] -row 3 -column 0 -sticky nw
    grid [color_button $t.coloroptions.b4  temp_info(menu_select_bg_color) $info(menu_select_bg_color)] -row 3 -column 1 -sticky n
    grid [color_button $t.coloroptions.b5  temp_info(menu_select_fg_color) $info(menu_select_fg_color)] -row 3 -column 2 -sticky n
  }
  grid [label $t.coloroptions.l6  -text [mc "Text"]] -row 4 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b6  temp_info(text_bg_color) $info(text_bg_color)] -row 4 -column 1 -sticky n
  grid [color_button $t.coloroptions.b7  temp_info(text_fg_color) $info(text_fg_color)] -row 4 -column 2 -sticky n
  grid [label $t.coloroptions.l7  -text [mc "Text (selected)"]] -row 5 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b8  temp_info(text_select_bg_color) $info(text_select_bg_color)] -row 5 -column 1 -sticky n
  grid [color_button $t.coloroptions.b9  temp_info(text_select_fg_color) $info(text_select_fg_color)] -row 5 -column 2 -sticky n
  grid [label $t.coloroptions.l8  -text [mc "Text (background)"]] -row 6 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b10  temp_info(text_select2_bg_color) $info(text_select2_bg_color)] -row 6 -column 1 -sticky n
  grid [color_button $t.coloroptions.b11  temp_info(text_select2_fg_color) $info(text_select2_fg_color)] -row 6 -column 2 -sticky n

  grid [label $t.coloroptions.l9  -text [mc "Find(forward)"]] -row 7 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b12  temp_info(find_forward_highlight) $info(find_forward_highlight)] -row 7 -column 1 -sticky n
  grid [label $t.coloroptions.l10  -text [mc "Find(reverse)"]] -row 8 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b13  temp_info(find_reverse_highlight) $info(find_reverse_highlight)] -row 8 -column 1 -sticky n

  grid [label $t.coloroptions.l11  -text [mc "Feature default (fwd)"]] -row 7 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b14  temp_info(feature_default_fcolor) $info(feature_default_fcolor)] -row 7 -column 1 -sticky n
  grid [label $t.coloroptions.l12  -text [mc "Feature default (rev)"]] -row 8 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b15  temp_info(feature_default_rcolor) $info(feature_default_rcolor)] -row 8 -column 1 -sticky n

  grid [label $t.coloroptions.l13  -text [mc "Enzyme highlight"]] -row 9 -column 0 -sticky nw
  grid [color_button $t.coloroptions.b16  temp_info(enzyme_highlight_color) $info(enzyme_highlight_color)] -row 9 -column 1 -sticky n
  grid [checkbutton $t.coloroptions.b17 -text [mc "No Enzyme Color"] -selectcolor white -variable temp_info(enzyme_highlight_transparent) -onvalue 1 -offvalue 0] -row 10 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.coloroptions.enzhighfont -text [mc "Enzyme Highlight Bold"] -selectcolor white -onvalue bolddnafont -offvalue dnafont -variable temp_info(enzyme_highlight_font)] -row 11 -column 0 -columnspan 3 -sticky nw
  grid [checkbutton $t.coloroptions.enzhighunderl -text [mc "Enzyme Highlight Underline"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(enzyme_highlight_underline)] -row 12 -column 0 -columnspan 3 -sticky nw


  grid [button $t.coloroptions.bdefaults -text [mc "Restore Program Defaults"] -command "
    foreach {var color} {$info(system_default_colors)} {
      set temp_info(\$var) \$color
    }
  "] -row 13 -column 0 -columnspan 3
  grid rowconfigure $t.coloroptions 14 -weight 1

  ###ABI options frame
  $t add [frame $t.abioptions] -text [mc ABI] -sticky nswe
  foreach base [list A C G T N] row [list 1 2 3 4 5] {
    set temp_abi($base) $abi_info(colors,$base)
    grid [label $t.abioptions.label$base -justify left -text "$base\:" ] -row $row -column 0 -sticky nw
    grid [color_button $t.abioptions.button$base  temp_abi($base) $temp_abi($base)] -row $row -column 1 -sticky nw
  }
  set temp_abi(non) $abi_info(colors,B)
  grid [label $t.abioptions.labelnon -justify left -text "BDHKMRSVWY\:" ] -row 6 -column 0 -sticky nw
  grid [color_button $t.abioptions.buttonnon  temp_abi(non) $temp_abi(non)] -row 6 -column 1 -sticky nw
  grid [frame $t.abioptions.abi_print_options -relief flat -borderwidth 2] -row 7 -column 0 -columnspan 2 -sticky nswe
  grid [label $t.abioptions.abi_print_options.l1 -text [mc "Print lines per page:"]] -row 0 -column 0 -sticky w
  grid [menubutton $t.abioptions.abi_print_options.menubutton -textvariable temp_info(print_abi_lines_per_page) -menu $t.abioptions.abi_print_options.menubutton.menu -indicatoron 1 -relief raised] -row 0 -column 1  -sticky w
  menu $t.abioptions.abi_print_options.menubutton.menu 
  foreach menuitem [list 2 3 4 5 6 7 8] {
    $t.abioptions.abi_print_options.menubutton.menu add radiobutton -label $menuitem -value $menuitem -variable temp_info(print_abi_lines_per_page) -state active
  }
  grid rowconfigure $t.abioptions 14 -weight 1

  ###Speech options frame
  if  {([lsearch -glob [info loaded] "*TclSpeech2.0.dylib*"] > -1)} {
    $t add [frame $t.speech] -text [mc Speech] -sticky nswe
    foreach var [list speak_use_aqua speak_use_words speak_voice speak_delay] {
      set temp_info($var) $info($var)
    }
    grid [frame $t.speech.f0 -relief flat -borderwidth 2] -row 0 -column 0 -sticky nswe
    grid [label $t.speech.f0.dellabel -text [mc "Delay (ms):"]] -row 0 -column 0 -sticky nswe
    grid [entry $t.speech.f0.del -textvariable temp_info(speak_delay) -validate key -vcmd "check_char %S" -width 5 -justify right] -row 0 -column 1 -sticky nw
    if  {([lsearch -glob [info loaded] "*TclSpeech2.0.dylib*"] > -1)} {
      grid [frame $t.speech.f2 -relief flat -borderwidth 2] -row 1 -column 0 -sticky nswe
      grid [checkbutton $t.speech.f2.native -text [mc "Use Mac Native Speech"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(speak_use_aqua)] -row 1 -column 1
      grid [menubutton $t.speech.f2.menubutton -textvariable temp_info(speak_voice) -menu $t.speech.f2.menubutton.menu -indicatoron 1 -relief raised] -row 2 -column 1 -sticky w
      menu $t.speech.f2.menubutton.menu 
      foreach menuitem [speech::speakers] {
        $t.speech.f2.menubutton.menu add radiobutton -label $menuitem -value $menuitem -variable temp_info(speak_voice) -state active -command "speech::speak {$menuitem} -voice {$menuitem}"
      }
      if {[lsearch -exact [speech::speakers] $temp_info(speak_voice)] ==-1} {
        set temp_info(speak_voice) [lindex [speech::speakers] 0]
      }
      grid [checkbutton $t.speech.f2.words -text [mc "Use NATO phonetics"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(speak_use_words)] -row 3 -column 1
    }
    grid rowconfigure $t.speech 14 -weight 1
  }


  ###Files options frame
  foreach var [list default_dnadir dnadir_follows_open default_featuredir featuredir_follows_open default_enzymedir default_file_format save_file_format_warning default_file_extension max_open_previous] {
    set temp_info($var) $info($var)
  }
  $t add [frame $t.files] -text [mc Files] -sticky nswe
  grid [frame $t.files.f1 -relief flat -borderwidth 2] -row 0 -column 0 -sticky nswe
  grid [label $t.files.f1.dnalabel -text [mc "Default DNA Directory:"]] -row 0 -column 0 -sticky w
  grid [label $t.files.f1.dnadir -textvariable temp_info(default_dnadir)] -row 1 -column 0 -columnspan 2 -sticky nsw
  grid [button $t.files.f1.changednadir -text [mc "Change Directory"] -command {set temp_info(default_dnadir) [tk_chooseDirectory -initialdir $temp_info(default_dnadir) -mustexist 1 -title "Chose New DNA Directory..." -parent .dialog]}] -row 2 -column 0 -sticky w
  grid [checkbutton $t.files.f1.follows -text [mc "Follows Last Opened File"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(dnadir_follows_open)] -row 2 -column 1 -sticky w
  grid [ttk::separator $t.files.f1.s1 -orient horizontal] -row 3 -column 0 -columnspan 3 -sticky swe
  grid columnconfigure $t.files.f1 1 -weight 1 -uniform 1

  grid [frame $t.files.f2 -relief flat -borderwidth 2] -row 1 -column 0 -sticky nswe
  grid [label $t.files.f2.dnalabel -text [mc "Default Feature Directory:"]] -row 0 -column 0 -sticky w
  grid [label $t.files.f2.dnadir -textvariable temp_info(default_featuredir)] -row 1 -column 0 -columnspan 2 -sticky nsw
  grid [button $t.files.f2.changednadir -text [mc "Change Directory"] -command {set temp_info(default_featuredir) [tk_chooseDirectory -initialdir $temp_info(default_featuredir) -mustexist 1 -title "Chose New Feature Directory..." -parent .dialog]}] -row 2 -column 0 -sticky w
  if {1} {
    grid [button $t.files.f2.exportfeatures -text [mc "Create Default Feature File"] -command {
      if {(![file exists [file join $temp_info(default_featuredir) "Default_Features.txt"]]) || ([tk_messageBox -message [mc {Replace Default_Features.txt in directory %1$s?} $temp_info(default_featuredir)] -title [mc "Default Features file exists"] -icon question -type yesno -default no] == "yes")} {
          file copy -force [file join $info(Accdir) "Features" "Default_Features.txt"] [file join $temp_info(default_featuredir) "Default_Features.txt"]
      }
    }] -row 3 -column 0 -sticky w
  }
  grid [checkbutton $t.files.f2.follows -text [mc "Follows Last Opened File"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(featuredir_follows_open)] -row 2 -column 1 -sticky w
  grid [ttk::separator $t.files.f2.s1 -orient horizontal] -row 3 -column 0 -columnspan 3 -sticky swe
  grid columnconfigure $t.files.f2 1 -weight 1 -uniform 1

  grid [frame $t.files.f3 -relief flat -borderwidth 2] -row 2 -column 0 -sticky nswe
  grid [label $t.files.f3.dnalabel -text [mc "Default Enzyme Directory:"]] -row 0 -column 0 -sticky w
  grid [label $t.files.f3.dnadir -textvariable temp_info(default_enzymedir)] -row 1 -column 0 -columnspan 2 -sticky nsw
  grid [button $t.files.f3.changednadir -text [mc "Change Directory"] -command {set temp_info(default_enzymedir) [tk_chooseDirectory -initialdir $temp_info(default_enzymedir) -mustexist 1 -title "Chose New Enzyme Directory..." -parent .dialog]}] -row 2 -column 0 -sticky w
  if {1} {
    grid [button $t.files.f3.exportenzymes -text [mc "Create Default Enzyme File"] -command {
      if {(![file exists [file join $temp_info(default_enzymedir) "Default_Enzymes.txt"]]) || ([tk_messageBox -message [mc {Replace Default_Enzymes.txt in directory %1$s?} $temp_info(default_enzymedir)] -title [mc "Default Enzymess file exists"] -icon question -type yesno -default no] == "yes")} {
          file copy -force [file join $info(Accdir) "Enzymes" "Default_Enzymes.txt"] [file join $temp_info(default_enzymedir) "Default_Enzymes.txt"]
      }
    }] -row 2 -column 1 -sticky w
  }
  grid [ttk::separator $t.files.f3.s1 -orient horizontal] -row 3 -column 0 -columnspan 3 -sticky swe
  grid columnconfigure $t.files.f3 1 -weight 1 -uniform 1

  grid [frame $t.files.f4 -relief flat -borderwidth 2] -row 3 -column 0 -sticky nswe
  grid [label $t.files.f4.formatlabel -text [mc "Save Files in Format:"]] -row 0 -column 0 -sticky wn
  tk_optionMenu $t.files.f4.format temp_info(default_file_format) Genbank {DNA Strider} FASTA
  grid $t.files.f4.format -row 0 -column 1 -sticky wn
  grid [checkbutton $t.files.f4.formatwarning -text [mc "Warn if Changing File Formats"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(save_file_format_warning)] -row 1 -column 0 -sticky nw -columnspan 2
  grid [checkbutton $t.files.f4.strictformat -text [mc "Strict Genbank Format"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(genbank_strict_genbank)] -row 2 -column 0 -sticky nw -columnspan 2
  grid [checkbutton $t.files.f4.skipblankgenbank -text [mc "Skip Blank Fields in Genbank"] -selectcolor white -onvalue 1 -offvalue 0 -variable temp_info(genbank_skip_blank)] -row 3 -column 0 -sticky nw -columnspan 2
  grid [label $t.files.f4.extensionlabel -text [mc "Default File Extension"]] -row 4 -column 0 -sticky wn
  eval "tk_optionMenu $t.files.f4.extension temp_info(default_file_extension) $possible_extensions"
  grid $t.files.f4.extension -row 4 -column 1 -sticky wn
  grid [label $t.files.f4.rfileslabel -text [mc "Recently used files list"]] -row 5 -column 0 -sticky wn
  tk_optionMenu $t.files.f4.rfiles temp_info(max_open_previous) 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
  grid $t.files.f4.rfiles -row 5 -column 1 -sticky wn

  grid columnconfigure $t.files.f4 1 -weight 1 -uniform 1
  grid rowconfigure $t.files 14 -weight 1

  ###Filetypes options frame
  if {[tk windowingsystem] == "win32"} {
    $t add [frame $t.filetypes] -text [mc Filetypes] -sticky nswe
    global possible_extensions
    #grid [frame $t.filetypes -relief flat -borderwidth 2] -row 0 -column 1 -sticky nswe
    set registered [get_registered_types]
    set ape_registered [lindex $registered 0]
    set other_registered [lindex $registered 1]
    set other_appl [lindex $registered 2]
    set r 0
    foreach extension $possible_extensions {
      if {[lsearch -exact $ape_registered $extension] > -1} {
        set temp_info($extension,selected) 2
        grid [checkbutton $t.filetypes.button$r -text "$extension"  -selectcolor white -variable temp_info($extension,selected) -onvalue 2 -offvalue 0] -row $r -column 0 -sticky w
      } elseif {[set pos [lsearch $other_registered $extension]] > -1} {
        set temp_info($extension,selected) -3
        grid [label $t.filetypes.button$r -text [format [mc {%1$s is already: %2$s}] $extension [lindex $other_appl $pos]] -fg red] -row $r -column 0 -sticky w
      } else {
        set temp_info($extension,selected) -1
        grid [checkbutton $t.filetypes.button$r -text "$extension" -selectcolor white -variable temp_info($extension,selected) -onvalue 1 -offvalue -1] -row $r -column 0 -sticky w
      }
      incr r
    }
    grid rowconfigure $t.filetypes 14 -weight 1
  }


  ###ok buttons frame
  grid [ttk::frame .dialog.f3 -relief flat] -row 1 -column 0 -columnspan 2 -sticky nswe
  grid [ttk::button .dialog.f3.ok -command "set ok 1" -text [mc "OK"] -default active] -row 0 -column 1 -padx 10 -pady 3
  bind .dialog <Key-Return> "set ok 1" 
  grid [ttk::button .dialog.f3.cancel -command "set ok -1" -text [mc "Cancel"]] -row 0 -column 0 -padx 10
  grid columnconfigure .dialog.f3 0 -weight 1 -uniform 1
  grid columnconfigure .dialog.f3 1 -weight 1 -uniform 1


  grid columnconfigure .dialog 1 -weight 1
  grid rowconfigure .dialog 0 -weight 1
  #wm resizable .dialog 0 0
  update idletasks

  if {[tk windowingsystem] == "aqua"} {
    set width [winfo reqwidth .dialog]
    set height [winfo reqheight .dialog]
    set x [expr { ( [winfo vrootwidth  .dialog] - $width  ) / 2 }]
    set y [expr { ( [winfo vrootheight .dialog] - $height ) / 2 }]
    wm geometry .dialog ${width}x${height}+${x}+${y}
    update
  } else {
    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .dialog "+$winx+$winy"
    update
  }
  if {[llength $info(fixedfontlist)] == 0} {
    $t.generaloptions.f1.menubutton1.menu add command -label [mc "Searching for fixed fonts on the system, please wait..."]
    get_fixed_fonts
  } else {
    foreach fontfam $info(fixedfontlist) {
      $t.generaloptions.f1.menubutton1.menu add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable temp_info(textfontfamily) -font [list $fontfam 10]
    }
  }

  focus .dialog
  #grab set .dialog

  vwait ok
  destroy .dialog
  set dialogblock 0
  bind . <<RaiseDialogs>> ""



  ###execute changes
  if {$ok == 1} {

    #text changes
    if {$temp_info(dnafontsize) != $info(dnafontsize)} {
      font configure dnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
      font configure bolddnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
      font configure labelfont -size $temp_info(dnafontsize)
      font configure boldlabelfont -size $temp_info(dnafontsize)
      font configure entryfont -size $temp_info(dnafontsize)
    } elseif {$temp_info(textfontfamily) != $info(textfontfamily)} {
      font configure dnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
      font configure bolddnafont  -family $temp_info(textfontfamily) -size $temp_info(dnafontsize)
    }
    if {($temp_info(graphicfontfamily) != $info(graphicfontfamily)) || ($temp_info(graphicfontsize) != $info(graphicfontsize))} {
      font configure graphicfont -family $temp_info(graphicfontfamily) -size $temp_info(graphicfontsize)
    }

    if {($temp_info(locale) != $info(locale))} {
      mclocale $temp_info(locale)
      if {[catch {mcload [file join $info(Accdir) Msgs]} err]} {sputs $err}
    }

    if {(![string is integer $temp_info(comment_height)]) || ($temp_info(comment_height) > 10) ||($temp_info(comment_height) <0)} {
      set temp_info(comment_height) $info(comment_height)
    }

    if {(![string is integer $temp_info(default_textarea_width)]) || ($temp_info(default_textarea_width) > 300) ||($temp_info(default_textarea_width) <0)} {
      set temp_info(default_textarea_width) $info(default_textarea_width)
    }

    foreach element [array names temp_info] {
      set info($element) $temp_info($element)
    }

    set info(allowedkeys) [string map {"ACGTN" "ACGTNacgtn*" "ACGT" "ACGTacgt" "degenerate code" "ABCDGHKMNRSTVWYabcdghkmnrstvwy*" "ACGU" "ACGUacgu" "ACGUN" "ACGUNacgun*"} $allowedkeys] 
    set info(keysubstmap) [list]
    foreach sub [array names keysubst] {
      foreach char [split $keysubst($sub)] {
        if {[string is alpha $char]} {
          lappend info(keysubstmap) [string toupper $char] $sub [string tolower $char] [string tolower $sub]
        } else {
          lappend info(keysubstmap) $char $sub
        }
      }
    }

    #color changes
    #tk_setPalette background $info(bg_color) activeBackground $info(bg_color) activeForeground black selectForeground $info(text_select_fg_color) selectBackground $info(text_select_bg_color);#selectColor white
    #unset checkbutton

    foreach {option color} [list background $info(bg_color) highlightBackground $info(bg_color) troughColor gray50 activeBackground $info(bg_color) activeForeground black selectForeground $info(text_select_fg_color) selectBackground $info(text_select_bg_color)] {
      option add *$option $color
    }
    catch {style default -background  $info(bg_color)}

    option add *Label.foreground $info(label_fg_color)
    option add *Checkbutton.foreground $info(label_fg_color)
    option add *Radiobutton.foreground $info(label_fg_color)
    option add *Labelframe.foreground $info(label_fg_color)

    option add *Text.background $info(text_bg_color)
    option add *Text.foreground $info(text_fg_color)
    option add *Entry.background $info(text_bg_color)
    option add *Entry.foreground $info(text_fg_color)

    option add *Menu*foreground $info(menu_fg_color)
    option add *Menu*background $info(menu_bg_color)
    option add *Menu*activeBackground $info(menu_select_bg_color)
    option add *Menu*activeForeground $info(menu_select_fg_color)

    option add *Checkbutton.activeBackground $info(bg_color)
    option add *Button.selectColor white
    option add *Radiobutton.activeBackground $info(bg_color)

    label .temp
    set info(label_fg_color) [.temp cget -foreground]
    destroy .temp

    if {[info exists tk::mac::CGAntialiasLimit]} {
      set tk::mac::CGAntialiasLimit $info(mac_antialias_limit)
    }
    foreach w [winfo children .] {
      if {[winfo exists $w.menubar]} {
        recolor_menu $w.menubar
      }
      if {[winfo exists $w.textframe.text]} {
        $w.textframe.text configure -background $info(text_bg_color) -foreground $info(text_fg_color)
        $w.textframe.text tag configure sel -background $info(text_select_bg_color) -foreground $info(text_select_fg_color) -relief flat
      }
      if {[winfo exists $w.text]} {
        $w.text configure -background $info(text_bg_color) -foreground $info(text_fg_color)
        $w.text tag configure sel -background $info(text_select_bg_color) -foreground $info(text_select_fg_color) -relief flat
      }
    }
    foreach w [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
      set w [string range $w 0 end-1]
      if {[winfo exists $w.textarea]} {
        $w.textarea configure -background $info(text_bg_color) -foreground $info(text_fg_color)
        $w.textarea tag configure sel -background $info(text_select_bg_color) -foreground $info(text_select_fg_color) -relief flat
        $w.textarea tag configure tempsel -background $info(text_select2_bg_color) -foreground $info(text_select2_fg_color)
        catch {$w.textarea configure -inactiveselectbackground $info(text_select2_bg_color)}
        $w.textarea tag configure foundf -background $info(find_forward_highlight)
        $w.textarea tag configure foundr -background $info(find_reverse_highlight)
        $w.horzindex configure -background $info(bg_color) -fg $info(label_fg_color)
        $w.horzindex2 configure -background $info(bg_color) -fg $info(label_fg_color)
        $w.vertindex configure -background $info(bg_color) -fg $info(label_fg_color)
        #$w.infoframe.saved configure -disabledforeground $info(label_fg_color)
        $w.comframe.comtextframe.text configure -background $info(text_bg_color) -foreground $info(text_fg_color)
      }
    }

    #ABI changes
    foreach base [list A C G T N] {
      set abi_info(colors,$base) $temp_abi($base)
    }
    foreach base [list B D H K M R S V W Y] {
      set abi_info(colors,$base) $temp_abi(non)
    }
    foreach window [winfo children .] { 
      if {([string match ".abi_window*" $window]) && (![string match "*analysis*" $window])} {
        if {$abi_info($window,rev_com)} {
          foreach base [list A C G T N B D H K M R S V W Y] rc_base [list T G C A N V H D K H Y W B S R] {
            $window.c itemconfigure $base -fill $abi_info(colors,$rc_base)
          }
        } else {
          foreach base [list A C G T N B D H K M R S V W Y] {
            $window.c itemconfigure $base -fill $abi_info(colors,$base)
          }
        }
      }
    }
    #filetype changes
    if {[tk windowingsystem] == "win32"} {
      set on_list [list]
      set off_list [list]
      set tot_on 0
      foreach extension $possible_extensions {
        if {$temp_info($extension,selected) > 0} {incr tot_on}
        if {$temp_info($extension,selected) == 0} {lappend off_list $extension}
        if {$temp_info($extension,selected) == 1} {lappend on_list $extension}
      }
      file_typer $on_list $off_list [expr {$tot_on==0}]
    }

    save_defaults
  }

  array unset keysubst
  array unset temp_info
  array unset temp_abi
  unset allowedkeys

  unset ok current_NCBI_translation_code
}
}

###########
## recolor menus when color schemes change
###########
proc recolor_menu {m} {
  global info
  $m configure -background $info(menu_bg_color) -foreground $info(menu_fg_color) -activebackground $info(menu_select_bg_color) -activeforeground $info(menu_select_fg_color)
  foreach m2 [winfo children $m] {
    recolor_menu $m2
  }
}

###########
## Save program defaults
###########
proc save_defaults {} {
  global info
  set required_items [list clock_format last_update_check update_check_interval allowedkeys ApE_version text_select2_fg_color graphicfontsize locale menu_select_bg_color menu_bg_color menu_select_fg_color textfontfamily default_textarea_width default_featuredir default_enzymedir graphicfontfamily find_orf_starts menu_fg_color default_file_extension methylated_default selection_shows_Trans default_dnadir default_file_format save_file_format_warning max_open_previous open_previous dnadir_follows_open draw_graphic_connectors circ_map_feature_names_centered circ_map_radius linear_map_bump_label featuredir_follows_open text_select_bg_color find_reverse_highlight text_bg_color feature_default_type_colors feature_color_favorites feature_default_fcolor feature_default_rcolor  show_comment comment_height find_forward_highlight find_wrap text_select2_bg_color enzyme_highlight_color enzyme_highlight_font enzyme_highlight_underline enzyme_highlight_transparent dnafontsize text_select_fg_color text_fg_color bg_color print_formatted print_abi_lines_per_page abi_default_canvas_height abi_default_canvas_width gap_penalty gap_extension_penalty mm_penalty NWmax align_blocksize translation_window_copy_highlight align_copy_highlight align_linewidth align_phredtrim align_trim_to_alignment genbank_strict_genbank genbank_skip_blank leopard_dialog_bug]
  lappend required_items enz_text_dialog_order enz_text_dna_numbers enz_text_show_index enz_text_index_char1 enz_text_index_spacing1 enz_text_index_nums enz_text_index_char2 enz_text_index_spacing2 enz_text_index_char3 enz_text_show_features enz_text_2nd enz_text_genes enz_text_show_trans enz_text_trans enz_text_show_enz enz_text_enz enz_text_width enz_text_copy_highlight
  lappend required_items primer_len_min primer_len_max primer_Tm_min primer_Tm_max primer_gc_min primer_gc_max primer_clamp_min primer_clamp_max primer_consec_max primer_scomp_tot_max primer_scomp_adj_max primer_scomp_3_max primer_hcomp_tot_max primer_hcomp_adj_max primer_hcomp_3_max primer_hcomp_oligo primer_check_sc primer_salt primer_dna primer_scan translation_code feature_default_type_gformat

  ##needed to get around the bug in menus- \b is used as a non-printing leader to "-"
  set info(enz_text_index_char2) [string index $info(enz_text_index_char2) end]
  set info(enz_text_index_char1) [string index $info(enz_text_index_char1) end]


  set oldfilename [file join $info(user_defaults_dir) "ApE_Defaults.txt"]

  if {[file exists $oldfilename] && [file writable $oldfilename]} {
    #make a unique temporary filename
    set base [file join $info(user_defaults_dir) "O"]
    set i 0
    while {([file exists [set newfilename "$base$i"]])} {incr i}

    #open temp file for writing, old prefs file for reading
    set newfile [open $newfilename w]
    set oldfile [open $oldfilename r]

    set infolist [array names info]
    set saved_items [list]

    #read the prefs file and update values for all items that exist in the info array
    while {[gets $oldfile nextline] != -1} {
      if {([string index $nextline 0] == "#") || ($nextline =="") || ([string first \t $nextline] == -1)} {
        puts $newfile $nextline
      } else {
        set l [split $nextline \t]
        if {[lsearch $infolist [lindex $l 0]] > -1} {
          puts $newfile "[lindex $l 0]\t$info([lindex $l 0])"
          lappend saved_items [lindex $l 0]
        } else {
          puts $newfile $nextline
        }
      }
    }
    close $oldfile

    #add items that should exist but don't
    foreach item $required_items {
      if {[lsearch $saved_items $item] == -1} {
        puts $newfile "$item\t$info($item)"
      }
    } 
    close $newfile
    file delete $oldfilename
    file rename $newfilename $oldfilename

  } else {
    warning_dialog "Can't find the \"ApE_Defaults.txt\" file, or file is locked."
  }
}

###########
## downloads new ApE from web and updates the application 
###########
proc web_update {} {
  global argv0 info

  set info(web_update_dl_dir) {http://www.biology.utah.edu/jorgensen/wayned/ape/Download/}
  set appdir [file dir $argv0]
  package require vfs::zip
  if {[lsearch -exact [package names] "vfs::zip"] == -1} {
    tk_messageBox -message [mc "Sorry, zip file package isn't available"] -type ok -icon error
    return
  }
  switch [tk windowingsystem] {
    X11 {
      set dl_filename "ApE_linux_current.zip"
      set zip_dir "zip_volume/ApE"
    }
    win32 {
      set dl_filename "ApE_win_current.exe"
      set zip_dir "zip_volume/ApE"
    }
    aqua {
      set dl_filename "Ape_OSX_current.zip"
      set zip_dir "zip_volume/ApE.app"
      set appdir [eval [concat file join [lrange [file split [file dir $argv0]] 0 end-3]]]
    }
    default {
      set dl_filename ""
      set zip_dir "zip_volume/ApE"
    }
  }

  set error [catch {set http_token [http::geturl "$info(web_update_dl_dir)$dl_filename" -validate 1]} err_msg]
  if {!$error} {
    upvar #0 $http_token state
    array set meta $state(meta)
    ::http::cleanup $http_token
    set web_zip_clock_scan [clock scan $meta(Last-Modified)]
sputs "Zip file was last uploaded [clock format $web_zip_clock_scan]. Clock scan: $web_zip_clock_scan."
    array unset meta
  } else {
    sputs "Error getting zip file date: $err_msg"
    catch {::http::cleanup $http_token}
    set web_zip_clock 0
  }


  set error [catch {set http_token [http::geturl "$info(web_update_dl_dir)$dl_filename" -binary 1]} err_msg]
  if {!$error} {
######need to set the temp file to a place that the user can write to (temp??)
    set tempfilename [file join [tempdir] $dl_filename]
    set tempfile [open $tempfilename w]
    fconfigure $tempfile -translation binary -buffering none
    puts $tempfile [http::data $http_token]
    close $tempfile
    ::http::cleanup $http_token
 
    set zip_file_id [vfs::zip::Mount $tempfilename zip_volume]
    set i 2
    while {!(([set file_list [glob -directory $zip_dir -types f -nocomplain [string repeat /* $i]]] == {}))} {
sputs i:$i, [set dir_list [glob -directory $zip_dir -types d -nocomplain [string repeat /* $i]]]
      foreach incomming $dir_list {
        set existing [eval [concat file join {$appdir} [lrange [file split $incomming] 2 end]]]
sputs $incomming :: $existing
        if {(![file exists $existing])} {
         # sputs needs dir:$existing
        } else {
         # sputs has dir:$existing
        }
      }
      foreach incomming $file_list {
        set existing [eval [concat file join {$appdir} [lrange [file split $incomming] 2 end]]]
        if {(![file exists $existing])} {
          sputs needs:$incomming
        } elseif {[expr {[clock scan [clock format [file mtime $incomming] -format "%m/%d/%y %H:%M:%S" -gmt 1]] - [clock scan [clock format [file mtime $existing] -format "%m/%d/%y %H:%M:%S"]]}] > 0} {
           sputs newer:$incomming [clock format [file mtime $incomming] -gmt 1]
        } else {
           sputs unchanged:$existing [clock format [file mtime $existing] -gmt 1]
        }
      }

      incr i
    }
    vfs::zip::Unmount $zip_file_id zip_volume
    #file delete $tempfilename 
  } else {
    sputs "error copying zip: $err_msg"
  }
}

###########
## Checks for latest version info from web
###########
proc web_version_check {{dialog 0}} {
  global info version
#sputs doing web version check
update
  set info(web_dir)  {http://www.biology.utah.edu/jorgensen/wayned/ape/}
  set dl_filename "current_version.html"
  set error [catch {set http_token [http::geturl "$info(web_dir)$dl_filename" -timeout 1000]} err_msg]
  if {(!$error) && ([::http::status $http_token] == "ok")} {
    set data [::http::data $http_token]
    catch {::http::cleanup $http_token}
    set windowingsystem ""
    set new_version $version
    foreach line [split $data \n] {
      if {[regexp {([^\\\t]*)\t([^\\\t]*)\t(.*)} $line n windowingsystem variable data]} {
        if {($windowingsystem == [tk windowingsystem]) || ($windowingsystem == "all")} {
          set temp_info($variable) $data
        }
      }
    }
    if {[info exists temp_info(new_version)]} {
      set info(last_update_check) [clock seconds]
      #sputs web new version:$temp_info(new_version)
      if {[package vcompare $temp_info(new_version) $version] > 0} {
        set reply [tk_messageBox -message "There is a new version available ($temp_info(new_version)).\nDo you want to update?" -type yesno -icon info -title "Checking for Updates"]
        if {$reply == "yes"} {
          if {[info exists  temp_info(url)]} {
            open_url $temp_info(url)
          } else {
            open_url $info(web_dir)
          }
        }
      } elseif {$dialog} {
        tk_messageBox -message "Your current version of ApE is up to date." -type ok -icon info -title "Checking for Updates"
      }
    } else {
      tk_messageBox -message "Can't get version info from web." -type ok -icon info -title "Checking for Updates"
#sputs "Can't get version info from web."
    }
  } else {
    if {$error} {
      tk_messageBox -message "Error connecting to web: $err_msg" -type ok -icon info -title "Checking for Updates"
      #sputs "Error connecting to web: $err_msg"
      catch {::http::cleanup $http_token}
    } elseif {([::http::status $http_token] != "ok")} {
      if {[::http::status $http_token]=="timeout"} {
        tk_messageBox -message "Could not check for web updates, connection timed out. Either the website is down, or you are not connected to the internet" -type ok -icon info -title "Checking for Updates"
      } else {
        tk_messageBox -message "Error connecting to web: [expr {([::http::status $http_token]!="")?[::http::status $http_token]:""}] [expr {([::http::error $http_token]!="")?[::http:: error $http_token]:""}]." -type ok -icon info -title "Checking for Updates"
      }
      catch {::http::cleanup $http_token}
    }
  }
}


###########
## coppied from Tcl fileutil
###########
proc tempdir {} {
global tcl_platform env
    set attempdirs [list]

    foreach tmp {TMPDIR TEMP TMP} {
	if { [info exists env($tmp)] } {
	    lappend attempdirs $env($tmp)
	}
    }

    switch $tcl_platform(platform) {
	windows {
	    lappend attempdirs "C:\\TEMP" "C:\\TMP" "\\TEMP" "\\TMP"
	}
	default {
	    lappend attempdirs [file join / tmp]  [file join / var tmp] [file join / usr tmp]
	}
    }

    foreach tmp $attempdirs {
	if { [file isdirectory $tmp] && [file writable $tmp] } {
	    return $tmp
	}
    }

    # If nothing else worked...
    return [pwd]
}

###########
## returns a valid DNA directory
###########
proc valid_default_dir {} {
  global env argv0 tcl_platform

    foreach tmp {HOME HOMEPATH} {
	if { [info exists env($tmp)] } {
	    lappend attempdirs $env($tmp)
	}
    }

    switch $tcl_platform(platform) {
	windows {
	    lappend attempdirs [file dirname [file nativename [info nameofexecutable]]] [file dirname $argv0] "C:" "D:"
	}
	default {
	    lappend attempdirs [file join / Applications ApE] [file join / Applications] "/"
	}
    }

    foreach tmp $attempdirs {
	if { [file isdirectory $tmp]} {
	    return $tmp
	}
    }

    # If nothing else worked...
    return [tk_chooseDirectory -title "Please select a valid working directory" -mustexist 1]
}

###########
## returns text with all non-ATCG characters removed
###########
proc atgcfilter {s {allowed_keys "acgtACGT"} {message 0}} {

  regsub -all "\[^$allowed_keys\]" $s {} result
  regsub -all "\[$allowed_keys\]" $s {} disallowed
  regsub -all "\n" $disallowed "" disallowed
  regsub -all "\t" $disallowed "" disallowed
  regsub -all "\f" $disallowed "" disallowed
  regsub -all "\ " $disallowed "" disallowed
  regsub -all "\r" $disallowed "" disallowed
  set disallowed [join [lsort -unique [split $disallowed ""]] ""]
  if {$message && ($disallowed != [list])} {
    if {[string length $disallowed] > 100} {
      set disallowed "[string range $disallowed 0 100]..."
    }
    if {[string first N $allowed_keys] > -1} {
      set answer [tk_messageBox -icon warning -title [mc "Disallowed characters being inserted..."] -message [mc "Remove disallowed characters: %1\$s ? \n\n You may remove them (Yes), convert them to N (No), or cancel the insertion (Cancel)." $disallowed] -type yesnocancel -default cancel]
    } else {
      set answer [tk_messageBox -icon warning -title [mc "Disallowed characters being inserted..."] -message [mc "Remove disallowed characters: %1\$s ? \n\n You may remove them (OK) or cancel the insertion (Cancel)." $disallowed] -type okcancel -default cancel]
    }
    if {($answer == "yes") || ($answer == "ok")} {
      return $result
    } elseif {($answer == "no") && ([string first N $allowed_keys] > -1)} {
      regsub -all -nocase "\[^$allowed_keys\]" $s "N" s
      return $s
    } else {
      return ""
    }
  }
  return $result
}


#########
## close window- keep track of open windows, so you can exit if all are closed
#########
proc closewindow {w} {
  #in aqua, there is a menubar child of .
  if {$w == ".menubar"} return
  global abi_info
  global info tk_patchLevel

  set proceede 1
  if {[string match "*_analysis*" $w]} {
    #####close an analysis window
     #look at all of the events linked to windows linked to this analysis window
    foreach window $info($w,linked_windows) {
      set templist [list]
      foreach event $info($window,linked_events) {
        #if the event doesn't refer to this analysis window, keep it in the list
        if {[winfo toplevel [lindex $event 0]] != $w} { 
          lappend templist $event
        }
      }
      set info($window,linked_events) $templist
    }
    array unset info "$w,*"

    if {[winfo exists $w]} {destroy $w}
  } elseif {[string match ".dna_window*" $w]} {
    ####close a dna window
    if {$info($w,saved) == 0} {
      wm deiconify $w
      raise $w
      set answer [tk_messageBox -icon warning -title [mc "ApE: File not saved"] -message "[mc {Do you want to save the changes you made to}]\n[expr {($info($w,filename)=="")?[wm title $w]:$info($w,filename)}]?" -type yesnocancel -default yes -parent $w]
      if {$answer == "yes"} {
       save_file $w Save
      } elseif {$answer == "cancel"} {
        set proceede 0
      }
    }
    if {$proceede == 1} {
      unlink_analysis_window $w
      if {[winfo exists $w]} {destroy $w}
      array unset info "$w,*"
      if {[llength [array names info $w]] > 0} {warning_dialog "info array still has elements: [array names info $w]"}
      set templist [list]
      set temptitleslist [list]
      foreach element $info(dnawindows_list) {
        if {$element != $w} {lappend templist $element; lappend temptitleslist $info($element,win_title)}
      }
      set info(dnawindows_list) $templist
      set info(dnatitles_list) $temptitleslist
    }
  } elseif {[string match ".abi_window*" $w]} {
    #####close an abi window
    unlink_analysis_window $w
    if {[winfo exists $w]} {destroy $w}
    array unset abi_info "$w,*"
  } 

  update_windows_menu
  if {[tk windowingsystem] != "aqua"} {
    if {([llength $info(dnawindows_list)] == 0) && ([llength [regexp -all -inline ".abi_window\[0-9\]* " "[winfo children .] "]] == 0)} {
      if {([llength [winfo children .]] > 0) && ([tk_messageBox -message [mc "Do you want to exit?"] -title [mc "Last DNA window"] -icon question -type yesno -default no] == "no")} {
        create_window
      } else {
        exit_with_checks
      }
    }
  } else {
    if {([llength $info(dnawindows_list)] == 0)} {
      bind . <Command-KeyPress-o> open_file_dialog
      bind . <Command-KeyPress-n> create_window
      bind . <Command-KeyPress-q> close_all_windows
      catch {.menubar.filemenu entryconfigure [mc "New"] -state normal}
      catch {.menubar.filemenu entryconfigure [mc "Open..."] -state normal}
      catch {.menubar.filemenu entryconfigure [mc "Open Recent Files"] -state normal}
      #.menubar.apple entryconfigure [mc "Preferences..."] -state normal
      catch {.menubar.apple entryconfigure [mc "About ApE"] -state normal}
    }
  }
  return $proceede
}

########
## Rename exit to final_exit, so exit commands from the outside can be re-directed
########
rename exit exit_proc

proc final_exit {} {
sputs final_exit proc called
  if {[tk windowingsystem] == "win32"} {
    dde servername " "
  }
  exit_proc
}

########
## Exiting, no more dialogs
########
proc exit_with_checks {} {
  global info fea_info

  if {$info(enzymes_saved) != 1} {
    if {[tk_messageBox -message "Do you want to save changes to the enzyme set?" -type yesno -icon question] == "yes"} {
      save_enzymes "" 0
    }
  }
  if {($fea_info(library_file) == "") && ([llength $fea_info(library)] > 0)} {
    if {[tk_messageBox -message "Do you want to save changes to the feature file?" -type yesno -icon question] == "yes"} {
      save_feature_library
    }
  }

  save_defaults

  final_exit
}

########
## Now, direct exit commands to close all windows
########
proc exit {} {
  close_all_windows
}

########
## break the event links when a dna window is modified
########
proc unlink_analysis_window {w} {
  global info
#unbind all the bound events pointing to $w
  if {[lsearch [array names info] "$w,linked_events"] == -1} {return}
  foreach event $info($w,linked_events) {
    if {[llength $event] == 3} {
      if {[tk windowingsystem] eq "aqua"} {
        [lindex $event 0] configure -background gray85
      } else {
        [lindex $event 0] configure -background gray95
      }
      if {[winfo class [lindex $event 0]] == "Text"} {  
        [lindex $event 0] tag bind [lindex $event 1] [lindex $event 2] "
          tk_messageBox -message {The window this analysis refers to has been modified.} -parent [winfo toplevel [lindex $event 0]] -icon info -type ok -default ok
          #[lindex $event 0] tag bind [lindex $event 1] [lindex $event 2] {}
        "
      } else {
        [lindex $event 0] bind [lindex $event 1] [lindex $event 2] "
          tk_messageBox -message {The window this analysis refers to has been modified.} -parent [winfo toplevel [lindex $event 0]] -icon info -type ok -default ok
          #[lindex $event 0] bind [lindex $event 1] [lindex $event 2] {}
        "
      }
    } else {
      bind [lindex $event 0] [lindex $event 1] "
        tk_messageBox -message {The window this analysis refers to has been modified.} -parent [winfo toplevel [lindex $event 0]] -icon info -type ok -default ok
       #bind [lindex $event 0] [lindex $event 1] {}
      " 
    }
  }
#take $w out of all the analysis,linked_windows lists
  foreach a [array names info "*,linked_windows"] {
    if {[set i [lsearch -exact $info($a) $w]] != -1 } {
      set info($a) [lreplace $info($a) $i $i]
    }
  }
  set info($w,linked_events) [list]
}


########
## Close all windows for exit
########
proc close_all_windows {} {
  ##close analysis windows first
  foreach window [winfo children .] {
    if {[string first "analysis" $window] > -1} {
      closewindow $window
    }
  }

  ##then close the dna windows, asking for saves
  set really 1
  foreach window [winfo children .] {
    if {[closewindow $window] == 0} {
      set really 0
      break
    }
  }

sputs caw [winfo children .]
  if {([tk windowingsystem] == "aqua") && ($really == 1)} {
    exit_with_checks
  }
}

########
## Make sure the window is on the screen
########
proc window_on_screen {w} {
  update
  if {![winfo exists $w]} {return}
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winw winh winx winy
  if {[expr $winx + $winw] > [winfo screenwidth $w]} {set winx [expr {[winfo screenwidth $w]-$winw}]}
  if {[expr $winy + $winh] > [winfo screenheight $w]} {set winy [expr {[winfo screenheight $w]-$winh}]}
  if {$winx < 20} {set winx 20}
  if {($winy < 20)} {set winy 20}
  wm geometry $w +$winx+$winy
}

########
## set the selection in the textbox (Shift-arrow)
########
proc textkeyselect {w direction} {
global info
  if {1} {
    switch $direction {
      Left {
        set pos [$w.textarea index insert-1c]
        if {[$w.textarea compare $pos == "$pos lineend"]} {
          set pos [$w.textarea index $pos-1c]
        }
      }
      Right {
        set pos [$w.textarea index insert+1c]
        if {[$w.textarea compare $pos == "$pos lineend"]} {
          set pos [$w.textarea index $pos+1c]
        }
      }
      Up {
        if {[$w.textarea compare 1.0 < "insert linestart"]} {
          set pos [$w.textarea index insert-1line]
        } else {
          set pos [$w.textarea index insert]
        }
      }
      Down {
        if {[$w.textarea compare end > insert+1line]} {
          set pos [$w.textarea index insert+1line]
        } else {
          set pos [$w.textarea index insert]
        }
      }
    } 
  }

  set new $pos
  if {[string equal [$w.textarea tag nextrange sel 1.0 end] ""]} {
    if {[$w.textarea compare $new < insert]} {
      $w.textarea tag add sel $new insert
    } else {
      $w.textarea tag add sel insert $new
    }
    $w.textarea mark set anchor insert
    $w.textarea mark set tk::anchor$w.textarea insert
  } else {
    if {[$w.textarea compare $new < tk::anchor$w.textarea]} {
      set first $new
      set last tk::anchor$w.textarea
    } else {
      set first tk::anchor$w.textarea
      set last $new
    }
    $w.textarea tag remove sel 1.0 $first
    $w.textarea tag add sel $first $last
    $w.textarea tag remove sel $last end
  }
  $w.textarea mark set insert $new
  $w.textarea see insert

  vertindexbalancer $w
  selection_manager $w
  update idletasks
}

########
## set the cursor in the textbox
########
proc textsetcursor {w pos} {
    if {[$w.textarea compare $pos == end]} {
	set pos {end - 1 chars}
    }
    $w.textarea mark set insert $pos
    $w.textarea mark set anchor insert
    $w.textarea mark set tk::anchor$w.textarea insert
    $w.textarea tag remove sel 1.0 end
    $w.textarea tag remove tempsel 1.0 end
    $w.textarea see insert

    vertindexbalancer $w
    selection_manager $w
}

########
## move the cursor in the textbox (arrow movements)
########
proc textarea_move_cursor {w direction} {
global info
  if {1} {
    switch $direction {
      Left {
        set pos [$w.textarea index insert-1c]
        if {[$w.textarea compare $pos == "$pos lineend"]} {
          set pos [$w.textarea index $pos-1c]
        }
      }
      Right {
        set pos [$w.textarea index insert+1c]
        if {[$w.textarea compare $pos == "$pos lineend"]} {
          set pos [$w.textarea index $pos+1c]
        }
      }
      Up {
        if {[$w.textarea compare 1.0 < "insert linestart"]} {
          set pos [$w.textarea index insert-1line]
        } else {
          set pos [$w.textarea index insert]
        }
      }
      Down {
        if {[$w.textarea compare end > insert+1line]} {
          set pos [$w.textarea index insert+1line]
        } else {
          set pos [$w.textarea index insert]
        }
      }
    } 
  }
  textsetcursor $w $pos
}

########
## return the index of the closest gap to a mouse press
########
proc text_closest_gap {w x y} {
    if {$y < 1} {
      set y 3
    }
    if {$y >= [winfo height $w]} {
      set y [expr {[winfo height $w]-5}]
    }
    set pos [$w index @$x,$y]
    set bbox [$w bbox $pos]
    if {($bbox ne "") && ($x - [lindex $bbox 0]) >= ([lindex $bbox 2]/2)} {
      set pos [$w index $pos+1char]
    }
    if {[$w compare $pos == "$pos lineend"]} {
      set pos [$w index $pos+1c]
    }
    return $pos
}

########
## configure the mouseindex and info box for textarea motion events
########
proc mouseover_info {w index} {
   global info
  if {$index > 0} {
    #$w.mouseindex configure -text [expr {1+[ix2bp $w.textarea $index]}]
    $w.infoframe.mouseindex configure -text [expr {1+[ix2bp $w.textarea $index]}]
    set info1 [list]
    foreach tag [$w.textarea tag names $index] {
      if {[lindex [$w.textarea tag bind $tag <<Metadata>>] 2] == "enzyme"} {
        #set name [lindex [$w.textarea tag bind $tag <<Metadata>>] 0]
        #lappend info "$name\([enz_count $w $name all]):[lindex [$w.textarea tag bind $tag <<Metadata>>] 4]"
        lappend info1 "[lindex [$w.textarea tag bind $tag <<Metadata>>] 0]:[lindex [$w.textarea tag bind $tag <<Metadata>>] 4]"
      } else {
        if {[set name [lindex [$w.textarea tag bind $tag <<Metadata>>] 0]] != ""} {
          lappend info1 $name
        }
      }
    }
    $w.infobox configure -text [join $info1 ","]
    if {![info exists info($w,seq_tooltip)]} {
      set info($w,seq_tooltip) 0
    }
    if {$info($w,seq_tooltip)} {
      seq_tooltip_post $w [lindex [$w.textarea bbox $index] 0]  [lindex [$w.textarea bbox $index] 1]
    } else {
      catch {destroy $w.seqtooltip}
    }
  } else {
    #$w.mouseindex configure -text ""
    $w.infoframe.mouseindex configure -text ""
    $w.infobox configure -text ""
    catch {destroy $w.seqtooltip}
  }
}

#######
## post tooltip over sequence window
#######
proc seq_tooltip_post {w x y} {
  if {![winfo exists $w] || [catch {$w.textarea index @$x,$y}]} return
  set textbox $w.textarea
  set index [$textbox index @$x,$y]  
  seq_tooltip_create $w
  foreach {tt_height tt_width} [seq_tooltip_update $w $x $y] {}
  if {$tt_height == 0} {
    catch {destroy $w.seqtooltip}
  } else {
##set the geometry here- currently centers on the selected region, could draw the width of the textarea
    #wm geometry $w.seqtooltip "+[expr {[winfo rootx $textbox]+$x- ($tt_width/2)+7 }]+[expr {[winfo rooty $textbox]+$y- $tt_height-19}]"
    wm geometry $w.seqtooltip "+[expr {[winfo rootx $textbox]}]+[expr {[winfo rooty $textbox]+$y- $tt_height-9}]"
  }
}

#######
## create tooltip window over sequence (called by seq_tooltip_post)
#######
proc seq_tooltip_create {w} {
  global info
  if {[winfo exists $w.seqtooltip]} {
    return
  }
  toplevel $w.seqtooltip  -borderwidth 1 -background black
  if {([tk windowingsystem] == "aqua")} {
    tk::unsupported::MacWindowStyle style $w.seqtooltip help {}
  } else { 
    wm overrideredirect $w.seqtooltip 1
  }
  catch {wm attributes $w.seqtooltip -alpha $info(seq_tooltip_alpha)}
  pack [canvas $w.seqtooltip.c -background white]
  $w.seqtooltip.c create text 10 10 -tags infotext
}

#######
## update info in sequence tooltip window (called by seq_tooltip_post)
#######
proc seq_tooltip_update {w x y} {
  set to_canvas $w.seqtooltip.c
  set seq_width [expr {[winfo width $w.textarea]-9}]
  set line_width [lindex [$w.textarea dlineinfo [$w.textarea index @$x,$y]] 2]
##draw tooltip canvas here
  #$to_canvas itemconfigure infotext -text "Test $x $y [ix2bp $w.textarea [$w.textarea index @$x,$y]] [$w.textarea tag names @$x,$y]"
  $to_canvas delete all
    set start [ix2bp $w.textarea [set start_index [$w.textarea index "@$x,$y linestart"]]]
    set end [ix2bp $w.textarea [set end_index [$w.textarea index "@$x,$y lineend"]]]
    set total_length [expr {$end-$start}]
    set templist [feature_find $w $start $end]
    set depthdict [tagdepth $w.textarea $start_index $end_index]
    foreach {name tag} $templist {
      regsub "fn" $tag "f" tag
      if {[dict exists $depthdict $tag]} {
        set yplus [dict get $depthdict $tag]
      } else {
        set yplus 0
      }
#need to copy this feature and take out all feature links
      seq_tooltip_linear_feature_draw $to_canvas [expr {$yplus*30}] $w $start $end $total_length $tag $line_width
    }
  set bbox [$to_canvas bbox all]
  if {$bbox == [list]} {
    set bbox [list 0 0 $seq_width 0]
  } else {
    set bbox [list 0 [lindex $bbox 1] $seq_width [lindex $bbox 3]]
  }
  $to_canvas xview moveto 0
  $to_canvas configure -scrollregion $bbox -width $seq_width -height [expr {[lindex $bbox 3]-[lindex $bbox 1]}]
  return [list [expr {[lindex $bbox 3]-[lindex $bbox 1]}] [expr {[lindex $bbox 2]-[lindex $bbox 0]}]]
}

#######
## draw feature arrows in the seq tooltip window
#######
proc seq_tooltip_linear_feature_draw {c y w start end total_length tag x_right} {
  global info modifier
  set ranges [feature_coords $w $tag $start $end]
  if {[$w.textarea tag cget $tag -background] == ""} {
    return
  } else {
    set state "normal"
  }
  set tag_color [eval format "\#%04X%04X%04X" [winfo rgb . [lindex [$w.textarea tag bind $tag <<Revcolors>>] [lindex [$w.textarea tag bind $tag <<Metadata>>] 3]]]]
  set tags [list $tag]
  set tag_bg_color [gray_color $tag_color]
  set direction [lindex [$w.textarea tag bind $tag <<Metadata>>] 3]
  set label [lindex [$w.textarea tag bind $tag <<Metadata>>] 0]
  set gformat [lindex [$w.textarea tag bind $tag <<Metadata>>] 1]
  set width [dict get $gformat width]
  set arrow_list [dict get $gformat arrow_data]
  set fntag [regsub f $tag fn]

  set x_left 0
  #draw first through 2nd to last exon and all introns (no exons drawn if only one exon)
  foreach range1 [lrange $ranges 0 end-1]  range2 [lrange $ranges 1 end] {
    set x1 [expr {$x_left + $x_right * ([lindex $range1 0] - $start) / $total_length}]
    set x2 [expr {$x_left + $x_right * ([lindex $range1 1] - $start) / $total_length}]
    $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon outline] -fill $tag_bg_color -outline $tag_bg_color -state $state -width 2
    $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon foreground] -fill $tag_color -state $state -outline {}
    if {$range2 != [list]} {
      #draw intron
      set x1 [expr {$x_left + $x_right * ([lindex $range2 0] - $start) / $total_length}]
      if {($x1 >= $x2)} {
        $c create line [expr {$x2+0}] [expr {$y+$width/2.0}] [expr {($x1+$x2)/2.0}]  [expr {$y+$width/2.0+5}] $x1 [expr {$y+$width/2.0}] -tag [concat $tags intron] -state $state -fill $tag_color -width 2
      } else {
        #split around the circle
        $c create line $x2 $y [expr {$x2+1}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x2+3}] $y [expr {$x2+4}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x2+6}] $y [expr {$x2+7}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line $x1 $y [expr {$x1-1}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x1-3}] $y [expr {$x1-4}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x1-6}] $y [expr {$x1-7}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
      }
    }
  }
  #draw final (or only) exon
  set x1 [expr {$x_left + $x_right * ([lindex [lindex $ranges end] 0] - $start) / $total_length}]
  set x2 [expr {$x_left + $x_right * ([lindex [lindex $ranges end] 1] - $start) / $total_length}]
  $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon outline] -fill $tag_bg_color -outline $tag_bg_color -width 2 -state $state
  $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon foreground] -fill $tag_color -outline {} -state $state
  

  
  #draw arrows
#move this to a proc, get coords, direction and arrows from tag binding, scale the x coords based on [lindex [$c coords line] 2], keep y coords

  $c create polygon 0 0 -tag  [concat $tags fwd_arrow outline]  -fill $tag_bg_color -width 2 -state $state
  $c create polygon 0 0 -tag  [concat $tags fwd_arrow foreground]  -fill $tag_color  -state $state
  $c create polygon 0 0 -tag  [concat $tags rev_arrow outline]  -fill $tag_bg_color -width 2 -state $state
  $c create polygon 0 0 -tag  [concat $tags rev_arrow foreground]  -fill $tag_color  -state $state

  set first_exon [lindex [$c find withtag $tag&&exon&&foreground]  0]
  set first_exon_bg [lindex [$c find withtag $tag&&exon&&outline]  0]
  set last_exon [lindex [$c find withtag $tag&&exon&&foreground]  end]
  set last_exon_bg [lindex [$c find withtag $tag&&exon&&outline]  end]

  $c bind $tag <<Gformat>> $gformat
  $c bind $tag <<Coord_list>> [list [list $first_exon $first_exon_bg [$c coords $first_exon]] [list $last_exon $last_exon_bg [$c coords $last_exon]]]
  $c bind $tag <<Direction>> $direction

  linear_feature_draw_arrow $c $tag
  

  #draw label
  set x1 [expr {$x_left + $x_right * ((([lindex [lindex $ranges 0] 0] + [lindex [lindex $ranges end] 1])/2)-$start) / $total_length }]
  set featurelabelid [$c create text $x1 [expr {$y+$width/2.0+2}] -text "$label" -anchor n -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tag [concat $tags featurelabel moveabletext] -state $state]

  $c lower intron exon
}

#######
## splits feature tags after an insertion is made
#######
proc tag_split {w index1 index2 {operation dialog}} {
  global fea_info

  set tags_added [list]
  set tags_modified [list]
  set c [$w.textarea compare $index1 > $index2]
  #sputs tagsplit $index1 $index2 $c
  foreach tag [$w.textarea tag names $index1] {
    #sputs tagsplit2  $tag [$w.textarea tag ranges $tag]
    if {[regexp {f[0-9]*#} $tag] && ([lsearch -exact [$w.textarea tag names $index2] $tag] > -1)} { 
     #fix feature tags
      set ranges [$w.textarea tag ranges $tag]
      set name [lindex [$w.textarea tag bind $tag <<Metadata>>] 0]
      regsub f $tag fn fntag
      if {($operation == "split") || (($operation == "dialog") && ([tk_messageBox -message [mc {Should the feature %1$s be split into two features?} $name] -type yesno -icon question -title [mc {Insertion into feature}]] == "yes"))} {
        #split the tag
        #create new tag info
        set newtag "f$fea_info($w,count)#"
        lappend tags_added $newtag
        lappend tags_modified $tag
        regsub f $newtag fn newfntag
        incr fea_info($w,count)
        foreach event [$w.textarea tag bind $tag] {
          $w.textarea tag bind $newtag $event [$w.textarea tag bind $tag $event]
        }
        $w.textarea tag configure $newtag -background [$w.textarea tag cget $tag -background]
        #set the tag ranges
        if {[set fnrange [$w.textarea tag ranges $fntag]] != {}} {
          #fn tag present
          if {$c} {
            #insertion at the start or end of circular sequence
            set fnstart [lindex $fnrange 0]
            set fnend [lindex $fnrange 1]
          } else {
            set fnstart [lindex $fnrange 2]
            set fnend [lindex $fnrange 3]
          }
          set startindex [lsearch -exact $ranges $fnstart]
          set endindex [lsearch -exact $ranges $fnend]
          #sputs $fnstart $fnend $startindex $endindex
          $w.textarea tag remove $fntag $fnstart $fnend
          if {[$w.textarea tag ranges $tag] == [$w.textarea tag ranges $fntag]} {
            $w.textarea tag delete $fntag
          }
          lappend tags_modified $fntag
          foreach {x y} [lrange $ranges $startindex $endindex] {
            $w.textarea tag remove $tag $x $y
            $w.textarea tag add $newtag $x $y
          }
          if {[expr {$endindex-$startindex}] > 1} {
            $w.textarea tag add $newfntag $fnstart $fnend
            lappend tags_added $newfntag
          }
        } else {
          #simple tag
          if {$c} {
            #insertion at the start or end of circular sequence
            $w.textarea tag remove $tag [lindex $ranges 0] [lindex $ranges 1]
            $w.textarea tag add $newtag [lindex $ranges 0] [lindex $ranges 1]
          } else {
            $w.textarea tag remove $tag [lindex $ranges 2] [lindex $ranges 3]
            $w.textarea tag add $newtag [lindex $ranges 2] [lindex $ranges 3]
          }
        }
      } else {
        #make a gap in the feature
        if {[set fnrange [$w.textarea tag ranges $fntag]] != {}} {
          #fn tag exists
          if {$c} {
            #insertion at the start or end of circular sequence
            $w.textarea tag add $fntag $index1 end-1c
            $w.textarea tag add $fntag 1.0 $index2
          } else {
            $w.textarea tag add $fntag $index1 $index2
          }
        } else {
          #create fntag
          lappend tags_added $fntag
          if {$c} {
            #insertion at the start or end of circular sequence
              $w.textarea tag add $fntag 1.0 [lindex $ranges 1]
              if {[llength $ranges] > 2} {
                $w.textarea tag add $fntag [lindex $ranges 2] end-1c
              }
          } else {
            if {[lsearch $ranges $index2] == 4} {
              #tag through origin
              $w.textarea tag add $fntag [lindex $ranges 0] [lindex $ranges 1]
              $w.textarea tag add $fntag [lindex $ranges 2] [lindex $ranges 5]
            } else {
              $w.textarea tag add $fntag [lindex $ranges 0] [lindex $ranges 3]
              if {[llength $ranges] > 4} {
                $w.textarea tag add $fntag [lindex $ranges 4] [lindex $ranges 5]
              }
            }
          }
        }
      }
      #sputs $tag [$w.textarea tag ranges $tag] [$w.textarea tag ranges $fntag]
    } elseif  {[regexp {fn[0-9]*#} $tag] && ([lsearch -exact [$w.textarea tag names $index2] $tag] > -1)} {
      #fix fn tags without f tags (gapped at insertion)
      regsub fn $tag f ftag
      if {([lsearch -exact [$w.textarea tag names $index1] $ftag] == -1) || ([lsearch -exact [$w.textarea tag names $index2] $ftag] == -1)} {
        if {$operation != "split"} {
          #expand gaps
          if {$c} {
            $w.textarea tag add $tag 1.0 $index2
            $w.textarea tag add $tag $index1 end-1c
          } else {
            $w.textarea tag add $tag $index1 $index2
          }
        } else {
          #split features that are gapped at insertion point
          set ranges [$w.textarea tag ranges $ftag]
          set fnranges [$w.textarea tag ranges $tag]
          set newtag "f$fea_info($w,count)#"
          incr fea_info($w,count)
          foreach event [$w.textarea tag bind $tag] {
            $w.textarea tag bind $newtag $event [$w.textarea tag bind $tag $event]
          }
          $w.textarea tag configure $newtag -background [$w.textarea tag cget $tag -background]
          lappend tags_added $newtag
          lappend tags_modified $ftag $tag
          if {$c} {
            #insertion at origin
            $w.textarea tag remove $tag [lindex $fnranges 2] end
            $w.textarea tag remove $ftag [lindex $fnranges 2] end
            $w.textarea tag remove $tag 1.0 [lindex $ranges 0]

            set newranges [lrange $ranges [lsearch $ranges [lindex $fnranges 2]] end]
            foreach {r1 r2} $newranges {
              $w.textarea tag add $newtag $r1 $r2
            }
            if {[llength $newranges]  > 2} {
              regsub f $newtag fn newfntag
              $w.textarea tag add $newfntag [lindex $newranges 0] [lindex $newranges end]
              lappend tags_added $newfntag 
            }

            if {[llength [$w.textarea tag ranges $ftag]] == 2} {
             $w.textarea tag remove $tag 1.0 end
            }
            
          } else {
            #split the feature at the insertion point 
            set splitindex2 1.0
            foreach r $ranges {
              if {[$w.textarea compare $r < $index1]} {
                set splitindex1 $r
              } elseif {[$w.textarea compare $r > $index2] && ($splitindex2 == 1.0)} {
                set splitindex2 $r
              } 
            }
            $w.textarea tag remove $tag $splitindex1 $splitindex2
            $w.textarea tag remove $ftag [lindex $fnranges 2] [lindex $fnranges 3]
            $w.textarea tag remove $tag [lindex $fnranges 2] [lindex $fnranges 3]
            if {[$w.textarea compare $index1 < [lindex $fnranges 2]]} {
              set newranges [lrange $ranges $splitindex2 [lsearch $ranges [lindex $fnranges 3]]]
            } else {
              set newranges [lrange $ranges [lsearch $ranges [lindex $fnranges 2]] $splitindex1]
            }
            foreach {r1 r2} $newranges {
              $w.textarea tag add $newtag $r1 $r2
            }
            if {[llength $newranges]  > 2} {
              regsub f $newtag fn newfntag
              $w.textarea tag add $newfntag [lindex $newranges 0] [lindex $newranges end]
              lappend tags_added $newfntag 
            }
            if {(([llength $fnranges] == 6) && ([llength [$w.textarea tag ranges $ftag]] == 4)) || ([llength [$w.textarea tag ranges $ftag]] == 2)} {
             $w.textarea tag remove $tag 1.0 end
            }
          }
        }
      }
    }
  }
}

#######
## delete text from index to del_index, then add text with tags (allows undo)
#######
proc register_undo {w type {args [list]} {label ""} {direction Undo}} {
  global info

  if {$type != "cant"} {
    set info($w,undo) [list $type $args $direction]
    $w.menubar.edit entryconfigure 0 -label "[mc $direction] [mc $label]" -state normal
  } else {
    set info($w,undo) [list]
    $w.menubar.edit entryconfigure 0 -label "[mc {Can't Undo}] [mc $label]" -state disabled
  }
}

#######
## uses info($w,undo) to undo the last edit
#######
proc undo {w} {
  global info

  if {$info($w,undo) != {}} {
  set type [lindex $info($w,undo) 0]
  set args [lindex $info($w,undo) 1]
  set direction [lindex $info($w,undo) 2]
  switch $type {
    rev_com {
      #format: first, last, cleanup
      set first [lindex $args 0]
      set last [lindex $args 1]
      set tag_cleanup [lindex $args 2]

      if {($first != 1.0) || ($last != [$w.textarea index end-1c])} {
        select_region $w $first $last
      }
      rev_com_window $w [expr {($direction == "Undo")?"Redo":"Undo"}]
      $w.textarea see insert
      #tag_cleanup_undo $w $tag_cleanup
    }
    change_case {
      #format: first, last, action
      set first [lindex $args 0]
      set last [lindex $args 1]
      set action [lindex $args 2]

      if {($first != 1.0) || ($last != [$w.textarea index end-1c])} {
        select_region $w $first $last
      }
      if {$action == "upper"} {
        set action lower
      } elseif {$action == "lower"} {
        set action upper
      }
      if {($direction == "Redo") || ($action == "exchange")} {
        change_case $w $action [expr {($direction == "Undo")?"Redo":"Undo"}]
      } else {
        change_case $w $action Redo [lindex $args 3]
      }
    }
    typing -
    delete -
    cut -
    paste {
      set first [lindex $args 0]
      set last [lindex $args 1]
      set label [lindex $args 2]
      set undo_text [lindex $args 3]
      set undo_tags [lindex $args 4]
      set tag_cleanup [lindex $args 5]
      set text_was_selected [lindex $args 6]
      set insert_at_end [lindex $args 7]
      text_ins_del $w $type $first $last $label $undo_text $undo_tags $tag_cleanup $text_was_selected $insert_at_end [expr {($direction == "Undo")?"Redo":"Undo"}]
    }
    set_origin {
      set index [lindex $args 0]
      select_region $w $index $index
      set_origin $w [expr {($direction == "Undo")?"Redo":"Undo"}]
    }
    toggle_circ {
      set tag_cleanup [lindex $args 0]
      toggle_circ $w [expr {($direction == "Undo")?"Redo":"Undo"}]
      #tag_cleanup_undo $w $tag_cleanup
    }

    default {

    }
  }
  }
}

#######
## delete text from first to last then insert undo_text with undo_tags at that location
#######
proc text_ins_del {w type first last label undo_text undo_tags tag_cleanup text_was_selected insert_at_end direction} {
  set new_undo_text [textarea_get $w.textarea $first $last]
  set new_undo_tags [get_tags $w.textarea [list $first $last]]
  textarea_delete $w.textarea $first $last
  textarea_insert $w.textarea $first $undo_text
  set ins_last [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index $first]] + [string length $undo_text]}]]
  put_tags $w.textarea [list $first $ins_last] $undo_tags forward 0
  if {$text_was_selected} {
    if {$insert_at_end} {
      select_region $w $first $ins_last
    } else {
      select_region $w $ins_last $first
    }
  } else {
    if {$insert_at_end} {
      $w.textarea mark set anchor $ins_last
      $w.textarea mark set tk::anchor$w.textarea $ins_last
      $w.textarea mark set insert $ins_last
    } else {
      $w.textarea mark set insert $first
      $w.textarea mark set anchor $first
      $w.textarea mark set tk::anchor$w.textarea $first
    }
  }
  #tag_cleanup_undo $w $tag_cleanup
  register_undo $w $type [list $first $ins_last $label $new_undo_text $new_undo_tags [feature_cleanup $w.textarea] $text_was_selected $insert_at_end] $label $direction
}

#######
## sends the scrollbar commands to both the index box and the text box
#######
proc vertscrollmanager {w args} {
  global info
  if {![winfo exists $w.textarea]} return
  if {[$w.textarea compare insert == end]} {
    $w.textarea mark set insert end-1c
  }
  if {[lindex $args 0] == "moveto"} {
    set numlines [expr {([ix2bp $w.textarea [$w.textarea index end-1c]]-1)/$info($w,textwidth)+1.0}]
    set numlines [expr {$numlines +1}]
    set toline [expr {int([lindex $args 1]*$numlines)}]
    $w.textarea yview [bp2ix $w.textarea [expr {$toline*$info($w,textwidth)+1}]]
    $w.vertindex yview "[expr {$toline+1}].0" 
  } else {
    eval [concat $w.textarea yview $args]
    eval [concat $w.vertindex yview $args]
  }
  vertindexbalancer $w
}


#######
##  makes the index numbers along the left edge and scrollbar match the text box
#######
proc vertindexbalancer {w } {
  global info

  if {![winfo exists $w]} {return}
  set textend [expr round (([ix2bp $w.textarea [$w.textarea index end-1c]]) / ($info($w,textwidth)) )+1]

  set vertend [lindex [split [$w.vertindex index end-1chars] .] 0]
  #$w.vertindex configure -state normal
  if {$vertend < $textend} { 
    set templist [list]
    while {$vertend < $textend} {
      #$w.vertindex insert end "\n [expr $vertend*($info($w,textwidth))+1]" allvertindex
      lappend templist [expr $vertend*($info($w,textwidth))+1]
      incr vertend
    }
    $w.vertindex insert end \n allvertindex
    $w.vertindex insert end [join $templist \n] allvertindex

  }
  if {($vertend > $textend) && ($vertend > 1)} {
    $w.vertindex delete [expr ($textend > 1 ? $textend : 1)+1].0 end
  }
  #$w.vertindex tag configure allvertindex -justify right
  #$w.vertindex configure -state disabled

  $w.vertindex yview moveto [lindex [$w.textarea yview] 0]
#make the scrollbar match the text view
  set numlines [expr {([ix2bp $w.textarea [$w.textarea index end-1c]] - 1)/$info($w,textwidth)+1}]
  ####bug on the mac- when scrolling to the end, the top line is not properly gridded- first line is at 5 pixels down (hopefully not more)
  set firstline [expr {([ix2bp $w.textarea [$w.textarea index @0,5]])/$info($w,textwidth)}]
  #set lastline [expr {([ix2bp $w.textarea [$w.textarea index "@0,[winfo height $w.textarea]"]])/$info($w,textwidth)+1}]
  set lastline $numlines
  #set mod [expr {[winfo height $w.textarea] % [font metrics dnafont -linespace]}]
  set mod [expr {[winfo height $w.textarea] % [font metrics dnafont -linespace]}]

  set wheight [expr {([winfo height $w.textarea]/ [font metrics dnafont -linespace])}]
  if {($lastline > $wheight)} {
    set lastline [expr {$wheight+$firstline}]
  }
  #if {$mod < 4} {incr numlines}

  if {($numlines == 0.0) || (($firstline == 0) && ($lastline == $numlines))} {
    if {[grid info $w.vertscroll] != {}} {
      grid remove $w.vertscroll
    }
  } else {
    if {[grid info $w.vertscroll] == ""} {
      grid configure $w.vertscroll
      update idletasks
    } 
    eval [concat $w.vertscroll set [expr {1.0*$firstline/$numlines}] [expr {1.0*$lastline/$numlines}]]
   #$w.infobox configure -text "$mod $lastline $numlines [expr {1.0*$firstline/$numlines}] [expr {1.0*$lastline/$numlines}]"
  }
}

##########
## change the vertical balance if width changes
##########
proc textarea_width_changed {w} {
  global info
  if {![winfo exists $w]} {return}
  if {[winfo width $w.textarea] <= 1} {
    set width $info(default_textarea_width)
  } else {  
    set width [expr {int(([winfo width $w.textarea]-4)/[lindex [wm grid $w] 2])}]
  }
  if {$width != $info($w,textwidth)} {
    set info($w,textwidth) $width
    $w.textarea mark set templinestart [$w.textarea index @0,0]
    reline $w.textarea [expr {$width}]
    ####redo the top and bottom numbers
    set iline ""
    set count 10
    while {[string length $iline] < $width} {
      set iline "$iline    *[string repeat " " [expr {5-[string length $count]}]]$count"
      incr count 10
    }

    $w.horzindex delete 1.0 end
    $w.horzindex insert 1.0 $iline

    $w.horzindex2 delete 1.0 end
    $w.horzindex2 insert 1.0 $iline

    ####redo the left side numbers
    $w.vertindex delete 2.0 end 
  }
  vertindexbalancer $w
}

##########
## sets the selection location info for the textbox (start and end of selection)
##########
proc selection_manager {w} {
  global info

  if {![winfo exists $w]} {return}
  $w.textarea tag remove tempsel 1.0 end

  if {[$w.textarea compare insert == end]} {
    $w.textarea mark set insert end-1c
  }
  if {[$w.textarea tag names end] == "sel"} {
    $w.textarea tag remove sel end 
  }
  $w.infoframe.totallen configure -text [ix2bp $w.textarea [$w.textarea index end-1c]]
  if {[$w.textarea tag ranges sel] == ""} {
    $w.infoframe.startlabel configure -text [mc "insert@"]
    set first [expr {[ix2bp $w.textarea [$w.textarea index insert]]+1}]
    $w.infoframe.start configure -text "$first\<[expr {($first-1) % 3}]>"
    if {$info($w,insert_loc) != $first} {
      set info($w,insert_loc) $first
      set info($w,sel_start2) $first
      set info($w,sel_end2) $first
    }
    if {($info($w,sel_start) != 1) || ($info($w,sel_end) != [ix2bp $w.textarea [$w.textarea index end-1c]])} {
      set info($w,sel_start) 1
      set info($w,sel_end) [ix2bp $w.textarea [$w.textarea index end-1c]]
    }
    $w.infoframe.sellenlabel configure -text ""
    $w.infoframe.sellen configure -text ""
    $w.infoframe.endlabel configure -text ""
    $w.infoframe.end configure -text ""
    $w.infoframe.orf configure -text ""
    $w.infoframe.orflabel configure -text ""
    $w.infoframe.tm configure -text ""
    $w.infoframe.tmlabel configure -text ""
    $w.infoframe.gc configure -text ""
    $w.infoframe.gclabel configure -text ""
    $w.infoframe.trans configure -text ""
  } else {
    if {[$w.textarea index sel.last] == [$w.textarea index end]} {
      $w.textarea tag remove sel end-1c end
    }
    $w.textarea tag add tempsel sel.first sel.last
    $w.textarea tag lower tempsel sel
    $w.infoframe.startlabel configure -text [mc "Start"]
    set first [expr {1+[ix2bp $w.textarea [$w.textarea index sel.first]]}]
    set last [expr {[ix2bp $w.textarea [$w.textarea index sel.last]]}]
    $w.infoframe.start configure -text "$first\<[expr {($first-1) % 3}]>"
    $w.infoframe.sellenlabel configure -text [mc "Length"]
    $w.infoframe.endlabel configure -text [mc "End"]
    $w.infoframe.end configure -text "$last\<[expr {($last-1) % 3}]>"
    $w.infoframe.sellen configure -text "[expr {$last-$first+1}]\<[expr {($last-$first+1) % 3}]>"
    if {$info($w,insert_loc) != [expr {[ix2bp $w.textarea [$w.textarea index insert]]+1}]} {
      set info($w,insert_loc) [expr {[ix2bp $w.textarea [$w.textarea index insert]]+1}]
    }
    if {($info($w,sel_start2) != $first) || ($info($w,sel_end2) != $last)} {
      set info($w,sel_start) $first
      set info($w,sel_end) $last
      set info($w,sel_start2) $first
      set info($w,sel_end2) $last
    }
    $w.infoframe.orflabel configure -text [mc "ORF"]
    set selection [textarea_get $w.textarea sel.first sel.last]
    if {[regexp -nocase "^(atg)" $selection] == 1} {
      set orftemp "M"
    } else {
      set orftemp ""
    }
    if {[regexp -nocase -indices "^(...)*?(taa|tag|tga)" $selection found] == 1} {
      if {[expr [string length $selection]- [lindex $found 1]] < 4 } {
        append orftemp " *"
      } else {
        append orftemp "---"
      }
    }
    $w.infoframe.orf configure -text $orftemp
    $w.infoframe.tmlabel configure -text "Tm"
    if {[string is double [set tm [Tm $selection $info(primer_dna) $info(primer_salt)]]]} {
      $w.infoframe.tm configure -text "[format %2.0f $tm]C"
    } else {
      $w.infoframe.tm configure -text "$tm"
    }
    $w.infoframe.gclabel configure -text "%GC"
    $w.infoframe.gc configure -text "[format %2.0f [GC% $selection]]%"

    if {[string length $selection] > 144} {
        $w.infoframe.trans configure -text "[translate [string range $selection 0 59]]...[translate [string range $selection end-[expr {([string length $selection] % 3) + 59}] end-[expr {[string length $selection] % 3}]]]"
    } else {
      $w.infoframe.trans configure -text [translate $selection]
    }
  }
  mouseover_info $w [$w.textarea index insert]
}

#########
## manages all key press events in the textbox
#########
proc keyevent_manager {w modifier k} { 
  global info toolbar_images
  set k [string map {asterisk *} $k]
  #$w.infobox configure -text "$modifier $k" ;#this let's you see the keypress keysyms
  switch $modifier {
    None {
      if {([string length $k] == 1)} {set k [string map $info(keysubstmap) $k]}
      if {([string length $k] == 1) && ([regexp  "\[$info(allowedkeys)\]" $k] == 1) && (![file_lock_check $w])}  {
        if {[llength [$w.textarea tag ranges sel]] > 0} {
          set undo_text [textarea_get $w.textarea sel.first sel.last]
          set undo_tags [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]]]
          set insert_at_end [expr {[$w.textarea index sel.last] == [$w.textarea index insert]}]
          textarea_delete $w.textarea sel.first sel.last
          set text_was_selected 1
        } else {
          set undo_text ""
          set undo_tags {}
          set insert_at_end 1
          set text_was_selected 0
        }
        if {[$w.textarea index insert] > 1.0} {
          textarea_insert $w.textarea [$w.textarea index insert] $k {}
          $w.textarea mark set anchor insert
          $w.textarea mark set tk::anchor$w.textarea insert
        } else {
          textarea_insert $w.textarea 1.0 $k {}
          $w.textarea mark set anchor 1.1
          $w.textarea mark set tk::anchor$w.textarea 1.1
          $w.textarea mark set insert 1.1
        }
        if {[$w.textarea compare insert == 1.1] && ($info($w,circular) == "circular")} {
          tag_split $w [$w.textarea index end-2chars] 1.1
        } elseif {[$w.textarea compare insert == end-1c] && ($info($w,circular) == "circular")} {
          tag_split $w [$w.textarea index insert-2chars] 1.0
        } else {
          tag_split $w [$w.textarea index insert-2chars] [$w.textarea index insert]
        }
        $w.textarea see insert
        register_undo $w typing [list [$w.textarea index insert-1chars] [$w.textarea index insert] "Typing" $undo_text $undo_tags [feature_cleanup $w.textarea] $text_was_selected $insert_at_end] "Typing" Undo
        set info($w,scanned) 0
        set info($w,saved) 0
        if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
        unlink_analysis_window $w
      } else {

        switch $k {
          "BackSpace" {
            if {![file_lock_check $w]} {
              if {[llength [$w.textarea tag ranges sel]] > 0} {
                set undo_text [textarea_get $w.textarea sel.first sel.last]
                set undo_tags [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]]]
                set insert_at_end [expr {[$w.textarea index sel.last] == [$w.textarea index insert]}]
                textarea_delete $w.textarea sel.first sel.last
                register_undo $w delete [list [$w.textarea index insert] [$w.textarea index insert] "Delete" $undo_text $undo_tags [feature_cleanup $w.textarea] 1 $insert_at_end] "Delete" Undo
                set info($w,scanned) 0
                set info($w,saved) 0
                if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
                unlink_analysis_window $w
              } elseif {[$w.textarea index insert] != 1.0} {
                set undo_text [textarea_get $w.textarea [$w.textarea index insert-1chars] [$w.textarea index insert]]
                set undo_tags [get_tags $w.textarea [list [$w.textarea index insert-1chars] [$w.textarea index insert]]]
                textarea_delete $w.textarea insert-1chars
                $w.textarea mark set anchor insert
                $w.textarea mark set tk::anchor$w.textarea insert
                $w.textarea see insert
                register_undo $w delete [list [$w.textarea index insert] [$w.textarea index insert] "Delete" $undo_text $undo_tags [feature_cleanup $w.textarea] 0 1] "Delete" Undo
                set info($w,scanned) 0
                set info($w,saved) 0
                if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
                unlink_analysis_window $w
              }
            }
          } 
          "Delete" {
            if {![file_lock_check $w]} {
              if {[llength [$w.textarea tag ranges sel]] > 0} {
                set undo_text [textarea_get $w.textarea sel.first sel.last]
                set undo_tags [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]]]
                set insert_at_end [expr {[$w.textarea index sel.last] == [$w.textarea index insert]}]
                textarea_delete $w.textarea sel.first sel.last
                register_undo $w delete [list [$w.textarea index insert] [$w.textarea index insert] "Delete" $undo_text $undo_tags [feature_cleanup $w.textarea] 1 $insert_at_end] "Delete" Undo
                set info($w,scanned) 0
                set info($w,saved) 0
                if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
                unlink_analysis_window $w
              } elseif {[$w.textarea index insert] != [$w.textarea index "1.0 lineend"]} {
                set undo_text [textarea_get $w.textarea [$w.textarea index insert] [$w.textarea index insert+1chars]]
                set undo_tags [get_tags $w.textarea [list [$w.textarea index insert] [$w.textarea index insert+1chars]]]
                textarea_delete $w.textarea insert
                $w.textarea mark set anchor insert+1chars
                $w.textarea mark set tk::anchor$w.textarea insert+1chars
                $w.textarea see insert
                register_undo $w delete [list [$w.textarea index insert] [$w.textarea index insert] "Delete" $undo_text $undo_tags [feature_cleanup $w.textarea] 0 0] "Delete" Undo
                set info($w,scanned) 0
                set info($w,saved) 0
                if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
                unlink_analysis_window $w
              }
            }
          }
          "space" {
            sputs kem space
            return
          } 
          default {
            #sputs "unknown key:$k"
            return
	    }
        } 
      } 
    } 
    Control {
      switch -glob -- $k {
        Control_L {return}
        Control_R {return}
        Meta_L {return}
        Alt_L {return}
        [Zz] {undo $w}
        [xX] {clip_cut_copy $w cut}
        [cC] {clip_cut_copy $w copy}
        [vV] {clip_paste $w}
        [aA] {select_all $w}
        [kK] {feature_scan $w}
        [jJ] {jump_to $w}
        [nN] {create_window; return}
        [oO] {open_file_dialog; return}
        [dD] {duplicate_window $w selection; return}
        [sS] {save_file $w "Save"; return}
        [wW] {closewindow $w; return}
        [iI] {if {$info($w,circular)== "circular"} {set_origin $w} else {bell}}
        [uU] {#toggle_circ $w}
        minus {change_case $w lower}
        plus {change_case $w upper}
        greater {next_ORF $w}
        less {next_ORF $w reverse}

        [fF] {find_dialog $w}
        [gG] {do_find $w again}
        [rR] {enz_digest $w $info(enz_currently_selected) $info(analyze_selection)}
        [eE] {enzyme_selection_dialog $w}
        [yY] {enz_graphic_map $w}
        [tT] {translation_window $w}
        [lL] {align_dialog2 $w}
        [bB] {NCBI_Blast $w}
        [qQ] {close_all_windows; return}
        [0]  {if {[info commands console] != ""} {
               console show
               uplevel #0 {set w [lsearch -regexp -inline [winfo children .] {.dna_window[0-9]+}]
                 sputs "w= $w"
               }
              }
             }
        [1] {calc}
        slash {rev_com_window $w}
        equal {change_case $w exchange}
        comma {configure_preferences $w}
        period {add_sel_feature_file $w}
        [hH] {if {([lsearch -glob [info loaded] "*tclCarbonHICommand.dylib*"] > -1)} {
                carbon::processHICommand hide {}
                }
             }
        [mM] {if {[tk windowingsystem] == "aqua"} {
               catch {aqua_minimize $w}
               }
             }
        quoteleft {if {[tk windowingsystem] == "aqua"} {
                     catch {raise [lindex [wm stackorder .] 0]}
                   }
             }
	}
    }
    ShiftControl {
      switch -glob -- $k {
        Control_L {return}
        Shift_L {return}
        Control_R {return}
        Shift_R {return}
        Meta_L {return}
        Alt_L {return}
        [xX] {clip_cut_copy $w cut rev-com}
        [cC] {clip_cut_copy $w copy rev-com}
        [Vv] {clip_paste $w rev-com}
        minus {change_case $w lower}
        plus {change_case $w upper}
        greater {next_ORF $w}
        less {next_ORF $w reverse}
        [aA] {select_from_to $w}
        [dD] {duplicate_window $w all; return}
        [kK] {feature_clear $w}
        [rR] {enz_digest_partial_dialog $w}
        [tT] {enz_text_map $w}
        [yY] {enz_graphic_map $w {==1}}
        [eE] {set info(analyze_selection) [expr {($info(analyze_selection)=="all")?"selection":"all"}]}
	}

    }
  }  
  vertindexbalancer $w
  selection_manager $w
  #$w.infobox configure -text "$modifier $k" ;#this let's you see the keypress keysyms
}


###########
## limited control keys for the comment window
###########
proc comment_keyevent_manager {w modifier k} {
  global info
  switch $modifier {
    Control {
      switch -glob $k {
        Control_L {return}
        Control_R {return}
        [cC] {event generate $w.comframe.comtextframe.text <<Copy>>}
        [xX] {event generate $w.comframe.comtextframe.text <<Cut>>}
        [vV] {event generate $w.comframe.comtextframe.text <<Paste>>}
        [aA] {$w.comframe.comtextframe.text tag add sel 1.0 end-1chars; $w.comframe.comtextframe.text mark set insert end; $w.comframe.comtextframe.text mark set anchor insert; $w.comframe.comtextframe.text mark set tk::anchor$w.textarea insert}
        [nN] {create_window; return}
        [oO] {open_file_dialog; return}
        [dD] {duplicate_window $w selection; return}
        [sS] {save_file $w "Save"; return}
        [wW] {closewindow $w; return}
        [fF] {find_dialog $w}
        [gG] {do_find $w again}
        [qQ] {close_all_windows; return}
        [0]  {if {[info commands console] != ""} {
               console show
               uplevel #0 {set w [lsearch -regexp -inline [winfo children .] {.dna_window[0-9]+}]
                 sputs "w= $w"
               }
              }
             }
	}
    }
    ShiftControl {
      switch -glob $k {
        Control_L {return}
        Shift_L {return}
        Control_R {return}
        Shift_R {return}
        [dD] {duplicate_window $w all; return}
	}

    }
  }  
}

###########
## resize callback for the comment window
###########
proc comment_resize {t y} {
  set deltaY [expr {$y-[bind $t <<resizeY>>]}]
  set w [winfo toplevel $t]
  set newHeight [expr {[bind $t <<resizeHeight>>] + $deltaY / [ttk::style configure Treeview -rowheight]}]
  if {[$t cget -height] != $newHeight && $newHeight > 2} {
    $t configure -height $newHeight
  }
}

###########
## return the locked state of a file (when attempting to change contents)
###########
proc file_lock_check {w {message 1}} {
  global info toolbar_images


  set info($w,locked) [expr {[file isfile $info($w,filename)] && ![file writable $info($w,filename)]}]
  if {[winfo class $w.infoframe.locked] ne "TCheckbutton"} {
    $w.infoframe.locked configure -image $toolbar_images([expr {$info($w,locked)?"locked":"unlocked"}])
  }
  if {$message && $info($w,locked)} {
    tk_messageBox -message [mc "Sorry, the file is locked"] -icon warning -type ok
  }
  return $info($w,locked)
}

###########
## return the locked state of a file
###########
proc file_islocked {w} {
  global info

  set info($w,locked) [expr {[file isfile $info($w,filename)] && ![file writable $info($w,filename)]}]
  return $info($w,locked)
}

###########
## toggle the locked state of a file
###########
proc toggle_locked {w} {
  global info tcl_platform toolbar_images


  if {[file isfile $info($w,filename)]} {
    if {$tcl_platform(platform) == "windows"} {
      file attributes $info($w,filename) -readonly [expr {![file attributes $info($w,filename) -readonly]}]

    } elseif {$tcl_platform(platform) == "unix"} {
      if {[catch {file attributes $info($w,filename) -permissions [expr {([file attributes $info($w,filename) -permissions] ^ 000200)}]} err]} {
        tk_messageBox -type ok -message "[mc "Can't set file permissions."] $err" -icon error
      }
    }
    set info($w,locked) [expr {![file writable $info($w,filename)]}]
  } else {
    if {$info($w,filename) == ""} {
      if {[tk_messageBox -title [mc "File is not saved."] -message "[mc {You can't lock a file until it is saved. Do you want to save this file now?}]" -type "yesno" -icon question -default no] == "no"} {
        set info($w,locked) 0
      } else {
        save_file $w "Save_as"
      }
    } else {
      if {[tk_messageBox -title [mc "File doesn't exist."] -message "[mc {The file %1$s no longer exists on the disk. Do you want to save this file now?} $info($w,filename)]" -type "yesno" -icon question -default no] == "no"} {
        set info($w,locked) 0
      } else {
        save_file $w "Save_as"
      }
    }
  }
  if {[winfo class $w.infoframe.locked] ne "TCheckbutton"} {
    $w.infoframe.locked configure -image $toolbar_images([expr {$info($w,locked)?"locked":"unlocked"}])
  }
}

###########
## save a file
###########
proc save_file {w mode {type ""} {filename ""}} {
global info toolbar_images
global tcl_platform

  set focus_win [focus]
  if {$focus_win == ""} {set focus_win .}

  while {(![file isdirectory $info(default_dnadir)]) } {
    set info(default_dnadir) [file dirname $info(default_dnadir)]
    if {[file dirname $info(default_dnadir)] == $info(default_dnadir)} {
      set info(default_dnadir) [valid_default_dir]
    }
  }

  if {$type == ""} {
    set type $info(default_file_format)
  }

  if {($mode != "Save_as") && ($info($w,filetype) != "None") && ($info($w,filetype) != $type) && $info(save_file_format_warning)} {
    set response [tk_messageBox -title [mc "Changing File Format"] -message "$info($w,filename) \n[mc "File is currently of filetype:%1\$s.\nIt will be saved as type: %2\$s.\n Do you want to change the file name?" $info($w,filetype) $type]" -type "yesno"  -icon warning -default no]
    if {$response == "yes"} { 
      set mode "Save_as"
    }
  }

  if {($mode == "Save_as") || ($info($w,filename) == "")} {
    if {$filename eq ""} {
    set initialdir [file dirname $info($w,filename)]
      if {($info($w,filename) == "") || (![file isdirectory $initialdir])} {set initialdir $info(default_dnadir)}
      set filename [tk_getSaveFile -title [mc "Save File As..."] -initialfile [file tail $info($w,filename)] -initialdir $info(default_dnadir) -parent $focus_win -defaultextension $info(default_file_extension) -filetypes { {"All files" {"*.*"}} {"ApE" {.str .ape .dna .seq .gb}}}]
      focus $focus_win
    }
  } else {
    set filename $info($w,filename)
  }
  if {$filename == ""} {return 0}
  if {[file extension $filename] == ""} {set filename "$filename$info(default_file_extension)"}

  while {!$info(lock_bug) && (([file isfile $filename] && ![file writable $filename]) && ($filename != ""))} {
    set response [tk_messageBox -title [mc "File is not writable."] -message "$filename \n[mc {File is locked. Do you want to unlock it (Yes), save it with a different name (No) or cancel save (Cancel?)}]" -type "yesnocancel"  -icon warning -default no]
    if {$response == "yes"} {
      set info($w,filename) $filename
      toggle_locked $w
      if {![file writable $filename]} {
        set filename [tk_getSaveFile -title [mc "Sorry, couldn't unlock. Save File As..."] -initialdir $info(default_dnadir) -parent $focus_win -defaultextension $info(default_file_extension) -filetypes { {"All files" {"*.*"}} {"strider" {.str .test}} {"genbank" {.gb}} {"fasta" {.fasta}}}]
        set info($w,filename) $filename
      }
    } elseif {$response == "no"} {
      set filename [tk_getSaveFile -title [mc "Save File As..."] -initialdir $info(default_dnadir) -parent $focus_win -defaultextension $info(default_file_extension) -filetypes { {"All files" {"*.*"}} {"strider" {.str .test}} {"genbank" {.gb}} {"fasta" {.fasta}}}]
    } else {
      set filename ""
    }
  }
  if {$filename == ""} {return 0}

  if {[file extension $filename] == ""} {set filename "$filename$info(default_file_extension)"}
  if {$type == "DNA Strider"} {
    ######write strider format
    if {$info($w,circular) == "circular"} {set topology 1} else {set topology 0}
    set dnalength [ix2bp $w.textarea [$w.textarea index end-1chars]]
    if {![catch {set fileid [open $filename w]} err_msg]} {
      fconfigure $fileid -translation binary
      puts -nonewline $fileid [binary format "cccx14cx10IIx60Ix12" 0 1 $topology $info($w,Dam_Dcm_methylated) $dnalength [expr {$info($w,startindex)-1}] [string length [$w.comframe.comtextframe.text get 1.0 end-1char]]]
      set text [textarea_get $w.textarea 1.0 end-1chars]
      regsub -all -nocase "n" $text "*" text
      puts -nonewline $fileid $text
      puts -nonewline $fileid [$w.comframe.comtextframe.text get 1.0 end-1char]
      close $fileid
      set info($w,filetype) "DNA Strider"
    } else {
      tk_messageBox -title [mc "File not savable"] -message $err_msg
    }

  } elseif {$type == "Genbank"} {
    #####write genbank format
    if {![catch {set fileid [open $filename w]} err_msg]} {
      puts $fileid [genbank_text $w 1]
      close $fileid
      set info($w,filetype) "Genbank"
    } else {
      tk_messageBox -title [mc "File not savable"] -message $err_msg
    }
  } elseif {$type == "FASTA"} {
    #####write FASTA format
    if {![catch {set fileid [open $filename w]} err_msg]} {
      puts $fileid ">[file rootname [file tail $filename]]"
      set text [textarea_get $w.textarea 1.0 end-1chars]
      puts $fileid $text
      close $fileid
      set info($w,filetype) "FASTA"
    } else {
      tk_messageBox -title [mc "File not savable"] -message $err_msg
    }
  } else {
    tk_messageBox -title [mc "Filetype not savable"] -message "I don't know how to save files in format:$type"
  }


  set info($w,saved) 1 
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 0 -titlepath $filename}
  set info($w,filename) $filename
  set info($w,win_title) [file tail $filename]
  if {!$info(lock_bug)} {
    set info($w,locked) [expr {[file isfile $info($w,filename)] && ![file writable $info($w,filename)]}]
  } else {
    set info($w,locked) 0
  }
  if {[winfo class $w.infoframe.locked] ne "TCheckbutton"} {
    $w.infoframe.locked configure -image $toolbar_images([expr {$info($w,locked)?"locked":"unlocked"}])
  }
  if {$info(dnadir_follows_open)} {
    set info(default_dnadir) [file dirname $filename]
  }
  wm title $w $info($w,win_title)
  set info(dnatitles_list) [list]
  foreach element $info(dnawindows_list) {
    lappend info(dnatitles_list) $info($element,win_title)
  }
  set info(open_previous) [linsert $info(open_previous) 0 $filename]
  update_windows_menu
  update_open_previous_menu
  return 1
}

###########
## return genbank file contents as text
###########
proc genbank_text {w {include_linked 0}} {
  global info

  set result ""
    set text [textarea_get $w.textarea 1.0 end-1chars]
    set locus_line [lindex $info($w,genbank_header_list) 1]
    if {![regexp {LOCUS       (.*) ([0-9]*) bp (   |ss-|ds-|ms-)(NA    |DNA   |RNA   |tRNA  |rRNA  |mRNA  |uRNA  |snRNA |snoRNA)[ ]*(linear  |circular|        )[ ]*([ A-Z]{3})[ ]*(..-...-....)} $locus_line x genbank_locus_name size stranded type circular genbank_division_code date] || $circular== "        "} {
      set genbank_locus_name ""
      set genbank_division_code ""
    }
    set genbank_locus_name [string trim $genbank_locus_name]
    if {$genbank_locus_name ==""} {set genbank_locus_name [file rootname [file tail $info($w,filename)]]}
    set genbank_locus_name [regsub -all {[^a-zA-Z0-9]} $genbank_locus_name _]
    if {$genbank_locus_name == ""} {set genbank_locus_name "New_DNA"}
    set genbank_locus_name [string range $genbank_locus_name 0 15]

    append result "[format "LOCUS       %-16s %+11s bp ds-DNA     %-8s %-3s %-11s" $genbank_locus_name [string length $text] $info($w,circular) $genbank_division_code [string toupper [clock format [clock seconds] -format "%d-%h-%Y"]]]\n"


   #if {$info(genbank_suppress_blank_fields)} {
   #   set temp_list [list]
   #   if {[lindex $info($w,genbank_header_list) 0]  == "LOCUS       "} {
   #     lappend temp_list [lindex $info($w,genbank_header_list) 0] [lindex $info($w,genbank_header_list) 1]
   #   }
   #   foreach {xx yy} $info($w,genbank_header_list) {
   #     if {($yy != "") && ($yy != ".")} {
   #       lappend temp_list $xx $yy
   #     }
   #   }
   #   set info($w,genbank_header_list) $temp_list
   # }


    ##strip any comment lines from the header (should be done in the genbank read, but just in case
    set header_list [list]
    foreach {type data} [lrange $info($w,genbank_header_list) 2 end] {
      if {$type != "COMMENT     "} {
        lappend header_list $type $data
      }
    }
    if {[$w.comframe.comtextframe.text get 1.0 end-1char] != ""} {
      foreach comm_line [split [$w.comframe.comtextframe.text get 1.0 end-1char] \n] {
        lappend header_list "COMMENT     " $comm_line
      }
    } else {
      lappend header_list "COMMENT     " ""
    }
  ##format each header field 
    foreach {type data} $header_list {
      if {(($data != "") && ($data != ".")) || (!$info(genbank_skip_blank))} {
        while {([string length $data] > 67) || ([string first \n $data] > -1)} {
          if {([set split [string first \n $data]] == -1) || ($split > 67)} {
            set split [string last " " $data 67]
          }
          if {$split < 0} {set split 67}
          set firstline [regsub -all {[ ]*$} [string range $data 0 [expr {$split-1}]] ""]
          set data [regsub {^[ ]*[\n]?} [string range $data $split end] ""]
          append result "$type$firstline\n"
          set type "            "
        } 
        append result "$type$data\n"
      }
    }

    append result "COMMENT     ApEinfo:methylated:$info($w,Dam_Dcm_methylated)\n"

    ##ADD FEATURES HERE
    set temp_fea_list [list]
    foreach tag [$w.textarea tag names] {
      if {([regexp {f[0-9]+#} $tag]) && ([llength [$w.textarea tag ranges $tag]] > 1)} {
        lappend temp_fea_list $tag
      }
    }
    #set temp_fea_list [lsort -index 0 -integer $temp_fea_list]
    if {[llength $temp_fea_list] > 0} {
      append result "FEATURES             Location/Qualifiers\n"
    }
    set used_labels [list]
    foreach tag $temp_fea_list {
##metadata here
      set metadata [$w.textarea tag bind $tag <<Metadata>>]

      set loc [feature_coords_text $w $tag]
      if {[string first , $loc] > -1} {
        set loc "join($loc)"
      }
      if {[lindex $metadata 3]} {
        set loc "complement($loc)"
      }
      ##put feature definition line
      ##first the type and location indexes
      if {[string length $loc] <= 58} {
        append result "[format "     %-16s%s" [lindex $metadata 2] $loc]\n"
      } else {
        append result "[format "     %-16s%s" [lindex $metadata 2] [string range $loc 0 [string last "," $loc 58]]]\n"
        set loc [string range $loc [expr {[string last "," $loc 58]+1}] end]
        while {[string length $loc] > 58} {  
          set split [string last "," $loc 58]
          if {$split < 0} {set split 58}
          set firstline [string range $loc 0 $split]
          set loc [string range $loc [expr {$split+1}] end]
          append result "                     $firstline\n"
        }
        append result "                     $loc\n"
      }


      ##put sub-data lines
      set feature_comment [lindex $metadata 4]
        ##if feature comment isn't in a paired format, make it a note
      if {([llength $feature_comment] == 1) || (([llength $feature_comment] % 2) != 0)} {
        set feature_comment [list note $feature_comment]
      }
      ##add label and colors data
      if {1} {
        set new_label [lindex $metadata 0]
        set label_i 1
        set base_label $new_label
        while {[lsearch -exact $used_labels $new_label] > -1} {
          set new_label "$base_label\($label_i)"
          incr label_i
        }
        lappend feature_comment label $new_label
        if {($base_label!= $new_label) && !$info(genbank_strict_genbank)} {
          lappend feature_comment ApEinfo_label [lindex $metadata 0] 
        }
        lappend used_labels $new_label
      }
      if {!$info(genbank_strict_genbank)} {
        if {[lindex [$w.textarea tag bind $tag <<Revcolors>>] 0] != ""} {
          lappend feature_comment ApEinfo_fwdcolor [lindex [$w.textarea tag bind $tag <<Revcolors>>] 0]
        }
        if {[lindex [$w.textarea tag bind $tag <<Revcolors>>] 1] != ""} {
          lappend feature_comment ApEinfo_revcolor [lindex [$w.textarea tag bind $tag <<Revcolors>>] 1]
        }
        if {[lindex $metadata 1] != ""} {
          lappend feature_comment ApEinfo_graphicformat [lindex $metadata 1]
        }
      }
      foreach {type data} $feature_comment {
        set data "/$type=$data"
        while {[string length $data] > 58} {
          if {([set split [string first \n $data]] == -1) || ($split > 58)} {
            set split [string last " " $data 58]
          }
          if {$split < 0} {set split 58}
          set firstline [regsub -all {[ ]*$} [string range $data 0 [expr {$split-1}]] ""]
          set data [regsub {^[ ]*[\n]?} [string range $data $split end] ""]
          append result "                     $firstline\n"
        }
        append result "                     $data\n"
      }
    }

    append result "ORIGIN\n"

    ##sequence output
    set i 0
    while {$i < [string length $text]} {
      append result "[format "%+9s %s %s %s %s %s %s" [expr {$i+1}] [string range $text $i [expr {$i+9}]] [string range $text [expr {$i+10}] [expr {$i+19}]] [string range $text [expr {$i+20}] [expr {$i+29}]] [string range $text [expr {$i+30}] [expr {$i+39}]] [string range $text [expr {$i+40}] [expr {$i+49}]] [string range $text [expr {$i+50}] [expr {$i+59}]]]\n"
      incr i 60
    }
    append result "//"

  if {$include_linked && [info exists info($w,linked_abi_list)] && ($info($w,linked_abi_list) != {})} {
    for {set i 0} {$i < [llength $info($w,linked_abi_list)]} {incr i} {
      append result \n \n [encode_abi $w $i]
    }
  }
  return $result
}

###########
## return NCBI bankit feature table as text
## http://www.ncbi.nlm.nih.gov/WebSub/html/help/feature-table.html
###########
proc bankit_text {w} {
  global info

    set temp_fea_list [list]
    foreach tag [$w.textarea tag names] {
      if {([regexp {f[0-9]+#} $tag]) && ([llength [$w.textarea tag ranges $tag]] > 1)} {
        lappend temp_fea_list $tag
      }
    }
    #set temp_fea_list [lsort -index 0 -integer $temp_fea_list]
    if {[llength $temp_fea_list] == 0} {
      return ""
    }

    set result ""
    foreach tag $temp_fea_list {
      set metadata [$w.textarea tag bind $tag <<Metadata>>]
      set loc [feature_coords_text $w $tag]
      regsub -all {\.\.} $loc {.} loc
      ##put sub-data lines
      set name  [lindex $metadata 0]
      set type  [lindex $metadata 2]
      set dir  [lindex $metadata 3]
      set feature_comment [lindex $metadata 4]
      set loc_list [split $loc ,]
      if {$dir} {
        set loc_list [lreverse $loc_list]
      }
      set l [split [lindex $loc_list 0] "."]
      if {$dir} {
        set l [lreverse $l]
      }
      append result "[lindex $l 0]\t[lindex $l 1]\t$type\n"

      foreach l [lrange $loc_list 1 end] {
        set l [split $l "."]
        if {$dir} {
          append result "[lindex $l 1]\t[lindex $l 0]\n"
        } else {
          append result "[lindex $l 0]\t[lindex $l 1]\n"
        }
      }
      append result "\t\t\tlabel\t$name\n"
    } 
  return $result

}

###########
## cut and copy  function
###########
proc clip_cut_copy {w {function copy} {direction normal}} {
  global info
  global tcl_platform


  if {($function == "cut") && [file_lock_check $w]} {return}
  if {[llength [$w.textarea tag ranges sel]] > 0} {
    clipboard clear 
    if {$direction == "rev-com"} {
      clipboard append -displayof $w [revcom [textarea_get $w.textarea sel.first sel.last]]
      set info(clipboard_text) [revcom [textarea_get $w.textarea sel.first sel.last]]
      set info(clipboard_tags) [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]] reverse]
    } else {
      clipboard append -displayof $w [textarea_get $w.textarea sel.first sel.last]
      set info(clipboard_text) [textarea_get $w.textarea sel.first sel.last]
      set info(clipboard_tags) [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]]]
    }
    if {$function == "cut"} {
      set undo_text [textarea_get $w.textarea sel.first sel.last]
      set undo_tags [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]]]
      set insert_at_end [expr {[$w.textarea index sel.last] == [$w.textarea index insert]}]
      textarea_delete $w.textarea sel.first sel.last
      register_undo $w cut [list [$w.textarea index insert] [$w.textarea index insert] "Cut" $undo_text $undo_tags [feature_cleanup $w.textarea] 1 $insert_at_end] "Cut" Undo
      set info($w,scanned) 0
      set info($w,saved) 0
      if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
      unlink_analysis_window $w
      vertindexbalancer $w
      selection_manager $w
    }
    if {($tcl_platform(platform) == "unix") && ([tk windowingsystem] != "aqua")} {
      if {$function == "copy"} {
        $w.textarea tag add tempsel sel.first sel.last
      }
      selection own -selection CUT_BUFFER0 $w
      selection own -selection CLIPBOARD $w
      if {$function == "copy"} {
        $w.textarea tag add sel tempsel.first tempsel.last
      }
      #warning_dialog "cutbuffer0 owned by:[selection own -displayof $w -selection CUT_BUFFER0]; primary oned by [selection own -displayof $w -selection CLIPBOARD]"
    }
  }
}

###########
## paste  function
###########
proc clip_paste {w {direction normal}} {
  global info text2
  global tcl_platform

#tk_messageBox -message "clip paste"
  if {($tcl_platform(platform) == "unix") && ([tk windowingsystem] != "aqua")} {
    if {[catch {set text [selection get -displayof $w -selection CLIPBOARD]}] != 0} {return}
  } else {
    if {[catch {set text [selection get -displayof $w -selection CLIPBOARD]}] != 0} {return}
  }

  if {[file_lock_check $w]} {return}

  if {[regexp {LOCUS[[:space:]]+(.*)[[:space:]]+([0-9]*) bp.*\n.*ORIGIN.*//} $text] || ([regexp {>.*\n[ACGTNBDHKMRSVWYacgtnbdhkmrsvwy]+} $text])} {
    paste_file $w $text
    return
  }
set text2 $text

  regsub -all {[[:space:]0-9]} $text "" text
  set text [atgcfilter $text $info(allowedkeys) 1]
  if {$direction == "rev-com"} {set text [revcom $text]}
  if {$text == ""} return
  
  

  if {[llength [$w.textarea tag ranges sel]] > 0} {
    set undo_text [textarea_get $w.textarea sel.first sel.last]
    set undo_tags [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]]]
    set insert_at_end [expr {[$w.textarea index sel.last] == [$w.textarea index insert]}]
    set text_was_selected 1
    textarea_delete $w.textarea sel.first sel.last
  } else {
    set undo_text ""
    set undo_tags {}
    set insert_at_end 1
    set text_was_selected 0
  }
###some sort of bug (maybe only on windows) when inserting at insert mark, if insert is at 1.0
  if {[$w.textarea compare insert == 1.0]} {
    $w.textarea mark set insert end-1c
    $w.textarea mark set anchor end-1c
    $w.textarea mark set tk::anchor$w.textarea end-1c
    textarea_insert $w.textarea 1.0 $text {}
    $w.textarea mark set insert [bp2ix $w.textarea [string length $text]]
    $w.textarea mark set anchor 1.0
    $w.textarea mark set tk::anchor$w.textarea 1.0
  } else {
    textarea_insert $w.textarea [$w.textarea index insert] $text {}
  }
  if {[$w.textarea compare insert == [bp2ix $w.textarea [string length $text]]] && ($info($w,circular) == "circular")} {
    tag_split $w [$w.textarea index end-2chars] [$w.textarea index insert]
  } elseif {[$w.textarea compare insert == end-1c] && ($info($w,circular) == "circular")} {
    tag_split $w [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index insert]]-[string length $text] -1}]] 1.0
  } else {
    tag_split $w [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index insert]]-[string length $text] -1}]] [$w.textarea index insert]
  }


  if {($direction == "rev-com") && ($text == [revcom $info(clipboard_text)])} {
    put_tags $w.textarea [list [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index insert]]-[string length $text]}]] [$w.textarea index insert]] $info(clipboard_tags) reverse
  } elseif {($direction != "rev-com") && ($text == $info(clipboard_text))} {
    put_tags $w.textarea [list [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index insert]]-[string length $text]}]] [$w.textarea index insert]] $info(clipboard_tags)
  } 

  register_undo $w paste [list [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index insert]]-[string length $text]}]] [$w.textarea index insert] "Paste" $undo_text $undo_tags [feature_cleanup $w.textarea] $text_was_selected $insert_at_end] "Paste" Undo
  set info($w,scanned) 0
  set info($w,saved) 0
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
  unlink_analysis_window $w
 
  select_region $w [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index insert]]-[string length $text]}]] insert
  vertindexbalancer $w
}

###########
## copy special (translated, reverse com, etc. function)
###########
proc clip_copy_special {w function {direction normal}} {
  if {[llength [$w.textarea tag ranges sel]] > 0} {
    clipboard clear 
    set temp_text [textarea_get $w.textarea sel.first sel.last]
    if {$direction == "rev_com"} {
      set temp_text [revcom $temp_text]
    }
    switch $function {
      upper {
        clipboard append -displayof $w [regsub -all {[^A-Z]} $temp_text ""]
      }
      translated {
        clipboard append -displayof $w [translate $temp_text]
      }
      translated_uc {
        clipboard append -displayof $w [translate [regsub -all {[a-z]} $temp_text ""]]
      }
      reverse {
        clipboard append -displayof $w [rev $temp_text]
      }
      complement {
        clipboard append -displayof $w [com $temp_text]
      }
    }
  }
}

###########
## update the copy special: copy feature text menu to list all features in $w
###########
proc update_copy_features_menu {w} {
}

###########
## copy special: copy feature text
###########
proc clip_copy_features_text {w tag} {

}


###########
## send out the cut buffer for unix pastes
###########
proc unix_cubuffer_handler {{offset 0} {maxchars 1000000}} {
  global info
  #sputs "$offset $maxchars"
  #sputs [string range $info(clipboard_text) $offset [expr {$offset+$maxchars-1}]]
  return [string range $info(clipboard_text) $offset [expr {$offset+$maxchars-1}]]
}

###########
## Paste buffer contained a complete file- save the file and open it
###########
proc paste_file {w text} {
  global info

  if {([regexp  {>([^\n]+)\n([ACGTNBDHKMRSVWYacgtnbdhkmrsvwy\n]+)} $text x name data])} {
    #processing for fasta format file
  } elseif {[regexp {LOCUS[[:space:]]+(.*)[[:space:]]+([0-9]+)[[:space:]]?bp} $text]} {
    if {![regexp {LOCUS       (.*) ([0-9]*) bp (   |ss-|ds-|ms-)(NA    |DNA   |RNA   |tRNA  |rRNA  |mRNA  |uRNA  |snRNA |snoRNA|dna   |rna   )[ ]*(linear  |circular|        )[ ]*([ A-Z]{3})[ ]*(..-...-....)} $text x name size stranded type circular div date]} {
      if {![regexp {LOCUS[[:space:]]+(.*)[[:space:]]+([0-9]+)[[:space:]]?bp} $text x name size]} {
        set name ""
      }
      regsub -all {[^a-zA-Z0-9]} $name _ name
    }
    #processing for genbank format file
  } else  {
    sputs unknown format
    return
  }

  set name [string trim $name " "]
  regsub -all {[\\:\./]} $name "_" name
  if {$name == ""} {set name [mc "Untitled"]}
  set filename [tk_getSaveFile -title "Save File from Clipboard" -parent $w  -initialfile "$name$info(default_file_extension)" -initialdir $info(default_dnadir) -defaultextension $info(default_file_extension) -filetypes {{"All files" {"*.*"}} {"ApE" {.str .ape .dna .seq .gb}}}]
  if {([file extension $filename] == "") && ($filename != "")} {set filename "$filename$info(default_file_extension)"}

  while {([file isfile $filename] && ![file writable $filename]) && ($filename != "") } {
    set response [tk_messageBox -title [mc "File is not writable."] -message "$filename \n[mc {File is locked. Do you want to unlock it (Yes), save it with a different name (No) or cancel save (Cancel?)}]" -type "yesnocancel"  -icon warning -default no]
    if {$response == "yes"} {
      set info($w,filename) $filename
      toggle_locked $w
      if {![file writable $filename]} {
        set filename [tk_getSaveFile -title [mc "Sorry, couldn't unlock. Save File As..."] -initialdir $info(default_dnadir) -parent .dialog -defaultextension $info(default_file_extension) -filetypes { {"All files" {"*.*"}} {"genbank" {.gb}}}]
        set info($w,filename) $filename
      }
    } elseif {$response == "no"} {
      set filename [tk_getSaveFile -title [mc "Save File As..."] -initialdir $info(default_dnadir) -parent .dialog -defaultextension $info(default_file_extension) -filetypes { {"All files" {"*.*"}} {"genbank" {.gb}}}]
    } else {
      set filename ""
    }
  }
  if {$filename == ""} {return}

  if {$info(dnadir_follows_open)} {
    set info(default_dnadir) [file dirname $filename]
  }

  set fid [open $filename w]
  puts $fid $text
  close $fid
  open_file $filename
}

###########
## get tags from a selection for storage
###########
#(list of tag data pairs siutable for array get; data = list of indices, list of properties, list of bindings, list of actions bound)
proc get_tags {text range {direction forward}} {
  set first [lindex $range 0]
  set first [$text index $first]
  set last [lindex $range 1]
  set last [$text index $last]

  set firstchar [ix2bp $text $first]
  set lastchar [ix2bp $text $last]

  foreach tagname [$text tag names $first] {
    set tags($tagname) $first
  }


  foreach {action tagname index} [$text dump -tag $first+1char $last+1chars] {
    lappend tags($tagname) $index
  }

  foreach tagname [$text tag names $last] {
    if {[lindex $tags($tagname) 0] != $last} {
      lappend tags($tagname) $last
    } else {
      array unset tags $tagname
    }
  }

  set result [list]

  foreach tagname [$text tag names] {
    if {[lsearch -exact [array names tags] $tagname] == -1} {continue}
    #converts 1.n indexes here by removing "1." from everything- instead needs to do ix2bp on each.
    #regsub -all {[0-9]*?\.} $tags($tagname) "" tags($tagname)
    set indexlist [list]
    foreach index $tags($tagname) {
      if {$direction == "forward"} {
        lappend indexlist [expr {[ix2bp $text $index] - $firstchar}]
      } else {
        set indexlist [linsert $indexlist 0 [expr {$lastchar - [ix2bp $text $index] }]]
      }
    }
    set formatlist [list [$text tag cget $tagname -background] [$text tag cget $tagname -foreground] [$text tag cget $tagname -font] [$text tag cget $tagname -underline]]
    set bindlist [$text tag bind $tagname]
    set actionlist [list]
    foreach binding $bindlist {
      lappend actionlist [$text tag bind $tagname $binding]
    }

    ###change the metadata and colors if the tags are getting reversed
    if {$direction == "reverse"} {
      #change the direction data in the Features metadata
      if {[set pos [lsearch $bindlist <<Metadata>>]] != -1} {
        set metadata [lindex $actionlist $pos]
        #set dir [lindex $metadata 3]
        set metadata [lreplace $metadata 3 3 [expr {![lindex $metadata 3]}]]
        set actionlist [lreplace $actionlist $pos $pos $metadata]
      }
      #change the colors if a reverse color is provided
      if {[set pos [lsearch $bindlist <<Revcolors>>]] != -1} {
        set colorlist [lindex $actionlist $pos]
        if {[lindex $formatlist 0] != [lindex $colorlist 0]} {
          set formatlist [lreplace $formatlist 0 0 [lindex $colorlist 0]]
        } else {
          set formatlist [lreplace $formatlist 0 0 [lindex $colorlist 1]]
        }
      }
    }
    if {($tagname ne "sel") && ($tagname ne "tempsel")} {
      lappend result $tagname [list $indexlist $formatlist $bindlist $actionlist]
    }
    #set tags($tagname) [list $indexlist $formatlist $bindlist $actionlist]
    #sputs "$tagname: $tags($tagname)"
  }
  array unset tags sel
  array unset tags tempsel
  #return [array get tags]
  return $result
}

###########
## put tags back onto a selection (see get_tags)
###########
proc put_tags {text range taglist {direction forward} {rename 1}} {
  global fea_info

  set first [ix2bp $text [lindex $range 0]]
  set last [ix2bp $text [lindex $range 1]]
  set name_store [list]
  foreach {tagname tagdata} $taglist {
    set formatlist [lindex $tagdata 1]
    set bindlist [lindex $tagdata 2]
    set actionlist [lindex $tagdata 3]

    if {([regexp {f[0-9]+#} $tagname]) && ($rename == 1)} {
      set newtagname "f$fea_info([winfo parent $text],count)#"
      incr fea_info([winfo parent $text],count)
      lappend name_store $tagname $newtagname
    } else {
      set newtagname $tagname
    }

    ###change the metadata and colors if the tags are getting reversed
    if {$direction == "reverse"} {
      #change the direction data in the Features metadata
      if {[set pos [lsearch $bindlist <<Metadata>>]] != -1} {
        set metadata [lindex $actionlist $pos]
        set metadata [lreplace $metadata 3 3 [expr {![lindex $metadata 3]}]]
        set actionlist [lreplace $actionlist $pos $pos $metadata]
      }
      #change the colors if a reverse color is provided
      if {([set pos [lsearch $bindlist <<Revcolors>>]] != -1)} {
        set colorlist [lindex $actionlist $pos]
        if {[lindex $formatlist 0] != ""} {
          if {[lindex $formatlist 0] != [lindex $colorlist 0]} {
            set formatlist [lreplace $formatlist 0 0 [lindex $colorlist 0]]
          } else {
            set formatlist [lreplace $formatlist 0 0 [lindex $colorlist 1]]
          }
        }
      }
      if {$newtagname == "foundf"} {set newtagname "foundr"} elseif {$newtagname == "foundr"} {set newtagname "foundf"}
    }

    if {($rename == 0) || (![regexp {fn[0-9]+#} $tagname])} {
      $text tag configure $newtagname -background [lindex $formatlist 0] -foreground [lindex $formatlist 1] -font [lindex $formatlist 2] -underline  [lindex $formatlist 3] 
      foreach {start end} [lindex $tagdata 0] {
        if {$direction == "forward"} {
          $text tag add $newtagname [bp2ix $text [expr {$first+$start}]] [bp2ix $text [expr {$first+$end}]]
        } else {
          $text tag add $newtagname  [bp2ix $text [expr {$last-$end}]]  [bp2ix $text [expr {$last-$start}]]
        }
      }
      foreach binding $bindlist action $actionlist {
        $text tag bind $newtagname $binding $action
      }
      if {$tagname != $newtagname} {
        catch {$text tag raise $newtagname $tagname}
        if {[$text tag ranges $tagname] == ""} {$text tag delete $tagname}
      }
    }
  }

 
  ##make new fn# tags for split features that just got added in rename mode
  foreach {old_tag new_tag} $name_store {
    if {[string match {f[0-9]*#} $old_tag]} {
      set old_fn_tag "fn[regexp -inline {[0-9]+} $old_tag]#"
      if {([lsearch -exact $taglist $old_fn_tag] > -1) && ([llength [lindex $taglist [expr {[lsearch -exact $taglist $old_tag]+1}] 0]] > 2)} {
        set new_fn_tag "fn[regexp -inline {[0-9]+} $new_tag]#"
        lappend name_store $old_fn_tag $new_fn_tag
        foreach {start end} [lindex $taglist [expr {[lsearch -exact $taglist $old_fn_tag]+1}] 0] {
          if {$direction == "forward"} {
            $text tag add $new_fn_tag [bp2ix $text [expr {$first+$start}]] [bp2ix $text [expr {$first+$end}]]
          } else {
            $text tag add $new_fn_tag [bp2ix $text [expr {$last-$end}]] [bp2ix $text [expr {$last-$start}]]
          }
        }
        catch {$text tag raise $new_fn_tag $old_fn_tag}
        if {[$text tag ranges $old_fn_tag] == ""} {$text tag delete $old_fn_tag}
      }
    }
  }
  features_to_tree_view [winfo toplevel $text]
  return $name_store
}

#############
## copy tags into a destination analysis window
#############
proc copy_tags {text range dest dest_index {direction forward} {tagappend ""}} {
  set first [lindex $range 0]
  set last [lindex $range 1]
  if {[$text compare $first > $last]} {
    set temp $first
    set first $last
    set last $temp
    unset temp
  }
  set firstchar [ix2bp $text $first]
  set lastchar [ix2bp $text $last]

  foreach tagname [$text tag names $first] {
    set tags($tagname) $first
  }
  foreach {type tag index} [$text dump -tag $first+1char $last+1chars] {
    lappend tags($tag) $index
  }
  foreach tagname [$text tag names $last] {
    lappend tags($tagname) [$text index $last+1char]
  }
  set dest_line [$dest get $dest_index "$dest_index lineend"]

#sputs $dest_line
  array unset tags sel
  array unset tags tempsel
  foreach tag [array names tags] {
    if {($tag == "sel") ||($tag == "tempsel") || ([regexp {(fn|trans)[0-9]+#} $tag])} continue

    set tagname "$tag$tagappend"
    #regsub -all {[0-9]*?\.} $tags($tag) "" tags($tag)

    foreach {index1 index2} $tags($tag) {
      if {$direction == "forward"} {
        set tag_start [expr {[ix2bp $text $index1] - $firstchar}]
        set tag_end [expr {[ix2bp $text $index2] - $firstchar}]
      } else {
        set tag_start [expr {$lastchar - [ix2bp $text $index2] +1}]
        set tag_end [expr {$lastchar - [ix2bp $text $index1] +1}]
      }
#bug: can't use {$tag_start} counting in regexp for numbers above 255
      if {[regexp -indices "(?:\[-\\\ ~\]*\[^-~\\\ \]){$tag_start}((?:\[-\\\ ~\]*\[^-~\\\ \]){[expr {$tag_end-$tag_start}]})" $dest_line a b]} {
        $dest tag add $tagname [$dest index $dest_index+[lindex $b 0]char] [$dest index $dest_index+[expr {1+[lindex $b 1]}]char]
#sputs $dest_line \n$tag_start $tag_end $a $b
      }
      #$dest tag add $tag [$dest index $dest_index+[string length [regexp -inline "(?:\[\\\ -\]*\[^-\\\ \]){$tag_start}" $dest_line]]char] [$dest index $dest_index+[string length [regexp -inline "(?:\[\\\ -\]*\[^-\\\ \]){$tag_end}" $dest_line]]char]
    }
    $dest tag configure $tagname -background [$text tag cget $tag -background] -font [$text tag cget $tag -font] -underline [$text tag cget $tag -underline]
    $dest tag bind $tagname <<Metadata>> [$text tag bind $tag <<Metadata>>]
  }
}

#############
## copy tags into a destination analysis window
#############
proc copy_tags {text range dest dest_index {direction forward} {tagappend ""}} {
  set first [lindex $range 0]
  set last [lindex $range 1]
  if {[$text compare $first > $last]} {
    set temp $first
    set first $last
    set last $temp
    unset temp
  }
  set firstchar [ix2bp $text $first]
  set lastchar [ix2bp $text $last]
  set dest_line [$dest get $dest_index "$dest_index lineend"]
  if {$direction != "forward"} {
    set dest_line [string reverse $dest_line]
  }

  set lastindex $first
  set dest_last_index 0
  set dest_char_count 0
  foreach {type tag index} [concat [$text dump -tag $first+1char $last+1chars] 0 notag [bp2ix $text [expr {1+[ix2bp $text $last]}]]] {
    if {[$text compare $index == $lastindex]} {continue}
    set tags [lsearch -inline -all -regexp -not [$text tag names $index-1c] {sel|tempsel|(fn|trans)[0-9]+#}]

    set index_bp [expr {[ix2bp $text $index] - $firstchar}]
    #convert tag range to dest range

    set dest_first_index $dest_last_index
    while {($dest_last_index< [string length $dest_line]) && ($dest_char_count < $index_bp)} {
      incr dest_last_index
      if {[string first [string index $dest_line $dest_last_index] "abcdghkmnrstuvwyABCDGHKMNRSTUVWY"] > -1} {incr dest_char_count}
    }
    #add tags to dest
    foreach tag $tags {
      set tagname "$tag$tagappend"
      if {$direction == "forward"} {
        $dest tag add $tagname [$dest index $dest_index+[expr {$dest_first_index}]char] [$dest index $dest_index+[expr {$dest_last_index}]char]
      } else {
        $dest tag add $tagname [$dest index "$dest_index lineend -[expr {$dest_last_index}]char"] [$dest index "$dest_index lineend -[expr {$dest_first_index}]char"]
      }
      $dest tag configure $tagname -background [$text tag cget $tag -background] -font [$text tag cget $tag -font] -underline [$text tag cget $tag -underline]
      $dest tag bind $tagname <<Metadata>> [$text tag bind $tag <<Metadata>>]
    }

    set lastindex $index
  }

}


###########
## Add features from a GFF3 file
###########
proc add_gff_annotations {w} {
  set filename [tk_getOpenFile]
  if {![catch {open $filename r} fileid err]} {
    set fileid [open $filename r]
    while {[eof $fileid] != 1} {
      lappend gff3file [gets $fileid]
    }
    if {[regexp {##gff-version\s+3} [lindex $gff3file 0]]} {
      foreach {newdna filecomment circular startindex seqlength new_tags error} [parse_gff_file $gff3file] {}
      if {$error != ""} {
        close $fileid
        tk_messageBox -message [mc "Error opening GFF file: $error"] -title [mc "Error opening GFF file"] -icon info -type ok
        set dialogblock 0
        return error
      }
      if {($seqlength > [ix2bp $w.textarea [$w.textarea index end]]) && ([tk_messageBox -message [mc "GFF# file length ($seqlength) is greater than the sequence length ([ix2bp $w.textarea [$w.textarea index end]]).\nTry anyway?"] -type yesno -icon info] == "no")} {
        return
      }
      put_tags $w.textarea [list 1.0 [$w.textarea index end]] $new_tags
    } else {
      tk_messageBox -message [mc "File is not a GFF3 file"] -type ok -icon info
    }

  }
}

###########
## select all function
###########
proc select_all {w} {
  $w.textarea tag add sel 1.0 end-1chars
  $w.textarea mark set insert 1.0
  $w.textarea mark set anchor insert
  $w.textarea mark set tk::anchor$w.textarea insert
  selection_manager $w
}

###########
## select from_to window
###########
proc select_from_to {w} {
  global ok
  global info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {[winfo exists .select_to]} {destroy .select_to}
  set s [toplevel .select_to -background $info(bg_color)]
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }
  wm title $s [mc "Select from to"]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  raise $s
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $s "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"

  set wgeomlist [split [wm geometry $w] "x+"]
  set sgeom "+[expr [lindex $wgeomlist 2]+3]+[expr [lindex $wgeomlist 3]+150]"
  wm geometry $s $sgeom
  set from 0
  set to 0
  set ok 0
  frame $s.fromtoframe  
  pack [label $s.fromtoframe.fromlabel -text [mc "Select from"]] -expand false -side left

  pack [entry $s.fromtoframe.from -width 10 -validate key -vcmd "check_char %S" -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color)] -expand true -fill x -side left
  pack [label $s.fromtoframe.tolabel -text [mc "to"]] -expand false -side left
  pack [entry $s.fromtoframe.to -width 10 -validate key -vcmd "check_char %S" -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color)] -expand true -fill x -side left
  button $s.ok -text [mc "OK"] -command "set ok 1" -default active 
  bind $s <Key-Return> "set ok 1"
  button $s.cancel -text [mc "Cancel"] -command "set ok -1"
  grid rowconfigure $s 0 -weight 0
  grid rowconfigure $s 1 -weight 0
  grid columnconfigure $s 0 -weight 1
  grid columnconfigure $s 1 -weight 1 
  grid configure $s.fromtoframe -row 0 -column 0 -columnspan 2 -sticky we
  grid configure $s.ok -row 1 -column 0 -padx 10 -pady 3
  grid configure $s.cancel -row 1 -column 1  -padx 10 -pady 3
  
  if {[llength [$w.textarea tag ranges tempsel]] > 0} {
    $s.fromtoframe.from insert 0 [expr {[ix2bp $w.textarea [$w.textarea index sel.first]]+1}]
    $s.fromtoframe.to insert 0 [ix2bp $w.textarea [$w.textarea index sel.last]]
  } else {
    $s.fromtoframe.from insert 0 [expr {[ix2bp $w.textarea [$w.textarea index insert]]+1}]
  }

  $s.fromtoframe.from selection range 0 end

  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $s] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $s "+$winx+$winy"

  #grab set $s
  bind $s <Key-Return> "set ok 1"
  focus $s
  focus $s.fromtoframe.from

  vwait ok
  if {$ok == 1} {
    set from [string trimleft [$s.fromtoframe.from get] 0]
    set to [string trimleft [$s.fromtoframe.to get] 0]

    if {($from > $to) && ($from != "") && ($to != "") } {set temp $from; set from $to; set to $temp}
    if {$from == ""} {set from 1}
    incr from -1
    if {$to == ""} {set to [ix2bp $w.textarea [$w.textarea index end-1char]]}
    select_region $w [bp2ix $w.textarea $from] [bp2ix $w.textarea $to]
  }
  #grab release $s
  destroy $s
  set dialogblock 0
  bind . <<RaiseDialogs>> ""
  focus $w
  focus $w.textarea
}

###########
## jump to window
###########
proc jump_to {w} {
  global ok
  global info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {[winfo exists .dialog]} {destroy .dialog}
  set s [toplevel .dialog -background $info(bg_color)]
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }
  wm title $s [mc "Jump to"]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  raise $s
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"


  set wgeomlist [split [wm geometry $w] "x+"]
  set sgeom "+[expr [lindex $wgeomlist 2]+3]+[expr [lindex $wgeomlist 3]+150]"
  wm geometry $s $sgeom

  grid [label $s.tolabel -text [mc "Jump to:"]] -row 0 -column 0 -sticky nwe
  grid [entry $s.to -width 10 -validate key -vcmd "check_char %S" -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color)] -row 0 -column 1 -sticky nwe
  grid [button $s.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 0 -sticky n -padx 10 -pady 3
  bind $s <Key-Return> "set ok 1"
  grid [button $s.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 1 -sticky n -padx 10 -pady 3
  grid rowconfigure $s 0 -weight 0
  grid rowconfigure $s 1 -weight 0
  grid columnconfigure $s 0 -weight 1
  grid columnconfigure $s 1 -weight 1 
  $s.to insert 0 [ix2bp $w.textarea [$w.textarea index insert]]
  $s.to selection range 0 end

  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $s] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $s "+$winx+$winy"

  #grab set $s
  bind $s <Key-Return> "$s.ok invoke"
  focus $s
  focus $s.to
  vwait ok
  set dialogblock 0
  if {$ok == 1} {
    $w.textarea tag remove sel 1.0 end
    set to [string trimleft [$s.to get] 0]
    if {$to == ""} {set to 0}
    if {$to > 0} {incr to -1}
    select_region $w [bp2ix $w.textarea $to] [bp2ix $w.textarea $to]
  }
  #grab release $s
  destroy $s
  bind . <<RaiseDialogs>> ""
  focus $w
  focus $w.textarea
  unset ok
}

###########
## checks for numeric character in validation of numeric entries
###########
proc check_char {c} {
  if {[string equal $c " "]} {return 0}
  if {![string is integer $c]} {return 0}
  if {[regexp {[^0-9]} $c]} {return 0}
  return  1
}

proc entry_integer {c w mode min max} {
  if {$mode != "key"} {
    if {(![string is integer -strict $c]) || ($c< $min)} {
      $w delete 0 end
      $w insert end $min
      after idle "if {\[winfo exists $w\]} {$w config -validate all}"
    } elseif {$c > $max} {
      $w delete 0 end
      $w insert end $max
      after idle "if {\[winfo exists $w\]} {$w config -validate all}"
    }
  return 1
  } else {
    if {[string equal $c " "]} {return 0}
    if {[regexp {[^0-9]} $c]} {return 0}
    return  1
  }
}


###########
## Insert a repeated string of characers
###########
proc insert_repeat {w} {
  global ok
  global info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {[winfo exists .insert_rep]} {destroy .insert_rep}
  set s [toplevel .insert_rep -background $info(bg_color)]
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }
  wm title $s [mc "Insert Repeat"]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  raise $s
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $s "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"

  set wgeomlist [split [wm geometry $w] "x+"]
  set sgeom "+[expr [lindex $wgeomlist 2]+3]+[expr [lindex $wgeomlist 3]+150]"
  wm geometry $s $sgeom
  set from 0
  set to 0
  set ok 0
  frame $s.fromtoframe  
  grid [label $s.fromtoframe.seqlabel -text [mc "Sequence"]] -row 0 -column 0 -sticky nw

  grid [entry $s.fromtoframe.seq -width 10 -validate key -vcmd "regexp -nocase {\[ACGTN\]} %S" -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color)] -row 0 -column 1 -sticky nw

  grid [label $s.fromtoframe.lenlabel -text [mc "Repeats"]] -row 1 -column 0 -sticky nw
  grid [entry $s.fromtoframe.repeats -width 10 -validate key -vcmd "check_char %S" -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color)] -row 1 -column 1 -sticky nw
  button $s.ok -text [mc "OK"] -command "set ok 1" -default active 
  bind $s <Key-Return> "set ok 1"
  button $s.cancel -text [mc "Cancel"] -command "set ok -1"
  grid rowconfigure $s 0 -weight 0
  grid rowconfigure $s 1 -weight 0
  grid columnconfigure $s 0 -weight 1
  grid columnconfigure $s 1 -weight 1 
  grid configure $s.fromtoframe -row 0 -column 0 -columnspan 2 -sticky we
  grid configure $s.ok -row 1 -column 0 -padx 10 -pady 3
  grid configure $s.cancel -row 1 -column 1  -padx 10 -pady 3
  

  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $s] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $s "+$winx+$winy"

  #grab set $s
  bind $s <Key-Return> "set ok 1"
  focus $s
  focus $s.fromtoframe.seq

  vwait ok
  if {$ok == 1} {
    set seq [string trimleft [$s.fromtoframe.seq get] 0]
    set rpts [string trimleft [$s.fromtoframe.repeats get] 0]
      if {![catch {set k [string repeat $seq $rpts]}] && (![file_lock_check $w])}  {
        if {[llength [$w.textarea tag ranges sel]] > 0} {
          set undo_text [textarea_get $w.textarea sel.first sel.last]
          set undo_tags [get_tags $w.textarea [list [$w.textarea index sel.first] [$w.textarea index sel.last]]]
          set insert_at_end [expr {[$w.textarea index sel.last] == [$w.textarea index insert]}]
          textarea_delete $w.textarea sel.first sel.last
          set text_was_selected 1
        } else {
          set undo_text ""
          set undo_tags {}
          set insert_at_end 1
          set text_was_selected 0
        }
        if {[$w.textarea index insert] > 1.0} {
          textarea_insert $w.textarea [$w.textarea index insert] $k {}
          $w.textarea mark set anchor insert
          $w.textarea mark set tk::anchor$w.textarea insert
        } else {
          textarea_insert $w.textarea 1.0 $k {}
          $w.textarea mark set anchor 1.1
          $w.textarea mark set tk::anchor$w.textarea 1.1
          $w.textarea mark set insert 1.1
        }
        if {[$w.textarea compare insert == 1.1] && ($info($w,circular) == "circular")} {
          tag_split $w [$w.textarea index end-2chars] 1.1
        } elseif {[$w.textarea compare insert == end-1c] && ($info($w,circular) == "circular")} {
          tag_split $w [$w.textarea index insert-2chars] 1.0
        } else {
          tag_split $w [$w.textarea index insert-2chars] [$w.textarea index insert]
        }
        $w.textarea see insert
        register_undo $w typing [list [$w.textarea index insert-1chars] [$w.textarea index insert] "Typing" $undo_text $undo_tags [feature_cleanup $w.textarea] $text_was_selected $insert_at_end] "Typing" Undo
        set info($w,scanned) 0
        set info($w,saved) 0
        if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
        unlink_analysis_window $w
        vertindexbalancer $w
        selection_manager $w
      } else {
sputs error $seq $rpts [string repeat $seq $pts]
      }
  }
  #grab release $s
  destroy $s
  set dialogblock 0
  bind . <<RaiseDialogs>> ""
  focus $w
  focus $w.textarea
}

###########
## find dialog
###########
proc find_dialog {w} {
  global info modstring
  global ok dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1


  if {[winfo exists .find_dialog]} {destroy .find_dialog}
  set s [toplevel .find_dialog -background $info(bg_color)]
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }
  wm title $s [mc "Find..."]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  raise $s
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s; focus $s.find"

  set wgeomlist [split [wm geometry $w] "x+"]
  set sgeom "+[expr [lindex $wgeomlist 2]+3]+[expr [lindex $wgeomlist 3]+150]"
  wm geometry $s $sgeom

  set ok 0
  label $s.parent_info -text "[mc {Find in}] $info($w,win_title):"
  entry $s.find -width 50 -textvariable info(find_pattern) -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color) -font dnafont
  $s.find selection range 0 end
  $s.find icursor end

  set popupmenu [menu $s.find.popupmenu]
  $popupmenu add command -label [mc "Cut"]  -accelerator "$modstring+X" -command "event generate $s.find <<Cut>>"
  $popupmenu add command -label [mc "Copy"]  -accelerator "$modstring+C" -command "event generate $s.find <<Copy>>"
  $popupmenu add command -label [mc "Paste"]  -accelerator "$modstring+V" -command "event generate $s.find <<Paste>>"
  if {[tk windowingsystem] != "aqua"} {
    bind $s.find <Button-3> "tk_popup $popupmenu %X %Y"
  } else {
    bind $s.find <Button-2> "tk_popup $popupmenu %X %Y"
    bind $s.find <Control-Button-1> [bind $s.find <Button-2>]
  }

  frame $s.mod_frame 
    pack [checkbutton  $s.mod_frame.casens -text [mc "case sensitive"] -onvalue 1 -offvalue 0 -variable info(find_casens) -selectcolor white] -side left
    pack [checkbutton  $s.mod_frame.revcom -text [mc "also find rev-com of string"] -onvalue 1 -offvalue 0 -variable info(find_revcom) -selectcolor white] -side left
    pack [checkbutton  $s.mod_frame.aa -text [mc "as amino acid"] -onvalue 1 -offvalue 0 -variable info(find_as_aa) -selectcolor white] -side left

  frame $s.mod_frame2
    pack [checkbutton  $s.mod_frame2.exact -text [mc "as literal"] -onvalue 1 -offvalue 0 -variable info(find_as_literal) -selectcolor white] -side left
    pack [checkbutton  $s.mod_frame2.wrap -text [mc "wrap"] -onvalue 1 -offvalue 0 -variable info(find_wrap) -selectcolor white] -side left
 
  frame $s.mm_frame
    #pack [checkbutton  $s.mm_frame.exact  -onvalue 1 -offvalue 0 -variable info(find_allow_mm) -selectcolor white -command "$s.mm_frame.mm_entry configure -state \[expr {\$info(find_allow_mm)?\"normal\":\"disabled\"}\]; $s.mm_frame.mm_label configure -state \[expr {\$info(find_allow_mm)?\"normal\":\"disabled\"}\]"] -side left   
    pack [label $s.mm_frame.mm_label -text [mc "Allow mismatches:"]] -side left
    #pack [entry $s.mm_frame.mm_entry -width 5 -textvariable info(find_allow_mm_number) -validate key -vcmd "check_char %S"] -side left 
    pack [menubutton $s.mm_frame.mm_button -menu $s.mm_frame.mm_button.menu -textvariable info(find_allow_mm_number)] -side left 
    menu $s.mm_frame.mm_button.menu
    for {set mma 0} {$mma <26} {incr mma} {
      $s.mm_frame.mm_button.menu add radiobutton -label $mma -variable info(find_allow_mm_number) -value $mma
    }
    #$s.mm_frame.mm_entry configure -state [expr {$info(find_allow_mm)?"normal":"disabled"}]
    #$s.mm_frame.mm_label configure -state [expr {$info(find_allow_mm)?"normal":"disabled"}]

  frame $s.action_frame
    pack [button $s.action_frame.next -text [mc "Find Next"] -command "set ok next" -default active] -side left  -padx 10 -pady 3
    pack [button $s.action_frame.prev -text [mc "Find Prev"] -command "set ok prev"] -side left  -padx 10 -pady 3
    pack [button $s.action_frame.all -text [mc "Highlight All"] -command "set ok highlight"] -side left -padx 10 -pady 3
    pack [button $s.action_frame.cancel -text [mc "Close"] -command "set ok -1"] -side left  -padx 10 -pady 3

  pack $s.parent_info -side top -fill x -expand true
  pack $s.find -side top -fill x -expand true
  pack $s.mod_frame -side top -fill x -expand true
  pack $s.mod_frame2 -side top -fill x -expand true
  pack $s.mm_frame -side top -fill x -expand true
  pack $s.action_frame -side top -fill x -expand true
 
  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $s] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $s "+$winx+$winy"

  bind $s <Key-Return> "$s.action_frame.next invoke"
  focus $s
  focus $s.find

  if {[tk windowingsystem] == "aqua"} {
    bind $s <Deactivate> {set ok -1}
  } else {
    #bind $s <FocusOut> {set ok -1}
  }
  while {$ok != -1} {
    vwait ok
    if {$ok != -1} { 
      set info(find_action) $ok
      do_find $w $ok
    }
  }

  set dialogblock 0
  destroy $s
  bind . <<RaiseDialogs>> ""
}

###########
## perform find function
###########
proc do_find {w {action again}} {
  global info

  if {($action == "again") && ($info(find_pattern) == "")} {
      find_dialog $w
      return
  }
    set action $info(find_action)
    set s $info(find_pattern)
    set casens $info(find_casens)
    set revcom $info(find_revcom)
    set as_aa $info(find_as_aa)
    set as_literal $info(find_as_literal)


  if {$s == ""} return


  if {(!$as_aa) && ($info(find_allow_mm_number) > -1)} {
    # use find mm for all nucleotide searches
    do_find_mm $w
    return
  }

  if {$as_aa} {
    set pat [aa_regexp $s]
  } elseif {!$as_literal} {
    regsub -all -nocase {[^abcdghkmnrstvwy\*\|\;\,]} $s "" s
    regsub -all -nocase {\*} $s ".*" s
    set pat [regsubpattern $s] 
    while {[regsub -all {\|\|} $pat "|" pat] > 0} {}
    regsub {^\|} $pat "" pat
    regsub {\|$} $pat "" pat
  } else {
    regsub -all -nocase {[^abcdghkmnrstvwy\*\|\;\,]} $s "" s
    regsub -all -nocase {\*} $s "\\\*" s
    regsub -all -nocase {;|,} $s "|" s
    set pat $s 
  }

  if {$pat == ""} {
    set info(find_pattern) ""
    return
  }

  if {$revcom} {
    set rpat "(?:$pat)|(?:[revcom_regexp $pat])"
  } else {
    set rpat $pat
  }

  if {!$casens || $as_aa} {set switch2 "-nocase"} else {set switch2 "--"}


  switch $action {
    next {
      if {$info($w,circular) eq "circular"} {
        set matchlist [regexp -inline -indices -all $switch2 $rpat "[textarea_get $w.textarea 1.0 end-1c][textarea_get $w.textarea 1.0 end-2c]"]
        #need to convert list elements that span the origin here
        set i 0
        set seq_len [ix2bp $w.textarea end-1c]
        while {($i < [llength $matchlist]) && ([lindex [lindex $matchlist $i] 0] <= $seq_len)} {
          if {[lindex [lindex $matchlist $i] 1] > $seq_len} {
            set matchlist [lreplace $matchlist $i $i [list [lindex [lindex $matchlist $i] 0] $seq_len]]
          }
          incr i
        }
        incr i -1
        set matchlist [lrange $matchlist 0 $i]
      } else {
        set matchlist [regexp -inline -indices -all $switch2 $rpat [textarea_get $w.textarea 1.0 end]]
      }
      if {$matchlist != [list]} {
        catch {$w.textarea mark set insert sel.first+1chars}
        set ins [ix2bp $w.textarea insert]
        set i 0
        while {($i< [llength $matchlist]) && ([lindex [lindex $matchlist $i] 0] <= $ins)} {incr i}
        if {$i == [llength $matchlist]} {
          set i 0
        }
        select_region $w [bp2ix $w.textarea [lindex [lindex $matchlist $i] 0]]  [bp2ix $w.textarea [expr {1 + [lindex [lindex $matchlist $i] 1]}]]
      } else {
        tk_messageBox -message [mc "No sequence found"] -type ok -icon info -parent [expr {[winfo exists .find_dialog]?".find_dialog":$w}]
      }
    }
    prev {
      if {$info($w,circular) eq "circular"} {
        set matchlist [regexp -inline -indices -all $switch2 $rpat "[textarea_get $w.textarea 1.0 end-1c][textarea_get $w.textarea 1.0 end-2c]"]
        #need to convert list elements that span the origin here
        set i 0
        set seq_len [ix2bp $w.textarea end-1c]
        while {($i < [llength $matchlist]) && ([lindex [lindex $matchlist $i] 0] <= $seq_len)} {
          if {[lindex [lindex $matchlist $i] 1] > $seq_len} {
            set matchlist [lreplace $matchlist $i $i [list [lindex [lindex $matchlist $i] 0] $seq_len]]
          }
          incr i
        }
        incr i -1
        set matchlist [lrange $matchlist 0 $i]
      } else {
        set matchlist [regexp -inline -indices -all $switch2 $rpat [textarea_get $w.textarea 1.0 end]]
      }
      if {$matchlist != [list]} {
        catch {$w.textarea mark set insert sel.first}
        set ins [ix2bp $w.textarea insert]
        set i 1
        while {($i< [llength $matchlist]) && ([lindex [lindex $matchlist $i] 0] < $ins)} {incr i}
        incr i -1
        if {$i == 0} {
          set i [expr {[llength $matchlist] - 1}]
        }
        select_region $w [bp2ix $w.textarea [lindex [lindex $matchlist $i] 0]]  [bp2ix $w.textarea [expr {1 + [lindex [lindex $matchlist $i] 1]}]]
      } else {
        tk_messageBox -message [mc "No sequence found"] -type ok -icon info -parent [expr {[winfo exists .find_dialog]?".find_dialog":$w}]
      }
    }
    highlight {
      set cur 1.0
      $w.textarea tag remove foundf 1.0 end
      $w.textarea tag remove foundr 1.0 end
      $w.textarea tag configure foundf -background $info(find_forward_highlight)
      $w.textarea tag configure foundr -background $info(find_reverse_highlight)
      if {!$casens || $as_aa} {
        set switches "-nocase"
      } else {
        set switches "--"
      }
      if {$info($w,circular) eq "circular"} {
        set matchlist [regexp -inline -indices -all $switch2 $pat "[textarea_get $w.textarea 1.0 end-1c][textarea_get $w.textarea 1.0 end-2c]"]
        #need to convert list elements that span the origin here
        set i 0
        set seq_len [ix2bp $w.textarea end-1c]
        while {($i < [llength $matchlist]) && ([lindex [lindex $matchlist $i] 0] <= $seq_len)} {
          if {[lindex [lindex $matchlist $i] 1] > $seq_len} {
            set matchlist [lreplace $matchlist $i $i [list [lindex [lindex $matchlist $i] 0] $seq_len 0 [expr {[lindex [lindex $matchlist $i] 1] - $seq_len}] ]]
          }
          incr i
        }
        incr i -1
        set matchlist [lrange $matchlist 0 $i]
      } else {
        set matchlist [regexp -inline -indices -all $switch2 $pat [textarea_get $w.textarea 1.0 end]]
      }
      foreach match $matchlist {
        $w.textarea tag add foundf [bp2ix $w.textarea [expr {(([lindex $match 0]))}]]  [bp2ix $w.textarea [expr {(([lindex $match 1])) +1}]]
        if {[llength $match] == 4} {
          $w.textarea tag add foundf [bp2ix $w.textarea [expr {(([lindex $match 2]))}]]  [bp2ix $w.textarea [expr {(([lindex $match 3])) +1}]]
        }
        $w.textarea tag bind foundf <<Revcolors>> [list gray70 gray50]
      }
      $w.textarea tag raise foundf
      if {$revcom} {
        set cur 1.0
        set pat [revcom_regexp $pat]
        if {$info($w,circular) eq "circular"} {
          set matchlist [regexp -inline -indices -all $switch2 $pat "[textarea_get $w.textarea 1.0 end-1c][textarea_get $w.textarea 1.0 end-2c]"]
          #need to convert list elements that span the origin here
          set i 0
          set seq_len [ix2bp $w.textarea end-1c]
          while {($i < [llength $matchlist]) && ([lindex [lindex $matchlist $i] 0] <= $seq_len)} {
            if {[lindex [lindex $matchlist $i] 1] > $seq_len} {
              set matchlist [lreplace $matchlist $i $i [list [lindex [lindex $matchlist $i] 0] $seq_len 0 [expr {[lindex [lindex $matchlist $i] 1] - $seq_len}] ]]
            }
            incr i
          }
          incr i -1
          set matchlist [lrange $matchlist 0 $i]
        } else {
          set matchlist [regexp -inline -indices -all $switch2 $pat [textarea_get $w.textarea 1.0 end]]
        }
        foreach match $matchlist {
          $w.textarea tag add foundr [bp2ix $w.textarea [expr {(([lindex $match 0]))}]]  [bp2ix $w.textarea [expr {(([lindex $match 1])) +1}]]
          if {[llength $match] == 4} {
            $w.textarea tag add foundr [bp2ix $w.textarea [expr {(([lindex $match 2]))}]]  [bp2ix $w.textarea [expr {(([lindex $match 3])) +1}]]
          }
          $w.textarea tag bind foundr <<Revcolors>> [list gray50 gray70]
        }
        $w.textarea tag raise foundr
      }
      if {[$w.textarea tag ranges foundf] != ""} {
        $w.textarea see [lindex [$w.textarea tag ranges foundf] 0]
      } elseif {[$w.textarea tag ranges foundr] != ""} {
        $w.textarea see [lindex [$w.textarea tag ranges foundr] 0]
      } else {
        tk_messageBox -message [mc "No sequence found"] -type ok -icon info -parent [expr {[winfo exists .find_dialog]?".find_dialog":$w}]
      }
    }
  }

  focus $w
  focus $w.textarea
}

###########
## perform find function
###########
proc do_find_mm {w {action again}} {
  global info

  set action $info(find_action)
  set s $info(find_pattern)
  set casens $info(find_casens)
  set revcom $info(find_revcom)
  set as_aa $info(find_as_aa)
  set as_literal $info(find_as_literal)




  if {$as_aa} {
    switch $action {
      next {
      }
      prev {
      }
      highlight {
      }
    }
    tk_messageBox -message [mc "Mismatch search not implemented yet"] -type ok -icon info -parent [expr {[winfo exists .find_dialog]?".find_dialog":$w}]
  } else {
   ##find nucleotide
    set text [textarea_get $w.textarea 1.0 end-1c]
    set text_length [string length $text]

    regsub -all -nocase {[^abcdghkmnrstvwy\*\|\;\,]} $s "" s
    if {!$casens} {  
      set text [string toupper $text]
      set s [string toupper $s]
    }  
    set s_list1 [split $s "|,;"]

    set longest 0
    set s_list [list]
    foreach t $s_list1 {
      lappend s_list [split $t ""]
      if {$revcom} {
        lappend s_list [split [revcom $t] ""]
      }
      if {[string length $t] > $longest} {
        set longest [string length $t]
      }

    }
    if {!$info(find_as_literal)} {
      set s_list [string map {B BYSKCGT D DRWKAGT H HMWYACT K KGT M MAC N NBDHVKMRYWSACGT R RAG S SGC V VMSRACG W WAT Y YCT b byskcgt d drwkagt h hmwyact k kgt m mac n nbdhvkmrywsacgt r rag s sgc v vmsracg w wat y yct} $s_list]

    }

    switch $action {
      next {
        if {[$w.textarea tag ranges sel] != ""} {
          set ins [ix2bp $w.textarea sel.first+1chars]
        } else {
          set ins [ix2bp $w.textarea insert]
        }
        set text2 [string range $text $ins end]
        if {$info($w,circular) eq "circular"} {
          append text2 [string range $text 0 [expr {$ins -1}]] [string range $text[string range $text 0 $longest] $ins [expr {$ins + $longest -1}]]
       } elseif {$info(find_wrap)} {
          append text2 \t [string range $text 0 [expr {$ins -1}]] [string range $text $ins [expr {$ins + $longest -1}]]
        }
        set text_list [split $text2 ""]

        set found -1
        for {set i 0} {$i <= [expr {[llength $text_list] - $longest}]} {incr i} {
          foreach st $s_list {
            set mm 0
            foreach s1 $st c2 [lrange $text_list $i [expr {$i+[llength $st]-1}]] {
              if {[string first $c2 $s1] == -1} {
                incr mm
                if {$mm > $info(find_allow_mm_number)} break
              }
            }
            if {$mm <= $info(find_allow_mm_number)} {
              set found $i
              break
            }
          }
          if {$found > -1} break
        }
        if {$found > -1} {
          if {($info($w,circular) eq "linear") && $info(find_wrap) && (($found + $ins) > $text_length )} {
            incr found -1
          }
          select_region $w [bp2ix $w.textarea [expr {($found + $ins) % $text_length}]]  [bp2ix $w.textarea [expr {($found + $ins) % $text_length + [llength $st]}]]
          catch {$w.textarea mark set insert sel.first+1chars}
        } else {
          tk_messageBox -message [mc "No sequence found"] -type ok -icon info -parent [expr {[winfo exists .find_dialog]?".find_dialog":$w}]
        }

      }
      prev {
       if {[$w.textarea tag ranges sel] != ""} {
          set ins [ix2bp $w.textarea sel.first]
        } else {
          set ins [ix2bp $w.textarea insert]
        }
        set text2 [string range $text 0 [expr {$longest + $ins -1}]]
        if {$info($w,circular) eq "circular"} {
          set text2 [string range $text$text[string range $text 0 $longest] [expr {$ins}] [expr {[string length $text] + $ins + $longest-1}]]
        } elseif {$info(find_wrap) } {
          set text2 [string range $text [expr {$ins}] end]\t[string range $text 0 [expr {$longest + $ins -2}]]
        }
        set text_list [split $text2 ""]

        set found -1
        for {set i [expr {[llength $text_list] - 1 -$longest}]} {$i >= 0} {incr i -1} {
          foreach st $s_list {
            set mm 0
            foreach s1 $st c2 [lrange $text_list $i [expr {$i+[llength $st]-1}]] {
              if {[string first $c2 $s1] == -1} {
                incr mm
                if {$mm > $info(find_allow_mm_number)} break
              }
            }
            if {$mm <= $info(find_allow_mm_number)} {
              set found $i
              break
            }
          }
          if {$found > -1} break
        }
        if {$found > -1} {
          if {$info($w,circular) eq "circular"} {
            select_region $w [bp2ix $w.textarea [expr {($found + $ins) % $text_length}]]  [bp2ix $w.textarea [expr {($found + $ins) % $text_length + [llength $st]}]]
          } elseif {$info(find_wrap)} {
            set gap [string first \t $text2]
            if {$found > $gap} {
              select_region $w [bp2ix $w.textarea [expr {($found - $gap - 1)}]]  [bp2ix $w.textarea [expr {($found - $gap -1) + [llength $st]}]] 
            } else {
              select_region $w [bp2ix $w.textarea [expr {($found + $ins)}]]  [bp2ix $w.textarea [expr {($found + $ins) + [llength $st]}]]
            }
          } else {
            select_region $w [bp2ix $w.textarea [expr {($found)}]]  [bp2ix $w.textarea [expr {($found) + [llength $st]}]]
          }
        } else {
          tk_messageBox -message [mc "No sequence found"] -type ok -icon info -parent [expr {[winfo exists .find_dialog]?".find_dialog":$w}]
        }

      }
      highlight {
        $w.textarea tag remove foundf 1.0 end
        $w.textarea tag remove foundr 1.0 end
        $w.textarea tag configure foundf -background $info(find_forward_highlight)
        $w.textarea tag configure foundr -background $info(find_reverse_highlight)

        set text2 $text
        if {$info($w,circular) eq "circular"} {
          append text2  [string range $text 0 [expr {$longest -1}]]
        }
        set text_list [split $text2 ""]

        set found -1
        for {set i 0} {$i <= [expr {[llength $text_list] - $longest}]} {incr i} {
          set dir 0
          foreach st $s_list {
            set mm 0
            foreach s1 $st c2 [lrange $text_list $i [expr {$i+[llength $st]-1}]] {
              if {[string first $c2 $s1] == -1} {
                incr mm
                if {$mm > $info(find_allow_mm_number)} break
              }
            }
            if {$mm <= $info(find_allow_mm_number)} {
              # add tag here       
              $w.textarea tag add [expr {$dir?"foundr":"foundf"}] [bp2ix $w.textarea [expr {($i)}]]  [bp2ix $w.textarea [expr {min ($text_length,($i +  [llength $st]))}]]
              if {[expr {($i + [llength $st])}] > $text_length} {
                $w.textarea tag add [expr {$dir?"foundr":"foundf"}] [bp2ix $w.textarea 0]  [bp2ix $w.textarea [expr {($i + [llength $st]) % $text_length }]]
              }
            }
            if {$info(find_revcom)} {
              set dir [expr {($dir + 1) % 2}]
            }
          }
        }
        if {[$w.textarea tag ranges foundf] != ""} {
          $w.textarea tag raise foundf
          $w.textarea tag bind foundf <<Revcolors>> [list gray70 gray50]
          $w.textarea see [lindex [$w.textarea tag ranges foundf] 0]
        } elseif {[$w.textarea tag ranges foundr] != ""} {
          $w.textarea tag raise foundr
          $w.textarea tag bind foundr <<Revcolors>> [list gray50 gray70]
          $w.textarea see [lindex [$w.textarea tag ranges foundr] 0]
        } else {
          tk_messageBox -message [mc "No sequence found"] -type ok -icon info -parent [expr {[winfo exists .find_dialog]?".find_dialog":$w}]
        }
      }
    }
  }
  focus $w
  focus $w.textarea

}

###########
##  find all occurrences of s in text with # mismatches
###########
proc search_with_mm {s text {mm_allowed 0}} {
  set s [string toupper $s]
  set s_list [split $s ""]
  set longest [string length $s]
  set text [string toupper $text]
  set text_list [split $text ""]

  set result [list]
  set found -1
  for {set i 0} {$i <= [expr {[llength $text_list] - $longest}]} {incr i} {
    set mm 0
    foreach s1 $s_list c2 [lrange $text_list $i [expr {$i+[llength $s_list]-1}]] {
      if {[string first $c2 $s1] == -1} {
        incr mm
        if {$mm > $mm_allowed} break
      }
    }
    if {$mm <= $mm_allowed} {
      lappend result $i
    }
  }
  return $result
}

###########
## returns regexp pattern for aa input 
###########
proc aa_regexp {pattern} {
  set temp [list]
  set lookup [list A (GC.) C (TG\[CT\]) D (GA\[CT\]) E (GA\[AG\]) F (TT\[CT\]) G (GG.) H (CA\[CT\]) I (AT\[ACT\]) K (AA\[AG\]) L ((CT.)|(TT\[AG\])) M (ATG) N (AA\[CT\]) P (CC.) Q (CA\[AG\]) R ((CG.)|(AG\[AG\])) S ((TC.)|(AG\[CT\])) T (AC.) V (GT.) W (TGG) X (...) Y (TA\[CT\]) * ((TA\[AG\])|(TGA))]  

  foreach seq [split $pattern " ;,"] {
    lappend temp [string map -nocase $lookup $seq]
  }
  return [join $temp |]
}

if {[catch {string reverse a}]} {
####use old revcom if using Tcl 8.4
###########
## returns revrse complement of simple regexp patterns
###########
proc revcom_regexp {pattern} {
  set temp ""
  set length [string length $pattern]
  for {set i [expr {$length-1}]} {$i >= 0} {incr i -1} {
      append temp [string map {A T C G G C T A a t c g g c t a \[ \] \] \[ ) ( ( )} [string index $pattern $i]]
  }
  return $temp
}


##########
## returns the reverse complement of the input
##########
proc revcom {pattern} {
  set temp ""
  set length [string length $pattern]
  for {set i [expr {$length-1}]} {$i >= 0} {incr i -1} {
    append temp [string map {A T B V C G D H G C H D K M M K N N * * R Y S S T A V B W W Y R a t b v c g d h g c h d k m m k n n r y s s t a v b w w y r} [string index $pattern $i]]
  }
  return $temp
}

##########
## returns the reverse of the input
##########
proc rev {args} {
  set temp ""
  set pattern [join $args " "]
  foreach char [split $pattern ""] {
    set temp "$char$temp"
  }
  return $temp
}
} else {
########################################use new revcom if using Tcl 8.5 (string reverse)
###########
## returns revrse complement of simple regexp patterns
###########
proc revcom_regexp {pattern} {
  return [string map {A T C G G C T A a t c g g c t a \[ \] \] \[ ) ( ( )} [string reverse $pattern]]
}


##########
## returns the reverse complement of the input
##########
proc revcom {pattern} {
  return [string map {A T B V C G D H G C H D K M M K N N * * R Y S S T A V B W W Y R a t b v c g d h g c h d k m m k n n r y s s t a v b w w y r} [string reverse $pattern]]
}

##########
## returns the reverse of the input
##########
proc rev {args} { 
  return [string reverse [join $args " "]]
}
#end of if {catch [string reverse a]}
}


##########
## returns the complement of the input
##########
proc com {args} {
   return [string map {A T B V C G D H G C H D K M M K N N * * R Y S S T A V B W W Y R a t b v c g d h g c h d k m m k n n r y s s t a v b w w y r} [join $args " "]]
}


################
## Generate a translation map string from a string of 64 single letter codes
################
proc gen_translation_map {code} {
  set codon_list [list]
  foreach first {t c a g} {
    foreach second {t c a g} {
      foreach third {t c a g} {
        lappend codon_list "$first$second$third"
      }
    }
  }

  set str "xxx X "
  foreach aa [split $code ""] codon $codon_list {
    append str "$codon $aa "
  }
  lappend result $str
  set str_r "xxx X "
  foreach aa [split $code ""] codon $codon_list {
    append str_r "[revcom $codon] $aa "
  }
  lappend result $str_r
  lappend result [string map {X Xxx F Phe L Leu S Ser Y Tyr C Cys * End W Trp P Pro H His Q Gln R Arg I Ile M Met T Thr N Asn K Lys V Val A Ala D Asp E Glu G Gly} $str]
  lappend result [string map {X Xxx F Phe L Leu S Ser Y Tyr C Cys * End W Trp P Pro H His Q Gln R Arg I Ile M Met T Thr N Asn K Lys V Val A Ala D Asp E Glu G Gly} $str_r]
  return $result
}

################
## Returns the current translation code (uses info(translation_code) to determine)
################
proc get_ncbi_translation_code {code} {
  global info
  set i [lsearch $info(NCBI_translation_code_list) $code]
  if {$i > 0} {
    return [lindex $info(NCBI_translation_code_list) [expr {$i -1}]]
  } else {
    return {Custom}
  }
}

################
## Translate dna, 1 or 3 characters, direction:1 forward, 0 reverse, spacing between characters
################
proc translate {dna {chars 1} {direction 1} {spacing 0}} {
  global info

  set i [string range $dna 0 [expr [string length $dna]/3*3-1]]

  while {[regsub -nocase "((...)*)((.\[bdhkmnrsvwy*\].)|(..\[bdhkmnrsvwy*\])|(\[bdhkmnrsvwy*\]..))(.*)" $i {\1xxx\7} i]} {}
  set i [regexp -inline -all {...} $i]

  if {$chars == 1} {
    if {$direction == 1} {
      set result [string map -nocase [lindex $info(translation_map_lists) 0] $i]
    } else {
      set result [string map -nocase [lindex $info(translation_map_lists) 1] $i]
    }
  } else {
    if {$direction == 1} {
      set result [string map -nocase [lindex $info(translation_map_lists) 2] $i]
    } else {
      set result [string map -nocase [lindex $info(translation_map_lists) 3] $i]
    }
  }
  return [join $result [string repeat " " $spacing]]
}


################
## Translate dna, 1 or 3 characters, direction:1 forward, 0 reverse, spacing between characters
################
proc reverse_translate {protein} {
  global info
  set tr_map [list]
  foreach {codon aa} [lindex $info(translation_map_lists) 0] {
    if {[lsearch -exact $tr_map $aa] < 0} {
      lappend tr_map $aa [string toupper $codon] [string tolower $aa] $codon
    } 
  }
  regsub -all -nocase {[^ACDEFGHIKLMNPQRSTVWXY*]} $protein "" protein
  return [string map $tr_map $protein]
  
}

################
## Returns cds features as concatenated text
################
proc get_cds {w tag} {
  global info
  set fn_tag [string replace $tag 0 0 fn]
  set tag_range [$w.textarea tag ranges $tag]
  if {[lsearch -exact [$w.textarea tag names] $fn_tag] != -1} {
    set fn_tag_range [$w.textarea tag ranges $fn_tag]
    if {[llength $fn_tag_range] == 4} {
      set break [lsearch $tag_range [lindex $fn_tag_range 2]]
      set tag_range [concat [lrange $tag_range $break end] [lrange $tag_range 0 [expr {$break -1}]]] 
    } 
    set text ""
    foreach {f0 f1} $tag_range {
      set text "$text[textarea_get $w.textarea $f0 $f1]"
    } 
  } else {
    if {[llength $tag_range] == 4} {
      set text "[textarea_get $w.textarea [lindex $tag_range 2] [lindex $tag_range 3]][textarea_get $w.textarea [lindex $tag_range 0] [lindex $tag_range 1]]"
    } else {
      set text [textarea_get $w.textarea [lindex $tag_range 0] [lindex $tag_range 1]]
    }
  }
  set text [regsub -all \n $text ""]
  return $text
}

################
## Returns list of tag string (length of full sequence, space padded)
################
proc cds_trans_lines {w} {
  set result [list]
  set tag_list [get_tags $w.textarea [list 1.0 end]]
  foreach {tag data} $tag_list {
    if {[regexp {f[0-9]+#} $tag]} {
      set metadata_index [lsearch -exact [lindex $data 2] <<Metadata>>]
      set type [lindex [lindex [lindex $data 3] $metadata_index] 2]
      if {[string toupper $type] == "CDS"} {
        set dir [lindex [lindex [lindex $data 3] $metadata_index] 3]
        set cds_text [get_cds $w $tag]
        set cds_case ""
        foreach {a b c d e f} [split $cds_text ""] {
          append cds_case [string toupper $a] [string toupper $b] [string toupper $c] [string tolower $d] [string tolower $e] [string tolower $f]
        }
        set cds_trans " [translate $cds_text 1 [expr {$dir?-1:1}] 2]  "
        set fn_tag [string replace $tag 0 0 fn]
        set tag_range [$w.textarea tag ranges $tag]
        if {[lsearch -exact [$w.textarea tag names] $fn_tag] != -1} {
          set fn_tag_range [$w.textarea tag ranges $fn_tag]
          if {[llength $fn_tag_range] == 4} {
            set break [lsearch $tag_range [lindex $fn_tag_range 2]]
            set tag_range [concat [lrange $tag_range $break end] [lrange $tag_range 0 [expr {$break -1}]]] 
          }  
        } elseif {[llength $tag_range] == 4} {
          set tag_range [list [lindex $tag_range 2] [lindex $tag_range 3] [lindex $tag_range 0] [lindex $tag_range 1]]
        }
        set prstring [string repeat " " [ix2bp $w.textarea end]]
        set cdnastring [string repeat " " [ix2bp $w.textarea end]]
        set i 0
        foreach {f0 f1} $tag_range {
          set f0 [ix2bp $w.textarea $f0]
          set f1 [expr {[ix2bp $w.textarea $f1]-1}]
          set flen [expr {$f1 -$f0}]
          set prstring [string replace $prstring $f0 $f1 [string range $cds_trans $i [expr {$i+$flen}]]]
          set cdnastring [string replace $cdnastring $f0 $f1 [string range $cds_case $i [expr {$i+$flen}]]]
          incr i [expr {$flen+1}]
        }
        lappend result [list $tag $prstring $cdnastring]
      }
    }
  }
  return $result
}


###############
## finds the melting temperature of a sequence, [dna] in nM, [Na] in mM
###############
#Option for the table of Nearest-Neighbor thermodynamic parameters and for the method of melting temperature calculation. Two different tables of thermodynamic parameters are available:
#   1. Breslauer et al. 1986, DOI:10.1073/ pnas.83.11.3746 In that case the formula for melting temperature calculation suggested by Rychlik et al. 1990 is used (this is used until Primer3 version 1.0.1). This is the default value of Primer3 (for backward compatibility).
#   2. SantaLucia 1998, DOI:10.1073/pnas.95.4.1460 This is the recommended value. 

#Option for specifying the salt correction formula for the melting temperature calculation.

#   There are three different options available: 
#   1. Schildkraut and Lifson 1965, DOI:10.1002/bip.360030207 (this is used until the version 1.0.1 of Primer3).The default value of Primer3 version 1.1.0 (for backward compatibility)
#   2. SantaLucia 1998, DOI:10.1073/pnas.95.4.1460 This is the recommended value.
#   3. Owczarzy et al. 2004, DOI:10.1021/bi034621r

proc Tm {seq {dna_conc 250} {salt_conc 50}} {
  set seq [regsub -all \n $seq ""]
  if {[string length $seq] > 100} {return "---"}
  regsub -nocase -all {[^acgt]} $seq "t" seq
  set seq [string tolower $seq]
#parameters from SantaLucia J., Proc. Nat. Acad. Sci. 95: 1460-1465 (1998)
  array set s {aa 222 tt 222 at 204 ta 213 ca 227 tg 227 gt 224 ac 224 ct 210 ag 210 ga 222 tc 222 cg 272 gc 244 gg 199 cc 199}
  array set h {aa 79 tt 79 at 72 ta 72 ca 85 tg 85 gt 84 ac 84 ct 78 ag 78 ga 82 tc 82 cg 106 gc 98 gg 80 cc 80}
  
#parameters from Breslauer et al. 1986
#  array set s {aa 240 tt 240 at 239 ta 169 ca 129 tg 129 gt 173 ac 173 ct 208 ag 208 ga 135 tc 135 cg 278 gc 267 gg 266 cc 266}
#  array set h {aa 91 tt 91 at 86 ta 60 ca 58 tg 58 gt 65 ac 65 ct 78 ag 78 ga 56 tc 56 cg 119 gc 111 gg 110 cc 110}

# initiation parameters from SantaLucia J., Proc. Nat. Acad. Sci. 95: 1460-1465 (1998)
  if {[string first [string index $seq 0] "at"] > -1} {
    set htot -23
    set stot -41
  } else {
    set htot -1
    set stot 28
  }
  if {[string first [string index $seq end] "at"] > -1} {
    incr htot -23
    incr stot -41
  } else {
    incr htot -1
    incr stot 28
  }

#calculate total deltah and deltas
  set l [expr [string length $seq]-1]
  for {set i 0} {$i < $l} {incr i} {
    incr htot $h([string range $seq $i [expr $i+1]])
    incr stot $s([string range $seq $i [expr $i+1]])
  }

##salt correction from SantaLucia, J., Jr., Allawi, H. T., and Seneviratne, P. A. (1996)
#Tm=dH/(dS + R ln [DNA])
#R= 1.987
  set log_dna [expr {1.987 * log( $dna_conc / 1000000000.0)}]
  set log_salt [expr {12 * log10($salt_conc / 1000.0)}]
  set result [expr {$htot * 100.0 / ($stot * 0.1 - $log_dna) - 273.15 + $log_salt}]

  if {$result > 0} {return $result} else {return <0}
}


##########
## finds the %GC of a sequence
##########
proc GC% {seq} {
set seq [regsub -all \n $seq ""]
set gc [string map -nocase {a "" t "" n "" b "" d "" h "" k "" m "" r "" v "" w "" y "" * ""} $seq]
return [expr {100.0*[string length $gc]/[string length $seq]}] 
}

##########
## finds the extinction coeff (L/Mmole/cm) of a sequence
##########
proc extinction {seq} {
  set seq [regsub -all \n $seq ""]
  array set edata [list A 15.4 C 7.4 G 11.5 T 8.7 AA 13.7 AC 10.6 AG 12.5 AT 11.4 CA 10.6 CC 7.3 CG 9.0 CT 7.6 GA 12.6 GC 8.8 GG 10.8 GT 10.0 TA 11.7 TC 8.1 TG 9.5 TT 8.4]
  set seq [string toupper $seq]
  set e $edata([string range $seq 0 0])
  for {set i 0} {$i <= [expr {[string length $seq]-2}]} {incr i} {
    set e [expr {$e + 2.0 * $edata([string range $seq $i [expr {$i+1}]]) - $edata([string range $seq $i $i])}]
  }
  return $e
}

##########
## find ORF- finds the next ATG-Stop after the cursor
##########
proc next_ORF {w {direction forward}} {
  global info 
  set c [list]
  if {$direction == "forward"} {
    if {[$w.textarea tag ranges sel] != {}} {
      set text [textarea_get $w.textarea sel.first+1chars end-1c]
      set i [$w.textarea index sel.first+1chars]
    } else {
      set text [textarea_get $w.textarea insert end-1c]
      set i [$w.textarea index insert]
    }

    if {$info(find_orf_starts) == "Met"} {
      set c [lindex [lindex [regexp -nocase -indices -inline {ATG} $text] 0] 0]
    } elseif {[$w.textarea compare 1.3 > $i]} {
      set c 0
    } else {
      set c [lindex [lindex [regexp -nocase -indices -inline "(?:taa|tag|tga|tar)" $text] 0] 0]
      if {$c != [list]} {
        incr c 3
      }
    }
    if {$c != [list]} {
      set text [string range $text $c end]
      set d [lindex [lindex [regexp -nocase -indices -inline "^(?:...)*?(?:taa|tag|tga|tar)" $text] 0] 1]
     if {$d == [list]} {set d [expr {3*(([string length $text])/3)}]}
     lappend c [expr {$c+$d+1}]
    }
  } else {
#find previous
    if {[$w.textarea tag ranges sel] != {}} {
      set text [textarea_get $w.textarea 1.0 sel.last-1chars]
    } else {
      set text [textarea_get $w.textarea 1.0 insert]
    }
    set stoplist [lsort -decreasing -integer -index 0 [regexp -inline -all -nocase -indices {(?:taa|tag|tga|tar)} $text]]
    set stoplist [concat $stoplist [list {2 4} {1 3} {0 2}]]
    if {((([$w.textarea tag ranges sel] != {}) && ([$w.textarea compare end-4chars < sel.last])) || ([$w.textarea compare end-4chars < insert])) && ([string length $text] > 2)} {
      set stoplist [concat [list [list [expr {[string length $text]-3}] [expr {[string length $text]-1}]]] $stoplist]
    }
    set startlist [lsort -decreasing -integer -index 0 [regexp -inline -all -nocase -indices {(?:atg)} $text]]
    set c [list]
    foreach stop2 $stoplist {
      foreach stop1 $stoplist {
        if {([lindex $stop1 0] < [lindex $stop2 0]) &&([expr {fmod([lindex $stop2 0] - [lindex $stop1 0], 3)}]==0.0)} {
          if {$info(find_orf_starts) == "Met"} {
             if {[regexp -nocase -indices {(?:atg)(?:...)*$} [string range $text [lindex $stop1 0] [lindex $stop2 1]] start] == 1} {
               set c [list [expr {[lindex $start 0]+[lindex $stop1 0]}] [lindex $stop2 1]]
             }
          } else {
            set c [list [expr {3+[lindex $stop1 0]}] [lindex $stop2 1]]
          }
          break
        }
      }
      if {$c != [list]} break
    }

    set i 1.0

  }
  if {$c == [list]} {
    bell
    return
  } else {
    $w.textarea tag remove sel 1.0 end
    set i [ix2bp $w.textarea $i]
    select_region $w [bp2ix $w.textarea [expr {$i +[lindex $c 0]}]] [bp2ix $w.textarea [expr {$i +[lindex $c 1]}]]
  }
}

###########
##
###########
proc next_ORF {w {direction forward}} {
  global info
  if {$direction eq "all"} {

  } else {
    if {$direction eq "forward"} {
      set text [textarea_get $w.textarea 1.0 end-1c]
      if {[$w.textarea tag ranges sel] != {}} {
        set i [ix2bp $w.textarea sel.first+1chars]
      } else {
        set i [ix2bp $w.textarea insert]
      }
      set res [find_orf $text $i $info(find_orf_strand)]
    } else {
      set text [revcom [textarea_get $w.textarea 1.0 end-1c]]
      if {[$w.textarea tag ranges sel] != {}} {
        set i [ix2bp $w.textarea sel.last-2chars]
      } else {
        set i [ix2bp $w.textarea insert-1char]
      }
      set i [expr {[string length $text] - $i -1}]
      set res [find_orf $text $i [expr {-1*$info(find_orf_strand)}]]
      if {$res != [list]} {
        set res [list [expr {[string length $text] - [lindex $res 1] -1}] [expr {[string length $text] - [lindex $res 0]-1}]]
      }
    }
    if {$res == [list]} {
      bell
      return
    } else {
      $w.textarea tag remove sel 1.0 end
      select_region $w [bp2ix $w.textarea [expr {[lindex $res 0]}]] [bp2ix $w.textarea [expr {1 + [lindex $res 1]}]]
    }
  }
}

##########
##
##########
set info(find_orf_min) 90
#use this to find next orf on top or bottom strand
#search with this until the result is past the insertion point to find previous
# find orf in $w that starts after index i and is find_orf_min bp minimum
# top_strand is -1 for bottom, 1 for top and 0 for both
# set text [textarea_get $w.textarea 1.0 end-1c]
proc find_orf {text i strand} {
  global info
  set c ""
  set e ""
  if {$strand > -1} {
    set found_orf 0
    while {!$found_orf} {
      if {$info(find_orf_starts) == "Met"} {
        set c [lindex [lindex [regexp -nocase -indices -inline -start $i $info(start_codons) $text] 0] 0]
      } else {
        set c [lindex [lindex [regexp -nocase -indices -inline -start [expr {$i-3}] "(?:taa|tag|tga|tar)" $text] 0] 0]
        if {$c != [list]} {
          incr c 3
        }
      }
      if {$c != [list]} {
        set d [lindex [lindex [regexp -nocase -indices -inline -start $c "\\A(?:...)*?(?:taa|tag|tga|tar)" $text] 0] 1]
        if {$d == [list]} {
          set d [expr {$c+ 3*(([string length $text]-$c)/3)}]
        }
        if {[expr {$d - $c}] >= $info(find_orf_min)} {
          set found_orf 1
          set top_result [list $c $d]
        } else {
          set i [expr {$c+1}]
        }
      } else {
        set top_result [list]
        set found_orf 1
      }
    }
  } else {
    set top_result [list]
  }
  if {$strand < 1} {
    set found_orf 0
    while {!$found_orf} {
      set e [lindex [lindex [regexp -nocase -indices -inline -start $i "(?:tta|cta|tca|yta)" $text] 0] 0]
      if {$e != [list]} {
        if {$info(find_orf_starts) == "Met"} {
          set g  [lindex [lindex [regexp -nocase -indices -inline -start [expr {$e+3}] "\\A(?:...)*?(?:tta|cta|tca|yta)" $text] 0] 1]
          if {$g == [list]} {
            set g [string length $text]
          }
          set j $e
          set f -1
          while {([set tempf [lindex [lindex [regexp -nocase -indices -inline -start $j "\\A(?:...)*?(?:[revcom_regexp $info(start_codons)])" $text] 0] 1]] < $g) && ($tempf ne "")} {
            set f $tempf
            set j [expr {$f+1}]
          }
          #if there is a stop before the start, it's not an orf
          if {$f > $g} {
            set i [expr {$e+1}]
            continue
          }
        } else {
          set f [lindex [lindex [regexp -nocase -indices -inline -start [expr {$e+3}] "\\A(?:...)*?(?:tta|cta|tca|yta)" $text] 0] 1]
          if {$f != [list]} {
            incr f -3
          }
        }
        if {$f == [list]} {
          set bottom_result [list]
          set found_orf 1
          continue
        }
        if {[expr {$f - $e}] >= $info(find_orf_min)} {
          set found_orf 1
          set bottom_result [list $e $f]
        } else {
          set i [expr {$e+1}]
        }
      } else {
        set bottom_result [list]
        set found_orf 1
      }
    }
  } else {
    set bottom_result [list]
  }
  #return the first of top_result and bottom_result
  if { ($bottom_result == [list]) || (($c ne "") && $c < $e)} {
    return $top_result
  } else {
    return $bottom_result
  } 
}

##########
## changes case of the selection (or window if no selection)
##########
proc change_case {w {action "upper"} {undo Undo} {undo_text ""}} { 
  global info

  if {[file_lock_check $w]} {return}

  if {[$w.textarea tag ranges sel] == ""} {
    set first 1.0
    set last [$w.textarea index end-1chars]

    set reset 0
  } else {
    set first [$w.textarea index sel.first]
    set last [$w.textarea index sel.last]
    catch {set anchorstore [$w.textarea index tk::anchor$w.textarea]}
    set reset 1
  }
  set insertstore [$w.textarea index insert]
  set scrollstore [lindex [$w.textarea yview] 0]
  set textstore [textarea_get $w.textarea $first $last]
  set tagstore [get_tags $w.textarea [list $first $last]]
  textarea_delete $w.textarea $first $last
  if {($undo == "Undo") || ($action == "exchange")} {
    switch $action {
      upper {
        textarea_insert $w.textarea $first [string toupper $textstore] {}
        register_undo $w change_case [list $first $last $action $textstore] "Change Case" Undo
      }
      lower {
        textarea_insert $w.textarea $first [string tolower $textstore] {}
        register_undo $w change_case [list $first $last $action $textstore] "Change Case" Undo
      }
      exchange {
        textarea_insert $w.textarea $first [swap $textstore] {}
        register_undo $w change_case [list $first $last $action] "Change Case" Undo
      }
      default {
        textarea_insert $w.textarea $first $textstore {}
      }
    }
  } else {
    textarea_insert $w.textarea $first $undo_text {}
    register_undo $w change_case [list $first $last $action] "Change Case" Redo
  }
  $w.textarea yview moveto $scrollstore
  put_tags $w.textarea [list $first $last] $tagstore forward 0
  if {$reset} {
    $w.textarea tag add sel $first $last
    catch {$w.textarea mark set anchor $anchorstore; $w.textarea mark set tk::anchor$w.textarea $anchorstore}
  } 
  $w.textarea mark set insert $insertstore



  set info($w,saved) 0
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
}

##########
## returns the case swap of the input
##########
proc swap {pattern} {
  return [string map {A a B b C c D d G g H h K k M m N n R r S s T t V v W w Y y a A b B c C d D g G h H k K m M n N r R s S t T v V w W y Y} $pattern]
}

##########
## rotates the origin of a circular sequence to the insertion point-needs to move the tags too
##########
proc set_origin {w {undo Undo}} {
  global info
  if {([$w.textarea index insert] == 1.0) ||[file_lock_check $w]} {return}
  set before [textarea_get $w.textarea 1.0 insert]
  set tagstore [get_tags $w.textarea [list 1.0 [$w.textarea index insert]]]
  textarea_delete $w.textarea 1.0 insert
  textarea_insert $w.textarea end-1chars $before {}
  put_tags $w.textarea [list [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index end-1c]] - [string length $before]}]] end-1c] $tagstore forward 0
  selection_manager $w

  register_undo $w set_origin [list [bp2ix $w.textarea [expr {[ix2bp $w.textarea [$w.textarea index end-1c]] - [string length $before]}]]] "Set Origin" $undo
  set info($w,scanned) 0
  set info($w,saved) 0
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
  unlink_analysis_window $w
  vertindexbalancer $w
}

##########
## toggle circular to linear
##########
proc toggle_circ {w {undo Undo}} {
  global info toolbar_images

  if {[file_lock_check $w]} {return}

  if {($info($w,circular) == "linear") } {
    set info($w,circular) circular
    $w.menubar.edit entryconfigure [mc "Set Origin"] -state normal
    $w.menubar.edit entryconfigure [mc "Linearize @ insert site"] -state normal
    $w.infoframe.circular configure -image $toolbar_images(circular)
  } else {
    set info($w,circular) linear
    $w.menubar.edit entryconfigure [mc "Set Origin"] -state disabled
    $w.menubar.edit entryconfigure [mc "Linearize @ insert site"] -state disabled
    $w.infoframe.circular configure -image ""
  }
  register_undo $w toggle_circ [list [feature_cleanup $w.textarea]] "Circular<->Linear" $undo
  set info($w,scanned) 0
  set info($w,saved) 0
  set info($w,circular_text) [mc $info($w,circular)]
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
  unlink_analysis_window $w
}

##########
## linearize at insert site
##########
proc linearize {w {undo Undo}} {
  set_origin $w
  toggle_circ $w
  register_undo $w cant [list] "Linearize" $undo
}

##########
## reverse complements the selection if there is one, or the whole dna if not -needs to deal with tags
##########
proc rev_com_window {w {undo Undo}} {
  global info 

  if {[file_lock_check $w]} {return}
  if {[$w.textarea tag ranges sel] == ""} {
    set first 1.0
    set last [$w.textarea index end-1chars]
    set reset 0
  } else {
    set first [$w.textarea index sel.first]
    set last [$w.textarea index sel.last]
    set anchorstore $first
    catch {set anchorstore [$w.textarea index tk::anchor$w.textarea]}
    set reset 1
  }
  set insertstore [$w.textarea index insert]
  set selected [textarea_get $w.textarea $first $last]
  set tagstore [get_tags $w.textarea [list $first $last]]
  textarea_delete $w.textarea $first $last
  textarea_insert $w.textarea $first [revcom $selected] {}

  #if rev-com the first time, rename the tags and store the name equivalences
  #if undoing ($undo=="Redo"), then don't change the names so the equivalences can be re-exchanged
  set put_tag_store [put_tags $w.textarea [list $first $last] $tagstore reverse [expr {$undo=="Undo"}]]

  if {$reset} {
    $w.textarea tag add sel $first $last
    $w.textarea mark set insert $insertstore
    $w.textarea mark set anchor $anchorstore
    $w.textarea mark set tk::anchor$w.textarea $anchorstore
  } else {
    $w.textarea mark set insert [bp2ix $w.textarea [expr {int([ix2bp $w.textarea [$w.textarea index end-1c]]- [ix2bp $w.textarea $insertstore])}]]
    $w.textarea see insert
  }

  register_undo $w rev_com [list $first $last $put_tag_store] "Reverse Complement" $undo

  vertindexbalancer $w
  selection_manager $w
  set info($w,scanned) 0 
  set info($w,saved) 0
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
  unlink_analysis_window $w
}

##############
## enzyme selection dialog
##############
proc enzyme_selection_dialog {w} {
  global info
  global enzinfo
  global enzymes
  global enz_select_window old_enz_select_window
  global enz_select_groups
  global select_numsites_lab select_numsites_comp
  global ok dialogblock modstring modifier tk_patchLevel
  if {$dialogblock == 1} {return}
  set dialogblock 1

  set s ".enz_selector"

  foreach window $info(dnawindows_list) {
    findenzymes $window
  }

  if {[winfo exists $s]} {wm deiconify $s; raise $s; return}
  toplevel $s -background $info(bg_color)

  bind . <<RaiseDialogs>> "after 100 {catch {wm deiconify $s; raise $s}}"
  bind $s <FocusIn> "event generate . <<RaiseDialogs>>"
  bind $s <Map> "event generate . <<RaiseDialogs>>"
  bind $s <Activate> "event generate . <<RaiseDialogs>>"

  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $s "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox resizable}
  }
  wm title $s [mc "Enzyme Selection..."]
  wm protocol $s WM_DELETE_WINDOW "$s.actionframe.cancel invoke"
  bind $s <KeyPress-Escape> "$s.actionframe.cancel invoke"
  set ok 0
  menu $s.menubar

  menu $s.menubar.filemenu 
  $s.menubar add cascade -menu $s.menubar.filemenu -label [mc "File"]
  $s.menubar.filemenu add command -label [mc "Open new enzymes file"] -command "reload_enzymes"
  $s.menubar.filemenu add command -label [mc "Save enzymes file"] -command {save_enzymes "" 0; wm deiconify .enz_selector}
  $s.menubar.filemenu add separator
  $s.menubar.filemenu add command -label [mc "Save current enzymes as Default"] -command {save_enzymes "" 1; wm deiconify .enz_selector}
  $s.menubar.filemenu add separator
  $s.menubar.filemenu add command -label [mc "Import Enzymes From DNA Strider..."] -command "import_strider_enzymes .enz_selector"
  $s.menubar.filemenu add separator
  $s.menubar.filemenu add command -label [mc "Close Selection Dialog"] -accelerator "$modstring+W" -command "$s.actionframe.cancel invoke"

  menu $s.menubar.enzmenu 
  $s.menubar add cascade -menu $s.menubar.enzmenu -label [mc "Enzymes"]
  $s.menubar.enzmenu add command -label [mc "New Enzyme..."] -command "add_enzyme_dialog $s"
  $s.menubar.enzmenu add command -label [mc "Delete Selected Enzymes"] -command {delete_selected $info(enz_currently_selected)}
  $s.menubar.enzmenu add separator
  $s.menubar.enzmenu add command -label [mc "New Group..."] -command "add_enz_group $s \$info(enz_currently_selected)"
  $s.menubar.enzmenu add command -label [mc "Delete Groups..."] -command "delete_enz_group $s"
  $s.menubar.enzmenu add command -label [mc "Read Groups File..."] -command "read_enz_groups $s"


  menu $s.menubar.listmenu
  $s.menubar add cascade -menu $s.menubar.listmenu -label [mc "List"]
  $s.menubar.listmenu add command -label [mc "List enzymes"] -command "list_enzymes_window \$enz_select_window 0 selected; if {!\$info(enz_selector_keep_open)} {set ok 1} "
  $s.menubar.listmenu add command -label [mc "List enzymes + #sites"] -command "list_enzymes_window \$enz_select_window 1 selected; if {!\$info(enz_selector_keep_open)} {set ok 1} "
  $s.menubar.listmenu add command -label [mc "List enzymes + site positions"] -command "list_enzymes_window \$enz_select_window 2 selected; if {!\$info(enz_selector_keep_open)} {set ok 1} "
  $s.menubar.listmenu add command -label [mc "List enzyme + recognition sequences"] -command "list_enzymes_window \$enz_select_window 3 selected; if {!\$info(enz_selector_keep_open)} {set ok 1} "

  if {[tk windowingsystem] == "aqua"} {
    menu $s.menubar.apple 
    $s.menubar.apple add command -label [mc "About ApE"] -command "about_dialog ." -state disabled
    $s.menubar.apple add separator
    #$s.menubar.apple add command -label [mc "Preferences..."]  -command "configure_preferences $w" -accelerator "$modstring+,"
    $s.menubar add cascade -menu $s.menubar.apple
  }

  $s configure -menu $s.menubar

  bind $s <$modifier-KeyPress-w> "$s.actionframe.cancel invoke"
  bind $s <$modifier-KeyPress-y> "$s.actionframe.graphic invoke"
  bind $s <$modifier-KeyPress-Y> "$s.actionframe.graphicU invoke" 
  bind $s <$modifier-KeyPress-g> "$s.actionframe.digest invoke" 
  bind $s <$modifier-KeyPress-T> "$s.actionframe.textmap invoke"

##Region of interest frame###
  grid [frame $s.location -relief ridge -borderwidth 3] -row 0 -column 0 -sticky nwe
  grid [label $s.location.label -text [mc "Window"] -font boldlabelfont] -row 0 -column 0 -sticky wns
  menubutton $s.location.win_button
    menu $s.location.win_button.menu 
    foreach window $info(dnawindows_list) {
      $s.location.win_button.menu add radiobutton -command "change_enz_select_window" -label $info($window,win_title) -variable enz_select_window -value $window 
    }
    $s.location.win_button configure -textvariable info($w,win_title) -menu $s.location.win_button.menu  -indicatoron 1 -relief raised -width 50 
    bind $s.location.win_button <<MenuSelect>> "focus $s"

  set enz_select_window $w
  set old_enz_select_window $w
  grid $s.location.win_button -row 0 -column 1 -sticky wens

  grid [checkbutton $s.location.local -height 1 -width 0 -variable info(analyze_selection) -onvalue "selection" -offvalue "all" -indicator on -selectcolor white -command "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment \$enz_select_window" -justify right] -row 0 -column 2 -sticky wns 
  grid [label $s.location.labelssel -text  [mc "Selection: "] -font labelfont -justify right] -row 0 -column 3 -sticky wns
  grid [label $s.location.labelss -textvariable info($w,sel_start) -font labelfont] -row 0 -column 4 -sticky wns
  grid [label $s.location.labesdashl -text "-" -font labelfont] -row 0 -column 5 -sticky wns
  grid [label $s.location.labelse -textvariable info($w,sel_end) -font labelfont] -row 0 -column 6 -sticky wns

  trace add variable info($w,sel_start) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $w; #"
  trace add variable info($w,sel_end) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $w; #"

  grid [checkbutton $s.location.methylation -text Dam/Dcm -variable info($enz_select_window,Dam_Dcm_methylated) -onvalue 1 -offvalue 0 -command {toggle_methylation $enz_select_window;fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window} -selectcolor white] -row 0 -column 7 -sticky wns
  grid columnconfigure $s.location 1 -weight 1

###Enzyme list frame ######
  grid [frame $s.textframe] -row 1 -column 0 -sticky nswe
  grid [scrollbar $s.textframe.scroll -command "$s.textframe.textbox yview"] -row 0 -column 1 -sticky nsw
  grid [text $s.textframe.textbox -yscrollcommand "optionscrollbar $s.textframe.scroll" -height 20 -background $info(text_bg_color) -foreground $info(text_fg_color) -font labelfont -wrap none -insertontime 0 -insertofftime 1000] -row 0 -column 0 -sticky nswe
  set tabwidth [font measure [$s.textframe.textbox cget -font] "HpyCH4III(200) "]
  $s.textframe.textbox configure -tabs "$tabwidth left" -width [expr {0+$tabwidth*8/[font measure [$s.textframe.textbox cget -font] "0"]}]
  #grid [scrollbar $s.textframe.scrollx -command "$s.textframe.textbox xview" -orient horizontal] -row 1 -column 0 -sticky nwe

  grid columnconfigure $s.textframe 0 -weight 1
  grid rowconfigure $s.textframe 0 -weight 1

##Enzyme Comment box
  grid [label $s.enz_comment -justify center] -row 2 -column 0 -sticky nswe

###Select_enzymes frame 
  grid [frame $s.groupsframe -relief ridge -borderwidth 3] -row 3 -column 0 -sticky nwe
  grid [label $s.groupsframe.label -text [mc "Select Enzymes"] -font boldlabelfont] -row 0 -column 0 -sticky w

  #number of sites menu button
  menubutton $s.groupsframe.numsites
    menu $s.groupsframe.numsites.menu 
    foreach label [list [mc "unique (1)"] [mc any] [mc "absent (0)"] [mc "present (>0)"] [mc "not unique (>1)"]] comparison [list "==1" ">-1" "==0" ">0" ">1"] {
      $s.groupsframe.numsites.menu add radiobutton -label $label -value $comparison -command "set select_numsites_lab {$label}" -variable select_numsites_comp
    }
    menu $s.groupsframe.numsites.menu.lt 
    foreach label [list <2 <3 <4 <5 <6 <7 <8 <9 <10 <11 <12 <13 <14 <15 <16] comparison [list <2 <3 <4 <5 <6 <7 <8 <9 <10 <11 <12 <13 <14 <15 <16] {
      $s.groupsframe.numsites.menu.lt add radiobutton -label $label -value $comparison -command "set select_numsites_lab {$label}" -variable select_numsites_comp
    }
    menu $s.groupsframe.numsites.menu.et 
    foreach label [list =2 =3 =4 =5 =6 =7 =8 =9 =10 =11 =12 =13 =14 =15 =16] comparison [list ==2 ==3 ==4 ==5 ==6 ==7 ==8 ==9 ==10 ==11 ==12 ==13 ==14 ==15 ==16] {
      $s.groupsframe.numsites.menu.et add radiobutton -label $label -value $comparison -command "set select_numsites_lab {$label}" -variable select_numsites_comp
    }
    menu $s.groupsframe.numsites.menu.gt 
    foreach label [list >2 >3 >4 >5 >6 >7 >8 >9 >10 >11 >12 >13 >14 >15 >16] comparison [list >2 >3 >4 >5 >6 >7 >8 >9 >10 >11 >12 >13 >14 >15 >16] {
      $s.groupsframe.numsites.menu.gt add radiobutton -label $label -value $comparison -command "set select_numsites_lab {$label}" -variable select_numsites_comp
    }
    $s.groupsframe.numsites.menu add cascade -label [mc "less than"] -menu $s.groupsframe.numsites.menu.lt
    $s.groupsframe.numsites.menu add cascade -label [mc "equal to"] -menu $s.groupsframe.numsites.menu.et
    $s.groupsframe.numsites.menu add cascade -label [mc "greater than"] -menu $s.groupsframe.numsites.menu.gt
    # $s.groupsframe.numsites.menu add command -label [mc "Other..."] -command "enzyme_count_dialog" 
    $s.groupsframe.numsites configure -indicatoron 1 -relief raised -width 12 -textvariable select_numsites_lab -menu $s.groupsframe.numsites.menu
    $s.groupsframe.numsites.menu invoke 0
    bind $s.groupsframe.numsites.menu <<MenuSelect>> "focus $s"
  grid $s.groupsframe.numsites -row 0 -column 1 -sticky w 

  #enzyme groups menu button
  menubutton $s.groupsframe.groups_button
    menu $s.groupsframe.groups_button.menu 
    foreach element $enzinfo(enz_groups_list) {
      $s.groupsframe.groups_button.menu add radiobutton -label $element -variable enz_select_groups -value $element 
    }
    $s.groupsframe.groups_button configure -indicatoron 1 -relief raised -width 10 -textvariable enz_select_groups -menu $s.groupsframe.groups_button.menu
    $s.groupsframe.groups_button.menu invoke 0
    bind $s.groupsframe.groups_button.menu <<MenuSelect>> "focus $s"

  grid $s.groupsframe.groups_button -row 0 -column 2 -sticky w

  #select functions button set
  grid [button $s.groupsframe.plus -text [mc "Select"] -command {tagmanage .enz_selector.textframe.textbox add [enz_site_usage_filter $enz_select_window $enzinfo(enz_groups,$enz_select_groups) $select_numsites_comp $info(analyze_selection)]}] -row 0 -column 3 -sticky w
  grid [button $s.groupsframe.minus -text [mc "De-select"] -command {tagmanage .enz_selector.textframe.textbox remove [enz_site_usage_filter $enz_select_window $enzinfo(enz_groups,$enz_select_groups) $select_numsites_comp $info(analyze_selection)]}] -row 0 -column 4 -sticky w
  grid [button $s.groupsframe.and -text [mc "AND"] -command {tagmanage .enz_selector.textframe.textbox booland [enz_site_usage_filter $enz_select_window $enzinfo(enz_groups,$enz_select_groups) $select_numsites_comp $info(analyze_selection)]}] -row 0 -column 5 -sticky w
  grid [button $s.groupsframe.clearall -text [mc "clear all"] -command {tagmanage .enz_selector.textframe.textbox booland {}}] -row 0 -column 6 -sticky w
  grid [button $s.groupsframe.memplus -text [mc "Sel to Mem"] -command {set enzinfo(enz_groups,Mem\ Recall) $info(enz_currently_selected)}] -row 0 -column 7 -padx {10 0} -sticky w
  grid columnconfigure $s.groupsframe 7 -weight 1

##Perfom Action frame######
  grid [frame $s.actionframe -relief ridge  -borderwidth 3] -row 4 -column 0 -sticky nsew
  grid [label $s.actionframe.label -text [mc "Perform Action"] -font boldlabelfont] -row 0 -column 0 -sticky w
  grid [button $s.actionframe.graphic -text [mc "Graphic Map"] -command "enz_graphic_map \$enz_select_window ; if {!\$info(enz_selector_keep_open)} {set ok 1}"] -row 0 -column 1
  grid [button $s.actionframe.graphicU -text [mc "Graphic Map +U"] -command "enz_graphic_map \$enz_select_window {==1} ;if {!\$info(enz_selector_keep_open)} {set ok 1}"] -row 0 -column 2
  grid [button $s.actionframe.digest -text [mc "Digest"] -command "if \{\$info(enz_currently_selected) != {}\} \{enz_digest \$enz_select_window \$info(enz_currently_selected) \$info(analyze_selection)\}; if {!\$info(enz_selector_keep_open)} {set ok 1}"] -row 0 -column 3
  grid [button $s.actionframe.hilight -text [mc "Highlight"] -command "highlight_enzymes \$enz_select_window \$info(enz_currently_selected); if {!\$info(enz_selector_keep_open)} {set ok 1}"]  -row 0 -column 4
  grid [button $s.actionframe.textmap -text [mc "Text"] -command "enz_text_map $enz_select_window 0; if {!\$info(enz_selector_keep_open)} {set ok 1}"]  -row 0 -column 5
  grid [button $s.actionframe.cancel -text [mc "Close"] -command "set ok Cancel"]  -row 0 -column 6
  grid [checkbutton $s.actionframe.keep_open -text [mc "Keep Selector Dialog Open"] -variable info(enz_selector_keep_open)] -row 1 -column 0 -columnspan 3 -sticky w
  grid columnconfigure $s.actionframe 1 -weight 1
  grid columnconfigure $s.actionframe 2 -weight 1
  grid columnconfigure $s.actionframe 3 -weight 1
  grid columnconfigure $s.actionframe 4 -weight 1
  grid columnconfigure $s.actionframe 5 -weight 1

  fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window

  menu .enz_selector.textframe.textbox.popupmenu
  .enz_selector.textframe.textbox.popupmenu add command -label "REBASE: enzyme search"
  .enz_selector.textframe.textbox.popupmenu add command -label "REBASE: isoschizomer search"
  .enz_selector.textframe.textbox.popupmenu add command -label "REBASE: supplier search"

  grid columnconfigure $s 0 -weight 1
  grid rowconfigure $s 0 -weight 0
  grid rowconfigure $s 1 -weight 1
  grid rowconfigure $s 2 -weight 0
  grid rowconfigure $s 3 -weight 0
  grid rowconfigure $s 4 -weight 0

  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $s] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $s "+$winx+$winy"

  tagmanage .enz_selector.textframe.textbox add $info(enz_currently_selected)
  $s.textframe.textbox configure -state disabled -cursor arrow
  bind $s <Any-MouseWheel> "$s.textframe.textbox yview scroll \[expr {int(1.0 * %D/-\$info(mousewheelunits))}] units"
  bind $s <Any-Button-1> {}


  bindtags $s.textframe.textbox {$s.textframe.textbox .enz_selector}
  #grab set $s
  bind $s <Key-Return> "$s.actionframe.cancel invoke"
  focus $s

  vwait ok

  set dialogblock 0
  bind . <<RaiseDialogs>> ""

  if {$info(enzymes_saved) == 0} {
    if {[tk_messageBox -message "Do you want to save changes to the current enzyme set?" -type yesno -icon question] == "yes"} {
      save_enzymes "" 0
    } else {
      set info(enzymes_saved) -1
    }
  }

  destroy .enz_selector
  unset select_numsites_lab select_numsites_comp ok 
  set enz_select_groups "All"
 
  trace remove variable info($enz_select_window,sel_start) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window; #"
  trace remove variable info($enz_select_window,sel_end) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window; #"
  unset enz_select_window old_enz_select_window
}

#################
## insert enzymes into the enzyme selector text box
#################
proc change_enz_select_window {} {
  global enz_select_window old_enz_select_window info
  trace remove variable info($old_enz_select_window,sel_start) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $old_enz_select_window; #"
  trace remove variable info($old_enz_select_window,sel_end) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $old_enz_select_window; #"
  .enz_selector.location.labelss configure -textvariable info($enz_select_window,sel_start)
  .enz_selector.location.labelse configure -textvariable info($enz_select_window,sel_end)
  trace add variable info($enz_select_window,sel_start) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window; #"
  trace add variable info($enz_select_window,sel_end) write "fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window; #"
  .enz_selector.location.win_button configure -textvariable info($enz_select_window,win_title)
  .enz_selector.location.methylation configure -variable info($enz_select_window,Dam_Dcm_methylated)
  set old_enz_select_window $enz_select_window
  fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window
}

#################
## insert enzymes into the enzyme selector text box
#################
proc fill_enzymes_box {textbox commentbox w } {
  set columns 8
  global enzymes modifier
  global enzinfo
  global info

  set enzymelist $enzymes
  while {[expr {[llength $enzymelist] % $columns}] > 0} {
    lappend enzymelist ""
  }
  set rows [expr int([llength $enzymelist]/$columns)]

  $textbox configure -state normal
  $textbox delete 1.0 end
  for {set i 0} {$i < $rows} {incr i} {
    set prepend " "
    for {set j 0} {$j < $columns} {incr j} {
      set beginenz [$textbox index "end-1 chars"]
      set enzyme [lindex $enzymelist [expr $j*$rows+$i]]
      if {$enzyme != ""} {
        $textbox insert end "$prepend$enzyme ([enz_count $w $enzyme $info(analyze_selection)]) "
        $textbox tag add $enzyme "$beginenz+1 chars" "end-1 chars"
        if {$enzinfo(compat,$enzyme) != ""} {
          if {[llength $enzinfo(compat,$enzyme)] < 11} {
            $textbox tag bind $enzyme <Any-Enter> "$commentbox configure -text {$enzyme: $enzinfo(enz_comment,$enzyme) (compat w/: $enzinfo(compat,$enzyme))}"
          } else {
            $textbox tag bind $enzyme <Any-Enter> "$commentbox configure -text {$enzyme: $enzinfo(enz_comment,$enzyme) (compat w/: [lrange $enzinfo(compat,$enzyme) 0 9]+[expr {[llength $enzinfo(compat,$enzyme)]-10}] others)}"
          }
        } else {
          $textbox tag bind $enzyme <Any-Enter> "$commentbox configure -text {$enzyme: $enzinfo(enz_comment,$enzyme)}"
        }
        $textbox tag bind $enzyme <Any-Leave> "$commentbox configure -text {}"
        $textbox tag bind $enzyme <Button-1> "tagmanage $textbox click \{\{$enzyme\}\}"
        $textbox tag bind $enzyme <Double-Button-1> "tagmanage $textbox click \{\{$enzyme\}\}; edit_enzyme \{$enzyme\} .enz_selector"
        $textbox tag bind $enzyme <Shift-Button-1> "tagmanage $textbox booland {}; tagmanage $textbox click \{\{$enzyme\}\}"
        if {[tk windowingsystem] != "aqua"} {
          $textbox tag bind "$enzyme" <Button-3> "
             $textbox.popupmenu entryconfigure \"REBASE: enzyme search\" -command \"rebase_query \\\"$enzyme\\\" main\"
             $textbox.popupmenu entryconfigure \"REBASE: isoschizomer search\" -command \"rebase_query \\\"$enzyme\\\" similar\"
             $textbox.popupmenu entryconfigure \"REBASE: supplier search\" -command \"rebase_query \\\"$enzyme\\\" suppliers\"
             tk_popup $textbox.popupmenu %X %Y 0"
        } else {
          $textbox tag bind "$enzyme" <Button-2>  "
             $textbox.popupmenu entryconfigure \"REBASE: enzyme search\" -command \"rebase_query \\\"$enzyme\\\" main\"
             $textbox.popupmenu entryconfigure \"REBASE: isoschizomer search\" -command \"rebase_query \\\"$enzyme\\\" similar\"
             $textbox.popupmenu entryconfigure \"REBASE: supplier search\" -command \"rebase_query \\\"$enzyme\\\" suppliers\"
             tk_popup $textbox.popupmenu %X %Y 0" 
          $textbox tag bind $enzyme <Control-Button-1> [$textbox tag bind $enzyme <Button-2>]
        }
        set prepend "\t"
      } else {
        $textbox insert end "$prepend$enzyme "
      }
    }
    $textbox insert end "\n"
  }
  $textbox delete end-1char end
  $textbox configure -state disabled
  unset enzymelist
}


#################
## filter an incoming group for site number and return remaining elements
#################
proc enz_site_usage_filter {w {enzlist [list]} {comparison "==1"} {region all}} {
  global info enz_select_groups

  set templist [list]
  if {$enzlist != "Difference..."} {
    foreach enzyme $enzlist {
      if "[enz_count $w $enzyme $region] $comparison" {lappend templist $enzyme}
    }
  } else {
    foreach enzyme [enzyme_diffs $w] {
      if "[enz_count $w $enzyme $region] $comparison" {lappend templist $enzyme}
    }
  }
  return $templist
}

#################
## return the number of sites for enzyme in window
#################
proc enz_count {w enzyme region} {
  global info

  if {[$w.textarea tag ranges tempsel] == ""} {set region "all"}
  if {$region == "all"} {
    return [llength $info($w,$enzyme)]
  } else {
    set start [ix2bp $w.textarea [$w.textarea index tempsel.first]]
    incr start
    set end [ix2bp $w.textarea [$w.textarea index tempsel.last]]
    set i 0
    foreach site $info($w,$enzyme) {
      if {$site > $end} {break}
      if {$site >= $start} {incr i}
    }
    return $i
  }
}

#################
## retrun enzymes that have diff # cuts from w
#################
proc enzyme_diffs {w} {
  global ok2 wins wins_title analyze_selection info enzymes

  set a [toplevel .dialog -background $info(bg_color)]
  wm title $a [mc "Enzyme Difference..."]
  set ok 0
  wm protocol $a WM_DELETE_WINDOW "set ok2 -1"
  bind $a <KeyPress-Escape>  "set ok2 -1"
  set bindstore [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify $a; raise $a"
  bind $a <KeyPress-Escape>  "set ok2 -1"
  if {[winfo exists .enz_selector]} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .enz_selector] wgeom winx winy
    wm geometry $a "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient $a .enz_selector
    } else {
      ::tk::unsupported::MacWindowStyle style $a document {closeBox}
    }
  }

  grid [label $a.l1 -text "Window 1:" -font labelfont] -row 1 -column 0 -sticky w
  grid [label $a.l2 -text "$info($w,win_title)" -font labelfont] -row 1 -column 1 -sticky w
  grid [label $a.l3 -text  $info(analyze_selection) -font labelfont] -row 1 -column 2 -columnspan 3 -sticky w
  grid [label $a.l4 -text "Window 2:" -font labelfont] -row 2 -column 0 -sticky w

  set maxwidth 10
  menubutton $a.win -menu $a.win.win_menu -textvariable wins_title
  menu $a.win.win_menu -background $info(menu_bg_color) -foreground $info(menu_fg_color) -activebackground $info(menu_select_bg_color) -activeforeground $info(menu_select_fg_color)
  foreach window $info(dnawindows_list) {
      $a.win.win_menu add radiobutton -label $info($window,win_title) -variable wins -value $window -command "set wins_title \{$info($window,win_title)\}"
      if {[string length $info($window,win_title)] > $maxwidth} {set maxwidth [string length $info($window,win_title)]}   
  }
  if {$maxwidth > 200} {set maxwidth 200}
  incr maxwidth 3
  $a.win configure -width $maxwidth

  set wins $w
  set wins_title "$info($w,win_title)"
  grid $a.win -row 2 -column 1 -sticky we

  grid [checkbutton $a.local2 -height 1 -width 10 -variable analyze_selection -text [mc "Selection Only"] -onvalue "selection" -offvalue "all" -indicator on -selectcolor white] -row 2 -column 2 -sticky wns 
  set analyze_selection all

  grid [button $a.ok -text "OK" -command "set ok2 1" -default active] -row 3 -column 1 -padx 10 -pady 3
  grid columnconfigure $a 1 -weight 1

  bind $a <Key-Return> "$a.ok invoke"
  wm deiconify $a; raise $a; focus $a
  vwait ok2

  set templist [list]
  if {$ok2 == 1} {
    foreach enzyme $enzymes {
      if {[enz_count $w $enzyme $info(analyze_selection)] != [enz_count $wins $enzyme $analyze_selection]} {lappend templist $enzyme}
    }
  }
  bind . <<RaiseDialogs>> $bindstore
  destroy $a
  unset ok2 wins wins_title analyze_selection
  set templist
}

#################
## enter a different enzyme count condition
#################
proc enzyme_count_dialog {} {
  global ok2 info enzymes select_numsites_comp select_numsites_lab

  set a [toplevel .dialog -background $info(bg_color)]
  wm title $a [mc "Enzyme Count..."]
  set ok 0
  set ok2 0
  wm protocol $a WM_DELETE_WINDOW "set ok2 -1"
  set bindstore [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify $a; raise $a"
  bind $a <KeyPress-Escape>  "set ok2 -1"
  if {[winfo exists .enz_selector]} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .enz_selector] wgeom winx winy
    wm geometry $a "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient $a .enz_selector
    } else {
      ::tk::unsupported::MacWindowStyle style $a document {closeBox}
    }
  } else {
    return
  }

  grid [label $a.l1 -text "Count (ex <6  ==8):" -font labelfont] -row 1 -column 0 -sticky w
  grid [entry $a.l2 -font labelfont -width 10 -textvariable comparison] -row 1 -column 1 -sticky w


  grid [button $a.ok -text "OK" -command "set ok2 1" -default active] -row 3 -column 1 -padx 10 -pady 3
  grid columnconfigure $a 1 -weight 1

  bind $a <Key-Return> "$a.ok invoke"
  wm deiconify $a; raise $a; focus $a
  while {$ok2 == 0} {
    vwait ok2
    if {$ok2 == 1} {
      if {[catch {if "1 $comparison" {}}]} {
        set ok2 0
        set comparison "==1"
      } else {
        set select_numsites_comp
        set select_numsites_lab  $comparison
      }
    }
  }
  bind . <<RaiseDialogs>> $bindstore
  destroy $a
  unset ok2
}

#################
## manage the enzyme selector dialog enzyme textbox tags
#################
proc tagmanage {textbox action {taglist [list]}} {
  global enzymes
  global info

  switch $action {
    click {
       foreach etag $taglist {
          if {[$textbox tag cget $etag -background] == "red"} {
            $textbox tag configure $etag -background white
          } else {
            $textbox tag configure $etag -background red
          }
       }
    }
    add {
       foreach etag $taglist {
          $textbox tag configure $etag -background red
       }
    }
    remove {
       foreach etag $taglist {
          $textbox tag configure $etag -background white
       }
    }
    booland {
       foreach etag $enzymes {
          if {[lsearch -exact $taglist $etag] == -1} {
             $textbox tag configure $etag -background white  
          }
       }
    }
    diff {

    }
  }
  set info(enz_currently_selected) [list]
  foreach etag $enzymes {
    if {[$textbox tag cget $etag -background] == "red"} {
      lappend info(enz_currently_selected) $etag
    }
  }
}

##############
## Web query of Rebase for enzyme name
##############
proc rebase_query {enz {type main}} {
  regsub -all " " $enz "" enz
  switch $type {
    "main" {
      if {[set error [open_url "http://rebase.neb.com/cgi-bin/reb_get.pl?[::http::formatQuery enzname $enz]"]] != ""} {

      } 
    }
    "suppliers" {
      if {[set error [open_url "http://rebase.neb.com/cgi-bin/ecget?$enz"]] != ""} {

      }
    }
    "similar" {
      if {[set error [open_url "http://rebase.neb.com/cgi-bin/isoget?$enz"]] != ""} {

      }
    }
    "methylation" {
      if {[set error [open_url "http://rebase.neb.com/cgi-bin/msget?$enz"]] != ""} {

      }
    }
    "name" {
      #could get the html and check it for error before showing the page
      if {[set error [open_url "http://rebase.neb.com/rebase/enz/$enz.html"]] != ""} {

      }
    }
  }
}

##############
## Delete selected enzymes from the enzyme library
##############
proc delete_selected {enzyme_list} {
  global info
  global enz_select_window

  if {([llength $enzyme_list] == 0) || ([tk_messageBox -message "Are you sure you want to delete these [llength $enzyme_list] enzymes?" -type okcancel -default cancel  -icon question] == "cancel")} {
    return
  }
  wm deiconify .enz_selector
  .enz_selector configure -cursor watch
  .enz_selector.textframe.textbox configure -cursor watch
  update

  foreach enzyme $enzyme_list {
    delete_enzyme $enzyme
  }
  set info(enzymes_saved) 0
  foreach window $info(dnawindows_list) {
    set info($window,scanned) 0
    findenzymes $window
  }

  fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window
  .enz_selector configure -cursor arrow
  .enz_selector.textframe.textbox configure -cursor arrow
  .enz_selector.textframe.textbox configure -cursor arrow
  update
}

##############
## List enzymes Dialog
##############
proc list_enzymes_dialog {w} {
  global info
  global ok
  global analyze_selection
  global enzymes dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

##open configuration dialog
  toplevel .dialog -background $info(bg_color)
  wm title .dialog [mc "List Enzymes..."]
  set ok 0
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }

  set modelist [list [mc "Name"] [mc "Name, #Sites"] [mc "Name, Site, #Sites, Positions"] [mc "Site, Name"]]
  grid [frame .dialog.f1 -relief ridge -borderwidth 3] -row 0 -column 0  -sticky nwe
  grid [label .dialog.f1.label1 -text [mc "Format:"] ] -row 0 -column 0 -sticky w
  grid [menubutton .dialog.f1.formatmbutton -direction below -indicatoron 1 -textvariable info(enz_list_mode) -menu .dialog.f1.formatmbutton.menu] -row 0 -column 1 -sticky w
  menu .dialog.f1.formatmbutton.menu 
  foreach mode $modelist number {0 1 2 3} state {normal normal disabled disabled} {
    .dialog.f1.formatmbutton.menu add radiobutton -label $mode -variable info(enz_list_mode_number) -value $number -command "set info(enz_list_mode) \"$mode\"; .dialog.f1.colentry configure -state $state; .dialog.f1.label2 configure -state $state "
  }
  set info(enz_list_mode) [lindex $modelist $info(enz_list_mode_number)]
  bind .dialog.f1.formatmbutton.menu <<MenuSelect>> {focus .dialog}

  grid [label .dialog.f1.label2 -text [mc "Columns:"] ] -row 0 -column 2 -sticky w
  tk_optionMenu .dialog.f1.colentry info(enz_list_columns) 1 2 3 4 5 6 7 8 9 10
  .dialog.f1.colentry configure -state [lindex {normal normal disabled disabled} $info(enz_list_mode_number)]
  .dialog.f1.label2 configure -state  [lindex {normal normal disabled disabled} $info(enz_list_mode_number)]
  grid .dialog.f1.colentry -row 0 -column 3 -sticky w

  grid [frame .dialog.f3 -relief ridge -borderwidth 3] -row 1 -column 0  -sticky nwe
  grid [label .dialog.f3.label1 -text [mc "Enzymes:"] ] -row 0 -column 0 -sticky w
  grid [radiobutton .dialog.f3.allenz -text [mc "All"] -value "all" -variable info(enz_list_enz) -selectcolor white] -row 0 -column 1 -sticky w
  grid [radiobutton .dialog.f3.selenz -text [mc "Selected Enzymes Only"] -value "selected" -variable info(enz_list_enz) -selectcolor white] -row 0 -column 2 -sticky w
  grid [radiobutton .dialog.f3.absenz -text [mc "Absent Enzymes"] -value "absent" -variable info(enz_list_enz) -selectcolor white] -row 0 -column 3 -sticky w
  grid [radiobutton .dialog.f3.unienz -text [mc "Unique Enzymes"] -value "unique" -variable info(enz_list_enz) -selectcolor white] -row 0 -column 4 -sticky w

  set analyze_selection $info(analyze_selection)
  grid [frame .dialog.f4 -relief ridge -borderwidth 3] -row 2 -column 0  -sticky nwe
  grid [label .dialog.f4.label1 -text [mc "DNA:"]] -row 0 -column 0 -sticky w
  grid [radiobutton .dialog.f4.selall -text [mc "All"] -value "all" -variable analyze_selection -selectcolor white] -row 0 -column 1 -sticky w
  grid [radiobutton .dialog.f4.selonly -text [mc "Selected DNA only"] -value "selection" -variable analyze_selection -selectcolor white] -row 0 -column 2 -sticky w

  grid [button .dialog.ok -command {set ok 1} -text [mc "OK"]  -default active] -row 3 -column 0 -sticky n -padx 10 -pady 3
  bind .dialog <Key-Return> "set ok 1"
  grid columnconfigure .dialog 0 -weight 1

  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry .dialog "+$winx+$winy"
  wm resizable .dialog 0 0
  focus .dialog
  #grab .dialog
  vwait ok
  set dialogblock 0

  if {$ok == 1} {
    list_enzymes_window $w $info(enz_list_mode_number) $info(enz_list_enz) $analyze_selection
  }
  destroy .dialog
  bind . <<RaiseDialogs>> ""
  unset ok 

}


##############
## Make a list enzymes analysis window
##############
proc list_enzymes_window {w {mode ""} {enz_list_type ""} {region ""}} {
  global info

  if {$enz_list_type == ""} {
    set enz_list_type $info(enz_list_enz)
  }
  switch $enz_list_type {
    "all" {
      set title "All Enzymes"
    }
    "selected" {
      set title "Selected Sites"
    }
    "absent" {
      set title "Absent Sites"
    }
    "unique" {
      set title "Unique Sites"
    }
  }
  if {$region == ""} {
    set region $info(analyze_selection)
  }
  if {([$w.textarea tag ranges tempsel] == "") && ($region == "selection")} {set region "all"}
  if {$region == "all"} {
    set start 0
    set end [ix2bp $w.textarea [$w.textarea index end-1chars]]
  } else {
    set start [ix2bp $w.textarea [$w.textarea index tempsel.first]]
    set end [ix2bp $w.textarea [$w.textarea index tempsel.last]]
  }

  set a [new_analysis_window $w $title]
  create_textframe $a 120
    
  catch {$a.textframe.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
  $a.textframe.text insert end "$info($w,win_title) \n"
  $a.textframe.text insert end "[mc From] $start [mc to] $end\. \n\n"
  $a.textframe.text insert end "[mc $title]\n\n"
  set text [list_enzymes_text $w $mode $enz_list_type $region]
#mode: (sorted by *)
#0:*name    
#1:*name, #_of_sites       
#2:name, comment, *#_of_sites, position  
#3:*comment, name
  switch $mode {
    0 {
      $a.textframe.text configure -tabs "2.5c" -width 75
    }
    1 {
      $a.textframe.text configure -tabs "3c 4c 7c 8c 11c 12c 15c 16c 19c 20c 21c 24c 25c 28c" -width 100
    }
    2 {
      $a.textframe.text configure -tabs "2.5c 5.5c 6c" -width 100
    }
    3 {
      $a.textframe.text configure -tabs "6c " -width 50
    }
  }
  $a.textframe.text insert end $text
  $a.textframe.text configure -state disabled

  set outputmenu [add_output_menu $a.textframe.text "Text" text $w]
  bind $a <Button-1> "focus $a.textframe.text" 
  bindtags $a.textframe.text [list $a.textframe.text AnalysisText . all]
  wm deiconify $a
  window_on_screen $a
  focus $a.textframe.text
}

##############
## Make a list enzymes analysis text
##############
proc list_enzymes_text {w {mode ""} {enz_list_type ""} {region "all"} } {
  global info enzinfo
  global analyze_selection
  global enzymes
  if {$enz_list_type == ""} {
    set enz_list_type $info(enz_list_enz)
  }
  if {$mode == ""} {
    set mode $info(enz_list_mode_number)
  }
  if {([$w.textarea tag ranges tempsel] == "") && ($region == "selection")} {
    set region "all"
  }
  if {$region == "all"} {
    set start 0
    set end [ix2bp $w.textarea [$w.textarea index end-1chars]]
  } else {
    set start [ix2bp $w.textarea [$w.textarea index tempsel.first]]
    set end [ix2bp $w.textarea [$w.textarea index tempsel.last]]
  }
  findenzymes $w
  switch $enz_list_type {
    "all" {
      set enz_list $enzymes
    }
    "selected" {
      set enz_list $info(enz_currently_selected)
    }
    "absent" {
      set enz_list [enz_site_usage_filter $w $enzymes "==0" $region]
    }
    "unique" {
      set enz_list [enz_site_usage_filter $w $enzymes "==1" $region]
    }
  }
  set templist [list]
  foreach enzyme $enz_list {
    set sitelist [list]
    foreach site $info($w,$enzyme) {
      if {$site >= $end} {break}
      if {$site >= $start} {lappend sitelist $site}
    }
    lappend templist [list $enzyme [llength $sitelist] $sitelist $enzinfo(enz_pattern,$enzyme) [lindex $sitelist 0]]
  }
  set result ""
#mode: (sorted by *)
#0:*name    
#1:*name, #_of_sites       
#2:name, comment, *#_of_sites, position  
#3:*comment, name
  switch $mode {
    0 {
      set templist [lsort -index 0 $templist]
      set rows [expr {ceil(1.0*[llength $templist]/$info(enz_list_columns))}]
      set columns [expr {$info(enz_list_columns) - 1 }]
      for {set i 0} {$i < $rows} {incr i} {
        set spacer "\t"
        for {set j 0} {$j <= $columns} {incr j} {
          if {$j == $columns} {set spacer "\n"}
          if {[set enzyme [lindex $templist [expr {$i*$info(enz_list_columns)+$j}]]] != ""} {
            set result "$result[lindex $enzyme 0]$spacer"
          }
        }
      } 
    }
    1 {
      set templist [lsort -index 0 $templist]
      set rows [expr {ceil(1.0*[llength $templist]/$info(enz_list_columns))}]
      set columns [expr {$info(enz_list_columns) - 1 }]
      for {set i 0} {$i < $rows} {incr i} {
        set spacer "\t"
        for {set j 0} {$j <= $columns} {incr j} {
          if {$j == $columns} {set spacer "\n"}
          if {[set enzyme [lindex $templist [expr {$i*$info(enz_list_columns)+$j}]]] != ""} {
            set result "$result[lindex $enzyme 0]\t[lindex $enzyme 1]$spacer"
          }
        }
      }
    }
    2 {
      set templist [lsort -integer -index 1 $templist]
      foreach enzyme $templist {
        set result "$result[lindex $enzyme 0]\t[lindex $enzyme 3]\t[lindex $enzyme 1]\t[lindex $enzyme 2]\n"
      }
    }
    3 {
      set templist [lsort -index 3 $templist]
      foreach enzyme $templist {
        set result "$result[lindex $enzyme 3]\t[lindex $enzyme 0]\n"
      }
    }
  }
  return $result
}



##############
## Highlights the enzymes in list enz_list in window w
##############
proc highlight_enzymes {w enz_list} {
  global enzymes
  global enzinfo
  global info

  if {$info(enzyme_highlight_transparent)} {
    set bg_color {}
  } else {
    set bg_color $info(enzyme_highlight_color)
  }
  set font $info(enzyme_highlight_font)
  set underline $info(enzyme_highlight_underline)
  findenzymes $w


  set seq_end [ix2bp $w.textarea [$w.textarea index end-1c]]
  incr seq_end

  foreach enzyme $enzymes {
    $w.textarea tag delete $enzyme
  }

  foreach enzyme $enz_list { 
    set length [string length $enzinfo(flatpat,$enzyme)]
    #set comment $enzinfo(enz_comment,$enzyme)
    if {$info($w,circular) == "circular"} {
      foreach site $info($w,$enzyme) {
        $w.textarea tag add $enzyme [bp2ix $w.textarea [expr {$site -1}]] [bp2ix $w.textarea [expr {$site + $length -1}]]
        if {[expr {$site+$length}] > $seq_end} {
          $w.textarea tag add $enzyme 1.0 [bp2ix $w.textarea [expr ($site + $length- $seq_end)]]      
        }
      }
    } else {
      foreach site $info($w,$enzyme) {
        $w.textarea tag add $enzyme [bp2ix $w.textarea [expr {$site -1}]] [bp2ix $w.textarea [expr {$site + $length -1}]]
      }
    }
    $w.textarea tag configure $enzyme -background $bg_color -font $font -underline $underline
    #metadat format: (0)name, (1)special_info, (2)type, (3)fwd/rev, (4)annotations_string
    $w.textarea tag bind $enzyme <<Metadata>> [list $enzyme {} enzyme 0 $enzinfo(enz_comment,$enzyme)]
    #$w.textarea tag bind $enzyme <Any-Enter> "\[winfo parent %W\].infobox configure -text \"$enzyme: $comment\""
    #$w.textarea tag bind $enzyme <Any-Leave> "\[winfo parent %W\].infobox configure -text {}"
  }
}

##############
## Make a new window to contain an analysis result
##############
proc new_analysis_window {winlist title} {
  global info
  global modifier

  set w [lindex $winlist 0]
  set childlist [winfo children .]
  set i 0
  while {[lsearch -exact $childlist "$w\_analysis$i"] > -1 } {incr i}
  set a [toplevel "$w\_analysis$i"]
  foreach {w_width w_height w_x w_y} [split [wm geometry $w] +x] {}
  wm geometry $a +[expr {$w_x + ([winfo width $w] / 8)}]+[expr {$w_y + ([winfo height $w] / 8)}]
  bind $a <FocusIn> "event generate . <<RaiseDialogs>>"
  bind $a <Map> "event generate . <<RaiseDialogs>>"
  bind $a <Activate> "event generate . <<RaiseDialogs>>"
  bind $a <$modifier-Key-n> "create_window"
  bind $a <$modifier-Key-q> "close_all_windows"
  if {[tk windowingsystem] == "aqua"} {
      bind $a <$modifier-Key-m> "catch \{aqua_minimize $a\}"
      bind $a <$modifier-Key-quoteleft> "catch {raise \[lindex \[wm stackorder .\] 0\]}"
  }
  wm protocol $a WM_DELETE_WINDOW "closewindow $a"
  wm title $a "[wm title $w] [mc $title]"
  set info($a,linked_windows) $winlist
  update_windows_menu
  return $a
}


##############
## Add a double scrolled text ananysis frame
##############
proc create_textframe {a width {row 0} {column 0}} {
  set screen_fraction 0.5
  set text_height [expr {int([winfo screenheight .]*$screen_fraction/[font metrics dnafont -linespace])}]
  grid [frame $a.textframe] -row $row -column $column -sticky nswe
  grid [text $a.textframe.text -yscrollcommand "optionscrollbar $a.textframe.scrolly" -xscrollcommand "optionscrollbar $a.textframe.scrollx" -wrap none -width $width -height $text_height -font dnafont -setgrid 1 -insertontime 0 -insertofftime 1000] -row 0 -column 0 -rowspan 2 -sticky nswe

  grid [frame $a.textframe.spacer -width 2 -height 17] -row 2 -column 0 -sticky nswe
  grid [scrollbar $a.textframe.scrollx -orient horizontal -command "$a.textframe.text xview"] -row 2 -column 0 -sticky swe
  grid [scrollbar $a.textframe.scrolly -orient vertical -command "$a.textframe.text yview"] -row 0 -column 1 -sticky nse
  grid columnconfigure $a.textframe 0 -weight 1
  grid rowconfigure $a.textframe 0 -weight 1

  grid columnconfigure $a $column -weight 1
  grid rowconfigure $a $row -weight 1
}

##############
## Add the output menu to an analysis window
##############
proc add_output_menu {w label type return_window} {
  global info modifier modstring tk_patchLevel

  set top [winfo toplevel $w]
  if {[tk windowingsystem] != "aqua"} {
    set outputmenu [menu $w.outputmenu]
    bind $w <Button-3> "tk_popup $outputmenu %X %Y"
    #bind $top <Button-1> "if \{\[winfo ismapped $outputmenu\]\} \{$outputmenu unpost\}"
  } else {
    menu $top.menubar

    set filemenu [menu $top.menubar.filemenu]
    $top.menubar add cascade -menu $filemenu -label [mc "File"]
    $top.menubar.filemenu add command -label [mc "New"] -accelerator "$modstring+N" -command "create_window"
    $top.menubar.filemenu add command -label [mc "Open..."] -accelerator "$modstring+O"  -command "open_file_dialog"
    menu $top.menubar.filemenu.open_previous
    $top.menubar.filemenu add cascade -label [mc "Open Recent Files"] -menu $top.menubar.filemenu.open_previous
    if {[catch {update_open_previous_menu} err]} {tk_messageBox  -message "open previous: $err"}

    set outputmenu [menu $top.menubar.outputmenu]
    $top.menubar add cascade -menu $outputmenu -label [mc $label]

    menu $top.menubar.apple
    $top.menubar.apple add command -label [mc "About ApE"] -command "about_dialog $top"
    $top.menubar.apple add separator
    #$top.menubar.apple add command -label [mc "Preferences..."]  -command "configure_preferences $w" -accelerator "$modstring+,"
    $top.menubar add cascade -menu $top.menubar.apple

    $top.menubar add cascade -menu [menu $top.menubar.windows] -label [mc "Window"]
    update_windows_menu

    menu $top.menubar.help1
    $top.menubar add cascade -menu $top.menubar.help1 -label [mc "Help"]
    $top.menubar.help1 add command -label [mc "Standard Genetic Code"] -command "genetic_code_dialog $top"
    $top.menubar.help1 add command -label [mc "AA Info"] -command "aa_info_dialog $top"
    $top configure -menu $top.menubar
    bind $w <Button-2> "tk_popup $outputmenu %X %Y"
    bind $w <Control-Button-1> "tk_popup $outputmenu %X %Y"
  }

  switch $type {
    text {
      $outputmenu add command -label [mc "Copy"] -accelerator "$modstring+C" -command "event generate $w <<Copy>>"
      $outputmenu add command -label [mc "Save"] -accelerator "$modstring+S" -command "event generate $w <<Save>>"
      $outputmenu add separator
      $outputmenu add command -label [mc "Print"] -accelerator "$modstring+P" -command "event generate $w <<Print>>"
      if {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] > -1) ||  ([lsearch [package names] "wmf"] > -1)} {
        $outputmenu add command -label [mc "Page Setup"] -accelerator "$modstring+Shift+P" -command "page_setup_dialog $top"
        bind $w <$modifier-KeyPress-P> "event generate $w <<Print-Setup>>"
        bind $w <<Print-Setup>> "page_setup_dialog $top"
        $outputmenu add checkbutton -label [mc "Print with Color Formatting"] -variable info(print_formatted) -onvalue 1 -offvalue 0
      }
      $outputmenu add separator
      $outputmenu add command -label [mc "Raise Parent"] -accelerator "$modstring+Space" -command "event generate $w <<Return>>"
      $outputmenu add command -label [mc "Close"] -accelerator "$modstring+W" -command "closewindow $top"
      bind $w <$modifier-KeyPress-c> "event generate $w <<Copy>>"
      bind $w <$modifier-KeyPress-s> "event generate $w <<Save>>"
      bind $w <$modifier-KeyPress-p> "event generate $w <<Print>>"
      bind $w <$modifier-KeyPress-w> "closewindow $top"
      bind $w <$modifier-KeyPress-space> "event generate $w <<Return>>"
      bind $w <Double-Button-1> "event generate $w <<Return>>; break"
      bind $w <<Save>> "text_save $w"
      bind $w <<Print>> "print_text $w"
      bind $w <<Return>> "wm deiconify $return_window; raise $return_window; focus $return_window.textarea"
      lappend info($return_window,linked_events) [list $w <<Return>>]
    }
    image {
      set c $w
      if {([lsearch -exact [package names] "wmf"] > -1)} {
        $outputmenu add command -label [mc "Copy Metafile"] -accelerator "$modstring+C" -command "event generate $c <<CopyEMF>>"
        bind $c <$modifier-KeyPress-c> "event generate $c <<CopyEMF>>"
        bind $c <<CopyEMF>> "canvas_to_metafile copy $c both"
      }
      $outputmenu add command -label [mc "Save"] -accelerator "$modstring+S" -command "event generate $c <<Save>>"
      $outputmenu add separator
      $outputmenu add command -label [mc "Print"] -accelerator "$modstring+P" -command "event generate $c <<Print>>"
      if {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] > -1) ||  ([lsearch -exact [package names] "wmf"] > -1)} {
        $outputmenu add command -label [mc "Page Setup"] -accelerator "$modstring+Shift+P" -command "page_setup_dialog $top"
        bind $c <$modifier-KeyPress-P> "event generate $c <<Print-Setup>>"
        bind $c <<Print-Setup>> "page_setup_dialog $top"
      }
      $outputmenu add separator
      menu $outputmenu.scale
      $outputmenu add cascade -label [mc "Scale"] -menu $outputmenu.scale
        $outputmenu.scale add radiobutton -label [mc "50%"] -command "scale_canvas $c" -variable info($top,new_scale) -value 50
        $outputmenu.scale add radiobutton -label [mc "75%"] -command "scale_canvas $c" -variable info($top,new_scale) -value 75
        $outputmenu.scale add radiobutton -label [mc "100%"] -command "scale_canvas $c" -variable info($top,new_scale) -value 100
        $outputmenu.scale add radiobutton -label [mc "125%"] -command "scale_canvas $c" -variable info($top,new_scale) -value 125
        $outputmenu.scale add radiobutton -label [mc "150%"] -command "scale_canvas $c" -variable info($top,new_scale) -value 150
        $outputmenu.scale add radiobutton -label [mc "200%"] -command "scale_canvas $c" -variable info($top,new_scale) -value 200
        $outputmenu.scale add radiobutton -label [mc "300%"] -command "scale_canvas $c" -variable info($top,new_scale) -value 300
      $outputmenu add separator
      $outputmenu add command -label [mc "Raise Parent"] -accelerator "$modstring+Space" -command "event generate $c <<Return>>"
      $outputmenu add command -label [mc "Close"] -accelerator "$modstring+W" -command "closewindow $top"
      bind $c <$modifier-KeyPress-s> "event generate $c <<Save>>"
      bind $c <$modifier-KeyPress-p> "event generate $c <<Print>>"
      bind $c <$modifier-KeyPress-space> "event generate $c <<Return>>"
      bind $c <$modifier-KeyPress-w> "closewindow $top"
      bind $c <Double-Button-1> "event generate $c <<Return>>; break"
      bind $c <<Save>> "canvas_save $c"
      bind $c <<Print>> "print_canvas $c $c"
      bind $c <<Return>> "wm deiconify $return_window; raise $return_window; focus $return_window.textarea; break"
      lappend info($return_window,linked_events) [list $c <<Return>>]
    }
    none {
    }
  }
  return $outputmenu
}


##############
## Make a digest window
##############
proc enz_digest {w enz_list region {partial_list ""}} {
  global enzymes info modifier modstring toolbar_images

  set bandwidth 50
  set bandspacing 0.1

  #if {$enz_list == [list]} {
  #  enzyme_selection_dialog $w
  #  return 
  #}

  if {[$w.textarea tag ranges tempsel] == ""} {set region "all"}
  if {$region == "all"} {
    set start 1
    set total_length [ix2bp $w.textarea [$w.textarea index end-1chars]]
    set end $total_length
  } else {
    set start [ix2bp $w.textarea [$w.textarea index tempsel.first]]
    incr start 
    set end [ix2bp $w.textarea [$w.textarea index tempsel.last]]
    set total_length [expr {$end - $start+1}]
  }
  if {$total_length == 0} return
  incr end
  findenzymes $w

  set templist [list]
  foreach enzyme $enz_list {
    if {($region != "all") || ($info($w,circular) != "circular")} {
      ##on linear fragments reject sites that CUT outside the range
      foreach site $info($w,$enzyme) dir $info($w,enzdir,$enzyme) {
        if {$site >= $end} {break}
        if {$site >= $start} {
          set cutsitelist [enz_cut_offset $enzyme $site $dir]
          if {([lindex $cutsitelist 0] >= $start) && ([lindex $cutsitelist 1] >= $start) && ([lindex $cutsitelist 0] <= $end) && ([lindex $cutsitelist 1] <= $end)} {
            lappend templist [list $site $enzyme $dir]
          }
        }
      }
    } else {
      foreach site $info($w,$enzyme) dir $info($w,enzdir,$enzyme) {
        if {$site >= $end} {break}
        if {$site >= $start} {lappend templist [list $site $enzyme $dir]}
      }
    }
  }

  if {($region != "all") || ($info($w,circular) != "circular")} {
    lappend templist [list $start "Start" 0]
    lappend templist [list $end "End" 0]
  }
  set templist [lsort -integer -index 0 $templist]

  set fraglist [list]


###################old digest routine- no partials
if {0} {
  set i 0
  set lastsite [lindex [lindex $templist 0] 0]
  set lastenz [lindex [lindex $templist 0] 1]
  set lastsitedir [lindex [lindex $templist 0] 2]
  foreach pair [lrange $templist 1 end] {
    if {[expr {[lindex $pair 0]- $lastsite}] > 0} {
      lappend fraglist [list [expr {[lindex $pair 0]- $lastsite}] $lastenz $lastsite [lindex $pair 1] [lindex $pair 0] $i [expr {round(100.0*([lindex $pair 0]- $lastsite)/$total_length)}] $lastsitedir [lindex $pair 2]]
      set lastsite [lindex $pair 0]
      set lastenz [lindex $pair 1]
      set lastsitedir [lindex $pair 2]
      incr i
    }
  }
  if {($region == "all") && ($info($w,circular) == "circular")} {
    if {$templist != [list]} {
      lappend fraglist [list [expr {[lindex [lindex $templist 0] 0]+ $total_length - $lastsite}] $lastenz $lastsite [lindex [lindex $templist 0] 1] [lindex [lindex $templist 0] 0] $i [expr {round(100.0*([lindex [lindex $templist 0] 0]+ $total_length - $lastsite)/$total_length)}] $lastsitedir [lindex [lindex $templist 0] 2]]
    } else {    
      tk_messageBox -type ok -message "No Enzymes Cut -- Circular product." -default ok  -icon info
      return 
    }
  }
}
###################old digest routine- no partials
###################new digest routine
  set circular [expr {$info($w,circular) == "circular"}]
  set maxmassperc 1
  if {$partial_list == ""} {
    foreach enz $enz_list {
      set part($enz) 1.0
    }
  } else {
      array set part $partial_list
  }
  set part(Start) 1.0
  set part(End) 1.0
  set count 0
  for {set i 0} {$i < [llength $templist]} {incr i} {
    for {set j2 [expr {$i +1}]} {$j2 < [expr {[llength $templist] +($circular ? (1+$i) : 0)}]} {incr j2} {
      set j [expr {$j2 % [llength $templist]}]
      if {$i==$j} {
        set perc [expr {$part([lindex [lindex $templist $j] 1])}]
      } else {
        set perc [expr {$part([lindex [lindex $templist $i] 1]) * $part([lindex [lindex $templist $j] 1])}]
      }
      for {set k2 [expr {$i+1}]} {$k2 < $j2} {incr k2} {
        set k [expr {$k2 % [llength $templist]}]
        set perc [expr {$perc* (1.00-$part([lindex [lindex $templist $k] 1]))}]
      }
      if {$perc > 0} {
        if {[expr {([lindex [lindex $templist $j] 0] - [lindex [lindex $templist $i] 0]) % $total_length}] > 0} {
          set mass_perc [expr {round(max(1,(100.0*$perc* (([lindex [lindex $templist $j] 0] - [lindex [lindex $templist $i] 0]) % $total_length) / $total_length)))}]
        } else {
          set mass_perc [expr {round(max(1,(100.0*$perc)))}]
        }
        set maxmassperc [expr {max($maxmassperc, $mass_perc)}]
        lappend fraglist [list [expr {(([lindex [lindex $templist $j] 0] - [lindex [lindex $templist $i] 0]) % $total_length)==0 ? $total_length : (([lindex [lindex $templist $j] 0] - [lindex [lindex $templist $i] 0]) % $total_length)}] [lindex [lindex $templist $i] 1] [lindex [lindex $templist $i] 0] [lindex [lindex $templist $j] 1] [lindex [lindex $templist $j] 0] $count $mass_perc [lindex [lindex $templist $i] 2] [lindex [lindex $templist $j] 2]]
        incr count
      }
    }
  }
  if {$circular} {
    set perc 1.0
    foreach e $templist {
      set perc [expr {$perc * (1.00-$part([lindex $e 1])) }]
    }
    if {$perc > 0} {
      lappend fraglist [list  $total_length uncut 0 "" 0 $count [expr {round(100*$perc)}] 0 0]
        set maxmassperc [expr {max($maxmassperc, round(100*$perc))}]
    }
  }
  if {$fraglist == [list]} {
    lappend fraglist [list  $total_length uncut 0 "" 0 0 100 0 0]
  }
###################new digest routine
  set fraglist [lsort -integer -index 0 -decreasing $fraglist]
  set enz_list_label [join [lrange $enz_list 0 2] +]
  if {[llength $enz_list] > 3} {
    append enz_list_label " et al."
  }
  set a [new_analysis_window $w "[mc Digest] $enz_list_label"]  


  grid [canvas $a.t -yscrollcommand "optionscrollbar $a.s" -xscrollcommand "optionscrollbar $a.s2" -width 500 -height 250 -background white] -row 0 -column 0 -rowspan 2 -sticky nswe
  grid [scrollbar $a.s -orient vertical -command "$a.t yview"] -row 1 -column 1 -sticky nsw
  grid [label $a.infobutton -image $toolbar_images(info_button) -width 17 -relief flat -borderwidth 0] -row 0 -column 1 -sticky nsw
  bind $a.infobutton <Button-1> "$a.t itemconfigure !band -state hidden ; $a.t itemconfigure infotext -state normal"
  tooltip_install $a.infobutton [mc "Show lane info"]
  grid [scrollbar $a.s2 -orient horizontal -command "$a.t xview"] -row 2 -column 0 -sticky nwe
  grid rowconfigure $a 1 -weight 1
  grid columnconfigure $a 0 -weight 1
  grid columnconfigure $a 1 -minsize 17

  #draw file info
  #set timestring ""
  #catch {set timestring [clock format [clock seconds] -format $info(clock_format)]}

  #$a.t create text 0 0 -text "$timestring" -anchor nw -font [list $info(graphicfontfamily) $info(graphicfontsize)]-tags [list time table] 
  #set textheight [expr {[lindex [$a.t bbox time] 3] - [lindex [$a.t bbox time] 1]}]
  set textheight 0

  $a.t create text 0 [expr {$textheight}] -text "[wm title $w]" -anchor nw -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tags [list filename table text lane1]
  set textheight [expr {[lindex [$a.t bbox filename] 3] - [lindex [$a.t bbox filename] 1]}]

  #create dummy text to allow table coords and text properties to persist
  $a.t create text 0 [expr {$textheight}] -text "Dummy Text" -anchor nw -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tags [list dummy text] -state hidden


  set i 1
  #draw table header
  set colswidth [font measure [list $info(graphicfontfamily) $info(graphicfontsize)] "HindIII          "]
  set cols [list]
  for {set cw 0} {$cw < 6} {incr cw} {
    lappend cols [expr {$cw * $colswidth}]
  } 
  foreach ttext [list [mc "Size"] [mc "site1"] "" [mc "site2"] "" [mc "Mass %"]] tx $cols {
    $a.t create text $tx [expr {$i*$textheight}] -text $ttext -anchor nw -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tags [list table title text lane1]
  }
  incr i
  set textright [lindex [$a.t bbox title] 2]
  $a.t create line 0 [lindex [$a.t bbox title] 3] [lindex [$a.t bbox title] 2] [lindex [$a.t bbox title] 3] -tags {table title line lane1}

  
  #draw map area tick marks
  foreach site $templist {
    $a.t create line [expr {$textright + 5}] [expr {30+ ([lindex $site 0]-$start)* 210 / ($end - $start)}] [expr {$textright + 15}] [expr {30+ ([lindex $site 0]-$start)* 210 / ($end - $start)}] -tags  {scalable map line lane1}
    $a.t create text [expr {$textright + 17}] [expr {30+ ([lindex $site 0]-$start)* 210 / ($end - $start)}] -anchor w -text "[lindex $site 0] [lindex $site 1]" -tags {scalable map text lane1}
  }

  set mapright [lindex [$a.t bbox map] 2]
  if {$mapright == ""} {
    set mapright [expr {$textright + 5}]
  }

  #create an empty info text item
  $a.t create text 0 0 -anchor nw -font [list $info(graphicfontfamily) $info(graphicfontsize)] -width [expr {$mapright-15}] -tags [list infotext text] -state hidden

  #find short and long fragments for the canvas
  if {$info(ladderlist) != [list]} {
    set dig_ladder $info(ladder,$info(current_ladder))
  } else {
    set dig_ladder [list]
  }

  if {($dig_ladder != [list]) && ([lindex [lindex $fraglist end] 0] > [lindex $dig_ladder end])} {
    set shortfrag [lindex $dig_ladder end]
  } else {
    set shortfrag [lindex [lindex $fraglist end] 0]
  }
  if {$shortfrag < 10} {
    set shortfrag 10
  }

  if {($dig_ladder != [list]) && ([lindex [lindex $fraglist 0] 0] < [lindex $dig_ladder 0])} {
    set longfrag [lindex $dig_ladder 0]
  } else {
    set longfrag [lindex [lindex $fraglist 0] 0]
  }


  if {[lindex [lindex $fraglist 0] 0] > $shortfrag} {
    set gelscale [expr {210.0/(log10($longfrag)- log10($shortfrag))}]
  } else {
    set gelscale 20
  }
  set gelorigin [expr {30.0 + $gelscale * log10($longfrag) }]

  bind $a.t <<Info>> [list min_size [expr {round(10**(($gelorigin - 240)/$gelscale))}] max_size [expr {round(10**(($gelorigin - 30)/$gelscale))}] band_spacing $bandspacing]

  ##draw ladder
  set bandleft [expr {$mapright + ($bandwidth*$bandspacing)}]
  if {$dig_ladder != [list]} {
    set lastladderband 0
    foreach band $dig_ladder {
      if {$lastladderband != $band} {
        #draw new band
        if {[lindex $band 0] > 0} {
          set last_band_item [$a.t create line [expr {$bandleft}] [expr {$gelorigin - $gelscale * log10($band)}] [expr {$bandleft+$bandwidth}] [expr {$gelorigin - $gelscale *log10($band)}] -width 3 -capstyle round -activefill red -tags [list scalable band lane0]]
        }
        $a.t bind $last_band_item <<Size>> $band
        $a.t bind $last_band_item <<Gray_fill>> 100
        set lastladderband $band
      } else {
        #make last band wider
        $a.t itemconfigure $last_band_item -width [expr {[$a.t itemcget $last_band_item -width]+1}]
      }
    }
    $a.t create text [expr {$bandleft+$bandwidth/2}] 30 -text 1 -anchor s -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tags [list infotext lanelabel]

    set bandleft [expr {$bandleft + ($bandspacing+1) * $bandwidth}]

    set ladder_text "$info(current_ladder)\n[mc Sizes:] [join [lsort -unique -integer $dig_ladder] {, }]"
    $a.t bind lane0 <<Info>> [list info_text $ladder_text min_size [lindex $dig_ladder end] max_size [lindex $dig_ladder 0]]
  }


  ##draw digest items
  set fragnum 0
  set fragtexts [list]
    #draw lane label
    $a.t create text [expr {$bandleft+$bandwidth/2}] 30 -text 2 -anchor s -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tags [list infotext lanelabel]

  foreach fragment $fraglist {

    #draw table entry for the band
    foreach ttext [list [lindex $fragment 0] [lindex $fragment 1] [format %7d [lindex $fragment 2]] [lindex $fragment 3] [format %7d [lindex $fragment 4]] [format %5d [lindex $fragment 6]]] tx $cols   {
      $a.t create text $tx [expr {$i*$textheight}] -font [list $info(graphicfontfamily) $info(graphicfontsize)] -anchor nw -text $ttext -tags [list table table_text frag$fragnum lane1 action_item]
    }
    incr i



    #draw gel bands
    if {[lindex $fragment 0] > 0} {
      set band_gray [expr {round(max(10,(100.0*[lindex $fragment 6]/$maxmassperc)))}]
      set band_item [$a.t create line [expr {$bandleft}] [expr {$gelorigin - $gelscale * log10([lindex $fragment 0])}] [expr {$bandleft+$bandwidth}] [expr {$gelorigin - $gelscale *log10([lindex $fragment 0])}] -width 3 -capstyle round -tags [list frag$fragnum band lane1 scalable action_item] -activefill red -fill gray[expr {100-$band_gray}]]
        $a.t bind $band_item <<Size>> [lindex $fragment 0]
        $a.t bind $band_item <<Gray_fill>> $band_gray
        $a.t bind $band_item <<Mass_perc>> [lindex $fragment 6]
    }

    #draw map area line highlight
    if {[lindex $fragment 2] < [lindex $fragment 4]} {
      $a.t create line [expr {$textright + 5}] [expr {30+ ([lindex $fragment 2]-$start)* 210 / ($end - $start)}] [expr {$textright + 5}] [expr {30+ ([lindex $fragment 4]-$start)* 210 / ($end - $start)}] -width 3 -tags [list frag$fragnum map lane1 scalable action_item]
    } else {
      #needs to deal with band button presses for circular fragments
      $a.t create line [expr {$textright + 5}] 30 [expr {$textright + 5}] [expr {30+ ([lindex $fragment 4]-$start)* 210 / ($end - $start)}] -width 3 -tags  [list frag$fragnum map lane1 scalable action_item]
      $a.t create line [expr {$textright + 5}] [expr {30+ ([lindex $fragment 2]-$start)* 210 / ($end - $start)}] [expr {$textright + 5}] 240 -width 3 -tags  [list frag$fragnum map map_line2 lane1 scalable action_item]
    }

    foreach item [$a.t find withtag frag$fragnum] {
      #get top and bottom cut sites for each end (send enzyme_name, location, direction; get top and bottom cut locations)
      set cutsites_list1 [enz_cut_offset [lindex $fragment 1] [lindex $fragment 2] [lindex $fragment 7]]
      set cutsites_list2 [enz_cut_offset [lindex $fragment 3] [lindex $fragment 4] [lindex $fragment 8]]
      $a.t bind $item <<Link>> "$w [expr {[lindex $cutsites_list1 0]-1}] [expr {[lindex $cutsites_list2 0]-1}] [expr {[lindex $cutsites_list1 1]-1}] [expr {[lindex $cutsites_list2 1]-1}]"
      lappend info($w,linked_events) [list $a.t $item "<<Link>>"]
    }
    if {[lindex $fragment 3] ne ""} {
      lappend fragtexts "[lindex $fragment 0]([lindex $fragment 1]-[lindex $fragment 3])"
    } else {
      lappend fragtexts "[lindex $fragment 0]([lindex $fragment 1])"
    }
    incr fragnum
  }

  #create hidden map line dummy for aligning incoming lanes to
  $a.t create line [expr {$textright + 5}] 30 [expr {$textright + 5}] 240 -tags [list dummy line scalable] -state hidden
 
  set info_text "[file root [wm title $w]] "
  if {($enz_list == [list])} {
    append info_text [mc "uncut"]
  } else {
    append info_text "[mc {digested with:}] "
    if {[llength $enz_list] <=3} {
      if {$partial_list != [list]} {
        set enz_text_list [list]
        foreach ea [lrange $enz_list 0 2] {
          lappend enz_text_list "$ea\([expr {int(100*$part($ea))}]%)"
        }
        append info_text "[join [lrange $enz_text_list 0 2] { + }]\n"
      } else {
        append info_text "[join [lrange $enz_list 0 2] { + }]\n"
      }
    } else {
        append info_text "[mc {>3 enzymes}]\n"
    }
    append info_text [join $fragtexts {, }] 
  } 

  $a.t bind lane1 <<Info>> [list info_text $info_text min_size [lindex [lindex $fraglist end] 0] max_size [lindex [lindex $fraglist 0] 0]]

  #need to use an update_infotext proc here
  catch {$a.t itemconfigure infotext&&text -text [wrap_text "[mc {Lane %1$s:} 1] [dict get [$a.t bind lane0 <<Info>>] info_text]\n\n[mc {Lane %1$s:} 2] [dict get [$a.t bind lane1 <<Info>>] info_text]" [$a.t itemcget infotext&&text -font] [$a.t itemcget infotext&&text -width]]}

  #$a.t bind lane0 <Any-Enter> "%W itemconfigure !band -state hidden ; %W itemconfigure infotext -state normal"
  $a.t bind lane1 <Any-Enter> "%W itemconfigure !band -state hidden ;%W itemconfigure lane1 -state normal"

  $a.t bind band  <Any-Enter> "if {\[winfo exists .bandtooltip\]} {destroy .bandtooltip}; toplevel .bandtooltip -borderwidth 1 -background black; if {(\[tk windowingsystem\] == \"aqua\")} {tk::unsupported::MacWindowStyle style .bandtooltip help {noActivates noUpdates}} else { wm overrideredirect .bandtooltip 1}; catch {wm attributes .bandtooltip -alpha .7}; wm geometry .bandtooltip +\[expr {%X + 2}\]+\[expr {%Y - 20}\];  pack \[label .bandtooltip.l -background white -text \[$a.t bind \[$a.t find withtag current\] <<Size>>\]\]"
  $a.t bind band  <Any-Motion> "if {\[winfo exists .bandtooltip\]} {wm geometry .bandtooltip +\[expr {%X + 2}\]+\[expr {%Y - 20}\]}"
  $a.t bind band  <Any-Leave> "if {\[winfo exists .bandtooltip\]} {destroy .bandtooltip}"


  $a.t bind band <B1-Motion> "digest_peel_bands $a.t %X %Y"
  $a.t bind band <ButtonRelease-1> "catch {unset tooltip_x tooltip_y}; if {(\[winfo containing %X %Y\] != \"\") && \[winfo exists .tooltip\]} {destroy .tooltip; digest_move_lane $a.t %X %Y move} else {digest_action_item_manager $a.t button-1}"
  $a.t bind band <Shift-ButtonRelease-1> "catch {unset tooltip_x tooltip_y}; if {(\[winfo containing %X %Y\] != \"\") && \[winfo exists .tooltip\]} {destroy .tooltip; digest_move_lane $a.t %X %Y move} else {digest_action_item_manager $a.t shift-button-1}"
  $a.t bind band <$modifier-ButtonRelease-1> "catch {unset tooltip_x tooltip_y}; if {(\[winfo containing %X %Y\] != \"\") && \[winfo exists .tooltip\]} {destroy .tooltip; digest_move_lane $a.t %X %Y copy} else {digest_action_item_manager $a.t button-1}"
  if {[tk windowingsystem] eq "aqua"} {$a.t bind band <Option-ButtonRelease-1> [$a.t bind band <$modifier-ButtonRelease-1>]}
  bind $a.t <KeyPress-BackSpace> "digest_action_item_manager $a.t delete"
  bind $a.t <KeyPress-Delete> "digest_action_item_manager $a.t delete"

  $a.t bind action_item <Any-Enter> "digest_action_item_manager $a.t enter"
  $a.t bind action_item <Any-Leave> "digest_action_item_manager $a.t leave"
  $a.t bind action_item&&!band <Button-1> "digest_action_item_manager $a.t button-1"
  $a.t bind action_item&&!band <Shift-ButtonRelease-1> "digest_action_item_manager $a.t shift-button-1"

  $a.t configure -scrollregion [$a.t bbox all]

  #bind $a.t <Configure> "if {\[winfo height $a.t\] > 80} {$a.t scale scalable \[lindex \[$a.t bbox scalable\] 0\] \[lindex \[$a.t bbox scalable\] 1\] 1 \[expr \{(\[winfo height $a.t\]-60.0)/(\[lindex \[$a.t bbox scalable\] 3\]-\[lindex \[$a.t bbox scalable\] 1\])\}\]}; $a.t configure -scrollregion \[$a.t bbox all\]; digest_color_bands $a"
  bind $a.t <Configure> "if {\[winfo height $a.t\] > 80} {$a.t scale scalable 0 30 1 \[expr \{(\[winfo height $a.t\]-60.0)/(\[lindex \[$a.t bbox scalable\] 3\]-\[lindex \[$a.t bbox scalable\] 1\])\}\]}; $a.t configure -scrollregion \[$a.t bbox all\]; digest_color_bands $a"

  set outputmenu [add_output_menu $a.t "Image" image $w]
  set info($a,scale) 100
  set info($a,new_scale) 100

  bind $a.t <<Return>> "digest_action_item_manager $a.t return"
  bind $a.t <<Parent>> $w
  $outputmenu insert 0 command -label "Copy Text" -accelerator "$modstring+Shift+C" -command "event generate $a.t <<CopyText>>"
  bind $a.t <$modifier-KeyPress-C> "event generate $a.t <<CopyText>>"
  bind $a.t <<CopyText>> "\
    clipboard clear;\
    foreach row \[$a.t find withtag table&&(table_text||text)\] \{\
      clipboard append \"\[$a.t itemcget \$row -text\]\\n\"\
    \}"
  bindtags $a.t [list $a.t $a all]
  bind $a <Button-1> "focus $a.t" 
  wm deiconify $a
  foreach {x0 y0 x1 y1} [$a.t bbox all] {}
  wm geometry $a [expr {min ($x1 - $x0 + 30, ([winfo vrootwidth $a]-100))}]x[expr {min ($y1 - $y0 + 25, ([winfo vrootheight $a]-150))}]

  window_on_screen $a
  focus $a.t
}

#############
## partial digest dialog
#############
## need to implement maximizing a fragment starting at enz_site1 going to enz_site2 (use menubuttons to select sites)
##if 1==2 solve for p*(1-p)^n, set any other site to 0
##if 1 and 2 are same enz but different sites solve p^2*(1-p)^n, set any other site between to 0, not between to 100
##different enz solve p(1-p)^n*q(1-q)^m, set any other site between to 0, not between to 100
proc enz_digest_partial_dialog {w} {
  global info modifier dialogblock
  global ok part

  if {$dialogblock == 1} {return}
  if {$info(enz_currently_selected) == {}} {
    enz_digest $w $info(enz_currently_selected) $info(analyze_selection)
    return
  }
  set dialogblock 1
  set a [toplevel .dialog]
  wm title .dialog [mc "Partial Digest..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  if {$w != "."} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  }
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0

  grid [frame $a.enz_frame] -row 0 -column 1 -sticky nswe
  set r 0
  foreach enz $info(enz_currently_selected) {
    grid [label $a.enz_frame.label_$enz -text $enz] -row $r -column 0 -sticky nw
    grid [entry $a.enz_frame.entry_$enz -textvariable part($enz) -validate key -vcmd "check_char %S" -width 3 -justify right] -row $r -column 1 -sticky nw
    if {$info(use_tile)} {
      grid [ttk::scale $a.enz_frame.scale_$enz -from 0 -to 100 -command "set part($enz) \[expr {round(\$part($enz))}\];#" -orient horizontal -variable part($enz)] -row $r -column 2 -sticky nswe
    } else {
      grid [scale $a.enz_frame.scale_$enz -from 0 -to 100 -sliderrelief raised -showvalue 0 -resolution 1 -troughcolor white -background $info(bg_color) -width 10  -command "set part($enz) \[expr {round(\$part($enz))}\];#" -orient horizontal -variable part($enz)] -row 0 -column 1 -sticky nswe 
    }
    set part($enz) 100
    incr r
  }


  grid [frame $a.okframe] -row 3 -column 1 -sticky nswe
  grid [button $a.okframe.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 0 -sticky nw -padx 10 -pady 3
  grid [button $a.okframe.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 1 -sticky nw -padx 10 -pady 3
  vwait ok

  destroy $a
  set dialogblock 0
  bind . <<RaiseDialogs>> ""

  if {$ok == 1} {
    foreach enz $info(enz_currently_selected) {
      set part($enz) [expr {max(0,min($part($enz)/100.0, 1.0))}]
    }
    enz_digest $w $info(enz_currently_selected) $info(analyze_selection) [array get part]
  }
  unset ok part
}

#############
## implement item linking and higlighting on digest windows
#############
proc enz_cut_offset {enz loc dir} {
  global enzinfo

  if {[info exists enzinfo(enz_cut_sites,$enz)] && [info exists enzinfo(flatpat,$enz)]} {
    if {$dir} {
      #reverse site
      return [list [expr {$loc + [string length $enzinfo(flatpat,$enz)]- [lindex $enzinfo(enz_cut_sites,$enz) 1]}]  [expr {$loc  + [string length $enzinfo(flatpat,$enz)] - [lindex $enzinfo(enz_cut_sites,$enz) 0]}]]
    } else {
      #forward site
      return [list [expr {$loc + [lindex $enzinfo(enz_cut_sites,$enz) 0]}]  [expr {$loc + [lindex $enzinfo(enz_cut_sites,$enz) 1]}]]
    }
  } else {
      return [list $loc $loc]
  }
}

#############
## implement item linking and higlighting on digest windows
#############
proc wrap_text {text font width} {

  set result_list [list]
  foreach line [split $text \n] {
    set newline ""
    foreach word [split $line " "] {
      if {($newline == "")} {
        set newline $word
      } elseif {([font measure $font "$newline $word"] < $width)} {
        set newline "$newline $word"
      } else {
        lappend result_list $newline
        set newline $word
      }
    }
    lappend result_list $newline
  }
  return [join $result_list \n]
}

#############
## implement item linking and higlighting on digest windows
#############
proc digest_action_item_manager {c event} {
  if {[set item [$c find withtag current]] == ""} {
    if {$event ne "return"} {
      return
    } else {
      set parent [bind $c <<Parent>>]
      wm deiconify $parent; raise $parent; focus $parent.textarea
    }
  }

  set tag_list [$c itemcget current -tags]
  set fragstring [lsearch -regexp -inline $tag_list {frag[0-9]+}]
  set lanestring [lsearch -regexp -inline $tag_list {lane[0-9]+}]
  if {(($fragstring == "") && ($event ne "delete")) || ($lanestring == "")} {return}
  switch $event {
    enter {
      $c itemconfigure $lanestring&&$fragstring&&map -fill red -width 5
      #$c itemconfigure $lanestring&&$fragstring&&band -fill red -width 5
      $c itemconfigure $lanestring&&$fragstring&&band -fill red
      $c itemconfigure $lanestring&&$fragstring&&table_text -fill red
      $c raise $fragstring 
    }
    leave {
      $c itemconfigure $lanestring&&$fragstring&&map -fill black -width 3
      if {[$c bind [$c find withtag $lanestring&&$fragstring&&band] <<Gray_fill>>] != ""} {
        $c itemconfigure $lanestring&&$fragstring&&band -fill gray[expr {100-[$c bind [$c find withtag $lanestring&&$fragstring&&band] <<Gray_fill>>]}] -width 3    
      } else {
        $c itemconfigure $lanestring&&$fragstring&&band -fill black -width 3
      }
      $c itemconfigure $lanestring&&$fragstring&&table_text -fill black
    }
    button-1 {
      set link_list [$c bind $item <<Link>>]
      if {[string first tk_messageBox $link_list] > -1} {return}
      foreach {w first last first_bottom last_bottom} $link_list {}
      if {$link_list == {}} {
      } elseif {$first < $last} {
        select_region $w [bp2ix $w.textarea $first] [bp2ix $w.textarea $last]
      } elseif {[$c find withtag current&&$lanestring&&map_line2] != ""} {
        select_region $w [bp2ix $w.textarea $first] [$w.textarea index end-1c]
      } else {
        select_region $w 1.0 [bp2ix $w.textarea $last]
      }
    }
    shift-button-1 {
      set link_list [$c bind $item <<Link>>]
      if {[string first tk_messageBox $link_list] > -1} {return}
      foreach {w first last first_bottom last_bottom} $link_list {}
      if {$link_list == {}} {
      } elseif {$first < $last} {
        select_region $w [bp2ix $w.textarea $first] [bp2ix $w.textarea $last]
      } elseif {[$c find withtag current&&$lanestring&&map_line2] != ""} {
        select_region $w 1.0 [bp2ix $w.textarea $last]
      } else {
        select_region $w [bp2ix $w.textarea $first] [$w.textarea index end-1c]
      }
    }
    delete {
      if {[$c find withtag $lanestring] != ""} {
        global from_lane
        set from_lane $lanestring
        digest_move_lane $c [winfo pointerx .] [winfo pointery .] delete
      }
    }
    return {
      set link_list [$c bind $item <<Link>>]
      if {[string first tk_messageBox $link_list] > -1} {return}
      foreach {w first last first_bottom last_bottom} $link_list {}
      if {$link_list == {}} {
      } elseif {$first < $last} {
        select_region $w [bp2ix $w.textarea $first] [bp2ix $w.textarea $last]
      } elseif {[$c find withtag current&&$lanestring&&map_line2] != ""} {
        select_region $w [bp2ix $w.textarea $first] [$w.textarea index end-1c]
      } else {
        select_region $w 1.0 [bp2ix $w.textarea $last]
      }
      wm deiconify $w; raise $w; focus $w.textarea
    }
  }
}

#############
## move a lane from one digest canvas to another
#############
proc digest_move_lane {from_canvas X Y {mode move}} {

  global from_lane
  

  if {[catch {set to_window [winfo toplevel [winfo containing $X $Y]]}]} {
    set to_window ""
  }
  if {(![winfo exists $to_window.t]) || ([[set to_canvas $to_window.t] coords dummy&&line] == "") || (![info exists from_lane])} {
    catch {unset from_lane}
    return
  }



  if {($mode == "copy") || (($to_canvas != $from_canvas) && ($mode == "move"))} {
    #copy lane to the canvas
    set i 0
    while {([$to_canvas find withtag lane$i] != "") && ($i < 10000) } {incr i}
    set to_lane "lane$i"


    if {[$from_canvas find withtag table&&$from_lane] != ""} {
      #digest table items
      $to_canvas create text 0 0 -text [$from_canvas itemcget filename&&$from_lane -text] -anchor nw -font [$to_canvas itemcget dummy&&text -font] -tags [list filename table text $to_lane]
      set textheight [expr {[lindex [$to_canvas bbox filename] 3] - [lindex [$to_canvas bbox filename] 1]}]
      set colswidth [font measure [$to_canvas itemcget dummy&&text -font] "HindIII          "]
      set cols [list]
      for {set cw 0} {$cw < 6} {incr cw} {
        lappend cols [expr {$cw * $colswidth}]
      } 

      #draw the table header
      foreach ttextitem [$from_canvas find withtag table&&title&&text&&$from_lane] tx $cols {
        $to_canvas create text $tx $textheight -text [$from_canvas itemcget $ttextitem -text] -anchor nw -font [$to_canvas itemcget dummy&&text -font] -tags [list table title text $to_lane]
      }

      set textright [lindex [$to_canvas bbox title&&$to_lane] 2]
      $to_canvas create line 0  [lindex [$to_canvas bbox title&&$to_lane] 3] [lindex [$to_canvas bbox title&&$to_lane] 2] [lindex [$to_canvas bbox title&&$to_lane] 3]  -tags [list table title line $to_lane]

      set i 2
      set txi 0
      foreach table_item [lsort -integer [$from_canvas find withtag table_text&&$from_lane]] {
        if {[set fragnum [lsearch -regexp -inline [$from_canvas itemcget $table_item -tags] {frag[0-9]+}]] != ""} {
          set item [$to_canvas create text [lindex $cols $txi] [expr {$i*$textheight}] -font [$to_canvas itemcget dummy&&text -font] -anchor nw -text [$from_canvas itemcget $table_item -text] -tags [list table table_text $fragnum $to_lane action_item]]
          $to_canvas bind $item <<Link>> [$from_canvas bind $table_item <<Link>>]
          incr txi
          if {$txi == 6} {
            incr i
            set txi 0
          }
        }
      }
    }
    if {[$from_canvas find withtag map&&line&&$from_lane] != ""} {
      #draw map area tick marks
      foreach {map_x map_min_y map_x2 map_max_y} [$to_canvas coords dummy&&line] {}
      foreach {from_map_x from_map_min_y from_map_x2 from_map_max_y} [$from_canvas coords dummy&&line] {}
      set mapscale [expr {1.0 * ($map_max_y - $map_min_y) / ($from_map_max_y - $from_map_min_y)}]
      foreach from_tic [$from_canvas find withtag map&&line&&$from_lane] {
        $to_canvas create line $map_x [set tic_y [expr {1.0 * $map_min_y + $mapscale * ([lindex [$from_canvas coords $from_tic] 1] - $from_map_min_y)}]] [expr {$map_x + 10}] $tic_y -tags  [list {*}[lsearch -all -inline -regexp -not [$from_canvas itemcget $from_tic -tags] {lane[0-9]+}] $to_lane]
        # text is next item 
        incr from_tic
        $to_canvas create text [expr {$map_x + 12}] $tic_y -anchor w -text [$from_canvas itemcget $from_tic -text] -tags  [list {*}[lsearch -all -inline -regexp -not [$from_canvas itemcget $from_tic -tags] {lane[0-9]+}] $to_lane]
      }

      #draw map area fragment lines
      foreach from_map_line [$from_canvas find withtag map&&action_item&&$from_lane] {
        set item [$to_canvas create line $map_x [expr {1.0 * $map_min_y + $mapscale * ([lindex [$from_canvas coords $from_map_line] 1] - $from_map_min_y)}] $map_x [expr {1.0 * $map_min_y + $mapscale * ([lindex [$from_canvas coords $from_map_line] 3] - $from_map_min_y)}]  -width 3 -tags [list {*}[lsearch -all -inline -regexp -not [$from_canvas itemcget $from_map_line -tags] {lane[0-9]+}] $to_lane]]
        $to_canvas bind $item <<Link>> [$from_canvas bind $from_map_line <<Link>>]
      }
    }

    #draw bands
    foreach {map_x map_min_y map_x2 map_max_y} [$to_canvas coords dummy&&line] {}
    set to_info_dict [bind $to_canvas <<Info>>]
    set to_long_frag [dict get $to_info_dict max_size]
    set to_short_frag [dict get $to_info_dict min_size]
    set to_gelscale [expr {1.0* ($map_max_y - $map_min_y)/(log10($to_long_frag)- log10($to_short_frag))}]
    set to_gelorigin [expr {1.0* $map_min_y + $to_gelscale * log10($to_long_frag) }]

    if {[$to_canvas coords band] != ""} {
      foreach {band_x1 band_y band_x2 band_y2} [$to_canvas coords band] {}
      set bandwidth [expr {$band_x2 - $band_x1}]
    } else {

    }
    set band_spacing [dict get $to_info_dict band_spacing]
    set new_band_x1 [expr {[lindex [$to_canvas bbox band] 2] + $band_spacing * $bandwidth }]
    set new_longfrag $to_long_frag
    set new_shortfrag $to_short_frag
    foreach from_band [$from_canvas find withtag band&&$from_lane] {
      set band_size [$from_canvas bind $from_band <<Size>>]
      set band_gray [$from_canvas bind $from_band <<Gray_fill>>]
      if {$band_gray == ""} {set band_gray 100}
      set new_band [$to_canvas create line $new_band_x1 [expr {$to_gelorigin - $to_gelscale * log10($band_size)}] [expr {$new_band_x1 + $bandwidth}] [expr {$to_gelorigin - $to_gelscale *log10($band_size)}] -width [$from_canvas itemcget $from_band -width] -capstyle round -activefill red -fill gray[expr {100-$band_gray}] -tags [list {*}[lsearch -all -inline -regexp -not [$from_canvas itemcget $from_band -tags] {lane[0-9]+}] $to_lane]]
      set new_longfrag [expr {max ($new_longfrag, $band_size) }]
      set new_shortfrag [expr {min ($new_shortfrag, $band_size) }]
      $to_canvas bind $new_band <<Size>> $band_size
      $to_canvas bind $new_band <<Gray_fill>> $band_gray
      $to_canvas bind $new_band <<Mass_perc>> [$from_canvas bind $from_band <<Mass_perc>>]
      $to_canvas bind $new_band <<Link>> [$from_canvas bind $from_band <<Link>>]
    }

    #move band items to the right of the new map texts and down to the same y position as the old band items had
    if {[$to_canvas find withtag map] != ""} {
      $to_canvas itemconfigure map -state normal
      $to_canvas move band [expr {[lindex [$to_canvas bbox map] 2] - [lindex [$to_canvas bbox band] 0]}] [expr {($to_gelorigin - $to_gelscale * log10($to_long_frag)) - ($to_gelorigin - $to_gelscale * log10($new_longfrag))}]
    } else {
      $to_canvas move band [expr {[lindex [$to_canvas bbox infotext&&text] 2] - [lindex [$to_canvas bbox band] 0]}] [expr {($to_gelorigin - $to_gelscale * log10($to_long_frag)) - ($to_gelorigin - $to_gelscale * log10($new_longfrag))}]
    }

    #scale bands to the same total height as old band items
    $to_canvas scale band 0 [expr {($to_gelorigin - $to_gelscale * log10($to_long_frag))}] 1.0 [expr {(log10($to_short_frag) - log10($to_long_frag)) / (log10($new_shortfrag) - log10($new_longfrag)) }]

    $to_canvas bind $to_lane <<Info>> [$from_canvas bind $from_lane <<Info>>]
    $to_canvas bind $to_lane <Any-Enter> [regsub -all $from_lane [$from_canvas bind $from_lane <Any-Enter>] $to_lane]
    dict set to_info_dict max_size $new_longfrag
    dict set to_info_dict min_size $new_shortfrag
    bind $to_canvas <<Info>> $to_info_dict

    $to_canvas configure -scrollregion [$to_canvas bbox all]
    set a [winfo toplevel $to_canvas]
    foreach {x0 y0 x1 y1} [$to_canvas bbox all] {}
    wm geometry $a [expr {max (min($x1 - $x0 + 25, ([winfo vrootwidth $a]-100)), [winfo width $a] )}]x[winfo height $a]
    $to_canvas dtag current current
    $from_canvas dtag current current
    $to_canvas itemconfigure !band -state hidden ; $to_canvas itemconfigure infotext -state normal
    set to_lane_old_x [lindex [$to_canvas coords [lindex [$to_canvas find withtag $to_lane&&band] 0]] 0] 
  } else {
    #make the to_lane == $from_lane- move the lane only
    set to_lane $from_lane
    set to_lane_old_x [lindex [$from_canvas coords [lindex [$from_canvas find withtag $from_lane&&band] 0]] 0] 
    set to_info_dict [bind $to_canvas <<Info>>]
    set band_spacing [dict get $to_info_dict band_spacing]
    foreach {band_x1 band_y band_x2 band_y2} [$to_canvas coords band] {}
    set bandwidth [expr {$band_x2 - $band_x1}]

  }
  ## move to_lane bands into proper x position 
  set to_canvasx [expr {$X - [winfo rootx $to_canvas] + [$to_canvas canvasx 0]}]
  set to_canvasy [expr {$Y - [winfo rooty $to_canvas] + [$to_canvas canvasy 0]}]

  #move all bands right of the location moving band is coming from one space left
  foreach band [$to_canvas find withtag band] {
    set lane [lsearch -regexp -inline [$to_canvas gettags $band] {lane[0-9+]}]
    if {($lane != $to_lane) && ([lindex [$to_canvas coords $band] 0] > $to_lane_old_x)} {
      $to_canvas move $band [expr {(1.0 + $band_spacing) * -$bandwidth }] 0
    }
  }

  if {$mode != "delete"} {
    #move all bands right of the location moving band is going to one space right
    set all_x [list]
    set right_x [list]
    foreach band [$to_canvas find withtag band] {
      set lane [lsearch -regexp -inline [$to_canvas gettags $band] {lane[0-9+]}]
      if {($lane != $to_lane)} {
        lappend all_x [lindex [$to_canvas coords $band] 0] 
        if {([lindex [$to_canvas coords $band] 2] > $to_canvasx)} {
          lappend right_x [lindex [$to_canvas coords $band] 0]
          $to_canvas move $band [expr {(1.0+$band_spacing) * $bandwidth }] 0
        }
      }
    }
    # move the band from where it is to where its going
    if {$right_x != [list]} {
      set dest_x [lindex [lsort -real $right_x] 0]
      $to_canvas move band&&$to_lane [expr {$dest_x - $to_lane_old_x}] 0
    } elseif {$all_x != [list]} {
        set dest_x [lindex [lsort -real $all_x] end]
        $to_canvas move band&&$to_lane [expr {$dest_x - $to_lane_old_x+(1.0+$band_spacing) * $bandwidth }] 0
    }
  } else {
    #delete to_lane
    $to_canvas delete $to_lane
    catch {destroy .bandtooltip}
    if {[$to_canvas find withtag map] != ""} {
      $to_canvas itemconfigure map -state normal
      $to_canvas move band [expr {[lindex [$to_canvas bbox map] 2] - [lindex [$to_canvas bbox band] 0]}] 0
    } elseif {[$to_canvas find withtag band] != ""} {
      $to_canvas itemconfigure infotext&&text -state normal
      $to_canvas move band [expr {[lindex [$to_canvas bbox infotext&&text] 2] - [lindex [$to_canvas bbox band] 0]}] 0
    } else {
      closewindow [winfo toplevel $to_canvas]
      unset from_lane
      return
    }
  }

  set bandinfo [list]
  foreach band [$to_canvas find withtag band] {
    lappend bandinfo [list [lsearch -regexp -inline [$to_canvas gettags $band] {lane[0-9+]}] [lindex [$to_canvas coords $band] 0]]
  }
  set bandinfo [lsort -unique -real -index 1 $bandinfo]
  set infotext [list]
  set lanenum 1
  foreach band $bandinfo lanelabel [$to_canvas find withtag infotext&&lanelabel] {
    if {$band != ""} {
      lappend infotext "[mc {Lane %1$s:} $lanenum] [dict get [$to_canvas bind [lindex $band 0] <<Info>>] info_text]"
      if {$lanelabel == ""} {
        $to_canvas create text [expr {[lindex $band 1]+$bandwidth/2}] 30 -text $lanenum -anchor s -tags [list infotext lanelabel]
      } else {
        $to_canvas coords $lanelabel [expr {[lindex $band 1]+$bandwidth/2}] 30
        $to_canvas itemconfigure $lanelabel -text $lanenum
      }
    } else {
      $to_canvas delete $lanelabel
    }
    incr lanenum
  }
  catch {$to_canvas itemconfigure infotext&&text -text [wrap_text [join $infotext "\n\n"] [$to_canvas itemcget infotext&&text -font] [$to_canvas itemcget infotext&&text -width]]}
  digest_color_bands $to_window
  unset from_lane
}

#############
## bindings to implement a canvas drag and drop
#############
proc digest_peel_bands {c x y} {
  global tooltip_x tooltip_y from_lane
  if {[winfo exists .tooltip]} {
    wm geometry .tooltip +[expr {$x-$tooltip_x}]+[expr {$y-$tooltip_y}]
    if {[winfo containing $x $y] == $c} {
     # $c configure -cursor copyarrow
    } else {
     # $c configure -cursor {}
    }
  } elseif {![info exists tooltip_x]} {
    set tooltip_x $x
    set tooltip_y $y
  } elseif {([expr {abs($x - $tooltip_x)}] > 3) || ([expr {abs($y - $tooltip_y)}] > 3)} {
    if {[set from_lane [lsearch -regexp -inline [$c itemcget current -tags] {lane[0-9]+}]] == ""} {return}

    toplevel .tooltip -borderwidth 1 -background black
    if {([tk windowingsystem] == "aqua")} {
     # tk::unsupported::MacWindowStyle style .tooltip help {noActivates noUpdates}
      tk::unsupported::MacWindowStyle style .tooltip help {}
    } else { 
      wm overrideredirect .tooltip 1
    }
    catch {wm attributes .tooltip -alpha .4}
    pack [canvas .tooltip.c]
    foreach band [$c find withtag band&&$from_lane] {
      .tooltip.c create line {*}[$c coords $band] -width 3
    }
    .tooltip.c configure -scrollregion [$c bbox band&&$from_lane] -width [expr {[lindex [$c bbox band&&$from_lane] 2] - [lindex [$c bbox band&&$from_lane] 0]}] -height [expr {[lindex [$c bbox band&&$from_lane] 3] - [lindex [$c bbox band&&$from_lane] 1]}] 
    set tooltip_x [expr {round($x - [winfo rootx $c] + [$c canvasx 0] - [lindex [$c bbox band&&$from_lane] 0])}]
    set tooltip_y [expr {round($y -  [winfo rooty $c] + [$c canvasy 0]- [lindex [$c bbox band&&$from_lane] 1])}]
    wm geometry .tooltip +[expr {$x-$tooltip_x}]+[expr {$y-$tooltip_y}]
  }
}

#############
## recolor bands to represent the total mass percent of all overlapping bands
#############
proc digest_color_bands {a} {
  set halo 1
  foreach b [$a.t find withtag band] {
    set mp [$a.t bind $b <<Mass_perc>>]
    if {$mp != ""} {
      set lane [lsearch -regexp -inline [$a.t itemcget $b -tags] {lane[0-9]+}]
      set lanearr($b) $lane
      foreach {x0 y0 x1 y1} [$a.t coords $b] {}
      set effmassperc($b) 0
      foreach b2 [$a.t find overlapping [expr {($x0+$x1)/2}] [expr {$y0-$halo}] [expr {($x0+$x1)/2}] [expr {$y0+$halo}]] {
        if {[$a.t bind $b2 <<Mass_perc>>] ne ""} {
          set effmassperc($b) [expr {$effmassperc($b) + [$a.t bind $b2 <<Mass_perc>>]}]
        }
      }
      if {![info exists maxmasperc($lane)]} {
        set maxmasperc($lane) $effmassperc($b)
      } else {
        set maxmasperc($lane) [expr {max($effmassperc($b), $maxmasperc($lane))}]
      }
    }
  }
  foreach b [array names effmassperc] {
    set gray_fill [expr {round(max(10,(100.0* $effmassperc($b)/ $maxmasperc($lanearr($b)) )))}]
    $a.t itemconfigure $b -fill gray[expr {100-$gray_fill}]
    $a.t bind $b <<Gray_fill>> $gray_fill
  }
}


#############
## bindings to implement a canvas drag and drop
#############
proc drag_canvas {} {
#####under_construction
set c .dna_window1_analysis0.t
bind $c <Button-1> {toplevel .tooltip -borderwidth 1 -background black; if {([tk windowingsystem] == "aqua")} {tk::unsupported::MacWindowStyle style .tooltip help {noActivates noUpdates}} else { wm overrideredirect .tooltip 1}; catch {wm attributes .tooltip -alpha .4}; wm geometry .tooltip +%X+%Y; pack [canvas .tooltip.c]}
bind $c <B1-Motion> "wm geometry .tooltip +%X+%Y"
bind $c <ButtonRelease-1> {destroy .tooltip; if {[winfo containing %X %Y] != ""} {sputs [winfo toplevel [winfo containing %X %Y]]}}


#listbox bindings
toplevel .t
pack [set l [listbox .t.l]]
.t.l insert end aaa
.t.l insert end bbb
.t.l insert end ccc
.t.l insert end ddd
bind $l <B1-Motion> {if {![info exists listmove]} {set listmove [.t.l index @%x,%y]; toplevel .tooltip -borderwidth 1 -background black; if {([tk windowingsystem] == "aqua")} {tk::unsupported::MacWindowStyle style .tooltip help {noActivates noUpdates}} else { wm overrideredirect .tooltip 1}; wm attributes .tooltip -alpha .4; wm geometry .tooltip +%X+%Y; pack [label .tooltip.l -text [.t.l get $listmove]]} else {wm geometry .tooltip +%X+%Y}}
bind $l <ButtonRelease-1> {if {[info exists listmove]} {destroy .tooltip; if {[winfo containing %X %Y] == ".t.l"} {if {[.t.l index @%x,%y] <= $listmove} {.t.l insert @%x,%y [.t.l get $listmove]; incr listmove ; .t.l delete $listmove} else {.t.l insert [expr {[.t.l index @%x,%y] +1}] [.t.l get $listmove] ; .t.l delete $listmove}}; unset listmove}}



}

###treeview drag and drop moves
#bind $t <B1-Motion> "treeview_move $t %x %y"
proc treeview_move {t x y} {
  global listmove

  if {(![info exists listmove])} {
    set g [$t identify row $x $y]
    if {$g == {} || ([lsearch [$t children {}] $g] == -1) } return
    set listmove $g
    toplevel .tooltip -borderwidth 1 -background black
    if {([tk windowingsystem] == "aqua")} {
      tk::unsupported::MacWindowStyle style .tooltip help {noActivates noUpdates}
    } else {
      wm overrideredirect .tooltip 1
    }
    wm attributes .tooltip -alpha .4
    wm geometry .tooltip +[expr {[winfo rootx $t]+$x}]+[expr {[winfo rooty $t]+$y}]
    pack [label .tooltip.l -text [$t item $g -text]]
  } else {
    wm geometry .tooltip +[expr {[winfo rootx $t]+$x}]+[expr {[winfo rooty $t]+$y}]
    if {$y < 0} {
      $t yview scroll -1 unit
    } elseif {$y > [winfo height $t]} {
      $t yview scroll 1 unit
    }
  }
}

#bind $t <ButtonRelease-1> "treeview_release $t %x %y"
proc treeview_release {t x y} {
  global listmove
  if {[info exists listmove]} {
    destroy .tooltip
    if {[set g [$t identify row $x $y]] != {}} {
      while {[$t parent $g] != {}} {
        set g [$t parent $g]
      }
      $t move $listmove {} [lsearch [$t children {}] $g]
    }
    unset listmove
  }
}

#############
##
#############
proc enz_text_map {w {dialog 1}} {
  global info
  global enzymes
  global ok
  global modifier
  global modstring
  global analyze_selection dialogblock


  if {$info(enz_text_width) == ""} {set info(enz_text_width) 100}
##open configuration dialog
  if {$dialog} {
    if {$dialogblock == 1} {return}
    set dialogblock 1
    toplevel .dialog
    wm title .dialog [mc "Configure Text Map..."]
    set ok 0
    wm protocol .dialog WM_DELETE_WINDOW "set ok -1"

    bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
    bind .dialog <KeyPress-Escape>  "set ok -1"
    #bind .dialog <FocusIn> "event generate . <<RaiseDialogs>>;focus %W"
    bind .dialog <Map> "event generate . <<RaiseDialogs>>"
    bind .dialog <Activate> "event generate . <<RaiseDialogs>>"

    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient .dialog $w
    } else {
      ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
    }

    set i 0

    foreach frame $info(enz_text_dialog_order) {
      switch $frame {
        enzymes {
          grid [labelframe .dialog.enzymes -relief ridge -borderwidth 3 -text [mc "Enzymes"]] -row $i -column 0  -sticky nwe
          set show_variable "enz_text_show_enz"
          grid [radiobutton .dialog.enzymes.allenz -text [mc "All"] -value "all" -variable info(enz_text_enz) -selectcolor white -activebackground $info(bg_color)] -row 1 -column 0 -sticky w
          grid [radiobutton .dialog.enzymes.selenz -text [mc "Selected Enzymes Only"] -value "selected" -variable info(enz_text_enz) -selectcolor white -activebackground $info(bg_color)] -row 1 -column 1 -sticky w
          grid columnconfigure .dialog.enzymes 1 -weight 1 -pad 0
        }

        dna {
          set analyze_selection $info(analyze_selection)
          grid [labelframe .dialog.dna -relief ridge -borderwidth 3 -text [mc "DNA"] -font labelfont] -row $i -column 0  -sticky nwe
          grid [frame .dialog.dna.showframe -relief flat] -row 0 -column 0 -columnspan 2 -sticky w
          grid [radiobutton .dialog.dna.showframe.selall -text [mc "All"] -value "all" -variable analyze_selection -selectcolor white -activebackground $info(bg_color)] -row 0 -column 2 -sticky w
          grid [radiobutton .dialog.dna.showframe.selonly -text [mc "Selected DNA only"] -value "selection" -variable analyze_selection -selectcolor white -activebackground $info(bg_color)] -row 0 -column 3 -sticky w
          grid [checkbutton .dialog.dna.copyhighlight -text [mc "Copy Highlighting"] -onvalue 1 -offvalue 0 -variable info(enz_text_copy_highlight) -selectcolor white -activebackground $info(bg_color)] -row 1 -column 0 -sticky w
          grid [frame .dialog.dna.lineframe -relief flat] -row 2 -column 0 -columnspan 2
          grid [label .dialog.dna.lineframe.widthlabel -text [mc "Characters/line:"]] -row 0 -column 0 -sticky w
          grid [entry .dialog.dna.lineframe.width -width 4 -textvariable info(enz_text_width) -validate key -vcmd "check_char %S"] -row 0 -column 1 -sticky w
          grid [label .dialog.dna.lineframe.numberslabel -text [mc "Line Numbers:"]] -row 0 -column 2 -sticky e
          #need line #s on left for alignlink to work, but not for alignlink2
          set line_num_menu [tk_optionMenu .dialog.dna.lineframe.numbers info(enz_text_dna_numbers) None Left Right Both]
          #set line_num_menu [tk_optionMenu .dialog.dna.lineframe.numbers info(enz_text_dna_numbers) Left Both]
          grid .dialog.dna.lineframe.numbers -row 0 -column 3 -sticky e
          grid columnconfigure .dialog.dna.lineframe 2 -weight 1 -pad 0
          #grid columnconfigure .dialog.dna 0 -weight 1 -pad 0
          #grid columnconfigure .dialog.dna 1 -weight 1 -pad 0
          grid columnconfigure .dialog.dna 2 -weight 1 -pad 0
        }

        sec_strand {
          grid [labelframe .dialog.sec_strand -relief ridge -borderwidth 3 -text [mc "2nd Strand"]] -row $i -column 0 -sticky nwe
          set show_variable "enz_text_2nd"
          grid columnconfigure .dialog.sec_strand 0 -weight 1 -pad 0
        }

        translation {
          grid [labelframe .dialog.translation -relief ridge -borderwidth 3 -text [mc "Translation"]] -row $i -column 0  -sticky nwe
          set show_variable "enz_text_show_trans"
          grid [radiobutton .dialog.translation.11 -text [mc "1 frame 1 letter"] -value "1_1" -variable info(enz_text_trans) -selectcolor white -activebackground $info(bg_color)] -row 1 -column 1 -sticky w
          grid [radiobutton .dialog.translation.31 -text [mc "3 frame 1 letter"] -value "3_1" -variable info(enz_text_trans) -selectcolor white -activebackground $info(bg_color)] -row 1 -column 2 -sticky w
          grid [radiobutton .dialog.translation.61 -text [mc "6 frame 1 letter"] -value "6_1" -variable info(enz_text_trans) -selectcolor white -activebackground $info(bg_color)] -row 1 -column 3 -sticky w
          grid [radiobutton .dialog.translation.13 -text [mc "1 frame 3 letter"] -value "1_3" -variable info(enz_text_trans) -selectcolor white -activebackground $info(bg_color)] -row 2 -column 1 -sticky w
          grid [radiobutton .dialog.translation.33 -text [mc "3 frame 3 letter"] -value "3_3" -variable info(enz_text_trans) -selectcolor white -activebackground $info(bg_color)] -row 2 -column 2 -sticky w
          grid [radiobutton .dialog.translation.63 -text [mc "6 frame 3 letter"] -value "6_3" -variable info(enz_text_trans) -selectcolor white -activebackground $info(bg_color)] -row 2 -column 3 -sticky w
          grid columnconfigure .dialog.translation 0 -weight 1 -pad 0
        }

        genes {
          grid [labelframe .dialog.genes -relief ridge -borderwidth 3 -text [mc "Uppercase as Genes"]] -row $i -column 0 -sticky nwe
          set show_variable "enz_text_genes"
          grid columnconfigure .dialog.genes 0 -weight 1 -pad 0
        }

        index {
          grid [labelframe .dialog.index -relief ridge -borderwidth 3 -text [mc "Index Line"]] -row $i -column 0  -sticky nwe
          set show_variable "enz_text_show_index"
          if {[tk windowingsystem] == "aqua"} {
            set char1_menu [tk_optionMenu .dialog.index.char1 info(enz_text_index_char1) " " "+" "*" ":" "|" "." "^" "\b-"]
          } else {
            set char1_menu [tk_optionMenu .dialog.index.char1 info(enz_text_index_char1) " " "+" "*" ":" "|" "." "^" "-"]
          }
          grid .dialog.index.char1 -row 1 -column 0 -sticky w
          #grid [entry .dialog.index.char1 -width 1  -textvariable info(enz_text_index_char1)] -row 1 -column 0 -sticky w
          grid [label .dialog.index.l1a -text [mc "character every"]] -row 1 -column 1 -sticky w
          grid [entry .dialog.index.spacing1 -width 3  -textvariable info(enz_text_index_spacing1) -validate key -vcmd "check_char %S"] -row 1 -column 2 -sticky w
          grid [label .dialog.index.l1b -text [mc "bases."]] -row 1 -column 3 -sticky w
          grid [checkbutton .dialog.index.nums -text [mc "Numbers"]  -onvalue 1 -offvalue 0 -variable info(enz_text_index_nums) -selectcolor white -activebackground $info(bg_color)] -row 1 -column 4 -sticky w

          if {[tk windowingsystem] == "aqua"} {
            set char2_menu [tk_optionMenu .dialog.index.char2 info(enz_text_index_char2) " " "+" "*" ":" "|" "." "^" "\b-"]
          } else {
            set char2_menu [tk_optionMenu .dialog.index.char2 info(enz_text_index_char2) " " "+" "*" ":" "|" "." "^" "-"]
          }
          grid .dialog.index.char2 -row 2 -column 0 -sticky w
          #grid [entry .dialog.index.char2 -width 1  -textvariable info(enz_text_index_char2)] -row 2 -column 0 -sticky w
          grid [label .dialog.index.l2a -text [mc "character every"]] -row 2 -column 1 -sticky w
          grid [entry .dialog.index.spacing2 -width 3  -textvariable info(enz_text_index_spacing2) -validate key -vcmd "check_char %S"] -row 2 -column 2 -sticky w
          grid [label .dialog.index.l2b -text [mc "bases."]] -row 2 -column 3 -sticky w
          #set char3_menu [tk_optionMenu .dialog.index.char3 info(enz_text_index_char3) " " "+" "*" ":" "|" "." "^" " -"]
          #grid .dialog.index.char3 -row 3 -column 0 -sticky w
          ##grid [entry .dialog.index.char3 -width 1  -textvariable info(enz_text_index_char3)] -row 3 -column 0 -sticky w
          #grid [label .dialog.index.l3a -text [mc "character every base."]] -row 3 -column 1 -columnspan 2 -sticky w
          grid columnconfigure .dialog.index 4 -weight 1 -pad 0
        }

        features {
          grid [labelframe .dialog.features -relief ridge -borderwidth 3 -text [mc "Features"]] -row $i -column 0  -sticky nwe
          set show_variable "enz_text_show_features"
          grid columnconfigure .dialog.features 1 -weight 1 -pad 0
        }
        default {
          set del_index [lsearch -exact $info(enz_text_dialog_order) $frame]
          sputs deleting invalid text map frame:$frame
          set info(enz_text_dialog_order) [lreplace $info(enz_text_dialog_order) $del_index $del_index]
        }
      }
      if {($frame != "dna") && [winfo exists .dialog.$frame] } {
        .dialog.$frame configure -fg [expr {$info($show_variable)?$info(label_fg_color):"gray35"}] -font labelfont -bd 3
        foreach e [winfo children .dialog.$frame] {
          catch {$e configure -state [expr {$info($show_variable)?"normal":"disabled"}]}
        }
        grid [frame .dialog.$frame.showframe -relief flat] -row 0 -column 0 -columnspan 2 -sticky w
        grid [checkbutton .dialog.$frame.showframe.check1 -text [mc "Show"] -onvalue 1 -offvalue 0 -variable info($show_variable) -selectcolor white -activebackground $info(bg_color)] -row 0 -column 2 -sticky w
        .dialog.$frame.showframe.check1 configure -command "
          .dialog.$frame configure -fg \[expr {\$info($show_variable)?\"black\":\"gray35\"}\]
          foreach e \[winfo children .dialog.$frame\] {
            if {\$e != \".dialog.$frame.showframe.check1\"} {
              catch {\$e configure -state \[expr {\$info($show_variable)?\"normal\":\"disabled\"}\]}
            }
          }"
      }
      incr i

bind .dialog.$frame <B1-Motion> "if {!\[info exists listmove\]} {set listmove \.dialog.$frame; toplevel .tooltip -borderwidth 1 -background black; if {(\[tk windowingsystem\] == \"aqua\")} {tk::unsupported::MacWindowStyle style .tooltip help {noActivates noUpdates}} else { wm overrideredirect .tooltip 1}; catch {wm attributes .tooltip -alpha .4}; wm geometry .tooltip +%X+%Y; pack \[label .tooltip.l -text \[.dialog.$frame cget -text\]\]} else {wm geometry .tooltip +%X+%Y}"
bind .dialog.$frame <ButtonRelease-1> {if {[winfo exists .tooltip]} {destroy .tooltip}; if {[info exists listmove]} {text_map_frame_drag $listmove %X %Y;unset listmove}}
    }


    grid [frame .dialog.okframe -relief flat -borderwidth 1] -row $i -column 0  -sticky nwe
    #grid [button .dialog.okframe.raise_dialog -command text_map_dialog_frame_listbox -text [mc "Stacking Order"]] -padx 10 -row 1 -column 0 -sticky n -pady 3 
    grid [label .dialog.okframe.raise_instr -text [mc "Drag frames to set the display order"]] -row 0 -column 0 -sticky n -columnspan 3
    grid [button .dialog.okframe.cancel -command {set ok -1} -text [mc "Cancel"]] -padx 10  -pady 3 -row 1 -column 1 -sticky n
    grid [button .dialog.okframe.ok -command {set ok 1} -text [mc "OK"]  -default active] -padx 10  -pady 3 -row 1 -column 2 -sticky n -padx 10 -pady 3
    bind .dialog <Key-Return> "set ok 1"
    grid columnconfigure .dialog 0 -weight 1
    wm resizable .dialog 0 0

    update idletasks
    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .dialog "+$winx+$winy"

    focus .dialog
    vwait ok
    set dialogblock 0
    destroy .dialog
    bind . <<RaiseDialogs>> ""
    if {$ok != 1} {return}
    unset ok
    if {$info(enz_text_enz) == "selected"} {
      set enzlist $info(enz_currently_selected)
    } else {
      set enzlist $enzymes
    }
  } else {
    ###No dialog
    set analyze_selection $info(analyze_selection)
     if {$info(enz_currently_selected) != {}} {
      set enzlist $info(enz_currently_selected)
     } else {
      set enzlist $enzymes
     }
  }
  do_text_map $w $enzlist $analyze_selection 
}

#############
## move frames up and down in text_map dialog- not used now
#############
proc text_map_dialog_raise_lower {frame direction} {
  global info
  set index [lsearch $info(enz_text_dialog_order) $frame]
  if {($index+ $direction > -1) && ($index + $direction < [llength $info(enz_text_dialog_order)])} {
    if {$direction == 1} {
      set info(enz_text_dialog_order) [lreplace $info(enz_text_dialog_order) $index [expr {$index +1}] [lindex $info(enz_text_dialog_order) [expr {$index +1}]] [lindex $info(enz_text_dialog_order) $index]]
    } else {
      set info(enz_text_dialog_order) [lreplace $info(enz_text_dialog_order) [expr {$index - 1}] $index [lindex $info(enz_text_dialog_order) $index] [lindex $info(enz_text_dialog_order) [expr {$index - 1}]]]
    }
    set i 0
    foreach frame $info(enz_text_dialog_order) {
      grid configure .dialog.$frame -row $i
      incr i
    }
  }
}

#############
## move frames up and down in text_map dialog by drag and drop
#############
proc text_map_frame_drag {drag_frame drop_x drop_y} {
  global info
  if {([regexp {\.dialog\.([^\.]*).*} [winfo containing $drop_x $drop_y] noop drop_frame]) && ([set drop_frame_index [lsearch -exact $info(enz_text_dialog_order) $drop_frame]] > -1)} {
    regexp {\.dialog\.(.*)} $drag_frame none drag_frame
    set drag_frame_index [lsearch -exact $info(enz_text_dialog_order) $drag_frame]
    set info(enz_text_dialog_order) [lreplace $info(enz_text_dialog_order) $drag_frame_index $drag_frame_index]
    set info(enz_text_dialog_order) [linsert $info(enz_text_dialog_order) $drop_frame_index $drag_frame]   
  }
  set i 0
  foreach frame $info(enz_text_dialog_order) {
    grid configure .dialog.$frame -row $i
    incr i
  }
}

#############
## move frames up and down in text_map with dialog--listbox
#############
proc text_map_dialog_frame_listbox {} {
  global info ok2

  set w ".dialog"
  toplevel .dialog2
  wm title .dialog2 [mc "Text Map Item Order..."]
  set ok2 0
  wm protocol .dialog2 WM_DELETE_WINDOW "set ok2 -1"
  set old_bind [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify .dialog2; raise .dialog2"
  bind .dialog2 <KeyPress-Escape>  "set ok2 -1"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry .dialog2 "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog2 $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog2 document {closeBox}
  }

  grid [listbox .dialog2.list -bg $info(text_bg_color) -height [llength $info(enz_text_dialog_order)]] -row 1 -column 1
  grid [frame .dialog2.raiseframe] -row 2 -column 1 -sticky nwe
  grid [button .dialog2.raiseframe.raise -text [mc "Raise"] -command "event generate .dialog2.list <<Raise>>"] -row 0 -column 1 -padx 10 -pady 3
  grid [button .dialog2.raiseframe.lower -text [mc "Lower"] -command "event generate .dialog2.list <<Lower>>"] -row 0 -column 2 -padx 10 -pady 3
  grid [button .dialog2.ok -command {set ok2 1} -text [mc "OK"]  -default active] -row 3 -column 1 -sticky n -padx 10 -pady 3
  bind .dialog2 <Key-Return> "set ok2 1"
  grid columnconfigure .dialog2 1 -weight 1
  wm resizable .dialog 0 0

  foreach frame $info(enz_text_dialog_order) {
    .dialog2.list insert end [string map {enzymes Enzymes dna DNA features Features index "Index Line" translation Translation sec_strand "2nd Strand" genes Genes} $frame]
  }
  .dialog2.list selection set 0

  bind .dialog2.list <<Raise>> {
    if {[set i [.dialog2.list curselection]] > 0} {
      set t [.dialog2.list get $i]
      .dialog2.list delete $i
      .dialog2.list insert [expr {$i -1}] $t
      .dialog2.list selection set [expr {$i -1}]
    }
  }
  bind .dialog2.list <<Lower>> {
    if {[set i [.dialog2.list curselection]] < [expr {[.dialog2.list index end]-1}]} {
      set t [.dialog2.list get $i]
      .dialog2.list delete $i
      .dialog2.list insert [expr {$i +1}] $t
      .dialog2.list selection set [expr {$i +1}]
    }
  }
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog2] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry .dialog2 "+$winx+$winy"

  focus .dialog2
  set ok2 0
  vwait ok2
  ##needed to get around the bug in menus- \b is used as a non-printing leader to "-"
  set info(enz_text_index_char2) [string index $info(enz_text_index_char2) end]
  set info(enz_text_index_char1) [string index $info(enz_text_index_char1) end]


  set list_store [.dialog2.list get 0 end]
  destroy .dialog2
  bind . <<RaiseDialogs>> $old_bind
  if {$ok2 != 1} {unset ok2; return}
  unset ok2
  set info(enz_text_dialog_order) [list]
  foreach frame_name $list_store {
    lappend info(enz_text_dialog_order) [string map {Enzymes enzymes DNA dna Features features "Index Line" index Translation translation "2nd Strand" sec_strand Genes genes} $frame_name]
  }
  set i 0
  foreach frame $info(enz_text_dialog_order) {
    grid configure .dialog.$frame -row $i
    incr i
  }
}

#############
## Make the Text map analysis window
#############
proc do_text_map {w enzlist analyze_selection} {
  global info modifier
  set region $analyze_selection

  if {[$w.textarea tag ranges tempsel] == ""} {set region "all"}
  if {$region == "all"} {
    set start 0
    set total_length [ix2bp $w.textarea [$w.textarea index end-1chars]]
    set end $total_length
  } else {
    set start [ix2bp $w.textarea [$w.textarea index tempsel.first]]
    set end [ix2bp $w.textarea [$w.textarea index tempsel.last]]
    set total_length [expr {$end - $start}]
  }

  if {$total_length < 1} return
  findenzymes $w



  set a [new_analysis_window $w "Text Map"]

  create_textframe $a [expr {$info(enz_text_width)+21}]

  set text [textarea_get $w.textarea [bp2ix $w.textarea $start] [bp2ix $w.textarea $end]]

  #initialize text lines that can be generated for the full sequence
  if {$info(enz_text_show_trans)} {
    #reminder:proc translate {dna {chars 1} {direction 1} {spacing 0}} {}
    switch $info(enz_text_trans) {
      off {set trans [list]}
      "1_1" {
        set trans [list [translate $text 1 1 2]]  
      }
      "3_1" {
        set trans [list "[translate $text 1 1 2]" " [translate [string range $text 1 end] 1 1 2]" "  [translate [string range $text 2 end] 1 1 2]"]
      }
      "6_1" {
        set trans [list "[translate $text 1 1 2]" " [translate [string range $text 1 end] 1 1 2]" "  [translate [string range $text 2 end] 1 1 2]" "[translate [string range $text 0 end] 1 -1 2]" " [translate [string range $text 1 end] 1 -1 2]" "  [translate [string range $text 2 end] 1 -1 2]" ]
      }
      "1_3" {
        set trans [list [translate $text 3 1 0]]
      }
      "3_3" {
        set trans [list "[translate $text 3 1 0]" " [translate [string range $text 1 end] 3 1 0]" "  [translate [string range $text 2 end] 3 1 0]"]
      }
        "6_3" {
       set trans [list [translate $text 3 1 0] [translate [string range $text 1 end] 3 1 0] [translate [string range $text 2 end] 3 1 0] [translate [string range $text 0 end-[expr {[string length $text] % 3}]] 3 -1 0] [translate [string range $text 0 end-[expr {1+([string length $text] % 3)}]] 3 -1 0] [translate [string range $text 0 end-[expr {2+([string length $text] % 3)}]] 3 -1 0]]
      }
    }
  }

  if {$info(enz_text_show_features)} {
    set tag_list [get_tags $w.textarea [list [bp2ix $w.textarea $start] [bp2ix $w.textarea $end]]]
    foreach {tag data} $tag_list {
      if {[regexp {f[0-9]+#} $tag]} {
        set metadata_index [lsearch -exact [lindex $data 2] <<Metadata>>]
        set type [lindex [lindex [lindex $data 3] $metadata_index] 2]
        if {[string toupper $type] == "CDS"} {
          set dir [lindex [lindex [lindex $data 3] $metadata_index] 3]
          set cds_text [get_cds $w $tag]
          set cds_trans "[translate $cds_text 1 [expr {$dir?-1:1}] 2]  "
          set fn_tag [string replace $tag 0 0 fn]
          set tag_ranges [$w.textarea tag ranges $tag]
          set fn_tag_ranges [$w.textarea tag ranges $fn_tag]
          #rotate the tanslation string if feature goes through origin
          set f_store($tag,split) 0
          set f_store($tag,dir) $dir
          if {([llength $fn_tag_ranges] == 0) && ([llength $tag_ranges] == 4)} {
            #no fn_tag, passes through origin
            set split [expr {[ix2bp $w.textarea [lindex $tag_ranges 3]] - [ix2bp $w.textarea [lindex $tag_ranges 2]]}]
            set cds_trans "[string range $cds_trans $split end][string range $cds_trans 0 [expr {$split-1}]]"
            set f_store($tag,split) $split
          } elseif {[llength $fn_tag_ranges] == 4} {
            #fn tag, through origin
            set split 0
            foreach {f0 f1} [lrange $tag_ranges [lsearch -exact $tag_ranges [lindex $fn_tag_ranges 2]] end] {
              incr split [expr {[ix2bp $w.textarea $f1]- [ix2bp $w.textarea $f0]}]
            }
            set cds_trans "[string range $cds_trans $split end][string range $cds_trans 0 [expr {$split-1}]]"
            set f_store($tag,split) $split
          }
          set fstart 0
          foreach {f0 f1} $tag_ranges {
            set f0 [ix2bp $w.textarea $f0]
            if {$start < $f0} break
            set f1 [ix2bp $w.textarea $f1]
            if {$start < $f1} {
              incr fstart [expr {$start - $f0}]
            } else {
              incr fstart [expr {$f1 - $f0}]
            }
          }
          set f_store($tag) $cds_trans
          set f_store($tag,start) $fstart
        }
      }
    }
  }

  if {$info(enz_text_genes) == 1} {
    set geneslist [uppercase_cdna $text]
    set genesline [translate [lindex $geneslist 0] 1 1 2]
    foreach intron [lsort -decreasing -integer -index 0 [lindex $geneslist 1]] {
      set genesline "[string range $genesline 0 [expr {[lindex $intron 0]-1}]][string repeat " " [lindex $intron 1]][string range $genesline [lindex $intron 0] end]"
    }
  }

  set enz_line_above [expr {[lsearch $info(enz_text_dialog_order) "enzymes"] < [lsearch $info(enz_text_dialog_order) "dna"]}]
  set index_line_above [expr {[lsearch $info(enz_text_dialog_order) "index"] < [lsearch $info(enz_text_dialog_order) "dna"]}]


  ##start output
  catch {$a.textframe.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
  $a.textframe.text insert end "$info($w,win_title)\nText Map\n"

#put the output out 1 line at a time ($info(enz_text_width) bp per line)
  for {set x 0} {$x < [expr {[string length $text]}]} {incr x $info(enz_text_width)} {
    set linelength [expr {[string length $text]- $x}]
    if {$linelength > $info(enz_text_width)} {
      set linelength $info(enz_text_width)
    }
    foreach frame $info(enz_text_dialog_order) {
      switch $frame {
        enzymes {
          if {$info(enz_text_show_enz)} {
            set templist [linear_enz_sort $w $enzlist [expr {$start+$x+1}] [expr {$start+$x+$linelength}]]
            #set tickline [string repeat "         *" [expr {$linelength /10}]]
            set tickline [string repeat " " $linelength]
            foreach pair $templist {
              set i 0
              while {([info exists enzline($i)]) && ([string length $enzline($i)] >= [expr {[lindex $pair 0]-$start - $x -1}])} {
                incr i
              }
              if {![info exists enzline($i)]} {
                set enzline($i) ""
                set maxi $i
              }
              set tickline [string replace $tickline [expr {[lindex $pair 0] -$start - $x -1}] [expr {[lindex $pair 0] - $start - $x -1}] "|"]
              set enzline($i) "$enzline($i)[string repeat " " [expr {[lindex $pair 0] - $start - $x -1 -[string length $enzline($i)]}]][lindex $pair 0] [lindex $pair 1]"
            }
            if {[info exists enzline(0)]} {
              if {$enz_line_above} {
                for {set i $maxi} {$i >= 0} {incr i -1} {
                  $a.textframe.text insert end "[string repeat " " 7]$enzline($i)\n"
               }
                $a.textframe.text insert end "[string repeat " " 7]$tickline\n"
              } else {
                $a.textframe.text insert end "[string repeat " " 7]$tickline\n"
                for {set i 0} {$i <= $maxi} {incr i} {
                  $a.textframe.text insert end "[string repeat " " 7]$enzline($i)\n"
                }
              }
              unset i maxi enzline
            }
            unset templist tickline
          }
        }

        dna {
          set textline [string range $text $x [expr {$x+$linelength-1}]]
          if {($info(enz_text_dna_numbers) == "Left") || ($info(enz_text_dna_numbers) == "Both")} {
            $a.textframe.text insert end "[string repeat " " [expr {6-[string length [expr {$x+$start+1}]]}]][expr {$x+$start+1}] " 
          } else {
            $a.textframe.text insert end "[string repeat " " 7]" 
          }
          set lstag "ls[expr {$x+$start+1}]_1"
          $a.textframe.text insert end $textline [list dnatag $lstag]
          if {($info(enz_text_dna_numbers) == "Right") || ($info(enz_text_dna_numbers) == "Both")} {
            $a.textframe.text insert end " [expr {$x+$start+$linelength}]\n"
          } else {
            $a.textframe.text insert end " \n"
          }

          if {$info(enz_text_copy_highlight)} {
            copy_tags $w.textarea [list [bp2ix $w.textarea [expr {$x+$start}]] [bp2ix $w.textarea [expr {$x+$start+$linelength-1}]]] $a.textframe.text [$a.textframe.text index "end-2line linestart +7char"] "forward" ""
          }
        }

        sec_strand {
          if {$info(enz_text_2nd) == 1} {
            $a.textframe.text insert end "[string repeat " " 7][string map {A T B V C G D H G C H D K M M K N N R Y S S T A V B W W Y R a t b v c g d h g c h d k m m k n n r y s s t a v b w w y r} $textline]\n"
          }
        }

        translation {
          if {$info(enz_text_show_trans)} {
            foreach transline $trans {
              $a.textframe.text insert end "[string repeat " " 7][string range $transline $x [expr {$x+$linelength-1}]]\n"
            }
          }
        }

        index {
          if {$info(enz_text_show_index)} {
            set start_index [expr {$x+$start+1}]
            set tickline "[string repeat " " [expr {$info(enz_text_index_spacing2)-1-(($start_index-1) % $info(enz_text_index_spacing2))}]]$info(enz_text_index_char2)"
            set tickline "$tickline[string repeat "[string repeat " " [expr {$info(enz_text_index_spacing2)-1}]]$info(enz_text_index_char2)" [expr {$linelength/$info(enz_text_index_spacing2)}]]"
            set tickline [string range $tickline 0 [expr {$linelength-1}]]
            set first_index [expr {$info(enz_text_index_spacing1)-1-(($start_index-1) % $info(enz_text_index_spacing1))}]

            set numline "[string repeat " " 7]"
            set first_num [expr {$start_index + $info(enz_text_index_spacing1) - ($start_index % $info(enz_text_index_spacing1))}]
            #set tickline [string replace $tickline $first_index $first_index $info(enz_text_index_char1)]
            #set numline "[string repeat " " [expr {7+$first_index-([string length $first_num] / 2)}]]$first_num"
            for {set i $first_index} {$i < $linelength} {incr i $info(enz_text_index_spacing1)} {
              set tickline [string replace $tickline $i $i $info(enz_text_index_char1)]
              set numline "$numline[string repeat " " $info(enz_text_index_spacing1)]"
              set numline "[string range $numline 0 [expr {7-1+$i-([string length $first_num] / 2)}]]$first_num"
              incr first_num $info(enz_text_index_spacing1)
            }
      
            if {$index_line_above} {
              if {$info(enz_text_index_nums)} {
                $a.textframe.text insert end "$numline\n"
              }
              $a.textframe.text insert end "[string repeat " " 7]$tickline\n"
            } else {
              $a.textframe.text insert end "[string repeat " " 7]$tickline\n"
              if {$info(enz_text_index_nums)} {
                $a.textframe.text insert end "$numline\n"
              }
            }
          }
        }
        genes {
          if {$info(enz_text_genes) == 1} {
            $a.textframe.text insert end "[string repeat " " 7][string range $genesline $x [expr {$x+$linelength-1}]]\n"
          }
        }
        features {
          if {$info(enz_text_show_features)} {
            set tag_space 3
            set fea_char(0) ">"
            set fea_char(1) "<"
            set gap_char(0) "."
            set gap_char(1) "."
            set tag_list [get_tags $w.textarea [list [bp2ix $w.textarea [expr {$x+$start}]] [bp2ix $w.textarea [expr {$x+$start+$linelength}]]]]
            set i 0
            foreach {tag data} $tag_list {
              if {[regexp {f[0-9]+#} $tag]} {
                set fn_tag [string replace $tag 0 0 fn]
                set metadata_index [lsearch -exact [lindex $data 2] <<Metadata>>]
                set dir [lindex [lindex [lindex $data 3] $metadata_index] 3]
                set type [lindex [lindex [lindex $data 3] $metadata_index] 2]
                if {[set fn_list_loc [lsearch -exact $tag_list $fn_tag]] != -1} {
                  set start_index [lindex [lindex [lindex $tag_list [expr {$fn_list_loc+1}]] 0] 0]
                  set end_index [lindex [lindex [lindex $tag_list [expr {$fn_list_loc+1}]] 0] 1]
                } else {
                  set start_index [lindex [lindex $data 0] 0]
                  set end_index [lindex [lindex $data 0] 1]
                }
                set i 0
                while {([info exists fea_line($i)]) && (([expr {[string length $fea_line($i)]+$tag_space}] >= $start_index) || ([expr {[string length $name_line($i)]+$tag_space}] >= $start_index))} {
                  incr i
                }
                
                if {![info exists fea_line($i)]} {
                  set fea_line($i) ""
                  set name_line($i) ""
                  set trans_line($i) ""
                  set trans_index_line($i) ""
                }
                #move feature and name lines over to start_index
                set fea_line($i) "$fea_line($i)[string repeat " " [expr {$start_index-[string length $fea_line($i)]}]]"
                set name_line($i) "$name_line($i)[string repeat " " [expr {$start_index-[string length $name_line($i)]}]]"
                #fill in the feature line
                if {$fn_list_loc > -1} {
                  set fea_line($i) "$fea_line($i)[string repeat $gap_char($dir) [expr {$end_index-$start_index}]]"
                  foreach {f0 f1} [lindex $data 0] {
                    set fea_line($i) [string replace $fea_line($i) $f0 [expr {$f1-1}] [string repeat $fea_char($dir) [expr {$f1-$f0}]]]
                  }
                } else {
                  set fea_line($i) "$fea_line($i)[string repeat $fea_char($dir) [expr {$end_index-$start_index}]]"
                }
                #fill in the trans line (if cds translation)
                if {[info exists f_store($tag)]} {
                  set trans_line($i) "$trans_line($i)[string repeat " " [expr {$start_index-[string length $trans_line($i)]}]]"
                  set trans_index_line($i) "$trans_index_line($i)[string repeat " " [expr {$start_index-[string length $trans_index_line($i)]}]]"
                  set trans_start_index [expr {([regexp -all {[^\s]} [string range $f_store($tag) 0 [expr {$f_store($tag,start)-1}]]] +($f_store($tag,split)+2)/3)% ([string length $f_store($tag)]/3) + 1}]
                  if {$f_store($tag,dir)} {
                    set trans_start_index [expr {[string length $f_store($tag)]/3- $trans_start_index+1}]
                  }
                  if {$fn_list_loc > -1} {
                    set trans_line($i) "$trans_line($i)[string repeat " " [expr {$end_index-$start_index}]]"
                    set trans_index_line($i) "$trans_index_line($i)[string repeat " " [expr {[lindex [lindex $data 0] 0]- 2-[string length $trans_index_line($i)]}]]"
                    foreach {f0 f1} [lindex $data 0] {
#numbering aa in trans line
#needs to know the rotation of through index features, and the direction
#sputs text_map_i possible start aa number $tag [expr {[regexp -all {[^\s]} [string range $f_store($tag) 0 [expr {$f_store($tag,start)-1}]]] + 1}]
#sputs text_map_ib $f_store($tag) $f_store($tag,start)
                      set trans_line($i) [string replace $trans_line($i) $f0 [expr {$f1-1}] [string range $f_store($tag) $f_store($tag,start) [expr {[incr f_store($tag,start) [expr {$f1-$f0}]]-1}]]]

                    }
                  } else {
#numbering aa in trans line
#needs to know the rotation of through index features, and the direction
#sputs text_map_i2 possible start aa number $tag [expr {[regexp -all {[^\s]} [string range $f_store($tag) 0 [expr {$f_store($tag,start)-1}]]] + 1}]
#sputs text_map_2b $f_store($tag) $f_store($tag,start)
                    set trans_line($i) "$trans_line($i)[string range $f_store($tag) $f_store($tag,start) [expr {[incr f_store($tag,start) [expr {$end_index-$start_index}]]-1}]]"
                  }
                  set trans_index_line($i) "$trans_index_line($i)$trans_start_index"
                }
                #fill in the name line
                set name_line($i) "$name_line($i)[lindex [lindex [lindex $data 3] $metadata_index] 0]"
              } elseif {([regexp {fn[0-9]+#} $tag]) && ([lsearch -exact $tag_list [set f_tag [string replace $tag 0 1 f]]] == -1)} {
               #fn tag without an f tag (all gap cahracters)
                set i 0
                while {[info exists fea_line($i)]} {
                  incr i
                }
                set metadata [$w.textarea tag bind $f_tag <<Metadata>>]
                set fea_line($i) [string repeat $gap_char([lindex $metadata 3]) $linelength]
                set name_line($i) [lindex $metadata 0]
              }
            }; #foreach tag
            set j 0
            while {[info exists fea_line($j)]} {
              if {[info exists trans_line($j)] && ($trans_line($j) != "")} {
                $a.textframe.text insert end "[string repeat " " 7]$trans_line($j)\n" 
                $a.textframe.text insert end "[string repeat " " 7]$trans_index_line($j)\n" 
              }
              $a.textframe.text insert end "[string repeat " " 7]$fea_line($j)\n" 
              $a.textframe.text insert end "[string repeat " " 7]$name_line($j)\n" 
              incr j
            }
            if {[info exists fea_line]} {
              unset fea_line
              unset name_line
            }
            if {[info exists trans_line]} {
              unset trans_line
            }
            unset i
          }; #if show features
        }
      }; #case
    }; #foreach frame
    if {$info(enz_text_show_enz) || $info(enz_text_2nd) || $info(enz_text_show_trans) || $info(enz_text_show_index) || $info(enz_text_genes) || $info(enz_text_show_features)} {
      $a.textframe.text insert end "\n"
    }
  }

  foreach tag [$w.textarea tag names] {
     if {[lsearch -exact [$a.textframe.text tag names] $tag] > -1} {
       $a.textframe.text tag raise $tag
     }
  }

  $a.textframe.text tag bind dnatag <Double-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] goto 1; break"
  $a.textframe.text tag bind dnatag <Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] goto 0; break"
  $a.textframe.text tag bind dnatag <Shift-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] select 0; break"
  $a.textframe.text tag bind dnatag <Shift-Double-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] select 1; break"
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Double-Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Shift-Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Shift-Double-Button-1>]
  $a.textframe.text tag bind dnatag <Any-Leave> {%W tag remove highlite 1.0 end}
  $a.textframe.text tag bind dnatag <Any-Motion> {%W tag remove highlite 1.0 end; %W tag add highlite current}
  $a.textframe.text tag bind dnatag <Any-Enter> {%W tag remove highlite 1.0 end; %W tag add highlite current}
  $a.textframe.text tag configure highlite -background red
#####
  set outputmenu [add_output_menu $a.textframe.text "Text" text $w]
  bind $a <Button-1> "focus $a.textframe.text" 
  bindtags $a.textframe.text [list $a.textframe.text AnalysisText . all]
  wm deiconify $a
  window_on_screen $a
  focus $a.textframe.text
}

##############
## returns cDNA extracted as uppercase exons, and location and size of introns
##############
proc uppercase_cdna {dna} {
  set templist [list]
  #find leading region
  set templist [concat $templist [regexp -inline -indices {([a-y]+)[A-Y]} $dna]]
  #find introns- lowercase gt..ag between uppercase exons
  set templist [concat $templist [regexp -all -inline -indices {[A-Y](g[tc][a-y]*?ag)[A-Y]} $dna]]
  #find trailing region- all lowercase after stop (stop not necessarily in frame with cDNA)
  set templist [concat $templist [regexp -all -inline -indices {(?:TGA|TAA|TAG)([a-y]+)} $dna]]

  set intronlist [list]
  foreach {i j} $templist {
    lappend intronlist $j
  }

  set intronlist [lsort -unique -integer -index 1 $intronlist]
  set sizelist [list]
  set sum 0
  foreach intron $intronlist { 
    set dna [string replace $dna [expr {[lindex $intron 0]-$sum}] [expr {[lindex $intron 1]-$sum}] ""]
    lappend sizelist [list [expr {[lindex $intron 0]-$sum}] [expr {[lindex $intron 1]-[lindex $intron 0]+1}]]
    incr sum [expr {[lindex $intron 1]-[lindex $intron 0]+1}]
  }

  return [list $dna $sizelist]
}


##############
## draws a graphic map of enzymes
##############
proc enz_graphic_map {w {numsites "none"}} {
  global enzymes
  global info
  global enzinfo
  global modifier
  global modstring

  set enz_list $info(enz_currently_selected) 
  set region $info(analyze_selection)
  if {[$w.textarea tag ranges tempsel] == ""} {set region "all"}

  if {$region == "all"} {
    set start 0
    set total_length [ix2bp $w.textarea [$w.textarea index end-1chars]]
    set end $total_length
  } else {
    set start [ix2bp $w.textarea [$w.textarea index tempsel.first]]
    set end [ix2bp $w.textarea [$w.textarea index tempsel.last]]
    set total_length [expr {$end - $start}]
  }

  if {$total_length == 0} {return}
  findenzymes $w

  if {$numsites != "none"} {
    set extra_enz [enz_site_usage_filter $w $enzymes $numsites all]
  } else {
    set extra_enz [list]
  }

  set a [new_analysis_window $w "Map"]

#make the canvas

  set c [canvas $a.canvas -width 500 -height 500 -background white -xscrollincrement 1 -yscrollincrement 1]

   bind $c <<Window>> $w
####check for circular or linear map
  if {($region == "all") && ($info($w,circular) == "circular")} {
    ########draw circular map
    set radius $info(circ_map_radius)
    $c create oval [expr {-$radius}] [expr {-$radius}] $radius $radius -activeoutline red -tags circle 
    set pi 3.141592654

    #draw enzyme and feature labels
    #get a list of locations and tags
    set templist [circ_enz_sort $w [lsort -unique [concat $enz_list $extra_enz]] $total_length]
    set maxx 150; set maxy 150; set minx -150; set miny -150

    set charheight [expr [font metrics graphicfont -linespace]]
    set anchor "sw"; set bump [expr -$charheight]; set nexty 0; set comparison ">"
    set lastloc -1
    foreach {pair} $templist  {
      set loc [lindex $pair 0]
      set label_dict [lindex $pair 1]    
      set angle [expr {2*$pi*$loc/$total_length}]
      set tag [dict get $label_dict tag]
      if {($anchor == "sw") && ($angle > [expr {$pi/2}])} {set anchor "nw"; set nexty 0; set comparison "<"; set bump $charheight}
      if {($anchor == "nw") && ($angle > $pi)} {set anchor "ne"; set nexty 0}
      if {($anchor == "ne") && ($angle > [expr {$pi*1.5}])} {set anchor "se"; set nexty 0; set comparison ">"; set bump [expr -$charheight]}
      #tick line
      set lineid [$c create line [expr {0.5 + $radius*sin($angle)}] [expr {0.5 - $radius*cos($angle)}] [expr {0.5 + ($radius+10)*sin($angle)}] [expr {0.5 - ($radius+10)*cos($angle)}] -tags [list $tag [dict get $label_dict type] tick]]
      set y [expr {-($radius+15)*cos($angle)}]
      if "$y $comparison $nexty" {set y $nexty}
      set nexty [expr {$y + $bump}]

      #connector line
      set connectorid [$c create line [expr {0.5 + ($radius+10)*sin($angle)}] [expr {0.5 - ($radius+10)*cos($angle)}] [expr {($radius+15)*sin($angle)}] $y -state [expr {$info(draw_graphic_connectors)?"normal":"hidden"}] -tags [list $tag [dict get $label_dict type] connector]]

    
      if {[dict get $label_dict type] eq "enzyme"} {
        #enzyme label text
        set id [$c create text [expr {($radius+15)*sin($angle)}] $y -text "[dict get $label_dict location_start] [dict get $label_dict name] ([dict get $label_dict count])" -anchor $anchor -font [list $info(graphicfontfamily) $info(graphicfontsize)]]
        #bindings for enzyme texts
        $c bind $id <Any-Enter> "$c raise $tag; set tag_color \[lindex \[$c  bind $id <<Colors>>\] 1\];foreach egm_x \[$c find withtag (label||connector||tick)&&$tag\] {$c itemconfigure \$egm_x -fill \$tag_color}; destroy egm_x tag_color"
        $c bind $id <Any-Leave> "set tag_color \[lindex \[$c  bind $id <<Colors>>\] 0\];foreach egm_x \[$c find withtag (label||connector||tick)&&$tag\] {$c itemconfigure \$egm_x -fill \$tag_color}; destroy egm_x tag_color"
        $c bind $id <Any-Enter> "+$c itemconfigure seqtext -text {$enzinfo(enz_pattern,$tag)}"
        $c bind $id <Any-Leave> "+$c itemconfigure seqtext -text {}"
        if {[lsearch -exact $enz_list $tag] > -1} {
          #selected enzymes
          $c bind $id <<Colors>> {black red}
          $c itemconfigure $id -tags [list enzyme $tag label moveablelabel selected_enz]]
        } else {
          #unique enzymes
          $c bind $id <<Colors>> {gray50 blue}
          $c itemconfigure $id -tags [list enzyme $tag label moveablelabel unique_enz]]

          $c itemconfigure $tag -fill gray50
        }
        $c bind $id <<Label>> $label_dict
        $c bind $id <Button-1> "$w.textarea tag remove tempsel 1.0 end; textsetcursor $w \[bp2ix $w.textarea [expr {$loc-1}]\]" 
        $c bind $id <Shift-Button-1> "select_region $w \[$w.textarea index insert\] \[bp2ix $w.textarea [expr {$loc-1}]\]" 
        $c bind $id <Shift-Double-Button-1> "select_region $w \[$w.textarea index insert\] \[bp2ix $w.textarea [expr {$loc-1}]\]; event generate $c <<Return>>;break"
        lappend info($w,linked_events) [list $c $id <Button-1>] [list $c $id <Shift-Button-1>] [list $c $id <Shift-Double-Button-1>]
      } else {
        #features labels
        set tag2 $tag
        set tag [regsub fn $tag f] 
        set direction [lindex [$w.textarea tag bind $tag <<Metadata>>] 3]
        dict set label_dict direction $direction
        set tag_color [eval format "\#%04X%04X%04X" [winfo rgb . [lindex [$w.textarea tag bind $tag <<Revcolors>>] [lindex [$w.textarea tag bind $tag <<Metadata>>] 3]]]]
        set id [$c create text [expr {($radius+15)*sin($angle)}] $y -text "[dict get $label_dict name] [dict get $label_dict location_start]..[dict get $label_dict location_end]" -anchor $anchor -font [list $info(graphicfontfamily) $info(graphicfontsize) bold]  -fill $tag_color -tags [list feature $tag2 label moveablelabel dir$direction]] 
   
        $c itemconfigure $lineid -fill $tag_color
        $c itemconfigure $connectorid -fill $tag_color
        $c bind $id <<Colors>> [list $tag_color red]
        $c bind $id <<Label>> $label_dict
      }
      


  
      scan [$c bbox $id] "%u %u %u %u" x1 y1 x2 y2
      if {$x1 < $minx} {set minx $x1}
      if {$y1 < $miny} {set miny $y1}
      if {$x2 > $maxx} {set maxx $x2}
      if {$y2 > $maxy} {set maxy $y2}
    }


    #draw features
    set feature_ranges(0) [list]
    foreach {name tag} [feature_find $w] {
      draw_circular_feature $w $c $tag
    }
    $c lower tick
    $c lower connector

    #make the enzyme sequence text box
    $c create text 0 [expr {10+2*$info(graphicfontsize)}] -tags [list seqtext] -justify center -anchor s -font "Helvetica $info(graphicfontsize)"

    #draw info text
    $c create text [dict get $info(graphic_map_text_properties) circular title x] [dict get $info(graphic_map_text_properties) circular title y]  -text "[file rootname [wm title $w]]" -justify center -font [dict get $info(graphic_map_text_properties) circular title font] -tags {title moveabletext} -anchor s -state [dict get $info(graphic_map_text_properties) circular title state] -fill [dict get $info(graphic_map_text_properties) circular title color]

    $c create text  [dict get $info(graphic_map_text_properties) circular seq_length x] [dict get $info(graphic_map_text_properties) circular seq_length y]  -text "[expr $total_length] bp" -justify center -font [dict get $info(graphic_map_text_properties) circular seq_length font] -tags {seq_length moveabletext}  -state [dict get $info(graphic_map_text_properties) circular seq_length state] -fill [dict get $info(graphic_map_text_properties) circular seq_length color]

    set bottomy [lindex [$c bbox all] 3]
    $c create text  [dict get $info(graphic_map_text_properties) circular file_comment x] [dict get $info(graphic_map_text_properties) circular file_comment y] -text [$w.comframe.comtextframe.text get 1.0 end] -justify left  -font [dict get $info(graphic_map_text_properties) circular file_comment font] -width 500 -anchor n -tags {file_comment moveabletext}  -state [dict get $info(graphic_map_text_properties) circular file_comment state] -fill [dict get $info(graphic_map_text_properties) circular file_comment color]

    $c create text  [dict get $info(graphic_map_text_properties) circular enz_list x] [dict get $info(graphic_map_text_properties) circular enz_list y] -text [list_enzymes_text $w] -justify left  -font [dict get $info(graphic_map_text_properties) circular enz_list font] -width 500 -anchor ne -tags {enz_list moveabletext}  -state [dict get $info(graphic_map_text_properties) circular enz_list state] -fill [dict get $info(graphic_map_text_properties) circular enz_list color]

    $c create text  [dict get $info(graphic_map_text_properties) circular feature_list x] [dict get $info(graphic_map_text_properties) circular feature_list y] -text  [list_features $w 1] -justify left  -font [dict get $info(graphic_map_text_properties) circular feature_list font] -width 500 -anchor nw -tags {feature_list moveabletext}  -state [dict get $info(graphic_map_text_properties) circular feature_list state] -fill [dict get $info(graphic_map_text_properties) circular feature_list color]


  } else {

 #######draw linear map

    $c create line 0 350 390 350 -tags line
    set templist [linear_enz_sort $w [lsort -unique [concat $enz_list $extra_enz]] $start $end]

    #draw enzymes
    set maxx 400; set maxy 370; set minx 0; set miny 340

    set bump [expr -[font metrics graphicfont -linespace]]
    set xright 0
    set lastloc -1
    set nexty [expr 335+$bump]
    foreach pair $templist  {
      set x [expr {0 + 390 * ([lindex $pair 0] - $start) / $total_length}]
      if {$lastloc != [lindex $pair 0]} {
        set lineid [$c create line $x 340 $x 350 -tags [list [lindex $pair 1] visible]]
      } else {
        $c itemconfigure $lineid -tags [concat [$c itemcget $lineid -tags] [lindex $pair 1]]
      }
      set lastloc [lindex $pair 0]
      
      if {$x > $xright} {
        set y 335
        set nexty [expr 335+$bump]
      } else {
        set y $nexty
        set nexty [expr $nexty+$bump]
      }
      while {[$c find overlapping $x [expr {$y-1}] [expr {$x+1}] [expr {$y-2}]] != ""} {
        set y $nexty
        set nexty [expr $nexty+$bump]      
      }
      set id [$c create text $x $y -text "[lindex $pair 0] [lindex $pair 1] \([llength $info($w,[lindex $pair 1])]\)" -anchor "sw" -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tags [list [lindex $pair 1] moveableboxlabel]]
      $c create line $x 340 $x $y -state [expr {$info(draw_graphic_connectors)?"normal":"hidden"}] -tags [list [lindex $pair 1] $id.connector connector] 
      set boxid [$c create rectangle [lindex [$c bbox $id] 0] [lindex [$c bbox $id] 1] [lindex [$c bbox $id] 2] [lindex [$c bbox $id] 3] -fill [$c cget -background] -outline {}  -tags [list $id.box box]] 
      $c raise $id $boxid
      if {[lsearch -exact $enz_list [lindex $pair 1]] > -1} {
        $c bind $id <Any-Enter> "$c raise [lindex $pair 1];$c raise box;$c raise moveableboxlabel; $c itemconfigure [lindex $pair 1] -fill red"
        $c bind $id <Any-Leave> "$c itemconfigure [lindex $pair 1] -fill black"
      } else {
        $c itemconfigure [lindex $pair 1] -fill gray50
        $c bind $id <Any-Enter> "$c raise [lindex $pair 1];$c raise box;$c raise moveableboxlabel; $c itemconfigure [lindex $pair 1] -fill blue"
        $c bind $id <Any-Leave> "$c itemconfigure [lindex $pair 1] -fill gray50"
      }

      $c bind $id <Any-Enter> "+$c itemconfigure seqtext -text {$enzinfo(enz_pattern,[lindex $pair 1])}"
      $c bind $id <Any-Leave> "+$c itemconfigure seqtext -text {}"
      $c bind $id <Button-1> "select_region $w \[bp2ix $w.textarea [expr {[lindex $pair 0]-1}]\] \[bp2ix $w.textarea [expr {[lindex $pair 0]-1}]\]" 
      $c bind $id <Shift-Button-1> "select_region $w \[$w.textarea index insert\] \[bp2ix $w.textarea [expr {[lindex $pair 0]-1}]\]" 
      $c bind $id <Shift-Double-Button-1> "select_region $w \[$w.textarea index insert\] \[bp2ix $w.textarea [expr {[lindex $pair 0]-1}]\]; event generate $c <<Return>>; break" 
      lappend info($w,linked_events) [list $c $id <Button-1>] [list $c $id <Shift-Button-1>] [list $c $id <Shift-Double-Button-1>]

      scan [$c bbox $id] "%u %u %u %u" x1 y1 x2 y2
      if {$y1 < $miny} {set miny $y1}
      if {$x2 > $maxx} {set maxx $x2}
      if {$y == 335} {set xright [expr {23 + $x2}]}
    }
    $c raise box;$c raise moveableboxlabel

    #draw file identifiers
    set y [expr {350+5}]
    set ystep [font metrics [list $info(graphicfontfamily) $info(graphicfontsize)] -displayof . -linespace]
    incr y $ystep
    $c create text 0 $y -text "[wm title $w] from [expr {1+$start}] to $end" -anchor "sw" -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tags {title visible moveabletext}
    incr y $ystep
    $c create text 0 $y  -tags {seqtext visible} -justify left -anchor sw -font [list $info(graphicfontfamily) $info(graphicfontsize)]
    incr y 5

    #draw features
    set templist [feature_find $w $start $end]
    global icount
    set icount 0
    if {[llength $templist] > 100} {
      if {$info(use_tile)} {
        grid [label $w.pleasewait -width 50 -bg yellow -text "Searching for Features, Please wait..."] -row 2 -column 0  -columnspan 3  -sticky new
        grid [ttk::progressbar $w.pleasewait_prog -maximum [llength $templist] -variable icount -orient horizontal -mode determinate] -row 3 -column 1  -sticky new
      } else {
        grid [label $w.pleasewait -width 50 -bg yellow -text "Searching for Features, Please wait..."] -row 2 -column 0  -columnspan 3  -sticky new
      }
    }
    update idletasks
    set depthdict [tagdepth $w.textarea [bp2ix $w.textarea $start] [bp2ix $w.textarea $end]]
    foreach {name tag} $templist {
      regsub "fn" $tag "f" tag
      if {[dict exists $depthdict $tag]} {
        set yplus [dict get $depthdict $tag]
      } else {
        set yplus 0
      }
      linear_feature_draw $c [expr {$y+ $yplus*30}] $w $start $end $total_length $tag $tag
      incr icount 2
      if {($icount % 100) ==0} {
        update idletasks
      }
    }
    destroy icount
    destroy $w.pleasewait
    if {[winfo exists $w.pleasewait_prog]} {destroy $w.pleasewait_prog}
    if {$info(linear_map_bump_label)} {
      linear_feature_label_bump $c
    }
    update
  }

  if {1} {
    $c configure -scrollregion [$c bbox all] -xscrollcommand "optionscrollbar $a.xscroll " -yscrollcommand "optionscrollbar $a.yscroll " -confine True
    set info($a,scale) 100
    set info($a,new_scale) 100
    grid rowconfigure $a 0 -weight 1
    grid columnconfigure  $a 0 -weight 1
    #need to set the minimum size here to save room for a scrollbar, to prevent infinite loops with autoscaling size (see <Configure> above)
    grid columnconfigure  $a 1 -minsize 17
    grid configure $c -row 0 -column 0 -sticky nsew
    grid configure [scrollbar $a.yscroll -command "$c yview " ] -row 0 -column 1 -sticky nes 
    grid configure  [scrollbar $a.xscroll -orient horizontal -command "$c xview"] -row 1 -column 0 -sticky wse

    wm deiconify $a
    #update

  }

  if {($region == "all") && ($info($w,circular) == "circular")} {
    foreach {x0 y0 x1 y1} [$a.canvas bbox all] {}
    wm geometry $a [expr {min ($x1 - $x0 + 25, ([winfo vrootwidth $a]-100))}]x[expr {min ($y1 - $y0 + 25, ([winfo vrootheight $a]-150))}]
    #window resizing for circular maps- keeps the aspect ration constant and centered
    #the following keeps everything centered when the window is wider than the scrollregion, but requires scrollincrement= 1
    $c configure -xscrollincrement 1 -yscrollincrement 1

    #update
     #the following keeps everything scaled to fit and centered when the window is wider than the scrollregion, but requires scrollincrement= 1
    bind $c <Configure> { 
      set new_scale [expr {min(1.0*max(([winfo height %W]-20), 300)/([lindex [%W bbox all] 3]-[lindex [%W bbox all] 1]), 1.0*max(([winfo width %W]-40), 300)/([lindex [%W bbox all] 2]-[lindex [%W bbox all] 0]))}]
      if {$new_scale == 0} {continue}
      %W scale all 0 0 $new_scale $new_scale
      %W configure -scrollregion [%W bbox all]
      set templist [%W bbox all]
      %W xview scroll [expr {int((([lindex $templist 2]+[lindex $templist 0]-[winfo width %W])/2-[%W canvasx 0]))}] unit
      %W yview scroll [expr {int(([lindex $templist 3]+[lindex $templist 1]-[winfo height %W])/2-[%W canvasy 0])}] unit
      if {[%W type 1] == "oval"} {
        foreach exon [%W find withtag exon] {
          set tag [lindex [%W gettags $exon] [lsearch -regexp [%W gettags $exon]  {f.[0-9]*#}]]
          change_radius %W $tag [lindex [%W coords $exon] 2]
        }
        #if {[lindex [%W coord 1] 2] > 30} {
        #  set info(circ_map_radius) [expr {int([lindex [%W coord 1] 2])}]
        #}
      }
      destroy templist new_scale exon tag
    }

  } else {
    #window resizing for linear maps- resizes image to width, keeps height constant, resizes moveableboxlabel boxes
      #needs to redraw the arrows, when redraw proc is written
    foreach {x0 y0 x1 y1} [$a.canvas bbox all] {}
    wm geometry $a [expr {min ($x1 - $x0 + 40, ([winfo vrootwidth $a]-100))}]x[expr {min ($y1 - $y0 + 25, ([winfo vrootheight $a]-150))}]
    bind $c <Configure> {
      set new_scale [expr { 1.0*max(([winfo width %W]-17), 300)/([lindex [%W bbox line||featurelabel||moveableboxlabel] 2]-[lindex [%W bbox line||featurelabel||moveableboxlabel] 0])}]
      if {$new_scale == 0} {continue}
      %W scale all 0 350 $new_scale 1
      %W configure -scrollregion [%W bbox all]
      foreach boxlabel [%W find withtag moveableboxlabel] {
        %W coords $boxlabel.box {*}[%W bbox $boxlabel]
        %W itemconfigure $boxlabel.box
      }
      destroy boxlabel
    }

  }

  $c bind moveabletext <$modifier-Button-1> "set cmoveitem \[$c find withtag current&&moveabletext\]; if {\[$c type \$cmoveitem\] == \"text\"} {set cmdx %x; set cmdy %y; set cmx1 \[lindex \[$c coords \$cmoveitem\] 0\]; set cmy1 \[lindex \[$c coords \$cmoveitem\] 1\]} else {unset cmoveitem}"
  $c bind moveabletext <$modifier-B1-Motion> "if {!\[info exists cmoveitem\]} {[$c bind moveabletext <$modifier-Button-1>]} else {$c coords \$cmoveitem \[expr {\$cmx1+%x-\$cmdx}\] \[expr {\$cmy1+%y-\$cmdy}\]}"
  $c bind moveabletext <$modifier-ButtonRelease-1> "unset -nocomplain cmoveitem cmx1 cmy1 cmdx cmdy; $c configure -scrollregion \[$c bbox all\]"


  $c bind moveablelabel <$modifier-Button-1> "set cmoveitem \[$c find withtag current\]; if {(\[$c type \$cmoveitem\] == \"text\") && (\[$c type \[set cmoveitem2 \[expr {\$cmoveitem-1}\]\]\] == \"line\")} {set cmdx %x; set cmdy %y; set cmx1 \[lindex \[$c coords \$cmoveitem\] 0\]; set cmy1 \[lindex \[$c coords \$cmoveitem\] 1\]} else {unset cmoveitem cmoveitem2}; break"
  $c bind moveablelabel <$modifier-B1-Motion> "if {!\[info exists cmoveitem\]} {[$c bind moveablelabel <$modifier-Button-1>]} else {$c coords \$cmoveitem \[expr {\$cmx1+%x-\$cmdx}\] \[expr {\$cmy1+%y-\$cmdy}\]; $c coords \$cmoveitem2 \[lindex \[$c coords \$cmoveitem2\] 0\] \[lindex \[$c coords \$cmoveitem2\] 1\] \[expr {\$cmx1+%x-\$cmdx}\] \[expr {\$cmy1+%y-\$cmdy}\]}"
  $c bind moveablelabel <$modifier-ButtonRelease-1> "unset -nocomplain cmoveitem cmx1 cmy1 cmdx cmdy cmoveitem2; $c configure -scrollregion \[$c bbox all\]"

  $c bind moveableboxlabel <$modifier-Button-1> "set cmoveitem \[$c find withtag current\]; if {(\[$c type \$cmoveitem\] == \"text\") && (\[set cmoveitem2 \[$c find withtag \$cmoveitem.connector \]\] != \"\") && (\[set cmoveitem3 \[$c find withtag \$cmoveitem.box \]\] != \"\")} {set cmdx %x; set cmdy %y; set cmx1 \[lindex \[$c coords \$cmoveitem\] 0\]; set cmy1 \[lindex \[$c coords \$cmoveitem\] 1\]} else {unset -nocomplain cmoveitem cmoveitem2 cmoveitem3}; break"
  $c bind moveableboxlabel <$modifier-B1-Motion> "if {!\[info exists cmoveitem\]} {[$c bind moveableboxlabel <$modifier-Button-1>]} else {$c coords \$cmoveitem \[expr {\$cmx1+%x-\$cmdx}\] \[expr {\$cmy1+%y-\$cmdy}\]; $c coords \$cmoveitem2 \[lindex \[$c coords \$cmoveitem2\] 0\] \[lindex \[$c coords \$cmoveitem2\] 1\] \[expr {\$cmx1+%x-\$cmdx}\] \[expr {\$cmy1+%y-\$cmdy}\];$c coords \$cmoveitem3 \[lindex \[$c bbox \$cmoveitem\] 0\] \[lindex \[$c bbox \$cmoveitem\] 1\] \[lindex \[$c bbox \$cmoveitem\] 2\] \[lindex \[$c bbox \$cmoveitem\] 3\]}"
  $c bind moveableboxlabel <$modifier-ButtonRelease-1> "unset -nocomplain cmoveitem cmx1 cmy1 cmdx cmdy cmoveitem2 cmoveitem3; $c configure -scrollregion \[$c bbox all\]"

  set outputmenu [add_output_menu $c "Image" image $w]
  if {($region == "all") && ($info($w,circular) == "circular")} {
    $outputmenu insert 0 command -label "Configure" -state normal -command "if {!\[info exists c_withtag_current\]} {set c_withtag_current \"\"};circular_map_configure_dialog $c \$c_withtag_current; unset c_withtag_current"
    $outputmenu insert 1 separator
  } else {
    $outputmenu insert 0 command -label "Bump texts" -state normal -command "linear_feature_rebump_labels $c" -accelerator "$modstring+B"
    $outputmenu insert 1 separator
    bind $c <$modifier-Key-b> "linear_feature_rebump_labels $c"
  }

  bind $c <Button-2> "set c_withtag_current \[$c find withtag current\] ; tk_popup $outputmenu %X %Y"
  #bind $c <Button-2> "if \{\[$c find withtag current&&moveabletext\] != \"\"\} \{$outputmenu entryconfigure 0 -state normal\} else \{$outputmenu entryconfigure 0 -state disabled\}; tk_popup $a.menubar.outputmenu %X %Y"
  #$a.menubar.outputmenu entryconfigure 0 -command \"sputs \[$c find withtag current\]\"; tk_popup $a.menubar.outputmenu %X %Y"

  #selection mechanism
  #bind $c <Shift-Button-1> "set info(mousex) %x; set info(mousey) %y"
  #bind $c <Shift-ButtonRelease-1> "sputs \[$c find enclosed \[$c canvasx \[expr {min(\$info(mousex), %x)}\]\] \[$c canvasy \[expr {min(\$info(mousey), %y)}\]\] \[$c canvasx \[expr {max(\$info(mousex), %x)}\]\] \[$c canvasy \[expr {max(\$info(mousey), %y)}\]\]\]; unset -nocomplain info(mousex); unset -nocomplain info(mousey)"

  #need to take out scale option if using the <Configure> above that keeps everything scaled
  set scale_index [$outputmenu index [mc "Scale"]]
  if {$scale_index != ""} {
    $outputmenu delete $scale_index
    #and the separator
    $outputmenu delete $scale_index    
  }


  bind $c <MouseWheel> {%W yview scroll [expr {int(10.0 * %D/-$info(mousewheelunits))}] units}
  bind $c <Shift-MouseWheel> {%W xview scroll [expr {int(10.0 * %D/-$info(mousewheelunits))}] units}
  bind $a <MouseWheel> {[winfo toplevel %W].canvas yview scroll [expr {int(10.0 * %D/-$info(mousewheelunits))}] units}
  bind $a <Shift-MouseWheel> {[winfo toplevel %W].canvas xview scroll [expr {int(10.0 *%D/-$info(mousewheelunits))}] units}
  bind $a <Button-1> "focus $c" 

  focus $a
  focus $c
}

################
## Configure dialog
################
proc circular_map_configure_dialog {c item} {
  global info dialogblock ok global_c enz_list fea_list
  global text_tag_list text_label_list
  global text_size text_color text_show text_fontfam text_width
  global apply_text_size apply_text_color apply_text_show apply_text_width text_select_all

  set global_c $c
  if {$dialogblock == 1} {return}
  set dialogblock 1
  toplevel .dialog
  wm title .dialog [mc "Configure Circular Map..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok 1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  bind .dialog <FocusIn> "event generate . <<RaiseDialogs>>"
  bind .dialog <Map> "event generate . <<RaiseDialogs>>"
  bind .dialog <Activate> "event generate . <<RaiseDialogs>>"

  set w [winfo toplevel $c]
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox resizable}
  }
  set ok 0

  grid [ttk::notebook .dialog.tabframe] -row 0 -column 0 -sticky nswe

  set active_tab texts
  set active_item 0

  #texts frame

  #initialize texts settings
  set text_tag_list [list title seq_length file_comment enz_list feature_list]
  set text_label_list [list [mc "Title"] [mc "Sequence Length"] [mc "File Comment"] [mc "Enzyme List"] [mc "Feature_List"]]
# need to add custom texts here, (if available)
  # intitialize formatting variables (need to reset these later if sel_item is a text)
  set sel_item [$c find withtag [lindex $text_tag_list 0]]
  set text_size [lindex [$c itemcget $sel_item -font] 1]
  set text_color [$c itemcget $sel_item -fill]
  set text_show [$c itemcget  $sel_item -state]
  set text_width [$c itemcget  $sel_item -width]
  set text_fontfam  [lindex [$c itemcget $sel_item -font] 0]
  foreach apply {apply_text_size apply_text_color apply_text_show apply_text_width} {
    set $apply 1
  }
  .dialog.tabframe add [frame .dialog.tabframe.texts -relief flat] -text [mc "Texts"] -sticky nswe
  grid [frame .dialog.tabframe.texts.frame1 -relief flat] -row 0 -column 0 -sticky nswe
  grid rowconfigure .dialog.tabframe.texts 0 -weight 1
  grid columnconfigure .dialog.tabframe.texts 0 -weight 1
  grid [set t [listbox .dialog.tabframe.texts.frame1.list -width 60 -yscrollcommand "optionscrollbar .dialog.tabframe.texts.frame1.scroll" -selectmode extended -activestyle none -background white -exportselection 0]] -row 0 -column 0 -sticky nswe
  grid [scrollbar .dialog.tabframe.texts.frame1.scroll -command ".dialog.tabframe.texts.frame1.list yview"] -row 0 -column 1 -sticky nse
  grid rowconfigure .dialog.tabframe.texts.frame1 0 -weight 1
  grid columnconfigure .dialog.tabframe.texts.frame1 0 -weight 1
  grid columnconfigure .dialog.tabframe.texts.frame1 1 -weight 0
  grid [frame .dialog.tabframe.texts.frame2 -relief ridge -borderwidth 2] -row 1 -column 0 -sticky swe
 # grid [button .dialog.tabframe.texts.frame2.raise -text [mc "Select All"] -command "event generate .dialog.tabframe.texts.frame1.list <<select_all>>"] -row 0 -column 0 -sticky we
 # grid [button .dialog.tabframe.texts.frame2.lower -text [mc "Deselect All"] -command "event generate .dialog.tabframe.texts.frame1.list <<select_none>>"] -row 0 -column 1 -sticky we
  grid [frame .dialog.tabframe.texts.frame3 -relief ridge -borderwidth 2] -row 2 -column 0 -sticky swe
 # grid [checkbutton .dialog.tabframe.texts.frame3.apply_show -variable apply_text_show -selectcolor white -activebackground $info(bg_color) -command ".dialog.tabframe.texts.frame3.show configure -state \[expr \{\$apply_text_show?\"normal\":\"disabled\"\}\]" ] -row 0 -column 0 -sticky nw
  grid [checkbutton .dialog.tabframe.texts.frame3.show -text [mc "Show"] -variable text_show -onvalue "normal" -offvalue "hidden" -selectcolor white -activebackground $info(bg_color) -command "event generate .dialog.tabframe.texts.frame1.list <<apply_show>>"] -row 0 -column 1 -sticky ne
 # grid [checkbutton .dialog.tabframe.texts.frame3.apply_color -variable apply_text_color -selectcolor white -activebackground $info(bg_color) -command ".dialog.tabframe.texts.frame3.color configure -state \[expr \{\$apply_text_color?\"normal\":\"disabled\"\}\]" ] -row 1 -column 0 -sticky nw
  grid [label .dialog.tabframe.texts.frame3.col_label -text [mc "Color:"]] -row 1 -column 1 -sticky ne
  grid [color_button .dialog.tabframe.texts.frame3.color text_color black] -row 1 -column 2 -sticky nw
  bind .dialog.tabframe.texts.frame3.color <<color_picked>>  "+event generate .dialog.tabframe.texts.frame1.list <<apply_color>>;#"
 # grid [checkbutton .dialog.tabframe.texts.frame3.apply_font -variable apply_text_size -selectcolor white -activebackground $info(bg_color) -command ".dialog.tabframe.texts.frame3.menubutton_size configure -state \[expr \{\$apply_text_size?\"normal\":\"disabled\"\}\]; .dialog.tabframe.texts.frame3.menubutton3 configure -state \[expr \{\$apply_text_size?\"normal\":\"disabled\"\}\] " ] -row 2 -column 0 -sticky nw
  grid [label .dialog.tabframe.texts.frame3.font_label -text [mc "Font:"]] -row 2 -column 1 -sticky ne
  grid [menubutton .dialog.tabframe.texts.frame3.menubutton_size -textvariable text_size -menu .dialog.tabframe.texts.frame3.menubutton_size.menu -indicatoron 1 -relief raised] -row 2 -column 2 -sticky w
  menu .dialog.tabframe.texts.frame3.menubutton_size.menu 
    foreach fontsize [lsort -unique -integer [concat [list 8 10 12 14 18] $info(graphicfontsize)]] {
      .dialog.tabframe.texts.frame3.menubutton_size.menu  add radiobutton -label $fontsize -indicatoron 1 -value $fontsize -variable text_size -command "event generate .dialog.tabframe.texts.frame1.list <<apply_font>>"
    }
  bind .dialog.tabframe.texts.frame3.menubutton_size.menu  <<MenuSelect>> "focus .dialog"
  grid [label .dialog.tabframe.texts.frame3.label4 -text "pt" -width 2] -row 2 -column 3 -sticky w
  grid [menubutton .dialog.tabframe.texts.frame3.menubutton3 -textvariable text_fontfam -menu .dialog.tabframe.texts.frame3.menubutton3.menu -indicatoron 1 -relief raised] -row 2 -column 4 -sticky w
  menu .dialog.tabframe.texts.frame3.menubutton3.menu 
    if {[llength $info(allfontlist)] <= 20} {
      foreach fontfam info(allfontlist) {
        .dialog.tabframe.texts.frame3.menubutton3.menu add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable text_fontfam -command "event generate .dialog.tabframe.texts.frame1.list <<apply_font>>";# -font [list $fontfam 10]
      }
    } else {
      for {set fi 0} {$fi < [llength $info(allfontlist)]} {incr fi 20} {
        if {[set fj [expr {$fi + 19}]] > [llength $info(allfontlist)]} {set fj [expr {[llength $info(allfontlist)]-1}]}
        .dialog.tabframe.texts.frame3.menubutton3.menu add cascade -label "[lindex $info(allfontlist) $fi]-[lindex $info(allfontlist) $fj]" -menu .dialog.tabframe.texts.frame3.menubutton3.menu$fi 
        menu .dialog.tabframe.texts.frame3.menubutton3.menu$fi
        foreach fontfam [lrange $info(allfontlist) $fi $fj] {
          .dialog.tabframe.texts.frame3.menubutton3.menu$fi add radiobutton -label $fontfam -indicatoron 1 -value $fontfam -variable text_fontfam -command "event generate .dialog.tabframe.texts.frame1.list <<apply_font>>";# -font [list $fontfam 10]
        }
      }
    }
 # grid [checkbutton .dialog.tabframe.texts.frame3.apply_width -variable apply_text_width -selectcolor white -activebackground $info(bg_color) -command ".dialog.tabframe.texts.frame3.textwidthentry configure -state \[expr \{\$apply_text_width?\"normal\":\"disabled\"\}\]" ] -row 3 -column 0 -sticky nw
  grid [label .dialog.tabframe.texts.frame3.label5 -text [mc "Text Width:"]] -row 3 -column 1 -sticky ne
  grid [entry .dialog.tabframe.texts.frame3.textwidthentry  -textvariable text_width -validate key -vcmd "check_char %S" -width 3 -justify left] -row 3 -column 2 -sticky w
 # grid [checkbutton .dialog.tabframe.texts.frame3.toggleall -variable text_select_all -selectcolor white -activebackground $info(bg_color) -command "set apply_text_size \$text_select_all; set apply_text_color \$text_select_all; set apply_text_show \$text_select_all; set apply_text_width \$text_select_all"]  -row 4 -column 0 -sticky nw
  set text_select_all 1

  grid [frame .dialog.tabframe.texts.frame3.butframe] -row 5 -column 0 -columnspan 5 -sticky nwe
 # grid [button .dialog.tabframe.texts.frame3.butframe.apply -text [mc "Apply"] -command "event generate .dialog.tabframe.texts.frame1.list <<apply>>"] -row 4 -column 1 -sticky we
  grid [button .dialog.tabframe.texts.frame3.butframe.update -text [mc "Update Texts"] -command "event generate .dialog.tabframe.texts.frame1.list <<update_text>>"] -row 4 -column 2 -sticky we
  grid [button .dialog.tabframe.texts.frame3.butframe.positions -text [mc "Set Text Positions as Default"] -command "event generate .dialog.tabframe.texts.frame1.list <<update_xy>>"] -row 4 -column 3 -sticky we

  #fill texts list
  foreach tag $text_tag_list label $text_label_list {
    .dialog.tabframe.texts.frame1.list insert end $label
    if {[$c itemcget [$c find withtag $tag] -state] == "hidden"} {
      .dialog.tabframe.texts.frame1.list itemconfigure end -selectforeground gray40 -foreground gray60 -background gray80
    } elseif {[$c find withtag $tag] == $item} {
      set active_tab texts
      set active_item [expr {[.dialog.tabframe.texts.frame1.list index end] - 1}]
    }
  }
  .dialog.tabframe.texts.frame1.list selection set 0
  .dialog.tabframe.texts.frame1.list selection anchor 0

  bind .dialog.tabframe.texts.frame1.list <<ListboxSelect>> {
    set sel_item [$global_c find withtag [lindex $text_tag_list [.dialog.tabframe.texts.frame1.list index anchor]]]
    set text_size [lindex [$global_c itemcget $sel_item -font] 1]
    set text_color [$global_c itemcget $sel_item -fill]
    set text_show [$global_c itemcget  $sel_item -state]
    set text_width [$global_c itemcget  $sel_item -width]
    set text_fontfam  [lindex [$global_c itemcget $sel_item -font] 0]
    unset sel_item
  }

  bind .dialog.tabframe.texts.frame1.list <<apply>> {
    foreach sel_item [.dialog.tabframe.texts.frame1.list curselection] {
      if {$apply_text_show} {
        if {$text_show == "hidden"} {
          .dialog.tabframe.texts.frame1.list itemconfigure $sel_item -selectforeground gray40 -foreground gray60 -background gray80
        } else {
          .dialog.tabframe.texts.frame1.list itemconfigure $sel_item -selectforeground {} -foreground {} -background {}
        }
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] state $text_show
      }
      if {$apply_text_size} {
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] font [list $text_fontfam $text_size]
      }
      if {$apply_text_color} {
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] color $text_color
      }
      if {$apply_text_width} {
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] width $text_width
      }
      set sel_item [$global_c find withtag [lindex $text_tag_list $sel_item]]
      if {$apply_text_size} {
        $global_c itemconfigure $sel_item -font [list $text_fontfam $text_size]
      }
      if {$apply_text_show} {
        $global_c itemconfigure $sel_item -state $text_show
      }
      if {$apply_text_color} {
        $global_c itemconfigure $sel_item -fill $text_color
      }
      if {$apply_text_width} {
        $global_c itemconfigure $sel_item -width $text_width
      }
      event generate $global_c <Configure>
    }
    catch {unset sel_item}
  }
  bind .dialog.tabframe.texts.frame1.list <<apply_show>> {
    foreach sel_item [.dialog.tabframe.texts.frame1.list curselection] {
        if {$text_show == "hidden"} {
          .dialog.tabframe.texts.frame1.list itemconfigure $sel_item -selectforeground gray40 -foreground gray60 -background gray80
        } else {
          .dialog.tabframe.texts.frame1.list itemconfigure $sel_item -selectforeground {} -foreground {} -background {}
        }
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] state $text_show
        $global_c itemconfigure [$global_c find withtag [lindex $text_tag_list $sel_item]] -state $text_show
        event generate $global_c <Configure>
    }
  }
  bind .dialog.tabframe.texts.frame1.list <<apply_font>> {
    foreach sel_item [.dialog.tabframe.texts.frame1.list curselection] {
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] font [list $text_fontfam $text_size]
        $global_c itemconfigure [$global_c find withtag [lindex $text_tag_list $sel_item]] -font [list $text_fontfam $text_size]
        event generate $global_c <Configure>
    }
  }
  bind .dialog.tabframe.texts.frame1.list <<apply_color>> {
    foreach sel_item [.dialog.tabframe.texts.frame1.list curselection] {
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] color $text_color
        $global_c itemconfigure [$global_c find withtag [lindex $text_tag_list $sel_item]] -fill $text_color
        event generate $global_c <Configure>
    }
  }
  bind .dialog.tabframe.texts.frame1.list <<apply_width>> {
    foreach sel_item [.dialog.tabframe.texts.frame1.list curselection] {
        dict set info(graphic_map_text_properties) circular [lindex $text_tag_list $sel_item] width $text_width
        $global_c itemconfigure [$global_c find withtag [lindex $text_tag_list $sel_item]] -width $text_width
        event generate $global_c <Configure>
    }
  }

  bind .dialog.tabframe.texts.frame1.list <<select_all>> {
    .dialog.tabframe.texts.frame1.list selection set 0 end
    .dialog.tabframe.texts.frame1.list selection anchor 0 
  }

  bind .dialog.tabframe.texts.frame1.list <<select_none>> {
    .dialog.tabframe.texts.frame1.list selection clear 0 end
  }


  bind .dialog.tabframe.texts.frame1.list <<update_text>> {
    foreach sel_item [.dialog.tabframe.texts.frame1.list curselection] {
      set sel_item [lindex $text_tag_list $sel_item]
      switch $sel_item {
        title {sputs [file rootname [wm title [bind $global_c <<Window>>]]]}
        file_comment {sputs [[bind $global_c <<Window>>].comframe.comtextframe.text get 1.0 end]}
        enz_list  {sputs [list_enzymes_text [bind $global_c <<Window>>]]}
        feature_list  {sputs [list_features [bind $global_c <<Window>>] 1]}
      }
    }
    catch {unset sel_item} 
  }

  bind .dialog.tabframe.texts.frame1.list <<update_xy>> {
    foreach sel_item [.dialog.tabframe.texts.frame1.list curselection] {
      set sel_item [lindex $text_tag_list $sel_item]
      dict set info(graphic_map_text_properties) circular $sel_item x [lindex [$global_c coords $sel_item] 0]
      dict set info(graphic_map_text_properties) circular $sel_item y [lindex [$global_c coords $sel_item] 1]
    }
    catch {unset sel_item}
  }


#$c find withtag enzyme&&label
#$c find withtag feature&&label
#$c find withtag feature&&label&&dir0
#$c bind $id <<Colors>> 
#$c bind $id <<Label>> ($label_dict)
#enzymes: $label_dict:  type name location_start count tag
#features: $label_dict: type name location_start location_end tag direction




  ####enzymes frame
  .dialog.tabframe add [frame .dialog.tabframe.enzymes -relief flat] -text [mc "Enzymes"] -sticky nswe
  grid [frame .dialog.tabframe.enzymes.frame1 -relief flat] -row 0 -column 0 -sticky nswe
  grid rowconfigure .dialog.tabframe.enzymes 0 -weight 1
  grid columnconfigure .dialog.tabframe.enzymes 0 -weight 1
  grid [set t [listbox .dialog.tabframe.enzymes.frame1.list -width 60 -yscrollcommand "optionscrollbar .dialog.tabframe.enzymes.frame1.scroll" -selectmode extended -activestyle none -background white -exportselection 0]] -row 0 -column 0 -sticky nswe
  grid [scrollbar .dialog.tabframe.enzymes.frame1.scroll -command ".dialog.tabframe.enzymes.frame1.list yview"] -row 0 -column 1 -sticky nse
  grid rowconfigure .dialog.tabframe.enzymes.frame1 0 -weight 1
  grid columnconfigure .dialog.tabframe.enzymes.frame1 0 -weight 1
  grid columnconfigure .dialog.tabframe.enzymes.frame1 1 -weight 0
  grid [frame .dialog.tabframe.enzymes.frame2 -relief ridge -borderwidth 2] -row 1 -column 0 -sticky swe
  grid [button .dialog.tabframe.enzymes.frame2.b1 -text [mc "Select All"] -command "event generate .dialog <<raise>>"] -row 0 -column 0 -sticky we
  grid [menubutton .dialog.tabframe.enzymes.frame2.sort -textvariable enzyme_sort -menu .dialog.tabframe.enzymes.frame2.sort.menu -indicatoron 1 -relief raised] -row 0 -column 1 -sticky we
  grid [frame .dialog.tabframe.enzymes.frame3 -relief ridge -borderwidth 2] -row 2 -column 0 -sticky swe
  grid [button .dialog.tabframe.enzymes.frame3.some -text [mc "Config options2"] -command ""] -row 0 -column 1 -sticky we
  fill_circular_config_enz_listbox

  .dialog.tabframe.enzymes.frame1.list selection set 0
  .dialog.tabframe.enzymes.frame1.list selection anchor 0

  bind .dialog.tabframe.enzymes.frame1.list <<ListboxSelect>> {
    set sel_item [$global_c find withtag [lindex [lindex $enz_list [.dialog.tabframe.enzymes.frame1.list index anchor]] 0]]
    sputs text_show [$global_c itemcget  $sel_item -state]
    sputs text_color [$global_c itemcget $sel_item -fill]
    sputs text_size [lindex [$global_c itemcget $sel_item -font] 1]
    sputs text_fontfam  [lindex [$global_c itemcget $sel_item -font] 0]
    unset sel_item
  }
# hide
# label text (name %n, pos%1, count %# variables)
# label color
# font size and family

  ####features frame
  .dialog.tabframe add [frame .dialog.tabframe.features -relief flat] -text [mc "Features"] -sticky nswe
  grid [frame .dialog.tabframe.features.frame1 -relief flat] -row 0 -column 0 -sticky nswe
  grid rowconfigure .dialog.tabframe.features 0 -weight 1
  grid columnconfigure .dialog.tabframe.features 0 -weight 1
  grid [set t [listbox .dialog.tabframe.features.frame1.list -width 60 -yscrollcommand "optionscrollbar .dialog.tabframe.features.frame1.scroll" -selectmode extended -activestyle none -background white -exportselection 0]] -row 0 -column 0 -sticky nswe
  grid [scrollbar .dialog.tabframe.features.frame1.scroll -command ".dialog.tabframe.features.frame1.list yview"] -row 0 -column 1 -sticky nse
  grid rowconfigure .dialog.tabframe.features.frame1 0 -weight 1
  grid columnconfigure .dialog.tabframe.features.frame1 0 -weight 1
  grid columnconfigure .dialog.tabframe.features.frame1 1 -weight 0
  grid [frame .dialog.tabframe.features.frame2 -relief ridge -borderwidth 2] -row 1 -column 0 -sticky swe
  grid [button .dialog.tabframe.features.frame2.b1 -text [mc "Select All"] -command "event generate .dialog <<raise>>"] -row 0 -column 0 -sticky we
  grid [button .dialog.tabframe.features.frame2.b2 -text [mc "Select Forward"] -command "event generate .dialog <<lower>>"] -row 0 -column 1 -sticky we
  grid [button .dialog.tabframe.features.frame2.b3 -text [mc "Select Reverse"] -command "event generate .dialog <<lower>>"] -row 0 -column 2 -sticky we
  grid [frame .dialog.tabframe.features.frame3 -relief ridge -borderwidth 2] -row 2 -column 0 -sticky swe
  grid [button .dialog.tabframe.features.frame3.some -text [mc "Config options3"] -command ""] -row 0 -column 1 -sticky we
  fill_circular_config_fea_listbox
  bind .dialog.tabframe.features.frame1.list <<ListboxSelect>> {
    set sel_item [$global_c find withtag [lindex [lindex $fea_list [.dialog.tabframe.features.frame1.list index anchor]] 0]]
    sputs text_show [$global_c itemcget  $sel_item -state]
    sputs text_color [$global_c itemcget $sel_item -fill]
    sputs text_size [lindex [$global_c itemcget $sel_item -font] 1]
    sputs text_fontfam  [lindex [$global_c itemcget $sel_item -font] 0]
    unset sel_item
  }

# hide
# label text (name %n pos1 %1, pos2 %2 variables)
#      format {%1$s} r t y
#      set a [regsub %% asdf%% \x0]
#      set b [regsub \x0 $a %]
# label color (use feature color)
# font size and family

  ####circle frame
# show enzymes circle: width, color
# show features circle (features height is relative to features circle): radius, width, color, 
# show crosshairs: width, color
# show index marks: radius, spacing, font, size, color, with 0's, 
# show GC circle: radius, accumulation window, low-color, mid-color, high color, >%, <%
# show ORFs circle: radius, min length, fwd color, rev color
# all radius measures are as % of enzymes circle

 # .dialog.tabframe add [frame .dialog.tabframe.circle -relief flat] -text [mc "Circle"] -sticky nswe
 # grid [frame .dialog.tabframe.circle.frame1 -relief flat] -row 0 -column 0 -sticky nswe
 # grid rowconfigure .dialog.tabframe.circle 0 -weight 1
 # grid columnconfigure .dialog.tabframe.circle 0 -weight 1
 # grid [button .dialog.tabframe.circle.frame1.some -text [mc "Config options4"] -command ""] -row 0 -column 0 -sticky we

  #### ok frame
  grid [frame .dialog.frame2 -relief raised] -row 1 -column 0 -sticky swe
  grid [button .dialog.frame2.ok -text [mc "OK"] -command "set ok 1" -default active] -row 0 -column 0 -padx 5 -pady 3 -sticky n
  grid columnconfigure .dialog.frame2 0 -weight 1

  bind .dialog <Key-Return> "set ok 1"

  grid rowconfigure .dialog 0 -weight 1
  grid rowconfigure .dialog 1 -weight 0
  grid columnconfigure .dialog 0 -weight 1

  update
  event generate .dialog.tabframe.enzymes.frame1.list <<FillListbox>>
  event generate .dialog.tabframe.features.frame1.list <<FillListbox>>

  vwait ok
  set dialogblock 0
  unset ok
  destroy .dialog
  bind . <<RaiseDialogs>> ""


#hidden items:
#$t itemconfigure 0 -selectforeground gray60 -selectbackground gray80
}

################
## utility to fill enzymes listbox
################
proc fill_circular_config_enz_listbox {} {
  global global_c enz_list
  if {![winfo exists .dialog.tabframe.enzymes.frame1.list]} {
    sputs no fea
    return
  }
  .dialog.tabframe.enzymes.frame1.list delete 0 end
  set enz_list [list]
  foreach et [$global_c find withtag enzyme&&label] {
    lappend enz_list [list $et [dict get [$global_c bind $et <<Label>>] name] [dict get [$global_c bind $et <<Label>>] location_start]]
  }
  set enz_list [lsort -integer -index 2 $enz_list]
  foreach enz $enz_list {
    foreach {tag name loc} $enz {}
    .dialog.tabframe.enzymes.frame1.list insert end "$loc $name "
    if {[$global_c itemcget [$global_c find withtag $tag] -state] == "hidden"} {
      .dialog.tabframe.enzymes.frame1.list itemconfigure end -selectforeground gray40 -foreground gray60 -background gray80
    } else {
      .dialog.tabframe.enzymes.frame1.list itemconfigure end -foreground [$global_c itemcget [$global_c find withtag $tag] -fill]
    }
  }
}

################
## utility to fill features listbox
################
proc fill_circular_config_fea_listbox {} {
  global global_c fea_list
  if {![winfo exists .dialog.tabframe.features.frame1.list]} {
    sputs no fea
    return
  }
  .dialog.tabframe.features.frame1.list delete 0 end
  set fea_list [list]
  foreach ft [$global_c find withtag feature&&label] {
    lappend fea_list [list $ft [dict get [$global_c bind $ft <<Label>>] name] [dict get [$global_c bind $ft <<Label>>] location_start] [dict get [$global_c bind $ft <<Label>>] location_end] [dict get [$global_c bind $ft <<Label>>] direction]]
  }
  set fea_list [lsort -integer -index 2 $fea_list]
  foreach fea $fea_list {
    foreach {tag name loc1 loc2 dir} $fea {}
    .dialog.tabframe.features.frame1.list insert end "$loc1..$loc2 $name [expr {$dir?"<<<":">>>"}]"
    if {[$global_c itemcget [$global_c find withtag $tag] -state] == "hidden"} {
      .dialog.tabframe.features.frame1.list itemconfigure end -selectforeground gray40 -foreground gray60 -background gray80
    } else {
      .dialog.tabframe.features.frame1.list itemconfigure end -foreground [$global_c itemcget [$global_c find withtag $tag] -fill]
    }
  }
}

################
## Return a grayed version of input color
################
proc gray_color {color} {
  set c [format "\#%04X%04X%04X" [expr {int([lindex [winfo rgb . $color] 0] * 0.6)}] [expr {int([lindex [winfo rgb . $color] 1] * 0.6)}] [expr {int([lindex [winfo rgb . $color] 2] * 0.6)}]]
}

################
## Add circular feature to a graphic map
################
proc draw_circular_feature {w c tag} {
  global modifier
      #tag the labels with the tag name too
      #$c addtag $tag withtag "$tag\_label" 

      if {[string match fn* $tag]} {
        regsub "fn" $tag "f" tag2
      } else {
        set tag2 $tag
      }

      set state "normal"
      if {[catch {set tag_color [eval format "\#%04X%04X%04X" [winfo rgb . [$w.textarea tag cget $tag2 -background]]]}]} {
        set tag_color [lindex [$w.textarea tag bind $tag2 <<Revcolors>>] [lindex [$w.textarea tag bind $tag2 <<Metadata>>] 3]]
        set state "hidden"
      }
      set tag_bg_color [gray_color $tag_color]

      #if across origin
      if {[llength [set ranges [$w.textarea tag ranges $tag]]] > 2} {
        $c bind $tag <Shift-Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 2]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 3]]\]" 
       # $c bind $id <Shift-Double-Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 2]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 3]]\]; event generate $c <<Return>>;break"
        lappend info($w,linked_events) [list $c $tag <Shift-Button-1>] [list $c $tag <Shift-Double-Button-1>]
      }

      if {[string match fn* $tag]} {
        #split tag
        set fnranges $ranges
        set ranges [$w.textarea tag ranges $tag2]
        set start_i [lindex $fnranges 2]
        set start_i_i [lsearch -exact $ranges $start_i]
        #rotate ranges to start with first exon
        set ranges [concat [lrange $ranges $start_i_i end] [lrange $ranges 0 [expr {$start_i_i - 1}]]]
        #check for exon across origin 
        if {([set one_i [lsearch -exact $ranges 1.0]] > -1) && ([lindex $ranges [expr {$one_i -1}]] eq [$w.textarea index end-1chars])} {
          set ranges [lreplace $ranges [expr {$one_i -1}] $one_i]
        }
      } elseif {[llength $ranges] == 4} {
        #non-split tag that crosses the origin
        set ranges [list [lindex $ranges 2]  [lindex $ranges 1]]
      }


      set total_length [ix2bp $w.textarea [$w.textarea index end-1chars]]
      set direction [lindex [$w.textarea tag bind $tag2 <<Metadata>>] 3]
      



      ###need to get width, radius, arrow_list from Metadata 1
      set gformat [lindex [$w.textarea tag bind $tag2 <<Metadata>>] 1]
      set width [dict get $gformat width]
      if {$width == ""} {set width 1}
      set arrow_list [dict get $gformat arrow_data]
      set radius_offset [dict get $gformat offset]


      set radius [lindex [$c coord 1] 2]
      set r [expr {$radius + $radius_offset}]
      set ri [expr {(2 * $direction -1) * ($width / 2 -1) + $r}]


      set last_stop -1000
      foreach {start stop} $ranges {
        set start_angle [expr {90.0-(360.0*[ix2bp $w.textarea $start]/$total_length)}]
        set extent_angle [expr {1.0 *(([ix2bp $w.textarea $stop]-[ix2bp $w.textarea $start])%$total_length)/$total_length * -360}]
        #bug in arc drawing for extents <0.45, on windows
        #if {[expr {abs($extent_angle)}] < 0.9} {set extent_angle [expr {$extent_angle/abs($extent_angle)*0.9}]}
        $c create arc [expr {-$r}] [expr {-$r}] $r $r -style arc -width [expr {$width+2}] -start [expr {$start_angle+0.5}] -extent [expr {$extent_angle -1.0}] -outline $tag_bg_color  -tags [list $tag outline exon]
        $c create arc [expr {-$r}] [expr {-$r}] $r $r -style arc -width $width -start $start_angle -extent $extent_angle -outline $tag_color -tags [list $tag foreground exon]
        lappend coord_list $start_angle $extent_angle
        #draw introns
        if {$last_stop != -1000} {
          set start_anglei [expr {90.0-(360.0*[ix2bp $w.textarea $last_stop]/$total_length)}]
          set extent_anglei [expr {1.0 *(([ix2bp $w.textarea $start]-[ix2bp $w.textarea $last_stop])%$total_length)/$total_length * -360}]
          $c create arc [expr {-$ri}] [expr {-$ri}] $ri $ri -style arc -width 3 -start [expr {$start_anglei+0.5}] -extent [expr {$extent_anglei -1.0}] -outline $tag_bg_color -tags [list $tag outline intron]
          $c create arc [expr {-$ri}] [expr {-$ri}] $ri $ri -style arc -width 1 -start $start_anglei -extent $extent_anglei -outline $tag_color -tags [list $tag foreground intron]
        }
        set last_stop $stop
      }
      $c raise foreground outline
      #make dummy arrow items - coordinates are set later
      $c create polygon 0 0 -fill $tag_bg_color -width 2 -tags [list $tag fwd_arrow outline]
      $c create polygon 0 0 -fill $tag_color  -tags [list $tag fwd_arrow foreground]
      $c create polygon 0 0 -fill $tag_bg_color -width 2 -tags [list $tag rev_arrow outline]
      $c create polygon 0 0 -fill $tag_color -tags [list $tag rev_arrow foreground]

      $c itemconfigure $tag -state $state

      $c bind $tag <<Arrow_list>> $arrow_list
      $c bind $tag <<Coord_list>> $coord_list
      $c bind $tag <<Direction>> $direction
      #redraw feature to set arrows etc.
      change_radius $c $tag $r
      $c bind $tag&&(exon||intron||fwd_arrow||rev_arrow) <$modifier-Button1-Motion> "change_radius $c $tag \[expr {sqrt(\[$c canvasx %x\]*\[$c canvasx %x\]+\[$c canvasy %y\]*\[$c canvasy %y\])}\]"
      $c bind $tag <Any-Enter> "$c raise label&&$tag; $c itemconfigure (connector||label||tick)&&$tag -fill \[lindex \[$c bind [$c find withtag label&&$tag] <<Colors>>] 1\]; $c itemconfigure outline&&$tag -outline \[lindex \[$c bind $tag <<Colors>>\] 1\]"
      $c bind $tag <Any-Leave> "$c itemconfigure (connector||label||tick)&&$tag -fill \[lindex \[$c bind [$c find withtag label&&$tag] <<Colors>>] 0\]; $c itemconfigure outline&&$tag -outline \[gray_color \[lindex \[$c bind $tag <<Colors>>\] 0\]\]"
      $c bind $tag <<Colors>> [list $tag_color red]
      $c bind $tag <$modifier-Button-1> continue
      $c bind $tag <Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 0]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges end]]\]" 
      $c bind $tag <Double-Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges 0]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $ranges end]]\]; event generate $c <<Return>>;break" 
      lappend info($w,linked_events) [list $c $tag <Button-1>] [list $c $tag <Double-Button-1>]
} 


################
## Change radius of a circular feature- can also be used to redraw feature
################
proc change_radius {c tag r} {
  set degtorad 0.017453292522222223
  set direction [$c bind $tag <<Direction>>]
  set width [$c itemcget [lindex [$c find withtag exon&&foreground&&$tag] 0] -width]

  #change radius of exons and introns
  foreach i [$c find withtag exon&&$tag] {
    $c coords $i [expr {-$r}] [expr {-$r}] [expr {$r}] [expr {$r}]
  }
  set ri [expr {(-2 * $direction +1) * ($width / 2-1) + $r}]
  foreach i [$c find withtag intron&&$tag] {
    $c coords $i [expr {-$ri}] [expr {-$ri}] [expr {$ri}] [expr {$ri}]
  }

  #set the arrow coordinates
  if {$direction} {
    set fwd_pts [lindex [$c bind $tag <<Arrow_list>>] 1]
    set rev_pts [lindex [$c bind $tag <<Arrow_list>>] 0]
  } else {
    set fwd_pts [lindex [$c bind $tag <<Arrow_list>>] 0]
    set rev_pts [lindex [$c bind $tag <<Arrow_list>>] 1]
  }
  set flip [lindex [$c bind $tag <<Arrow_list>>] 2]

  set first_exon [lindex [$c find withtag exon&&foreground&&$tag] 0]
  set rev_angle [lindex [$c bind $tag <<Coord_list>>] 0]
  set r_max_x 0
  foreach {x y} $rev_pts {
    set r_max_x [expr {max($x, $r_max_x)}]
  }
  set rev_angle_adjust [expr {2.0* asin( min($r_max_x *$width/2.0, max($r, 10))  / max($r, 10)) / $degtorad}]
  set rev_angle_adjust [expr {min ($rev_angle_adjust, ($rev_angle_adjust-[lindex [$c bind $tag <<Coord_list>>] 1]) / 2.0)}]
  set rev_angle [expr {$rev_angle- $rev_angle_adjust }]



  set last_exon [lindex [$c find withtag exon&&foreground&&$tag] end]
  set fwd_angle [expr {[lindex [$c bind $tag <<Coord_list>>] end-1] + [lindex [$c bind $tag <<Coord_list>>] end]}]
  set f_max_x 0
  foreach {x y} $fwd_pts {
    set f_max_x [expr {max($x, $f_max_x)}]
  }
  set fwd_angle_adjust [expr {2.0* asin( min($f_max_x *$width/2.0, max($r, 10))  / max($r, 10)) / $degtorad}]
  set fwd_angle_adjust [expr {min ($fwd_angle_adjust, ($fwd_angle_adjust-[lindex [$c bind $tag <<Coord_list>>] end]) / 2.0)}]
  set fwd_angle [expr {$fwd_angle + $fwd_angle_adjust}]


  #adjust the start and extent of the 1st and last exons to make proper space for the arrows
  if {$first_exon == $last_exon} {
    $c itemconfigure $first_exon -start [expr {$rev_angle+ 0.03*$width}] -extent [expr {min (0, [lindex [$c bind $tag <<Coord_list>>] 1] + $rev_angle_adjust  + $fwd_angle_adjust -0.06*$width)}]
  } else {
    $c itemconfigure $first_exon -start [expr {$rev_angle+ 0.03*$width}] -extent [expr {min (0, [lindex [$c bind $tag <<Coord_list>>] 1] + $rev_angle_adjust -0.06*$width)}]
    $c itemconfigure $last_exon -extent [expr {min (0,[lindex [$c bind $tag <<Coord_list>>] end] + $fwd_angle_adjust -0.1)}]
  }

  set r_arrow_y [expr {-($r) * sin($rev_angle * $degtorad)}]
  set r_arrow_x [expr {($r) * cos($rev_angle * $degtorad)}]
  set rev_coords [arrow_coords $r_arrow_x $r_arrow_y [expr {180 -$rev_angle}] 0 $width $rev_pts $flip]
  eval {$c coords rev_arrow&&foreground&&$tag $rev_coords}
  eval {$c coords rev_arrow&&outline&&$tag $rev_coords}

  set f_arrow_y [expr {-($r) * sin($fwd_angle * $degtorad)}]
  set f_arrow_x [expr {($r) * cos($fwd_angle * $degtorad)}]
  set fwd_coords [arrow_coords $f_arrow_x $f_arrow_y [expr {-$fwd_angle}] 0 $width $fwd_pts $flip]
  eval {$c coords fwd_arrow&&foreground&&$tag $fwd_coords}
  eval {$c coords fwd_arrow&&outline&&$tag $fwd_coords}



  #adjust the extent angles of the exon outlines
  foreach a [$c find withtag exon&&outline&&$tag] b [$c find withtag exon&&foreground&&$tag] {
    $c itemconfigure $a -start [expr {[$c itemcget $b -start]+0.5/$r*200}] -extent [expr {[$c itemcget $b -extent] -1.0/$r*200}]
  }

  $c raise foreground&&$tag outline&&$tag
}

################
## Return a list of arrow coordinates
################
proc arrow_coords {x y angle dir width pts {flip 0}} {
  set degtorad 0.017453292522222223
  set pts_list [list]
  if {$dir} {
    set angle [expr {$angle +180}]
  }
  foreach {pt1 pt2} $pts {
    if {$dir} {
      set pt2 [expr {(1-$flip*2)*$pt2}]
    }
    lappend pts_list [expr {$x+ (cos($angle * $degtorad) * $pt2 - sin($angle * $degtorad) *$pt1) * 1.0 * $width}]  [expr { $y+  (sin($angle * $degtorad) * $pt2 + cos($angle * $degtorad) *$pt1) * 1.0 * $width}]
  }
  return $pts_list
}

################
## Return a list of {site name} list pairs for a set of enzyme lists,with pairs sorted into quadrants, 2nd and 4th quadrants reversed in order
################
proc circ_enz_sort {w enz_list len} {
  global info
# returns a list of positions, and dict: type enzyme/feature, location location string, name name string, tag: tag name, count feature count
  set templist [list]
  set a1 -1
  set a2 -1
  set a3 -1
  foreach enzyme $enz_list {
    foreach site $info($w,$enzyme) {
      lappend templist [list $site [list type enzyme location_start $site name $enzyme tag $enzyme count [llength $info($w,$enzyme)]]]
    }
  }

  foreach {name text_tag} [feature_find $w] {
    if {[$w.textarea tag cget [regsub "fn" $text_tag "f"] -background] == ""} {
      continue
    }
    if {[llength [$w.textarea tag ranges $text_tag]] == 2} {
      set tx1 [ix2bp $w.textarea [lindex [$w.textarea tag ranges $text_tag] 0]]
    } else {
      set tx1 [ix2bp $w.textarea [lindex [$w.textarea tag ranges $text_tag] 2]]
    }
    set tx2 [ix2bp $w.textarea [lindex [$w.textarea tag ranges $text_tag] 1]]
    set ttg $text_tag
    regsub fn $text_tag f ttg
    if {[lindex [$w.textarea tag bind $ttg <<Metadata>>] 3]} {
      set from [expr {$tx2}]
      set to [expr {$tx1+1}]
      if {$info(circ_map_feature_names_centered)} {
        if {[llength [$w.textarea tag ranges $text_tag]] == 2} {
           set loc [expr {($tx2+$tx1+1)/2}]
        } else {
           #feature spans origin
           set loc  [expr {($tx2+$tx1+1+$len)/2}]
        }
      } else {
        set loc  [expr {$tx2}]
      }
    } else {
      set from [expr {$tx1+1}]
      set to [expr {$tx2}]
      if {$info(circ_map_feature_names_centered)} {
        if {[llength [$w.textarea tag ranges $text_tag]] == 2} {
          set loc [expr {($tx2+$tx1+1)/2}]
        } else {
           #feature spans origin
           set loc  [expr {($tx2+$tx1+1+$len)/2}]
        }
      } else {
        set loc [expr {$tx1+1}]
      }
    }
    lappend templist [list $loc [list type feature location_start $from location_end $to name $name tag $text_tag]]
  }

  set templist [lsort -integer -index 0 $templist]
  set i 0
  foreach element $templist {
    set index [lindex $element 0]
    if {$index < [expr .25 *$len]} {set a1 $i}
    if {$index < [expr .5 *$len]} {set a2 $i}
    if {$index < [expr .75 *$len]} {set a3 $i}
    incr i
  }
  return [concat [lsort -integer -index 0 -decreasing [lrange $templist -1 $a1]] [lrange $templist [expr $a1+1] $a2] [lsort -integer -index 0 -decreasing [lrange $templist [expr $a2+1] $a3]] [lrange $templist [expr $a3+1] $i]]
}

################
## Return a list of {site name} list pairs for a set of enzyme lists
################
proc linear_enz_sort {w enz_list start end} {
  global info
  set templist [list]
  foreach enzyme $enz_list {
    foreach site $info($w,$enzyme) {
      if {$site > $end} {break}
      if {$site >= $start} {lappend templist [list $site $enzyme]}
    }
  }
  set templist [lsort -integer -index 0 $templist]
}


################
## draw arrows on the linear graphic map
################
proc linear_feature_draw {c y w start end total_length tag {tags [list]} {x_right 390}} {
  global info modifier
  set ranges [feature_coords $w $tag $start $end]
  if {[$w.textarea tag cget $tag -background] == ""} {
    set state "hidden"
  } else {
    set state "normal"
  }
  set tag_color [eval format "\#%04X%04X%04X" [winfo rgb . [lindex [$w.textarea tag bind $tag <<Revcolors>>] [lindex [$w.textarea tag bind $tag <<Metadata>>] 3]]]]

  set tag_bg_color [gray_color $tag_color]
  set direction [lindex [$w.textarea tag bind $tag <<Metadata>>] 3]
  set label [lindex [$w.textarea tag bind $tag <<Metadata>>] 0]
  set gformat [lindex [$w.textarea tag bind $tag <<Metadata>>] 1]
  set width [dict get $gformat width]
  set arrow_list [dict get $gformat arrow_data]
  set fntag [regsub f $tag fn]

  set x_left 0
  #draw first through 2nd to last exon and all introns (no exons drawn if only one exon)
  foreach range1 [lrange $ranges 0 end-1]  range2 [lrange $ranges 1 end] {
    set x1 [expr {$x_left + $x_right * ([lindex $range1 0] - $start) / $total_length}]
    set x2 [expr {$x_left + $x_right * ([lindex $range1 1] - $start) / $total_length}]
    $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon outline] -fill $tag_bg_color -outline $tag_bg_color -state $state -width 2
    $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon foreground] -fill $tag_color -state $state -outline {}
    if {$range2 != [list]} {
      #draw intron
      set x1 [expr {$x_left + $x_right * ([lindex $range2 0] - $start) / $total_length}]
      if {($x1 >= $x2)} {
        $c create line [expr {$x2+0}] [expr {$y+$width/2.0}] [expr {($x1+$x2)/2.0}]  [expr {$y+$width/2.0+5}] $x1 [expr {$y+$width/2.0}] -tag [concat $tags intron] -state $state -fill $tag_color -width 2
      } else {
        #split around the circle
        $c create line $x2 $y [expr {$x2+1}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x2+3}] $y [expr {$x2+4}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x2+6}] $y [expr {$x2+7}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line $x1 $y [expr {$x1-1}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x1-3}] $y [expr {$x1-4}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
        $c create line [expr {$x1-6}] $y [expr {$x1-7}] $y -tag [concat $tags] -fill $tag_color -width 4 -state $state
      }
    }
  }
  #draw final (or only) exon
  set x1 [expr {$x_left + $x_right * ([lindex [lindex $ranges end] 0] - $start) / $total_length}]
  set x2 [expr {$x_left + $x_right * ([lindex [lindex $ranges end] 1] - $start) / $total_length}]
  $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon outline] -fill $tag_bg_color -outline $tag_bg_color -width 2 -state $state
  $c create rectangle $x1 [expr {$y-$width/2.0}] $x2 [expr {$y+$width/2.0}] -tag [concat $tags exon foreground] -fill $tag_color -outline {} -state $state
  

  
  #draw arrows
#move this to a proc, get coords, direction and arrows from tag binding, scale the x coords based on [lindex [$c coords line] 2], keep y coords

  $c create polygon 0 0 -tag  [concat $tags fwd_arrow outline]  -fill $tag_bg_color -width 2 -state $state
  $c create polygon 0 0 -tag  [concat $tags fwd_arrow foreground]  -fill $tag_color  -state $state
  $c create polygon 0 0 -tag  [concat $tags rev_arrow outline]  -fill $tag_bg_color -width 2 -state $state
  $c create polygon 0 0 -tag  [concat $tags rev_arrow foreground]  -fill $tag_color  -state $state

  set first_exon [lindex [$c find withtag $tag&&exon&&foreground]  0]
  set first_exon_bg [lindex [$c find withtag $tag&&exon&&outline]  0]
  set last_exon [lindex [$c find withtag $tag&&exon&&foreground]  end]
  set last_exon_bg [lindex [$c find withtag $tag&&exon&&outline]  end]

  $c bind $tag <<Gformat>> $gformat
  $c bind $tag <<Coord_list>> [list [list $first_exon $first_exon_bg [$c coords $first_exon]] [list $last_exon $last_exon_bg [$c coords $last_exon]]]
  $c bind $tag <<Direction>> $direction

  linear_feature_draw_arrow $c $tag
  

  #draw label
  set x1 [expr {$x_left + $x_right * ((([lindex [lindex $ranges 0] 0] + [lindex [lindex $ranges end] 1])/2)-$start) / $total_length }]
  set featurelabelid [$c create text $x1 [expr {$y+$width/2.0+2}] -text "$label" -anchor n -font [list $info(graphicfontfamily) $info(graphicfontsize)] -tag [concat $tags featurelabel moveabletext] -state $state]

  $c lower intron exon

  #bindings
  $c bind $tag <Any-Enter> "$c itemconfigure $tag&&featurelabel -fill red;$c itemconfigure seqtext -text \{[lindex [$w.textarea tag bind $tag <<Metadata>>] 0]([expr {1+[lindex [lindex $ranges 0] 0]}]...[expr {1+[lindex [lindex $ranges end] end]}])\}; $c itemconfigure $tag&&outline -outline red -width 4"
  $c bind $tag <Any-Leave> "$c itemconfigure $tag&&featurelabel -fill black;$c itemconfigure seqtext -text {}; $c itemconfigure $tag&&outline -outline $tag_bg_color -width 2"

  $c bind $tag <<Tag>> $tag


  $c bind $tag <$modifier-Button-1> "if {\[$c find withtag current&&moveabletext\] ==\"\"} {set cmdy %y; break}"
  $c bind $tag&&(exon||intron||fwd_arrow||rev_arrow) <$modifier-B1-Motion> "if {\[info exists cmdy\]} {$c move $tag 0 \[expr {%y-\$cmdy}\]; set cmdy %y}"
  $c bind $tag&&(exon||intron||fwd_arrow||rev_arrow) <$modifier-ButtonRelease-1> "unset -nocomplain cmoveitem cmdy; $c configure -scrollregion \[$c bbox all\]"


  if {[$w.textarea tag ranges $fntag] == {}} {
    set linktag $tag
  } else {
    set linktag $fntag
  }
  set linkranges [$w.textarea tag ranges $linktag]
  if {[$w.textarea compare [lindex $linkranges 1] < [bp2ix $w.textarea $start]]} {
    set linkranges [lrange $linkranges 2 3] 
  }
  if {([llength $linkranges] > 2) && [$w.textarea compare [lindex $linkranges 2] > [bp2ix $w.textarea $end]]} {
    set linkranges [lrange $linkranges 0 1] 
  }
  if {[$w.textarea compare [lindex $linkranges 0] < [bp2ix $w.textarea $start]]} {
    set linkranges [lreplace $linkranges 0 0 [bp2ix $w.textarea $start]] 
  }
  if {([llength $linkranges] > 2) && [$w.textarea compare [lindex $linkranges 3] > [bp2ix $w.textarea $end]]} {
    set linkranges [lreplace $linkranges 3 3 [bp2ix $w.textarea $end]] 
  } elseif {([llength $linkranges] == 2) && [$w.textarea compare [lindex $linkranges 1] > [bp2ix $w.textarea $end]]} {
    set linkranges [lreplace $linkranges 1 1 [bp2ix $w.textarea $end]] 
  }

  $c bind $tag <Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 0]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 1]]\]"
  $c bind $tag <Double-Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 0]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 1]]\]; event generate $c <<Return>>; break"
  lappend info($w,linked_events) [list $c $tag <Button-1>] [list $c $tag <Double-Button-1>]

  if {[llength $linkranges] == 4} {
    $c bind $tag <Shift-Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 2]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 3]]\]" 
    $c bind $tag <Shift-Double-Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 2]]\] \[bp2ix $w.textarea [ix2bp $w.textarea [lindex $linkranges 3]]\]; event generate $c <<Return>>; break" 
    lappend info($w,linked_events) [list $c $tag <Shift-Button-1>] [list $c $tag <Shift-Double-Button-1>]
  }
}

################
## set the arrow coordinates for a linear feature
################
proc linear_feature_draw_arrow {c tag} {
  set gformat [$c bind $tag <<Gformat>>]
  set width [dict get $gformat width]
  set arrow_list [dict get $gformat arrow_data]
  set coord_list [$c bind $tag <<Coord_list>>]
  foreach {a b} $coord_list {}
  foreach {first_exon first_exon_bg first_exon_coords} $a {}
  foreach {last_exon last_exon_bg last_exon_coords} $b {}
  set direction [$c bind $tag <<Direction>>]
  set y [expr {([lindex [$c coords $first_exon] 1] + [lindex [$c coords $first_exon] 3])/ 2.0}]

  if {$direction} {
    set fwd_pts [lindex $arrow_list 1]
    set rev_pts [lindex $arrow_list 0]
  } else {
    set fwd_pts [lindex $arrow_list 0]
    set rev_pts [lindex $arrow_list 1]
  }
  set flip [lindex $arrow_list 2]
  set f_max_x 0
  foreach {xp yp} $fwd_pts {
    set f_max_x [expr {max($xp, $f_max_x)}]
  }
  set f_max_x [expr {$f_max_x * $width}]

  foreach {fx0 fy0 fx1 fy1 } $last_exon_coords {}
  set last_w [expr {$fx1 - $fx0}]
  set fwd_adjust [expr {min ($f_max_x, ($f_max_x + $last_w) / 2.0)}]
  set fwd_x [expr {$fx1 - $fwd_adjust}]
  set fwd_coords [arrow_coords $fwd_x [expr {$y+0}] -90 0 $width $fwd_pts]
  eval {$c coords fwd_arrow&&foreground&&$tag $fwd_coords}
  eval {$c coords fwd_arrow&&outline&&$tag $fwd_coords}

  set r_max_x 0
  foreach {xp yp} $rev_pts {
    set r_max_x [expr {max($xp, $r_max_x)}]
  }
  set r_max_x [expr {$r_max_x * $width}]
  foreach {rx0 ry0 rx1 ry1 } $first_exon_coords {}
  set first_w [expr {$rx1 - $rx0}]
  set rev_adjust [expr {min ($r_max_x, ($r_max_x + $first_w) / 2.0)}]
  set rev_x [expr {$rx0 + $rev_adjust}]
  set rev_coords [arrow_coords $rev_x [expr {$y+0}] -90 1 $width $rev_pts]
  eval {$c coords rev_arrow&&foreground&&$tag $rev_coords}
  eval {$c coords rev_arrow&&outline&&$tag $rev_coords}

  if {$first_exon == $last_exon} {
    if {[expr {$fwd_adjust+$rev_adjust}] > $first_w} {
      $c itemconfigure $first_exon -state hidden
      $c itemconfigure $first_exon_bg  -state hidden
    } else {
      eval {$c coords $first_exon [expr {$fx0+$rev_adjust-(($rev_adjust>0)?1:0)}] $fy0 [expr {$fx1-$fwd_adjust+(($fwd_adjust>0)?1:0)}] $fy1} 
      eval {$c coords $first_exon_bg [expr {$fx0+$rev_adjust}] $fy0 [expr {$fx1-$fwd_adjust}] $fy1} 
    }
  } else {
    if {$fwd_adjust > $last_w} {
      $c itemconfigure $last_exon -state hidden
      $c itemconfigure $last_exon_bg -state hidden
    } else {
      eval {$c coords $last_exon $fx0 $fy0 [expr {$fx1-$fwd_adjust+(($fwd_adjust>0)?1:0)}] $fy1} 
      eval {$c coords $last_exon_bg $fx0 $fy0 [expr {$fx1-$fwd_adjust}] $fy1} 
    }
    if {$rev_adjust > $first_w} {
      $c itemconfigure $first_exon -state hidden
      $c itemconfigure $first_exon_bg -state hidden
    } else {
      eval {$c coords $first_exon [expr {$rx0+$rev_adjust-(($rev_adjust>0)?1:0)}] $ry0 $rx1 $ry1} 
      eval {$c coords $first_exon_bg [expr {$rx0+$rev_adjust}] $ry0 $rx1 $ry1} 
    }
  }
  $c raise $tag&&foreground $tag&&outline
}

################
## bump all featurelabel items to not overlap, but be as close as possible to their items
################
proc linear_feature_label_bump {c} {
  foreach l [lreverse [$c find withtag featurelabel]] {
    while {[llength [set ollist [linear_feature_overlapping_labels $c $l]]] > 0} {
      set newy 0
      foreach i $ollist {
        set newy [expr {max($newy, [lindex [$c bbox $i] 3]+3)}]
      }
      $c coords $l [lindex [$c coords $l] 0] $newy
    }
  }
}

proc linear_feature_overlapping_labels {c l} {
  set ollist [$c find overlapping {*}[$c bbox $l]]
  set result [list]
  set ltag [lsearch -regexp -inline [$c gettags $l] {f.*#}]
  foreach k $ollist {
    if {$k != $l && ([lsearch -regexp -inline [$c gettags $k] {f.*#}] != $ltag)} {
      lappend result $k
    }
  }
  return $result
}

proc linear_feature_rebump_labels {c} {
  foreach l [lreverse [$c find withtag featurelabel]] {
    set ltag [lsearch -regexp -inline [$c gettags $l] {f.*#}]
    set newy [expr {[lindex [$c bbox {*}[$c find withtag $ltag&&(!featurelabel)]] 3]-2}]
    $c coords $l [lindex [$c coords $l] 0] $newy
  }
  linear_feature_label_bump $c
}

################
## returns a count of features that are below a feature and overlap it- not used-see tagdepth
################
proc features_below {w feature} {
##needs to use recursion, since two features below might not overlap each other
##needs to return one more than the result of features_below for all overlapping features below
  set feature_list [regexp -inline -all {f[0-9]+#} [$w.textarea tag names]]
  set ftag [regsub fn* $feature f]
  set fntag [regsub fn* $feature fn]
  set index [lsearch $feature_list $ftag]
  if {$index == -1} {return -1}
  incr index -1
  set below [lrange $feature_list 0 $index]
  set i 0
  if {[$w.textarea tag ranges $fntag] == {}} {set fntag $ftag}
  foreach b_tag $below {
    if {($b_tag == $ftag) || ($b_tag == $fntag)} continue
    if {[$w.textarea tag ranges [regsub f $b_tag fn]] != {}} {
      set b_tag [regsub f $b_tag fn]
    }
    foreach {x1 x2} [$w.textarea tag ranges $fntag] {
      foreach {y1 y2} [$w.textarea tag ranges $b_tag] {
        if {!([$w.textarea compare $x1 > $y2] || [$w.textarea compare $x2 < $y1])} {
          incr i
        }
      }
    }
  }
  return $i
}

################
## returns a dictionary of tags and depth between indicesstart and end
################
proc tagdepth {t start end} {
  set toptags [list]
  set tagtaglist [list]

  set ixlist [list]
  set taglist [lsearch -inline -regexp -all -not [$t tag names $start] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|foundf|foundr}]
  if {$taglist != [list ]} {lappend ixlist $start}
  set taglist [lsearch -inline -regexp -all -not [$t tag names $end] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|foundf|foundr}]
  if {$taglist != [list ]} {lappend ixlist $end}
  foreach {type tag index} [$t dump -tag $start+1char $end+1chars] {
    if {[lsearch -inline -regexp -all -not $tag {trans[0-9]+#|fn[0-9]+#|tempsel|sel|foundf|foundr}] != [list]} {
      lappend ixlist $index
    }
  }
  set ixlist [lsort -unique $ixlist]
  foreach i $ixlist {
    set taglist [lsearch -inline -regexp -all -not [$t tag names $i] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|foundf|foundr}]
    for {set j 0} {$j < [llength $taglist]} {incr j} {
      foreach tag [lrange $taglist [expr {$j +1}] end] {
        if {(![info exists tagbelow([lindex $taglist $j])]) || ([lsearch -exact $tagbelow([lindex $taglist $j]) $tag] == -1)} {
          lappend tagbelow([lindex $taglist $j]) $tag
        }
      }
    }
  }
  set below_list_dict [array get tagbelow]
  set depth_dict [list]
  foreach tag [dict keys $below_list_dict] {
    set depth_dict [recurs_tagbelow $tag $below_list_dict $depth_dict]
  }
  return $depth_dict

#### old
##bug: current version doesn't work. need to make an array of all tags above the index tag at each i and then recursively add 1 level to each tag above
  foreach i $ixlist {
    set taglist [lsearch -inline -regexp -all -not [$t tag names $i] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|foundf|foundr}]
    for {set j 0} {$j < [llength $taglist]} {incr j} {
      set tag [lindex $taglist $j]
      if {[info exists tags($tag)]} {
        set tags($tag) [expr {max($j,$tags($tag))}]
      } else {
        set tags($tag) $j
      }
    }
  }
  return [array get tags]


### old
  foreach {a b c} [lrange [$t dump -tag $start $end] 0 end-3] {d e f} [lrange [$t dump -tag $start $end] 3 end] {
    if {($c != $f)} {
      set taglist [lsearch -inline -regexp -all -not [$t tag names $c] {trans[0-9]+#|fn[0-9]+#|tempsel|sel|foundf|foundr}]
      if {[llength $taglist] > 1} {
        lappend tagtaglist $taglist
      }
    }
  }
  set c 1
  set z 0
  while {$c && ($z < 15)} {
    set c 0
    foreach taglist $tagtaglist {
      set i 0
      foreach tag $taglist {
        if {![dict exists $toptags $tag] || ($i > [dict get $toptags $tag])} {
          dict set toptags $tag $i
          set c 1
        } elseif {($i < [dict get $toptags $tag])} {
          set i [dict get $toptags $tag]
        }
        incr i
      }
    }
    incr z
  }
  return $toptags
}

################
## recursive function to generate a list of tag depths
################
proc recurs_tagbelow {tag below_list_dict depth_dict} {
  if {(![dict exists $below_list_dict $tag]) || ([dict get $below_list_dict $tag] == [list])} {
    dict set depth_dict $tag 0
    return $depth_dict
  } else {
    set max 0
    foreach btag [dict get $below_list_dict $tag] {
      set depth_dict [recurs_tagbelow $btag $below_list_dict $depth_dict]
      set max [expr {max($max, [dict get $depth_dict $btag])}]
    }
    dict set depth_dict $tag [incr max]
    return $depth_dict
  }
}

################
## changes the scale of a canvas analysis window (as a percent)
################
proc scale_canvas {c} {
  global info

  if {[catch {set info([winfo toplevel $c],scale)}]} {
    set info([winfo toplevel $c],scale) 100
    set info([winfo toplevel $c],new_scale) 100
    sputs [winfo toplevel $c] has not set scale variable.
  }
  set old_scale $info([winfo toplevel $c],scale)
  set new_scale $info([winfo toplevel $c],new_scale)
  if {$old_scale != $new_scale} {
    set xviewstore [lindex [$c xview] 0]
    set yviewstore [lindex [$c yview] 0]
#    $c scale all [lindex [$c bbox all] 0] [lindex [$c bbox all] 1] [expr {1.0 * $new_scale / $old_scale}] [expr {1.0 * $new_scale / $old_scale}]
    $c scale all 0 0 [expr {1.0 * $new_scale / $old_scale}] [expr {1.0 * $new_scale / $old_scale}]
    set new_font_size [expr {int($info(graphicfontsize) * 1.0 *$new_scale/100.0)}]
    foreach item [$c find all] {
      if {[$c type $item] == "text"} {
        $c itemconfigure $item -font [list $info(graphicfontfamily) $new_font_size [font actual [$c itemcget $item -font] -weight]] 
        if {[$c itemcget $item -width] != ""} {
          $c itemconfigure $item -width [expr {1.0 * $new_scale / $old_scale * [$c itemcget $item -width]}]
        }
      } elseif {[$c type $item] == "arc"} {
        $c itemconfigure $item -width [expr {[$c itemcget $item -width] * $new_scale / $old_scale}] 
      }
    }
    $c configure -scrollregion [$c bbox all]
    $c xview moveto $xviewstore
    $c yview moveto $yviewstore
    event generate $c <Configure>
    set info([winfo toplevel $c],scale) $new_scale
  }
}

################
## Select a region of the DNA textarea
################
proc select_region {w from_index to_index} {
  if {[$w.textarea compare $from_index == end]} {set from_index [$w.textarea index end-1c]}
  if {[$w.textarea compare $to_index == end]} {set to_index [$w.textarea index end-1c]}
  $w.textarea tag remove tempsel 1.0 end
  #$w.textarea tag raise tempsel
  $w.textarea tag remove sel 1.0 end
  #$w.textarea tag raise sel
  $w.textarea mark set insert $to_index
  $w.textarea mark set anchor $from_index
  $w.textarea mark set tk::anchor$w.textarea $from_index
  if {[$w.textarea compare insert > tk::anchor$w.textarea]} {
    $w.textarea tag add tempsel tk::anchor$w.textarea insert
    $w.textarea tag add sel tk::anchor$w.textarea insert
  } else {
    $w.textarea tag add tempsel insert tk::anchor$w.textarea 
    $w.textarea tag add sel insert tk::anchor$w.textarea 
  }
  $w.textarea see insert

  vertindexbalancer $w
  selection_manager $w
}

################
## Select from anchor to new x y position (mouse movement selections
################
proc text_select_xy {w x y} {
  global info

  #if {$y < 0} {
  #  vertscrollmanager $w scroll -2 units
  #} elseif {$y >= [winfo height $w.textarea]} {
  #  vertscrollmanager $w scroll 2 units
  #}


  set cur [text_closest_gap $w.textarea $x $y]
  if {[$w.textarea compare $cur == end]} {
    set cur [$w.textarea index end-1c]
  }
  if {[catch {$w.textarea index tk::anchor$w.textarea}]} {
    $w.textarea mark set anchor $cur
    $w.textarea mark set tk::anchor$w.textarea $cur
  }
  #set anchor [$w.textarea index tk::anchor$w.textarea]

  if {[$w.textarea compare $cur < tk::anchor$w.textarea]} {
    set first $cur
    set last tk::anchor$w.textarea
  } else {
    set first tk::anchor$w.textarea
    set last $cur
  }
  $w.textarea tag remove sel 1.0 end
  $w.textarea tag remove tempsel 1.0 end
  $w.textarea mark set insert $cur
  $w.textarea tag add tempsel $first $last
  $w.textarea tag add sel $first $last
  selection_manager $w
  update idletasks
}

################
## scroll and select if mouse leaves DNA with button down
################
proc mouse_left_DNA {w x y} {
  global info

  #$w.infobox configure -text ""
  if {[winfo exists $w]} {
    set x [expr {[winfo pointerx $w]-[winfo rootx $w.textarea]}]
    set y [expr {[winfo pointery $w]-[winfo rooty $w.textarea]}]
    if {$y < 0} {
      vertscrollmanager $w scroll -2 units
      text_select_xy $w $x 3
    } elseif {$y >= [winfo height $w.textarea]} {
      vertscrollmanager $w scroll 2 units
      text_select_xy $w $x [expr {[winfo height $w.textarea]-5}]
    } else {
     # return
   }
    set info(cancel_scroll) [after 70 [list mouse_left_DNA $w $x $y]]
  } else {
    cancel_scrolling_DNA
  }
}

################
## Stop scrolling when mouse re-enters
################
proc cancel_scrolling_DNA {} {
  global info
  if {$info(cancel_scroll) != "" } {
    after cancel $info(cancel_scroll)
    set info(cancel_scroll) ""
  }
}

########
## deletes unneeded scrollbars from the grid manager, and sends scrollbar coordinates to the scrollbar if needed
########
proc optionscrollbar {s args} {
  if {$args == {0 0}} {return}
  if {$args == {0 1} || $args == {0.0 1.0}} {
    if {[grid info $s] != {}} {
      grid remove $s
    }
  } else {
    if {[grid info $s] == ""} {
      grid configure $s
      update idletasks
    } 
  }
  eval [concat $s set $args]
}

########
## deletes unneeded scrollbars from the grid manager, and sends scrollbar coordinates to the scrollbar if needed
########
proc optionxscrollbar {s args} {
  if {$args == {0 0}} {return}
  regexp {([0-9]*)x([0-9]*)\+} [wm geometry [winfo toplevel $s]] g x y
  if {$args == {0 1}} {
    if {[grid info $s] != {}} {
      grid remove $s
      wm geometry [winfo toplevel $s] "$x\x[expr {$y-[$s cget -width]}]"
    }
  } else {
    if {[grid info $s] == ""} {
      wm geometry [winfo toplevel $s] "$x\x[expr {$y+[$s cget -width]}]"
      grid configure $s
      update idletasks
    } 
  }
  eval [concat $s set $args]
}

########
## deletes unneeded scrollbars from the grid manager, and sends scrollbar coordinates to the scrollbar if needed
########
proc optionyscrollbar {s args} {
  if {$args == {0 0}} {return}
  regexp {([0-9]*)x([0-9]*)\+} [wm geometry [winfo toplevel $s]] g x y
  if {$args == {0 1}} {
    if {[grid info $s] != {}} {
      grid remove $s
      wm geometry [winfo toplevel $s] "[expr {$x-[$s cget -width]-1}]x$y"
    }
  } else {
    if {[grid info $s] == ""} {
      wm geometry [winfo toplevel $s] "[expr {$x+[$s cget -width]+1}]x$y"
      grid configure $s
      update idletasks
    } 
  }
  eval [concat $s set $args]
}

##############
## toggle the comment textbox on and off (see next proc def)
##############
proc toggle_comment {w} {
    if {[grid info $w.comframe] == ""} {
      grid configure $w.comframe
    } else {
      grid remove $w.comframe
      focus $w.textarea
    }
}

##############
## open an abi file and create a new window
##############
proc open_abi {filename} {
  global abi_info abiwinum

  set childlist [winfo children .]
  foreach win [regexp -all -inline ".abi_window\[0-9\]*" "[winfo children .] "] {
    if {$abi_info($win,filename) == $filename} {
      wm deiconify $win
      raise $win
      focus $win
      tk_messageBox -message [mc "The file is already being edited."] -type ok -icon info
      return "already open"
    }
  }
  set w ".abi_window$abiwinum"
  incr abiwinum
  set error_status [read_abi_info $filename $w]
  if {$error_status =="ok"} {

    new_abi_window $w
    update_open_previous_menu
  } else {
    array unset abi_info $w*
    tk_messageBox -message "Error opening file:$error_status" -type ok -title "Error Opening File" -icon warning -default ok
  }
  return $error_status
}

##############
## read the header info for an abi file
##############
proc read_abi_info {filename w} {
  global abi_info

  set error_status ok
  foreach track [list 0 1 2 3] {
    set abi_info($w,scale_track,$track) 0
    set abi_info($w,processed_data,$track) [list]
  }
  set abi_info($w,filter_wheel) ACGT
  set abi_info($w,basecall,edited) ""
  set abi_info($w,basecall,original) ""
  set abi_info($w,basecall_loc,edited) [list]
  set abi_info($w,basecall_loc,original) [list]
  set abi_info($w,sample_name) ""
  set abi_info($w,run_time,1) "00:00:00"
  set abi_info($w,run_date,1) "01/01/00"
  set abi_info($w,run_time,2) "00:00:00"
  set abi_info($w,run_date,2) "01/01/00"
  set abi_info($w,filename) $filename
  set abi_info($w,basecall_prob_called,original) [list]
  set abi_info($w,basecall_prob_called,edited) [list]
  set abi_info($w,basecall_prob_a,original) [list]
  set abi_info($w,basecall_prob_a,edited) [list]
  set abi_info($w,basecall_prob_c,original) [list]
  set abi_info($w,basecall_prob_c,edited) [list]
  set abi_info($w,basecall_prob_g,original) [list]
  set abi_info($w,basecall_prob_g,edited) [list]
  set abi_info($w,basecall_prob_t,original) [list]
  set abi_info($w,basecall_prob_t,edited) [list]
  set fid [open $filename r]
  fconfigure $fid -translation binary
  seek $fid 0
  set magnum [read $fid 4]


  if {$magnum == "ABIF"} {
  #####read ABI format data
    set record_list [list]
    set scf_comments [list]
    seek $fid 18
    set bindata [read $fid 4]
    binary scan $bindata I numrecords
    seek $fid 26
    set bindata [read $fid 4]
    binary scan $bindata I records_offset

    seek $fid 0 end
    set file_size [tell $fid]
    if {[expr {$records_offset+28*$numrecords}]<= $file_size} {
      seek $fid $records_offset
      for {set rec_num 0} {$rec_num < $numrecords} {incr rec_num} {
        binary scan [read $fid 28] a4ISSIIII tag_name tag_number data_type ele_len num_ele rec_len rec_data blank
        set file_pointer [tell $fid]
        switch -glob -- $tag_name {
          DATA {#raw and processed data tracks
            if {$tag_number < 0 } {#set to <5 to read in raw data
              #raw data traces- not read at this time, see line above
              set track [expr $tag_number-1]
              seek $fid $rec_data
              binary scan [read $fid [expr {2*$num_ele}]] S* abi_info($w,raw_data,$track)
            } elseif {$tag_number < 9 } {
               #runtime data
            } else {
              #processed data
              set track [expr {$tag_number-9}]
              seek $fid $rec_data
              binary scan [read $fid [expr {2*$num_ele}]] S* abi_info($w,processed_data,$track)
            }
          } 
          FWO_ {#filter wheel order
            set abi_info($w,filter_wheel) [binary format I $rec_data]
          } 
          PBAS {#basecalls
            if {$tag_number == 1 } {
              set type edited
            } else {
              set type original
            }
            seek $fid $rec_data
            set abi_info($w,basecall,$type) [read $fid $num_ele]
          }
          PLOC {#basecalls positions
            if {$tag_number == 1 } {
              set type edited
            } else {
              set type original
            }
            seek $fid $rec_data
            binary scan [read $fid [expr {2*$num_ele}]] S* abi_info($w,basecall_loc,$type)
          }
          RUND {
            binary scan [binary format I $rec_data] Scc year month day
            set abi_info($w,run_date,$tag_number) "$month/$day/$year"
          }
          RUNT {
            binary scan [binary format I $rec_data]  ccc hour min sec
            set abi_info($w,run_time,$tag_number) [format %1s:%02s:%02s $hour $min $sec]
          }
          SMPL {
            seek $fid [expr {$rec_data+1}]
            set abi_info($w,sample_name) [read $fid [expr {$num_ele-1}]]
          }
          S/N% {
            seek $fid [expr $rec_data]
            binary scan [read $fid 8] SSSS abi_info($w,scale_track,0) abi_info($w,scale_track,1) abi_info($w,scale_track,2) abi_info($w,scale_track,3)
          }
          PCON {
          #KB basecaller phred confidence 
            if {$tag_number == 1 } {
              set type edited
            } else {
              set type original
            }
            seek $fid $rec_data
            binary scan [read $fid [expr {$num_ele}]] c* abi_info($w,basecall_prob_called,$type)
            set abi_info($w,basecall_prob_a,$type) [string repeat "0 " $num_ele]
            set abi_info($w,basecall_prob_c,$type) $abi_info($w,basecall_prob_a,$type)
            set abi_info($w,basecall_prob_g,$type) $abi_info($w,basecall_prob_a,$type)
            set abi_info($w,basecall_prob_t,$type) $abi_info($w,basecall_prob_a,$type)
          }
          MODL {
            lappend scf_comments "MODL=[binary format I $rec_data]"
          }
          default {
            if {($data_type == 18) } {
              #PASCAL string (leading size byte)
              seek $fid [expr {$rec_data+1}]
              set string_contents [read $fid [expr {$num_ele-1}]]
              #sputs "untrapped string data($data_type):$tag_name=$string_contents"
              lappend scf_comments "$tag_name=$string_contents"
            } elseif {($data_type == 19)} {
              #C string (0 terminated)
              seek $fid [expr {$rec_data}]
              set string_contents [read $fid [expr {$num_ele-1}]]
              lappend scf_comments "$tag_name=$string_contents"

            } elseif {($data_type == 1024)} {
              seek $fid [expr {$rec_data}]
              set data_contents [read $fid [expr {$num_ele}]]
              binary scan $data_contents c* c_data
              #sputs "untrapped c data($data_type):$rec_data, $num_ele, $tag_name=$c_data"
              #lappend scf_comments "$tag_name=$c_data"
            } elseif {($data_type == 4) } {
              binary scan [binary format I $rec_data] S int_data
              #sputs "untrapped short integer data($data_type):$tag_name=$int_data"
              lappend scf_comments "$tag_name=$int_data"
            } elseif {($data_type == 5) } {
              #sputs "untrapped long integer data($data_type):$tag_name=$rec_data"
              lappend scf_comments "$tag_name=$rec_data"
            } elseif {($data_type == 7) } {
              binary scan [binary format I $rec_data] f float_data
              #sputs "untrapped float data($data_type):$tag_name=$float_data"
              lappend scf_comments "$tag_name=$float_data"
            } else {
              binary scan [binary format I $rec_data] c* c_data
              #sputs "untrapped data:$tag_name $tag_number $data_type $ele_len $num_ele $rec_len $rec_data, $c_data"
            }
          }
        } ;#switch
        seek $fid $file_pointer
      }
    } else {
      set error_status "Wrong Filetype- Data Past End of File"
    }
    set scf_comments [concat "SIGN=[string index $abi_info($w,filter_wheel) 0]=$abi_info($w,scale_track,0),[string index $abi_info($w,filter_wheel) 1]=$abi_info($w,scale_track,1),[string index $abi_info($w,filter_wheel) 2]=$abi_info($w,scale_track,2),[string index $abi_info($w,filter_wheel) 3]=$abi_info($w,scale_track,3)" $scf_comments]
    set scf_comments [concat "STRT=$abi_info($w,run_date,1) $abi_info($w,run_time,1)" "STOP=$abi_info($w,run_date,2) $abi_info($w,run_time,2)" $scf_comments]
    set abi_info($w,scf_comments) [join $scf_comments \n]
  } elseif {$magnum == ".scf"} {
    ########read scf file
  global header
    set header [read $fid 52]
    binary scan $header IIIIIIIIa4IIII samples samples_offset bases left_clip right_clip bases_offset comments_size comments_offset version sample_size code_set private_size private_offset

  global h2
  set h2 $header
  #sputs $w,scf file version $version
  #sputs $samples $samples_offset $bases $left_clip $right_clip $bases_offset $comments_size $comments_offset $version $sample_size $code_set $private_size $private_offset

    #read comments section
    seek $fid $comments_offset
    set comments [read $fid $comments_size]
    set abi_info($w,scf_comments) $comments
    #sputs scf comments:$comments
    #read private section
    seek $fid $private_offset
    set private [read $fid $private_size]
    #sputs p:$private
    set abi_info($w,filter_wheel) ACGT

    if {$version >= 3.00} {
    #read V 3 files
      #read sample points section 
sputs reading scf ver 3
      seek $fid $samples_offset

      foreach track [list 0 1 2 3] {
        if {$sample_size ==  1} {
          binary scan [read $fid $samples] c* data
        } else {
          binary scan [read $fid [expr {2*$samples}]] S* data
        }
        set p_sample 0
        set new_data [list]
        for {set i 0} {$i < $samples} {incr i} {
          lappend new_data [set p_sample [expr {[lindex $data $i]+$p_sample}]]
        }
        set p_sample 0
        set abi_info($w,processed_data,$track) [list]
        for {set i 0} {$i < $samples} {incr i} {
          lappend abi_info($w,processed_data,$track) [set p_sample [expr {[lindex $new_data $i]+$p_sample}]]
        }
      }
      unset data new_data
      #read basecall section
      seek $fid $bases_offset
      set data [list]
      binary scan [read $fid [expr {4*$bases}]] I* abi_info($w,basecall_loc,edited)
      binary scan [read $fid $bases] c* abi_info($w,basecall_prob_a,edited)
      binary scan [read $fid $bases] c* abi_info($w,basecall_prob_c,edited)
      binary scan [read $fid $bases] c* abi_info($w,basecall_prob_g,edited)
      binary scan [read $fid $bases] c* abi_info($w,basecall_prob_t,edited)
      set abi_info($w,basecall,edited) [read $fid $bases]
      foreach char [split $abi_info($w,basecall,edited) ""] prob(a) $abi_info($w,basecall_prob_a,edited) prob(c) $abi_info($w,basecall_prob_c,edited) prob(g) $abi_info($w,basecall_prob_g,edited) prob(t) $abi_info($w,basecall_prob_t,edited) {
        if {[regexp {[acgtACGT]} $char]} {
          lappend abi_info($w,basecall_prob_called,edited) $prob([string tolower $char])
        } else {
          lappend abi_info($w,basecall_prob_called,edited) 0
        }
      }
    } else {
      #read v 1 and 2
      #read sample points section
sputs reading scf ver 2
      seek $fid $samples_offset
      for {set i 0} {$i < $samples} {incr i} {
        if {$sample_size ==  1} {
          binary scan [read $fid 4] cccc apoint cpoint gpoint tpoint
        } else {
          binary scan [read $fid 8] SSSS apoint cpoint gpoint tpoint
        }
        lappend adata $apoint
        lappend cdata $cpoint
        lappend gdata $gpoint
        lappend tdata $tpoint
      }
      set abi_info($w,processed_data,0) $adata
      set abi_info($w,processed_data,1) $cdata
      set abi_info($w,processed_data,2) $gdata
      set abi_info($w,processed_data,3) $tdata
      for {set i 0} {$i < $bases} {incr i} {
        binary scan [read $fid 12] Iccccac3 point prob(a) prob(c) prob(g) prob(t) char reserved
        lappend abi_info($w,basecall_loc,edited) $point
        lappend abi_info($w,basecall_prob_a,edited) $prob(a)
        lappend abi_info($w,basecall_prob_c,edited) $prob(c)
        lappend abi_info($w,basecall_prob_g,edited) $prob(g)
        lappend abi_info($w,basecall_prob_t,edited) $prob(t)
        append abi_info($w,basecall,edited) $char
        if {[regexp {[acgtACGT]} $char]} {
          lappend abi_info($w,basecall_prob_called,edited) $prob([string tolower $char])
        } else {
          lappend abi_info($w,basecall_prob_called,edited) 0
        }
      }
#sputs $abi_info($w,basecall_loc,edited) $abi_info($w,basecall,edited)
    }
  } else {
    set error_status "Wrong Filetype- ABIF not found"
  } 
  if {$abi_info($w,basecall_prob_called,edited) == [list]} {
     set abi_info($w,basecall_prob_a,edited) [string repeat "0 " [string length $abi_info($w,basecall,edited)]]
     set abi_info($w,basecall_prob_called,edited) $abi_info($w,basecall_prob_a,edited)
     set abi_info($w,basecall_prob_c,edited) $abi_info($w,basecall_prob_a,edited)
     set abi_info($w,basecall_prob_g,edited) $abi_info($w,basecall_prob_a,edited)
     set abi_info($w,basecall_prob_t,edited) $abi_info($w,basecall_prob_a,edited)
  }
  close $fid
  return $error_status
}

##############
## Make a new ABI trace window
##############
proc new_abi_window {w} {
  global abi_info
  global modstring modifier tk_patchLevel
  global info abiwinum  toolbar_images

  set abi_info($w,vert_scale) 1
  set abi_info($w,horiz_scale) 1
  set abi_info($w,sequence) $abi_info($w,basecall,edited)
  set abi_info($w,rev_com) 0

  toplevel $w
  wm withdraw $w
  bind $w <Map> "event generate . <<RaiseDialogs>>"
  bind $w <FocusIn> "after 200 event generate . <<RaiseDialogs>>"
  bind $w <Activate> "after 200 event generate . <<RaiseDialogs>>"

  bind $w <$modifier-Key-n> "create_window"
  bind $w <$modifier-Key-q> "close_all_windows"

  if {[tk windowingsystem] == "aqua"} {
      bind $w <$modifier-Key-m> "catch \{aqua_minimize $w\}"
      bind $w <$modifier-Key-quoteleft> "catch {raise \[lindex \[wm stackorder .\] 0\]}"
    if {[file exists $abi_info($w,filename)]} {
        wm attributes $w -titlepath $abi_info($w,filename)
    }
  }
  wm protocol $w WM_DELETE_WINDOW "if {!\$dialogblock} {closewindow $w}"
  wm title $w [file tail $abi_info($w,filename)]


  grid [canvas $w.c  -xscrollcommand "$w.xs set" -bg white -height $info(abi_default_canvas_height) -width $info(abi_default_canvas_width)] -row 0 -rowspan 1 -column 0 -sticky nswe
  grid [scrollbar $w.xs -command "$w.c xview" -orient horizontal] -row 1 -column 0 -sticky nswe

  if {$info(use_tile)} {
    grid [ttk::scale $w.ys -from 50 -to 10 -command "abi_scale $w" -orient vertical -value [expr {$abi_info($w,vert_scale)*10.0}]] -row 0 -column 1 -sticky nswe
    grid [ttk::scale $w.xs2 -from 50 -to 5 -command "abi_x_scale $w" -orient vertical -value [expr {$abi_info($w,horiz_scale)*10.0}]] -row 0 -column 2 -sticky nswe
  } else {
    grid [scale $w.ys -from 50 -to 10 -sliderrelief raised -showvalue 0 -resolution 1 -troughcolor white -background $info(bg_color) -width 10 -command "abi_scale $w" -orient vertical] -row 0 -column 1 -sticky nswe
    $w.ys set [expr {$abi_info($w,vert_scale)*10.0}]
    grid [scale $w.xs2 -from 50 -to 5 -sliderrelief raised -showvalue 0 -resolution 1 -troughcolor white -background $info(bg_color) -width 10 -command "abi_x_scale $w" -orient vertical] -row 0 -column 2 -sticky nswe
    $w.xs2 set [expr {$abi_info($w,horiz_scale)*10.0}]
  }
  grid [label $w.yslabel -text y] -row 1 -column 1 -sticky nswe
  grid [label $w.xslabel -text x] -row 1 -column 2 -sticky nswe

  grid [frame $w.fileframe] -row 2 -column 0 -sticky wes
  grid [label $w.fileframe.label -text $abi_info($w,filename) -width 5] -row 2 -column 0 -sticky wes
  grid [label $w.fileframe.linked_abi -image $toolbar_images(link) -borderwidth 0 -relief flat] -row 2 -column 1 -sticky ws
  bind $w.fileframe.linked_abi <ButtonPress-1> "set tooltip_x %x; set tooltip_y %y; sputs %W"
  bind $w.fileframe.linked_abi <B1-Motion> "abi_drag $w.fileframe.linked_abi %X %Y"
  bind $w.fileframe.linked_abi <ButtonRelease-1> "catch {unset tooltip_x tooltip_y}; if {(\[winfo containing %X %Y\] != \"\") && \[winfo exists .abitooltip\]} {destroy .abitooltip; abi_drop $w %X %Y}"
  tooltip_install $w.fileframe.linked_abi "Drag to a sequence window\nto link"
  grid columnconfigure $w.fileframe 0 -weight 1

  grid rowconfigure $w 0 -weight 1
  grid columnconfigure $w 0 -weight 1

  set b [menu $w.menubar]

  ##file menu
  $b add cascade -menu [menu $b.filemenu] -label [mc "File"]
  $b.filemenu add command -label [mc "Open"] -accelerator "$modstring+O" -command "open_file_dialog"
  bind $w <$modifier-KeyPress-o> "open_file_dialog"
  menu $b.filemenu.open_previous
  $b.filemenu add cascade -label [mc "Open Recent Files"] -menu $b.filemenu.open_previous
  $b.filemenu add command -label [mc "Save Window as EPS image"] -accelerator "$modstring+Shift+S" -command "abi_save_eps $w.c"
  bind $w <$modifier-Shift-KeyPress-s> "abi_save_eps $w.c"
  $b.filemenu add command -label [mc "Export as SCF"] -accelerator "$modstring+S" -command "abi_save_scf $w"
  bind $w <$modifier-KeyPress-s> "abi_save_scf $w.c"
  if {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] > -1) ||  ([lsearch -exact [package names] "wmf"] > -1)} {
    $b.filemenu add command -label [mc "Page Setup"] -accelerator "$modstring+Shift+P" -command "page_setup_dialog $w"
    bind $w <$modifier-KeyPress-P> "page_setup_dialog $w"
  }
  $b.filemenu add command -label [mc "Print"] -accelerator "$modstring+P" -command "print_abi $w.c"
  bind $w <$modifier-KeyPress-p> "print_abi $w.c"
  $b.filemenu add command -label [mc "New DNA from basecalls"] -accelerator "$modstring+Shift+N" -command "create_window \$abi_info($w,sequence) \"\" \"\[file tail \$abi_info($w,filename)\] basecalls\" linear 0 1 \"\[file tail \$abi_info($w,filename)\] basecalls\""
  bind $w <Shift-$modifier-KeyPress-n> "create_window \$abi_info($w,sequence) \"\" \"\[file tail \$abi_info($w,filename)\] basecalls\" linear 0 1 \"\[file tail \$abi_info($w,filename)\] basecalls\""
  $b.filemenu add separator
  $b.filemenu add command -label [mc "File Info"] -command "abi_file_info $w"
  $b.filemenu add separator
  $b.filemenu add command -label [mc "Close"] -accelerator "$modstring+W" -command "closewindow $w"
  bind $w <$modifier-KeyPress-w> "closewindow $w"

  ##edit menu
  $b add cascade -menu [menu $b.editmenu] -label [mc "Edit"]
  if {([lsearch -exact [package names] "wmf"] > -1)} {
    $b.editmenu add command -label [mc "Copy as Metafile"] -accelerator "$modstring+C" -command "event generate $w.c <<CopyEMF>>"
  }

  if {[tk windowingsystem] != "aqua"} {
    $b.editmenu add command -label [mc "Preferences..."] -command "configure_preferences $w" -accelerator "$modstring+,"
    bind $w <$modifier-KeyPress-comma> "configure_preferences $w"
  }
  $b.editmenu add command -label [mc "Find..."] -command "abi_find_dialog $w" -accelerator "$modstring+F"
  bind $w <$modifier-KeyPress-f> "abi_find_dialog $w"
  bind $w <$modifier-KeyPress-g> "abi_do_find $w \$abi_info(last_find) \$abi_info(find_revcom) \$abi_info(find_literal) \$abi_info(find_wrap)"
  if {[tk windowingsystem] != "aqua"} {
    $b.editmenu add checkbutton -label [mc "Reverse-Complement"] -command "abi_revcom $w" -variable abi_info($w,rev_com) -onvalue 1 -offvalue 0 -accelerator "$modstring+/"
  } else {
    $b.editmenu add checkbutton -label [mc "Reverse-Complement"] -command "abi_revcom $w" -variable abi_info($w,rev_com) -onvalue 1 -offvalue 0 
  }
  bind $w <$modifier-KeyPress-slash> "set abi_info($w,rev_com) \[expr {!\$abi_info($w,rev_com)}\];abi_revcom $w"
  $b.editmenu add separator
  $b.editmenu add command -label [mc "Align..."] -command "align_dialog2 $w" -accelerator "$modstring+L"
  bind $w <$modifier-KeyPress-l> "align_dialog2 $w"
  if  {([lsearch -glob [info loaded] "*TclSpeech2.0.dylib*"] > -1) && $info(speak_use_aqua)} {
    $b.editmenu add separator
    $b.editmenu add command -label [mc "Start/Stop Speak Text..."] -accelerator "" -command "if {!\[info exists info($w,speak_cancel)\]} {speak $w 0} else {speak $w stop}"

  }
  
  ##windows menu
  $b add cascade -menu [menu $b.windows] -label [mc "Window"]

  ##help menu
  $b add cascade -menu [menu $b.help1] -label [mc "Help"]
  $b.help1 add command -label [mc "Standard Genetic Code"] -command "genetic_code_dialog $w"
  $b.help1 add command -label [mc "AA Info"] -command "aa_info_dialog $w"

  ##platform specific menu items
  if {[tk windowingsystem] != "aqua"} {
    #Exit is automatically on the apple menu in Aqua
    $b.filemenu add separator
    $b.filemenu add command -label [mc "Exit"] -accelerator "$modstring+Q" -command close_all_windows

    #About... goes on the apple menu in aqua
    $b.help1 add separator
    $b.help1 add command -label [mc "About ApE..."] -command "about_dialog $w"
  } else {
    #define the apple menu
    menu $b.apple 
    $b add cascade -menu $b.apple
    $b.apple add command -label [mc "About ApE"] -command "about_dialog $w"
    $b.apple add separator
    #$b.apple add command -label [mc "Preferences..."]  -command "configure_preferences $w" -accelerator "$modstring+,"
    catch {.menubar.filemenu entryconfigure [mc "New"] -state disabled}
    catch {.menubar.filemenu entryconfigure [mc "Open..."] -state disabled}
    catch {  .menubar.filemenu entryconfigure [mc "Open Recent Files"] -state disabled}
      #.menubar.apple entryconfigure [mc "Preferences..."] -state disabled
     catch { .menubar.apple entryconfigure [mc "About ApE"] -state disabled}

    ##set the new window coordinates
    wm geometry $w "+$info(newaquax)+$info(newaquay)"
    incr info(newaquax) 20
    incr info(newaquay) 20
    if {$info(newaquax) > 100} {set info(newaquax) 20}
    if {$info(newaquay) > 100} {set info(newaquay) 20}
  }
  bind $w <$modifier-KeyPress-q> "close_all_windows"
  bind $w <$modifier-KeyPress-0> "if {\[info commands console\] != \"\"} \{
               console show
               uplevel #0 \{set w $w\}
               \}"
  $w configure -menu $b

  set outputmenu [menu $w.c.outputmenu]
  $outputmenu add command -label [mc "Save Window"] -accelerator "$modstring+S" -command "abi_save_eps $w.c" 
  if {([lsearch -exact [package names] "wmf"] > -1)} {
    $outputmenu add command -label [mc "Copy as Metafile"] -accelerator "$modstring+C" -command "event generate $w.c <<CopyEMF>>"
    bind $w.c <$modifier-KeyPress-c> "event generate $w.c <<CopyEMF>>"
    bind $w.c <<CopyEMF>> "abi_copy_metafile $w.c both"
  }
  $outputmenu add command -label [mc "Print"] -accelerator "$modstring+P" -command "print_abi $w.c"
  $outputmenu add command -label [mc "New DNA from basecalls"] -accelerator "$modstring+Shift+N" -command "create_window \$abi_info($w,sequence) \"\" \"\[file tail \$abi_info($w,filename)\] basecalls\" linear 0 1 \"\[file tail \$abi_info($w,filename)\] basecalls\""

  $outputmenu add command -label [mc "Align..."] -command "align_dialog2 $w" -accelerator "$modstring+L"
  if {[tk windowingsystem] != "aqua"} {
    $outputmenu add checkbutton -label [mc "Reverse-Complement"] -command "abi_revcom $w" -variable abi_info($w,rev_com) -onvalue 1 -offvalue 0 -accelerator "$modstring+/"
  } else {
    $outputmenu add checkbutton -label [mc "Reverse-Complement"] -command "abi_revcom $w" -variable abi_info($w,rev_com) -onvalue 1 -offvalue 0 
  }


  if {[tk windowingsystem] != "aqua"} {
    bind $w.c <Button-3> "tk_popup $outputmenu %X %Y"
  } else {
    bind $w.c <Button-2> "tk_popup $outputmenu %X %Y"
  }


  for {set track 0} {$track < 4} {incr track} {
    set i 0
    set trace [list]
    foreach point $abi_info($w,processed_data,$track) {
      lappend trace $i [expr {300-$point/8.0}]
      incr i
    } 
    $w.c create line $trace -fill $abi_info(colors,[string index $abi_info($w,filter_wheel) $track]) -tags [list scalable trace [string index $abi_info($w,filter_wheel) $track]]
  }
  set i 0

  foreach call [split $abi_info($w,basecall,edited) ""] x $abi_info($w,basecall_loc,edited) {
    $w.c create text $x 15 -text $call -anchor n -font dnafont -width 0 -fill $abi_info(colors,[string toupper $call]) -tags [list basecall [string toupper $call]]
    incr i
    if {[expr {$i % 10}] == 0} {
      $w.c create text $x 0 -text $i -anchor n -font dnafont -width 0 -fill black -tags indextext
    }
  }



  set trace_top [lindex [$w.c bbox trace] 1]
  set trace_bottom [lindex [$w.c bbox trace] 3]
  $w.c move trace 0 [expr {35-$trace_top}] 
  $w.c scale trace  0 35 1 [expr {($info(abi_default_canvas_height)-45.0)/($trace_bottom-$trace_top*1.0)}]


  #bug in canvas scale?
    set trace_top [lindex [$w.c bbox trace] 1]
    set trace_bottom [lindex [$w.c bbox trace] 3]
    $w.c move trace 0 [expr {35-$trace_top}] 
    $w.c scale trace  0 35 1 [expr {($info(abi_default_canvas_height)-45.0)/($trace_bottom-$trace_top)}]

   #create fred_graph polygon item (graphs the phred score)
  set phred_graph [$w.c create polygon {-2 300 -2 300 -2 300} -fill {} -outline {} -tags [list phred_graph scalable]]
  $w.c lower $phred_graph
  abi_draw_phred $w
 
  #create edit box and editing bindings
  $w.c create rectangle 0 0 0 0 -tag editbox -fill {} -outline {}
  $w.c lower editbox
  $w.c bind basecall <Double-Button-1> "abi_edit_mode $w \[$w.c find withtag current\]"
  bind $w.c <$modifier-Button-1> "abi_add_base $w \[$w.c canvasx %x\]"
  bind $w.c <<ClearEdit>> "
    $w.c coord editbox 0 0 0 0
    $w.c lower editbox
    $w.c itemconfigure editbox -outline {} -fill {}
    bind $w.c <Any-ButtonPress> {}
    bind $w.c <FocusOut> {}
    bind $w.c <Any-Key> {}
  "

  $w.c configure -scrollregion [list 0 0 [lindex [$w.c bbox all] 2] $info(abi_default_canvas_height)]
  wm deiconify $w
  raise $w
  focus $w
  focus $w.c
  #in aqua, the window height isn't assigned until after updating (needed to assign selection rectangle size)
  update

  bind $w.c <Configure> "if {\[winfo height $w.c\] > 80} {
    $w.c scale scalable  0 35 1 \[expr {(\[winfo height $w.c\]-45.0)/(\[lindex \[$w.c bbox trace\] 3\]-\[lindex \[$w.c bbox trace\] 1\])*\$abi_info($w,vert_scale)}\] 
    $w.c scale selection 0 -2 1 \[expr {\[winfo height $w.c\]/\[lindex \[$w.c coords selection\] 3\]}\]
    set info(abi_default_canvas_height) \[winfo height $w.c\]
    set info(abi_default_canvas_width) \[winfo width $w.c\]
  } else {
    set info(abi_default_canvas_height) 80
    set info(abi_default_canvas_width) \[winfo width $w.c\]
  }"
  bind $w <Any-MouseWheel> {[winfo toplevel %W].c xview scroll [expr {int(1.0 * %D/-$info(mousewheelunits))}] units}
  bind $w.c <Shift-Button-3> {console show}

  $w.c create rectangle -2 -2 -2 [winfo height $w.c] -tags [list selection] -fill gray90
  $w.c lower selection
  $w.c lower $phred_graph
  bind $w.c <Button-1> "abi_click_select $w.c %x"
  bind $w.c <Shift-Button-1> "abi_shift_select $w.c %x"
 
  if {([tk windowingsystem] == "win32") && ([lsearch -exact [package names] "tkdnd"] > -1)} {
    dnd bindtarget $w Files <Drop> {HandleFileDrop  %D %T}
  }

  update_windows_menu
  set info(open_previous) [linsert $info(open_previous) 0 $abi_info($w,filename)]
  update_open_previous_menu
}

###########
## drag and drop for abi sequence linking
###########
proc abi_drag {w x y} {
  global tooltip_x tooltip_y toolbar_images
  if {[winfo exists .abitooltip] && [info exists tooltip_x]} {
    wm geometry .abitooltip +[expr {$x-$tooltip_x}]+[expr {$y-$tooltip_y}]
  } elseif {![info exists tooltip_x]} {
    set tooltip_x $x
    set tooltip_y $y
  } elseif {([expr {abs($x - $tooltip_x)}] > 3) || ([expr {abs($y - $tooltip_y)}] > 3)} {
    toplevel .abitooltip -borderwidth 1 -background black
    if {([tk windowingsystem] == "aqua")} {
      tk::unsupported::MacWindowStyle style .abitooltip help {}
    } else { 
      wm overrideredirect .abitooltip 1
    }
    catch {wm attributes .abitooltip -alpha .4}
    pack [set c [canvas .abitooltip.c]]
    .abitooltip.c create image 0 0 -image $toolbar_images(link)
    .abitooltip.c configure -scrollregion [$c bbox 1] -width [expr {[lindex [$c bbox 1] 2] - [lindex [$c bbox 1] 0]}] -height [expr {[lindex [$c bbox 1] 3] - [lindex [$c bbox 1] 1]}] 
    #set tooltip_x [expr {round($x - [winfo rootx $w])}]
    #set tooltip_y [expr {round($y - [winfo rooty $w])}]
    wm geometry .abitooltip +[expr {$x-$tooltip_x}]+[expr {$y-$tooltip_y}]
  }
}

###########
## drag and drop for abi sequence linking
###########
proc abi_drop {from_abi X Y} {
  if {[catch {set to_window [winfo toplevel [winfo containing $X $Y]]}]} {
    set to_window ""
  }
  #sputs $from_abi $to_window
  if {[regexp {.dna_window[0-9]+} $to_window]} {
    link_abi $to_window $from_abi
  }
}

######
##
######
proc link_abi {w abi} {
  global info abi_info toolbar_images
  foreach element [list sample_name run_time,1 run_date,1 run_time,2 run_date,2 filename filter_wheel scale_track,0 scale_track,1 scale_track,2 scale_track,3 basecall processed_data,0 processed_data,1 processed_data,2 processed_data,3 basecall_loc basecall_prob_called basecall_prob_a basecall_prob_c basecall_prob_g basecall_prob_t] {
    if {$element in [list processed_data,0 processed_data,1 processed_data,2 processed_data,3]} {
      lappend result [binary format S* $abi_info($abi,$element)]
    } elseif {$element eq "basecall_loc"} {
      if {$abi_info($abi,$element\,edited) == $abi_info($abi,$element\,original)} {
        lappend result [list [binary format S* $abi_info($abi,$element\,edited)] [list]]
      } else {
        lappend result [list [binary format S* $abi_info($abi,$element\,edited)] [binary format S* $abi_info($abi,$element\,original)]]
      }
    } elseif {$element eq "basecall"} {  
      if {$abi_info($abi,$element\,edited) == $abi_info($abi,$element\,original)} {
        lappend result [list $abi_info($abi,$element\,edited) [list]]
      } else {
        lappend result [list $abi_info($abi,$element\,edited) $abi_info($abi,$element\,original)]
      }
    } elseif {$element in [list basecall_prob_called basecall_prob_a basecall_prob_c basecall_prob_g basecall_prob_t]} {
      if {$abi_info($abi,$element\,edited) == $abi_info($abi,$element\,original)} {
        if {[lsearch -not $abi_info($abi,$element\,edited) 0] > -1} {
          lappend result [list [binary format c* $abi_info($abi,$element\,edited)] [list]]
        } else {
          lappend result [list [list] [list]]
        }
      } else {
        lappend result [list [binary format c* $abi_info($abi,$element\,edited)] [binary format c* $abi_info($abi,$element\,original)]]
      }
    } elseif {$element eq "filename"} {
      lappend result [file tail $abi_info($abi,$element)]
    } else {
      lappend result $abi_info($abi,$element)
    }
  }
  if {!($result in $info($w,linked_abi_list)) } {
    lappend info($w,linked_abi_list) $result
    set info($w,saved) 0
    if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
  } else {
    sputs duplicate abi link
  }
  $w.infoframe.linked_abi configure -image $toolbar_images(link)
  bind $w.infoframe.linked_abi <Enter> " tooltip_enter %W \{Click to see [llength $info($w,linked_abi_list)] linked abi files.\}"
  bind $w.infoframe.linked_abi <Leave> "tooltip_leave %W"
  return {}
}

######
##
######
proc open_linked_abi {w index} {
  global info abi_info abiwinum data

  set data_list [lindex $info($w,linked_abi_list) $index]

  set abi ".abi_window$abiwinum"
  incr abiwinum
  foreach element [list  sample_name run_time,1 run_date,1 run_time,2 run_date,2 filename filter_wheel scale_track,0 scale_track,1 scale_track,2 scale_track,3 basecall processed_data,0 processed_data,1 processed_data,2 processed_data,3 basecall_loc basecall_prob_called basecall_prob_a basecall_prob_c basecall_prob_g basecall_prob_t] data $data_list {
    if {$element in [list processed_data,0 processed_data,1 processed_data,2 processed_data,3]} {
      binary scan $data S* abi_info($abi,$element)
    } elseif {$element eq "basecall_loc"} {
      if {[lindex $data 1] == [list]} {
        binary scan [lindex $data 0] S* abi_info($abi,$element\,edited)
        binary scan [lindex $data 0] S* abi_info($abi,$element\,original)
      } else {
        binary scan [lindex $data 0] S* abi_info($abi,$element\,edited)
        binary scan [lindex $data 1] S* abi_info($abi,$element\,original)
      }
    } elseif {$element eq "basecall"} {  
      if {[lindex $data 1] == [list]} {
        set abi_info($abi,$element\,edited) [lindex $data 0]
        set abi_info($abi,$element\,original) [lindex $data 0]
      } else {
        set abi_info($abi,$element\,edited) [lindex $data 0]
        set abi_info($abi,$element\,original) [lindex $data 1]
      }
    } elseif {$element in [list basecall_prob_called basecall_prob_a basecall_prob_c basecall_prob_g basecall_prob_t]} {
       if {[lindex $data 1] == [list]} {
         if {[lindex $data 0] == [list]} {
           set abi_info($abi,$element\,edited) [string repeat 0 [llength abi_info($abi,basecall_loc,edited)]]
           set abi_info($abi,$element\,original) [string repeat 0 [llength abi_info($abi,basecall_loc,edited)]]
         } else {
          binary scan [lindex $data 0] c* abi_info($abi,$element\,edited)
          binary scan [lindex $data 0] c* abi_info($abi,$element\,original)
         }
      } else {
        binary scan [lindex $data 0] c* abi_info($abi,$element\,edited)
        binary scan [lindex $data 1] c* abi_info($abi,$element\,original)
      }
    } else {
      set abi_info($abi,$element) $data
    }
  }

  new_abi_window $abi
  update_open_previous_menu
}

######
##
######
proc remove_linked_abi {w index} {
  global info
  set info($w,linked_abi_list) [lreplace $info($w,linked_abi_list) $index $index]
  set info($w,saved) 0
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
  if {[llength $info($w,linked_abi_list)] == 0} {
    $w.infoframe.linked_abi configure -image ""
    bind $w.infoframe.linked_abi <Enter> ""
    bind $w.infoframe.linked_abi <Leave> ""
  } else {
    bind $w.infoframe.linked_abi <Enter> "tooltip_enter %W \{Right-click to see [llength $info($w,linked_abi_list)] linked abi files.\}"
    bind $w.infoframe.linked_abi <Leave> "tooltip_leave %W"
  }
  return {}
}

#######
##
#######
proc linked_abi_popup {w rootx rooty} {
  global info
  if {[$w.infoframe.linked_abi cget -image] == ""} {
    return
  }
  if {[winfo exists .tooltip]} {destroy .tooltip}
  if {![winfo exists $w.infoframe.linked_abi.popupmenu]} {
    menu $w.infoframe.linked_abi.popupmenu
  }
  if {![winfo exists $w.infoframe.linked_abi.popupmenu.open]} {
    menu $w.infoframe.linked_abi.popupmenu.open
    $w.infoframe.linked_abi.popupmenu add cascade -label "Open" -menu $w.infoframe.linked_abi.popupmenu.open
  }
  if {![winfo exists $w.infoframe.linked_abi.popupmenu.remove]} {
    menu $w.infoframe.linked_abi.popupmenu.remove
    $w.infoframe.linked_abi.popupmenu add cascade -label "Remove" -menu $w.infoframe.linked_abi.popupmenu.remove
  }
  $w.infoframe.linked_abi.popupmenu.open delete 0 end
  $w.infoframe.linked_abi.popupmenu.remove delete 0 end
  set i 0
  foreach abi $info($w,linked_abi_list) {
    set filename [lindex $abi 5]
    $w.infoframe.linked_abi.popupmenu.open add command -label [file tail $filename] -command "open_linked_abi $w $i"
    $w.infoframe.linked_abi.popupmenu.remove add command -label [file tail $filename] -command  "remove_linked_abi $w $i"
    incr i
  }
  tk_popup $w.infoframe.linked_abi.popupmenu $rootx $rooty
}

######
##
######
proc encode_abi {w index} {
  global info
  set result ""
  set data_list [lindex $info($w,linked_abi_list) $index]
  set basecall [lindex [lindex $data_list 11] 0]
  set locus_line "[format "LOCUS       %-16s %+11s bp ds-DNA     %-8s %-3s %-11s" linked_abi [string length $basecall] linear SYN [string toupper [clock format [clock seconds] -format "%d-%h-%Y"]]]\n"

  #first comment line: sample_name run_time,1 run_date,1 run_time,2 run_date,2 filename filter_wheel scale_track,0 scale_track,1 scale_track,2 scale_track,3
  set s "COMMENT     "
  set result $locus_line
  append s [lrange $data_list 0 10]
  append result [join [regexp -all -inline "[string repeat . 79]"  $s] \n] \n
  append result [string range $s end-[expr {([string length $s] % 79)-1}] end] \n

  #2nd comment line: basecall,original data
  set s "COMMENT     [lindex [lindex $data_list 11] 1]"
  append result [join [regexp -all -inline "[string repeat . 79]"  $s] \n] \n
  append result [string range $s end-[expr {([string length $s] % 79)-1}] end] \n

  #3rd-18th comment line: processed_data,0 processed_data,1 processed_data,2 processed_data,3 basecall_loc basecall_prob_called basecall_prob_a basecall_prob_c basecall_prob_g basecall_prob_t
  foreach element [lrange $data_list 12 end] {
    set s "COMMENT      [::base64::encode -maxlen 0 $element]"
    append result [join [regexp -all -inline "[string repeat . 79]"  $s] \n] \n
    append result [string range $s end-[expr {([string length $s] % 79)-1}] end] \n
  }
  regsub -all \n\n $result \n result
    append result "ORIGIN\n"

    ##sequence output
    set i 0
    while {$i < [string length $basecall]} {
      append result "[format "%+9s %s %s %s %s %s %s" [expr {$i+1}] [string range $basecall $i [expr {$i+9}]] [string range $basecall [expr {$i+10}] [expr {$i+19}]] [string range $basecall [expr {$i+20}] [expr {$i+29}]] [string range $basecall [expr {$i+30}] [expr {$i+39}]] [string range $basecall [expr {$i+40}] [expr {$i+49}]] [string range $basecall [expr {$i+50}] [expr {$i+59}]]]\n"
      incr i 60
    }
    append result "//"
  return $result
}


######
##
######
proc decode_abi {text} {
  global info data_list basecall return_list
  
  set data_list [split [regsub -all {ORIGIN} $text \x0] \x0]
  set header [lindex $data_list 0]
  regsub -all \n $header "" header
  set basecall  [lindex $data_list 1]
  regsub -all {[\s/0-9]} $basecall "" basecall
  set data_list [split [regsub -all {COMMENT\s\s\s\s\s} $header \x0] \x0]
  set data_list [lrange $data_list 1 end]
  set return_list [lindex $data_list 0]
  lappend return_list [list $basecall [lindex $data_list 1]]
  foreach element [lrange $data_list 2 end] {
    lappend return_list [::base64::decode $element]
  }
 return $return_list
}


###########
## change the selection with button1
###########
proc abi_draw_phred {w} {
  global abi_info
  #sputs $w, [info exists abi_info($w,basecall_prob_called,edited)]
  if {(![info exists abi_info($w,basecall_prob_called,edited)]) || ($abi_info($w,basecall_prob_called,edited) == [list])} {return}

  set abi_info($w,basecall_prob_called,edited) [lrange $abi_info($w,basecall_prob_called,edited) 0 [expr {[llength $abi_info($w,basecall_loc,edited)] - 1}]]
###need to put in the xscale!!!
  set c $w.c
  set p [$c find withtag phred_graph]
  set atrace [$c find withtag "trace && A"]
  set horiz_scale $abi_info($w,horiz_scale)
  set y1 [lindex [$c bbox $atrace] 3]
  set x0 [lindex [$c bbox $atrace] 0]
  set x1 [lindex [$c bbox $atrace] 2]
  set y0 [lindex [$c bbox [lindex [$c find withtag basecall] 0]] 3] 
  set yrange [expr {$y1 - $y0 *1.0}]
  if {!$abi_info($w,rev_com)} {
    set phred_coord_list [list $x1 $y1 $x0 $y1 $x0 [expr {$y1-[lindex $abi_info($w,basecall_prob_called,edited) 0]/100.0*$yrange}]]
    foreach prob0 [lrange $abi_info($w,basecall_prob_called,edited) 0 end-1] prob1 [lrange $abi_info($w,basecall_prob_called,edited) 1 end] basex0 [lrange $abi_info($w,basecall_loc,edited) 0 end-1] basex1 [lrange $abi_info($w,basecall_loc,edited) 1 end] {
      lappend phred_coord_list [set tx [expr {($basex1+$basex0)/2.0* $horiz_scale}]] [expr {$y1-$prob0/100.0*$yrange}] $tx [expr {$y1-$prob1/100.0*$yrange}]
    }
    lappend phred_coord_list $x1 [expr {$y1-$prob1/100.0*$yrange}]
  } else {
   ##rev com
   set phred_coord_list [list $x0 $y1 $x1 $y1 $x1 [expr {$y1-[lindex $abi_info($w,basecall_prob_called,edited) 0]/100.0*$yrange}]]
    foreach prob0 [lrange $abi_info($w,basecall_prob_called,edited) 0 end-1] prob1 [lrange $abi_info($w,basecall_prob_called,edited) 1 end] basex0 [lrange $abi_info($w,basecall_loc,edited) 0 end-1] basex1 [lrange $abi_info($w,basecall_loc,edited) 1 end] {
      lappend phred_coord_list [set tx [expr {$x1- (($basex1+$basex0)/2.0* $horiz_scale)}]] [expr {$y1-$prob0/100.0*$yrange}] $tx [expr {$y1-$prob1/100.0*$yrange}]
    }
    lappend phred_coord_list $x0 [expr {$y1-$prob1/100.0*$yrange}]
  }
  $c coords $p $phred_coord_list
  $c itemconfig $p  -fill #F0F0FF -outline #d0d0ff
  $c lower $p

}
###########
## change the selection with button1
###########
proc abi_click_select {c mouse_x} {
  set x [abi_get_gap $c [$c canvasx $mouse_x]]
  $c coords selection $x -2 $x [winfo height $c]
}

###########
## change the selection with shift-button1
###########
proc abi_shift_select {c mouse_x} {
  set x [abi_get_gap $c [$c canvasx $mouse_x]]
  if {$x < [expr {([lindex [$c coords selection] 0]+[lindex [$c coords selection] 2])/2}]} {
    $c coords selection $x -2 [lindex [$c coords selection] 2] [winfo height $c]
  } else {
    $c coords selection [lindex [$c coords selection] 0] -2 $x [winfo height $c]
  }
}


###########
## change the selection from from_c to to_c
###########
proc abi_select_region {w from_c to_c} {
  global abi_info
  foreach {x0 i x1 j} [$w.c bbox all] {break}
  foreach {s0 i s1 j} [$w.c coords selection] {break}

  if {[expr {$from_c+1}] > [llength $abi_info($w,basecall_loc,edited)]} {
    set from_c [expr {[llength $abi_info($w,basecall_loc,edited)]-1}]
  }
  if {($to_c ne "select") && ([expr {$to_c+1}] > [llength $abi_info($w,basecall_loc,edited)])} {
    set to_c [expr {[llength $abi_info($w,basecall_loc,edited)]-1}]
  }
  if {$from_c < 0 } {
    set from_c 0
  }
  if {$to_c < 0 } {
    set to_c 0
  }

  set a [lindex $abi_info($w,basecall_loc,edited) [expr {$from_c-1}]]
  set b [lindex $abi_info($w,basecall_loc,edited) $from_c]
  set c [lindex $abi_info($w,basecall_loc,edited) [expr {$from_c+1}]]

  if {$from_c == 0} {
    set loc_list [concat 0 [expr {($b+$c)/2}]]
  } elseif {[expr {$from_c+1}] == [llength $abi_info($w,basecall_loc,edited)]} {
    set loc_list [concat [expr {($a+$b)/2}] $x1]
  } else {
    set loc_list [list [expr {($a+$b)/2}] [expr {($b+$c)/2}]]
  }

  if {$to_c eq "select"} {
    set from_mid [expr {([lindex $loc_list 0]+[lindex $loc_list 1]) / 2.0}]
    set from_mid [expr {$abi_info($w,rev_com)?($x1-$abi_info($w,horiz_scale)*($from_mid+3)):($abi_info($w,horiz_scale)*$from_mid)}]
    set sel_mid [expr {($s0 + $s1) / 2.0}]
    if {$from_mid < $sel_mid} {
      $w.c coords selection [expr {$abi_info($w,rev_com)?($x1-$abi_info($w,horiz_scale)*([lindex $loc_list 1]+3)):($abi_info($w,horiz_scale)*[lindex $loc_list 0])}] -2 $s1 [winfo height $w.c]
    } else {
      $w.c coords selection $s0 -2 [expr {$abi_info($w,rev_com)?($x1-$abi_info($w,horiz_scale)*([lindex $loc_list 0]+3)):($abi_info($w,horiz_scale)*[lindex $loc_list 1])}] [winfo height $w.c]
    }
    $w.c xview moveto [expr {([lindex [$w.c coords selection] 0]-[winfo width $w.c]/2.0)/$x1}]
  } else {
    set a [lindex $abi_info($w,basecall_loc,edited) [expr {$to_c-1}]]
    set b [lindex $abi_info($w,basecall_loc,edited) $to_c]
    set c [lindex $abi_info($w,basecall_loc,edited) [expr {$to_c+1}]]

    if {$to_c == 0} {
      set loc_list [concat $loc_list 0 [expr {($b+$c)/2}]]
    } elseif {[expr {$to_c+1}] == [llength $abi_info($w,basecall_loc,edited)]} {
      set loc_list [concat $loc_list [expr {($a+$b)/2}] $x1]
    } else {
      set loc_list [concat $loc_list [expr {($a+$b)/2}] [expr {($b+$c)/2}]]
    }
    set loc_list [lsort -integer $loc_list]
    $w.c coords selection [expr {$abi_info($w,rev_com)?($x1-$abi_info($w,horiz_scale)*([lindex $loc_list 0]+3)):($abi_info($w,horiz_scale)*[lindex $loc_list 0])}] -2 [expr {$abi_info($w,rev_com)?($x1-$abi_info($w,horiz_scale)*([lindex $loc_list 3]+3)):($abi_info($w,horiz_scale)*[lindex $loc_list 3])}] [winfo height $w.c]
    $w.c xview moveto [expr {([lindex [$w.c coords selection] 0]-[winfo width $w.c]/2.0)/$x1}]
  }
}

###########
## get x value of gap nearest x
###########
proc abi_get_gap {c x} {
  set bclist [$c find withtag basecall]
  for  {set i 0} {($i < [llength $bclist]) && ([lindex [$c coord [lindex $bclist $i]] 0] < $x)} {incr i} {
  }
  if {$i== 0} {
    set result [lindex [$c bbox [lindex $bclist $i]] 0]
  } elseif {$i < [llength $bclist]} {
    set result [expr {([lindex [$c coord [lindex $bclist $i]] 0] + [lindex [$c coord [lindex $bclist [expr {$i-1}]]] 0]) /2}]
  } else {
    set result [lindex [$c bbox [lindex $bclist [expr {$i-1}]]] 2]
  }
  return $result
}

###########
## get x value of gap nearest x
###########
proc abi_indices {c x {dir +}} {
  set bclist [$c find withtag basecall]
  for  {set i 0} {($i < [llength $bclist]) && ([lindex [$c coord [lindex $bclist $i]] 0] < $x)} {incr i} {
  }
  return $i
}

###########
## get sequence and indicies can use pixel values, "start", "end", "sel.first", "sel.last"
###########
proc abi_get_seq {w from to} {
  global abi_info

  foreach {x0 i x1 j} [$w.c bbox all] {break}
  foreach {s0 i s1 j} [$w.c coords selection] {break}

  set from [string map "start $x0 end $x1 sel.first $s0 sel.last $s1" $from]
  set to [string map "start $x0 end $x1 sel.first $s0 sel.last $s1" $to]

  if {$from > $to} {
    set i $from
    set from $to
    set to $i   
  }

  set seq ""
  set first 0
  foreach base [$w.c find withtag basecall] {
    set basex [lindex [$w.c coord $base] 0]
    if {$basex > $to} {break}
    if {$basex >= $from} {
     # lappend indices $basex
      append seq [$w.c itemcget $base -text]
    } else {
      incr first
    }
  }

  if {$seq != ""} {
    return [list $first $seq]
  } else {
    return [list]
  }
}

###########
## reverse complement an abi window
###########
proc abi_revcom {w} {
  global abi_info
  set c $w.c

  set x0 [lindex [$c bbox all] 0]
  set x1 [lindex [$c bbox all] 2]
  $c scale all [expr {($x1+$x0)/2}] 0 -1 1

  if {$abi_info($w,rev_com)} {
    foreach base {A C G T} rc_base {T G C A} {
      $c itemconfigure $base -fill $abi_info(colors,$rc_base)
    }
  } else {
    foreach base {A C G T} {
      $c itemconfigure $base -fill $abi_info(colors,$base)
    }
  }
  set lowest [lindex [$c find withtag basecall] 0]
  foreach call [$c find withtag basecall] {
    $c itemconfigure $call -text [string map {A T B V C G D H G C H D K M M K N N * * R Y S S T A V B W W Y R a t b v c g d h g c h d k m m k n n r y s s t a v b w w y r} [$c itemcget $call -text]]
    $c lower $call $lowest
    set lowest $call
  }
  set abi_info($w,sequence) [revcom $abi_info($w,sequence)]

  $w.c xview moveto [expr {1.0-[lindex [$w.xs get] 1]}]
}

###########
## use a scrollbar instead of slider on aqua
## $w.ys -from 5 -to 1  $w.xs2 -from 5 -to 0.5
###########
proc abi_aqua_scale {w dir command args} {
  global abi_info

  if {$dir == "x"} {

  } else {
   if {$command == "moveto"} {
     set newscale [expr {5.0 - 4.0*[lindex $args 0]}]
     $w.ys set [lindex $args 0] [lindex $args 0]
   } else {
     set newscale [expr {$abi_info($w,vert_scale) - 0.1*[lindex $args 0]}]
     if {$newscale < 0} {set newscale 0}
     if {$newscale > 5} {set newscale 5}
     $w.ys set [expr {1.0 - ($newscale-1)/4.0}] [expr {1.0 - ($newscale-1)/4.0}]
   }
   abi_scale $w $newscale
  }
}

###########
## change y scaling of the traces in an abi window
###########
proc abi_scale {w new_scale} {
  global abi_info
    set new_scale [expr {$new_scale/10.0}]
    if {![winfo exists $w.c] || ([$w.c find withtag trace] == {})} {return}
    set baseline [lindex [$w.c bbox trace] 3]
    set ratio [expr {$new_scale/$abi_info($w,vert_scale)}]
    $w.c scale trace  0 $baseline 1 $ratio
    set abi_info($w,vert_scale) $new_scale
}

###########
## change x scaling of the traces in an abi window
###########
proc abi_x_scale {w new_scale} {
  global abi_info
    set new_scale [expr {$new_scale/10.0}]
    if {![winfo exists $w.c] || ![winfo exists $w.xs]} {return}
    set left [lindex [$w.c cget -scrollregion] 0] 
    set center [expr {([lindex [$w.xs get] 1] + [lindex [$w.xs get] 0]) / 2.0}]
    set ratio [expr {$new_scale/$abi_info($w,horiz_scale)}]
    $w.c scale all  0 0 $ratio 1
    $w.c configure -scrollregion [lreplace [$w.c cget -scrollregion] 2 2  [expr {$ratio* [lindex [$w.c cget -scrollregion] 2]}]]
    set abi_info($w,horiz_scale) $new_scale
    set half_width [expr {([lindex [$w.xs get] 1] - [lindex [$w.xs get] 0]) / 2.0/$ratio}]
    $w.c xview moveto [expr {$center-$half_width}]
}

###########
## abi file info dialog
###########
proc abi_file_info {w} {
  global abi_info
  global info

  if {[winfo exists $w.info] == 1} {
    wm deiconify $w.info
    raise $w.info
  } else {
    toplevel $w.info
    wm withdraw $w.info
    wm title $w.info "[mc {File Info:}]$abi_info($w,filename)"
    wm protocol $w WM_DELETE_WINDOW "closewindow $w"
    grid [text $w.info.text -height 5 -width 50  -insertontime 0 -insertofftime 1000] -row 0 -column 0 -sticky nsew
    grid rowconfigure $w.info 0 -weight 1
    grid columnconfigure $w.info 0 -weight 1
    $w.info.text insert end "[mc Sample:]$abi_info($w,sample_name) \n"
    $w.info.text insert end "[mc Scaling:][string index $abi_info($w,filter_wheel) 0]:$abi_info($w,scale_track,0),[string index $abi_info($w,filter_wheel) 1]:$abi_info($w,scale_track,1),[string index $abi_info($w,filter_wheel) 2]:$abi_info($w,scale_track,2),[string index $abi_info($w,filter_wheel) 3]:$abi_info($w,scale_track,3)\n"
    $w.info.text insert end "[mc {Run began:}][clock format [clock scan "$abi_info($w,run_date,1) $abi_info($w,run_time,1)"] -format "%l:%M%p %a,%b %d, %Y"]\n"
    $w.info.text insert end "[mc {Run ended:}][clock format [clock scan "$abi_info($w,run_date,2) $abi_info($w,run_time,2)"] -format "%l:%M%p %a,%b %d, %Y"]\n"
    wm deiconify $w.info 
  }
}

###########
## returns new canvas with copy of abi trace canvas c from x1 to x2.  
###########
proc abi_copy_region {fromc fromx1 fromx2 toc tox1 toy1 xscale yscale {clip_y 0}} {
  global abi_info
  regexp {(-?[0-9]*) (-?[0-9]*) (-?[0-9]*) (-?[0-9]*)} [$fromc bbox all] l x0 fromy1 x3 fromy2


#copy the non-trace objects (should be all text)
  set objects [$fromc find enclosed [expr {$fromx1-15.0}] $fromy1 [expr {$fromx2+15.0}] $fromy2]
  foreach object $objects {
    switch [$fromc type $object] {
      text {
        regexp {([0-9]*.[0-9]*) ([0-9]*.[0-9]*)} [$fromc coords $object] l textx texty
        $toc create text [expr {($textx-$fromx1)*$xscale+$tox1}] [expr {$texty*$yscale+$toy1}] -text [$fromc itemcget $object -text] -fill [$fromc itemcget $object -fill] -anchor [$fromc itemcget $object -anchor] -font [$fromc itemcget $object -font]
        #need to adjust scale if yscale<1
      }
      default {#sputs [$fromc type $object]}
    }
  }

 ##do all traces at once so you can do only the x region between fromx1 to fromx2

  set Aline [$fromc find withtag {trace && A}] 
  set Cline [$fromc find withtag {trace && C}] 
  set Gline [$fromc find withtag {trace && G}] 
  set Tline [$fromc find withtag {trace && T}] 
  set newAcoords [list]
  set newCcoords [list]
  set newGcoords [list]
  set newTcoords [list]
  if {$abi_info([winfo toplevel $fromc],rev_com)} {
    foreach {xA yA} [$fromc coords $Aline] {xC yC} [$fromc coords $Cline] {xG yG} [$fromc coords $Gline] {xT yT} [$fromc coords $Tline] {
      if {$xA < $fromx1} break
      if {$xA < $fromx2} {
         if {$yA < $clip_y} {set yA $clip_y}
         lappend newAcoords [expr {($xA-$fromx1)*$xscale+$tox1}] [expr {$yA*$yscale+$toy1}]
         if {$yC < $clip_y} {set yC $clip_y}
         lappend newCcoords [expr {($xC-$fromx1)*$xscale+$tox1}] [expr {$yC*$yscale+$toy1}] 
         if {$yG < $clip_y} {set yG $clip_y}
         lappend newGcoords [expr {($xG-$fromx1)*$xscale+$tox1}] [expr {$yG*$yscale+$toy1}] 
         if {$yT < $clip_y} {set yT $clip_y}
         lappend newTcoords [expr {($xT-$fromx1)*$xscale+$tox1}] [expr {$yT*$yscale+$toy1}]     
      }
    }
  } else {
    foreach {xA yA} [$fromc coords $Aline] {xC yC} [$fromc coords $Cline] {xG yG} [$fromc coords $Gline] {xT yT} [$fromc coords $Tline] {
      if {$xA > $fromx2} break
      if {$xA > $fromx1} {
         if {$yA < $clip_y} {set yA $clip_y}
         lappend newAcoords [expr {($xA-$fromx1)*$xscale+$tox1}] [expr {$yA*$yscale+$toy1}]
         if {$yC < $clip_y} {set yC $clip_y}
         lappend newCcoords [expr {($xC-$fromx1)*$xscale+$tox1}] [expr {$yC*$yscale+$toy1}] 
         if {$yG < $clip_y} {set yG $clip_y}
         lappend newGcoords [expr {($xG-$fromx1)*$xscale+$tox1}] [expr {$yG*$yscale+$toy1}] 
         if {$yT < $clip_y} {set yT $clip_y}
         lappend newTcoords [expr {($xT-$fromx1)*$xscale+$tox1}] [expr {$yT*$yscale+$toy1}]     
      }
    }
  }
  $toc create line $newAcoords -fill [$fromc itemcget $Aline -fill]
  $toc create line $newCcoords -fill [$fromc itemcget $Cline -fill]
  $toc create line $newGcoords -fill [$fromc itemcget $Gline -fill]
  $toc create line $newTcoords -fill [$fromc itemcget $Tline -fill]
}

###########
## save trace file as .scf
###########
proc abi_save_scf {w} {
  global info abi_info

  set mag_num ".scf"
  set num_samples [llength $abi_info($w,processed_data,0)]
  set samples_offset 128
  set num_bases [llength $abi_info($w,basecall_loc,edited)]
  set left_clip 0
  set right_clip 0
  set bases_offset [expr {$samples_offset+ $num_samples * 8}]
  if {[catch {set comments $abi_info($w,scf_comments)}]} {
    set comments {}
  }
  set comments_size [string length $comments]
  set comments_offset [expr {$bases_offset+$num_bases*12}]
  set version "3.00"
  set sample_size 2
  set code_set 2
  set private_size 0
  set private_offset [expr {$comments_offset+$comments_size}]

  set header [binary format a4IIIIIIIIa4IIIIx72 $mag_num $num_samples $samples_offset $num_bases $left_clip $right_clip $bases_offset $comments_size $comments_offset $version $sample_size $code_set $private_size $private_offset]
  set filename [tk_getSaveFile -title "Save SCF File" -parent $w -initialdir [file dirname $abi_info($w,filename)] -defaultextension ".scf"]
  if {[file extension $filename] == {}} {set filename "$filename.scf"}
  set fid [open $filename w]
  fconfigure $fid -translation binary
  puts -nonewline $fid $header
  
  #write trace info (samples section)
  foreach track [list 0 1 2 3] base [split $abi_info($w,filter_wheel) ""] {
    set p_delta 0
    set data [list]
    for {set i 0} {$i < $num_samples} {incr i} {
      set p_sample [lindex $abi_info($w,processed_data,$track) $i]
      lappend data [expr {$p_sample-$p_delta}]
      set p_delta $p_sample
    }
    set p_delta 0
    set new_data($base) [list]
    for {set i 0} {$i < $num_samples} {incr i} {
      set p_sample [lindex $data $i]
      lappend new_data($base) [expr {$p_sample-$p_delta}]
      set p_delta $p_sample
    }
  }
  foreach base {A C G T} {
    puts -nonewline $fid  [binary format S* $new_data($base)]
  }

  #write basecall section
  puts -nonewline $fid [binary format I* $abi_info($w,basecall_loc,edited)]
  puts -nonewline $fid [binary format c* $abi_info($w,basecall_prob_a,edited)]
  puts -nonewline $fid [binary format c* $abi_info($w,basecall_prob_c,edited)]
  puts -nonewline $fid [binary format c* $abi_info($w,basecall_prob_g,edited)]
  puts -nonewline $fid [binary format c* $abi_info($w,basecall_prob_t,edited)]
  puts -nonewline $fid $abi_info($w,basecall,edited)
  puts -nonewline $fid [binary format "x[expr {$num_bases*3}]"]

  #write comments section
  puts -nonewline $fid $comments

  close $fid
}

###########
## edit a base (after entering edit mode)
###########
proc abi_edit_base {w item call} {
  global abi_info
  set c $w.c
  if {[regexp {Shift_L|Alt_L|Meta_L|Ctrl_L} $call]} return

  set bclist [$c find withtag basecall]
sputs edit item:$item
  set i [lsearch -exact -integer $bclist $item] 
  if {$i == -1} {sputs $item not found in abi_edit; return}
  #need to set $i if rev_com):
  if {$abi_info($w,rev_com)} {
    set i [expr {[llength $bclist] - $i -1}]
  }

  ###need to scroll to see the edited base

  #delete basecall element if it is invalid and set to invalid
  if {(![string match -nocase {[ACGTNBDHKMRSVWY]} $call]) && (![string match -nocase {[ACGTNBDHKMRSVWY]} [$c itemcget $item -text]])} {
    set call "BackSpace"
  }

  if {[string match -nocase {[ACGTNBDHKMRSVWY]} $call]} {
   ###Edit base here
    if {$abi_info($w,rev_com)} {set call_text [revcom $call]} else {set call_text $call}
    $c itemconfigure $item -text $call -fill $abi_info(colors,[string toupper $call]) -tags [list basecall [string toupper $call_text]]
    if {$abi_info($w,basecall_prob_called,edited) != [list]} {
      foreach acgt {a c g t} {
        set abi_info($w,basecall_prob_$acgt,edited) [lreplace $abi_info($w,basecall_prob_$acgt,edited) $i $i 0]
      }
      set abi_info($w,basecall_prob_called,edited) [lreplace $abi_info($w,basecall_prob_called,edited) $i $i 0]
    }
    set abi_info($w,basecall,edited) [string replace $abi_info($w,basecall,edited) $i $i $call_text]
    abi_draw_phred $w
  } elseif {($call eq "BackSpace") || ($call eq "space")} {
  ####Delete base here
    $c delete $item
    if {$abi_info($w,basecall_prob_called,edited) != [list]} {
      foreach acgt {a c g t} {
        set abi_info($w,basecall_prob_$acgt,edited) [lreplace $abi_info($w,basecall_prob_$acgt,edited) $i $i]
      }
      set abi_info($w,basecall_prob_called,edited) [lreplace $abi_info($w,basecall_prob_called,edited) $i $i]
    }
    set abi_info($w,basecall,edited) [string replace $abi_info($w,basecall,edited) $i $i]
    set abi_info($w,basecall_loc,edited) [lreplace $abi_info($w,basecall_loc,edited) $i $i]
    abi_draw_phred $w
   # abi_redraw_indices $w
  } else {
sputs bad base edit char: $call
  }
  if {$abi_info($w,rev_com)} {
    set abi_info($w,sequence) [revcom $abi_info($w,basecall,edited)]
  } else {
    set abi_info($w,sequence) $abi_info($w,basecall,edited)
  }
  event generate $c <<ClearEdit>>
}

###########
## enter edit mode on a basecall (draw the edit box and set up bindings, use abi_edit_base to make the change)
###########
proc abi_edit_mode {w item} {
  set c $w.c
  event generate $c <<ClearEdit>>
  if {$item == ""} return
  $c coord editbox [$c bbox $item]
  $c lower editbox
  $c itemconfigure editbox -outline black -fill yellow
  bind $c <Any-ButtonPress> "event generate $c <<ClearEdit>>"
  bind $c <FocusOut> "event generate $c <<ClearEdit>>"
  #need to do ClearEdit on scroll
  #bind $c <Any-Key> "sputs %K"
  bind $c <Any-Key> "abi_edit_base $w $item %K"
}

###########
## insert a basecall into an abi file then enter edit mode to set the contents
###########
proc abi_add_base {w x} {
  global abi_info
  set c $w.c

  if {1} {
    set new_call [$c create text $x 15 -text "n" -anchor n -font dnafont -fill $abi_info(colors,N) -width 0 -tags {basecall tempbasecall}]
    set bclist [$c find withtag basecall]
    for  {set i 0} {($i < [llength $bclist]) && ([lindex [$c coord [lindex $bclist $i]] 0] < $x)} {incr i} {
    }
sputs add i:$i
    if {$i > 0} {
      $c raise $new_call [lindex $bclist [expr {$i-1}]]
    } else {
      $c lower $new_call [lindex $bclist 0]
    }

    #need to set $i if rev_com
    if {$abi_info($w,rev_com)} {
      set i [expr {[llength $bclist] - $i}]
    }
    if {$abi_info($w,basecall_prob_called,edited) != [list]} {
      foreach acgt {a c g t} {
       set abi_info($w,basecall_prob_$acgt,edited) [linsert $abi_info($w,basecall_prob_$acgt,edited) $i 0]
      }
      set abi_info($w,basecall_prob_called,edited) [linsert $abi_info($w,basecall_prob_called,edited) $i 0]
    }
    set abi_info($w,basecall,edited) "[string range $abi_info($w,basecall,edited) 0 [expr {$i-1}]]n[string range $abi_info($w,basecall,edited) $i end]"
    if {!$abi_info($w,rev_com)} {
      set abi_info($w,basecall_loc,edited) [linsert $abi_info($w,basecall_loc,edited) $i [expr {int($x / $abi_info($w,horiz_scale))}]]
      set abi_info($w,sequence) $abi_info($w,basecall,edited)
    } else {
      set abi_info($w,basecall_loc,edited) [linsert $abi_info($w,basecall_loc,edited) $i [expr {int([lindex [$w.c bbox 1] 2] - ($x / $abi_info($w,horiz_scale)) -2)}]]
      set abi_info($w,sequence) [revcom $abi_info($w,basecall,edited)]
    }
    abi_draw_phred $w
  }
    #abi_redraw_indices $w
    abi_edit_mode $w $new_call
}

###########
## save current view as eps file
###########
proc abi_save_eps {c} {
  set regionx1 [$c canvasx [expr {[winfo x $c]+2}]]
  set regionx2 [$c canvasx [expr {[winfo x $c]+[winfo width $c]-4}]]
  set c2 [canvas .print_canvas -width [expr {$regionx2-$regionx1}] -height [winfo height $c]]
  abi_copy_region $c $regionx1 $regionx2 $c2 0 0 1.0 1.0
  canvas_save $c2
  destroy $c2
}

###########
## copy current view to clipboard as metafile
###########
proc abi_copy_metafile {c {mode both}} {
  set regionx1 [$c canvasx [expr {[winfo x $c]+2}]]
  set regionx2 [$c canvasx [expr {[winfo x $c]+[winfo width $c]-4}]]
  set c2 [canvas .print_canvas -width [expr {$regionx2-$regionx1}] -height [winfo height $c]]
  abi_copy_region $c $regionx1 $regionx2 $c2 0 0 1.0 1.0
  canvas_to_metafile copy $c2 both
  destroy $c2
}

###########
## print current view
###########
proc abi_print {c} {
  set regionx1 [$c canvasx [expr {[winfo x $c]+2}]]
  set regionx2 [$c canvasx [expr {[winfo x $c]+[winfo width $c]-4}]]
  set c2 [canvas .print_canvas -width [expr {$regionx2-$regionx1}] -height [winfo height $c]]
  abi_copy_region $c $regionx1 $regionx2 $c2 0 0 1.0 1.0
  print_canvas $c2 $c
  destroy $c2
}


###########
## print abi files
###########
proc print_abi {c} {
global info abi_info
  foreach {xmin ymin xmax ymax} [$c bbox all] {}
  set ymin [expr {($ymin <= 0) ? 0 : $ymin}]
  set w [winfo toplevel $c]
  set header_text "[mc "File:"] $abi_info($w,filename)\n[mc {Run ended:}][clock format [clock scan "$abi_info($w,run_date,2) $abi_info($w,run_time,2)"] -format "%l:%M%p %a,%b %d, %Y"]\n(page %P)"
  if {[tk windowingsystem] == "win32"} {
   set page_width 8500
    set page_height 11000
    set pm_left 1000
    set pm_right 1000
    set pm_top 1000
    set pm_bottom 1000
    set ppi_x 1000
    set ppi_y 1000
    set attr_list [printer attr]
    foreach attr $attr_list {
      switch -exact [lindex $attr 0] {
        "page dimensions" {
          set page_width [lindex [lindex $attr 1] 0]
          set page_height [lindex [lindex $attr 1] 1]
        }
        "page margins" {
          set pm_left [lindex [lindex $attr 1] 0]
          set pm_top [lindex [lindex $attr 1] 1]
          set pm_right [lindex [lindex $attr 1] 2]
          set pm_bottom [lindex [lindex $attr 1] 3]
        }
        "pixels per inch" {
          set ppi_x [lindex [lindex $attr 1] 0]
          set ppi_y [lindex [lindex $attr 1] 1]
        }
      }
    }

   
    set print_width [expr {($page_width-$pm_left-$pm_right)/1000.0}]
    set print_height [expr {($page_height-$pm_top-$pm_bottom)/1000.0}]
    set line_height_inches [expr {1.0*($print_height)/$info(print_abi_lines_per_page)-0.5}]
    set line_width_abi_pixels [expr {int($print_width * ($ymax-$ymin)/$line_height_inches)}] 
    set total_lines [expr {int(ceil (1.0*($xmax- $xmin) / $line_width_abi_pixels))}]
    set total_pages [expr {int(ceil (1.0*$total_lines/$info(print_abi_lines_per_page)))}]


    if {[set print_parameters [windows_print_dialog [list 1 $total_pages]]] != ""} {
      #START PRINTING here
      foreach {hDC page_width page_height pm_left pm_top pm_right pm_bottom ppi_x ppi_y first_page last_page copies spool_copies print_flag} $print_parameters {}

      #reset the lines/page and total pages after getting possibly new printer margin info
      set print_width [expr {($page_width-$pm_left-$pm_right)/1000.0}]
      set print_height [expr {($page_height-$pm_top-$pm_bottom)/1000.0}]

      set header_height_inches 0.5

      set line_height_inches [expr {1.0*($print_height-$header_height_inches+0.5)/$info(print_abi_lines_per_page)-0.5}]
      set line_width_abi_pixels [expr {int($print_width * ($ymax-$ymin)/$line_height_inches)}] 
      set total_lines [expr {int(ceil (1.0*($xmax- $xmin) / $line_width_abi_pixels))}]
      set total_pages [expr {int(ceil (1.0*$total_lines/$info(print_abi_lines_per_page)))}]
      switch $print_flag {
        all {
        }
        selection {
          set xmin [expr {int([lindex [$c coords selection] 0])}]
          set xmax [expr {int([lindex [$c coords selection] 2])}]
          if {$xmin == $xmax} {
            foreach {xmin i xmax j} [$c bbox all] {} 
          }
        }
        pagenums {
            set xmin [expr {$xmin + ($first_page - 1) * $info(print_abi_lines_per_page) * $line_width_abi_pixels}]
            set xmax_temp [expr {$xmin + ($last_page- $first_page + 1)  * $info(print_abi_lines_per_page) * $line_width_abi_pixels}]
            set xmax [expr {($xmax < $xmax_temp) ? $xmax : $xmax_temp}]
        }
      } 

      set first_line 1
      set last_line [expr {int(ceil (1.0*($xmax- $xmin) / $line_width_abi_pixels))}]

      set Aline [$c find withtag {trace && A}] 
      set Cline [$c find withtag {trace && C}] 
      set Gline [$c find withtag {trace && G}] 
      set Tline [$c find withtag {trace && T}] 


      if {$abi_info($w,rev_com)} {
        set trace_i $last_line
        set temp_line_start [expr {$xmin + ($last_line-$first_line) * $line_width_abi_pixels}]
        foreach {xA yA} [$c coords $Aline] {xC yC} [$c coords $Cline] {xG yG} [$c coords $Gline] {xT yT} [$c coords $Tline] {
          if {$xA > $xmax} continue
          if {$xA < $xmin} break
          if {$xA < $temp_line_start} {
            incr trace_i -1
            incr temp_line_start [expr {-$line_width_abi_pixels}]
          }
          lappend newAcoords($trace_i) [expr {$xA-$temp_line_start}] [expr {($yA<0)?0: $yA}]
          lappend newCcoords($trace_i) [expr {$xC-$temp_line_start}] [expr {($yC<0)?0: $yC}]
          lappend newGcoords($trace_i) [expr {$xG-$temp_line_start}] [expr {($yG<0)?0: $yG}]
          lappend newTcoords($trace_i) [expr {$xT-$temp_line_start}] [expr {($yT<0)?0: $yT}]    
        }
      } else {
        set temp_line_start $xmin
        set temp_line_end [expr {$xmin + $line_width_abi_pixels}]
        set trace_i $first_line
        foreach {xA yA} [$c coords $Aline] {xC yC} [$c coords $Cline] {xG yG} [$c coords $Gline] {xT yT} [$c coords $Tline] {
          if {$xA > $xmax} break
          if {$xA < $xmin} continue
          if {$xA > $temp_line_end} {
            incr temp_line_start $line_width_abi_pixels
            incr temp_line_end $line_width_abi_pixels
            incr trace_i
          }
          lappend newAcoords($trace_i) [expr {$xA-$temp_line_start}] [expr {($yA<0)?0: $yA}]
          lappend newCcoords($trace_i) [expr {$xC-$temp_line_start}] [expr {($yC<0)?0: $yC}]
          lappend newGcoords($trace_i) [expr {$xG-$temp_line_start}] [expr {($yG<0)?0: $yG}]
          lappend newTcoords($trace_i) [expr {$xT-$temp_line_start}] [expr {($yT<0)?0: $yT}]    
        }
      }
      set element [lindex [$c find withtag basecall] 0]
      if {$element != {}} {
        set print_font [list [font actual [$c itemcget $element -font] -family] [expr {int ([font actual [$c itemcget $element -font] -size]/  ($line_width_abi_pixels/$print_width)*([tk scaling]*72) +0.5)}]]
      } else {
        set print_font [list Courier [expr {int (10 /($line_width_abi_pixels/$print_width)*([tk scaling]*72) +0.5)}]]
      } 
sputs $hDC
      printer job -hdc $hDC start
      toplevel .printer_notifier
      set dialogblock 1
      set bind_store [bind . <<RaiseDialogs>>]
      bind . <<RaiseDialogs>> "wm deiconify .printer_notifier; raise .printer_notifier"
      wm overrideredirect .printer_notifier 1
      wm title .printer_notifier "Printing..."
      regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
      wm geometry .printer_notifier "+[expr (($winx<0)?0:$winx)+100]+[expr (($winy<0)?0:$winy)+100]"
      pack [frame .printer_notifier.frame -relief ridge -bd 3 -width 200]      
      pack [label .printer_notifier.frame.message -text "" -width 50 -height 4]
      for {set copies_spooled 1} {$copies_spooled <= $spool_copies} {incr copies_spooled} {
        for {set next_line $first_line} {$next_line <= $last_line} {incr next_line $info(print_abi_lines_per_page)} {
          if {[expr {$next_line+$info(print_abi_lines_per_page)-1}] > $last_line} {
            set last_page_line $last_line
          } else {
            set last_page_line [expr {$next_line+$info(print_abi_lines_per_page)-1}]
          }
          for {set copies_printed 1} {$copies_printed <= $copies} {incr copies_printed} {
            if {$copies == 1} {
              if {$spool_copies == 1} {
                .printer_notifier.frame.message configure -text "Printing page [expr {$next_line/$info(print_abi_lines_per_page)+1}] of [expr {int(ceil(1.0*$last_line/$info(print_abi_lines_per_page)))}]."
              } else {
                .printer_notifier.frame.message configure -text "Printing page [expr {$next_line/$info(print_abi_lines_per_page)+1}] of [expr {int(ceil(1.0*$last_line/$info(print_abi_lines_per_page)))}], copy $copies_spooled of $spool_copies."
              } 
            } else {
                .printer_notifier.frame.message configure -text "Printing page [expr {$next_line/$info(print_abi_lines_per_page)+1}] of [expr {int(ceil(1.0*$last_line/$info(print_abi_lines_per_page)))}], copy $copies_printed of $copies."
            }
            update

            printer page -hdc $hDC start
            set current_page_line 0
              #put header at top of page
            gdi map $hDC -logical [expr {int ($line_width_abi_pixels/$print_width)}] -physical $ppi_x -offset [list [expr {int(($pm_left* $ppi_x / 1000))}] [expr {int(($pm_top* $ppi_x / 1000))}]]
            gdi text $hDC 0 0 -text [regsub -all {%P} $header_text [expr {$next_line/$info(print_abi_lines_per_page)+1}]] -font [list [font actual dnafont -family] 8] -anchor nw -justify left 

            for {set current_line $next_line} {$current_line <= $last_page_line} {incr current_line} {
              set line_xmin [expr {$xmin + ($current_line - 1) * $line_width_abi_pixels}]
              if {$current_line == $last_line} {
               set line_xmax $xmax
              } else {
               set line_xmax [expr {$line_xmin + $line_width_abi_pixels}]
              }
              gdi map $hDC -logical [expr {int ($line_width_abi_pixels/$print_width)}] -physical $ppi_x -offset [list [expr {int(($pm_left* $ppi_x / 1000))}] [expr {int(($pm_top / 1000 + (($current_page_line + 1)* 0.5)+ ($current_page_line * $line_height_inches))* $ppi_x)}]]
              foreach element [$c find overlapping $line_xmin $ymin $line_xmax $ymax] {
                if {[$c type $element] eq "text"} {
                  gdi text $hDC [expr {[lindex [$c coords $element] 0]-$line_xmin}] [expr {[lindex [$c coords $element] 1]-$ymin}] -text [$c itemcget $element -text] -fill [$c itemcget $element -fill] -font $print_font -anchor n
                }
              }
              gdi rectangle $hDC -45 $ymin -1 $ymax -fill white -outline white
              gdi rectangle $hDC [expr {$line_xmax-$line_xmin+1}] $ymin [expr {$line_xmax-$line_xmin+45}] $ymax -fill white -outline white
              gdi rectangle $hDC 0 $ymin [expr {$line_xmax-$line_xmin}] $ymax
              if {[catch {eval "gdi line $hDC $newAcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && A}] -fill]}"}]} {
                sputs error:$current_line [array names newAcoords]
              }
              catch {eval "gdi line $hDC $newCcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && C}] -fill]}"}
              catch {eval "gdi line $hDC $newGcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && G}] -fill]}"}
              catch {eval "gdi line $hDC $newTcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && T}] -fill]}"}
              incr current_page_line
            }
            printer page -hdc $hDC end
          }
        }
      }
      printer job -hdc $hDC end
      printer close -hdc $hDC
      destroy .printer_notifier
      set dialogblock 0
      bind . <<RaiseDialogs>> $bind_store
    }
   } elseif {[tk windowingsystem] == "aqua"} {
    if  {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] == -1)} {
      return
    }
   #####Aqua printing here
    set pf [eval {::maccarbonprint::pagesetup -dialog 0} $info(aqua_page_setup)]
    array set optsArr [maccarbonprint::pageformatconfigure $pf]
    foreach {pageX pageY page_width page_height} $optsArr(-adjustedpagerect) {}
    foreach {paperX paperY paper_width paper_height} $optsArr(-adjustedpaperrect) {}
    if {[llength [set resol $optsArr(-resolution)]]==1} {
      set ppi_x $resol
      set ppi_y $resol
    } else {
      foreach {ppi_x ppi_y} $resol {}
    }
           
    set print_width [expr {(1.0*$page_width/$ppi_x)}]
    set print_height  [expr {(1.0*$page_height/$ppi_y)}]
    set line_height_inches [expr {1.0*($print_height)/$info(print_abi_lines_per_page)-0.5}]
    set line_width_abi_pixels [expr {int($print_width * ($ymax-$ymin)/$line_height_inches)}] 
    set total_lines [expr {int(ceil (1.0*($xmax- $xmin) / $line_width_abi_pixels))}]
    set total_pages [expr {int(ceil (1.0*$total_lines/$info(print_abi_lines_per_page)))}]

    if {[set print_parameters [aqua_print_dialog $w [list 1 $total_pages]]] != ""} {
      foreach {printObj printtype page_width page_height ppi_x ppi_y copies first_page last_page} $print_parameters {}
#sputs printObj: $printObj
      #reset the lines/page and total pages after getting possibly new printer margin info
      set print_width [expr {(1.0*$page_width/$ppi_x)}]
      set print_height  [expr {(1.0*$page_height/$ppi_y)}]
      set line_height_inches [expr {1.0*($print_height)/$info(print_abi_lines_per_page)-0.5}]
      set line_width_abi_pixels [expr {int($print_width * ($ymax-$ymin)/$line_height_inches)}] 
      set total_lines [expr {int(ceil (1.0*($xmax- $xmin) / $line_width_abi_pixels))}]
      set total_pages [expr {int(ceil (1.0*$total_lines/$info(print_abi_lines_per_page)))}]
             
      set xmin [expr {$xmin + ($first_page - 1) * $info(print_abi_lines_per_page) * $line_width_abi_pixels}]
      set xmax_temp [expr {$xmin + ($last_page- $first_page + 1)  * $info(print_abi_lines_per_page) * $line_width_abi_pixels}]
      set xmax [expr {($xmax < $xmax_temp) ? $xmax : $xmax_temp}]
      set first_line 1
      set last_line [expr {int(ceil (1.0*($xmax- $xmin) / $line_width_abi_pixels))}]
      set scale [expr {$ppi_x/ ($line_width_abi_pixels/$print_width)}]
      set y_line_spacing_abi_pixels [expr {($line_height_inches+0.5)*($line_width_abi_pixels/$print_width)}]

      set Aline [$c find withtag {trace && A}] 
      set Cline [$c find withtag {trace && C}] 
      set Gline [$c find withtag {trace && G}] 
      set Tline [$c find withtag {trace && T}] 
             
      if {$abi_info($w,rev_com)} {
        set trace_i $last_line
        set temp_line_start [expr {$xmin + ($last_line-$first_line) * $line_width_abi_pixels}]
        set y_offset [expr {(0.5 * $line_width_abi_pixels/$print_width) + (($trace_i-1)%$info(print_abi_lines_per_page))*$y_line_spacing_abi_pixels}]
        foreach {xA yA} [$c coords $Aline] {xC yC} [$c coords $Cline] {xG yG} [$c coords $Gline] {xT yT} [$c coords $Tline] {
          if {$xA > $xmax} continue
          if {$xA < $xmin} break
          if {$xA < $temp_line_start} {
            incr trace_i -1
            incr temp_line_start [expr {-$line_width_abi_pixels}]
            set y_offset [expr {(0.5 * $line_width_abi_pixels/$print_width) + (($trace_i-1)%$info(print_abi_lines_per_page))*$y_line_spacing_abi_pixels}]
          }
          lappend newAcoords($trace_i) [expr {$xA-$temp_line_start}] [expr {($yA<0)?$y_offset: ($y_offset+$yA)}]
          lappend newCcoords($trace_i) [expr {$xC-$temp_line_start}] [expr {($yC<0)?$y_offset: ($y_offset+$yC)}]
          lappend newGcoords($trace_i) [expr {$xG-$temp_line_start}] [expr {($yG<0)?$y_offset: ($y_offset+$yG)}]
          lappend newTcoords($trace_i) [expr {$xT-$temp_line_start}] [expr {($yT<0)?$y_offset: ($y_offset+$yT)}]    
        }
      } else {
        set temp_line_start $xmin
        set temp_line_end [expr {$xmin + $line_width_abi_pixels}]
        set trace_i $first_line
        set y_offset [expr {(0.5 * $line_width_abi_pixels/$print_width) + (($trace_i-1)%$info(print_abi_lines_per_page))*$y_line_spacing_abi_pixels}]
        foreach {xA yA} [$c coords $Aline] {xC yC} [$c coords $Cline] {xG yG} [$c coords $Gline] {xT yT} [$c coords $Tline] {
          if {$xA > $xmax} break
          if {$xA < $xmin} continue
          if {$xA > $temp_line_end} {
            incr temp_line_start $line_width_abi_pixels
            incr temp_line_end $line_width_abi_pixels
            incr trace_i
            set y_offset [expr {-$paperY + (0.5 * $line_width_abi_pixels/$print_width) + (($trace_i-1)%$info(print_abi_lines_per_page))*$y_line_spacing_abi_pixels}]
          }
          lappend newAcoords($trace_i) [expr {-$paperX+$xA-$temp_line_start}] [expr {($yA<0)?$y_offset: ($y_offset+$yA)}]
          lappend newCcoords($trace_i) [expr {-$paperX+$xC-$temp_line_start}] [expr {($yC<0)?$y_offset: ($y_offset+$yC)}]
          lappend newGcoords($trace_i) [expr {-$paperX+$xG-$temp_line_start}] [expr {($yG<0)?$y_offset: ($y_offset+$yG)}]
          lappend newTcoords($trace_i) [expr {-$paperX+$xT-$temp_line_start}] [expr {($yT<0)?$y_offset: ($y_offset+$yT)}]    
        }
      }
          
      set element [lindex [$c find withtag basecall] 0]
      if {$element != {}} {
        set print_font [list [font actual [$c itemcget $element -font] -family] [expr {int ($scale * [font actual [$c itemcget $element -font] -size] +0.5)}]]
      } else {
        set print_font [list Courier [expr {int ($scale * 10 +0.5)}]]
      }      
      if {![catch {::maccarbonprint::opendoc $printObj 1 [expr {($last_page-$first_page+1)*$copies}]} errMsg]} {
        #bug? takes care of printing the copies already
        set copies 1
        for {set j 0} {$j < $copies} {incr j} {
          for {set next_line $first_line} {$next_line <= $last_line} {incr next_line $info(print_abi_lines_per_page)} {
            if {[expr {$next_line+$info(print_abi_lines_per_page)-1}] > $last_line} {
              set last_page_line $last_line
            } else {
              set last_page_line [expr {$next_line+$info(print_abi_lines_per_page)-1}]
            }
            if {![catch {set win [::maccarbonprint::openpage $printObj -scale $scale]}]} {
              set current_page_line 0
              #put header on top of page
              $win create text [expr {-$paperX}] [expr {-$paperY}] -text [regsub -all {%P} $header_text [expr {$next_line/$info(print_abi_lines_per_page)+1}]] -font [list [font actual dnafont -family] 8] -anchor nw -justify left 
              for {set current_line $next_line} {$current_line <= $last_page_line} {incr current_line} {
                set line_xmin [expr {$xmin + ($current_line - 1) * $line_width_abi_pixels}]
                set y_offset [expr {(0.5 * $line_width_abi_pixels/$print_width) + (($current_line-1)%$info(print_abi_lines_per_page))*$y_line_spacing_abi_pixels}]
#sputs xmin $current_line $line_xmin $y_offset
                if {$current_line == $last_line} {
                 set line_xmax $xmax
                } else {
                 set line_xmax [expr {$line_xmin + $line_width_abi_pixels}]
                }
                foreach element [$c find overlapping $line_xmin $ymin $line_xmax $ymax] {
                  if {[$c type $element] eq "text"} {
                     $win create text [expr {[lindex [$c coords $element] 0]-$line_xmin -$paperX}] [expr {[lindex [$c coords $element] 1]-$ymin+$y_offset -$paperY}] -text [$c itemcget $element -text] -fill [$c itemcget $element -fill] -font $print_font -anchor n
                  }
                }
                $win create rectangle [expr {-$paperX}] [expr {$ymin+$y_offset -$paperY}] [expr {$line_xmax-$line_xmin-$paperX}] [expr {$ymax+$y_offset-$paperY}]
                if {[catch {eval "$win create line $newAcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && A}] -fill]}"}]} {
                  sputs error:$current_line [array names newAcoords]
                }
                catch {eval "$win create line $newCcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && C}] -fill]}"}
                catch {eval "$win create line $newGcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && G}] -fill]}"}
                catch {eval "$win create line $newTcoords($current_line) -fill {[$c itemcget [$c find withtag {trace && T}] -fill]}"}
                incr current_page_line
              }
              catch {::maccarbonprint::closepage $printObj}
            }
          }
        }
        catch {::maccarbonprint::closedoc $printObj}
      }
    }
  } else {
    warning_dialog "Printing isn't available from non-windows or -unix"
  }
}


###########
## find dialog
###########
proc abi_find_dialog {w} {
  global abi_info
  global info
  global ok dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1
  bind . <<RaiseDialogs>> "wm deiconify .find_dialog; raise .find_dialog"
  set ok 0
  set s [toplevel .find_dialog]
  wm title $s "[mc Find]..."
  wm protocol $s WM_DELETE_WINDOW {set ok -1}
  bind $s <KeyPress-Escape>  "set ok -1"
  raise $s

  set wgeomlist [split [wm geometry $w] "x+"]
  set sgeom "+[expr [lindex $wgeomlist 2]+3]+[expr [lindex $wgeomlist 3]+150]"
  wm geometry $s $sgeom

  #label $s.parent_info -text "[mc Find]:"
  entry $s.find -width 50
  $s.find insert 0 $abi_info(last_find)
  frame $s.mod_frame 
    pack [checkbutton  $s.mod_frame.revcom -text [mc "Also find rev-com of string"] -onvalue 1 -offvalue 0 -variable abi_info(find_revcom)] -side left
    pack [checkbutton  $s.mod_frame.exact -text [mc "As literal"] -onvalue 1 -offvalue 0 -variable abi_info(find_literal) ] -side left 
    pack [checkbutton  $s.mod_frame.wrap -text [mc "Wrap"] -onvalue 1 -offvalue 0 -variable abi_info(find_wrap) ] -side left 
  frame $s.action_frame
    pack [button $s.action_frame.next -text [mc "find next"] -command "set abi_info(last_find) \[$s.find get\]; abi_do_find $w \$abi_info(last_find) \$abi_info(find_revcom) \$abi_info(find_literal) \$abi_info(find_wrap) " -default active] -side left  -padx 10 -pady 3
    pack [button $s.action_frame.cancel -text [mc "cancel"] -command "set ok -1"] -side left  -padx 10 -pady 3

  #pack $s.parent_info -side top -fill x -expand true
  pack $s.find -side top -fill x -expand true
  pack $s.mod_frame -side top -fill x -expand true
  pack $s.action_frame -side top -fill x -expand true
 

  bind $s <Key-Return> "$s.action_frame.next invoke"
  focus $s
  focus $s.find

  vwait ok
  set dialogblock 0
  bind . <<RaiseDialogs>> ""
  destroy $s
}

############
## Find text in a trace window
############
proc abi_do_find {w search_text revcom find_literal wrap} {
  global abi_info

  if {$search_text == ""} {return}
  set left_x [lindex [$w.c coord selection] 0]
  set target [abi_get_seq $w $left_x end]
  set text [string range [string toupper [lindex $target 1]] 1 end]
  set start_index [expr {1 + [lindex $target 0]}]
  set seq_len [llength [$w.c find withtag basecall]]

  set search_text [string toupper $search_text]
  if {!$find_literal} {
    set search_text [regsubpattern $search_text]
  }
  if {$revcom == 1} {
    set search_text "$search_text|[revcom_regexp $search_text]"
  }
  if {[regexp -indices $search_text $text index] == 1} {
    if {!$abi_info($w,rev_com)} {
      abi_select_region $w [expr {[lindex $index 0]+$start_index }] [expr {[lindex $index 1]+ $start_index}]
    } else {
      abi_select_region $w [expr {$seq_len-[lindex $index 0]-$start_index-1}] [expr {$seq_len-[lindex $index 1] - $start_index-1}]
    }
  } elseif {$wrap} {
    set target [abi_get_seq $w start end]
    set text [string range [string toupper [lindex $target 1]] 1 end]
    if {[regexp -indices $search_text $text index] == 1} {
      if {!$abi_info($w,rev_com)} {
        abi_select_region $w [expr {[lindex $index 0]+1}] [expr {[lindex $index 1]+1}]
      } else {
        abi_select_region $w [expr {$seq_len-[lindex $index 0] - 2}] [expr {$seq_len-[lindex $index 1] -2}]
      }
    } else {
      bell
    }
  } else {
    bell
  }
}


##############
## base64 encoding from base64 package
##############
    namespace eval base64 {
	variable base64 {}
	variable base64_en {}

	# We create the auxiliary array base64_tmp, it will be unset later.
	variable base64_tmp
	variable i

	set i 0
	foreach char {A B C D E F G H I J K L M N O P Q R S T U V W X Y Z \
		a b c d e f g h i j k l m n o p q r s t u v w x y z \
		0 1 2 3 4 5 6 7 8 9 + /} {
	    set base64_tmp($char) $i
	    lappend base64_en $char
	    incr i
	}

	#
	# Create base64 as list: to code for instance C<->3, specify
	# that [lindex $base64 67] be 3 (C is 67 in ascii); non-coded
	# ascii chars get a {}. we later use the fact that lindex on a
	# non-existing index returns {}, and that [expr {} < 0] is true
	#

	# the last ascii char is 'z'
	variable char
	variable len
	variable val

	scan z %c len
	for {set i 0} {$i <= $len} {incr i} {
	    set char [format %c $i]
	    set val {}
	    if {[info exists base64_tmp($char)]} {
		set val $base64_tmp($char)
	    } else {
		set val {}
	    }
	    lappend base64 $val
	}

	# code the character "=" as -1; used to signal end of message
	scan = %c i
	set base64 [lreplace $base64 $i $i -1]

	# remove unneeded variables
	unset base64_tmp i char len val

	namespace export encode decode
    }
    proc ::base64::encode {args} {
	set base64_en $::base64::base64_en
	
	# Set the default wrapchar and maximum line length to match
	# the settings for MIME encoding (RFC 3548, RFC 2045). These
	# are the settings used by Trf as well. Various RFCs allow for
	# different wrapping characters and wraplengths, so these may
	# be overridden by command line options.
	set wrapchar "\n"
	set maxlen 76

	if { [llength $args] == 0 } {
	    error "wrong # args: should be \"[lindex [info level 0] 0]\
		    ?-maxlen maxlen? ?-wrapchar wrapchar? string\""
	}

	set optionStrings [list "-maxlen" "-wrapchar"]
	for {set i 0} {$i < [llength $args] - 1} {incr i} {
	    set arg [lindex $args $i]
	    set index [lsearch -glob $optionStrings "${arg}*"]
	    if { $index == -1 } {
		error "unknown option \"$arg\": must be -maxlen or -wrapchar"
	    }
	    incr i
	    if { $i >= [llength $args] - 1 } {
		error "value for \"$arg\" missing"
	    }
	    set val [lindex $args $i]

	    # The name of the variable to assign the value to is extracted
	    # from the list of known options, all of which have an
	    # associated variable of the same name as the option without
	    # a leading "-". The [string range] command is used to strip
	    # of the leading "-" from the name of the option.
	    #
	    # FRINK: nocheck
	    set [string range [lindex $optionStrings $index] 1 end] $val
	}
    
	# [string is] requires Tcl8.2; this works with 8.0 too
	if {[catch {expr {$maxlen % 2}}]} {
	    return -code error "expected integer but got \"$maxlen\""
	} elseif {$maxlen < 0} {
	    return -code error "expected positive integer but got \"$maxlen\""
	}

	set string [lindex $args end]

	set result {}
	set state 0
	set length 0


	# Process the input bytes 3-by-3

	binary scan $string c* X

	foreach {x y z} $X {
	    ADD [lindex $base64_en [expr {($x >>2) & 0x3F}]]
	    if {$y != {}} {
		ADD [lindex $base64_en [expr {(($x << 4) & 0x30) | (($y >> 4) & 0xF)}]]
		if {$z != {}} {
		    ADD [lindex $base64_en [expr {(($y << 2) & 0x3C) | (($z >> 6) & 0x3)}]]
		    ADD [lindex $base64_en [expr {($z & 0x3F)}]]
		} else {
		    set state 2
		    break
		}
	    } else {
		set state 1
		break
	    }
	}
	if {$state == 1} {
	    ADD [lindex $base64_en [expr {(($x << 4) & 0x30)}]]
	    ADD =
	    ADD =
	} elseif {$state == 2} {
	    ADD [lindex $base64_en [expr {(($y << 2) & 0x3C)}]]
	    ADD =
	}
	return $result
    }

    proc ::base64::ADD {x} {
	# The line length check is always done before appending so
	# that we don't get an extra newline if the output is a
	# multiple of $maxlen chars long.

	upvar 1 maxlen maxlen length length result result wrapchar wrapchar
	if {$maxlen && $length >= $maxlen} {
	    append result $wrapchar
	    set length 0
	}
	append result $x
	incr length
	return
    }

    # ::base64::decode --
    #
    #	Base64 decode a given string.
    #
    # Arguments:
    #	string	The string to decode.  Characters not in the base64
    #		alphabet are ignored (e.g., newlines)
    #
    # Results:
    #	The decoded value.

    proc ::base64::decode {string} {
	if {[string length $string] == 0} {return ""}

	set base64 $::base64::base64
	set output "" ; # Fix for [Bug 821126]

	binary scan $string c* X
	foreach x $X {
	    set bits [lindex $base64 $x]
	    if {$bits >= 0} {
		if {[llength [lappend nums $bits]] == 4} {
		    foreach {v w z y} $nums break
		    set a [expr {($v << 2) | ($w >> 4)}]
		    set b [expr {(($w & 0xF) << 4) | ($z >> 2)}]
		    set c [expr {(($z & 0x3) << 6) | $y}]
		    append output [binary format ccc $a $b $c]
		    set nums {}
		}		
	    } elseif {$bits == -1} {
		# = indicates end of data.  Output whatever chars are left.
		# The encoding algorithm dictates that we can only have 1 or 2
		# padding characters.  If x=={}, we must (*) have 12 bits of input 
		# (enough for 1 8-bit output).  If x!={}, we have 18 bits of
		# input (enough for 2 8-bit outputs).
		#
		# (*) If we don't then the input is broken (bug 2976290).

		foreach {v w z} $nums break

		# Bug 2976290
		if {$w == {}} {
		    return -code error "Not enough data to process padding"
		}

		set a [expr {($v << 2) | (($w & 0x30) >> 4)}]
		if {$z == {}} {
		    append output [binary format c $a ]
		} else {
		    set b [expr {(($w & 0xF) << 4) | (($z & 0x3C) >> 2)}]
		    append output [binary format cc $a $b]
		}		
		break
	    } else {
		# RFC 2045 says that line breaks and other characters not part
		# of the Base64 alphabet must be ignored, and that the decoder
		# can optionally emit a warning or reject the message.  We opt
		# not to do so, but to just ignore the character. 
		continue
	    }
	}
	return $output
    }


##############
## Speak texts spacebar to start/stop arrows to slow or speed
##############
proc speak_dialog {w} {
  global info
  global ok dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1
  set s [toplevel .speak_dialog]
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"
  set ok 0

  wm title $s "[mc "Speak Texts"]...[wm title $w]"
  wm protocol $s WM_DELETE_WINDOW {set ok -1}
  bind $s <KeyPress-Escape>  "set ok -1"

  raise $s

  set wgeomlist [split [wm geometry $w] "x+"]
  set sgeom "+[expr [lindex $wgeomlist 2]+3]+[expr [lindex $wgeomlist 3]+150]"
  wm geometry $s $sgeom
  grid [label $s.inst -text [mc "Use left arrow to slow,\n right to accelerate,\n space to start and stop."]] -row 1 -column 1 -columnspan 2
  grid [label $s.dellabel -text [mc "Speed (ms):"]] -row 2 -column 1
  grid [label $s.delentry -textvariable info(speak_delay)  -width 5 -justify right] -row 2 -column 2 -sticky w
  grid [button $s.speakbutton -text [mc "Start Speaking"] -command "if {!\[info exists info($w,speak_cancel)\]} {speak $w -1; $s.speakbutton configure -text {[mc {Stop Speaking}]}; trace add variable info($w,speak_cancel) unset \"$s.speakbutton configure -text {[mc {Start Speaking}]}; #\"} else {speak $w stop; $s.speakbutton configure -text {[mc {Start Speaking}]}}
"] -row 3 -column 2
  
  bind $s <Key-space> "$s.speakbutton invoke"
  bind $s <Key-Left> {set info(speak_delay) [expr {$info(speak_delay) + 250}]}
  bind $s <Key-Right> {if {$info(speak_delay) > 500} {set info(speak_delay) [expr {$info(speak_delay) - 250}]}}
  grid [button $s.okbutton -text [mc Done] -default active -command "set ok 1"] -row 4 -column 2
  bind $s <Key-Return> "$s.okbutton invoke"
  vwait ok
  speak $w stop
  set dialogblock 0
  bind . <<RaiseDialogs>> ""
  destroy $s 
}

##############
## Speak texts
##############
proc speak {w i} {
  global info

  if {$i == "stop"} {
    catch {after cancel $info($w,speak_cancel)}
    array unset info "$w,speak_cancel"
    return
  }

  if {[regexp {.abi_window[0-9]+} $w] && ($i < [llength [$w.c find withtag basecall]])} {
    set char [$w.c itemcget [lindex [$w.c find withtag basecall] $i] -text]
    abi_select_region $w $i $i
  } elseif {[regexp {.dna_window[0-9]+} $w] && ![regexp {analysis} $w] && ([$w.textarea compare [bp2ix $w.textarea $i] < end-1c])} {
    if {($i == -1)} {
      if {([$w.textarea tag ranges sel] != "")} {
        set i [ix2bp $w.textarea [$w.textarea index sel.first]]
      } else {
        set i [ix2bp $w.textarea [$w.textarea index insert]]
      }
    }
    set char [textarea_get $w.textarea [bp2ix $w.textarea $i] [bp2ix $w.textarea [expr {$i+1}]]]
    select_region $w [bp2ix $w.textarea $i] [bp2ix $w.textarea [expr {$i+1}]]
  } else {
    if {[$w.textarea index end-1c] eq 1.0} {
      set info($w,speak_cancel) "empty text"
    }
    set char ""
  }

  if {$char != ""} {
    if  {([lsearch -glob [info loaded] "*TclSpeech2.0.dylib*"] > -1) && $info(speak_use_aqua)} {
      if {$info(speak_use_words)} {
        speech::speak [string map {A alpha B bravo C charlie D delta G golf H hotel K kilo M mike N november R romeo S sierra T tango U uniform V victor W wiskey Y yankee} [string toupper $char]] -voice $info(speak_voice)
      } else {
        speech::speak [string map {* N a ay A ay} $char] -voice $info(speak_voice)
      }
    } elseif  {([lsearch -glob [info loaded] "*libsnack*"] > -1)} {
      
    } else {
      return
    }
    set info($w,speak_cancel) [after $info(speak_delay) "speak $w [expr {$i+1}]"]
  } else {
    array unset info "$w,speak_cancel"
  }
}


##############
## Text-based calculator
##############
proc tcl::mathfunc::pi {} {return 3.141592653589793238462643383}
proc tcl::mathfunc::e {} {return 2.718281828459}
proc tcl::mathfunc::dsin {x} {return [expr {sin(180.0/pi()*$x)}]}
proc tcl::mathfunc::dcos {x} {return [expr {cos(180.0/pi()*$x)}]}
proc tcl::mathfunc::dtan {x} {return [expr {tan(180.0/pi()*$x)}]}
proc tcl::mathfunc::dacos {x} {return [expr {180.0/pi()*acos($x)}]}
proc tcl::mathfunc::dasin {x} {return [expr {180.0/pi()*asin($x)}]}
proc tcl::mathfunc::datan {x} {return [expr {180.0/pi()*atan($x)}]}
proc tcl::mathfunc::datan2 {x y} {return [expr {180.0/pi()*atan2($x, $y)}]}

proc calc {} {
  global modifier
  if {![winfo exists .calc]} {
    toplevel .calc
    wm resizable .calc 1 0
    wm title .calc "Calculator: Enter a calculation"
    grid [entry .calc.e1 -validatecommand "calc_update %P" -validate key] -row 1 -column 1 -sticky nwe
    grid [label .calc.result ] -row 2 -column 1 -sticky nwe
    grid columnconfigure .calc 1 -weight 1
    bind .calc <$modifier-Key-c> "clipboard clear; if {\[.calc.e1 selection present\]} {clipboard append \"\[tk::EntryGetSelection .calc.e1\]\"} else {clipboard append \"\[.calc.result cget -text\]\"}"
  } else {
    raise .calc
  }
}

##############
## Update the calculator results
##############
# adds a decimal to numbers, so that all calculations are real
proc calc_update {text} {
  set pi [expr {acos(-1)}]
  set e [expr {exp(1)}]
  if {[winfo exists .calc.result]} {
    set dotlist [list]
    foreach ilist [regexp -all -indices -inline {[0-9]+} $text] {
      foreach {a  b} $ilist {}
      if {([string index $text $a-1] ne ".") && ([string index $text $b+1] ne ".") && ([string toupper [string index $text $a-1]] ne "E") && ([string toupper [string range $text $a-2 $a-1]] ne "E-") && ([string toupper [string range $text $a-2 $a-1]] ne "E+") && ([string toupper [string index $text $a-1]] ne "X") && ([string toupper [string index $text $b+1]] ne "X")} {
        lappend dotlist $b
      }
    }
    set i 0
    foreach b $dotlist {
      set text "[string range $text 0 [expr {$i+$b}]].[string range $text [expr {$i+$b+1}] end]"
      incr i
    }
    if {[catch {expr "$text"} result]} {
      .calc.result configure -text "------"
    } else {
      .calc.result configure -text [regsub {\.0$} $result ""]
    }
  }

return 1
}


##############
## show all sites that can be generated keeping the same translation
##############
proc silent_sites {w selected_enzymes} {
  global info
  global enzinfo
  global enzymes
  global modstring modifier

  if {[$w.textarea tag ranges sel] == ""} {
    set start 0
    set end [ix2bp $w.textarea [$w.textarea index end-1chars]]
  } else {
    set  start [ix2bp $w.textarea [$w.textarea index sel.first]]
    set end [ix2bp $w.textarea [$w.textarea index sel.last]]
  }

  if {$selected_enzymes == [list]} {
    tk_messageBox -message [mc "No enzymes selected, searching all enzymes."] -type ok -icon info -default ok
    set selected_enzymes $enzymes
  } else {
    tk_messageBox -message [mc "Searching %1\$s selected enzymes." [llength $selected_enzymes]] -type ok -icon info -default ok
  }

  if {[array names enzinfo 3ftrxl*] == [list]} {
    foreach enzyme $enzymes {
      set enzinfo(3ftrxl,$enzyme) [degen_transl $enzinfo(flatpat,$enzyme)]
    }
  }

  findenzymes $w

  set DNA [textarea_get $w.textarea [bp2ix $w.textarea $start] [bp2ix $w.textarea $end]]
  incr start
  incr end
  set AA [translate $DNA]
  set templist [list]

  foreach enzyme $selected_enzymes {
    foreach trxl $enzinfo(3ftrxl,$enzyme) frame [list 2 1 0] {
      foreach pair [regexp -indices -all -inline $trxl $AA] {
#sputs $enzyme $info($w,$enzyme) [expr {$start+3*[lindex $pair 0]+$frame}] [lsearch $info($w,$enzyme) [expr {$start+3*[lindex $pair 0]+$frame}]]
        if {[lsearch $info($w,$enzyme) [expr {$start+3*[lindex $pair 0]+$frame}]] == -1} {
          lappend templist [list $enzyme $frame [expr {$start+3*[lindex $pair 0]+$frame}] [string range $DNA [expr {3*[lindex $pair 0]}] [expr {2+3*[lindex $pair 1]}]]]
        }
      }
    }
  }

  set a [new_analysis_window $w "Silent Sites"]
  create_textframe $a 40
  $a.textframe.text configure -tabs {3.5c right 3.5c left}

  catch {$a.textframe.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
  $a.textframe.text insert end "$info($w,win_title) \n"
  $a.textframe.text insert end "[mc From] $start [mc to] [expr {$end-1}]\. \n"
  $a.textframe.text insert end "Silent Sites\n\n"

  set templist [lsort -integer -index 2 $templist]
  foreach site $templist {
  #site: name of enzyme, frame, start index of enzyme, DNA sequence
    #pad the RE sequence with N and find the minimal change to give the same translation (stored in new_seq)
    set original_seq [lindex $site 3]
    set re_seq "[string repeat "N" [lindex $site 1]]$enzinfo(flatpat,[lindex $site 0])"
    set re_seq "$re_seq[string repeat "N" [expr {(3-[string length $re_seq]%3)%3}]]"
    set new_seq_list [coordinate_translation $original_seq $re_seq]

    #output to text window
    $a.textframe.text insert end "\t[expr {[lindex $site 2]-[lindex $site 1]}]\t" {} "[regexp -inline -all {(?:...)} [lindex $site 3]]" [list dnatag "ls[expr {[lindex $site 2]-[lindex $site 1]}]_1"] "\n"
    foreach new_seq $new_seq_list {
      $a.textframe.text insert end "\t\t[regexp -inline -all {(?:...)} $new_seq]\n"
    }
    $a.textframe.text insert end "\t[lindex $site 0]\t[join [regexp -inline -all {(?:...)} "[string repeat " " [lindex $site 1]]$enzinfo(flatpat,[lindex $site 0])   "] " "]\n"
    $a.textframe.text insert end "\t\t [translate [lindex $site 3] 1 1 3]\n\n"
  }

  if {$templist == ""} {
    $a.textframe.text insert end "No sites Found"
  }

  #bindings
  $a.textframe.text tag bind dnatag <Double-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] goto 1; break"
  $a.textframe.text tag bind dnatag <Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] goto 0; break"
  $a.textframe.text tag bind dnatag <Shift-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] select 0; break"
  $a.textframe.text tag bind dnatag <Shift-Double-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] select 1; break"
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Double-Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Shift-Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text dnatag <Shift-Double-Button-1>]
  $a.textframe.text tag bind dnatag <Any-Leave> {%W tag remove highlite 1.0 end}
  $a.textframe.text tag bind dnatag <Any-Motion> {%W tag remove highlite 1.0 end; %W tag add highlite current}
  $a.textframe.text tag configure highlite -background red

  bind $a <MouseWheel> {[winfo toplevel %W].text yview scroll [expr {int(1.0 * %D/-\$info(mousewheelunits))}] units}
  set outputmenu [add_output_menu $a.textframe.text "Text" text $w]
  bind $a <Button-1> "focus $a.textframe.text" 
  bindtags $a.textframe.text [list $a.textframe.text AnalysisText . all]
  wm deiconify $a
  window_on_screen $a
  focus $a.textframe.text
} 

##############
## Utility function of Silent sites- coordinate the original seq and enzyme sequence to give the smallest change that has the same translation
##############
proc coordinate_translation {original_seq re_seq} {
  set result ""
  set original_seq [string toupper $original_seq]
  foreach orig_codon [regexp -inline -all {(?:...)} $original_seq] re_codon [regexp -inline -all {(?:...)} $re_seq] {
    if {[regexp {[^ACGT]} $re_codon] == 0} {
       set i $re_codon
    } elseif {$re_codon == "NNN"} {
      set i $orig_codon
    } else {
      set i ""
      foreach orig_char [split $orig_codon ""] re_char [split $re_codon ""] {
        set possible_list [string map {A A B CGT C C D AGT G G H ACT K GT M AC N ACGT R AG S GC T T V ACG W AT Y CT}  $re_char]
         if {[string match "*[string toupper $orig_char]*" $possible_list]} {
           set i "$i$orig_char"
         } else {
           set i "$i$re_char"
         }
      }
    }
    if {[translate $i] == [translate $orig_codon]} {
      #we've found a codon that is compatible between original and re by simple substitution
      set result "$result$i"
    } else {
      #need to find codon from re only (re has at least one degenerate base)
      set codon_list [string map {R {CGN CGV CGD CGB CGH CGW CGS CGR CGY CGK CGM CGA CGC CGG CGT AGR AGA AGG} S {TCN TCV TCD TCB TCH TCW TCS TCR TCY TCK TCM TCA TCC TCG TCT AGY AGC AGT}  L {CTN CTV CTD CTB CTH CTW CTS CTR CTY CTK CTM CTA CTC CTG CTT TTR TTA TTG} G {GGN GGV GGD GGB GGH GGW GGS GGR GGY GGK GGM GGA GGC GGG GGT} V {GTN GTV GTD GTB GTH GTW GTS GTR GTY GTK GTM GTA GTC GTG GTT} P {CCN CCV CCD CCB CCH CCW CCS CCR CCY CCK CCM CCA CCC CCG CCT} T {ACN ACV ACD ACB ACH ACW ACS ACR ACY ACK ACM ACA ACC ACG ACT} A {GCN GCV GCD GCB GCH GCW GCS GCR GCY GCK GCM GCA GCC GCG GCT}  I {ATH ATW ATY ATM ATA ATC ATT} F {TTY TTC TTC} Y {TAY TAC TAT} C {TGY TGC TGT} H {CAY CAC CAT} N {AAY AAC AAT} D {GAY GAC GAT} * {TAR TAA TAG TGG} Q {CAR CAA CAG} K {AAR AAA AAG} E {GAR GAA GAG} W {TGG}  M {ATG} } [translate $orig_codon]]
      set search_pattern [string map {B [BYSKCGT] D [DRWKAGT] H [HMWYACT] K [KGT] M [MAC] N [NBDHVKMRYWSACGT] R [RAG] S [SGC] V [VMSRACG] W [WAT] Y [YCT]}  $re_codon]
      set i [regexp -inline $search_pattern $codon_list]
#sputs coordinate_translation $orig_codon [translate $orig_codon] $re_codon $i
      if {($i != "")} {
        if {[regexp {[^ACGT]} $i]} {
         #resubstitute any degenerate codes that are in the new codon
          set j ""
          foreach orig_char [split $orig_codon ""] re_char [split $i ""] {
            set possible_list [string map {A A B CGT C C D AGT G G H ACT K GT M AC N ACGT R AG S GC T T V ACG W AT Y CT}  $re_char]
             if {[string match "*[string toupper $orig_char]*" $possible_list]} {
               set j "$j$orig_char"
             } else {
                set j "$j$re_char"
             }
          }
          set result "$result$j"
          #if {$i != $j} {sputs coordinate_translation  $i $j}
        } else {
          set result "$result$i"
        }
      } else {
        #match algorithm has gone wrong- shouldn't get to here
        set result [join [list $result "xxx"] ""]
      }
    }
  }
  if {[regexp {[^ACGT]} $result] == 0} {
    set result_list [list $result]
  } else {
    set result_list [list ""]
    foreach char [split $result ""] {
      set templist [list]
      foreach new_char [split [string map {A A B CGT C C D AGT G G H ACT K GT M AC N ACGT R AG S GC T T V ACG W AT Y CT} $char] ""] {
        foreach str $result_list {
          lappend templist "$str$new_char"
        }
      }
      set result_list $templist
    }
  }
  return $result_list
}

##############
## Make an orf map
##############
proc orf_map {w region} {
  global enzymes
  global info
  global modstring
  global modifier

  if {[$w.textarea tag ranges tempsel] == ""} {set region "all"}
  if {$region == "all"} {
    set start 0
    set total_length [ix2bp $w.textarea [$w.textarea index end-1chars]]
    set end $total_length
  } else {
    set start [ix2bp $w.textarea [$w.textarea index tempsel.first]]
    set end [ix2bp $w.textarea [$w.textarea index tempsel.last]]
    set total_length [expr {$end - $start+1}]
  }
  if {$total_length == 0} return
  set text [textarea_get $w.textarea [bp2ix $w.textarea $start] [bp2ix $w.textarea $end]]

  incr start

  foreach frame [list 0 1 2] {
    set metlist($frame) [list]
    set stoplist($frame) [list]
    set temlist($frame) [list]
    set potslist($frame) [list]
  }

  foreach met [regexp -inline -all -nocase -indices {ATG} $text] {
    lappend metlist([expr {[lindex $met 0] % 3}]) [list met [lindex $met 0]]
  }
  foreach stop [regexp -inline -all -nocase -indices {TAG|TAA|TGA} $text] {
    lappend stoplist([expr {[lindex $stop 0] %3}]) [list stop [lindex $stop 0]]
  }
  foreach tem [regexp -inline -all -nocase -indices {CAT} $text] {
    lappend temlist([expr {[lindex $tem 0] % 3}]) [list tem [lindex $tem 0]]
  }
  foreach pots [regexp -inline -all -nocase -indices {CTA|TTA|TCA} $text] {
    lappend potslist([expr {[lindex $pots 0] % 3}]) [list pots [lindex $pots 0]]
  }

  set a [new_analysis_window $w "ORF Map"]  

  grid [canvas $a.c -yscrollcommand "optionscrollbar $a.sy" -xscrollcommand "optionscrollbar $a.sx" -width 700 -height 450 -background white] -row 0 -column 0 -sticky nswe
  grid [scrollbar $a.sy -orient vertical -command "$a.c yview"] -row 0 -column 1 -sticky nswe
  grid [scrollbar $a.sx -orient horizontal -command "$a.c xview"] -row 1 -column 0 -sticky nswe
  grid rowconfigure $a 0 -weight 1
  grid columnconfigure $a 0 -weight 1
  grid columnconfigure $a 1 -minsize 17

  set scale [expr {1.0/5}]
  set tick_incr 100
  if {$total_length <= 1000} {
    set scale [expr {1.0/2}]
    set tick_incr 10
    if {$total_length <= 100} {
      set scale [expr {2.0}]
      set tick_incr 1
    }
  }

  ##make the outer box and horizontal lines
  set x_right [expr {50+$total_length*$scale}]
  $a.c create rectangle 50 100 $x_right 400
  foreach y [list 150 200 250 300 350] {
    $a.c create line 50 $y $x_right $y
  }
  $a.c create text 50 405 -text "$info($w,filename)" -anchor nw 
  $a.c create text 50 417 -text "ORF Map from $start to $end" -anchor nw 

  ##make the top row tick marks
  set x [expr {$start-(($start-1) % $tick_incr)-1+$tick_incr}]
  while {$x <= $end} {
    set x_pos [expr {50+($x-$start)*$scale}]
    if {[expr {$x %(5*$tick_incr)}] == 0} {
      $a.c create line $x_pos 90 $x_pos 100
      if {[expr {$x % (10*$tick_incr)}] == 0} {
        $a.c create text $x_pos 87 -text $x -anchor s
      }
    } else {
      $a.c create line $x_pos 95 $x_pos 100
    }
    incr x $tick_incr
  }

  ##now put in the met and stops
  foreach frame [list 0 1 2] {
    set fwd [lsort -integer -index 1 [concat $metlist($frame) $stoplist($frame)]]
    foreach item $fwd {
      set x_pos [expr {50+[lindex $item 1]*$scale}]
      if {[lindex $item 0] == "met"} {
        $a.c create line $x_pos [expr {125+50*$frame}] $x_pos [expr {150+50*$frame}]
      } else {
        $a.c create line $x_pos [expr {100+50*$frame}] $x_pos [expr {150+50*$frame}] 
      }
    }
    set rev [lsort -integer -index 1 [concat $temlist($frame) $potslist($frame)]]
    foreach item $rev {
      set x_pos [expr {50+[lindex $item 1]*$scale}]
      if {[lindex $item 0] == "tem"} {
        $a.c create line $x_pos [expr {250+50*$frame}] $x_pos [expr {275+50*$frame}]
      } else {
        $a.c create line $x_pos [expr {250+50*$frame}] $x_pos [expr {300+50*$frame}] 
      }
    }
  }
  $a.c configure -scrollregion [$a.c bbox all]

  set outputmenu [add_output_menu $a.c "Image" image $w]
  set info($a,scale) 100
  set info($a,new_scale) 100
  bind $a <Button-1> "focus $a.c" 
  wm deiconify $a
  window_on_screen $a
  focus $a.c
}

##############
## Translation analysis window
##############
proc translation_window {w} {
  global info
  global modifier
  global modstring
  global ok dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1


  toplevel .dialog
  wm title .dialog [mc "Translate..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0
  grid [frame .dialog.f1 -relief ridge -borderwidth 3] -row 1 -column 0 -sticky nwe
  grid [label .dialog.f1.label -text [mc "Code:"]] -row 0 -column 0 -sticky w
  grid [radiobutton .dialog.f1.1let -text [mc "1 Letter"] -variable info(translation_window_code) -value 1  -selectcolor white -activebackground $info(bg_color)] -row 0 -column 1 -sticky w
  grid [radiobutton .dialog.f1.3let -text [mc "3 Letter"] -variable info(translation_window_code) -value 3 -selectcolor white -activebackground $info(bg_color)] -row 0 -column 2 -sticky w
  grid [checkbutton .dialog.f1.spacing -text [mc "Codon Spacing"] -variable info(translation_window_spacing) -onvalue 1 -offvalue 0 -selectcolor white -activebackground $info(bg_color)] -row 1 -column 0 -columnspan 2 -sticky w
  grid [checkbutton .dialog.f1.revcom -text [mc "Reverse Complement"] -variable info(translation_window_revcom) -onvalue 1 -offvalue 0 -selectcolor white -activebackground $info(bg_color)] -row 1 -column 2 -sticky w

  grid [frame .dialog.f2 -relief ridge -borderwidth 3] -row 2 -column 0  -sticky nwe
  grid [label .dialog.f2.label1 -text [mc "Line Width:"]] -row 0 -column 0 -sticky w
  grid [entry .dialog.f2.width -width 4 -textvariable info(translation_window_width) -validate key -vcmd "check_char %S"] -row 0 -column 1 -columnspan 3 -sticky w
  grid [label .dialog.f2.label2 -text [mc "Line Numbers:"]] -row 1 -column 0 -sticky w
  grid [radiobutton .dialog.f2.lnone -text [mc "None"] -variable info(translation_window_line_numbers) -value none -selectcolor white -activebackground $info(bg_color)] -row 1 -column 1 -sticky w
  grid [radiobutton .dialog.f2.lleft -text [mc "Left"] -variable info(translation_window_line_numbers) -value left -selectcolor white -activebackground $info(bg_color)] -row 1 -column 2 -sticky w
  grid [radiobutton .dialog.f2.lright -text [mc "Right"] -variable info(translation_window_line_numbers) -value right -selectcolor white -activebackground $info(bg_color)] -row 1 -column 3 -sticky w
  grid [radiobutton .dialog.f2.lboth -text [mc "Both"] -variable info(translation_window_line_numbers) -value both -selectcolor white -activebackground $info(bg_color)] -row 1 -column 4 -sticky w

  grid [frame .dialog.f3 -relief ridge -borderwidth 3] -row 3 -column 0  -sticky nwe
  #grid [checkbutton .dialog.f3.revcom -text [mc "Index Line"] -variable info(translation_window_index_line) -onvalue 1 -offvalue 0 -selectcolor white -activebackground $info(bg_color)] -row 1 -column 0 -columnspan 2 -sticky w
  grid [label .dialog.f3.label1 -text [mc "DNA:"]] -row 2 -column 0 -sticky w
  grid [radiobutton .dialog.f3.dnone -text [mc "None"] -variable info(translation_window_dna_line) -value none -selectcolor white -activebackground $info(bg_color)] -row 2 -column 1 -sticky w
  grid [radiobutton .dialog.f3.dabove -text [mc "Above"] -variable info(translation_window_dna_line) -value above -selectcolor white -activebackground $info(bg_color)] -row 2 -column 2 -sticky w
  grid [radiobutton .dialog.f3.dbelow -text [mc "Below"] -variable info(translation_window_dna_line) -value below -selectcolor white -activebackground $info(bg_color)] -row 2 -column 3 -sticky w
  grid [checkbutton .dialog.f3.dcopyhigh -text [mc "Copy Highlight"] -variable info(translation_window_copy_highlight) -onvalue 1 -offvalue 0 -selectcolor white -activebackground $info(bg_color)] -row 3 -column 0 -sticky w 

  grid [button .dialog.ok -command {set ok 1} -text [mc "OK"] -default active] -row 4 -column 0 -sticky n -padx 10 -pady 3
  bind .dialog <Key-Return> "set ok 1"
  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry .dialog "+$winx+$winy"

  vwait ok
  set dialogblock 0
  destroy .dialog
  bind . <<RaiseDialogs>> ""
  if {$ok != 1} {return}
  unset ok
  if {$info(translation_window_width) == ""} {set info(translation_window_width) 20}
  if {[$w.textarea tag ranges sel] == ""} {
    set start 0
    set end [ix2bp $w.textarea [$w.textarea index end-1chars]]
  } else {
    set  start [ix2bp $w.textarea [$w.textarea index sel.first]]
    set end [ix2bp $w.textarea [$w.textarea index sel.last]]
  }

  set a [new_analysis_window $w [mc "Translation"]]


  create_textframe $a 120
  #bind $a.textframe <Configure> "set info(last_trans_window_geom) \[winfo geom $a\]"

  set dna [textarea_get $w.textarea [bp2ix $w.textarea $start] [bp2ix $w.textarea $end]]
  incr start
  if {$info(translation_window_revcom)} {
    set dna [revcom $dna]
    set start [expr {$start+([string length $dna] % 3)}]
  } else {
    set end [expr {$end-([string length $dna] % 3)}]
  }
  regexp {(^[^*]*)\*?(.*)} [translate $dna 1 1 0] temp mwaa mwxs
  set dna [regexp -inline {(?:...)*} $dna]
  set spacing 0

  if {$info(translation_window_spacing)} {
    if {($info(translation_window_code) == 1) && ($info(translation_window_dna_line) != "none")} {
      set spacing 3
    } else {
      set spacing 1
    }
  } elseif {($info(translation_window_code) == 1) && ($info(translation_window_dna_line) != "none")} {
    set spacing 2
  }

  set protein [translate $dna $info(translation_window_code) 1 $spacing]

  if {$info(translation_window_spacing)} {
    set dna "[regexp -all -inline {(?:...)} $dna] "
    set protein "$protein "
  }
  if {($info(translation_window_code) == 1) && ($info(translation_window_dna_line) != "none")} {
    set protein " $protein"
  }
  if {($info(translation_window_code) == 1) && ($info(translation_window_dna_line) != "none")} {
    set protein "$protein "
  }

  if {($info(translation_window_code) == 1)} {
    incr spacing 1
  } else {
    incr spacing 3
  }


  catch {$a.textframe.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
  $a.textframe.text insert end "$info($w,win_title) \n"
  $a.textframe.text insert end "$info($w,filename) \n"
  if {$info(translation_window_revcom)} {
    $a.textframe.text insert end "[mc {From %1$s to %2$s.} $end $start] \n"
  } else {
    $a.textframe.text insert end "[mc {From %1$s to %2$s.} $start $end] \n"
  }
  $a.textframe.text insert end "[mc Translation] "

  set mw [expr "[string map -nocase {X +0.0 G +57.05 A +71.09 S +87.08 T +101.11 C +103.15 V +99.14 L +113.16 I +113.16 M +131.19 P +97.12 F +147.18 Y +163.18 W +186.21 D +115.09 E +129.12 N +114.11 Q +128.14 H +137.14 K +128.17 R +156.19 * +0.0} $mwaa]+18.02"]
  $a.textframe.text insert end "[mc {%1$s a.a. MW=%2$s} [string length $mwaa] $mw]\n"
  if {$mwxs!=""} {
    $a.textframe.text insert end "[mc {???(%1$s extra codons after stop)} [string length $mwxs]]\n"
  } else {
    $a.textframe.text insert end "\n"
  }

  for {set x 0} {[expr {$x*($spacing)}]< [string length $protein]} {incr x $info(translation_window_width)} {
    set width $info(translation_window_width)
    set pline [string range $protein [expr {$x*($spacing)}] [expr {($width+$x)*($spacing)-1}]]
    set dline [string range $dna [expr {$x*($spacing)}] [expr {($width+$x)*($spacing)-1}]]
    set linestart [expr {$info(translation_window_revcom)?($end-3*$x):($start+3*$x)}]
    if {[string length $dline] == [expr {$width*$spacing}]} {
      set lineend [expr {$info(translation_window_revcom)?($end-3*($x+$width)+1):($start+3*($x+$width)-1)}]
    } else {
      set lineend [expr {$info(translation_window_revcom)?$start:$end}]
    }
    if {$info(translation_window_dna_line) == "above"} { 
      if {($info(translation_window_line_numbers) == "left") ||($info(translation_window_line_numbers) == "both")} {
        $a.textframe.text insert end "[format {%7u } $linestart]"
      }
      set dlinestartindex [$a.textframe.text index "end -1char"]
      $a.textframe.text insert end "$dline" [list linktag "ls$linestart\_[expr {$info(translation_window_revcom)?-1:1}]"]
      if {$info(translation_window_copy_highlight)} {
        copy_tags $w.textarea [list [bp2ix $w.textarea [expr {$linestart-1}]] [bp2ix $w.textarea [expr {$lineend-1}]]] $a.textframe.text $dlinestartindex [expr {$info(translation_window_revcom)?"reverse":"forward"}] ""
      }
      if {($info(translation_window_line_numbers) == "right") ||($info(translation_window_line_numbers) == "both")} {
        $a.textframe.text insert end "[format { %-7u} $lineend]\n"
      } else {
        $a.textframe.text insert end "\n"
      }
    }

    if {($info(translation_window_line_numbers) == "left") ||($info(translation_window_line_numbers) == "both")} {
      $a.textframe.text insert end "[format {%7u } [expr {$x+1}]]"
    }
    $a.textframe.text insert end "$pline" [list linktag "ls$linestart\_[expr {$info(translation_window_revcom)?(($info(translation_window_code)==1)?-3:-1):(($info(translation_window_code)==1)?3:1)}]"]
    if {($info(translation_window_line_numbers) == "right") ||($info(translation_window_line_numbers) == "both")} {
      $a.textframe.text insert end "[format { %-7u} [expr {$x+[string length $pline]/$spacing}]]\n"
    } else {
      $a.textframe.text insert end "\n"
    }

    if {$info(translation_window_dna_line) == "below"} { 
      if {($info(translation_window_line_numbers) == "left") ||($info(translation_window_line_numbers) == "both")} {
        $a.textframe.text insert end "[format {%7u } $linestart]"
      }
      set dlinestartindex [$a.textframe.text index "end -1char"]
      $a.textframe.text insert end "$dline" [list linktag "ls$linestart\_[expr {$info(translation_window_revcom)?-1:1}]"]
      if {$info(translation_window_copy_highlight)} {
        copy_tags $w.textarea [list [bp2ix $w.textarea [expr {$linestart-1}]] [bp2ix $w.textarea [expr {$lineend-1}]]] $a.textframe.text $dlinestartindex [expr {$info(translation_window_revcom)?"reverse":"forward"}] ""
      }
      if {($info(translation_window_line_numbers) == "right") ||($info(translation_window_line_numbers) == "both")} {
        $a.textframe.text insert end "[format { %-7u} $lineend]\n"
      } else {
        $a.textframe.text insert end "\n"
      }
    }
    if {($info(translation_window_dna_line) != "none") || ($info(translation_window_index_line))} {
      $a.textframe.text insert end "\n"
    }
  }

  foreach tag [$w.textarea tag names] {
     if {[lsearch -exact [$a.textframe.text tag names] $tag] > -1} {
       $a.textframe.text tag raise $tag
     }
  }
  $a.textframe.text tag bind linktag <Double-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] goto 1; break"
  $a.textframe.text tag bind linktag <Shift-Double-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] select 1; break"
  $a.textframe.text tag bind linktag <Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] goto 0; break"
  $a.textframe.text tag bind linktag <Shift-Button-1> "alignlink2 $a.textframe.text $w \[$a.textframe.text index @%x,%y\] select 0; break"
  $a.textframe.text tag bind linktag <Any-Leave> {%W tag remove highlite 1.0 end}
  $a.textframe.text tag bind linktag <Any-Motion> {%W tag remove highlite 1.0 end; %W tag add highlite current}
  $a.textframe.text tag configure highlite -background red
  lappend info($w,linked_events) [list $a.textframe.text linktag <Double-Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text linktag <Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text linktag <Shift-Button-1>]
  lappend info($w,linked_events) [list $a.textframe.text linktag <Shift-Double-Button-1>]

  bind $a <MouseWheel> {[winfo toplevel %W].textframe.text yview scroll [expr {int(1.0 * %D/-\$info(mousewheelunits))}] units}
  set outputmenu [add_output_menu $a.textframe.text "Text" text $w]
  bind $a <Button-1> "focus $a.textframe.text" 
  bindtags $a.textframe.text [list $a.textframe.text AnalysisText . all]
  wm deiconify $a
  window_on_screen $a
  focus $a.textframe.text
}

##############
## save a canvas as encapsulated postscript or enhanced metafile
##############
proc canvas_save {c {type ""}} {
  global tcl_platform ps_fontmap

  if {[set coords [$c bbox all]] != [list]} {
    set filetypes {{"Encapsulated Postscript" {.eps}} {"Scalable Vector Graphics" {.svg}}} 
    if {$tcl_platform(platform) == "windows"} {
      lappend filetypes {"Enhanced Metafile" {.emf}}
    }

    set filename [tk_getSaveFile -defaultextension ".eps" -title [mc "Save Image"] -filetypes $filetypes -parent [winfo toplevel $c]]

    if {$filename == ""} {return}
    if {[file extension $filename] == ""} {
      switch $type {
        eps {set filename "$filename\.eps"}
        emf {set filename "$filename\.emf"}
        svg {set filename "$filename\.svg"}
        default {set filename "$filename\.eps"}
      }
    }
    switch [file extension $filename] {
      .eps {set type ".eps"}
      .emf {set type ".emf"}
      .svg {set type ".svg"}
      default {set type ".eps"}
    }

    switch $type {
      .eps {
        set x1 [lindex $coords 0]
        set y1 [lindex $coords 1]
        set x2 [lindex $coords 2]
        set y2 [lindex $coords 3]
        array unset ps_fontmap *
        get_canv_fontmap $c ps_fontmap
        $c postscript -file $filename -fontmap ps_fontmap -height [expr ($y2-$y1)] -width [expr ($x2-$x1)] -x $x1 -y $y1
      } 
      .emf {      
        if {([lsearch -exact [package names] "wmf"] > -1)} {
          set hDCname [wmf open]
          set hDC [hdc addr $hDCname]
          canvas_to_hdc $c $hDC 0
          set emf_file [wmf close $hDCname]
          wmf copy $emf_file -file $filename
          wmf delete $emf_file
        }
      }
      .svg {
        set file [open $filename w]
        puts $file [canvas_to_svg $c]
        close $file
      }
    } 
  }
}

##############
## get a postscript fontmap for a canvas
##############
proc get_canv_fontmap {c fontmap} {
  global $fontmap tk_fonts ps_fonts
  set fontlist [list]
  set scale [tk scaling]
  array unset $fontmap *
  foreach i [$c find all] {
    if {[$c type $i] == "text"} {
      set font [$c itemcget $i -font]
      if {[lsearch -exact $fontlist $font] == -1} {
        set family [string tolower [font actual "$font" -family]]
        set weight [font actual "$font" -weight]
        set size [font actual "$font" -size]
        if {[lsearch -exact $tk_fonts "$family\_$weight"] > -1} {
          set ps_font [lindex $ps_fonts [lsearch -exact $tk_fonts "$family\_$weight"]]
        } elseif {[font metrics $font -fixed]} {
          set ps_font Courier  
        } else {
          set ps_font Helvetica
        }
        set "$fontmap\($font)" [list $ps_font [expr {1.0*$size*$scale}]]
      }
    }
  }
}

##############
## print a canvas- windows uses printer extension, aqua uses maccarbonprint extension, UNIX uses postscript
##############
proc print_canvas {c {dialog_parent ""}} {
  global tcl_platform ps_fontmap
  if {[set sc [$c bbox all]] != [list]} {
    foreach {x1 y1 x2 y2} $sc {}
  } else {
    return
  }
  if {$dialog_parent eq ""} {
    if {[winfo ismapped $c]} {
      set dialog_parent $c
    } else {
      tk_messageBox -message "bad window parent: $c" -icon error 
      return
    }
  }
  if {($tcl_platform(platform) == "windows")} {
    if {[set print_parameters [windows_print_dialog]] != ""} {
      foreach {hDC page_width page_height pm_left pm_top pm_right pm_bottom ppi_x ppi_y first_page last_page copies spool_copies print_flag} $print_parameters {}
      set pages [expr {($copies<$spool_copies)?$spool_copies:$copies}]
      ###need to scale the output to fit on page
      set window_x [expr {$x2-$x1}]
      set window_y [expr {$y2-$y1}]
      set printer_x [expr {($page_width - $pm_left - $pm_right) * $ppi_x / 1000.0}]
      set printer_y [expr {($page_height - $pm_top - $pm_bottom) * $ppi_y / 1000.0}]
      set factor_x [ expr $window_x / $printer_x ]
      set factor_y [ expr $window_y / $printer_y ]
      if { $factor_x < $factor_y } {
        set lo $window_y
        set ph $printer_y
      } else {
        set lo $window_x
        set ph $printer_x
      }
      printer job start
      for {set i 0} {$i < $pages} {incr i} {
        printer page start
        gdi map $hDC -logical $lo -physical $ph -offset [list [expr {int(($pm_left* $ppi_x / 1000)-(1.0*$x1/$lo*$ph))}] [expr {int(($pm_top* $ppi_x / 1000)-(1.0*$y1/$lo*$ph))}]]
        canvas_to_hdc $c $hDC 1
        printer page end
      }
      printer job end
      printer close
    }
  } elseif {$tcl_platform(platform) == "unix"} {
    if  {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] > -1)} {
    ########Aqua native printing
      if {[set print_parameters [aqua_print_dialog $dialog_parent]] != ""} {
        foreach {printObj printtype page_width page_height ppi_x ppi_y copies firstpage lastpage} $print_parameters {}

        set window_x [expr {$x2-$x1}]
        set window_y [expr {$y2-$y1}]

        set scale_x [expr {($page_width/($window_x))<1?($page_width/($window_x)):1}]
        set scale_y [expr {($page_height/($window_y))<1?($page_height/($window_y)):1}]
        set scale [expr {($scale_x<$scale_y)?$scale_x:$scale_y}]

        if {![catch {::maccarbonprint::opendoc $printObj 1 1} errMsg]} {
          #bug? takes care of printing the copies already
          set copies 1
          for {set i 0} {$i<$copies} {incr i} {
sputs copies $copies
##some kind of margin issue- ad hoc add -30 to the offsety and -20 to offsetx
            if {![catch {set win [::maccarbonprint::openpage $printObj -scale $scale -offsetx [expr {int($scale*$x1-20)}] -offsety [expr {int($scale*$y1)-30}]]}]} {
              canvas_to_carbonprint $c $win $scale
              # Close down.
              catch {::maccarbonprint::closepage $printObj}
            }
          }
          catch {::maccarbonprint::closedoc $printObj}
        }
      }
    } else {
      #####non-aqua unix printing
      if {[llength [set print_parameters [unix_print_dialog [winfo toplevel $c]]]] > 3} {
        puts $print_parameters
        foreach {printer page_width page_height pm_left pm_top pm_right pm_bottom ppi_x ppi_y copies orient scale} $print_parameters {}
        array unset ps_fontmap *
        get_canv_fontmap $c ps_fontmap
        #exec lpr -P $printer << [$c postscript -height [expr ($y2-$y1)] -width [expr ($x2-$x1)] -x $x1 -y $y1]
        if {$orient=="landscape"} {
          exec lpr -P $printer << [$c postscript -height [expr ($y2-$y1)] -width [expr ($x2-$x1)] -x $x1 -y $y1 -pagex "$pm_top\i" -pagey "[expr {$pm_left}]\i" -pageanchor nw -rotate 1]
        } else {
          exec lpr -P $printer << [$c postscript -height [expr ($y2-$y1)] -width [expr ($x2-$x1)] -fontmap ps_fontmap -x $x1 -y $y1 -pagex "$pm_left\i" -pagey "[expr {$page_height-$pm_top}]\i" -pageanchor nw]
        }
        #if {[tk_messageBox -title [mc "Printing..."] -message "[mc {Printing will occur on your default printer:\n %1$s} [exec lpstat -d]]" -type okcancel -default ok -parent [winfo toplevel $c]] == "ok"} {
        #  exec lpr << [$c postscript -height [expr ($y2-$y1)] -width [expr ($x2-$x1)] -x $x1 -y $y1]
        #}
      }
    }
  } else {
    warning_dialog "Printing isn't available from non-windows or -unix"
    canvas_save $c
  }
}

##############
## print a text window- windows uses printer extension, aqua uses maccarbonprint extension, UNIX uses postscript
##############
proc print_text {t} {
  global ps_fontmap info

  #get the default font of the widget
  set print_font_size [font actual [$t cget -font] -size]
  set print_font [list [font actual [$t cget -font] -family] [font actual [$t cget -font] -size]]
  set char_x [expr {[font measure $print_font W]}]

  #find the widest line
  set max_chars_per_line 0
  for {set i 1} {[$t compare $i.0 < end]} {incr i} {
    if {[set lineend [regsub {[0-9]*\.} [$t index $i.0lineend] ""]] > $max_chars_per_line} {
      set max_chars_per_line $lineend
    }
  }

  #get list of text tags with colored background for color printing
  set bg_formatted_tags [list]
  if {$info(print_formatted)} {
    foreach tag [$t tag names] {
      if {([$t tag cget $tag -background] != "") && ($tag ne "sel")} {
        lappend bg_formatted_tags $tag
      }
    }
  }

  if {[tk windowingsystem] == "win32"} {
    set page_width 8500
    set page_height 11000
    set pm_left 1000
    set pm_right 1000
    set pm_top 1000
    set pm_bottom 1000
    set ppi_x 1000
    set ppi_y 1000
    set attr_list [printer attr]
    foreach attr $attr_list {
      switch -exact [lindex $attr 0] {
        "page dimensions" {
          set page_width [lindex [lindex $attr 1] 0]
          set page_height [lindex [lindex $attr 1] 1]
        }
        "page margins" {
          set pm_left [lindex [lindex $attr 1] 0]
          set pm_top [lindex [lindex $attr 1] 1]
          set pm_right [lindex [lindex $attr 1] 2]
          set pm_bottom [lindex [lindex $attr 1] 3]
        }
        "pixels per inch" {
          set ppi_x [lindex [lindex $attr 1] 0]
          set ppi_y [lindex [lindex $attr 1] 1]
        }
      }
    }

    #shrink the font size until it fits within the horizontal margins
    set print_width [expr {int(($page_width-$pm_left-$pm_right)/1000.0)}]
    set line_width [expr {int($max_chars_per_line*$char_x/([tk scaling]*72.0))}]
    while {($line_width > $print_width) && ($print_font_size > 5)} {
      incr print_font_size -1
      set print_font [list [font actual [$t cget -font] -family] $print_font_size]
      set char_x [expr {[font measure $print_font W]}]
      set line_width [expr {int($max_chars_per_line*$char_x/([tk scaling]*72.0))}]
    }

    #define the character height
    set char_y [expr {int([font metrics $print_font -linespace])}]
    set char_mid_y [expr {int([font metrics $print_font -linespace]/2)}]


    #count the lines/page so we can determine how many pages we will print (this might be wrong if the page orientation is changed in the dialog)
    set lines_per_page [expr {int((($page_height-$pm_top-$pm_bottom)/1000.0)/($char_y/([tk scaling]*72)))}]
    set total_pages [expr {int(ceil(([$t index end]-1)/$lines_per_page))}]

    if {[set print_parameters [windows_print_dialog [list 1 $total_pages]]] != ""} {
      #START PRINTING here
      foreach {hDC page_width page_height pm_left pm_top pm_right pm_bottom ppi_x ppi_y first_page last_page copies spool_copies print_flag} $print_parameters {}

      #reset the lines/page and total pages after getting possibly new printer margin info
      set print_width [expr {int(($page_width-$pm_left-$pm_right)/1000.0)}]
      set line_width [expr {int($max_chars_per_line*$char_x/([tk scaling]*72.0))}]
      while {($line_width > $print_width) && ($print_font_size > 5)} {
        incr print_font_size -1
        set print_font [list [font actual [$t cget -font] -family] $print_font_size]
        set char_x [expr {[font measure $print_font W]}]
        set line_width [expr {int($max_chars_per_line*$char_x/([tk scaling]*72.0))}]
      }
      set lines_per_page [expr {int((($page_height-$pm_top-$pm_bottom)/1000)/($char_y/([tk scaling]*72)))}]
      set total_pages [expr {int(ceil(([$t index end]-1)/$lines_per_page))}]
      switch $print_flag {
        all {
          set first_line 1
          set last_line [expr {int([$t index end]-1)}]
        }
        selection {
          if {[$t tag ranges sel] != ""} {
            set first_line [expr {int([$t index sel.first\linestart])}]
            set last_line [expr {int([$t index sel.last\linestart])}]
          } else {
            set first_line 1
            set last_line [expr {int([$t index end]-1)}]
          }
        }
        pagenums {
            set first_line [expr {int((($first_page-1)*$lines_per_page)+1.0)}]
            set last_line [expr {int(($last_page)*$lines_per_page*1.0)}]
        }
      } 
      printer job -hdc $hDC start
      toplevel .printer_notifier
      #wm attributes .printer_notifier -topmost 1
      set dialogblock 1
      set bind_store [bind . <<RaiseDialogs>>]
      bind . <<RaiseDialogs>> "wm deiconify .printer_notifier; raise .printer_notifier"
      wm overrideredirect .printer_notifier 1
      wm title .printer_notifier "Printing..."
      regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry [winfo toplevel $t]] wgeom winx winy
      wm geometry .printer_notifier "+[expr (($winx<0)?0:$winx)+100]+[expr (($winy<0)?0:$winy)+100]"
      pack [frame .printer_notifier.frame -relief ridge -bd 3 -width 200]      
      pack [label .printer_notifier.frame.message -text "" -width 50 -height 4]
      for {set copies_spooled 1} {$copies_spooled <= $spool_copies} {incr copies_spooled} {
        for {set next_line $first_line} {$next_line <= $last_line} {set next_line [expr {$next_line+$lines_per_page}]} {
          if {[expr {$next_line+$lines_per_page-1}] > $last_line} {
            set last_page_line $last_line
          } else {
            set last_page_line [expr {$next_line+$lines_per_page-1}]
          }
          set line_top_y 0
          set line_mid_y $char_mid_y
          set line_bottom_y [expr {$char_y-1}]
          for {set copies_printed 1} {$copies_printed <= $copies} {incr copies_printed} {
            if {$copies == 1} {
              if {$spool_copies == 1} {
                .printer_notifier.frame.message configure -text "Printing page [expr {$next_line/$lines_per_page+1}] of [expr {int(1.0*$last_line/$lines_per_page+0.5)}]."
              } else {
                .printer_notifier.frame.message configure -text "Printing page [expr {$next_line/$lines_per_page+1}] of [expr {int(1.0*$last_line/$lines_per_page+0.5)}], copy $copies_spooled of $spool_copies."
              } 
            } else {
                .printer_notifier.frame.message configure -text "Printing page [expr {$next_line/$lines_per_page+1}] of [expr {int(1.0*$last_line/$lines_per_page+0.5)}], copy $copies_printed of $copies."
            }
            update
            printer page -hdc $hDC start
            gdi map $hDC -logical [expr {(([tk scaling]*72))}] -physical $ppi_x -offset [list [expr {int(($pm_left* $ppi_x / 1000))}] [expr {int(($pm_top* $ppi_x / 1000))}]]
            for {set current_line $next_line} {$current_line <= $last_page_line} {incr current_line} {
              if {$info(print_formatted)} {
                foreach colorblock [get_text_line_props $t $current_line $bg_formatted_tags] {
                  foreach {color start end} $colorblock {
                    gdi rectangle $hDC [expr {$start*$char_x}] $line_top_y [expr {($end*$char_x)}] [expr {$line_bottom_y}] -fill $color -outline $color 
                  }
                }
                for {set i 0} {[$t compare $current_line.$i < $current_line.0\lineend]} {incr i} {
                  #foreach {font bg} [get_text_chraracter_props $t $current_line.$i] {
                  #  if {$bg != {}} {
                  #    gdi rectangle $hDC [expr {$i*$char_x}] $line_top_y [expr {(($i+1)*$char_x)}] [expr {$line_bottom_y}] -fill $bg -outline $bg 
                  #  }
                  #  if {$font == {}} {
                  #    set font $print_font
                  #  }
                  #}
                  set font $print_font
                  gdi text $hDC [expr {($i*$char_x+$char_x/2)}] $line_mid_y -text [$t get $current_line.$i] -font $font -anchor center -justify left
                }
              } else {
                gdi text $hDC 0 $line_mid_y -text [$t get $current_line.0 $current_line.0\lineend] -font $print_font -anchor w -justify left
              }

              incr line_top_y $char_y
              incr line_mid_y $char_y
              incr line_bottom_y $char_y
            }
            printer page -hdc $hDC end
          }
        }
      }
      printer job -hdc $hDC end
      printer close -hdc $hDC
      destroy .printer_notifier
      set dialogblock 0
      bind . <<RaiseDialogs>> $bind_store
    }
  } elseif {[tk windowingsystem] == "aqua"} {

    if  {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] > -1)} {
    ########Aqua native printing
      global info
      set pf [eval {::maccarbonprint::pagesetup -dialog 0} $info(aqua_page_setup)]
      array set optsArr [maccarbonprint::pageformatconfigure $pf]
 #sputs :pageformatconfigure:
      #foreach o [array names optsArr] {
      #  sputs $o $optsArr($o)
      #}
      foreach {pageX pageY page_width page_height} $optsArr(-adjustedpagerect) {}
      foreach {paperX paperY paper_width paper_height} $optsArr(-adjustedpaperrect) {}
      if {[llength [set resol $optsArr(-resolution)]]==1} {
        set ppi_x $resol
        set ppi_y $resol
      } else {
        foreach {ppi_x ppi_y} $resol {}
      }

      #shrink the font size until it fits within the horizontal margins
      set print_width [expr {(1.0*$page_width/$ppi_x)}]
      set line_width [expr {($max_chars_per_line*$char_x/([tk scaling]*72.0))}]
      while {($line_width > $print_width) && ($print_font_size > 5)} {
        incr print_font_size -1
        set print_font [list [font actual [$t cget -font] -family] $print_font_size]
        set char_x [expr {([font measure $print_font W])}]
        set line_width [expr {($max_chars_per_line*$char_x/([tk scaling]*72.0))}]
      }
if {$print_font_size <= 5} {
sputs print size at minimum: 5pt
}
      #define the character height
      set char_y [expr {int([font metrics $print_font -linespace])}]
      set char_mid_y [expr {int([font metrics $print_font -linespace]/2)}]


      #count the lines/page so we can determine how many pages we will print (this might be wrong if the page orientation is changed in the dialog)
      set lines_per_page [expr {int((($page_height)/$ppi_y)/($char_y/([tk scaling]*72.0)))}]
      set total_pages [expr {int(ceil(([$t index end]-1.0)/$lines_per_page))}]
#sputs font:$print_font x:$char_x y:char_y lines/page:$lines_per_page pages:$total_pages
      if {[set print_parameters [aqua_print_dialog [winfo toplevel $t] [list 1 $total_pages]]] != ""} {

        foreach {printObj printtype page_width page_height ppi_x ppi_y copies first_page last_page} $print_parameters {}
#sputs printObj: $printObj
        #reset vertical scaling in case the ppi_y has changed
        set lines_per_page [expr {int((($page_height)/$ppi_y)/($char_y/([tk scaling]*72)))}]
        set total_pages [expr {int(ceil(([$t index end]-1)/$lines_per_page))}]

        set first_line [expr {int (($first_page-1)*$lines_per_page)+1}]
        set last_line [expr {int (($last_page)*$lines_per_page*1)}]
        set scale [expr {$ppi_x/([tk scaling]*72)}]
#sputs $first_line $last_line $scale
        if {![catch {::maccarbonprint::opendoc $printObj 1 [expr {($last_page-$first_page+1)*$copies}]} errMsg]} {
          #bug? takes care of printing the copies already
          set copies 1
          for {set j 0} {$j < $copies} {incr j} {
            #Print a document copy
            set next_line $first_line
            while {$next_line <= $last_line} {
              if {[expr {$next_line+$lines_per_page-1}] > $last_line} {
                set last_page_line $last_line
              } else {
                set last_page_line [expr {$next_line+$lines_per_page-1}]
              }
              #Print page
              if {![catch {set win [::maccarbonprint::openpage $printObj -scale $scale]}]} {
                set line_top_y 0
                set line_mid_y $char_mid_y
                set line_bottom_y [expr {$char_y-1}]
                for {set current_line $next_line} {$current_line <= $last_page_line} {incr current_line} {
#sputs lines:$current_line $next_line $last_page_line
                  if {$info(print_formatted)} {
                    foreach colorblock [get_text_line_props $t $current_line $bg_formatted_tags] {
                      foreach {color start end} $colorblock {
                        $win create rectangle [expr {-$paperX+$start*$char_x}] [expr {-$paperY+$line_top_y}] [expr {-$paperX+$end*$char_x}] [expr {-$paperY+$line_bottom_y}] -fill $color -outline $color 
                      }
                    }
                    for {set i 0} {[$t compare $current_line.$i < $current_line.0\lineend]} {incr i} {
                      #foreach {font bg} [get_text_chraracter_props $t $current_line.$i] {
                      #  if {$bg != {}} {
                      #    $win create rectangle [expr {$i*$char_x}] $line_top_y [expr {($i+1)*$char_x}] $line_bottom_y -fill $bg -outline $bg 
                      #  }
                      #  if {$font == {}} {
                      #    set font $print_font
                      #  }
                      #}
                      set font $print_font
                      $win create text [expr {-$paperX+$i*$char_x+$char_x/2}] [expr {-$paperY+$line_mid_y}] -text [$t get $current_line.$i] -font $font -anchor center -justify left
                    }
                  } else {
                    $win create text [expr {-$paperX+$char_x/2}] [expr {-$paperY+$line_mid_y}] -text [$t get $current_line.0 $current_line.0\lineend] -font $print_font -anchor w -justify left
                  }

                  incr line_top_y $char_y
                  incr line_mid_y $char_y
                  incr line_bottom_y $char_y
                }
                catch {::maccarbonprint::closepage $printObj}
              }
              set next_line [expr {$next_line+$lines_per_page}]
            }
          }
         catch {::maccarbonprint::closedoc $printObj}
        }
      }
    } else {
      #####non-aqua unix printing
    }
  } else {
    warning_dialog "Printing isn't available from non-windows or -unix"
  }
}

############
## Return font and bg color for an index of a text window 
############
proc get_text_chraracter_props {text index} {
  set font {}
  set char_bg {}
  foreach tag [$text tag names $index] {
    if {($tag ne "dnatag") && ($tag ne "sel")} {
      #if {$font == {}} {set font [$text tag cget $tag -font]}
      set bg [$text tag cget $tag -background]
      if {$bg != {}} {
        set char_bg $bg
      }
    }
  }
  return [list $font $char_bg]
}

############
## Return list of colors and indices with that color for a row of a text window 
############
proc get_text_line_props {text line tags} {
  set result [list]
  foreach tag $tags {
    set i $line.0
    while {([set indexes [$text tag nextrange $tag $i $line.end]] != "")} {
      set i [lindex $indexes 1]
      lappend result [list [$text tag cget $tag -background] [regsub {[0-9]*\.} [lindex $indexes 0] ""] [regsub {[0-9]*\.} $i ""]]
    }
  }
  return $result
}

##############
## display printer dialog in windows
## return $hDC $page_width $page_height $pm_left $pm_top $pm_right $pm_bottom $ppi_x $ppi_y $copies
## return {} and close printer if no print connection is established
##############
proc windows_print_dialog {{pagerange {1 1}}} {
  if  {([lsearch -exact [package names] "printer"] > -1)} {
    set minimum_page [lindex $pagerange 0]
    set maximum_page [lindex $pagerange 1]
    printer attr -set [list [list "first page" $minimum_page] [list "last page" $maximum_page] [list "maximum page" $maximum_page] [list "minimum page" $minimum_page]]
    set hDC [printer dialog select]
    if { [lindex $hDC 1] == 0 } {
    # User has canceled printing
      catch {printer close}
	return {}
    }
    set hDC [lindex $hDC 0]
    if {[string match "?" $hDC] || [string match 0x0 $hDC]} {
      catch {printer close}
      tk_messageBox -title [mc "Printer problem"] -message [mc "Problem opening printer: printer context cannot be established"] -type ok
      return {}
    }
    set page_width 8500
    set page_height 1100
    set pm_left 1000
    set pm_top 1000
    set pm_right 1000
    set pm_bottom 1000
    set ppi_x 1000
    set ppi_y 1000
    set first_page 1
    set last_page 1
    set spool_copies 1
    set copies 1
    set print_flag "all"
    set attr_list [printer attr]
    foreach attr $attr_list {
      switch -exact [lindex $attr 0] {
        "page dimensions" {
          set page_width [lindex [lindex $attr 1] 0]
          set page_height [lindex [lindex $attr 1] 1]
        }
        "page margins" {
          set pm_left [lindex [lindex $attr 1] 0]
          set pm_top [lindex [lindex $attr 1] 1]
          set pm_right [lindex [lindex $attr 1] 2]
          set pm_bottom [lindex [lindex $attr 1] 3]
        }
        "pixels per inch" {
          set ppi_x [lindex [lindex $attr 1] 0]
          set ppi_y [lindex [lindex $attr 1] 1]
        }
        "first page" {
          set first_page [lindex $attr 1]
        }
        "last page" {
          set last_page [lindex $attr 1]
          if {$last_page > $maximum_page} {
            set last_page $maximum_page
          }
        }
        "copiesToSpool" {
          set spool_copies [lindex $attr 1]
        }
        "copies" {
          set copies [lindex $attr 1]
        }
        "print flag" {
          set print_flag [lindex $attr 1]
        }
      }
    }
    return [list $hDC $page_width $page_height $pm_left $pm_top $pm_right $pm_bottom $ppi_x $ppi_y $first_page $last_page $copies $spool_copies $print_flag]
  } else {
    tk_messageBox -title [mc "Printer problem"] -message [mc "Problem opening printer: printer dll is not loaded"] -type ok
    return {}
  }
}

##############
## display printer dialog in MacCarbon (Aqua)
## return $printerObject $type $page_width $page_height $ppi_x $ppi_y $copies
## return {} and close printer if no print connection is established
##############
proc aqua_print_dialog {w {pagerange {1 1}}} {
  global info

#sputs $w $pagerange $info(aqua_page_setup)
  if {[set printlist [eval {::maccarbonprint::print -parent $w -pagerange $pagerange -copies 1} $info(aqua_page_setup)]] != {}} {
    set type [lindex $printlist 0]
    set printObj [lindex $printlist 1]
    array set optsArr [::maccarbonprint::printconfigure $printObj]
    #sputs dialog-printconfigure
    #foreach o [array names optsArr] {
    #  sputs $o $optsArr($o)
    #}

    foreach {pageX pageY pagewidth pageheight} $optsArr(-adjustedpagerect) {}

    if {[llength [set resol $optsArr(-resolution)]]==1} {
      set ppi_x $resol
      set ppi_y $resol
    } else {
      foreach {ppi_x ppi_y} $resol {}
    }

    if {[set last_page $optsArr(-lastpage)] > [lindex $pagerange 1]} {
      set last_page [lindex $pagerange 1]
    }

    return [list $printObj $type $pagewidth $pageheight $ppi_x $ppi_y $optsArr(-copies) $optsArr(-firstpage) $last_page]
  } else {
    return ""
  }
}

##############
## display printer setup dialog in Aqua
##############
proc page_setup_dialog {w} {
  global info
  if  {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] > -1)} {
    set pf [eval {::maccarbonprint::pagesetup -parent $w} $info(aqua_page_setup)]
    if {$pf != ""} {
      set info(aqua_page_setup) [list -pageformat $pf]
    }
  } elseif {([lsearch -exact [package names] "printer"] > -1)} {
    printer dialog page_setup
  }
}

##############
## display printer dialog in unix
## return $printer $page_width $page_height $pm_left $pm_top $pm_right $pm_bottom $ppi_x $ppi_y $copies
## return {} and close printer if no print connection is established
##############
proc unix_print_dialog {w} {
  global ok dialogblock info tcl_platform
  global printer orient scale copies
  if {$tcl_platform(platform) != "unix"} {
    set prlist [list printer1 printer2 printer3]
    set defaultprinter printer2
  } else {
    if {([catch {set lplist [exec lpstat -a]}]) || ($lplist == "")} {return "no_lplist"}
    set lplist [split $lplist \n]
    foreach lp $lplist {
      puts $lp
      if {![regexp "not accepting" $lp]} {
        lappend prlist [regexp -inline {[^ ]*} $lp]
      }
    }
    if {([catch {set defaultprinter [exec lpstat -d]}]) || ([regexp "no system default" $defaultprinter])}  {return "no_default"}
    set defaultprinter [regexp -inline {[^ ]*$} $defaultprinter]
  }

  if {$dialogblock == 1} {return "dialogblock"}
  set dialogblock 1
  set a [toplevel .dialog]
  wm title $a [mc "Printer..."]
  wm protocol $a WM_DELETE_WINDOW "set ok -1"
  set oldbind [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify $a; raise $a"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $a "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $a $w
  } else {
    ::tk::unsupported::MacWindowStyle style $a document {closeBox}
  }
  set ok 0
  set page_width 8.500
  set page_height 11.00
  set pm_left 1.0
  set pm_top 1.0
  set pm_right 1.0
  set pm_bottom 1.0
  set ppi_x 1000
  set ppi_y 1000
  set copies 1
  set orient portrait
  set scale 100
  set printer $defaultprinter


  grid [frame $a.frame1 -relief flat] -row 0 -column 0 -sticky nswe
  grid [label $a.frame1.label1 -text [mc "Printer:"]] -row 0 -column 0 -sticky e
  set printer_menu [eval "tk_optionMenu $a.frame1.printer printer $prlist"]
  grid $a.frame1.printer -row 0 -column 1 -sticky nw -columnspan 2
  grid [label $a.frame1.label2 -text [mc "Orientation:"]] -row 1 -column 0 -sticky e
  set orientmenu [tk_optionMenu $a.frame1.orient orient portrait landscape]
  grid $a.frame1.orient -row 1 -column 1 -sticky nw -columnspan 2
  #grid [label $a.frame1.label3 -text [mc "Scale:"]] -row 2 -column 0 -sticky e
  #set scalemenu [tk_optionMenu $a.frame1.scale scale 10 20 30 40 50 60 70 80 90 100]
  #grid $a.frame1.scale -row 2 -column 1 -sticky nw
  #grid [label $a.frame1.label4 -text "%"] -row 2 -column 2 -sticky w
  #grid [label $a.frame1.label5 -text [mc "Copies:"]] -row 3 -column 0 -sticky e
  #grid [entry $a.frame1.copies -textvariable copies -width 2 -validate key -validatecommand "string is integer %P"] -row 3 -column 1 -sticky nw -columnspan 2


  grid [frame $a.frame2 -relief flat] -row 1 -column 0 -sticky nswe
  grid [button .dialog.frame2.ok -text [mc "OK"] -command "set ok 1" -default active] -row 0 -column 0 -padx 10 -pady 3 -sticky we
  bind .dialog <Key-Return> "set ok 1"
  grid [button .dialog.frame2.cancel -text [mc "Cancel"] -command "set ok -1"] -row 0 -column 1 -padx 5 -sticky we
  grid rowconfigure .dialog 0 -weight 1
  grid rowconfigure .dialog 1 -weight 0
  grid rowconfigure .dialog 2 -weight 0
  grid columnconfigure .dialog 0 -weight 1

  if {[tk windowingsystem] == "aqua"} {
    foreach button [list .dialog.frame2.ok .dialog.frame2.cancel] {
      grid configure $button -sticky n
      update
      grid configure $button -sticky ne
    }
  }

  vwait ok
  set dialogblock 0
  destroy .dialog
  bind . <<RaiseDialogs>> $oldbind
  if {$ok == 1} {
    if {[catch {set optionlist [exec lpoptions -p $printer -l]}]} {
      set optionlist ""
    } else {
      foreach attr [split $optionlist \n] {
        set attr [split $attr :]
        switch -regexp [lindex $attr 0] {
          "Resolution" {
            regexp {\*([0-9]*)x([0-9]*)} [lindex $attr 1] i ppi_x ppi_y
           }
        }
      }
    }
    set scale [expr {$scale/100.0}]
    puts "printer $printer optionlist:$optionlist"
    set result [list $printer $page_width $page_height $pm_left $pm_top $pm_right $pm_bottom $ppi_x $ppi_y $copies $orient $scale]
    unset printer orient scale copies
    return $result
  } else {
    return "cancel"
  }
}

##############
## save or copy to clipboard a canvas to wmf or emf format
##############
proc canvas_to_metafile {operation c {type both}} {
  set hDCname [wmf open]
  set hDC [hdc addr $hDCname]
  canvas_to_hdc $c $hDC 0
  set emf_file [wmf close $hDCname ]
  if {$operation == "copy"} {
    wmf copy $emf_file -type $type
  } else {
    set filename [tk_getSaveFile -defaultextension ".emf" -title [mc "Save Enhanced Metafile..."] -parent [winfo toplevel $c]]
    if {$filename != ""} {
      wmf copy $emf_file -file $filename
    }
  }
  wmf delete $emf_file
}

##############
## print a canvas to an hDC (device context handle) for windows printing and metafile output
##############
proc canvas_to_hdc {c hdc {bug_workaround 1}} {
  foreach item [$c find all] {
    if {[$c itemcget $item -state] == "hidden"} {
      continue
    }
    set coords [$c coords $item]

    switch [$c type $item] {
      arc {
        if {!$bug_workaround} {
          set cmd  "gdi arc $hdc $coords -extent [$c itemcget $item -extent] -outline {[$c itemcget $item -outline]} -start [$c itemcget $item -start] -style [$c itemcget $item -style]"
          if {[set width  [$c itemcget $item -width]] > 1} {set cmd "$cmd -width $width"}
          #sputs $cmd
        } else {
          #this is for bug in the gdi implementation- it might not be needed in wmf copies
          set x0 [expr {([lindex $coords 0]+[lindex $coords 2])/2.0}]
          set y0 [expr {([lindex $coords 1]+[lindex $coords 3])/2.0}]
          set xr [expr {[lindex $coords 2]-$x0}]
          set yr [expr {[lindex $coords 3]-$y0}]
          set start_angle [$c itemcget $item -start]
          set stop_angle [expr {[$c itemcget $item -extent]+$start_angle}]
          if {$stop_angle < $start_angle} {
            set a $start_angle
            set start_angle $stop_angle
            set stop_angle $a
          }
          set deg2rad [expr {3.14159/180}]
          set start_angle [expr {$deg2rad*$start_angle}]
          set stop_angle [expr {$deg2rad*$stop_angle}]
          set incr [expr {$deg2rad*2.5}]
          set coords [list [expr {$x0+cos($start_angle)*$xr}] [expr {$y0-sin($start_angle)*$yr}]]
          for {set a $start_angle} {$a <$stop_angle} {set a [expr {$a+$incr}]} {
            lappend coords [expr {$x0+cos($a)*$xr}] [expr {$y0-sin($a)*$yr}]
          }
          lappend coords [expr {$x0+cos($stop_angle)*$xr}] [expr {$y0-sin($stop_angle)*$yr}]
          set cmd  "gdi line $hdc $coords -fill {[$c itemcget $item -outline]}"
          if {[set width  [$c itemcget $item -width]] > 1} {
            set cmd "$cmd -width $width"
          }
        }
      } 
      bitmap {
        #sputs "No handler for item type: Bitmap"
      }
      image {
        #sputs "No handler for item type: Image"
      }
      line {
        set cmd  "gdi line $hdc $coords -fill {[$c itemcget $item -fill]}"
        if {[set width  [$c itemcget $item -width]] > 1} {set cmd "$cmd -width $width"}
      }
      oval {
        set cmd "gdi oval $hdc $coords -outline [$c itemcget $item -outline]"
        if {[set width  [$c itemcget $item -width]] > 1} {set cmd "$cmd -width $width"}
        #sputs $cmd
      }
      polygon {
        set cmd "gdi polygon $hdc $coords -width [$c itemcget $item -width]"
        if {[set outline [$c itemcget $item -outline]] != ""} {set cmd "$cmd  -outline {$outline}"}
      }
      rectangle {
        set cmd "gdi rectangle $hdc $coords -outline {[$c itemcget $item -outline]}"
        if {[set width  [$c itemcget $item -width]] > 1} {set cmd "$cmd -width $width"}
      }
      text {
        if {[$c itemcget $item -text] != ""} {
          set font [$c itemcget $item -font]
          #set font [list [font configure $font -family]  -[font configure $font -size]]
          set font [list [font actual $font -family] [expr {int([font actual $font -size]*[tk scaling])}] [font actual $font -weight] [font actual $font -slant]]
          set bbox [$c bbox $item]
          #set width [expr {[lindex $bbox 2] - [lindex $bbox 0]+2}]
          set width [font measure $font [$c itemcget $item -text]]
          set cmd "gdi text $hdc $coords -text [list [$c itemcget $item -text]] \
		-anchor [$c itemcget $item -anchor] -font [list $font] \
		-width $width -justify [$c itemcget $item -justify]"
        } else {
          set cmd ""
        }
      }
      window {
        #sputs "No handler for item type: Window"
      }
      default {
        #sputs "No handler for item type:[$c type $item]"
      }
    }

    if {([set fill [$c itemcget $item -fill]] != "") && ($cmd !="")} {set cmd "$cmd -fill $fill"}
    eval $cmd
  }
}

##############
## print a canvas to a printer window for Aqua printing
##############
proc canvas_to_carbonprint {c win scale} {
  foreach item [$c find all] {
    if {[$c itemcget $item -state] == "hidden"} {
      continue
    }
    switch [$c type $item] {
      text {
        if {[$c itemcget $item -text] != ""} {
          set font [$c itemcget $item -font]
          set font [list [font actual $font -family] [expr {int([font actual $font -size]*[tk scaling]*$scale)}] [font actual $font -weight] [font actual $font -slant]]
          set bbox [$c bbox $item]
          set width [font measure $font [$c itemcget $item -text]]
          eval {$win create text} [$c coords $item] -text [list [$c itemcget $item -text]] -anchor [$c itemcget $item -anchor] -font [list $font] -justify [$c itemcget $item -justify] -fill [$c itemcget $item -fill]
        }
      }
      arc {
        set opts {}
        foreach option [$c itemconfigure $item] {
          foreach {key blank blank2 def val} $option {}
          if {![string equal $def $val]} {
            lappend opts $key $val
          }
        }
        eval {$win create [$c type $item]} [$c coords $item] $opts
      }
      window {
        #sputs "No handler for item type: Window"
      }
      default {
        set opts {}
        foreach option [$c itemconfigure $item] {
          foreach {key blank blank2 def val} $option {}
          if {![string equal $def $val]} {
            lappend opts $key $val
          }
        }
        eval {$win create [$c type $item]} [$c coords $item] $opts
      }
    }
  }
}

##############
## generate a canvas from a simple text box
##############
proc text_to_canvas {t c {x0 2} {y0 2}} {
  set i 1
  set x $x0
  set y $y0
  set font [$t cget -font]
  set linespace [font metrics [$t cget -font] -linespace]
  while {$i < [$t index end]} {
    $c create text $x $y -text [$t get $i.0 $i.0lineend] -anchor nw -font $font
    incr i
    incr y $linespace 
  }
}

##############
## save text analysis as text
##############
proc text_save {t {filename {}}} {
global info
  while { (![file isdirectory $info(default_dnadir)])} {
    set info(default_dnadir) [file dirname $info(default_dnadir)]
    if {[file dirname $info(default_dnadir)] == $info(default_dnadir)} {
      set info(default_dnadir) [valid_default_dir]
    }
  }
  if {$filename == ""} {
    set filename [tk_getSaveFile -title [mc "Save As Text File"] -initialdir $info(default_dnadir) -defaultextension ".rtf"]
  }
  while {($filename != "") && ([catch {set text_file [open $filename w]}])} {
    catch {close $text_file}
    tk_messageBox -title "Text File not Writable" -message "The file \"$filename\" is not writable. It may be locked." -type ok -icon warning -default ok
    set filename [tk_getSaveFile -title "Save As Text File" -initialdir $info(default_dnadir) -defaultextension ".txt"]
  }
  if {$filename != ""} {
    ###save the text file
    if {[file extension $filename] eq ".rtf"} {
      puts -nonewline $text_file [text_to_rtf $t 1]
    } elseif {[file extension $filename] eq ".svg"} {
      set lastline [$t index end]
      if {[regexp {[0-9]+} $lastline lastline]} {
        puts -nonewline $text_file [seq_to_svg $t 1 $lastline]
      }
    } else {
      set i 1
      while {$i < [$t index end]} {
        puts $text_file [$t get $i.0 $i.0lineend]
        incr i
      }
    }
    close $text_file
  }
}

##############
## convert named color to svg rgb value
##############
proc color_to_svgrgb {color} {
    if {$color == ""} {return none}
    foreach {r g b} [winfo rgb . $color] {}
    format #%02x%02x%02x [expr {$r/256}] [expr {$g/256}] [expr {$b/256}]
}

proc color_to_keysvgrgb {color} {
    if {$color == ""} {return none}
    foreach {r g b} [winfo rgb . $color] {}
    return "[expr {$r/65536.0}] [expr {$g/65536.0}] [expr {$b/65536.0}]"
}

##############
## print a canvas to an svg string
##############
proc canvas_to_svg {c} {
  
  set result "<svg  xmlns=\"http://www.w3.org/2000/svg\" version=\"1.1\" preserveAspectRatio=\"xMidYMid meet\" viewBox=\"[lindex [$c bbox all] 0] [lindex [$c bbox all] 1] [expr {[lindex [$c bbox all] 2] - [lindex [$c bbox all] 0]}] [expr {[lindex [$c bbox all] 3] - [lindex [$c bbox all] 1]}]\">\n"
  foreach item [$c find all] {
    if {[$c itemcget $item -state] == "hidden"} {
      continue
    }
    set coords [$c coords $item]
    set deg2rad [expr {3.14159/180}]

    switch [$c type $item] {
      arc {
        set x0 [expr {([lindex $coords 0]+[lindex $coords 2])/2.0}]
        set y0 [expr {([lindex $coords 1]+[lindex $coords 3])/2.0}]
        set xr [expr {[lindex $coords 2]-$x0}]
        set yr [expr {[lindex $coords 3]-$y0}]
        set start_angle [$c itemcget $item -start]
        set stop_angle [expr {[$c itemcget $item -extent]+$start_angle}]
        if {$stop_angle < $start_angle} {
          set a $start_angle
          set start_angle $stop_angle
          set stop_angle $a
        }

        set start_angle [expr {$deg2rad*$start_angle}]
        set stop_angle [expr {$deg2rad*$stop_angle}]

        set mcoords "[expr {$x0+cos($start_angle)*$xr}],[expr {$y0-sin($start_angle)*$yr}]"
        set ecoords "[expr {$x0+cos($stop_angle)*$xr}],[expr {$y0-sin($stop_angle)*$yr}]"

        set cmd "<path d=\"M $mcoords A$xr,$yr 0 [expr {(abs([$c itemcget $item -extent])>180)?1:0}] 0 $ecoords\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_svgrgb [$c itemcget $item -outline]]\" fill=\"[color_to_svgrgb [$c itemcget $item -fill]]\"/>\n"
      } 
      bitmap {
        #sputs "No handler for item type: Bitmap"
        set cmd ""
      }
      image {
        #sputs "No handler for item type: Image"
        set cmd ""
      }
      line {
        if {[llength $coords] == 4} {
          set cmd "<line x1=\"[lindex $coords 0]\" y1=\"[lindex $coords 1]\" x2=\"[lindex $coords 2]\" y2=\"[lindex $coords 3]\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_svgrgb [$c itemcget $item -fill]]\"/>\n"
        } else {
          set cmd "<polyline points=\"$coords\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_svgrgb [$c itemcget $item -fill]]\" fill=\"none\"/>\n"
        }
      }
      oval {
          set cmd "<ellipse cx=\"[expr {([lindex $coords 2]+[lindex $coords 0])/2.0}]\" cy=\"[expr {([lindex $coords 3]+[lindex $coords 1])/2.0}]\" rx=\"[expr {([lindex $coords 2]-[lindex $coords 0])/2.0}]\" ry=\"[expr {([lindex $coords 3]-[lindex $coords 1])/2.0}]\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_svgrgb [$c itemcget $item -outline]]\" fill=\"[color_to_svgrgb [$c itemcget $item -fill]]\"/>\n"
      }
      polygon {
          set cmd "<polygon points=\"$coords\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_svgrgb [$c itemcget $item -outline]]\" fill=\"[color_to_svgrgb [$c itemcget $item -fill]]\"/>\n"

      }
      rectangle {
          set cmd "<rect x=\"[lindex $coords 0]\" y=\"[lindex $coords 1]\" width=\"[expr {[lindex $coords 2]-[lindex $coords 0]}]\" height=\"[expr {[lindex $coords 3]-[lindex $coords 1]}]\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_svgrgb [$c itemcget $item -outline]]\" fill=\"[color_to_svgrgb [$c itemcget $item -fill]]\"/>\n"
      }
      text {
        set font [$c itemcget $item -font]
        if {[$c itemcget $item -text] != ""} {
          set bbox [$c bbox $item]
          set txt [string map {> &#62; < &#60; \" &#34; & &#38;} [$c itemcget $item -text]]
          set cmd "<text x=\"[lindex $bbox 0]\" y=\"[lindex $bbox 3]\" font-weight=\"[font actual $font -weight]\" font-style=\"[font actual $font -slant]\" font-family=\"[font actual $font -family]\" font-size=\"[expr {round([tk scaling]*[font actual $font -size]*10)/10.0}]\" fill=\"[color_to_svgrgb [$c itemcget $item -fill]]\" >$txt</text>\n"
        } else {
          set cmd ""
        }
      }
      window {
        #sputs "No handler for item type: Window"
        set cmd ""
      }
      default {
        #sputs "No handler for item type:[$c type $item]"
        set cmd ""
      }
    }
    append result $cmd
  }
  append result "</svg>\n"
  return $result
}

##############
## print a canvas to a keynote simplified svg string
##############
proc canvas_to_keysvg {c} {
  ##arc and oval items, figure out group transformations, move all to +200 200, move text items to anchors
  set result ""
  set deg2rad [expr {3.14159/180}]

  foreach item [$c find all] {

    if {[$c itemcget $item -state] == "hidden"} continue
    set coords [$c coords $item]
    switch [$c type $item] {
      arc {
        set x0 [expr {([lindex $coords 0]+[lindex $coords 2])/2.0}]
        set y0 [expr {([lindex $coords 1]+[lindex $coords 3])/2.0}]
        set xr [expr {[lindex $coords 2]-$x0}]
        set yr [expr {[lindex $coords 3]-$y0}]
        set start_angle [$c itemcget $item -start]
        set stop_angle [expr {[$c itemcget $item -extent]+$start_angle}]
        if {$stop_angle < $start_angle} {
          set a $start_angle
          set start_angle $stop_angle
          set stop_angle $a
        }

        set start_angle [expr {$deg2rad*$start_angle}]
        set stop_angle [expr {$deg2rad*$stop_angle}]

        set mcoords "[expr {$x0+cos($start_angle)*$xr}],[expr {$y0-sin($start_angle)*$yr}]"
        set ecoords "[expr {$x0+cos($stop_angle)*$xr}],[expr {$y0-sin($stop_angle)*$yr}]"

        set cmd "<path d=\"M $mcoords A$xr,$yr 0 [expr {(abs([$c itemcget $item -extent])>180)?1:0}] 0 $ecoords\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_keysvgrgb [$c itemcget $item -outline]]\" fill=\"[color_to_keysvgrgb [$c itemcget $item -fill]]\"/>\n"
set cmd ""
      } 
      bitmap {
        #sputs "No handler for item type: Bitmap"
        set cmd ""
      }
      image {
        #sputs "No handler for item type: Image"
        set cmd ""
      }
      line {
        if {[llength $coords] == 4} {
          set cmd "<line head=\"[lindex $coords 0] [lindex $coords 1]\" tail=\"[lindex $coords 2] [lindex $coords 3]\" stroke-width=\"[$c itemcget $item -width]\" stroke-color=\"[color_to_keysvgrgb [$c itemcget $item -fill]] 1\"> <styles> <dash-style pattern=\"solid\"/> </styles> </line>\n"
        } else {
          set coordstring "M [lindex $coords 0] [lindex $coords 1]"
          foreach {a b} [lrange $coords 2 end] {
            append coordstring  " L $a $b"
          }
          set cmd "<shape path=\"$coordstring\" stroke-width=\"[$c itemcget $item -width]\" stroke-color =\"[color_to_keysvgrgb [$c itemcget $item -fill]] 1\"> <styles> <fill-style fill-type="none"/> <dash-style pattern="none"/> </styles> </shape> \n"
        }
      }
      oval {
          set cmd "<ellipse cx=\"[expr {([lindex $coords 2]+[lindex $coords 0])/2.0}]\" cy=\"[expr {([lindex $coords 3]+[lindex $coords 1])/2.0}]\" rx=\"[expr {([lindex $coords 2]-[lindex $coords 0])/2.0}]\" ry=\"[expr {([lindex $coords 3]-[lindex $coords 1])/2.0}]\" stroke-width=\"[$c itemcget $item -width]\" stroke=\"[color_to_keysvgrgb [$c itemcget $item -outline]]\" fill=\"[color_to_keysvgrgb [$c itemcget $item -fill]]\"/>\n"
set cmd ""
      }
      polygon {
        if {[llength $coords] ==0} {set cmd ""; continue}
          set coordstring "M [lindex $coords 0] [lindex $coords 1]"
          foreach {a b} [lrange $coords 2 end] {
            append coordstring  " L $a $b"
          }
          append coordstring " Z"
          set cmd "<shape path=\"$coordstring\" "
          if {[$c itemcget $item -outline] != ""} {
            append cmd "stroke-width=\"[$c itemcget $item -width]\" stroke-color =\"[color_to_keysvgrgb [$c itemcget $item -outline]] 1\">  <styles> <fill-style fill-type=\"color\"  fill-color=\"[color_to_keysvgrgb [$c itemcget $item -fill]] 1\"/> <dash-style pattern=\"solid\"/> </styles> </shape> \n"
           } else {
             append cmd ">  <styles> <fill-style fill-type=\"color\"  fill-color=\"[color_to_keysvgrgb [$c itemcget $item -fill]] 1\"/> <dash-style pattern=\"none\"/> </styles> </shape> \n"
           }
      }
      rectangle {
          set coords [list [lindex $coords 0] [lindex $coords 1] [lindex $coords 2] [lindex $coords 1] [lindex $coords 2] [lindex $coords 3] [lindex $coords 0] [lindex $coords 3]]
          set coordstring "M [lindex $coords 0] [lindex $coords 1]"
          foreach {a b} [lrange $coords 2 end] {
            append coordstring  " L $a $b"
          }
          append coordstring " Z"
          set cmd "<shape path=\"$coordstring\" 
          if {[$c itemcget $item -outline] != ""} {
            append cmd "stroke-width=\"[$c itemcget $item -width]\" stroke-color =\"[color_to_keysvgrgb [$c itemcget $item -outline]] 1\">  <styles> <fill-style fill-type=\"color\"  fill-color=\"[color_to_keysvgrgb [$c itemcget $item -fill]] 1\"/> <dash-style pattern=\"solid\"/> </styles> </shape> \n"
           } else {
             append cmd ">  <styles> <fill-style fill-type=\"color\"  fill-color=\"[color_to_keysvgrgb [$c itemcget $item -fill]] 1\"/> <dash-style pattern=\"none\"/> </styles> </shape> \n"
           }

      }
      text {
        if {[$c itemcget $item -text] != ""} {
          set font [$c itemcget $item -font]
          set bbox [$c bbox $item]
          set cmd "<textbox size=\"[expr {[lindex $bbox 2]-[lindex $bbox 0]+10}] 1\" transformation=\"1 0.00000 0.00000 1 [lindex $bbox 0] [lindex $bbox 1]\">  <content font-name=\"[font actual $font -family]\" font-size=\"[expr {[tk scaling]*[font actual $font -size]}]\" font-color=\"[color_to_keysvgrgb [$c itemcget $item -fill]] 1\">[$c itemcget $item -text]</content> </textbox>\n"
        } else {
          set cmd ""
        }
      }
      window {
        #sputs "No handler for item type: Window"
        set cmd ""
      }
      default {
        #sputs "No handler for item type:[$c type $item]"
        set cmd ""
      }
    }
    append result $cmd
  }
  append result "\n"
  return $result
}

##############
## scans a dna window textbox and adds feature tags and metainfo 
##############
#<<Metadata>>:(0)name, (1) format info, (2) type, (3)fwd/rev, (4)annotations_string
#<<Revcolors>>: binding used for the color if the sequence is reversed
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string

proc feature_scan {w} {
  global fea_info
  global info dialogblock
  global f_scan_i
  if {$dialogblock == 1} {return}
  set dialogblock 1

  $w configure -cursor watch
  $w.textarea configure -cursor watch
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
 
  set f_scan_i 0 
  if {$info(use_tile)} {
    grid [label $w.pleasewait -width 50 -bg yellow -text "Searching for Features, Please wait..."] -row 2 -column 0  -columnspan 3  -sticky new
    grid [ttk::progressbar $w.pleasewait_prog -maximum [llength $fea_info(library)] -variable f_scan_i -orient horizontal -mode determinate] -row 3 -column 1  -sticky new
  } else {
    grid [label $w.pleasewait -width 50 -bg yellow -text "Searching for Features, Please wait..."] -row 2 -column 0  -columnspan 3  -sticky new
  }

  set temp_text [string toupper [textarea_get $w.textarea 1.0 end-1c]]
  set text_end [expr {[string length $temp_text]-1}]
  if {$info($w,circular)== "circular"} {
    set temp_text "$temp_text$temp_text"
  }

  #feature_cleanup $w.textarea

  foreach feature $fea_info(library) {
    incr f_scan_i
    update idletasks
    foreach direction [list 1 2]  {
      set start 0
      if {[lindex $feature $direction] == ""} continue
      while {[set found_list [regexp -inline -indices -start $start [string toupper [lindex $feature $direction]] $temp_text]] != ""} {
        ##when adding features, set saved to 0 (keep links to analysis windows though)
        set info($w,saved) 0
        if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}

        set start [lindex [lindex $found_list 0] 0]
        if {$start > $text_end} {break}

        ###regexp prefers the earliest starting feature, even if there is a shorter match. for features that have low information exons before a "+" this can lead to finding hundreds of copies of the feature. By reverse complementing the found region, then searching that for the revcom search pattern, a shorter match can be found. start then needs to be incremented to that new start position.
        ###compare the last found base in the forward direction to the last found base in the reverse (looking only in the region of text within the found area).
        if {([llength $found_list] > 2) && ([set rc_found [regexp -inline -indices [string toupper [lindex $feature [expr {$direction==1?2:1}]]] [revcom [string range $temp_text $start [lindex [lindex $found_list 0] end]]]]] != "")} {
          if {[set rc_dif [expr {[lindex [lindex $found_list 0] end] - [lindex [lindex $rc_found 0] end]}]] > $start} {
             #sputs feature find: $found_list $rc_found , $rc_dif,  $start
             set start $rc_dif
             continue 
          }
        }


        incr start
        set tagname "f$fea_info($w,count)#"
        ##end extension scan
        if {$direction == 1} {
          set preseq [lindex $feature 3]
          set postseq [lindex $feature 4]
        } else {
          set preseq [revcom_regexp [lindex $feature 4]]
          set postseq [revcom_regexp [lindex $feature 3]]
        }
        if {$preseq != ""} {
          set i [expr {[lindex [lindex $found_list 0] 0]}]
          if {($i <= 0) && ($info($w,circular)== "circular")} {
            set i [expr {1+$text_end}]
          }
          set j [expr {[string length $preseq]}]
          set k 0
          while {([string match -nocase [string index $preseq [expr {$j-1}]] [string index $temp_text [expr {$i-1}]]]) || ([string index $preseq $j] == "N")} {
            incr i -1
            incr j -1
            incr k
            if {($i <= 0)} {
              if {($info($w,circular)== "circular")} {
                set i [expr {1+$text_end}]
              } else {
                break
              }
            }
          }
          ##add the extension
          if {$i > $start} {
            #wrapped around
            set temp_list [list]
            foreach r $found_list {
              lappend temp_list [list [expr {[lindex $r 0]+$text_end+1}] [expr {[lindex $r 1]+$text_end+1}]]
            }
            set found_list $temp_list
          }
          set found_list [lreplace $found_list 0 1 [list $i [lindex [lindex $found_list 0] 1]] [list $i [lindex [lindex $found_list 1] 1]]] 
        }

        if {$postseq != ""} {
          set last [lindex [lindex $found_list 0] 1]
          set postf [string toupper [string range $temp_text [expr {$last + 1}] [expr {$last + [string length $postseq]}]]]
          set i 0
          while {($i < [string length $postseq]) && (([string index $postseq $i] == [string index $postf $i]) || ([string index $postseq $i] == "N"))} {incr i} 
          ##add the extension
          set found_list [lreplace $found_list 0 0 [list [lindex [lindex $found_list 0] 0] [expr {[lindex [lindex [K $found_list [set found_list {}]] 0] 1]+$i}]]]
          set found_list [lreplace $found_list end end [list [lindex [lindex $found_list end] 0] [expr {[lindex [lindex [K $found_list [set found_list {}]] end] 1]+$i}]]]
        }
        ##add feature fn(feature_number)# to indicate a split feature
        if {[llength $found_list] > 2} {
          set first [lindex [lindex $found_list 0] 0]
          set last [lindex [lindex $found_list 0] 1]
          if {$last <= $text_end} {
            $w.textarea tag add "fn$fea_info($w,count)#" [bp2ix $w.textarea $first] [bp2ix $w.textarea [expr {1 + $last}]]
          } else {
            $w.textarea tag add "fn$fea_info($w,count)#" [bp2ix $w.textarea $first] end-1c
            $w.textarea tag add "fn$fea_info($w,count)#" 1.0 [bp2ix $w.textarea [expr {$last-$text_end}]]
          }
        }
        incr fea_info($w,count)

        foreach region [lrange $found_list 1 end] {
#sputs "$tagname [bp2ix $w.textarea [lindex $region 0]] [bp2ix $w.textarea [expr {1+[lindex $region 1]}]]"
#update
          if {[lindex $region 1] <= $text_end} {
            $w.textarea tag add $tagname [bp2ix $w.textarea [lindex $region 0]] [bp2ix $w.textarea [expr {1+[lindex $region 1]}]]
          } else {
            if {[lindex $region 0] <= $text_end} {
              $w.textarea tag add $tagname [bp2ix $w.textarea [lindex $region 0]] end-1c
              $w.textarea tag add $tagname 1.0 [bp2ix $w.textarea [expr {[lindex $region 1]-$text_end}]]
            } else {
              $w.textarea tag add $tagname [bp2ix $w.textarea [expr {[lindex $region 0]-$text_end-1}]] [bp2ix $w.textarea [expr {[lindex $region 1]-$text_end}]]
            }
          }
        }
        set color [lindex $feature 7]
        set revcolor [lindex $feature 8]
        $w.textarea tag bind $tagname <<Revcolors>> [list $color $revcolor]
##metadata here
        set g_format [lindex $feature 9]
        if {$g_format == "" || $g_format== 0 || $g_format == 1} {
          set g_format $info(feature_default_gformat)
        }
        #<<Metadata>>:(0)name, (1)format_info, (2)type, (3)fwd/rev, (4)annotations_string
        set metadata [list [lindex $feature 0] $g_format [lindex $feature 6] [expr {$direction-1}] [lindex $feature 11]]
        $w.textarea tag bind $tagname <<Metadata>> $metadata
        $w.textarea tag configure $tagname -background [lindex $feature [expr {$direction + 6}]]

        ###check for dup tags and delete the old tag
        set tag_start_index [lindex [$w.textarea tag ranges $tagname] 0]
        set tag_ranges [$w.textarea tag ranges $tagname]
        foreach pos_dup_tag [$w.textarea tag names $tag_start_index] {
          if {$pos_dup_tag == $tagname} continue
          if {([$w.textarea tag ranges $pos_dup_tag] == $tag_ranges) && ([lindex [$w.textarea tag bind $pos_dup_tag <<Metadata>>] 0] == [lindex $metadata 0])} {
            $w.textarea tag delete $pos_dup_tag
          }
        }
      }
    }
  }
  features_to_tree_view $w
  #destroy .wait 
  #bind . <<RaiseDialogs>> ""
  set dialogblock 0
  destroy $w.pleasewait
  if {[winfo exists $w.pleasewait_prog]} {destroy $w.pleasewait_prog}
  $w configure -cursor arrow
  $w.textarea configure -cursor xterm
  update
}

##############
## remove unused feature tags, split features that are broken
##############
proc feature_cleanup {text} {
  set deleted [list]
  foreach text_tag [$text tag names] {
    if {([regexp {fn?[0-9]+#} $text_tag]) && ([$text tag ranges $text_tag] == {})} {
      $text tag delete $text_tag 
      lappend deleted $text_tag
    }
  }
  features_to_tree_view [winfo toplevel $text]
  return 
}

##############
## returns all features with elements between c1 and c2 as a list of feature names and tag names 
##############
proc feature_find {w {c1 -1} {c2 -1}} {
  if {$c1 == -1} {
    set c1 1.0
  } else {
    set c1 [bp2ix $w.textarea $c1]
  }
  if {$c2 == -1} {
    set c2 [$w.textarea index end-1c]
  } else {
    set c2 [bp2ix $w.textarea $c2]
  }
  #feature_cleanup $w.textarea
  set result [list]
  foreach text_tag [$w.textarea tag names] {
    if {([regexp {f[0-9]+#} $text_tag]) && (([lsearch -exact [$w.textarea tag names $c1] $text_tag] != -1) || ([$w.textarea tag nextrange $text_tag $c1 $c2+1char] != {}))} {
      set metadata [$w.textarea tag bind $text_tag <<Metadata>>]
      set name [lindex $metadata 0]
      regsub "f" $text_tag "fn" tt2
      if {[$w.textarea tag ranges $tt2] != {}} {
        lappend result $name $tt2
      } else {
        lappend result $name $text_tag
      }
    }
  }
  return $result
}

##############
## returns coordinates of fea between c1 and c2
##############
proc feature_coords {w fea {c1 -1} {c2 -1}} {
  if {$c1 == -1} {
    set c1 0
  } 
  if {$c2 == -1} {
    set c2 [ix2bp $w.textarea [$w.textarea index end-1c]]
  }
  set result [list]
  foreach {x1 x2} [$w.textarea tag ranges $fea] {
    set x1 [ix2bp $w.textarea  $x1]
    set x2 [ix2bp $w.textarea  $x2]
    incr x2 -1
    if {$x1 >= $c1} {
      if {$x1 <= $c2} {
        if {$x2 <= $c2} {
          lappend result [list $x1 $x2]
        } else {
          lappend result [list $x1 $c2]
        }
      }
    } else {
      if {$x2 >= $c1} {
        if {$x2 <= $c2} {
          lappend result [list $c1 $x2]
        } else {
          lappend result [list $c1 $c2]
        }
      } 
    }
  }
  set fntag_ranges [$w.textarea tag ranges [regsub f $fea fn]]
  if {$fntag_ranges == ""} {set fntag_ranges [$w.textarea tag ranges $fea]}
  if {[llength $fntag_ranges]> 2} {
    set start [ix2bp $w.textarea [lindex $fntag_ranges 2]]
    set pos 0
    while {([lindex [lindex $result $pos] 0] < $start) && ($pos < [llength $result])} {incr pos}
    set result [concat [lrange $result $pos end] [lrange $result 0 [expr {$pos-1}]]]
  }
  return $result
}

##############
## returns feaure coordinates as a string format: aaa..bbb,xxx..yyy
##############
proc feature_coords_text {w fea} {
  set loc [list]
  foreach {x1 x2} [$w.textarea tag ranges $fea] {
    set x1 [ix2bp $w.textarea $x1]
    incr x1
    set x2 [ix2bp $w.textarea $x2]
    lappend loc "$x1..$x2"
  }

  if {[lsearch -exact [$w.textarea tag names] [regsub f $fea fn]] > -1} {
    #check that a split tag isn't split acros the origin
    set fntag [regsub f $fea fn]
    set fn_tagrange [$w.textarea tag ranges $fntag]
    if {[llength $fn_tagrange] > 2} {
      set tagstart [expr {1+[ix2bp $w.textarea [lindex $fn_tagrange 2]]}]
      set i 0
      foreach pair $loc {
        if {[regexp ^$tagstart.. $pair]} break
        incr i
      }
      set loc [concat [lrange $loc $i end] [lrange $loc 0 [expr {$i-1}]]]
    }
  } elseif {[llength $loc] > 1} {
    #tag is split across the origin
    set loc [concat [lindex $loc 1] [lindex $loc 0]]
  }

  return [join $loc ,]
}

##############
## deletes all feature tags in a textbox
##############
proc feature_clear {w} {
  global info
  if {[tk_messageBox -message [mc "Clear all features from the file (NO UNDO)?"] -type okcancel -icon warning -default cancel] == "cancel"} return
  foreach text_tag [$w.textarea tag names] {
    if {[regexp {fn?[0-9]+#} $text_tag]} {
        $w.textarea tag delete $text_tag 
    }
  }
  features_to_tree_view $w
  set info($w,saved) 0
  if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
}

##############
## Utility for dealing with selections in listboxes
##############
proc listbox_multiple {w el} {
  if {[$w selection includes $el]} {
    $w selection clear $el
  } else {
    $w selection set $el
  }
}

##############
## Configure display properties of features in a window
##############
proc configure_features {w} {
  global info 
  global ok modifier
  global mem deleted dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1
  toplevel .dialog
  wm title .dialog [mc "Edit Features..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  bind .dialog <FocusIn> "event generate . <<RaiseDialogs>>"
  bind .dialog <Map> "event generate . <<RaiseDialogs>>"
  bind .dialog <Activate> "event generate . <<RaiseDialogs>>"

  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox resizable}
  }
  set ok 0

  grid [frame .dialog.frame1 -relief flat] -row 0 -column 0 -sticky nswe
  grid [listbox .dialog.frame1.list -width 60 -yscrollcommand "optionscrollbar .dialog.frame1.scroll" -selectmode extended -activestyle none -background white -exportselection 0] -row 0 -column 0 -sticky nswe
  grid [scrollbar .dialog.frame1.scroll -command ".dialog.frame1.list yview"] -row 0 -column 1 -sticky nse
  grid rowconfigure .dialog.frame1 0 -weight 1
  grid columnconfigure .dialog.frame1 0 -weight 1
  grid columnconfigure .dialog.frame1 1 -weight 0
  grid [frame .dialog.frame2 -relief ridge -borderwidth 2] -row 1 -column 0 -sticky swe
  grid [button .dialog.frame2.raise -text [mc "Raise"] -command "event generate .dialog <<raise>>"] -row 0 -column 0 -sticky we
  grid [button .dialog.frame2.lower -text [mc "Lower"] -command "event generate .dialog <<lower>>"] -row 0 -column 1 -sticky we
  grid [button .dialog.frame2.delete -text [mc "Delete"] -command "event generate .dialog <<delete>>"] -row 0 -column 2 -sticky we
  bind .dialog <KeyPress-BackSpace> "event generate .dialog <<delete>>; break"
  grid [button .dialog.frame2.rename -text [mc "Edit"] -command "event generate .dialog.frame1.list <<edit>> -x -1 -y -1"] -row 0 -column 3 -sticky we
  grid [button .dialog.frame2.hide -text [mc "Hide"] -command "event generate .dialog.frame1.list <<hide>>"] -row 0 -column 4 -sticky we
  grid [button .dialog.frame2.show -text [mc "Show"] -command "event generate .dialog.frame1.list <<show>>"] -row 0 -column 5 -sticky we

  grid [frame .dialog.frame3 -relief raised] -row 2 -column 0 -sticky swe
  grid [button .dialog.frame3.ok -text [mc "OK"] -command "set ok 1" -default active] -row 0 -column 0 -padx 5 -pady 3 -sticky we
  bind .dialog <Key-Return> "set ok 1"
  grid [button .dialog.frame3.cancel -text [mc "Cancel"] -command "set ok -1"] -row 0 -column 1 -padx 5 -pady 3 -sticky we
  grid rowconfigure .dialog 0 -weight 1
  grid rowconfigure .dialog 1 -weight 0
  grid rowconfigure .dialog 2 -weight 0
  grid columnconfigure .dialog 0 -weight 1

  #bind .dialog.frame1.list <$modifier-Button-1> {listbox_multiple %W [%W index @%x,%y];break}
  bind .dialog.frame1.list <Double-Button-1> "event generate .dialog.frame1.list <<edit>> -x %x -y %y"
  #bind .dialog.frame1.list <Button-1> {bell; .dialog.frame1.list selection clear 0 end; .dialog.frame1.list selection set [%W index @%x,%y]}

  set i [expr {[llength [set features [feature_find $w]]]/2-1}]
  foreach {name tag} $features {
    .dialog.frame1.list insert 0 $name
    regsub "fn" $tag "f" tag
    .dialog.frame1.list itemconfigure 0 -background [$w.textarea tag cget $tag -background]
    if {[$w.textarea tag cget $tag -background] == ""} {
      .dialog.frame1.list itemconfigure 0 -foreground gray50
    }
    set mem($i) $tag
    incr i -1
  }
  set deleted [list]
  .dialog.frame1.list selection set 0
  .dialog.frame1.list selection anchor 0

  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry .dialog "+$winx+$winy"
  update
  focus .dialog.frame1.list

  bind .dialog.frame1.list <<edit>> "
    if {%y == -1} {
      set sel_index \[lindex \[%W curselection\] 0\]
    } else {
      set sel_index \[%W index @%x,%y\]
    }
    if {\$sel_index != {}} {
      if {\[rename_recolor_window_feature .dialog $w \$mem(\$sel_index)\] eq \"ok\"} {
        .dialog.frame1.list delete \$sel_index
        .dialog.frame1.list insert \$sel_index \[lindex \[$w.textarea tag bind \$mem(\$sel_index) <<Metadata>>\] 0\]
        .dialog.frame1.list itemconfigure \$sel_index -background \[$w.textarea tag cget \$mem(\$sel_index) -background\]
        .dialog.frame1.list selection set \$sel_index \$sel_index
      }
    }
  "
  bind .dialog <<raise>> {
    foreach i [.dialog.frame1.list curselection] {
      if {$i > 0} {
        set nstore [.dialog.frame1.list get $i]
        set cstore [.dialog.frame1.list itemcget $i -background]
        .dialog.frame1.list delete $i
        set tstore $mem($i)
        set mem($i) $mem([expr {$i-1}])
        incr i -1
        .dialog.frame1.list insert $i $nstore
        .dialog.frame1.list itemconfigure $i -background $cstore       
        set mem($i) $tstore
        .dialog.frame1.list selection set $i
      }
    }
    if {[.dialog.frame1.list curselection] != {}} {
      .dialog.frame1.list see [lindex [.dialog.frame1.list curselection] 0]
    }
  } 

  bind .dialog <<lower>> {
    for {set j [expr {[llength [.dialog.frame1.list curselection]]-1}]} {$j > -1} {incr j -1} {
      set i [lindex [.dialog.frame1.list curselection] $j]
      if {$i < [expr {[.dialog.frame1.list index end] -1}]} {
        set nstore [.dialog.frame1.list get $i]
        set cstore [.dialog.frame1.list itemcget $i -background]
        .dialog.frame1.list delete $i
        set tstore $mem($i)
        set mem($i) $mem([expr {$i+1}])
        incr i 1
        .dialog.frame1.list insert $i $nstore
        .dialog.frame1.list itemconfigure $i -background $cstore       
        set mem($i) $tstore
        .dialog.frame1.list selection set $i
      }
    }
    if {[.dialog.frame1.list curselection] != {}} {
      .dialog.frame1.list see [lindex [.dialog.frame1.list curselection] end]
    }
  }

  bind .dialog <<delete>> {
    set last_sel_index [lindex [.dialog.frame1.list curselection] end]
    set first_sel_index [lindex [.dialog.frame1.list curselection] 0]
    for {set j [expr {[llength [.dialog.frame1.list curselection]]-1}]} {$j > -1} {incr j -1} {
      set i [lindex [.dialog.frame1.list curselection] $j]
      .dialog.frame1.list delete $i

      lappend deleted $mem($i)
      while {$i <= [expr {[.dialog.frame1.list index end] - 1}]} {
        set mem($i) $mem([expr {$i+1}])
        incr i
      }
      array unset mem $i 
    }
#sputs $last_sel_index [.dialog.frame1.list index end]
    while {$last_sel_index >= [.dialog.frame1.list index end]} {incr last_sel_index -1}
#sputs $last_sel_index [.dialog.frame1.list index end]
    if {$last_sel_index > -1} {
      .dialog.frame1.list selection set [expr {$first_sel_index}]
      .dialog.frame1.list selection anchor [expr {$first_sel_index}]
    }
    #.dialog.frame1.list selection clear 0 end
  } 

  bind .dialog <<hide>> "
    foreach i \[.dialog.frame1.list curselection\] {
      .dialog.frame1.list itemconfigure \$i -background \"\" -foreground gray50
      $w.textarea tag configure \$mem(\$i) -background \"\"
    }
    destroy i
  "

  bind .dialog <<show>> "
    foreach sel_index \[.dialog.frame1.list curselection\] {
      .dialog.frame1.list itemconfigure \$sel_index -background \[lindex \[$w.textarea tag bind \$mem(\$sel_index) <<Revcolors>>\] \[lindex \[$w.textarea tag bind \$mem(\$sel_index) <<Metadata>>\] 3\]\] -foreground black
      $w.textarea tag configure \$mem(\$sel_index) -background \[lindex \[$w.textarea tag bind \$mem(\$sel_index) <<Revcolors>>\] \[lindex \[$w.textarea tag bind \$mem(\$sel_index) <<Metadata>>\] 3\]\]
    }
    destroy sel_index
  "


  vwait ok
  set dialogblock 0
  destroy .dialog

  bind . <<RaiseDialogs>> ""

  if {$ok == 1} {
    foreach i [lsort -integer [array names mem]] {
      $w.textarea tag lower $mem($i)
    }
    $w.textarea tag lower sel
    $w.textarea tag lower tempsel
    set tags [$w.textarea tag names]
    foreach tag $deleted {
      delete_feature $w $tag
    }
  }
  unset ok
  unset deleted
  array unset mem
}

##############
## drop listbox element from drag
##############
proc listbox_drop {listbox list drop_index} {

}

##############
## create a feature from selection and edit it
##############
proc add_sel_feature_file {w} {
  global dialogblock info fea_info
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {[$w.textarea tag ranges sel] != {}} {
    set tagname "f$fea_info($w,count)#"

    incr fea_info($w,count)
    $w.textarea tag add $tagname sel.first sel.last
##metadata here
    $w.textarea tag bind $tagname <<Metadata>> [list "New Feature" $info(feature_default_gformat) "misc_feature" 0 ""]
    $w.textarea tag bind $tagname <<Revcolors>> [list $info(feature_default_fcolor) $info(feature_default_rcolor)]
    $w.textarea tag configure $tagname -background $info(feature_default_fcolor)
    if {[rename_recolor_window_feature $w $w $tagname] != "ok"} {
      $w.textarea tag delete $tagname
      incr fea_info($w,count) -1
    } else {
      #features_to_tree_view $w; # this is done in rename_recolor_window_feature
    }

  } else {
    tk_messageBox -message [mc "There is no text selected."] -type ok -icon info -default ok
  }
  set dialogblock 0
}

##############
## Delete tag from a sequence
##############
proc delete_feature {w tag} {
  global info
      set info($w,saved) 0
      if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}
      $w.textarea tag delete $tag
      $w.textarea tag delete [regsub "f" $tag "fn"]
      features_to_tree_view $w
}


##############
## Edit feature properties
##############
proc rename_recolor_window_feature {parent w feature} {
  global mem ok2 temp_info info temp_colors temp_gformat apply_default
  if {$feature == ""} return
  set a [toplevel .edit_feature_dialog2]
  wm title $a [mc "Edit Feature..."]
  wm protocol $a WM_DELETE_WINDOW "set ok2 -1"
  set oldbind [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "after 100 {catch {wm deiconify $a; raise $a}}"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $parent] wgeom winx winy
  wm geometry $a "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $a $parent
  } else {
    ::tk::unsupported::MacWindowStyle style $a document {closeBox}
  }
  set ok2 0

  set temp_info(name) [lindex [$w.textarea tag bind $feature <<Metadata>>] 0]
  set temp_info(format) [lindex [$w.textarea tag bind $feature <<Metadata>>] 1]
  set temp_info(type) [lindex [$w.textarea tag bind $feature <<Metadata>>] 2]
  set temp_info(dir) [lindex [$w.textarea tag bind $feature <<Metadata>>] 3]
  set temp_info(comment) [lindex [$w.textarea tag bind $feature <<Metadata>>] 4]

  set temp_info(fwd_color) [lindex [$w.textarea tag bind $feature <<Revcolors>>] 0]
  set temp_info(rev_color) [lindex [$w.textarea tag bind $feature <<Revcolors>>] 1]
  array set temp_colors $info(feature_default_type_colors)
  array set temp_gformat $info(feature_default_type_gformat)

  set temp_info(loc) [feature_coords_text $w $feature]
  set original_loc $temp_info(loc)
  if {$temp_info(dir) == 0} {set original_color $temp_info(fwd_color)} else {set original_color $temp_info(rev_color)}


  grid [frame $a.textframe -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  grid [frame $a.infoframe -relief ridge -borderwidth 2] -row 1 -column 1 -sticky nswe
  grid [frame $a.okframe -relief ridge -borderwidth 2] -row 2 -column 1 -columnspan 2 -sticky nswe
  grid rowconfigure $a 0 -weight 1
  grid rowconfigure $a 1 -weight 0
  grid rowconfigure $a 2 -weight 0
  grid columnconfigure $a 1 -weight 1

  grid [entry $a.textframe.name -textvariable temp_info(name) -font dnafont -width 50] -row 0 -column 0 -columnspan 5 -sticky nwe
  grid [text $a.textframe.loc -font dnafont -width 40 -height 2 -background $info(bg_color)] -row 1 -column 0 -columnspan 4 -sticky nswe
  grid [checkbutton $a.textframe.compl -text [mc "Rev-Com"] -variable temp_info(dir) -onvalue 1 -offvalue 0 -selectcolor white -command "if {\$temp_info(dir) == 0} {$w.textarea tag configure $feature -background \$temp_info(fwd_color)} else {$w.textarea tag configure $feature -background \$temp_info(rev_color)}"] -row 1 -column 4 -sticky w
  grid [button $a.textframe.upper -text [mc "Uppercase Only"] -command "set temp_info(loc) \[locations_upper $w \$temp_info(loc)\]; event generate $a.textframe.loc <<update>>" ] -row 2 -column 0 -sticky w
  tooltip_install $a.textframe.upper [mc "Remove all lowercase text from the feature range"]
  grid [button $a.textframe.plus_sel -text [mc "Feature Plus Selection"] -command "set temp_info(loc) \[locations_plus_selection $w \$temp_info(loc) plus_sel\]; event generate $a.textframe.loc <<update>>" ] -row 2 -column 1 -sticky w
  tooltip_install $a.textframe.plus_sel [mc "Add text selection to the feature"]
  grid [button $a.textframe.minus_sel -text [mc "Feature Minus Selection"] -command "set temp_info(loc) \[locations_plus_selection $w \$temp_info(loc) minus_sel\]; event generate $a.textframe.loc <<update>>" ] -row 2 -column 3 -sticky w
  tooltip_install $a.textframe.minus_sel [mc "Remove text selection from the feature"]

  bind $a.textframe.loc <<update>> "
    $a.textframe.loc configure -state normal
    $a.textframe.loc delete 1.0 end
    $a.textframe.loc insert 1.0 \$temp_info(loc)
    $a.textframe.loc configure -state disabled
    apply_loc_list $w $feature \$temp_info(loc)
  "
  $a.textframe.loc insert 1.0 $temp_info(loc)
  $a.textframe.loc configure -state disabled

  grid rowconfigure $a.textframe 0 -weight 0
  grid rowconfigure $a.textframe 1 -weight 1
  grid columnconfigure $a.textframe 0 -weight 1

  grid [frame $a.infoframe.typeframe] -row 0 -column 1 -sticky nswe
  grid [label $a.infoframe.typeframe.label1 -text "Feature type:"] -row 0 -column 1 -sticky w
  grid [menubutton $a.infoframe.typeframe.type -menu $a.infoframe.typeframe.type.menu -textvariable temp_info(type) -font labelfont -width 15 -indicatoron 1] -row 0 -column 2 -sticky we
  menu $a.infoframe.typeframe.type.menu
  set typelist [list source primer_bind CDS exon intron 5'UTR 3'UTR mRNA prim_transcript precursor_RNA 5'clip 3'clip misc_RNA rep_origin gene promoter enhancer polyA_site polyA_signal terminator CAAT_signal TATA_signal -35_signal -10_signal GC_signal RBS attenuator misc_signal sig_peptide transit_peptide mat_peptide variation STS unsure conflict modified_base misc_difference old_sequence misc_feature LTR repeat_region repeat_unit satellite rRNA tRNA scRNA snRNA snoRNA protein_bind misc_binding misc_recomb misc_structure iDNA stem_loop D-loop C_region D_segment J_segment N_region S_region V_region V_segment] 
  set divided_typelist [list Genes [list promoter CDS exon intron gene 5'UTR 3'UTR polyA_site mRNA prim_transcript precursor_RNA 5'clip 3'clip] Signals [list rep_origin promoter enhancer polyA_site polyA_signal terminator CAAT_signal TATA_signal -35_signal -10_signal GC_signal RBS attenuator misc_signal sig_peptide transit_peptide mat_peptide] Binding [list primer_bind protein_bind misc_binding] Variation [list variation STS unsure conflict modified_base misc_difference old_sequence] Repeats [list LTR repeat_region repeat_unit satellite] RNA [list mRNA rRNA tRNA scRNA snRNA snoRNA misc_RNA] Misc [list source misc_feature misc_binding misc_recomb misc_structure iDNA stem_loop D-loop] Ig [list C_region D_segment J_segment N_region S_region V_region V_segment]] 
  foreach {header types} $divided_typelist {
    $a.infoframe.typeframe.type.menu add cascade -label $header -menu [menu $a.infoframe.typeframe.type.menu.[string tolower $header]]
    foreach type $types {
      if {[string index $type 0] eq "-"} {set typelabel " $type"} else {set typelabel $type}
      $a.infoframe.typeframe.type.menu.[string tolower $header] add radiobutton -label $typelabel -variable temp_info(type) -value $type -command "if {\[info exists temp_colors($type)\]} {set temp_info(fwd_color) \[lindex \$temp_colors($type) 0\]; set temp_info(rev_color) \[lindex \$temp_colors($type) 1\]} else {set temp_info(fwd_color) $info(feature_default_fcolor); set temp_info(rev_color) $info(feature_default_rcolor); set temp_colors($type) \[list $info(feature_default_fcolor) $info(feature_default_rcolor)\]}; if {\[info exists temp_gformat($type)\]} {set temp_info(f_arrow) \[lindex \[dict get \$temp_gformat($type) arrow_data\] 0\]; set temp_info(r_arrow) \[lindex \[dict get \$temp_gformat($type) arrow_data\] 1\]; set temp_info(arrow_flip) \[lindex \[dict get \$temp_gformat($type) arrow_data\] 2\]; set temp_info(g_width) \[dict get \$temp_gformat($type) width\]} else {set temp_info(f_arrow) \[lindex \[dict get \$info(feature_default_gformat) arrow_data\] 0\]; set temp_info(r_arrow) \[lindex \[dict get \$info(feature_default_gformat) arrow_data\] 1\]; set temp_info(arrow_flip) \[lindex \[dict get \$info(feature_default_gformat) arrow_data\] 2\];set temp_info(g_width) \[dict get \$info(feature_default_gformat) width\]}"

     ####add the -command to change the fwd and rev_color here
    }
  }
  if {[lsearch -exact $typelist $temp_info(type)] == -1} {
    $a.infoframe.typeframe.type.menu add radiobutton -label $temp_info(type) -variable temp_info(type) -value $temp_info(type) -command "if {\[info exists temp_colors($type)\]} {set temp_info(fwd_color) \[lindex \$temp_colors($type) 0\]; set temp_info(rev_color) \[lindex \$temp_colors($type) 1\]} else {set temp_info(fwd_color) $info(feature_default_fcolor); set temp_info(rev_color) $info(feature_default_rcolor); set temp_colors($type) \[list $info(feature_default_fcolor) $info(feature_default_rcolor)\]}; if {\[info exists temp_gformat($type)\]} {set temp_info(f_arrow) \[lindex \[dict get \$temp_gformat($type) arrow_data\] 0\]; set temp_info(r_arrow) \[lindex \[dict get \$temp_gformat($type) arrow_data\] 1\]; set temp_info(arrow_flip) \[lindex \[dict get \$temp_gformat($type) arrow_data\] 2\]; set temp_info(g_width) \[dict get \$temp_gformat($type) width\]} else {set temp_info(f_arrow) \[lindex \[dict get \$info(feature_default_gformat) arrow_data\] 0\]; set temp_info(r_arrow) \[lindex \[dict get \$info(feature_default_gformat) arrow_data\] 1\]; set temp_info(arrow_flip) \[lindex \[dict get \$info(feature_default_gformat) arrow_data\] 2\];set temp_info(g_width) \[dict get \$info(feature_default_gformat) width\]}"
  }
  #trace variable temp_info(type) w "bell;#"

  grid [frame $a.infoframe.colorframe] -row 1 -column 1 -sticky nswe
  grid [label $a.infoframe.colorframe.label2 -text [mc "Forward color:"]] -row 0 -column 1 -sticky w
  grid [color_button $a.infoframe.colorframe.fwdcolor temp_info(fwd_color) $temp_info(fwd_color) 12] -sticky w -row 0 -column 2
  grid [label $a.infoframe.colorframe.label3 -text [mc "Reverse color:"]] -row 0 -column 3
  grid [color_button $a.infoframe.colorframe.revcolor temp_info(rev_color) $temp_info(rev_color) 12] -sticky w -row 0 -column 4
  grid [button $a.infoframe.colorframe.revcolor_same -text [mc "Same"] -command "set temp_info(rev_color) \$temp_info(fwd_color)"] -sticky w -padx 5 -row 0 -column 5
  tooltip_install  $a.infoframe.colorframe.revcolor_same [mc "Make the reverse color the same as the forward color"]
  grid [menubutton $a.infoframe.colorframe.favs -menu $a.infoframe.colorframe.favs.menu -text [mc "Favorites"] -width 10 -indicatoron 1] -sticky w -padx 5 -row 0 -column 6
  menu $a.infoframe.colorframe.favs.menu
  fill_favs_menu $a $a.infoframe.colorframe.favs.menu temp_info(fwd_color) temp_info(rev_color)

  grid [frame $a.infoframe.gformatframe] -row 2 -column 1 -sticky nswe
  grid [label $a.infoframe.gformatframe.l1 -text [mc "Forward arrow:"]] -row 0 -column 1 -sticky w
  grid [entry $a.infoframe.gformatframe.e1 -textvariable temp_info(f_arrow)] -row 0 -column 2 -sticky w
  grid [label $a.infoframe.gformatframe.l2 -text [mc "Reverse arrow:"]] -row 1 -column 1 -sticky w
  grid [entry $a.infoframe.gformatframe.e2 -textvariable temp_info(r_arrow)] -row 1 -column 2 -sticky w
  grid [checkbutton $a.infoframe.gformatframe.c1 -text [mc "Flip on reverse"] -variable temp_info(arrow_flip)]  -row 1 -column 3 -sticky w
  grid [label $a.infoframe.gformatframe.l3 -text [mc "Width:"]] -row 2 -column 1 -sticky w
  grid [entry $a.infoframe.gformatframe.e3 -textvariable temp_info(g_width)] -row 2 -column 2 -sticky w
  

  set temp_info(f_arrow) [lindex [dict get $temp_info(format) arrow_data] 0]
  set temp_info(r_arrow) [lindex [dict get $temp_info(format) arrow_data] 1]
  set temp_info(arrow_flip) [lindex [dict get $temp_info(format) arrow_data] 2]
  set temp_info(g_width) [dict get $temp_info(format) width]

  trace add variable info(feature_color_favorites) write "fill_favs_menu $a $a.infoframe.colorframe.favs.menu temp_info(fwd_color) temp_info(rev_color);# "
 # trace add variable temp_info(fwd_color) write  "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \[lindex \$temp_colors(\$temp_info(type)) 1\]\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"
  # trace add variable temp_info(rev_color) write "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \[lindex \$temp_colors(\$temp_info(type)) 0\] \$temp_info(rev_color)\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"

  bind $a.infoframe.colorframe.fwdcolor <<updatevar>> "+;if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \[lindex \$temp_colors(\$temp_info(type)) 1\]\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]}"
  bind $a.infoframe.colorframe.revcolor <<updatevar>> "+;if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \[lindex \$temp_colors(\$temp_info(type)) 0\] \$temp_info(rev_color)\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]}"

  bind $a.infoframe.colorframe.fwdcolor <<updatevar>> "+;if {\$temp_info(dir) == 0} {$w.textarea tag configure $feature -background \$temp_info(fwd_color)} else {$w.textarea tag configure $feature -background \$temp_info(rev_color)}"
  bind $a.infoframe.colorframe.revcolor <<updatevar>> "+;if {\$temp_info(dir) == 0} {$w.textarea tag configure $feature -background \$temp_info(fwd_color)} else {$w.textarea tag configure $feature -background \$temp_info(rev_color)}"

  grid [button $a.okframe.ok -text [mc "OK"] -command "set ok2 1" -default active] -row 0 -column 0 -padx 10 -pady 3
  grid [checkbutton $a.okframe.apply -text [mc "Make format default for feature type"] -variable apply_default] -row 0 -column 1 -padx 10 -pady 3
  set apply_default 0
  bind $a <Key-Return> "set ok2 1"
  $a.textframe.name selection range 0 end
  $a.textframe.name icursor end
  wm deiconify $a
  raise $a
  focus $a
  update
  focus $a.textframe.name



  vwait ok2


  if {$ok2 == 1} {
  ###execute changes
    set info($w,saved) 0
    if {[tk windowingsystem] == "aqua"} {wm attributes $w -modified 1}

    #deal with transparent features
    if {[winfo rgb . $temp_info(fwd_color)] == [winfo rgb . $info(text_bg_color)]} {
      set fwd_color {}
    } else {
      set fwd_color $temp_info(fwd_color)
    }
    if {[winfo rgb . $temp_info(rev_color)] == [winfo rgb . $info(text_bg_color)]} {
      set rev_color {}
    } else {
      set rev_color $temp_info(rev_color)
    }

    #need to deal with adding and removing fn# tags
    set loc_list  [split [regsub -all {\.+} $temp_info(loc) ,] ","]
    if {([llength [$w.textarea tag ranges $feature]] == 2) || (([llength [$w.textarea tag ranges $feature]] == 4) && ([lindex $loc_list 0] > [lindex $loc_list end])) } {
      $w.textarea tag delete [regsub f $feature fn]
    } elseif {([lindex $loc_list 0] > [lindex $loc_list end])} {
      $w.textarea tag add [regsub f $feature fn] [bp2ix $w.textarea [expr {[lindex $loc_list 0] -1}]] [$w.textarea index end-1c]
      $w.textarea tag add [regsub f $feature fn] 1.0 [bp2ix $w.textarea [lindex $loc_list end]]
    } else {
      $w.textarea tag add [regsub f $feature fn] [bp2ix $w.textarea [expr {[lindex $loc_list 0] -1}]] [bp2ix $w.textarea [lindex $loc_list end]]
    }

    dict set temp_info(format) arrow_data [list $temp_info(f_arrow) $temp_info(r_arrow) $temp_info(arrow_flip)]
    dict set temp_info(format) width $temp_info(g_width)


    $w.textarea tag bind $feature <<Revcolors>> [list $fwd_color $rev_color]
##metadata here
    $w.textarea tag bind $feature <<Metadata>> [list $temp_info(name) $temp_info(format) $temp_info(type) $temp_info(dir) $temp_info(comment)]
    if {$temp_info(dir) == 0} {
      $w.textarea tag configure $feature -background $fwd_color
    } else {
      $w.textarea tag configure $feature -background $rev_color
    }
    features_to_tree_view $w
    set return "ok"
  } else {
  ##cancel changes
    apply_loc_list $w $feature $original_loc
    $w.textarea tag configure $feature -background $original_color
    set return "cancel"
  }


  #trace remove variable temp_info(fwd_color) write  "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \[lindex \$temp_colors(\$temp_info(type)) 1\]\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"
  #trace remove variable temp_info(rev_color) write "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \[lindex \$temp_colors(\$temp_info(type)) 0\] \$temp_info(rev_color)\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"
  if {$apply_default} {
    set info(feature_default_type_colors) [array get temp_colors]
    dict set info(feature_default_type_gformat)  $temp_info(type) $temp_info(format) 
  }
  destroy $a
  unset -nocomplain temp_colors temp_gformat
  bind . <<RaiseDialogs>> $oldbind
  array unset temp_info
  unset ok2 apply_default
  return $return
}

##########
## Return location list formed by adding or subtracting the0 selection from a location list of a feature (sub-proc of rename_recolor_features)
##########
proc locations_plus_selection {w loc_list_text mode} {


  if {[$w.textarea tag ranges sel] == ""} {return $loc_list_text}

  set sel_start [expr {[ix2bp $w.textarea [$w.textarea index sel.first]] +1}]
  set sel_end [ix2bp $w.textarea [$w.textarea index sel.last]]

  set loc_list [split [regsub -all {\.+} $loc_list_text ,] ".,"]
  set start_i [llength $loc_list]
  set end_i [llength $loc_list]
  for {set i 0} {$i < [llength $loc_list]} {incr i} {
    #find point in loc_list that sel_start is between (need to check if it is in the intron of a feature split at the origin)
    if {($sel_start < [lindex $loc_list $i]) || (($i > 0) && ([lindex $loc_list [expr {$i-1}]] > [lindex $loc_list $i]) && ($sel_start > [lindex $loc_list [expr {$i-1}]]))} {
      set start_i $i
      break
    }
  }

  #for features split at the origin, need to check for sel_start in the exons at the begining of the sequenc
  if {([lindex $loc_list 0] > [lindex $loc_list end]) && ($start_i == 0) && ($sel_start < [lindex $loc_list end])} {
    while {([lindex $loc_list $i] > [lindex $loc_list [expr {$i-1}]]) && ($i < [llength $loc_list])} {
      incr i 
    }
   for {set i $i} {$i < [llength $loc_list]} {incr i} {
    #find point in loc_list that sel_start is between (need to check if it is in the intron of a feature split at the origin)
      if {($sel_start < [lindex $loc_list $i])} {
        set start_i $i
        break
      }
    }
  }

  for {set i $i} {$i < [llength $loc_list]} {incr i} {
    if {($sel_end < [lindex $loc_list $i]) ||  (($i > 0) && ([lindex $loc_list [expr {$i-1}]] > [lindex $loc_list $i]) && ($sel_start > [lindex $loc_list $i]))} {
      set end_i $i
      break
    }
  }

  #even indices are in introns, odd in exons

  #need to check for circular sequences with 0 0 result (adding new exon to the beginning), see if it would be closer to add it to the end
  if {$mode == "plus_sel"} {
    ####plus_sel
    if {$start_i == [llength $loc_list]} {
      lappend loc_list $sel_start $sel_end
    } else {
      set loc_list [lreplace $loc_list $start_i [expr {$end_i-1}] {*}[expr {($start_i % 2)?"":$sel_start}] {*}[expr {($end_i % 2)?"":$sel_end}]]
    }

    #eliminate empty list elements
    set loc_list [lsearch -all -inline -not $loc_list {}]

    #fuse adjacent exons
    set loc_list2 [lindex $loc_list 0] 
    for {set i 1} {$i < [expr {[llength $loc_list] -1}]} {incr i} {
      if {[expr {$i % 2}] && ([expr {[lindex $loc_list $i] + 1}] == [lindex $loc_list [expr {$i +1}]])} {
        incr i 1

      } else {
        lappend loc_list2 [lindex $loc_list $i]
      }
    }
    lappend loc_list2 [lindex $loc_list end]

  } else {
    ####minus_sel
    if {($start_i == [llength $loc_list]) || ($end_i == 0)} {
    } elseif {($end_i == [llength $loc_list]) && ( ($start_i == 0) || (($start_i == 1) && ($sel_start == [lindex $loc_list 0])) )} {
      #deleting whole feature
      bell
      return $loc_list_text
    } else {
      set loc_list [lreplace $loc_list $start_i [expr {$end_i-1}] {*}[expr {($start_i % 2)?[expr {$sel_start-1}]:""}] {*}[expr {($end_i % 2)?[expr {$sel_end+1}]:""}]]
    }
    #eliminate empty list elements
    set loc_list [lsearch -all -inline -not $loc_list {}]
    #delete empty exons
    set loc_list2 [list] 
    for {set i 0} {$i < [llength $loc_list]} {incr i} {
      if {(![expr {$i % 2}]) && ([lindex $loc_list $i] > [lindex $loc_list [expr {$i +1}]])} {
        incr i 1
      } else {
        lappend loc_list2 [lindex $loc_list $i]
      }
    }
  }

    #make result text
    if {[llength $loc_list2] > 0} {
      set res_text "[lindex $loc_list2 0]..[lindex $loc_list2 1]"
      foreach {a b} [lrange $loc_list2 2 end] {
        set res_text "$res_text,$a..$b"
      } 
      return $res_text
   } else {
     return $loc_list_text
   }
}

##########
## Return location list of only uppercase chars (sub-proc of rename_recolor_features)
##########
proc locations_upper {w loc_list_text} {
  set loc_list [split [regsub -all {\.+} $loc_list_text ,] ".,"]
  set res_list [list]
  foreach {a b} $loc_list {
    set t [textarea_get $w.textarea [bp2ix $w.textarea [expr {$a-1}]] [bp2ix $w.textarea $b]]
    foreach c [regexp -all -indices -inline {[[:upper:]]+} $t] {
      lappend res_list [expr {[lindex $c 0] + $a}] [expr {[lindex $c 1] + $a}]
    }
  }
  if {$res_list != [list] } {
    set res_text "[lindex $res_list 0]..[lindex $res_list 1]"
    foreach {a b} [lrange $res_list 2 end] {
      set res_text "$res_text,$a..$b"
    } 
    return $res_text
  } else {
    return $loc_list_text
  }
}

##########
## Apply location list to a feature (sub-proc of rename_recolor_features)
##########
proc apply_loc_list {w tag loc_list_text} {
  
  set loc_list [split [regsub -all {\.+} $loc_list_text ,] ".,"]
  $w.textarea tag remove $tag 1.0 end
  foreach {a b} $loc_list {
    incr a -1
    $w.textarea tag add $tag [bp2ix $w.textarea $a] [bp2ix $w.textarea $b]
  }
}


##########
## Fill a feature favorite colors menu button
##########
proc fill_favs_menu {w menu fwd_color_var rev_color_var} {
  global info

  $menu delete 0 end
  foreach coloritem $info(feature_color_favorites) {
    $menu add command -label [lindex $coloritem 0] -command "set $fwd_color_var [lindex $coloritem 1]; set $rev_color_var [lindex $coloritem 2]"
    }
    $menu add separator
    $menu add command -label [mc "Edit Favorites"] -command "set dialogblock 0; edit_color_favorites $w; set dialogblock 1"
}

##########
## Read a file of "/allowed_subtype (tab) type" lines and build list
## of type (allowed_types_list)
##########
proc read_genbank_subtypes {} {
  set f {C:/My documents/programming/ApE/genbank_subfeatures.txt}
  set fileid [open $f r]
  while {[eof $fileid] != 1} {lappend lines [gets $fileid]}
  close $fileid

  set type ""
  regexp {/(.*)\t(.*)} [lindex $lines 0] line a b
  set type $b
  set proplist [list $a]
  foreach line [lrange $lines 1 end] {
    regexp {/(.*)\t(.*)} $line line a b
    if {$type ne $b} {
      lappend result [list $type $proplist]
      set type $b
      set proplist [list $a]
    } else {
      lappend proplist $a
    }
  }
lappend result [list $type $proplist]
set resultlist {-10_signal {allele citation db_xref evidence gene label locus_tag map note old_locus_tag operon standard_name usedin}} {-35_signal {allele citation db_xref evidence gene label locus_tag map note old_locus_tag operon standard_name usedin}} {3'clip {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag standard_name usedin}} {3'UTR {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag standard_name usedin}} {5'clip {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag standard_name usedin}} {5'UTR {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag standard_name usedin}} {attenuator {allele citation db_xref evidence gene label locus_tag map note old_locus_tag operon phenotype usedin}} {C_region {allele citation db_xref evidence gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {CAAT_signal {allele citation db_xref evidence gene label locus_tag map note old_locus_tag usedin}} {CDS {allele citation codon codon_start db_xref EC_number evidence exception function gene label locus_tag map note number old_locus_tag operon product protein_id pseudo standard_name transl_except transl_table translation usedin}} {conflict {allele citation compare db_xref evidence gene label locus_tag map note old_locus_tag replace usedin}} {D_segment {allele citation db_xref evidence gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {D-loop {allele citation db_xref evidence gene label locus_tag map note old_locus_tag usedin}} {enhancer {allele bound_moiety citation db_xref evidence gene label locus_tag map note old_locus_tag standard_name usedin}} {exon {allele citation db_xref EC_number evidence function gene label locus_tag map note number old_locus_tag product pseudo standard_name usedin}} {gap {estimated_length map note}} {GC_signal {allele citation db_xref evidence gene label locus_tag map note old_locus_tag usedin}} {gene {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag operon phenotype product pseudo standard_name usedin}} {iDNA {allele citation db_xref evidence function gene label locus_tag map note number old_locus_tag standard_name usedin}} {intron {allele citation cons_splice db_xref evidence function gene label locus_tag map note number old_locus_tag standard_name usedin}} {J_segment {allele citation db_xref evidence gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {LTR {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag standard_name usedin}} {mat_peptide {allele citation db_xref EC_number evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {misc_binding {allele bound_moiety citation db_xref evidence function gene label locus_tag map note old_locus_tag usedin}} {misc_difference {allele citation clone compare db_xref evidence gene label locus_tag map note old_locus_tag phenotype replace standard_name usedin}} {misc_feature {allele citation db_xref evidence function gene label locus_tag map note number old_locus_tag phenotype product pseudo standard_name usedin}} {misc_recomb {allele citation db_xref evidence gene label locus_tag map note old_locus_tag organism standard_name usedin}} {misc_RNA {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag operon product standard_name usedin}} {misc_signal {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag operon phenotype standard_name usedin}} {misc_structure {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag standard_name usedin}} {modified_base {allele citation db_xref evidence frequency gene label locus_tag map mod_base note old_locus_tag usedin}} {mRNA {allele citation db_xref evidence exception function gene label locus_tag map note old_locus_tag operon product pseudo standard_name usedin}} {N_region {allele citation db_xref evidence gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {old_sequence {allele citation compare db_xref evidence gene label locus_tag map note old_locus_tag replace usedin}} {operon {allele citation db_xref evidence function label map note operon phenotype pseudo standard_name usedin}} {oriT {allele bound_moiety citation db_xref direction evidence gene label locus_tag map note old_locus_tag rpt_family rpt_type rpt_unit standard_name usedin}} {polyA_signal {allele citation db_xref evidence gene label locus_tag map note old_locus_tag usedin}} {polyA_site {allele citation db_xref evidence gene label locus_tag map note old_locus_tag usedin}} {precursor_RNA {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag operon product standard_name usedin}} {prim_transcript {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag operon standard_name usedin}} {primer_bind {allele citation db_xref evidence gene label locus_tag map note old_locus_tag PCR_conditions standard_name usedin}} {promoter {allele bound_moiety citation db_xref evidence function gene label locus_tag map note old_locus_tag operon phenotype pseudo standard_name usedin}} {protein_bind {allele bound_moiety citation db_xref evidence function gene label locus_tag map note old_locus_tag standard_name usedin}} {RBS {allele citation db_xref evidence gene label locus_tag map note old_locus_tag standard_name usedin}} {rep_origin {allele citation db_xref direction evidence gene label locus_tag map note old_locus_tag standard_name usedin}} {repeat_region {allele citation db_xref evidence function gene insertion_seq label locus_tag map note old_locus_tag rpt_family rpt_type rpt_unit standard_name transposon usedin}} {repeat_unit {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag rpt_family rpt_type rpt_unit usedin}} {rRNA {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {S_region {allele citation db_xref evidence gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {satellite {allele citation db_xref evidence gene label locus_tag map note old_locus_tag rpt_family rpt_type rpt_unit standard_name usedin}} {scRNA {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {sig_peptide {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {snoRNA {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {snRNA {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {source {cell_line cell_type chromosome citation clone clone_lib country cultivar db_xref dev_stage ecotype environmental_sample focus frequency germline haplotype isolate isolation_source lab_host label macronuclear map mol_type note organelle organism plasmid pop_variant proviral rearranged segment serotype serovar sex specific_host specimen_voucher strain sub_clone sub_species sub_strain tissue_lib tissue_type transgenic usedin variety virion}} {stem_loop {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag operon standard_name usedin}} {STS {allele citation db_xref evidence gene label locus_tag map note old_locus_tag standard_name usedin}} {TATA_signal {allele citation db_xref evidence gene label locus_tag map note old_locus_tag usedin}} {terminator {allele citation db_xref evidence gene label locus_tag map note old_locus_tag operon standard_name usedin}} {transit_peptide {allele citation db_xref evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {tRNA {allele anticodon citation db_xref evidence function gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {unsure {allele citation compare db_xref evidence gene label locus_tag map note old_locus_tag replace usedin}} {V_region {allele citation db_xref evidence gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {V_segment {allele citation db_xref evidence gene label locus_tag map note old_locus_tag product pseudo standard_name usedin}} {variation {allele citation compare db_xref evidence frequency gene label locus_tag map note old_locus_tag phenotype product replace standard_name usedin}}
}


##############
## converts a list of lines from a genbank feature table to a tag list for put_tags
##############
proc feature_table_to_taglist {table {circular 0} {dna_length 0}} {
  global info
  set result [list]
  set subtype ""
  set subdata ""
  set type ""
  set range ""
  set source_tag ""
  set i 0
  set c 0
  set genbank_type_list [list]
  set genbank_data_list [list]
  set info_label ""
  set Apeinfo_label ""
  set Apeinfo_fwd ""
  set Apeinfo_rev ""
  set Apeinfo_gformat ""
  lappend table "     end   end"
if {1} {
  foreach line $table {
    if {[regexp { {21,23}/(.*)=(.*)} $line line next_subtype next_subdata]} {
      ##store the sub data
      if {$subtype == "ApEinfo_label"} {
        regsub -all {"} $subdata {} subdata
        set Apeinfo_label $subdata
      } elseif {$subtype == "ApEinfo_fwdcolor"} {
        regsub -all {"} $subdata {} subdata
        set Apeinfo_fwd $subdata
      } elseif {$subtype == "ApEinfo_revcolor"} {
        regsub -all {"} $subdata {} subdata
        set Apeinfo_rev $subdata
      } elseif {$subtype == "ApEinfo_graphicformat"} {
        regsub -all {"} $subdata {} subdata
        set Apeinfo_gformat $subdata
      } elseif {$subtype == "label"} {
        regsub -all {"} $subdata {} subdata
        set info_label $subdata
      } elseif {$subtype != ""} {
        lappend genbank_data_list $subdata
      }
      set subtype $next_subtype
      if {[lsearch [list label ApEinfo_label ApEinfo_fwdcolor ApEinfo_revcolor ApEinfo_graphicformat] $subtype] == -1} {
        lappend genbank_type_list $subtype
      }
      set subdata $next_subdata
      set c 1
    } elseif {[regexp { {21,23}(.*)} $line line continue]} {
      if {$c == 0} {
        set range "$range$continue"
      } else {
        set subdata "$subdata $continue"
      }
    } elseif {[regexp { {5,7}([^ ]*) *(.*)} $line line next_type next_range]} {
      ##next feature heading line found
      ##finish the previous feature
      if {$subtype == "ApEinfo_label"} {
        set Apeinfo_label $subdata
      } elseif {$subtype == "ApEinfo_fwdcolor"} {
        set Apeinfo_fwd $subdata
      } elseif {$subtype == "ApEinfo_revcolor"} {
        set Apeinfo_rev $subdata
      } elseif {$subtype == "ApEinfo_graphicformat"} {
        set Apeinfo_gformat $subdata
      } elseif {$subtype == "label"} {
        set info_label $subdata
      } elseif {$subtype != ""} {
        lappend genbank_data_list $subdata
      }
      if {($type != "")} {
        ##interpret the range data

        if {[string match "*complement*" $range]} {
          set dir 1
        } else {
          set dir 0
        }

        #if feature contains an outside reference, can't use it
        if {[string first : $range] > -1} {
          set range ""
        }

        #convert ^'s and ..'s to .'s
        regsub -all {\.\.|\^} $range . temp_range
        regsub -all " " $temp_range "" temp_range

        set new_range [list]
        if {0} {
          #[regexp "complement\\\((.*)\\\)" $t x r]
        } else {

        #process each location as defined as everything between ,'s
        foreach location [split $temp_range ,] {
          #take out everything that's not a number or a "."
          regsub -all {[^\.0-9]} $location "" location
          set location [split $location .]
          if {[catch {lsort -integer -increasing $location}]} {
            if {[lindex $location 1] == ""} {
              set location [list [lindex $location 0] [lindex $location 0]]
            }
            if {[lindex $location 0] == ""} {
              set location [list [lindex $location 1] [lindex $location 1]]
            }
          }
          if {[llength $location] == 1} {
            set location [concat $location $location]
          }
          if {($circular eq "circular") && ([llength $location] == 2) && ($dna_length > 0)} {
            if {[lindex $location 0] > [lindex $location 1]} {
              #VectorNTI stores features that span the origin as features with higher first index than second
              lappend new_range [list [expr {[lindex $location 0]-1}] [expr {$dna_length}]] [list 0 [lindex $location end]]
            } else {
              lappend new_range [list [expr {[lindex $location 0]-1}] [lindex $location end]]
            }
          } else {
            lappend new_range [list [expr {[lindex $location 0]-1}] [lindex $location end]]
          }
        }
       # set new_range [lsort -integer -increasing [join $new_range " "]]
        }
        set new_range [join $new_range " "]
        ##need to assign the name based on the sub-data
        #label gene product notes
        if {$Apeinfo_label != ""} {
          set name $Apeinfo_label
        } elseif {$info_label != ""} {
          set name $info_label
        } elseif {[set index [lsearch $genbank_type_list "product"]] > -1} {
          set name [lindex $genbank_data_list $index]
        } elseif {[set index [lsearch $genbank_type_list "gene"]] > -1} {
          set name [lindex $genbank_data_list $index]
        } elseif {[set index [lsearch $genbank_type_list "note"]] > -1} {
          set name [lindex $genbank_data_list $index]
        } elseif {$type == "source"} {
          if {[set index [lsearch $genbank_type_list "organism"]] > -1} {
            set name "source:[lindex $genbank_data_list $index]"
          } else {
            set name "source"
          }
        } else {
          set name $type
        }
        set name [string range $name 0 50]
        regsub -all {\"} $name "" name

        ##need to assign the colors based on the type
        set Apeinfo_fwd [regsub -all {{[^[:alnum:]\s#]} } $Apeinfo_fwd ""]
        set Apeinfo_rev [regsub -all {{[^[:alnum:]\s#]} } $Apeinfo_rev ""]
        if {($Apeinfo_fwd != "") && (![catch {winfo rgb . $Apeinfo_fwd}])} {
          set fwd_color $Apeinfo_fwd
          if {($Apeinfo_rev != "")  && (![catch {winfo rgb . $Apeinfo_rev}])} {
            set rev_color $Apeinfo_rev
          } else {
            set rev_color $Apeinfo_fwd
          }
        } elseif {1} {
          if {[set color_index [lsearch -exact $info(feature_default_type_colors) $type]] != -1} {
            set clist [lindex $info(feature_default_type_colors) [expr {$color_index+1}]]
          } else {
            set clist {pink pink}
          }
          set fwd_color [lindex $clist 0]
          set rev_color [lindex $clist 1]
        }
        
        #assign gformat based on type
        if {[catch {set ad [dict get $Apeinfo_gformat arrow_data]; dict get $Apeinfo_gformat width; dict get $Apeinfo_gformat offset}] || [llength $ad] !=3 || ([llength [lindex $ad 0]] % 2)|| ([llength [lindex $ad 1]] % 2) } {
          if {[catch {set Apeinfo_gformat [dict get $info(feature_default_type_gformat) $type]}]} {
            set Apeinfo_gformat $info(feature_default_gformat)
          }
        }

        set genbank_list [list]
        foreach subtype $genbank_type_list subdata $genbank_data_list {
            lappend genbank_list $subtype $subdata
        }
        if {$dir == 0} {
          set formatlist [list $fwd_color {} {}]
        } else {
          set formatlist [list $rev_color {} {}]
        }
        set bindlist [list <<Revcolors>> <<Metadata>>]
##metadata here
        set actionlist [list [list $fwd_color $rev_color] [list $name $Apeinfo_gformat $type $dir $genbank_list]]

        ###create the feature data 
        if {[llength $new_range] > 0} { 
          if {[llength $new_range] > 2} {
            if {($circular== "circular") && ([lindex $new_range 0] > [lindex $new_range end])} {
              #crosses the origin
              if {([llength $new_range] == 4) && ([lindex $new_range 1]== $dna_length) && ([lindex $new_range 2]== 0)} {
                #single range, just crosses the origin
                lappend result "f$i#" [list $new_range $formatlist $bindlist $actionlist]
              } else {
                #multi-range feature, that crosses the origin
                lappend result "f$i#" [list $new_range $formatlist $bindlist $actionlist]
                lappend result "fn$i#" [list [list [lindex $new_range 0] $dna_length 0 [lindex $new_range end]] [list {} {} {}] [list] [list]]
              }
            } else {
              #multi-range feature, doesn't cross the origin
              lappend result "f$i#" [list $new_range $formatlist $bindlist $actionlist]
              lappend result "fn$i#" [list [list [lindex $new_range 0] [lindex $new_range end]] [list {} {} {}] [list] [list]]
            }
          } else {
            #simple 1 range feature
            lappend result "f$i#" [list $new_range $formatlist $bindlist $actionlist]
          }
          incr i
        }
      }
      set type $next_type
      set range $next_range
      set subtype ""
      set subdata ""
      set genbank_type_list [list]
      set genbank_data_list [list]
      set Apeinfo_label ""
      set Apeinfo_fwd ""
      set Apeinfo_rev ""
      set Apeinfo_gformat ""
      set c 0
    }
  }
}

##also need to return $source_tag
  return $result
}

##############
## interpret pdraw features list
##############
proc pdraw_features_to_taglist {pdrawlist} {
  global info
  set result [list]
  set i 0
  set fwd_color cyan
  set rev_color cyan
  set type "misc_feature"
  if {[catch {set Apeinfo_gformat [dict get $info(feature_default_type_gformat) $type]}]} {
    set Apeinfo_gformat $info(feature_default_gformat)
  }
  set genbank_list [list]
  foreach ft $pdrawlist {
    foreach {name start end type orient} $ft {}
    incr start -1
    incr end -1
    set dir [expr {($orient == -1) ? 0:1}]
    if {$dir == 0} {
      set formatlist [list $fwd_color {} {}]
    } else {
      set formatlist [list $rev_color {} {}]
    }
    set bindlist [list <<Revcolors>> <<Metadata>>]
    set actionlist [list [list $fwd_color $rev_color] [list $name $Apeinfo_gformat $type $dir $genbank_list]]
    lappend result "f$i#" [list [list $start $end] $formatlist $bindlist $actionlist]
  }
  return $result
}

##############
## reads a new feature library and stores the feature list in fea_info(library) 
##############
#file format(tab sep): (0)name (1)plain text def (2)type (3)fwd_color (4)rev_color (5)bold (6)ital (7)annotations_string
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string

proc open_feature_library {{filename ""} {mode "new"} {msg 1}} {

  global info
  global fea_info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1
  set error 1
  while {$error == 1} {
    if {($filename == "") || (![file exists $filename])} {
      set focus_win [focus]
      if {![file isdirectory $info(default_featuredir)]} {
        global argv0
        set info(default_featuredir) [file dirname $argv0]
      }
      set filename [tk_getOpenFile -initialdir $info(default_featuredir) -title [mc "open ApE Features file"]]
      if {([winfo exists $focus_win]) && ($focus_win != ".")} {
        wm deiconify [winfo toplevel $focus_win]
        focus $focus_win
      }
    }

    set templibrary [read_feature_library $filename]

    if {[lindex $templibrary 0] == "invalid file" } {
      if {[tk_messageBox -message "$filename is an improperly formatted feature library. \n [string range [lindex $templibrary 1] 0 200]\nTry another?" -type yesno -icon error -default yes] == "yes"} {
        set error 1; #try again
        set filename ""
      } else {
        set error -1; #cancel
      }
    } elseif {$templibrary == "invalid filename"} {
      if {($filename != "") && ([tk_messageBox -message "$filename is not readable. \n $nextfea\nTry another?" -type yesno -icon error -default yes] == "yes")} {
        set error 1; #try again
        set filename ""
      } else {
        set error -1; #cancel
      }
    } else {
      set error 0
    }
  }
 ; #while error reading file
  if {$error == 0} {
    if {$mode == "new"} {
      set fea_info(library) $templibrary
      if {[tk windowingsystem] == "win32"} {
        regsub -all {\\} $filename {/} filename
      }
      set fea_info(library_file) $filename
      if {$msg} {
        tk_messageBox -message [mc "Read %1\$s features from %2\$s." [llength $templibrary] [file tail $filename]] -type ok -icon info
      }
    } else {
      lappend fea_info(library) $templibrary
      set fea_info(library_file) ""
    }

    if {$info(featuredir_follows_open)} {
      set info(default_featuredir) [file dirname $filename]
    }
  } 
  set dialogblock 0
}

##############
## reads a feature library and returns it as list 
##############
#file format(tab sep): (0)name (1)plain_text_def (2)type (3)fwd_color (4)rev_color (5)bold (6)ital (7)annotations_string
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string
proc read_feature_library {filename} {
  global info
    if {![catch {set fileid [open $filename r]}]} {
      set templibrary ""
      while {([eof $fileid] != 1)} {
        set nextline [gets $fileid]
        if {([string index $nextline 0] != "#") && ($nextline != "")} {
          set nextfea [split $nextline \t]
          if {([llength $nextfea] < 2) ||([llength $nextfea] > 8) || ([regexp -nocase {[^ACGTNBDHKMRSVWY\s\+\#<>]} [lindex $nextfea 1]] == 1)} {
            close $fileid
            return [list "invalid file" $nextfea]
          } else {
            set nextfea [concat $nextfea [lrange {{} {} {} {} {}} 0 [expr {6-[llength $nextfea]}]]]

            ######set defaults here
            if {[lindex $nextfea 2] == ""} {set nextfea [lreplace $nextfea 2 2 "misc_feature"]}
            if {[catch {winfo rgb . [lindex $nextfea 3]}]} {sputs "bad color name:[lindex $nextfea 3]"; set nextfea [lreplace $nextfea 3 3 $info(feature_default_fcolor)]}
            if {[catch {winfo rgb . [lindex $nextfea 4]}]} {sputs "bad color name:[lindex $nextfea 4]"; set nextfea [lreplace $nextfea 4 4 $info(feature_default_rcolor)]}
            if {[lindex $nextfea 5] != 1} {set nextfea [lreplace $nextfea 5 5 0]}
            if {[lindex $nextfea 6] != 1} {set nextfea [lreplace $nextfea 6 6 0]}


            ######set the regexp strings
            set regexpfwd [lindex $nextfea 1]
            #for all lower case, set to all upper case
            if {![regexp {[A-Z]} $regexpfwd]} {set regexpfwd [string toupper $regexpfwd]}   
            if {![regexp {(.*)<(.*)} $regexpfwd a preseq regexpfwd]} {
              set preseq ""
              ######for primer sequences, set the preseq to all leading lower case chars
              if {[lindex $nextfea 2] == "primer_bind"} {
                if {![regexp {([a-z]+)([^a-z]+.*)} $regexpfwd a preseq regexpfwd]} {
                  set preseq ""
                }
                set regexpfwd [string toupper $regexpfwd]
              }
            }
            if {![regexp {(.*)>(.*)} $regexpfwd a regexpfwd postseq]} {set postseq ""}
            set regexpfwd "($regexpfwd)"
            set preseq [string toupper $preseq]
            set postseq [string toupper $postseq]
            regsub -all {\s} $regexpfwd "" regexpfwd
            regsub -all {[a-z]+} $regexpfwd ")&(" regexpfwd
            regsub -all {[nN]} $regexpfwd "." regexpfwd
            #remove duplicate + and #
            regsub -all {\++} $regexpfwd "+" regexpfwd
            regsub -all {[\+\#][\+\#]+} $regexpfwd "#" regexpfwd
            #remove leading and trailing # and +
            regsub -all {^\+} $regexpfwd "" regexpfwd
            regsub -all {^\#} $regexpfwd "" regexpfwd
            regsub -all {\+$} $regexpfwd "" regexpfwd
            regsub -all {\#$} $regexpfwd "" regexpfwd
            #convert # and + to .*?
            regsub -all {\+} $regexpfwd ").*?(" regexpfwd
            regsub -all {\#} $regexpfwd ".*?" regexpfwd
            #remove empty parens
            regsub -all {\(\)} $regexpfwd "" regexpfwd

            #substitute degenerate codes
            set regexpfwd [regsubpattern $regexpfwd]

            #make the reverse pattern
            set regexprev [revcom_regexp $regexpfwd]
            regsub -all {\?\*\.} $regexprev .*? regexprev


            if {[string length [regsub -all -nocase {[^a-z]} $regexpfwd ""]] > 3} {
              #featurelib element:
              #(0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string
              if {$regexpfwd != $regexprev} {
                lappend templibrary [linsert $nextfea 1 $regexpfwd $regexprev $preseq $postseq]
              } else {
                lappend templibrary [linsert $nextfea 1 $regexpfwd "" $preseq $postseq]
              }
            } else {
              sputs "Feature too short:[lindex $nextfea 0] $regexpfwd"
            }
          }
        }
      }; #while not end of file
      close $fileid
      return $templibrary
    } else {
      #file doesn't exist
      return "invalid filename"
    }
}

##############
## lists feature tags found in a DNA window 
##############
proc list_features {w {text_only 0}} {
  global info toolbar_images
  global modstring modifier dialogblock
  if {($text_only == 0)} {
    if {($dialogblock == 1)} {return}
    set dialogblock 1
  }

#set t $a.textframe.text
#$t image create 7.0 -image $toolbar_images(info_button)
#$t tag add 7.0 7.0 button_tag
#$t tag bind button_tag <Enter> "$t configure -cursor arrow"
#$t tag bind button_tag <Leave> "$t configure -cursor xterm"

  if {!$text_only} {
    set a [new_analysis_window $w "Features List"]
    create_textframe $a 80
    $a.textframe.text configure -tabs {6c 9c}

    catch {$a.textframe.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
    $a.textframe.text insert end "$info($w,win_title) \n"
    $a.textframe.text insert end "$info($w,filename) \n"
    $a.textframe.text insert end "Features List\n\n"


    $a.textframe.text insert end "[mc "Name"]\t[mc "type"]\t[mc "location"]\n" heading
    $a.textframe.text tag configure heading -underline true
  }
  set result ""

  foreach tag [$w.textarea tag names] {
    if {([regexp {f[0-9]+#} $tag]) && ([llength [$w.textarea tag ranges $tag]] > 1)} {

      set metadata [$w.textarea tag bind $tag <<Metadata>>]

      set loc [feature_coords_text $w $tag]
      set direction [expr {[lindex $metadata 3]?"rev:":""}]



      set fn_tagrange [$w.textarea tag ranges [regsub f $tag fn]]
      if {[llength $fn_tagrange] > 0} {
        if {[llength $fn_tagrange] > 2} {
          set x1 [lindex $fn_tagrange 2]
          set x2 [lindex $fn_tagrange 3]
        } else {
          set x1 [lindex $fn_tagrange 0]
          set x2 [lindex $fn_tagrange 1]
        }
      } else {
        if {[llength [$w.textarea tag ranges $tag]] > 2} {
          set x1 [lindex [$w.textarea tag ranges $tag] 2]
          set x2 [lindex [$w.textarea tag ranges $tag] 3]
        } else {
          set x1 [lindex [$w.textarea tag ranges $tag] 0]
          set x2 [lindex [$w.textarea tag ranges $tag] 1]
        }
      }
      if {!$text_only} {
        $a.textframe.text insert end "[lindex $metadata 0]\t[lindex $metadata 2]\t$direction$loc\n" $tag
        $a.textframe.text tag bind $tag <Button-1> "select_region $w \[bp2ix $w.textarea [ix2bp $w.textarea $x1]\] \[bp2ix $w.textarea [ix2bp $w.textarea $x2]\]"
        lappend info($w,linked_events) [list $a.textframe.text $tag <Button-1>]
        $a.textframe.text tag bind $tag <Any-Enter> "%W tag configure $tag -foreground red; %W tag raise $tag sel"
        $a.textframe.text tag bind $tag <Any-Leave> "%W tag configure $tag -foreground black; %W tag lower $tag sel"
      } else {
        set result "$result[lindex $metadata 0]\t[lindex $metadata 2]\t$direction$loc\n"
      }
    }
  }

  if {!$text_only} {
    set outputmenu [add_output_menu $a.textframe.text "Text" text $w]
    bind $a <Button-1> "focus $a.textframe.text" 
    bindtags $a.textframe.text [list $a.textframe.text AnalysisText . all]
    wm deiconify $a
    window_on_screen $a
    focus $a.textframe.text
  }
  if {($text_only == 0)} {
    set dialogblock 0
  }
  return $result
}

##############
## edit a feature element
##############
#file format(tab sep): (0)name (1)plain_text_def (2)type (3)fwd_color (4)rev_color (5)bold (6)ital (7)annotations_string
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string
proc edit_feature {w feature_number} {
  global info temp_info temp_colors fea_info ok2 dialogblock clip_sel
  if {$dialogblock == 1} {return}
  set dialogblock 1

  set temp_info(name) [lindex [lindex $fea_info(library) $feature_number] 0]
  set temp_info(regexp) [lindex [lindex $fea_info(library) $feature_number] 5]
  set temp_info(fwd_color) [lindex [lindex $fea_info(library) $feature_number] 7]
  set temp_info(rev_color) [lindex [lindex $fea_info(library) $feature_number] 8]
  set temp_info(type) [lindex [lindex $fea_info(library) $feature_number] 6]
  set temp_info(notes) [lindex [lindex $fea_info(library) $feature_number] 11]
  array set temp_colors $info(feature_default_type_colors)

  set a [toplevel .edit_feature_dialog]
  wm title $a [mc "Edit Feature Definition..."]
  wm protocol $a WM_DELETE_WINDOW "set ok2 -1"
  bind $a <KeyPress-Escape>  "set ok2 -1"
  set raisedialogstore [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify $a; raise $a"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $a "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $a $w
  } else {
    ::tk::unsupported::MacWindowStyle style $a document {closeBox}
  }
  set ok2 0

  grid [frame $a.textframe -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  grid [frame $a.infoframe -relief ridge -borderwidth 2] -row 1 -column 1 -sticky nswe
  grid [frame $a.okframe -relief ridge -borderwidth 2] -row 2 -column 1 -columnspan 2 -sticky nswe
  grid rowconfigure $a 0 -weight 1
  grid rowconfigure $a 1 -weight 0
  grid rowconfigure $a 2 -weight 0
  grid columnconfigure $a 1 -weight 1

  grid [entry $a.textframe.name -textvariable temp_info(name) -font dnafont -width 50] -row 0 -column 0 -columnspan 2 -sticky nwe

  grid [text $a.textframe.regexp -height 10 -width 50 -wrap char -yscrollcommand "optionscrollbar $a.textframe.scroll" -font dnafont] -row 1 -column 0 -sticky nswe
  grid [scrollbar $a.textframe.scroll -command "$a.textframe.regexp yview"] -row 1 -column 1 -sticky nse
  grid [frame $a.textframe.buttons] -row 2 -column 0 -columnspan 2 -sticky nswe
  grid [button $a.textframe.buttons.upper -text [mc "Uppercase"] -command "event generate $a.textframe.regexp <<toupper>>"] -row 0 -column 0 -sticky ns
  grid [button $a.textframe.buttons.lower -text [mc "Lowercase"] -command "event generate $a.textframe.regexp <<tolower>>"] -row 0 -column 1 -sticky ns
  grid [button $a.textframe.buttons.lowertoplus -text [mc "Lowercase to +"] -command "event generate $a.textframe.regexp <<lowertoplus>>"] -row 0 -column 2 -sticky ns

  grid rowconfigure $a.textframe 1 -weight 1
  grid columnconfigure $a.textframe 0 -weight 1

  $a.textframe.regexp insert 1.0 $temp_info(regexp)

  grid [label $a.infoframe.label1 -text [mc "Feature type:"]] -row 0 -column 1
  grid [menubutton $a.infoframe.type -menu $a.infoframe.type.menu -textvariable temp_info(type) -font labelfont -width 10] -row 0 -column 2
  grid [label $a.infoframe.label2 -text [mc "Forward color:"]] -row 1 -column 1
  grid [color_button $a.infoframe.fwdcolor temp_info(fwd_color) $temp_info(fwd_color) 12] -sticky w -row 1 -column 2
  grid [label $a.infoframe.label3 -text [mc "Reverse color:"]] -row 1 -column 3
  grid [color_button $a.infoframe.revcolor temp_info(rev_color) $temp_info(rev_color) 12] -sticky w -row 1 -column 4
  grid [button $a.infoframe.revcolor_same -text [mc "Same"] -command "set temp_info(rev_color) \$temp_info(fwd_color)"] -sticky w -padx 5 -row 1 -column 5
  grid [menubutton $a.infoframe.favs -menu $a.infoframe.favs.menu -text [mc "Favorites"] -width 10] -sticky w -padx 5 -row 1 -column 6
  menu $a.infoframe.favs.menu
  fill_favs_menu $a $a.infoframe.favs.menu temp_info(fwd_color) temp_info(rev_color)

  trace add variable info(feature_color_favorites) write "fill_favs_menu $a $a.infoframe.favs.menu temp_info(fwd_color) temp_info(rev_color);# "
  trace add variable temp_info(fwd_color) write  "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \[lindex \$temp_colors(\$temp_info(type)) 1\]\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"
  trace add variable temp_info(rev_color) write "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \[lindex \$temp_colors(\$temp_info(type)) 0\] \$temp_info(rev_color)\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"

  grid [button $a.okframe.ok -text [mc "OK"] -command "set ok2 1"] -row 0 -column 0

  menu $a.infoframe.type.menu
  set typelist [list primer_bind CDS exon intron 5'UTR 3'UTR mRNA prim_transcript precursor_RNA 5'clip 3'clip misc_RNA rep_origin gene promoter enhancer polyA_site polyA_signal terminator CAAT_signal TATA_signal -35_signal -10_signal GC_signal RBS attenuator misc_signal sig_peptide transit_peptide mat_peptide variation STS unsure conflict modified_base misc_difference old_sequence misc_feature LTR repeat_region repeat_unit satellite rRNA tRNA scRNA snRNA snoRNA protein_bind misc_binding misc_recomb misc_structure iDNA stem_loop D-loop C_region D_segment J_segment N_region S_region V_region V_segment] 
  set divided_typelist [list Genes [list promoter CDS exon intron gene 5'UTR 3'UTR polyA_site mRNA prim_transcript precursor_RNA 5'clip 3'clip] Signals [list rep_origin promoter enhancer polyA_site polyA_signal terminator CAAT_signal TATA_signal -35_signal -10_signal GC_signal RBS attenuator misc_signal sig_peptide transit_peptide mat_peptide] Binding [list primer_bind protein_bind misc_binding] Variation [list variation STS unsure conflict modified_base misc_difference old_sequence] Repeats [list LTR repeat_region repeat_unit satellite] RNA [list mRNA rRNA tRNA scRNA snRNA snoRNA misc_RNA] Misc [list misc_feature misc_binding misc_recomb misc_structure iDNA stem_loop D-loop] Ig [list C_region D_segment J_segment N_region S_region V_region V_segment]] 
  foreach {header types} $divided_typelist {
    $a.infoframe.type.menu add cascade -label $header -menu [menu $a.infoframe.type.menu.[string tolower $header]]
    foreach type $types {
      if {[string index $type 0] eq "-"} {set typelabel " $type"} else {set typelabel $type}
      $a.infoframe.type.menu.[string tolower $header] add radiobutton -label $typelabel -variable temp_info(type) -value $type -command "if {\[info exists temp_colors($type)\]} {set temp_info(fwd_color) \[lindex \$temp_colors($type) 0\]; set temp_info(rev_color) \[lindex \$temp_colors($type) 1\]} else {set temp_info(fwd_color) $info(feature_default_fcolor); set temp_info(rev_color) $info(feature_default_rcolor); set temp_colors($type) \[list $info(feature_default_fcolor) $info(feature_default_rcolor)\]}"
    }
  }
  if {[lsearch -exact $typelist $temp_info(type)] == -1} {
    $a.infoframe.type.menu add radiobutton -label $temp_info(type) -variable temp_info(type) -value $temp_info(type) -command "if {\[info exists temp_colors($type)\]} {set temp_info(fwd_color) \[lindex \$temp_colors($type) 0\]; set temp_info(rev_color) \[lindex \$temp_colors($type) 1\]} else {set temp_info(fwd_color) $info(feature_default_fcolor); set temp_info(rev_color) $info(feature_default_rcolor); set temp_colors($type) \[list $info(feature_default_fcolor) $info(feature_default_rcolor)\]}"
  }
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $a] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $a "+$winx+$winy"
  update

  bind $a.textframe.regexp <<toupper>> "
    if {\[$a.textframe.regexp tag ranges sel\] != {}} {
      set temptext \[$a.textframe.regexp get sel.first sel.last\] 
      $a.textframe.regexp delete sel.first sel.last
      $a.textframe.regexp insert insert \[string toupper \$temptext\]
      $a.textframe.regexp tag add sel insert-\[string length \$temptext\]char insert
      unset temptext
    }
  "
  bind $a.textframe.regexp <<tolower>> "
    if {\[$a.textframe.regexp tag ranges sel\] != {}} {
      set temptext \[$a.textframe.regexp get sel.first sel.last\] 
      $a.textframe.regexp delete sel.first sel.last
      $a.textframe.regexp insert insert \[string tolower \$temptext\]
      $a.textframe.regexp tag add sel insert-\[string length \$temptext\]char insert
      unset temptext
    }
  "

  bind $a.textframe.regexp <<lowertoplus>> "
    set temptext \[$a.textframe.regexp get 1.0 end\]
    $a.textframe.regexp delete 1.0 end
    $a.textframe.regexp insert 1.0 \[regsub -all {\[a-z\\s\]+} \$temptext +\]
    unset temptext
  "
  bind $a.textframe.regexp <<Paste>> "
    if {![catch {::tk::GetSelection $a.textframe.regexp CLIPBOARD} clip_sel]} {
      if {\[tk windowingsystem\] ne \"x11\"} {
        catch {$a.textframe.regexp delete sel.first sel.last}
      }
      regsub -all -nocase {\[^ACGTNBDHKMRSVWY\\+\\#<>\]} \$clip_sel \"\" clip_sel
      $a.textframe.regexp insert insert \$clip_sel
    }
   break
  "

  focus $a
  $a.textframe.name selection range 0 end
  focus $a.textframe.name
  set continue 1

  while {$continue} {

    vwait ok2
    ###execute changes
    if {$ok2 == 1} {
      set featuretext [$a.textframe.regexp get 1.0 end]
      regsub -all "\ +" $featuretext "" featuretext 
      regsub -all "\n+" $featuretext "" featuretext 
      set regexpfwd $featuretext
      #for all lower case, set to all upper case
      if {![regexp {[A-Z]} $regexpfwd]} {set regexpfwd [string toupper $regexpfwd]}   
      if {![regexp {(.*)<(.*)} $regexpfwd fill preseq regexpfwd]} {
        set preseq ""
        ######for primer sequences, set the preseq to all leading lower case chars
        if {$temp_info(type) == "primer_bind"} {
          if {![regexp {([a-z]+)([^a-z]+.*)} $regexpfwd fill preseq regexpfwd]} {
            set preseq ""
          }
          set regexpfwd [string toupper $regexpfwd]
        }
      }
      if {![regexp {(.*)>(.*)} $regexpfwd blank regexpfwd postseq]} {set postseq ""}
      set regexpfwd "($regexpfwd)"
      set preseq [string toupper $preseq]
      set postseq [string toupper $postseq]
      regsub -all {\s} $regexpfwd "" regexpfwd
      regsub -all {[a-z]+} $regexpfwd ")&(" regexpfwd
      regsub -all {[nN]} $regexpfwd "." regexpfwd
      #remove duplicate + and #
      regsub -all {\++} $regexpfwd "+" regexpfwd
      regsub -all {[\+\#][\+\#]+} $regexpfwd "#" regexpfwd
      #remove leading and trailing # and +
      regsub -all {^\+} $regexpfwd "" regexpfwd
      regsub -all {^\#} $regexpfwd "" regexpfwd
      regsub -all {\+$} $regexpfwd "" regexpfwd
      regsub -all {\#$} $regexpfwd "" regexpfwd
      #convert # and + to .*?
      regsub -all {\+} $regexpfwd ").*?(" regexpfwd
      regsub -all {\#} $regexpfwd ".*?" regexpfwd
      #remove empty parens
      regsub -all {\(\)} $regexpfwd "" regexpfwd

      #substitute degenerate codes
      set regexpfwd [regsubpattern $regexpfwd]

      #make the reverse pattern
      set regexprev [revcom_regexp $regexpfwd]
      regsub -all {\?\*\.} $regexprev .*? regexprev


      if {[string length [regsub -all -nocase {[^a-z]} $regexpfwd ""]] > 3} {
        #featurelib element:
        #(0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string
        if {$regexpfwd != $regexprev} {
          set newfea [list $temp_info(name) $regexpfwd $regexprev $preseq $postseq $featuretext $temp_info(type) $temp_info(fwd_color) $temp_info(rev_color) 0 0 ""]
        } else {
          set newfea [list $temp_info(name) $regexpfwd "" $preseq $postseq $featuretext $temp_info(type) $temp_info(fwd_color) $temp_info(rev_color) 0 0 ""]
        }
        #sputs $newfea
        set fea_info(library) [lreplace [K $fea_info(library) [set fea_info(library) {}]] $feature_number $feature_number $newfea]
        set return "ok"
        set continue 0

      } else {
        bell
        tk_messageBox -message "$preseq<$regexpfwd>$postseq isn't valid, try again." -icon warning -type ok 
        set ok2 0
        set continue 1

      }
    } else {
      set return "cancel"
      set continue 0

    }
  }


  set dialogblock 0
  destroy $a
  bind . <<RaiseDialogs>> $raisedialogstore
  bind $w <FocusIn> ""
  bind $w <Map> ""
  bind $w <Activate> ""
  trace remove variable temp_info(fwd_color) write  "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \[lindex \$temp_colors(\$temp_info(type)) 1\]\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"
  trace remove variable temp_info(rev_color) write "if {\[info exists temp_colors(\$temp_info(type))\]} {set temp_colors(\$temp_info(type)) \[list \[lindex \$temp_colors(\$temp_info(type)) 0\] \$temp_info(rev_color)\]} else {set temp_colors(\$temp_info(type)) \[list \$temp_info(fwd_color) \$temp_info(rev_color)\]} ;#"
  set info(feature_default_type_colors) [array get temp_colors]

  unset ok2 clip_sel
  array unset temp_info 
  array unset temp_colors
  set return $return
}

##############
## adds selected DNA to curent feature library via edit_feature
##############
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string

proc add_sel_feature_library {w} {
  global info fea_info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {[$w.textarea tag ranges sel] != {}} {
    set text [textarea_get $w.textarea sel.first sel.last]
    set regexpfwd $text
    regsub -all {[a-z]+} $regexpfwd ")&(" regexpfwd
    regsub -all {[nN]} $regexpfwd "." regexpfwd
    regsub -all {\(\)} $regexpfwd "" regexpfwd
    set regexpfwd [regsubpattern $regexpfwd]

    set regexprev [revcom_regexp $regexpfwd]
    regsub -all {\?\*\.} $regexprev .*? regexprev
  } else {
    set text ""
    set regexpfwd ""
    set regexprev ""
  }
  set new_fea [list "New Feature" "($regexpfwd\)" "($regexprev\)" "" "" $text "misc_feature" $info(feature_default_fcolor) $info(feature_default_rcolor)]
  set dialogblock 0
  edit_feature_library $w $new_fea
}

##############
## edit, import and save curent feature library
##############
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string

proc edit_feature_library {w {new_fea ""}} {
#new
#import
#save as
  global info fea_info new_fea_global
  global ok
  global mem deleted dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  toplevel .dialog
  wm title .dialog [mc "Edit Feature Library..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"

  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  bind .dialog <FocusIn> "event generate . <<RaiseDialogs>>"
  bind .dialog <Map> "event generate . <<RaiseDialogs>>"
  bind .dialog <Activate> "event generate . <<RaiseDialogs>>"

  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox resizable}
  }
  set ok 0

  set library_store $fea_info(library)

  #menu .dialog.menubar
  #menu .dialog.menubar.librarymenu
  #  .dialog.menubar add cascade -menu .dialog.menubar.librarymenu -label [mc "Library"]
  #  .dialog.menubar.librarymenu add command -label [mc "Import Features from Feature File"]  -state disabled  -command "bell"
  #  .dialog.menubar.librarymenu add command -label [mc "Import Features from DNA Sequence"]  -state disabled  -command "bell"
  #  .dialog.menubar.librarymenu add command -label [mc "Save As..."] -command "set dialogblock 0; save_feature_library; set dialogblock 1"

  #.dialog configure -menu .dialog.menubar

  #if {[tk windowingsystem] == "aqua"} {
    #define the apple menu
    #menu .dialog.menubar.apple
    #.dialog.menubar add cascade -menu .dialog.menubar.apple
    #.dialog.menubar.apple add command -label [mc "About ApE"] -command "about_dialog $w" -state disabled
    #.dialog.menubar.apple add separator
    #.dialog.menubar.apple add command -label [mc "Preferences..."]  -command "configure_preferences $w" -state disabled 
  #}


  grid [frame .dialog.frame1 -relief flat] -row 0 -column 0 -sticky nswe
  grid [listbox .dialog.frame1.list -yscrollcommand "optionscrollbar .dialog.frame1.scroll" -selectmode extended -activestyle none -background white -exportselection 0] -row 0 -column 0 -sticky nswe
  grid [scrollbar .dialog.frame1.scroll -command ".dialog.frame1.list yview"] -row 0 -column 1 -sticky nse
  grid rowconfigure .dialog.frame1 0 -weight 1
  grid columnconfigure .dialog.frame1 0 -weight 1
  grid columnconfigure .dialog.frame1 1 -weight 0
  grid [frame .dialog.frame2 -relief ridge -borderwidth 2] -row 1 -column 0 -sticky swe
  grid [button .dialog.frame2.selall -text [mc "Select All"] -command "event generate .dialog <<sel_all>>"] -row 0 -column 0 -sticky we
  grid [button .dialog.frame2.raise -text [mc "Raise"] -command "event generate .dialog <<raise>>"] -row 0 -column 1 -sticky we
  grid [button .dialog.frame2.lower -text [mc "Lower"] -command "event generate .dialog <<lower>>"] -row 0 -column 2 -sticky we
  grid [button .dialog.frame2.delete -text [mc "Delete"] -command "event generate .dialog <<delete>>"] -row 0 -column 3 -sticky we
  grid [button .dialog.frame2.edit -text [mc "Edit"] -command "
    if {\[.dialog.frame1.list curselection\] != {}} {
      set dialogblock 0
      set pointer \[lindex \[.dialog.frame1.list curselection\] 0 \]
      edit_feature .dialog \$mem(\$pointer)
      set dialogblock 1
      .dialog.frame1.list delete \$pointer
      .dialog.frame1.list insert \$pointer \[lindex \[lindex \$fea_info(library) \$mem(\$pointer)] 0\]
      .dialog.frame1.list itemconfigure \$pointer -background \[lindex \[lindex \$fea_info(library) \$mem(\$pointer)] 7\]
      .dialog.frame1.list selection set \$pointer
      unset pointer
    }
  "] -row 0 -column 4 -sticky we
  grid [button .dialog.frame2.new -text [mc "New"] -command "event generate .dialog <<new>>"] -row 0 -column 5 -sticky we


  grid [frame .dialog.frame3 -relief raised] -row 2 -column 0 -sticky swe
  grid [button .dialog.frame3.ok -text [mc "Save Changes"] -command "set ok 1" -default active] -row 0 -column 0 -padx 5 -pady 3 -sticky we
  bind .dialog <Key-Return> "set ok 1"
  grid [button .dialog.frame3.ok_scan -text [mc "Save Changes As..."] -command "set ok 2"] -row 0 -column 1 -padx 5 -pady 3 -sticky we
  grid [button .dialog.frame3.cancel -text [mc "Cancel"] -command "set ok -1"] -row 0 -column 2 -padx 5 -pady 3 -sticky we
  grid [checkbutton .dialog.frame3.scan -text [mc "Scan on Close"] -variable info(feature_scan_on_close) -onvalue 1 -offvalue 0 -selectcolor white] -row 0 -column 3 -padx 5 -pady 3 -sticky we
  grid [label .dialog.filelabel -textvariable fea_info(library_file) -justify right -width 50] -row 3 -column 0 -sticky new
  grid rowconfigure .dialog 0 -weight 1
  grid rowconfigure .dialog 1 -weight 0
  grid rowconfigure .dialog 2 -weight 0
  grid columnconfigure .dialog 0 -weight 1

  #bind .dialog.frame1.list <Shift-Button-1> {listbox_multiple %W [%W index @%x,%y];break}
  #bind .dialog.frame1.list <Button-1> {bell; .dialog.frame1.list selection clear 0 end; .dialog.frame1.list selection set [%W index @%x,%y]}

  bind .dialog.frame1.list <Double-Button-1> "
    set dialogblock 0
    set pointer \[%W index @%x,%y\]
    edit_feature .dialog \$mem(\$pointer)
    set dialogblock 1
    .dialog.frame1.list delete \$pointer
    .dialog.frame1.list insert \$pointer \[lindex \[lindex \$fea_info(library) \$mem(\$pointer)] 0\]
    .dialog.frame1.list itemconfigure \$pointer -background \[lindex \[lindex \$fea_info(library) \$mem(\$pointer)] 7\]
    unset pointer
  "



  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry .dialog "+$winx+$winy"
  update
  focus .dialog.frame1.list


  bind .dialog <<fill_list>> {
    array unset mem
    set i [expr {[llength $fea_info(library)]-1}]
    set n 0
    foreach feature $fea_info(library) {
      .dialog.frame1.list insert 0 [lindex $feature 0]
      .dialog.frame1.list itemconfigure 0 -background [lindex $feature 7]
      set mem($i) $n
      incr i -1
      incr n 1
    }
    set feature ""
    unset n i feature
    set deleted [list]
    .dialog.frame1.list selection set 0
    .dialog.frame1.list selection anchor 0
  }

  bind .dialog <<sel_all>> {
    .dialog.frame1.list selection set 0 end
    .dialog.frame1.list selection anchor 0
  }

  bind .dialog <<raise>> {
    foreach i [.dialog.frame1.list curselection] {
      if {$i > 0} {
        set nstore [.dialog.frame1.list get $i]
        set cstore [.dialog.frame1.list itemcget $i -background]
        .dialog.frame1.list delete $i
        set tstore $mem($i)
        set mem($i) $mem([expr {$i-1}])
        incr i -1
        .dialog.frame1.list insert $i $nstore
        .dialog.frame1.list itemconfigure $i -background $cstore       
        set mem($i) $tstore
        .dialog.frame1.list selection set $i
        unset nstore cstore tstore
      }

    }
    if {[.dialog.frame1.list curselection] != {}} {
      .dialog.frame1.list see [lindex [.dialog.frame1.list curselection] 0]
      unset i
    }

  } 

  bind .dialog <<lower>> {
    for {set j [expr {[llength [.dialog.frame1.list curselection]]-1}]} {$j > -1} {incr j -1} {
      set i [lindex [.dialog.frame1.list curselection] $j]
      if {$i < [expr {[.dialog.frame1.list index end] -1}]} {
        set nstore [.dialog.frame1.list get $i]
        set cstore [.dialog.frame1.list itemcget $i -background]
        .dialog.frame1.list delete $i
        set tstore $mem($i)
        set mem($i) $mem([expr {$i+1}])
        incr i 1
        .dialog.frame1.list insert $i $nstore
        .dialog.frame1.list itemconfigure $i -background $cstore       
        set mem($i) $tstore
        .dialog.frame1.list selection set $i
        unset nstore cstore tstore
      }
    }
    if {[.dialog.frame1.list curselection] != {}} {
      .dialog.frame1.list see [lindex [.dialog.frame1.list curselection] end]
      unset i j
    }
  }
  bind .dialog <<delete>> {
    if {[tk_messageBox -title "Delete features from Library" -message "Are you sure you want to delete [llength [.dialog.frame1.list curselection]] features from the library?" -type okcancel -icon question] == "ok"} {
      for {set j [expr {[llength [.dialog.frame1.list curselection]]-1}]} {$j > -1} {incr j -1} {
        set i [lindex [.dialog.frame1.list curselection] $j]
        .dialog.frame1.list delete $i
        .dialog.frame1.list selection set $i
        lappend deleted $mem($i)
        while {$i <= [expr {[.dialog.frame1.list index end] - 1}]} {
          set mem($i) $mem([expr {$i+1}])
          incr i
        }
        array unset mem $i 
      }
      unset j i
    }
  } 

  bind .dialog <<new>> {
    if {![info exists new_fea_global] || ($new_fea_global == "")} {
      set new_fea_global [list "New Feature" "" "" "" "" "" "misc_feature" $info(feature_default_fcolor) $info(feature_default_rcolor)]
    }
    lappend fea_info(library) $new_fea_global
    set dialogblock 0
    set result [edit_feature .dialog [expr {[llength $fea_info(library)]-1}]]
    sputs "result=$result"
    if {$result != "ok"} {
      set fea_info(library) [lrange $fea_info(library) 0 end-1]
    } else {
      for {set i [.dialog.frame1.list index end]} {$i > 0} {incr i -1} {
        set mem($i) $mem([expr {$i-1}])
      }
      set mem(0) [expr {[llength $fea_info(library)]-1}]
      .dialog.frame1.list insert 0 [lindex [lindex $fea_info(library) end] 0]
      .dialog.frame1.list itemconfigure 0 -background [lindex [lindex $fea_info(library) end] 7]
      .dialog.frame1.list selection clear 0 end
      .dialog.frame1.list selection set 0
      .dialog.frame1.list selection anchor 0
      unset i
    }
    set new_fea_global ""
  }


  event generate .dialog <<fill_list>>

 ##if select !=-1, then we are editing a new element
  if {$new_fea != {}} {
    set new_fea_global $new_fea
    event generate .dialog <<new>>
  }
  vwait ok
  set dialogblock 0
  destroy .dialog

  bind . <<RaiseDialogs>> ""

  if {$ok > 0} {
    ##put the changes into the feature library
    foreach i [lsort -decreasing -integer [array names mem]] {
      lappend new_feature_list [lindex $fea_info(library) $mem($i)]
    }
    set fea_info(library) $new_feature_list

    if {$ok == 1} { 
      save_feature_library $fea_info(library_file)
    } elseif {$ok ==2} {
      save_feature_library
    }

    if {$info(feature_scan_on_close) == 1} {
      feature_scan $w
    }
  } else {
    ###revert to the saved version of the file
    set fea_info(library) $library_store
  }

  unset -nocomplain ok deleted new_fea_global
  array unset mem

}

##############
## save a feature library
##############
#file format(tab sep): (0)name (1)plain_text_def (2)type (3)fwd_color (4)rev_color (5)bold (6)ital (7)annotations_string
#library list: (0)name (1)regexp_fwd(flanked by paren) (2)regexp_rev (3)preseq (4)postseq (5)plain_text_def (6)type (7)fwd_color (8)rev_color (9)bold (10)ital (11)annotations_string
proc save_feature_library {{filename ""}} {
  global info fea_info
  global mem deleted dialogblock

  if {$dialogblock == 1} {return}
  set dialogblock 1
  if {![file isdirectory $info(default_featuredir)]} {
    global argv0
    set info(default_featuredir) [file dirname $argv0]
  }
  if {[set parent_win [focus]] == ""} {
    set parent_win .
  }
  set parent_win [winfo toplevel $parent_win]
  if {![file exists $filename]} {
    set filename [tk_getSaveFile -title "Save Feature File" -parent $parent_win -initialdir $info(default_featuredir) -defaultextension ".txt"]
  }

  while {($filename != "") && ([catch {set feature_file [open $filename w]}])} {
    catch {close $feature_file}
    tk_messageBox -title "Feature File not Writable" -message "The file \"$filename\" is not writable. It may be locked." -type ok -icon warning -default ok
    set filename [tk_getSaveFile -title "Save Feature File" -initialdir $info(default_featuredir) -defaultextension ".txt"]
  }

  if {$filename != ""} {
  
    foreach feature $fea_info(library) {
      puts $feature_file "[lindex $feature 0]\t[lindex $feature 5]\t[lindex $feature 6]\t[lindex $feature 7]\t[lindex $feature 8]\t[lindex $feature 9]\t[lindex $feature 10]\t[lindex $feature 11]"
    }
    close $feature_file
    set fea_info(library_file) $filename

  } else {
      set fea_info(library_file) ""
  }
  set dialogblock 0
}

##############
## dialog box to edit feature color favorites
##############
proc edit_color_favorites {w} {
  global info temp_info2 dialogblock ok3

  if {$dialogblock == 1} {return}
  set dialogblock 1

  set temp_info2(color_favorites) $info(feature_color_favorites)

  set temp_info2(fwd_color)  [lindex [lindex $temp_info2(color_favorites) 0] 1]
  set temp_info2(rev_color)  [lindex [lindex $temp_info2(color_favorites) 0] 2]

  set a [toplevel .edit_color_favorites]
  wm title $a [mc "Edit Color Favorites..."]
  wm protocol $a WM_DELETE_WINDOW "set ok3 -1"
  bind $a <KeyPress-Escape>  "set ok3 -1"
  set raisedialogstore [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify $a; raise $a"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
sputs $w $winx $winy "+[expr min (max ($winx,0), [winfo vrootwidth .]-200)+3]+[expr min (max ($winy,0),[winfo vrootheight .]-200)+50]"
  wm geometry $a "+[expr min (max ($winx,0), [winfo vrootwidth .]-200)+3]+[expr min (max ($winy,0),[winfo vrootheight .]-200)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $a $w
  } else {
    ::tk::unsupported::MacWindowStyle style $a document {closeBox}
  }
  set ok3 0
 
  grid [frame $a.f1 -relief ridge -borderwidth 2] -sticky nswe -row 0 -column 0
  grid [frame $a.f1.listframe] -sticky nswe -row 0 -column 0 -columnspan 2
  grid [listbox $a.f1.listframe.listbox -width 30 -yscrollcommand "optionscrollbar $a.f1.listframe.vert" -selectmode single -activestyle none -background white -exportselection 0] -row 0 -column 0 -sticky nswe
  grid [scrollbar $a.f1.listframe.vert -orient vertical -command "$a.f1.listframe.listbox yview"] -row 0 -column 1 -sticky nsw
  grid rowconfigure $a.f1.listframe 0 -weight 1
  grid [button $a.f1.add -text [mc "Add New"] -command "event generate $a.f1.listframe.listbox <<ListboxAddNew>>"] -row 1 -column 0 -sticky n
  grid [button $a.f1.del -text [mc "Delete"] -command "event generate $a.f1.listframe.listbox <<ListboxDelete>>"] -row 1 -column 1 -sticky n
  grid rowconfigure $a.f1 0 -weight 1

  grid [frame $a.f2 -relief ridge -borderwidth 2] -sticky nswe -row 1 -column 0
  grid [entry $a.f2.name -width 20 -textvariable temp_info2(name) -validate key] -row 0 -column 0 -columnspan 4 -sticky nw
  grid [label $a.f2.l1 -text [mc "forward:"]] -row 1 -column 0 -sticky nw
  grid [color_button $a.f2.fwd_color temp_info2(fwd_color)] -row 1 -column 1 -sticky nw
  grid [label $a.f2.l2 -text [mc "reverse:"]] -row 1 -column 2 -sticky n
  grid [color_button $a.f2.rev_color temp_info2(rev_color)] -row 1 -column 3 -sticky nw
  grid [button $a.f2.same -text [mc "Same"] -command "set temp_info2(rev_color) \$temp_info2(fwd_color)"] -row 1 -column 4 -sticky nw

  grid [frame $a.f3 -relief ridge] -sticky nswe -row 2 -column 0
  grid [button $a.f3.ok -text [mc "OK"] -command "set ok3 1" -default active] -row 0 -column 1 -padx 10 -pady 3
  bind $a <Key-Return> "set ok2 1"
  grid [button $a.f3.cancel -text [mc "Cancel"] -command "set ok3 -1"] -row 0 -column 2 -padx 10 -pady 3

  grid columnconfigure $a 0 -weight 1
  grid rowconfigure $a 0 -weight 1



  foreach color_item $temp_info2(color_favorites) {
    $a.f1.listframe.listbox insert end [lindex $color_item 0]
    $a.f1.listframe.listbox itemconfigure end -background  [lindex $color_item 1]
  }

  #trace add variable temp_info2(name) write "event generate $a.f1.listframe.listbox <<ListboxUpdateselection>>;#"

  bind $a.f1.listframe.listbox <<ListboxAddNew>> "
    $a.f1.listframe.listbox configure -state normal
    lappend temp_info2(color_favorites) \[list \"\" \$info(feature_default_fcolor) \$info(feature_default_rcolor)\]
    $a.f1.listframe.listbox insert end \"\"
    $a.f1.listframe.listbox itemconfigure end -background \$info(feature_default_fcolor)
    $a.f1.listframe.listbox selection set end
    if {\$temp_info2(old_sel) > -1} {
      $a.f1.listframe.listbox selection clear \$temp_info2(old_sel)
    } else {
      $a.f2.name configure -state normal
      $a.f2.fwd_color configure -state normal
      $a.f2.rev_color configure -state normal
      $a.f1.del configure -state normal
    }
    event generate $a.f1.listframe.listbox <<ListboxSelect>>
  "

  $a.f2.name configure -vcmd "
    if {\$temp_info2(old_sel) > -1} {
      $a.f1.listframe.listbox delete \$temp_info2(old_sel)
      $a.f1.listframe.listbox insert \$temp_info2(old_sel) %P
      $a.f1.listframe.listbox itemconfigure \$temp_info2(old_sel) -background \$temp_info2(fwd_color)
      $a.f1.listframe.listbox selection set \$temp_info2(old_sel)
      $a.f1.listframe.listbox see \$temp_info2(old_sel)
    }
    expr {1}
  "

  bind $a.f1.listframe.listbox <<ListboxDelete>> "
    if {\$temp_info2(old_sel) > -1} {
      set temp_info2(color_favorites) \[lreplace \$temp_info2(color_favorites) \$temp_info2(old_sel) \$temp_info2(old_sel)\]
      $a.f1.listframe.listbox delete \$temp_info2(old_sel)
      if {\$temp_info2(old_sel) == \[$a.f1.listframe.listbox index end\]} {
        incr temp_info2(old_sel) -1
      }
      if {\$temp_info2(old_sel) == -1} {
          event generate $a.f1.listframe.listbox <<ListboxEmpty>>
      } else {
        $a.f1.listframe.listbox selection set \$temp_info2(old_sel)
        $a.f2.name delete 0 end
        $a.f2.name insert end \[lindex \[lindex \$temp_info2(color_favorites) \[$a.f1.listframe.listbox curselection\]\] 0\]
        set temp_info2(fwd_color)  \[lindex \[lindex \$temp_info2(color_favorites) \[$a.f1.listframe.listbox curselection\]\] 1\]
        set temp_info2(rev_color)  \[lindex \[lindex \$temp_info2(color_favorites) \[$a.f1.listframe.listbox curselection\]\] 2\]
      }
    }
  "
  bind $a.f1.listframe.listbox <<ListboxEmpty>> "
    $a.f2.name delete 0 end
    $a.f2.name configure -state disabled
    $a.f1.listframe.listbox configure -state disabled
    $a.f2.fwd_color configure -state disabled
    $a.f2.rev_color configure -state disabled
    $a.f1.del configure -state disabled
  "

  bind $a.f1.listframe.listbox <<ListboxSelect>> "
    if {\$temp_info2(old_sel) !=  \[$a.f1.listframe.listbox curselection\]} {
      if {\$temp_info2(old_sel) > -1} {
        set temp_info2(old_item) \[list \$temp_info2(name) \$temp_info2(fwd_color) \$temp_info2(rev_color)\]
        set temp_info2(color_favorites) \[lreplace \$temp_info2(color_favorites) \$temp_info2(old_sel) \$temp_info2(old_sel) \$temp_info2(old_item)\]
        $a.f1.listframe.listbox itemconfigure \$temp_info2(old_sel) -background \$temp_info2(fwd_color)
      }
      if {\[llength \$temp_info2(color_favorites)\] > 0} {
        set temp_info2(old_sel) \[$a.f1.listframe.listbox curselection\]
        set temp_info2(fwd_color)  \[lindex \[lindex \$temp_info2(color_favorites) \$temp_info2(old_sel)\] 1\]
        set temp_info2(rev_color)  \[lindex \[lindex \$temp_info2(color_favorites) \$temp_info2(old_sel)\] 2\]
        set temp_info2(name) \[lindex \[lindex \$temp_info2(color_favorites) \$temp_info2(old_sel)\] 0\]
      }
    }
  "

  if {[llength $temp_info2(color_favorites)] > 0} {
    $a.f1.listframe.listbox selection set 0
    $a.f1.listframe.listbox selection anchor 0
    set temp_info2(old_sel) 0
    $a.f2.name insert end [lindex [lindex $temp_info2(color_favorites) 0] 0]
  } else {
    set temp_info2(old_sel) -1
    update
    event generate $a.f1.listframe.listbox <<ListboxEmpty>>
  }

 focus $a.f2.name

  vwait ok3
  if {$ok3 == 1} {
    set temp_info2(old_item) [list $temp_info2(name) $temp_info2(fwd_color) $temp_info2(rev_color)]
    set temp_info2(color_favorites) [lreplace $temp_info2(color_favorites) $temp_info2(old_sel) $temp_info2(old_sel) $temp_info2(old_item)]
    set info(feature_color_favorites) $temp_info2(color_favorites)
  }
  set dialogblock 0
  destroy $a
  bind . <<RaiseDialogs>> $raisedialogstore

  unset ok3
  array unset temp_info2

}

##############
## scans a dna window textbox and stores the cutsites in the info array as info($w,$enzyme) 
##############

proc findenzymes {w} {
  global info

  if {$info($w,scanned) == 1} {return}

  global longnamelist 
  global hexlist 
  global enzymes
  global enzinfo


  foreach enzyme $enzymes {
    set info($w,$enzyme) [list]
    set info($w,enzdir,$enzyme) [list]
  }
  set info($w,MDam) [list]
  set info($w,MDcm) [list]

  set str [textarea_get $w.textarea 1.0 "end-1chars"]
  set last [string length $str]

  if {[string length $str] < 4} {return}

  if {$info($w,circular) == "circular"} {
    set str "$str[textarea_get $w.textarea 1.0 [bp2ix $w.textarea 63]]"
  }

  ## scan the longnames using the regexp search function
  foreach enzymeelement $longnamelist {
    set enzname [lindex $enzymeelement 0]
    set patternf [lindex $enzymeelement 1]
    set patternr [lindex $enzymeelement 2]

    foreach found [regexp -nocase -indices -all -inline -- $patternf $str] {
      if {[lindex $found 0] < $last} {
        lappend info($w,$enzname) [expr {[lindex $found 0]+1}]
        lappend info($w,enzdir,$enzname) 0
      }
    }
    if {$patternr != {}} {
      foreach found [regexp -nocase -indices -all -inline -- $patternr $str] {
        if {[lindex $found 0] < $last} {
          #reverse pattern
          lappend info($w,$enzname) [expr {[lindex $found 0]+1}]
          lappend info($w,enzdir,$enzname) 1
        }
      }
    }
  }


  ## scan using the hexarray for all sites <=6bp long
  array set a {a 0 A 0 c 1 C 1 g 2 G 2 t 3 T 3 n 0 N 0 * 0 b 1 B 1 d 0 D 0 h 0 H 0 k 2 K 2 m 0 M 0 r 0 R 0 s 1 S 1 v 0 V 0 w 0 W 0 y 1 Y 1}
  array set b {a 8 A 8 c 4 C 4 g 2 G 2 t 1 T 1 n 15 N 15 * 15 b 7 B 7 d 11 D 11 h 13 H 13 k 3 K 3 m 12 M 12 r 10 R 10 s 6 S 6 v 14 V 14 w 9 W 9 y 5 Y 5}

  if {$info($w,circular) == "circular"} {
    set len [expr ($last+5)]
    if {$len > [string length $str]} {
      set len [string length $str]
    }
  } else {
    set len $last
  }

  set h 0

  if {[string length $str] == 4} {
    for {set i 0} {$i < 4} {incr i} {
      set h [expr {($h << 2) & 0xfff | $a([string index $str $i])}]
    }
  } else {
    for {set i 0} {$i < 5} {incr i} {
      set h [expr {($h << 2) & 0xfff | $a([string index $str $i])}]
    }
  }

  set v "0x[string map {A 8 B 7 C 4 D b G 2 H d K 3 M c N f * f R a S 6 T 1 V e W 9 Y 5} [string toupper [string range $str 0 4]]]"

  for {set i 5} {$i < $len} {incr i} {
    set h [expr {($h << 2) & 0xfff | $a([string index $str $i])}]
    set v [expr {($v << 4) & 0xffffff | $b([string index $str $i])}]
    if {[lindex $hexlist $h] != {}} {
      foreach enzname [lindex $hexlist $h] {
        set inc 0
        foreach enz_vcode $enzinfo(enz_vcode,$enzname) {
          if {[expr {$enz_vcode & $v}] == 0} {
            #if enz_vcode is 2nd element of the list, the enzyme is in reverse pattern
            lappend info($w,$enzname) [expr {$i-4}]
            lappend info($w,enzdir,$enzname) $inc
          }
          incr inc
        }
      }
    }
  }


  if {$info($w,circular) != "circular"} {
    #Check explicitly for 5 and 4 bp sites at the end
    set h [expr {($h << 2) & 0xfff}]
    set v [expr {($v << 4) & 0xffffff | 15}]
    if {[lindex $hexlist $h] != {}} {
      foreach enzname [lindex $hexlist $h] {
        set inc 0
        foreach enz_vcode $enzinfo(enz_vcode,$enzname) {
          if {([expr {$enz_vcode & $v}] == 0) && ([string length $enzinfo(flatpat,$enzname)] < 6)} {
            lappend info($w,$enzname) [expr {$i-4}]
            lappend info($w,enzdir,$enzname) $inc
          }
          incr inc
        }
      }
    }
    set h [expr {($h << 2) & 0xfff}]
    set v [expr {($v << 4) & 0xffffff | 15}]
    if {[lindex $hexlist $h] != {}} {
      foreach enzname [lindex $hexlist $h] {
        set inc 0
        foreach enz_vcode $enzinfo(enz_vcode,$enzname) {
          if {([expr {$enz_vcode & $v}] == 0) && ([string length $enzinfo(flatpat,$enzname)] < 5)} {
            lappend info($w,$enzname) [expr {$i-3}]
            lappend info($w,enzdir,$enzname) $inc
          }
          incr inc
        }
      }
    }

    #take out enzymes with cut sites past the ends
    foreach enz $enzymes {
      if {[set len [string length $enzinfo(flatpat,$enz)]] < [set max [expr {max ([lindex $enzinfo(enz_cut_sites,$enz) 0],[lindex $enzinfo(enz_cut_sites,$enz) 1])}]] } {
        #look for reverse sites cutting past 0
        set s 0
        set lm [expr {$max-$len}]
        set i 0
        while {$i < [llength  $info($w,$enz)] && ($s<$lm)} {
          set s [lindex $info($w,$enz) $i]
          set d [lindex $info($w,enzdir,$enz) $i]
          if {$d && $s < $lm} {
            #check s and d for site past end and take out the site
            set info($w,$enz) [lreplace $info($w,$enz) $i $i]
            set info($w,enzdir,$enz) [lreplace $info($w,enzdir,$enz) $i $i]
          } else {
            incr i
          }
        } 
        #look for fwd sites cutting past end
        set s $last
        set lm  [expr {$last-$max+1}]
        set i [llength  $info($w,$enz)]
        while {$i > 0 && ($s > $lm)} {
          incr i -1
          set s [lindex $info($w,$enz) $i]
          set d [lindex $info($w,enzdir,$enz) $i]
          if {(!$d && $s > $lm)} {
            #check s and d for site past end and take out the site
            set info($w,$enz) [lreplace $info($w,$enz) $i $i]
            set info($w,enzdir,$enz) [lreplace $info($w,enzdir,$enz) $i $i]
          }
        }
      }
    }
  }


  initialize_methylation $w

  set info($w,scanned) 1
  if {$info($w,Dam_Dcm_methylated) == 1} {toggle_methylation $w}

#sputs Total time [expr $btime-$atime]ms.
#sputs Longnames time [expr $dtime-$ctime]ms.
#sputs vscan time [expr $ftime-$etime]ms.
#sputs initialize_methylation time [expr $htime-$gtime]ms.
}

################
## for Dam/Dcm blocked enzymes, add a list of unblocked sites into info($w,mstore,$enzyme)
################
proc initialize_methylation {w} {
  global info
  global enzinfo

  if {($info($w,circular) == "circular")} {
    set last [expr {[ix2bp $w.textarea [$w.textarea index end-1c]]}]
    if {[llength $info($w,MDcm)] > 1 } {
      set info($w,MDcm) [concat [expr {[lindex $info($w,MDcm) end-1]-$last}] [expr {[lindex $info($w,MDcm) end]-$last}] $info($w,MDcm) [expr {[lindex $info($w,MDcm) 0]+$last}] [expr {[lindex $info($w,MDcm) 1]+$last}]]
    } elseif {[llength $info($w,MDcm)] > 0} {
      set info($w,MDcm) [concat [expr {[lindex $info($w,MDcm) end]-$last}] $info($w,MDcm) [expr {[lindex $info($w,MDcm) 0]+$last}]]
    }
    if {[llength $info($w,MDam)] > 1 } {
      set info($w,MDam) [concat [expr {[lindex $info($w,MDam) end-1]-$last}] [expr {[lindex $info($w,MDam) end]-$last}] $info($w,MDam) [expr {[lindex $info($w,MDam) 0]+$last}] [expr {[lindex $info($w,MDam) 1]+$last}]]
    } elseif {[llength $info($w,MDam)] > 0} {
      set info($w,MDam) [concat [expr {[lindex $info($w,MDam) end]-$last}] $info($w,MDam) [expr {[lindex $info($w,MDam) 0]+$last}]]
    }
  }
#example: {MDam {{BcgI 2 9} {BclI 2 3} {BsaBI 1 8} {BspHI 5 0} {ClaI 0 5} {HphI 4 0} {Hpy188I 4 0} {MboI 1 2} {MboII 4 0} {NruI 5 0} {TaqI 3 0} {XbaI 5 0}}} {MDcm {{AlwNI 0 8} {ApaI 5 0} {AvaII 4 0} {PflMI 1 9} {PpuMI 6 0} {ScrFI 1 3} {SexAI 2 4} {SfiI 12 0} {StuI 4 1}}}
  foreach enzyme $info(blocked_enzymes) {
    set info($w,mstore,$enzyme) $info($w,$enzyme)
  }
  foreach methylase $enzinfo(enz_methylaselist) {
    set metsiteslist $info($w,[lindex $methylase 0])
    foreach blocked_enzyme [lindex $methylase 1] {
      set enzyme [lindex $blocked_enzyme 0]  
      set info($w,mstore,$enzyme) [not_in_list [not_in_list $info($w,$enzyme) $metsiteslist [lindex $blocked_enzyme 1]] $metsiteslist [lindex $blocked_enzyme 2]]   
    }
  }
  foreach z [list BisI BlsI GlaI GluI KroI MalI PcsI DpnI SgeI FspEI LpnPI MspJI] {
    if {[array names info "$w,$z"] != ""} {
      set info($w,$z) [list]
    }
  }
}

###########
##return a list of elements in list a that are not in list b, when each element of a has dif added to it before the comparison
###########
proc not_in_list {a b dif} {
  if {$b == [list]} {
    return $a
  }
  set i 0
  set j 0
  set res [list]
  set lena [llength $a]
  set lenb [llength $b]
  while {($i < $lena) && ($j < $lenb)} {
    while {($i < $lena) && ([expr {[lindex $a $i] + $dif}] < [lindex $b $j])} {
      lappend res [lindex $a $i]
      incr i
    }

    while {($i < $lena) && ($j < $lenb) && ([expr {[lindex $a $i] + $dif}] >= [lindex $b $j])} {
      if {([expr {[lindex $a $i] + $dif}] == [lindex $b $j])} {
        incr i
      }
      incr j
    }
    while {($j == $lenb) && ($i < $lena)} {
      lappend res [lindex $a $i]
      incr i
    }
  }
  return $res
}

################
## Turn Dam/Dcm methylation on/off by swapping info($w,$enzyme) and info($w,mstore,$enzyme)
################
proc toggle_methylation {w} {
  global info

  if {$info($w,scanned) == 0} {
    findenzymes $w
    return
  }

  foreach enzyme $info(blocked_enzymes) {
    set templist $info($w,$enzyme) 
    set info($w,$enzyme) $info($w,mstore,$enzyme)
    set info($w,mstore,$enzyme) $templist
  }

}
################
## Primer scan conditions dialog
################
proc primer_window {w} {
  global info
  global ok dialogblock modifier
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {[winfo exists .primer_conditions]} {destroy .primer_conditions}
  set a [toplevel .primer_conditions]
  wm title  .primer_conditions [mc "Find Primer"]
  wm protocol .primer_conditions WM_DELETE_WINDOW "set ok -1"
  bind .primer_conditions <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify $a; raise $a"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $a "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $a $w
  } else {
    ::tk::unsupported::MacWindowStyle style $a document {closeBox}
  }
  grid [label $a.lmin -text [mc "Minimum"]] -row 0 -column 2
  grid [label $a.lmax -text [mc "Maximum"]] -row 0 -column 3
  grid [label $a.llen -text [mc "Length: "]] -row 1 -column 1 -sticky e
  grid [entry $a.elenmin -width 10 -textvariable info(primer_len_min) -validate all -vcmd "entry_integer %P %W %V 1 100"] -row 1 -column 2
  grid [entry $a.elenmax -width 10 -textvariable info(primer_len_max) -validate all -vcmd "entry_integer %P %W %V 1 100"] -row 1 -column 3
  grid [label $a.lTm -text "Tm: "] -row 2 -column 1 -sticky e
  grid [entry $a.eTmmin -width 10 -textvariable info(primer_Tm_min) -validate all -vcmd "entry_integer %P %W %V 1 100"] -row 2 -column 2
  grid [entry $a.eTmmax -width 10 -textvariable info(primer_Tm_max) -validate all -vcmd "entry_integer %P %W %V 1 100"] -row 2 -column 3
  grid [label $a.l%gc -text "%GC: " -justify right] -row 3 -column 1 -sticky e
  grid [entry $a.e%gcmin -width 10 -textvariable info(primer_gc_min) -validate all -vcmd "entry_integer %P %W %V 0 100"] -row 3 -column 2
  grid [entry $a.e%gcmax -width 10 -textvariable info(primer_gc_max) -validate all -vcmd "entry_integer %P %W %V 0 100"] -row 3 -column 3
  grid [label $a.lclamp -text [mc "GC clamp: "]] -row 4 -column 1 -sticky e
  grid [entry $a.eclampmin -width 10 -textvariable info(primer_clamp_min) -validate all -vcmd "entry_integer %P %W %V 0 100"] -row 4 -column 2
  grid [entry $a.eclampmax -width 10 -textvariable info(primer_clamp_max) -validate all -vcmd "entry_integer %P %W %V 0 100"] -row 4 -column 3
  grid [label $a.lconcec -text [mc "Consecutive bases: "]] -row 5 -column 1 -sticky e
  grid [entry $a.econsecmax -width 10 -textvariable info(primer_consec_max) -validate all -vcmd "entry_integer %P %W %V 0 100"] -row 5 -column 3

  grid [frame $a.concframe -relief ridge -borderwidth 3] -row 6 -column 1 -columnspan 3 -pady 3
    grid [label $a.concframe.lsalt -text [mc "Salt (mM):"]] -row 0 -column 1
    grid [entry $a.concframe.esalt -width 10 -textvariable info(primer_salt) -validate all -vcmd "entry_integer %P %W %V 1 1000"] -row 0 -column 2
    grid [label $a.concframe.ldna -text [mc "Primer (nM):"]] -row 1 -column 1
    grid [entry $a.concframe.edna -width 10 -textvariable info(primer_dna) -validate all -vcmd "entry_integer %P %W %V 1 1000"] -row 1 -column 2

  grid [frame $a.scomp -relief ridge -borderwidth 3] -row 7 -column 1 -columnspan 3 -pady 1
    grid [label $a.scomp.ltot -text [mc "total"]] -row 0 -column 1
    grid [label $a.scomp.ladj -text [mc "adjacent"]] -row 0 -column 2
    grid [label $a.scomp.ltp -text "3'"] -row 0 -column 3
    grid [checkbutton $a.scomp.lscomp -text [mc "Self complement: "] -variable info(primer_check_sc) -selectcolor white] -row 1 -column 0 -sticky e
    grid [entry $a.scomp.scomptot -width 10 -textvariable info(primer_scomp_tot_max) -validate all -vcmd "entry_integer %P %W %V 1 1000" -width 3] -row 1 -column 1
    grid [entry $a.scomp.scompadj -width 10 -textvariable info(primer_scomp_adj_max) -validate all -vcmd "entry_integer %P %W %V 1 1000" -width 3] -row 1 -column 2
    grid [entry $a.scomp.scompthree -width 10 -textvariable info(primer_scomp_3_max) -validate all -vcmd "entry_integer %P %W %V 1 1000" -width 3] -row 1 -column 3
    grid [label $a.scomp.lhcomp -text [mc "Heterodimer: "]] -row 2 -column 0 -sticky e
    grid [entry $a.scomp.hcomptot -width 10 -textvariable info(primer_hcomp_tot_max) -validate all -vcmd "entry_integer %P %W %V 1 1000" -width 3] -row 2 -column 1
    grid [entry $a.scomp.hcompadj -width 10 -textvariable info(primer_hcomp_adj_max) -validate all -vcmd "entry_integer %P %W %V 1 1000" -width 3] -row 2 -column 2
    grid [entry $a.scomp.hcompthree -width 10 -textvariable info(primer_hcomp_3_max) -validate all -vcmd "entry_integer %P %W %V 1 1000" -width 3] -row 2 -column 3
    #grid [label $a.scomp.lholigo -text [mc "Oligo: "]] -row 3 -column 0 -sticky e
    grid [entry $a.scomp.scompoligo -width 10 -textvariable info(primer_hcomp_oligo) -validate key -vcmd {if {[regexp {[^atcgATGC]} %P] || ([string length %P] > 40)} {bell; return 0} else {return 1}} -width 35 -selectforeground $info(text_select_fg_color) -selectbackground $info(text_select_bg_color) -foreground $info(text_fg_color) -background $info(text_bg_color)] -row 3 -column 0 -columnspan 4


  grid [label $a.lscan -text [mc "Orientation:"]] -row 8 -column 1 -sticky e
  tk_optionMenu $a.direction info(primer_scan) "5'-->3'" "3'<--5'"
  grid $a.direction -row 8 -column 2
  grid [label $a.lsort -text [mc "Sort by:"]] -row 9 -column 1 -sticky e
  tk_optionMenu $a.sort info(primer_sort) " 5'  " "  3'  " "length" "  %GC " "  Tm  "
  grid $a.sort -row 9 -column 2

  set ok 0
  grid [button $a.ok -width 9 -text [mc "OK"] -command "set ok 1" -default active] -row 10 -column 1 -columnspan 3 -padx 10 -pady 3
  bind $a <Key-Return> "set ok 1"
  #grab $a
  focus $a
  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $a] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $a "+$winx+$winy"

  vwait ok
  set dialogblock 0
  foreach entry [list concframe.edna concframe.esalt scomp.scompoligo scomp.hcompthree scomp.hcompadj scomp.hcomptot scomp.scompthree scomp.scompadj scomp.scomptot eclampmax eclampmin e%gcmax e%gcmin eTmmax eTmmin elenmin elenmax] {
    $a.$entry validate
  }
  destroy $a
  bind . <<RaiseDialogs>> ""
  if {$ok == 1} {primer_scan $w}
  unset ok
}

################
## Primer scan
################
proc primer_scan {w} {
  global info
  global modifier
  global modstring

  $w configure -cursor watch
  $w.textarea configure -cursor watch
  update
  set log_dna [expr {1.987 * log( $info(primer_dna) / 1000000000.0)}] 
  set log_salt [expr {12 * log10($info(primer_salt) / 1000.0)}]

  if {[$w.textarea tag ranges sel] == ""} {
    if {[tk_messageBox -type okcancel -message "No DNA is selected. Do you want to search the entire selection?" -icon question -default ok] == "cancel"} {
      $w configure -cursor arrow
      $w.textarea configure -cursor xterm
      return
    }
    set first 1.0
    set last [$w.textarea index end-1chars]
  } else {
    set first [$w.textarea index sel.first]
    set last  [$w.textarea index sel.last]
  }
  if {$info(primer_scan) == "3'<--5'"} {
    set text [textarea_get $w.textarea $first $last]
  } else {
    set text [revcom [textarea_get $w.textarea $first $last]]
  }
  set consec_regexp "[string repeat a [expr {1+$info(primer_consec_max)}]]|[string repeat c [expr {1+$info(primer_consec_max)}]]|[string repeat g [expr {1+$info(primer_consec_max)}]]|[string repeat t [expr {1+$info(primer_consec_max)}]]"
  set hc_oligo [string tolower $info(primer_hcomp_oligo)]

  regsub -nocase -all {[^acgt]} $text "t" text
  if {[string length $text] < $info(primer_len_min)} {
    tk_messageBox -type ok -message "Selection is smaller than the minimum primer size" -icon warning -default ok
    $w configure -cursor arrow
    $w.textarea configure -cursor xterm
    raise $w
    focus $w
    return
  }
  set text [string tolower $text]
  array set sadd {aa 222 tt 222 at 204 ta 213 ca 158 tg 296 gt 155 ac 293 ct 141 ag 279 ga 153 tc 291 cg 272 gc 244 gg 199 cc 199}
  array set hadd {aa 79 tt 79 at 72 ta 72 ca 63 tg 107 gt 62 ac 106 ct 56 ag 100 ga 60 tc 104 cg 106 gc 98 gg 80 cc 80}
  array set srem {aa -222 tt -222 at -204 ta -213 ca -296 tg -158 gt -293 ac -155 ct -279 ag -141 ga -291 tc -153 cg -272 gc -244 gg -199 cc -199}
  array set hrem {aa -79 tt -79 at -72 ta -72 ca -107 tg -63 gt -106 ac -62 ct -100 ag -56 ga -104 tc -60 cg -106 gc -98 gg -80 cc -80}
  
  if {[string first [string index $text 0] "at"] > -1} {
    set htot -46
    set stot -82 
    set gc 0
  } else {
    set htot -2
    set stot 56
    set gc 1
  }

  for {set i 0} {$i < [expr {$info(primer_len_min)-1}]} {incr i} {
    incr htot $hadd([string range $text $i [expr $i+1]])
    incr stot $sadd([string range $text $i [expr $i+1]])
    if {[string first [string index $text [expr $i+1]] "gc"] > -1} {incr gc}
  }
  set hmem $htot
  set smem $stot
  set gcmem $gc
 
  #set min_sc $info(primer_scomp_3_max)
  #if {$info(primer_scomp_adj_max) < $min_sc} {
  #  set min_sc $info(primer_scomp_adj_max)
  #}
  #if {$info(primer_scomp_tot_max) < $min_sc} {
  #  set min_sc $info(primer_scomp_tot_max)
  #}

  set primer_Tm_max [expr {$info(primer_Tm_max) + 0.4999999999}]
  set primer_Tm_min [expr {$info(primer_Tm_min) - 0.5}]
  set j $i
  set k 0

  set primerlist [list]
  while {$k < [expr {[string length $text]-$info(primer_len_min)-1}]} {
    regexp "^(g|c)*" [string range $text $k $j] clamp
    if {([string length $clamp] >= $info(primer_clamp_min)) && ([string length $clamp] <= $info(primer_clamp_max))} {
      while {[expr {$j-$k}] < $info(primer_len_max)} {
        if {[regexp $consec_regexp [string range $text $k $j]]} {
          break
        }
        set Tm [expr {$htot * 100.0 / ($stot * 0.1 - $log_dna) - 273.15 + $log_salt}]
        if {($Tm > $primer_Tm_max)} {
          break
        }
        if {($Tm > $primer_Tm_min && ([expr {$gc * 100 / ($j-$k+1)}] >= $info(primer_gc_min)) && ([expr {$gc * 100 / ($j-$k+1)}] <= $info(primer_gc_max)))} {
         #######add primer to list of acceptable primers here
          if {$info(primer_check_sc)} {
            set potential [revcom [string range $text $k $j]]
            set sc_list [oligo_self_compl $potential $potential]
            if {([lindex $sc_list 0] < $info(primer_scomp_tot_max)) && ([lindex $sc_list 1] < $info(primer_scomp_adj_max)) && ([lindex $sc_list 2] < $info(primer_scomp_3_max))} {
              if {$hc_oligo != ""} {
                set hc_list [oligo_self_compl $potential $hc_oligo]
                if {([lindex $hc_list 0] < $info(primer_hcomp_tot_max)) && ([lindex $hc_list 1] < $info(primer_hcomp_adj_max)) && ([lindex $hc_list 2] < $info(primer_hcomp_3_max))} {
                  lappend primerlist [list [expr $k+1] [expr $j+1] [string range $text $k $j] [expr {$gc * 100 / ($j-$k+1)}] $Tm [expr {$j-$k+1}] $sc_list $hc_list]
                }
              } else {
                lappend primerlist [list [expr $k+1] [expr $j+1] [string range $text $k $j] [expr {$gc * 100 / ($j-$k+1)}] $Tm [expr {$j-$k+1}] $sc_list "-----"]
              }
            }
          } elseif {$hc_oligo != ""} {
            set potential [revcom [string range $text $k $j]]
            set hc_list [oligo_self_compl $potential $hc_oligo]
            if {([lindex $hc_list 0] < $info(primer_hcomp_tot_max)) && ([lindex $hc_list 1] < $info(primer_hcomp_adj_max)) && ([lindex $hc_list 2] < $info(primer_hcomp_3_max))} {
              lappend primerlist [list [expr $k+1] [expr $j+1] [string range $text $k $j] [expr {$gc * 100 / ($j-$k+1)}] $Tm [expr {$j-$k+1}] "-----" $hc_list]
            }
          } else {
            lappend primerlist [list [expr $k+1] [expr $j+1] [string range $text $k $j] [expr {$gc * 100 / ($j-$k+1)}] $Tm [expr {$j-$k+1}] "-----" "-----"]
          }
        }
        if {($j == [expr {[string length $text]-1}])} {
          break
        }
        incr htot $hadd([string range $text $j [expr $j+1]])
        incr stot $sadd([string range $text $j [expr $j+1]])
        if {[string first [string index $text [expr $j+1]] "gc"] > -1} {incr gc}
        incr j
      }
    }
    incr hmem $hrem([string range $text $k [expr $k+1]])
    incr smem $srem([string range $text $k [expr $k+1]])
    if {[string first [string index $text $k] "gc"] > -1} {incr gcmem -1}
    incr k
    if {$i < [expr {[string length $text]-1}]} {
      incr hmem $hadd([string range $text $i [expr $i+1]])
      incr smem $sadd([string range $text $i [expr $i+1]])
      if {[string first [string index $text [expr $i+1]] "gc"] > -1} {incr gcmem}
      set j [incr i]
    } else {
      set j $i
    }
    set htot $hmem
    set stot $smem
    set gc $gcmem  
  }
  if {$primerlist != [list]} {
    set a [new_analysis_window $w "Find Primers"]

    set first_tab [expr {[font measure dnafont "100000 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA 100028"]/[winfo pixels $a "1c"]*1.01}]
    set tab_spacing [expr {[font measure dnafont "length "]/[winfo pixels $a "1c"]*1.0}]
    grid [text $a.heading -background $info(bg_color) -foreground $info(label_fg_color) -height 1 -relief flat -font labelfont -wrap none -width 120 -tabs "[expr {$first_tab}]c center [expr {$first_tab+$tab_spacing}]c center [expr {$first_tab+2*$tab_spacing}]c center [expr {$first_tab+3*$tab_spacing}]c left"] -row 0 -column 0 -columnspan 2 -sticky nswe
    $a.heading insert end "[mc "Primer (5'-->3')"] \t[mc "length"]\t[mc "%GC"]\t[mc "Tm(\xB0\C)"]\t[mc "self/other(max adj 3')"]\n" 
    $a.heading configure -state disabled 
    grid [text $a.text -yscrollcommand "$a.scroll set" -font dnafont -wrap none -width 120 -tabs "[expr {$first_tab}]c center [expr {$first_tab+$tab_spacing}]c center [expr {$first_tab+2*$tab_spacing}]c center [expr {$first_tab+3*$tab_spacing}]c left" -insertontime 0 -insertofftime 1000] -row 1 -column 0 -rowspan 2 -sticky nswe
    grid [scrollbar $a.scroll -orient vertical -command "$a.text yview"] -row 1 -column 1 -sticky nswe
    grid [frame $a.sp -height 10] -row 2 -column 1 -sticky swe
    grid columnconfigure $a 0 -weight 1
    grid columnconfigure $a 1 -weight 0
    grid rowconfigure $a 1 -weight 1

    catch {$a.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
    $a.text insert end "$info($w,filename) \n"
    $a.text insert end "From [expr {[ix2bp $w.textarea $first]+1}] to [ix2bp $w.textarea $last] ($info(primer_scan)) \n\n"
    $a.text insert end "Find Primers\n" 
    $a.text insert end "[mc "Primer (5'-->3')"] \t[mc "length"]\t[mc "%GC"]\t[mc "Tm(\xB0\C)"]\t[mc "self/other(max adj 3')"]\n"

    set first [ix2bp $w.textarea $first]
    set last [ix2bp $w.textarea $last]
    set t 0

    switch $info(primer_sort) {
      " 5'  " {set primerlist [lsort -decreasing -integer -index 1 $primerlist]}
      "  3'  " {set primerlist [lsort -decreasing -integer -index 0 $primerlist]}
      "length" {set primerlist [lsort -integer -index 5 $primerlist]}
      "  %GC " {set primerlist [lsort -integer -index 3 $primerlist]}
      "  Tm  " {set primerlist [lsort -index 4 $primerlist]}
    }
    foreach primer $primerlist {
      if {$info(primer_scan) == "3'<--5'"} {
        $a.text insert end "[expr {$first+[lindex $primer 1]}] "
        $a.text insert end "[string toupper [revcom [lindex $primer 2]]] " "tag$t"
        $a.text insert end "[expr {$first+[lindex $primer 0]}]\t"
        $a.text tag bind "tag$t" <Button-1> "$a.text tag remove sel 1.0 end
          $a.text tag add sel tag$t.first tag$t.last
          $a.text mark set insert tag$t.last
          $a.text mark set anchor tag$t.first
          $a.text mark set tk::anchor$w.textarea tag$t.first
          select_region $w [bp2ix $w.textarea [expr {$first+[lindex $primer 0]-1}]] [bp2ix $w.textarea [expr {$first+[lindex $primer 1]}]]"
      } else {
        $a.text insert end "[expr {1+$last-[lindex $primer 1]}] "
        $a.text insert end "[string toupper [revcom [lindex $primer 2]]] " "tag$t"
        $a.text insert end "[expr {1+$last-[lindex $primer 0]}]\t"
        $a.text tag bind "tag$t" <Button-1> "$a.text tag remove sel 1.0 end
          $a.text tag add sel tag$t.first tag$t.last
          $a.text mark set insert tag$t.last
          $a.text mark set anchor tag$t.first
          $a.text mark set tk::anchor$w.textarea tag$t.first
          select_region $w [bp2ix $w.textarea [expr {$last-[lindex $primer 1]}]] [bp2ix $w.textarea [expr {$last-[lindex $primer 0]+1}]]"
      }
      $a.text tag bind "tag$t" <Double-Button-1> [$a.text tag bind "tag$t" <Button-1>]
      $a.text tag bind "tag$t" <Any-Leave> "%W tag remove highlite 1.0 end"
      $a.text tag bind "tag$t" <Any-Motion> "%W tag remove highlite 1.0 end; %W tag add highlite tag$t.first tag$t.last"
      $a.text tag bind "tag$t" <Enter> "%W tag remove highlite 1.0 end; %W tag add highlite tag$t.first tag$t.last"


      lappend info($w,linked_events) [list $a.text "tag$t" <Button-1>]

      $a.text insert end "[lindex $primer 5]\t"
      $a.text insert end "[lindex $primer 3]\t"
      $a.text insert end "[format %2.0f [lindex $primer 4]]\t"
      if {[lindex [lindex $primer 6] 0] != "-----"} {
        $a.text insert end "[lrange [lindex $primer 6] 0 2]" "self_tag$t"
        $a.text tag bind "self_tag$t" <Any-Leave> "tooltip_leave %W; %W tag remove highlite 1.0 end"
        $a.text tag bind "self_tag$t" <Enter> "tooltip_enter %W {[primer_align_oligo_text [revcom [lindex $primer 2]] [revcom [lindex $primer 2]] [lrange [lindex $primer 6] 3 5]]} 1 dnafont; %W tag remove highlite 1.0 end; %W tag add highlite self_tag$t.first self_tag$t.last"
      } else {
        $a.text insert end "[lindex [lindex $primer 6] 0]"
      }
        $a.text insert end " /"
      if {[lindex [lindex $primer 7] 0] != "-----"} {
        $a.text insert end "[lrange [lindex $primer 7] 0 2]\n" "other_tag$t"
        $a.text tag bind "other_tag$t" <Any-Leave> "tooltip_leave %W; %W tag remove highlite 1.0 end"
        $a.text tag bind "other_tag$t" <Enter> "tooltip_enter %W {[primer_align_oligo_text  $hc_oligo [revcom [lindex $primer 2]] [lrange [lindex $primer 7] 3 5]]} 1 dnafont; %W tag remove highlite 1.0 end; %W tag add highlite other_tag$t.first other_tag$t.last"
      } else {
        $a.text insert end "[lindex [lindex $primer 7] 0] \n"
      }



      incr t
    }
    $a.text tag configure highlite -foreground red
    $a.text tag raise highlite sel
    bind $a.text <Button-1> "if \{\[lsearch -exact \[$a.text tag names @%x,%y\] sel\] != -1\} break"
    set outputmenu [add_output_menu $a.text "Text" text $w]
    bind $a <Button-1> "focus $a.text" 
    bindtags $a.text [list $a.text AnalysisText . all]
    wm deiconify $a
    window_on_screen $a
    focus $a.text
  } else {
    tk_messageBox -type ok -message "No primers found" -icon info -default ok
  }
  $w configure -cursor arrow
  $w.textarea configure -cursor xterm
}

################
## returns a text of aligning two oligos with given spacings
################
proc primer_align_oligo_text {o1 o2 spacing_list} {

  set result ""
  set o1 [string toupper $o1]
  set o2 [string toupper $o2]
  if {[string length $o1] > [string length $o2] } {
    set o3 $o1
    set o1 $o2
    set o2 $o3
    unset o3
  }
  foreach spacing $spacing_list {
    set line1 [string repeat " " [expr {$spacing}]]5'$o1
    append line1 3'
    set line2 [string repeat " " [expr {-$spacing}]]3'[string reverse $o2]5'
    append line1 [string repeat " " [expr {[string length $line2]-[string length $line1]}]]
    append line2 [string repeat " " [expr {[string length $line1]-[string length $line2]}]]
    set mline ""
    foreach a [split [string map {5 * 3 * ' * " " *} $line1] ""] b [split [string map {A T T A C G G C} $line2] ""] {
      append mline [expr {($a==$b)?"|":" "}]
    }
    append result $line1\n$mline\n$line2\n\n
  }
  set result [string trim $result \n]
  return $result
}

################
## find the complementarity between two oligos
################
#returns list of total, adjacent, and 3'

proc oligo_self_compl {o1 o2} {
  if {[string length $o2] < [string length $o1]} {
    set o3 $o1
    set o1 $o2
    set o2 $o3
  }
  set o2 [revcom $o2]
  set len_dif [expr {[string length $o2] - [string length $o1]}]

  set max_match 0
  set max_match_loc [expr {-[string length $o1]}]
  set max_adj 0
  set max_adj_loc [expr {-[string length $o1]}]
  set max_three 0
  set max_three_loc [expr {-[string length $o1]}]
  for {set i [expr {-[string length $o1]}]} {$i < [expr {[string length $o2]}]} {incr i} {
    if {$i <= 0} {
      set top [string range $o1 [expr {-$i}] end]
      set bottom [string range $o2 0 [expr {[string length $top]-1}]]
    } else {
      set bottom [string range $o2 $i [expr {$i+[string length $o1]-1}]]
      set top [string range $o1 0 [expr {[string length $bottom]-1}]]
    }
    set this_max_match 0
    set this_adj 0
    set this_adj_working 0
    set bottom_flag 1
    foreach x [split $top ""] y [split $bottom ""] {
      if {$x == $y} {
        incr this_max_match
        incr this_adj_working
        if {$this_adj_working > $this_adj} {set this_adj $this_adj_working}
      } else {
        if {($this_adj_working > $max_three) && ($i <= 0) && ($bottom_flag)} {set max_three $this_adj_working; set max_three_loc $i}
        set this_adj_working 0
        set bottom_flag 0  
      }
    }
    #sputs "$top\n$bottom\n$this_max_match $this_adj $this_adj_working $max_three"
    if {$this_max_match > $max_match} {set max_match $this_max_match; set max_match_loc $i}
    if {$this_adj > $max_adj} {set max_adj $this_adj; set max_adj_loc $i}
    #if {($this_adj_working > $max_three) && ($i <= $len_dif)} {set max_three $this_adj_working;}
  }
  return [list $max_match $max_adj $max_three $max_match_loc $max_adj_loc $max_three_loc]
} 

##############
## New align dialog with multiple sequences aligned to a reference sequence
##############
proc align_dialog2 {w} {
  global info  
  global align_ref_seq align_windows_list
  global align_seq align_seq_winlist align_prog align_sel_list align_dir_list
  global ok dialogblock 
  if {$dialogblock == 1} {return}
  set dialogblock 1

###algn windows data shows up in:
#global align_ref_seq
#global list align_windows_list- list of windows to align to

  if {[winfo exists .aligndialog]} {destroy .aligndialog}
  set s [toplevel .aligndialog]
  wm title $s [mc "Align DNA"]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $s "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }

###sequences windows in this frame
  grid [frame $s.seqsframe] -row 1 -column 1 -sticky nswe
  grid [label $s.seqsframe.label1 -text [mc "Reference Sequence:"]] -row 1 -column 1 -sticky ne
  menubutton $s.seqsframe.win_button1
    menu $s.seqsframe.win_button1.menu
    foreach window $info(dnawindows_list) {
      $s.seqsframe.win_button1.menu add radiobutton -command "$s.seqsframe.win_button1 configure -text \{[wm title $window]\}" -label [wm title $window] -variable align_ref_seq -value $window 
    }
    set abi_list [lsort -unique [regexp -inline -all {\.abi_window[0-9]*} "[winfo children .] "]]
    if {[llength $abi_list] > 0} {
      $s.seqsframe.win_button1.menu add separator
      foreach window $abi_list {
        $s.seqsframe.win_button1.menu add radiobutton -command "$s.seqsframe.win_button1 configure -text \{[wm title $window]\}" -label [wm title $window] -variable align_ref_seq -value $window 
      }
    }
  $s.seqsframe.win_button1 configure -text [wm title $w] -menu $s.seqsframe.win_button1.menu -indicatoron 1 -relief raised -width 60 
  bind $s.seqsframe.win_button1.menu <<MenuSelect>> "focus $s"
  set align_ref_seq $w
  grid $s.seqsframe.win_button1 -row 1 -column 2 -columnspan 3

  grid [checkbutton $s.seqsframe.local1 -width 12 -variable info(align_select_region1) -text [mc "Selection Only"] -onvalue "selection" -offvalue "all" -indicator on -selectcolor white] -row 1 -column 5
  grid [checkbutton $s.seqsframe.rc1 -width 8 -variable info(align_select_rc1) -text [mc "Rev-Com"] -offvalue "forward" -onvalue "rev/com" -indicator on -selectcolor white] -row 1 -column 6

  grid [labelframe $s.seqsframe.alignwins -text [mc "Align to Windows"]] -row 2 -column 1 -columnspan 6 -sticky nswe
  grid rowconfigure $s.seqsframe.alignwins 1 -weight 1
  grid columnconfigure $s.seqsframe.alignwins 1 -weight 1


#add in the first alignment window menu button in the menubutton frame
  #grid [frame $s.seqsframe.alignwins.meubuttonframe] -row 1 -column 1 -sticky nswe
  #align_add_window_menu $s.seqsframe.alignwins.meubuttonframe 0

##removed from the grid in favor of the window list view for now
  #grid remove $s.seqsframe.alignwins.meubuttonframe

#add in the window list frame
  grid [frame $s.seqsframe.alignwins.listframe] -row 1 -column 1 -sticky nswe
  align_fill_window_list_treeview $s.seqsframe.alignwins.listframe

###alignment parameteres in this frame
  grid [labelframe $s.alignparams -text [mc "Alignment Parameters"]] -row 4 -column 1 -sticky nswe
  grid [label $s.alignparams.blockslabel -text [mc "Blocks:"]] -row 4 -column 1 -sticky ne
  menubutton $s.alignparams.blocksbut -indicatoron 1 -relief raised -width 10 -textvariable info(align_blocksize)
  menu $s.alignparams.blocksbut.blocks
    $s.alignparams.blocksbut.blocks add radiobutton -label "200" -value 200 -variable info(align_blocksize)
    $s.alignparams.blocksbut.blocks add radiobutton -label "100" -value 100 -variable info(align_blocksize)
    $s.alignparams.blocksbut.blocks add radiobutton -label "50" -value 50 -variable info(align_blocksize)
    $s.alignparams.blocksbut.blocks add radiobutton -label "20" -value 20 -variable info(align_blocksize)
    $s.alignparams.blocksbut.blocks add radiobutton -label "15" -value 15 -variable info(align_blocksize)
    $s.alignparams.blocksbut.blocks add radiobutton -label "10" -value 10 -variable info(align_blocksize)
    $s.alignparams.blocksbut.blocks add radiobutton -label [mc "N-W align all"] -value "N-W align all" -variable info(align_blocksize)
  $s.alignparams.blocksbut configure -menu $s.alignparams.blocksbut.blocks
  bind $s.alignparams.blocksbut <<MenuSelect>> "focus $s.alignparams"

  grid $s.alignparams.blocksbut -row 4 -column 2 -sticky nw

  grid [label $s.alignparams.nwmaxlabel -text [mc "N-W max:"]] -row 4 -column 3 -sticky ne
  grid [entry $s.alignparams.nwmaxentry -validate key -width 4 -vcmd "check_char %S" -textvariable info(NWmax)] -row 4 -column 4 -sticky nw

  grid [label $s.alignparams.mmplabel -text [mc "Mismatch Penalty:"]] -row 5 -column 1 -sticky ne
  menubutton $s.alignparams.mmpbut -indicatoron 1 -relief raised -width 10 -textvariable info(mm_penalty)
  menu $s.alignparams.mmpbut.mmpmenu
    foreach val {0 -0.1 -0.2 -0.3 -0.4 -0.5 -0.6 -0.7 -0.8 -0.9 -1 -1.1 -1.2 -1.3 -1.4 -1.5 -1.6 -1.7 -1.8 -1.9 -2} {
       $s.alignparams.mmpbut.mmpmenu add radiobutton -label " $val" -value $val -variable info(mm_penalty)
    }
  $s.alignparams.mmpbut configure -menu $s.alignparams.mmpbut.mmpmenu
  bind $s.alignparams.mmpbut.mmpmenu <<MenuSelect>> "focus $s.alignparams"
  grid $s.alignparams.mmpbut -row 5 -column 2 -sticky nw

  grid [label $s.alignparams.gapplabel -text [mc "Gap Penalty:"]] -row 5 -column 3 -sticky ne
  menubutton $s.alignparams.gappbut -indicatoron 1 -relief raised -width 10 -textvariable info(gap_penalty)
  menu $s.alignparams.gappbut.gapp
    foreach val {0 -0.1 -0.2 -0.3 -0.4 -0.5 -0.6 -0.7 -0.8 -0.9 -1 -1.1 -1.2 -1.3 -1.4 -1.5 -1.6 -1.7 -1.8 -1.9 -2} {
       $s.alignparams.gappbut.gapp add radiobutton -label " $val" -value $val -variable info(gap_penalty)
    }
  $s.alignparams.gappbut configure -menu $s.alignparams.gappbut.gapp
  bind $s.alignparams.gappbut.gapp <<MenuSelect>> "focus $s.alignparams"
  grid $s.alignparams.gappbut -row 5 -column 4 -sticky nw

  grid [label $s.alignparams.gapeplabel -text [mc "Gap Ext. Penalty:"]] -row 5 -column 5 -sticky ne
  menubutton $s.alignparams.gapepbut -indicatoron 1 -relief raised -width 10 -textvariable info(gap_extension_penalty)
  menu $s.alignparams.gapepbut.gapep
    foreach val {0 -0.1 -0.2 -0.3 -0.4 -0.5 -0.6 -0.7 -0.8 -0.9 -1} {
      $s.alignparams.gapepbut.gapep add radiobutton -label " $val" -value $val -variable info(gap_extension_penalty)
    }
  $s.alignparams.gapepbut configure -menu $s.alignparams.gapepbut.gapep
  bind $s.alignparams.gapepbut.gapep <<MenuSelect>> "focus $s.alignparams"
  grid $s.alignparams.gapepbut -row 5 -column 6 -sticky nw

  grid [label $s.alignparams.widthentrylabel -text [mc "Line Width:"]] -row 6 -column 1 -sticky ne
  grid [entry $s.alignparams.widthentry -width 5 -validate key -vcmd "check_char %S" -textvariable info(align_linewidth)] -row 6 -column 2 -sticky nw
  grid [checkbutton $s.alignparams.highlight -selectcolor white -text [mc "Copy Highlighting from Sequence"] -onvalue 1 -offvalue 0 -variable info(align_copy_highlight)] -row 6 -column 3 -columnspan 2

  grid [label $s.alignparams.phredtrimlabel -text [mc "Trim ends with Phred <:"]] -row 7 -column 1 -sticky ne
  grid [entry $s.alignparams.phredtrim -width 5 -validate key -vcmd "check_char %S" -textvariable info(align_phredtrim)] -row 7 -column 2 -sticky nw

  grid [checkbutton $s.alignparams.alignmenttrim -selectcolor white -text [mc "Show Only Aligned Regions"] -onvalue 1 -offvalue 0 -variable info(align_trim_to_alignment)] -row 7 -column 3 -columnspan 2

  grid [button $s.alignparams.hide_alignparams -text [mc "Hide Alignment Parameters"] -command "grid configure $s.show_alignparams; grid remove $s.alignparams"] -row 8 -column 1 -sticky nsw -columnspan 2

  grid remove $s.alignparams
  grid [button $s.show_alignparams -text [mc "Show Alignment Parameters"] -command "grid remove $s.show_alignparams; grid configure $s.alignparams"] -row 4 -column 1 -sticky nsw


###ok and cancel in this frame
  grid [frame $s.okframe] -row 7 -column 1
  grid [button $s.okframe.ok -text [mc "OK"] -command "set ok 1" -default active -state disabled] -row 1 -column 1 -padx 10 -pady 3
  bind $s <Key-Return> "set ok 1"
  grid [button $s.okframe.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 2 -padx 10 -pady 3
  #grab $s
  focus $s

  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $s] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $s "+$winx+$winy"

  vwait ok

### do output here
  set dialogblock 0
  if {$info(NWmax) == ""} {set info(NWmax) 300}
  if {$info(align_linewidth) == ""} {set info(align_linewidth) 100}
 # wm withdraw $s
  if {$ok == 1} {
    #set align_windows_list [list]
    #set temp_align_dir_list $align_dir_list
    set align_dir_list [list]
    #set temp_align_sel_list $align_sel_list
    set align_sel_list [list]
    #multi-list windows list
    #if {[grid info $s.seqsframe.alignwins.listframe] != ""} {
    #  foreach selection [$s.seqsframe.alignwins.listframe.windowlist curselection] {
    #    lappend align_windows_list [lindex $align_seq_winlist $selection] 
    #    lappend align_dir_list [lindex $temp_align_dir_list $selection] 
    #    lappend align_sel_list [lindex $temp_align_sel_list $selection]
    #  }
    #}  else {
      #convert align_seq($i) array to list of windows
    #}
    #treeview windows list
    set align_windows_list [$s.seqsframe.alignwins.listframe.windowlist selection] 
    foreach selection $align_windows_list {
      lappend align_dir_list [$s.seqsframe.alignwins.listframe.windowlist set $selection Direction] 
      lappend align_sel_list [$s.seqsframe.alignwins.listframe.windowlist set $selection Range]
    }

    #add progress bar
    set align_prog 0
    if {$info(use_tile)} {
      grid [ttk::progressbar $s.align_prog -maximum [llength $align_windows_list] -variable align_prog -orient horizontal -mode determinate] -row 4 -column 1  -sticky new
    } else {
      grid [label $s.align_prog_label -width 50 -text "Aligning sequences, Please wait..."] -row 4 -column 1  -sticky nw
      grid [label $s.align_prog -width 50 -textvariable align_prog] -row 4 -column 2  -sticky nw
    }
    grid remove $s.show_alignparams
    grid remove $s.alignparams
    update
    output_alignment2
  }
  #grab release $s
  destroy $s
  bind . <<RaiseDialogs>> ""
  unset ok 
  catch {unset align_seq align_ref_seq align_sel_list align_seq_winlist align_dir_list}
  return ""
}


###########
## subroutine of align_dialog2
###########
proc align_add_window_menu {frame i} {
  global info align_seq

  set j [expr {$i +1}]
  menubutton $frame.awin_button$i -width 3
    menu $frame.awin_button$i.menu
    #$frame.awin_button$i.menu add command -command {sputs show list} -label [mc "Show windows list"]
    if {$i > 0} {
      $frame.awin_button$i.menu add command -command "set align_seq($i) \"\"; $frame.awin_button$i configure -text  \[mc {Select Window to align}\]" -label [mc "No Window"]
      $frame.awin_button$i.menu add separator
    }

    foreach window $info(dnawindows_list) {
####need to check for existence of $frame.win_button$j before calling align_add_window
      $frame.awin_button$i.menu add radiobutton -command "$frame.awin_button$i configure -text \{[wm title $window]\}; event generate $frame <<add_blank>>" -label [wm title $window] -variable align_seq($i) -value $window 
    }
    set abi_list [lsort -unique [regexp -inline -all {\.abi_window[0-9]*} "[winfo children .] "]]
    if {[llength $abi_list] > 0} {
      $frame.awin_button$i.menu add separator
      foreach window $abi_list {
        $frame.awin_button$i.menu add radiobutton -command "$frame.awin_button$i configure -text \{[wm title $window]\}; if \{!\[winfo exists $frame.awin_button$j\]\} \{align_add_window_menu $frame $j\}" -label [wm title $window] -variable align_seq($i) -value $window 
      }
    }
  $frame.awin_button$i configure -text [mc "Select Window to align"] -menu $frame.awin_button$i.menu -indicatoron 1 -relief raised -width 60 
  set align_seq($i) ""
  bind $frame.awin_button$i.menu <<MenuSelect>> "focus [winfo toplevel $frame]"
  grid $frame.awin_button$i -row [expr {$i+2}] -column 2 -columnspan 3

 ##binding to add new menubutton if all are filled
  bind $frame <<add_blank>> "
    set seqframecheck 1
    foreach element \[array names align_seq\] {
      if {\$align_seq(\$element) == \"\"} {set seqframecheck 0}
    } 
    if {\$seqframecheck} {
      align_add_window_menu $frame $j
    }
    unset seqframecheck
  "
  #endbind $frame <<add_blank>> 
}

###########
## subroutine of align_dialog2- makes a 3 list window selection box
###########
proc align_fill_window_list {s} {
  global align_seq_winlist align_sel_list align_dir_list

  set align_sel_list [list]
  set align_dir_list [list]

  grid [listbox $s.windowlist -yscrollcommand "multilist_optionscrollbar $s.windowlistscroll {$s.windowlist_dir $s.windowlist_sel}" -bg white -selectmode extended -height 10 -exportselection 0 -activestyle none] -row 1 -column 1 -sticky nswe
  grid [listbox $s.windowlist_sel -yscrollcommand "multilist_optionscrollbar $s.windowlistscroll {$s.windowlist $s.windowlist_dir}" -bg white -selectmode extended -height 10 -exportselection 0 -width 10 -activestyle none -listvariable align_sel_list] -row 1 -column 2 -sticky nswe
  grid [listbox $s.windowlist_dir -yscrollcommand "multilist_optionscrollbar $s.windowlistscroll {$s.windowlist $s.windowlist_sel}" -bg white -selectmode extended -height 10 -exportselection 0 -width 10 -activestyle none -listvariable align_dir_list] -row 1 -column 3 -sticky nswe

  grid [scrollbar $s.windowlistscroll -command "multilist_scroll {$s.windowlist $s.windowlist_dir $s.windowlist_sel} yview"] -row 1 -column 4 -sticky nsw

  grid columnconfigure $s 1 -weight 1
  grid rowconfigure $s 1 -weight 1

  set counti 0
  set align_seq_winlist [list]
      foreach abwindow [regexp -all -inline ".abi_window\[0-9\]* " "[winfo children .] "] {
        set abwindow [string range $abwindow 0 end-1]
          $s.windowlist insert end  "[wm title $abwindow]"
          $s.windowlist_dir insert end [mc Best]
          $s.windowlist_sel insert end [mc All]
          if {($counti % 2) == 1} {
             set bgcolor #FFF5F5
          } else {
            set bgcolor gray95
          }
          foreach list_box {windowlist windowlist_dir windowlist_sel} {
            $s.$list_box itemconfigure end -background $bgcolor
          }
          incr counti
          lappend align_seq_winlist $abwindow
      }
      foreach windowelement [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
        set windowelement [string range $windowelement 0 end-1]
        $s.windowlist insert end [wm title $windowelement]
        $s.windowlist_dir insert end [mc Best]
        $s.windowlist_sel insert end [mc All]
        if {($counti % 2) == 1} {
          foreach list_box {windowlist windowlist_dir windowlist_sel} {
            $s.$list_box itemconfigure end -background #F5F5FF
          }
        }
        incr counti
        lappend align_seq_winlist $windowelement
      }
  set top [winfo toplevel $s]
  bind $s.windowlist <<ListboxSelect>> "$s.windowlist_dir selection clear 0 end; $s.windowlist_sel selection clear 0 end; foreach w \[$s.windowlist curselection\] {$s.windowlist_dir selection set \$w; $s.windowlist_sel selection set \$w}; if {\[$s.windowlist curselection\] =={}} {$top.okframe.ok configure -state disabled} else {$top.okframe.ok configure -state normal}"
  bind $s.windowlist_sel <<ListboxSelect>> "$s.windowlist_dir selection clear 0 end; $s.windowlist selection clear 0 end; foreach w \[$s.windowlist_sel curselection\] {$s.windowlist_dir selection set \$w; $s.windowlist selection set \$w}; if {\[$s.windowlist curselection\] =={}} {$top.okframe.ok configure -state disabled} else {$top.okframe.ok configure -state normal}"
  bind $s.windowlist_dir <<ListboxSelect>> "$s.windowlist_sel selection clear 0 end; $s.windowlist= selection clear 0 end; foreach w \[$s.windowlist_dir curselection\] {$s.windowlist_sel selection set \$w; $s.windowlist selection set \$w}; if {\[$s.windowlist curselection\] =={}} {$top.okframe.ok configure -state disabled} else {$top.okframe.ok configure -state normal}"

  bind $s.windowlist_sel <Button-1> "toggle_align_sel $s.windowlist_sel %x %y; break"
  bind $s.windowlist_dir <Button-1> "toggle_align_sel $s.windowlist_dir %x %y; break"

}

proc multilist_scroll {windows command args} {
  foreach window $windows {{*}"$window $command $args"}
}
proc multilist_optionscrollbar {scrollbar windows  args} {
    {*}"optionscrollbar $scrollbar $args"
    multilist_scroll $windows yview moveto [lindex $args 0]
}
proc toggle_align_sel {list_box x y} {
  set item [$list_box index @$x,$y]
  set text [$list_box get $item]
  set sel_list [list [mc All] [mc Selection]]
  set dir_list [list  [mc Rev-com] [mc Best] [mc Forward]]

  if {[set list_index [lsearch -exact $sel_list $text]] > -1} {
    set new_text [lindex $sel_list [expr {($list_index +1) % 2}]]
  } elseif {[set list_index [lsearch -exact $dir_list $text]] > -1} {
    set new_text [lindex $dir_list [expr {($list_index +1) % 3}]]
  }
  set sel_store [$list_box curselection]
  set bg_store [$list_box itemcget $item -background]
  $list_box delete $item
  $list_box insert $item $new_text
  $list_box itemconfigure $item -background $bg_store
  foreach w $sel_store {
    $list_box selection set $w
  }

}

###############
## make align-multi winfow list a treeview
###############
proc align_fill_window_list_treeview {s} {
  global info

  grid [ttk::treeview $s.windowlist -yscrollcommand "optionscrollbar $s.windowlistscroll" -selectmode extended -height 10 ] -row 1 -column 1 -sticky nswe
  grid [scrollbar $s.windowlistscroll -command "multilist_scroll {$s.windowlist $s.windowlist_dir $s.windowlist} yview"] -row 1 -column 4 -sticky nsw
  grid columnconfigure $s 1 -weight 1
  grid rowconfigure $s 1 -weight 1

  set t $s.windowlist
  $t configure -columns {Range Direction}
  $t heading #0 -text "Window"
  $t column #0 -width 200 -minwidth 50 -stretch 1 -anchor e
  $t heading Range -text Range
  $t column Range -width 80 -minwidth 80 -stretch 0 -anchor c
  $t heading Direction -text Direction -command "treeview_sort $t Direction"
  $t column Direction -width 80 -minwidth 80 -stretch 1 -anchor c

  foreach abiwindow [regexp -all -inline ".abi_window\[0-9\]* " "[winfo children .] "] {
    set abiwindow [string range $abiwindow 0 end-1]
    $s.windowlist insert {} end  -id $abiwindow -text "[wm title $abiwindow]" -tag abi
    $s.windowlist set $abiwindow Range All
    $s.windowlist set $abiwindow Direction Best
  }
  foreach windowelement [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
    set windowelement [string range $windowelement 0 end-1]
    $s.windowlist insert {} end  -id $windowelement -text "[wm title $windowelement]" -tag seq
    $s.windowlist set $windowelement Range All
    $s.windowlist set $windowelement Direction Best
  }
  $s.windowlist tag configure abi -background #FFF5F5
  $s.windowlist tag configure seq -background #F5F5FF
  $t tag configure sel -background $info(text_select_bg_color)
  set top [winfo toplevel $s]
  bind $t <<TreeviewSelect>> "treeview_manageselection $t; if {\[$s.windowlist selection\] =={}} {$top.okframe.ok configure -state disabled} else {$top.okframe.ok configure -state normal}"
  bind $t <<OldSelection>> {}

  bind $s.windowlist <Button-1> "toggle_align_treeview $s.windowlist \[$t identify column %x %y]  \[$t identify row %x %y]"
  bind $t <B1-Motion> "treeview_move $t %x %y"
  bind $t <ButtonRelease-1> "treeview_release $t %x %y"
}

###############
## Generate output window for align_dialog2 (multi-alignment)
###############
proc toggle_align_treeview {t col row} {
  if {[$t column $col -id] eq "Range" } {
    $t set $row Range [lindex {All Selection} [lsearch {Selection All} [$t set $row Range]]]
  } elseif {[$t column $col -id] eq "Direction" } {
    $t set $row Direction [lindex {Best Forward Reverse} [lsearch {Reverse Best Forward} [$t set $row Direction]]]
  }
}

###############
## Generate output window for align_dialog2 (multi-alignment)
###############
proc output_alignment2 {} {
  global info abi_info
  global align_ref_seq align_windows_list align_dir_list align_sel_list align_prog
  global modifier
  global modstring
  set xdir 1
  if {[string first .abi_window $align_ref_seq] == -1} {
    ###window1 is a sequence window
    #$align_ref_seq.textarea configure -cursor watch
    set window_type1 "sequence"
    if {($info(align_select_region1) == "selection") && ([$align_ref_seq.textarea tag nextrange tempsel 1.0] != "")} {
      set xdna [textarea_get $align_ref_seq.textarea sel.first sel.last]
      if {$info(align_select_rc1) == "rev/com"} {
        set xfirst [expr {1+[ix2bp $align_ref_seq.textarea [$align_ref_seq.textarea index sel.last]]}]
        set xdna [revcom $xdna]
        set xdir -1
      } else {
        set xfirst [ix2bp $align_ref_seq.textarea [$align_ref_seq.textarea index tempsel.first]]
      }
    } else {
      set xdna [textarea_get $align_ref_seq.textarea 1.0 end-1chars]
      if {$info(align_select_rc1) == "rev/com"} {
        set xfirst [expr {1+[ix2bp $align_ref_seq.textarea [$align_ref_seq.textarea index end-1c]]}]
        set xdna [revcom $xdna]
        set xdir -1
      } else {
        set xfirst 0
      }
    }
    set cds_lines [cds_trans_lines $align_ref_seq]
  } else {
    ###window1 is an abi window
    set window_type1 "abi"
    if {($info(align_select_region1) == "selection")} {
      set abi_seq [abi_get_seq $align_ref_seq sel.first sel.last]
      if {$abi_seq == ""} {
        set abi_seq [abi_get_seq $align_ref_seq start end]
      }
    } elseif {$info(align_phredtrim) > 0} {
      set phredmin -1
      set phredmax 0
      for {set phredi 0} {$phredi < [llength $abi_info($align_ref_seq,basecall_prob_called,edited)]} {incr phredi} {
        if {[lindex $abi_info($align_ref_seq,basecall_prob_called,edited) $phredi] > $info(align_phredtrim)} {
          if {$phredmin == -1} {set phredmin $phredi}
          set phredmax $phredi
        }
      }
      if {$phredmin < $phredmax && $phredmin > -1} {
        set abi_seq [abi_get_seq $align_ref_seq [lindex $abi_info($align_ref_seq,basecall_loc,edited) $phredmin] [lindex $abi_info($align_ref_seq,basecall_loc,edited) $phredmax]]
      } else {
        set abi_seq [abi_get_seq $align_ref_seq start end]
      }
    } else {
      set abi_seq [abi_get_seq $align_ref_seq start end]
    }
    if {$info(align_select_rc1) == "rev/com"} {
      set xdna [revcom [lindex $abi_seq 1]]
      if {!$abi_info($align_ref_seq,rev_com)} {
        set xdir -1
        set xfirst [expr {1+[lindex $abi_seq 0]+[string length [lindex $abi_seq 1]]}]
      } else {
        set xfirst [expr {[llength [$align_ref_seq.c find withtag basecall]]-[lindex $abi_seq 0]-[string length [lindex $abi_seq 1]]}]
      }
    } else {
      set xdna [lindex $abi_seq 1]
      if {$abi_info($align_ref_seq,rev_com)} {
        set xdir -1
        set xfirst [expr {1+[llength [$align_ref_seq.c find withtag basecall]]-[lindex $abi_seq 0]}]
      } else  {
        set xfirst [expr {[lindex $abi_seq 0]}]
      }
    }
    set cds_lines [list]
  }
  if {![info exists info(($align_ref_seq,linked_events)]} {set info($align_ref_seq,linked_events) [list]}

#align each window to the reference
  set xout_list [list]
  set yout_list [list]
  set yfirst_list [list]
  set ydir_list [list]
  set lineout_list [list]

  foreach align_select_window2 $align_windows_list align_dir $align_dir_list align_sel $align_sel_list {
    set ydir 1
    if {[string first .abi_window $align_select_window2] == -1} {
    ###window2 is a sequence window
      if {($align_sel eq [mc "Selection"]) && ([$align_select_window2.textarea tag nextrange tempsel 1.0] != "")} {
        set ydna [textarea_get $align_select_window2.textarea sel.first sel.last]
        set yfirst [ix2bp $align_select_window2.textarea [$align_select_window2.textarea index tempsel.first]]
      } else {
        set ydna [textarea_get $align_select_window2.textarea 1.0 end-1chars]
        set yfirst 0
      }
    } else {
      ###window2 is an abi window
      if {($align_sel eq [mc "Selection"])} {
        set abi_seq [abi_get_seq $align_select_window2 sel.first sel.last]
        if {$abi_seq == ""} {
          set abi_seq [abi_get_seq $align_select_window2 start end]
        }
      } elseif {$info(align_phredtrim) > 0} {
        set phredmin -1
        set phredmax 0
        for {set phredi 0} {$phredi < [llength $abi_info($align_select_window2,basecall_prob_called,edited)]} {incr phredi} {
          if {[lindex $abi_info($align_select_window2,basecall_prob_called,edited) $phredi] > $info(align_phredtrim)} {
            if {$phredmin == -1} {set phredmin $phredi}
            set phredmax $phredi
          }
        }
        if {$phredmin < $phredmax && $phredmin > -1} {
          set abi_seq [abi_get_seq $align_select_window2 [lindex $abi_info($align_select_window2,basecall_loc,edited) $phredmin] [lindex $abi_info($align_select_window2,basecall_loc,edited) $phredmax]]
        } else {
          set abi_seq [abi_get_seq $align_select_window2 start end]
        }
      } else {
        set abi_seq [abi_get_seq $align_select_window2 start end]
      }
      set ydna [lindex $abi_seq 1]
      if {$abi_info($align_select_window2,rev_com)} {
        set ydir -1
        set yfirst [expr {1+[llength [$align_select_window2.c find withtag basecall]]-[lindex $abi_seq 0]}]
      } else  {
        set yfirst [expr {[lindex $abi_seq 0]}]
      }
    }
    if {($info(align_blocksize) != "N-W align all") && ($info(align_blocksize) > 2000)} {
      set info(align_blocksize) 2000
    }
    if {($align_dir eq [mc "Forward"]) || ($align_dir eq [mc "Best"])} {
      if {$info(align_blocksize) != "N-W align all"} {
        set resultlist [block_align3 $xdna $ydna $info(align_blocksize)]
      } else {
        set resultlist [NW_affine_align $xdna $ydna 1]
      }
    } else {
      set resultlist [list $xdna $ydna [string repeat . [expr {max([string length $xdna], [string length $ydna])}]]]
    }
    if {($align_dir eq [mc "Rev-com"]) || ($align_dir eq [mc "Best"])} {
      if {$info(align_blocksize) != "N-W align all"} {
        set resultlist_r [block_align3 $xdna [revcom $ydna] $info(align_blocksize)]
      } else {
        set resultlist_r [NW_affine_align $xdna [revcom $ydna]]
      }
    } else {
      set resultlist_r [list $xdna $ydna [string repeat . [expr {max([string length $xdna], [string length $ydna])}]]]
    }
    
## bug: needs a way to calculate the exact score to decide which alignment to use
    if {($align_dir eq [mc "Forward"]) || (($align_dir eq [mc "Best"]) && ([regexp -all {\|} [lindex $resultlist 2]]) >= ([regexp -all {\|} [lindex $resultlist_r 2]]))} {
      lappend xout_list [lindex $resultlist 0]
      lappend yout_list [lindex $resultlist 1]
      lappend ydir_list $ydir
      lappend yfirst_list $yfirst
      lappend lineout_list [lindex $resultlist 2]
    } else {
      lappend xout_list [lindex $resultlist_r 0]
      lappend yout_list [lindex $resultlist_r 1]
      lappend ydir_list [expr {-1 * $ydir}]
      lappend yfirst_list [expr {1+ $yfirst + [regexp -all {[a-zA-Z]} [lindex $resultlist_r 1]]}] 
      lappend lineout_list [lindex $resultlist_r 2]
    }
    if {![info exists info(($align_select_window2,linked_events)]} {set info($align_select_window2,linked_events) [list]}
    #increment progress bar
    incr align_prog
    update idletasks
  }


  #***build cds translations here then add those to the master alignment

  foreach tagdata $cds_lines {
    lappend xout_list [string repeat " " [string length $xdna]] [string repeat " " [string length $xdna]]
    foreach tagdata1 [lrange $tagdata 1 end] {
      if {($info(align_select_region1) == "selection") && ([$align_ref_seq.textarea tag nextrange tempsel 1.0] != "")} {
        set selfirst [ix2bp $align_ref_seq.textarea [$align_ref_seq.textarea index tempsel.first]]
      } else {
          set selfirst 0
      }
      set tagdata1 [string range $tagdata1 $selfirst [expr {$selfirst +[string length $xdna]-1}]]
      if {$xdir== -1} {
        set tagdata1 [revcom $tagdata1]
      }
      lappend yout_list $tagdata1
    }
  }



  #align each alignment to generate the final multi-alignment
  set mm_list [align_master_match $xout_list $yout_list]

  #****take the cds translations back out from yout_list here
  set cds_lists [lrange [lindex $mm_list 1] end-[expr {2*[llength $cds_lines]-1}] end]
  set mm_list [lreplace $mm_list 1 1 [lrange [lindex $mm_list 1] 0 end-[expr {2*[llength $cds_lines]}]]]


  ##make output
  set left_margin 8
  set a [new_analysis_window [concat $align_ref_seq $align_windows_list] "[mc {Alignment to %1$s windows} [llength $align_windows_list]]"]
  create_textframe $a [expr {$info(align_linewidth) + 2*$left_margin + 1}]

  #summary info
  catch {$a.textframe.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
  $a.textframe.text insert end "[wm title $align_ref_seq] from [expr {$xfirst + $xdir}] to [expr {$xfirst + $xdir*[string length $xdna]}]\n"
  $a.textframe.text insert end "[mc {Alignment to}]\n"
  foreach align_select_window2 $align_windows_list lineout $lineout_list {
    $a.textframe.text insert end "[wm title $align_select_window2]--  "
    $a.textframe.text insert end "[mc Matches]:[regexp -all {\|} $lineout]; "
    $a.textframe.text insert end "[mc Mismatches]:[regexp -all {\#} $lineout]; "
    #** should not count leading and trailing gaps
    $a.textframe.text insert end "[mc Gaps]:[regexp -all {\s} $lineout]; "
    #** should only show unattempted if >0; add warning statement
    $a.textframe.text insert end "[mc Unattempted]:[regexp -all {\.} $lineout]\n"
  }


  set xout  [lindex $mm_list 0]
  set yout_list [lindex $mm_list 1]

  ##replace leading and trailing -'s
  regexp {(^-*)(.*?)(-*$)} $xout fill xleading body xtrailing
  set xout "[string repeat "~" [string length $xleading]]$body[string repeat "~" [string length $xtrailing]]"
  set yout_temp [list]
  set leading_trim [string length $xout]
  set trailing_trim [string length $xout]
  foreach yout $yout_list {
    regexp {(^-*)(.*?)(-*$)} $yout fill leading body trailing
    lappend yout_temp "[string repeat "~" [string length $leading]]$body[string repeat "~" [string length $trailing]]"
    set leading_trim [expr {min($leading_trim, max([string length $leading], [string length $xleading]))}]
    set trailing_trim [expr {min($trailing_trim, max([string length $trailing], [string length $xtrailing]))}]
  }
  set yout_list $yout_temp

  #** take out leading and trailing ref seq lines that have no alignment here?
  #needs to trim each string in $cds_lists, $yout_list, $xout; adjust $xfirst (using $dir and  [regexp -all  {[^- ~]}]), $yfirst_list (using $ydir_list)
  if {$info(align_trim_to_alignment)} {
    #sputs align trim $leading_trim $trailing_trim $yfirst_list $ydir_list
    set cdslinetemp [list]
    foreach cdsline $cds_lists {
      lappend cdslinetemp [string range $cdsline $leading_trim end-$trailing_trim]
    }
    set cds_lists $cdslinetemp
    unset cdslinetemp
    set xfirst [expr {$xfirst + $xdir * [regexp -all  {[^- ~]} [string range $xout 0 $leading_trim-1]]}]
    set xout [string range $xout $leading_trim end-$trailing_trim]
    set youttemp [list]
    set yfirsttemp [list]
    foreach yout $yout_list ydir $ydir_list yfirst $yfirst_list {
#sputs $yfirst $ydir $leading_trim [expr {$yfirst + $ydir * [regexp -all  {[^- ~]} [string range $yout 0 $leading_trim-1]]}]
      lappend yfirsttemp [expr {$yfirst + $ydir * [regexp -all  {[^- ~]} [string range $yout 0 $leading_trim-1]]}]
      lappend youttemp [string range $yout $leading_trim end-$trailing_trim]
    }
    set yout_list $youttemp
    set yfirst_list $yfirsttemp
    unset youttemp yfirsttemp
  }


  ###make the top index line
  set spacing [expr {($xdir==-1)? (1 + ($xfirst-1) % 10) : (10 - ($xfirst % 10))}]
  set dot 0
  set x 0
  set xdots ""
  while {[set dot [string length [regexp -inline "(?:-*\[^-\]){$spacing}" [string range $xout $x end]]]] != 0} {
    append xdots "[string repeat " " [expr {$dot-1}]]*"
    set spacing 10
    incr x $dot
  }


  #break output into text lines x is the index of the first character of the line being displayed
  for {set x 0} {$x < [expr {[string length $xout]}]} {incr x $info(align_linewidth)} {
    #insert the index line
    $a.textframe.text insert end \n
    $a.textframe.text insert end "[string repeat " " $left_margin][string range $xdots $x [expr {$x+$info(align_linewidth)-1}]]\n"

    #insert cds translation lines
    foreach cdsline $cds_lists {
      set cdsoutline [string range $cdsline $x [expr {$x+$info(align_linewidth)-1}]]
      if {[regexp {[^\s\-]} $cdsoutline]} {
        $a.textframe.text insert end "[string repeat " " $left_margin]$cdsoutline\n"
      }
    }

    #insert the xout line
    set xchars [regexp -all  {[^- ~]} [string range $xout $x [expr {$x+$info(align_linewidth)-1}]]]
    set x_linestart [expr {$xfirst+ $xdir*([regexp -all  {[^- ~]} [string range $xout 0 $x-1]] + (($xchars>0)?1:0))}]
    $a.textframe.text insert end [format "%[expr {$left_margin -1}]u[expr {$xdir>0?">":"<"}]" $x_linestart]
    set dnastarts [$a.textframe.text index end-1char]
    set lstag "ls[expr {$x_linestart-1}]\_$xdir" 
    $a.textframe.text insert end "[set x_linestore [string range $xout $x [expr {$x+$info(align_linewidth)-1}]]]" [list $align_ref_seq\_tag $lstag noalignhighlight]
    if {($info(align_copy_highlight)) && ([string first .abi_window $align_ref_seq] == -1) && ($xchars > 0)} {
      copy_tags $align_ref_seq.textarea [list [bp2ix $align_ref_seq.textarea [expr {$x_linestart-1}]] [bp2ix $align_ref_seq.textarea [expr {$x_linestart-1 +$xdir * ( $xchars- (($xchars>0)?1:0))}]]] $a.textframe.text $dnastarts [expr {($xdir==1)?"forward":"reverse"}] 
    }
    $a.textframe.text insert end "[format "[expr {$xdir>0?">":"<"}]%-[expr {$left_margin -1}]u" [expr {$x_linestart +$xdir*( $xchars- (($xchars>0)?1:0))}]]\n"
    #add live link bindings 
    $a.textframe.text tag bind $align_ref_seq\_tag <Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink2 $a.textframe.text $align_ref_seq \[$a.textframe.text index @%x,%y\] goto 1; break"
    lappend info($align_ref_seq,linked_events) [list $a.textframe.text $align_ref_seq\_tag <Double-Button-1>]
    $a.textframe.text tag bind $align_ref_seq\_tag <Shift-Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink2 $a.textframe.text $align_ref_seq \[$a.textframe.text index @%x,%y\] select 1; break"
    lappend info($align_ref_seq,linked_events) [list $a.textframe.text $align_ref_seq\_tag <Shift-Double-Button-1>]
    $a.textframe.text tag bind $align_ref_seq\_tag <Button-1> "alignlink2 $a.textframe.text $align_ref_seq \[$a.textframe.text index @%x,%y\] goto 0; break"
    lappend info($align_ref_seq,linked_events) [list $a.textframe.text $align_ref_seq\_tag <Button-1>]
    $a.textframe.text tag bind $align_ref_seq\_tag <Shift-Button-1> "alignlink2 $a.textframe.text $align_ref_seq \[$a.textframe.text index @%x,%y\] select 0; break"
    lappend info($align_ref_seq,linked_events) [list $a.textframe.text $align_ref_seq\_tag <Shift-Button-1>]
    $a.textframe.text tag bind $align_ref_seq\_tag <Any-Leave> {%W tag remove highlite 1.0 end}
    $a.textframe.text tag bind $align_ref_seq\_tag <Any-Motion> {%W tag remove highlite 1.0 end; %W tag add highlite current}


    set x_linestore [string toupper $x_linestore]
    #insert all of the yout lines
    set y_line_count 0
    foreach yout $yout_list ydir $ydir_list yfirst $yfirst_list ywindow $align_windows_list {
      incr y_line_count
      set ychars [regexp -all  {[^- ~]} [string range $yout $x [expr {$x+$info(align_linewidth)-1}]]]
      #** skip the line if $ychars == 0?
      set y_linestart [expr {$yfirst+ $ydir*([regexp -all  {[^- ~]} [string range $yout 0 $x-1]] + (($ychars>0)?1:0))}]
      $a.textframe.text insert end [format "%[expr {$left_margin -1}]u[expr {$ydir>0?">":"<"}]" $y_linestart]
      set dnastarts [$a.textframe.text index end-1char]
      set lstag "ls[expr {$y_linestart-1}]\_$ydir"
      $a.textframe.text insert end "[set y_linestore [string range $yout $x [expr {$x+$info(align_linewidth)-1}]]]" [list $ywindow\_tag $lstag]
      #copy tags
      if {($info(align_copy_highlight)) && ([string first .abi_window $ywindow] == -1) && ($ychars > 0)} {
        copy_tags $ywindow.textarea [list [bp2ix $ywindow.textarea [expr {$y_linestart-1}]] [bp2ix $ywindow.textarea [expr {$y_linestart-1 +$ydir * ( $ychars- (($ychars>0)?1:0))}]]] $a.textframe.text $dnastarts [expr {($ydir==1)?"forward":"reverse"}] $ywindow
      }
      #add mmtag
      if {$ychars > 0} {
        $a.textframe.text tag remove noalignhighlight [$a.textframe.text index $dnastarts-$y_line_count\lines] [$a.textframe.text index $dnastarts+[string length $y_linestore]\chars-$y_line_count\lines]
        for {set i 0} {$i < [string length $y_linestore]} {incr i} {
          if {([string index $y_linestore $i] ne "~")  && ([string toupper [string index $y_linestore $i]] eq [string toupper [string index $x_linestore $i]])} {
              $a.textframe.text tag add matchhighlite [$a.textframe.text index $dnastarts+$i\chars-$y_line_count\lines]
          }
        }
      }
      if {([set y_linestore [string toupper $y_linestore]] ne $x_linestore) && ([regexp {[^- ~]} $y_linestore]) && (1 ||($ychars > [expr {[string length $y_linestore] / 2}]))} {
        for {set i 0} {$i < [string length $y_linestore]} {incr i} {
          if {([string index $y_linestore $i] ne "~") && ([string index $x_linestore $i] ne "~")} {
            if {([string index $y_linestore $i] ne [string index $x_linestore $i])} {
              $a.textframe.text tag add mmhighlite [$a.textframe.text index $dnastarts+$i\chars]
            } else {
             # $a.textframe.text tag add matchhighlite [$a.textframe.text index $dnastarts+$i\chars]
             # $a.textframe.text tag add matchhighlite [$a.textframe.text index $dnastarts+$i\chars-$y_line_count\lines]
            }
          }
        }
      } elseif {$y_linestore eq $x_linestore} {
        #$a.textframe.text tag add matchhighlite [$a.textframe.text index $dnastarts] [$a.textframe.text index $dnastarts+[string length $y_linestore]\chars]
        $a.textframe.text tag remove noalignhighlight [$a.textframe.text index $dnastarts-$y_line_count\lines] [$a.textframe.text index $dnastarts+[string length $y_linestore]\chars-$y_line_count\lines]
        $a.textframe.text tag add matchhighlite [$a.textframe.text index $dnastarts-$y_line_count\lines] [$a.textframe.text index $dnastarts+[string length $y_linestore]\chars-$y_line_count\lines]
      }
      #** add mmhigligth to index numbers at start and end of the line too?

      #add live link bindings 
      $a.textframe.text tag bind $ywindow\_tag <Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink2 $a.textframe.text $ywindow \[$a.textframe.text index @%x,%y\] goto 1; break"
      lappend info($ywindow,linked_events) [list $a.textframe.text $ywindow\_tag <Double-Button-1>]
      $a.textframe.text tag bind $ywindow\_tag <Shift-Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink2 $a.textframe.text $ywindow \[$a.textframe.text index @%x,%y\] select 1; break"
      lappend info($ywindow,linked_events) [list $a.textframe.text $ywindow\_tag <Shift-Double-Button-1>]
      $a.textframe.text tag bind $ywindow\_tag <Button-1> "alignlink2 $a.textframe.text $ywindow \[$a.textframe.text index @%x,%y\] goto 0; break"
      lappend info($ywindow,linked_events) [list $a.textframe.text $ywindow\_tag <Button-1>]
      $a.textframe.text tag bind $ywindow\_tag <Shift-Button-1> "alignlink2 $a.textframe.text $ywindow \[$a.textframe.text index @%x,%y\] select 0; break"
      lappend info($ywindow,linked_events) [list $a.textframe.text $ywindow\_tag <Shift-Button-1>]
      $a.textframe.text tag bind $ywindow\_tag <Any-Leave> {%W tag remove highlite 1.0 end}
      $a.textframe.text tag bind $ywindow\_tag <Any-Motion> {%W tag remove highlite 1.0 end; %W tag add highlite current}

      $a.textframe.text tag bind $ywindow\_tag <Any-Motion> "+;abi_tooltip_post $a.textframe.text $ywindow %x %y"
      #lappend info($ywindow,linked_events) [list $a.textframe.text $ywindow\_tag <Any-Motion>]
      $a.textframe.text tag bind $ywindow\_tag <Any-Enter> "+;abi_tooltip_post $a.textframe.text $ywindow %x %y; break"
      #lappend info($ywindow,linked_events) [list $a.textframe.text $ywindow\_tag <Any-Enter>]
      $a.textframe.text tag bind $ywindow\_tag <Any-Leave> "+;destroy .abitooltip"
      #lappend info($ywindow,linked_events) [list $a.textframe.text $ywindow\_tag <Any-Leave>]
#bind $a.textframe <FocusOut> "destroy .abitooltip"
      #**ctrl mouseover to generate tooltip of window name

      $a.textframe.text insert end "[format "[expr {$ydir>0?">":"<"}]%-[expr {$left_margin -1}]u" [expr {$y_linestart +$ydir*( $ychars- (($ychars>0)?1:0))}]]\n"
    }
    $a.textframe.text insert end \n
  }
  $a.textframe.text tag configure mmhighlite -background red -foreground white
  $a.textframe.text tag raise mmhighlite 
  $a.textframe.text tag configure matchhighlite -font bolddnafont -underline 1
  $a.textframe.text tag configure noalignhighlight -foreground gray80
  $a.textframe.text tag configure highlite -background red -foreground white

  #add popup menu
  set outputmenu [add_output_menu $a.textframe.text "Text" text $align_ref_seq]
  #raise parent is linked to the reference sequence
  $outputmenu entryconfigure [mc "Raise Parent"] -label [mc "Raise Reference sequence"]
  if {$window_type1 eq "abi"} {
    bind $a.textframe.text <<Return>> "wm deiconify $align_ref_seq; raise $align_ref_seq; focus $align_ref_seq.c"
  }

  #configure raise parent events for aligned sequences
  if {[llength $align_windows_list] > 0} {
    $outputmenu insert  [expr {1+[$outputmenu index [mc "Raise Reference sequence"]]}] cascade -menu [menu $outputmenu.subwindowcascade] -label [mc "Raise Window"]
    foreach ywindow $align_windows_list {
      $outputmenu.subwindowcascade add command -label [mc {Raise %1$s} [wm title $ywindow]] -command "event generate $a.textframe.text <<Return_$ywindow>>"
      if {[string first .abi_window $ywindow] == -1} {
        bind $a.textframe.text <<Return_$ywindow>> "wm deiconify $ywindow; raise $ywindow; focus $ywindow.textarea"
      } else {
        bind $a.textframe.text <<Return_$ywindow>> "wm deiconify $ywindow; raise $ywindow; focus $ywindow.c"
      }
      lappend info($ywindow,linked_events) [list $a.textframe.text <<Return_$ywindow>>]
    }
  }

  bind $a <Button-1> "focus $a.textframe.text"
  bind $a.textframe.text <Double-Button> break
  bind $a.textframe.text <Shift-Double-Button> break
  bind $a.textframe.text <Double-Button-1> ""
  bindtags $a.textframe.text [list $a.textframe.text AnalysisText . all]
  wm deiconify $a
  window_on_screen $a
  focus $a.textframe.text
}

############
## subroutine of output alignment2
## make all alignments have the same reference sequence (ref seq list, align seq list)
############
proc align_master_match {m_list s_list} {

  if {($m_list == [list]) || ($s_list == [list])} {return [list]}
  set count 0
  for {set count 0} {$count < [llength $m_list]} {incr count} {
    set i($count) 0
    set s_out($count) ""
  }
  set m_out ""

  set cont 1
  while {$cont} {
   #scan all elements of m_list for a dash at the index position
   #if any index positions are past the end, break
    set dash 0
    for {set count 0} {$count < [llength $m_list]} {incr count} {
      if {[set char [string index [lindex $m_list $count] $i($count)]] eq ""} {
        set cont 0
        break
      } elseif {$char eq "-"} {
        set dash 1
      }
    }

    #break while loop if any are past their ends
    if {!$cont} break
    #if any m_list index characters are dash, add dash to the m_out and put char out for m_lists with dashes, dash for those without (don't incr index for those)
    if {$dash} {
      append m_out "-"
      for {set count 0} {$count < [llength $m_list]} {incr count} {
        if {[string index [lindex $m_list $count] $i($count)] eq "-"} {
          append s_out($count) [string index [lindex $s_list $count] $i($count)]
          incr i($count)
        } else {
          append s_out($count) "-"
        }
      }
    } else {
      append m_out [string index [lindex $m_list 0] $i(0)]
      for {set count 0} {$count < [llength $m_list]} {incr count} {
        append s_out($count) [string index [lindex $s_list $count] $i($count)]
        incr i($count)
      }
    }
  }

  set len_max 0
  for {set count 0} {$count < [llength $m_list]} {incr count} {
    append s_out($count) [string range [lindex $s_list $count] $i($count) end]
    set len_max [expr {max ($len_max, [string length $s_out($count)])}]
  }
  append m_out [string repeat "-" [expr {$len_max - [string length $m_out]}]] 
  set s_out_list [list]
  for {set count 0} {$count < [llength $m_list]} {incr count} {
    append s_out($count) [string repeat "-" [expr {$len_max - [string length $s_out($count)]}]]
    lappend s_out_list $s_out($count)  
  }
  return [list $m_out $s_out_list]
}


##################
## block align2 algorithm that takes each block in xdna and finds all matches in ydna, keeps running list of lists of possible alignments
##################
proc block_align2 {xdna ydna} {
  global info
    set xseq [string toupper $xdna]
    set yseq [string toupper $ydna]
    set res_list [list [list]]
    for {set i 0} {[expr {$i+$info(align_blocksize)-1}] < [string length $xseq]} {incr i $info(align_blocksize)} {
      set found 0
      set foundlist [list]
      set lastfound [expr {-$info(align_blocksize) -2}]
      #find all blocks in ydna that align to the current block in xdna
      while {([set found [string first [string range $xseq $i [expr {$i+$info(align_blocksize)-1}]] $yseq $found]] > -1)} {
        if { (([expr {$found-$lastfound}] < $info(align_blocksize)) || ([llength $foundlist] > 4))} {
          set foundlist [list]
          break
        } else {
          lappend foundlist $found
          set lastfound $found
          incr found
        }
      }

      #add this block to all possible alignments
      if {[llength $res_list] < 40000} {
        set res_list [blockalign_result_insert $res_list [list $i $foundlist] $info(align_blocksize)]
      } else {
        break
      }
    }



    #find longest result list
    set maxlen 0
    set new_res [list]
    foreach res $res_list {
      if {[llength $res] > $maxlen} {
        set new_res $res
        set maxlen [llength $res]
      }
    }

    #take result list and generate alignment
    set x1 0
    set y1 0
    set xout ""
    set yout ""
    set lineout ""

    foreach res $new_res {
      set x2 [expr {[lindex $res 0]}]
      set y2 [expr {[lindex $res 1]}]
      if {($x2 > $x1) || ($y2 > $y1)} {
        set alignlist [finealign [string range $xdna $x1 [expr {$x2-1}]] [string range $ydna $y1 [expr {$y2 - 1}]]]
        append xout [lindex $alignlist 0]
        append yout [lindex $alignlist 1]
        append lineout [lindex $alignlist 2]
      }
      append xout [string range $xdna $x2 [expr {$x2+$info(align_blocksize)-1}]]
      append yout [string range $ydna $y2 [expr {$y2+$info(align_blocksize)-1}]]
      append lineout [string repeat "|" $info(align_blocksize)]
      set x1 [expr {$x2+$info(align_blocksize)}]
      set y1 [expr {$y2+$info(align_blocksize)}]
    }
    set alignlist [finealign [string range $xdna $x1 end] [string range $ydna $y1 end]]
    append xout [lindex $alignlist 0]
    append yout [lindex $alignlist 1]
    append lineout [lindex $alignlist 2]
    return [list $xout $yout $lineout]
}

############
## subroutine of blockalign2
## feed a list of prior blockalign alignment paths, list of new hit positions, return all possible alignment paths up to that point
############
proc blockalign_result_insert {res_lists pos_list align_blocksize} {


#loop through pos_list append to output_list the possible result lists for each one
  if {[lindex $pos_list 1] == [list]} {
    return $res_lists
  }
  set output_list [list]
  foreach pos [lindex $pos_list 1] {
    foreach proto_list $res_lists {
      if {($proto_list == [list]) || ([expr {$pos - $align_blocksize +1}] >= [lindex [lindex $proto_list end] 1])} {
        lappend proto_list [list [lindex $pos_list 0] $pos]

      } else {
        set new_list [list]
        foreach element $proto_list {
          if {[lindex $element 1] < [expr {$pos - $align_blocksize +1}]} {
            lappend new_list $element
          } else {
            break
          }
        }
        lappend new_list [list [lindex $pos_list 0] $pos]
        lappend output_list $new_list
      }
      lappend output_list $proto_list
    }
  }
  return $output_list
}


##################
## block align algorithm that takes each block in xdna and finds all matches in ydna, keeps running list of lists of possible alignments
##################
proc block_align3b {xdna ydna} {
  global info

    set xseq [string toupper $xdna]
    set yseq [string toupper $ydna]
    set res_list ""

    for {set i 0} {[expr {$i+$info(align_blocksize)-1}] < [string length $xseq]} {incr i $info(align_blocksize)} {
      set found 0
      set foundlist [list]
      set search_string [string range $xseq $i [expr {$i+$info(align_blocksize)-1}]]
      #find all blocks in ydna that align to the current block in xdna
      if {[string range $search_string 0 end-1] != [string range $search_string 1 end]} {
        while {([set found [string first $search_string $yseq $found]] > -1)} {
          lappend res_list [list $i $found]
          incr found
        }
      } else {
      }
    }
   set new_res [blockalign_combine_blocks $res_list] 

    #take result list and generate alignment
    set x1 0
    set y1 0
    set xout ""
    set yout ""
    set lineout ""

    foreach res $new_res {
      set x2 [expr {[lindex $res 0]}]
      set y2 [expr {[lindex $res 1]}]
      set align_blocksize [lindex $res 2]
      if {($x2 > $x1) || ($y2 > $y1)} {
        set alignlist [finealign [string range $xdna $x1 [expr {$x2-1}]] [string range $ydna $y1 [expr {$y2 - 1}]]]
        append xout [lindex $alignlist 0]
        append yout [lindex $alignlist 1]
        append lineout [lindex $alignlist 2]
      }
      append xout [string range $xdna $x2 [expr {$x2+$align_blocksize-1}]]
      append yout [string range $ydna $y2 [expr {$y2+$align_blocksize-1}]]
      append lineout [string repeat "|" $align_blocksize]
      set x1 [expr {$x2+$align_blocksize}]
      set y1 [expr {$y2+$align_blocksize}]
    }
    set alignlist [finealign [string range $xdna $x1 end] [string range $ydna $y1 end]]
    append xout [lindex $alignlist 0]
    append yout [lindex $alignlist 1]
    append lineout [lindex $alignlist 2]
    return [list $xout $yout $lineout]
}

############
## subroutine of block_align3b
############
proc blockalign_combine_blocks {blockslist} {
  global info okgo

  set align_blocksize $info(align_blocksize)
  if {$blockslist == {}} {return}
  set a([lindex $blockslist 0]) [lindex $blockslist 0]
  

  foreach block [lrange $blockslist 1 end] {
    set i 0
    foreach line [array names a] {
      if {([expr {[lindex $a($line) 0] + $align_blocksize}] == [lindex $block 0]) && ([expr {[lindex $a($line) 1] + $align_blocksize}] == [lindex $block 1])} {
        set a($line) $block
        set i 1
        break
      }
    }
    if {!$i} {
      set a($block) $block
    }
  }
  foreach res [lsort -integer -index 1 [array names a]] {
    lappend reslist [concat $res [expr {[lindex $a($res) 0] -[lindex $res 0] + $align_blocksize}]]
  }


  ##need to take out all lines that are a complete subset of another line here
  for {set k 0} {$k < [llength $reslist]} {incr k} {
    for {set j [expr {$k +1}]} {$j < [llength $reslist]} {incr j} {
      set kel [lindex $reslist $k]
      set jel [lindex $reslist $j]
      if {([lindex $jel 0] >= [lindex $kel 0]) && ([lindex $jel 0] <= [expr {[lindex $kel 0] + [lindex $kel 2]}]) && ([lindex $jel 1] >= [lindex $kel 1]) && ([lindex $jel 1] <= [expr {[lindex $kel 1] + [lindex $kel 2]}]) && ([expr {[lindex $jel 0] +[lindex $jel 2]}] >= [lindex $kel 0]) && ([expr {[lindex $jel 0] +[lindex $jel 2]}] <= [expr {[lindex $kel 0] + [lindex $kel 2]}]) && ([expr {[lindex $jel 1] +[lindex $jel 2]}] >= [lindex $kel 1]) && ([expr {[lindex $jel 1] +[lindex $jel 2]}] <= [expr {[lindex $kel 1] + [lindex $kel 2]}])} {
        set reslist [lreplace [K $reslist [set reslist {}]] $j $j]
        incr j -1
      }
      if {([lindex $jel 0] <= [lindex $kel 0]) && ([lindex $jel 0] >= [expr {[lindex $kel 0] + [lindex $kel 2]}]) && ([lindex $jel 1] <= [lindex $kel 1]) && ([lindex $jel 1] >= [expr {[lindex $kel 1] + [lindex $kel 2]}]) && ([expr {[lindex $jel 0] +[lindex $jel 2]}] <= [lindex $kel 0]) && ([expr {[lindex $jel 0] +[lindex $jel 2]}] >= [expr {[lindex $kel 0] + [lindex $kel 2]}]) && ([expr {[lindex $jel 1] +[lindex $jel 2]}] <= [lindex $kel 1]) && ([expr {[lindex $jel 1] +[lindex $jel 2]}] >= [expr {[lindex $kel 1] + [lindex $kel 2]}])} {
        set reslist [lreplace [K $reslist [set reslist {}]] $k $k]
        incr k -1
        break
      }
    }
  }



  ####need to use the blockalign_result_insert algorithm to find the longest full alignment from the combined blocks 
  ##start with single blank list as out_list
  ##foreach reslist
  ## foreach out_list
  ## if current_reslist adds smoothly to current_out_list, add it on
  ## else add new out_list that is the longest list that can be made with current_outlist that ends with current_reslist
  ## make new out list by looping through blocks of current_outlist until index 0 of the block+ block length > index 0 of current_reslist (don't need to check index 1, since those are in inceasing order)
  ## if index 0 of the block is > index 0 current_reslist, just add the current_reslist as the last block, else change the length of the last block to be difference in the two inxex 0, then add the current_reslist block.


  set outlist [list [list [lindex $reslist 0]]]
  set new_outlist ""
  foreach current_reslist [lrange $reslist 1 end] {
    set new_outlist ""
    foreach current_outlist $outlist {
      if {(([expr {[lindex [lindex $current_outlist end] 0] + [lindex [lindex $current_outlist end] 2]}] < [lindex $current_reslist 0]) && ([lindex [lindex $current_outlist end] 1] < [lindex $current_reslist 1]))} {
         lappend new_outlist [concat $current_outlist [list $current_reslist]]
       } else {
         lappend new_outlist $current_outlist
         ##need to make new list by adding current_reslist to end of current_outlist
         set newlist ""
         foreach block $current_outlist {
           if {([expr {[lindex $block 0] + [lindex $block 2]}] >= [lindex $current_reslist 0]) || ([lindex $block 1] >= [lindex $current_reslist 1])} {
             if {([lindex $block 0] < [lindex $current_reslist 0]) && ([lindex $block 1] < [lindex $current_reslist 1])} {
               ##**add in the partial block here
             }
             break
           }
           lappend newlist $block
         } 
         if {[lsearch $new_outlist [set newlist [concat $newlist [list $current_reslist]]]] == -1} {
           lappend new_outlist $newlist
         }
       }
    }
    set outlist $new_outlist
  }

  set longest_list ""
  set longest_sum 0
  foreach list $outlist {
    set sum 0
    foreach block $list {
      incr sum [lindex $block 2]
    }
    if {$sum > $longest_sum} {
      set longest_sum $sum
      set longest_list $list
    }
  }

  return $longest_list
}


##################
## block align4 algorithm that takes each block in xdna and finds all matches in ydna, keeps running list of lists of possible alignments
##################
proc block_align4 {xdna ydna} {
  global info
    set xseq [string toupper $xdna]
    set yseq [string toupper $ydna]
    set block_start_list [list]
    set block_end_list [list]
    for {set i 0} {[expr {$i+$info(align_blocksize)-1}] < [string length $xseq]} {incr i $info(align_blocksize)} {
      set found 0
      set foundlist [list]
      set lastfound [expr {-$info(align_blocksize) -2}]
      #find all blocks in ydna that align to the current block in xdna
      while {([set found [string first [string range $xseq $i [expr {$i+$info(align_blocksize)-1}]] $yseq $found]] > -1)} {
        if {(([expr {$found-$lastfound}] < $info(align_blocksize)) || ([llength $foundlist] > 4))} {
          set foundlist [list]
          break
        } else {
          lappend foundlist $found
          set lastfound $found
          incr found
        }
      }

      #add this block to block lists
      foreach found $foundlist {
        if {[set extend [lsearch -exact $block_end_list [list [expr {$i}] [expr {$found}]]]] > -1} {
          lset block_end_list $extend [list [expr {$i+$info(align_blocksize)}] [expr {$found+$info(align_blocksize)}]]
        } else {
sputs ext $block_end_list [list [expr {$i}] [expr {$found}]]
          lappend block_start_list [list $i $found]
          lappend block_end_list [list [expr {$i+$info(align_blocksize)}] [expr {$found+$info(align_blocksize)}]]
        }
      }
    }

sputs $block_start_list
sputs $block_end_list
    return [list "" "" ""]
}

##########################
#blockalign Dec 2011- currently in use
########################## 
proc block_align3 {xdna ydna blocksize} {
global text1 text2
  set text1 [string toupper $xdna]
  set text2 [string toupper $ydna]
  set result [list]

  #find blocks that are present only once in each sequence (ignore anything repeated)
  set i 0
  set lastlen 0
  foreach a [regexp -all -inline [string repeat . $blocksize] $text1] {
    if {([regexp -all $a $text1] == 1) &&  ([llength [set r1list [regexp -all -inline -indices $a $text2]]] == 1)  && ([regexp -all -start [expr {[lindex [lindex $r1list 0] 0]+1}] $a $text2] == 0)} {

      if {($lastlen > 0) && ([lindex [lindex $r1list 0] 0] == [expr {[lindex [lindex $result end] 1] + $lastlen}]) } {
        incr lastlen $blocksize
        #add len to last block
        lset result end end $lastlen
      } else {
        lappend result [list $i  [lindex [lindex $r1list 0] 0] $blocksize]
        set lastlen $blocksize
      }
    } else {
      set lastlen 0
    }
    incr i $blocksize
  }

#bug {{0 1 15} {15 15 60}} shouldn't be added together
  #add together adjacent blocks connected by identical sequence that was filtered by the repeat masking
  set res2 [list [lindex $result 0]]
  foreach b [lrange $result 1 end] {
    foreach {a1 a2 a3} [lindex $res2 end] {}
    foreach {b1 b2 b3} $b {}
    if {([string range $text1 [expr {$a1+$a3}] [expr {$b1-1}]] == [string range $text2 [expr {$a2+$a3}] [expr {$b2-1}]]) && ([expr {$a1+$a3}] <= $b1) && ([expr {$a2+$a3}] <= $b2)} {
      lset res2 end end [expr {$b1 -$a1 +$b3}]
    } else {
      lappend res2 $b
    }
  }

 
  #sort by size, then adjust or take out any block inconsistent with a larger block
  if {[llength [lindex $res2 0]] > 0} {
  set rlist [list]
  set res3 [lsort -index 2 -decreasing -integer $res2]
  for {set i 0} {$i < [llength $res3]} {incr i} {
    foreach {ax1 ay1 al} [lindex $res3 $i] {}
    if {$ax1 == -1} continue
    set ax2 [expr {$ax1 + $al}]
    set ay2 [expr {$ay1 + $al}]
    for {set j [expr {$i+1}]} {$j < [llength $res3]} {incr j} {
      foreach {bx1 by1 bl} [lindex $res3 $j] {} 
      if {$bx1 == -1} continue
      set bx2 [expr {$bx1 + $bl}]
      set by2 [expr {$by1 + $bl}]  
      if {($bx1 < $ax1) && ($by1 < $ay1)}  {
        if {($bx2 > $ax1) || ($by2 > $ay1)} {
          #shorten b to be upper left of a
          set newl [expr {min(($ax1-$bx1-1),($ay1-$by1-1))}]
          lset res3 $j [list $bx1 $by1 $newl]
        }
      } elseif {($bx2 > $ax2) && ($by2 > $ay2)} {
        if {($bx1 < $ax2) || ($by1 < $ay2)} {
          #shorten b to be lower right of a
          set newl [expr {min(($bx2-$ax2-1),($by2-$ay2-1))}]
          lset res3 $j [list [expr {$bx2-$newl}] [expr {$by2-$newl}] $newl]
        }
      } else {
        # b is inconsistent with a- delete it
        # if a is circular, it is possible that rotating b (set bx1 [expr {($bx1 - $r) % [string length $text2]}]) would make it consistent- store as possible r: $by2
        #lappend rlist $by2
        lset res3 $j [list -1 -1 0]
      }
    }
  }
  #take out the -1 -1 0 elements and sort by first index
  set res3 [lsort -index 0 -increasing -integer $res3]
  set res3 [lrange $res3 [lsearch -not -integer -index 0 $res3 -1] end]
  } else {
    set res3 $res2
  }

  # use finealign xdna ydna to put together the full alignment
  if {[llength [lindex $res3 0]] > 0} {
    set xout ""
    set yout ""
    set lout ""
    set ax2 -1
    set ay2 -1
    foreach resitem $res3 {
      foreach {ax1 ay1 al} $resitem {}
      set rlist1 [finealign [string range $xdna [expr {$ax2+1}] [expr {$ax1-1}]] [string range $ydna [expr {$ay2+1}] [expr {$ay1-1}]]]
      set ax2 [expr {$ax1 + $al -1}]
      set ay2 [expr {$ay1 + $al -1}]
      append xout [lindex $rlist1 0] [string range $xdna $ax1 $ax2]
      append yout [lindex $rlist1 1] [string range $ydna $ay1 $ay2]
      append lout [lindex $rlist1 2] [string repeat | $al]
    }
    set rlist1 [finealign [string range $xdna [expr {$ax2+1}] end] [string range $ydna [expr {$ay2+1}] end] ]
    append xout [lindex $rlist1 0]
    append yout [lindex $rlist1 1]
    append lout [lindex $rlist1 2]
  } else {
    return [finealign $xdna $ydna]
  }

  

  return [list $xout $yout $lout]
}

################
## OLD DNA alignment dialog- align two sequences
################
proc align_dialog {w} {
  global info  
  global align_select_window1
  global align_select_window2
  global ok dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1


  if {[winfo exists .aligndialog]} {destroy .aligndialog}
  set s [toplevel .aligndialog]
  wm title $s [mc "Align DNA"]
  wm protocol $s WM_DELETE_WINDOW "set ok -1"
  bind $s <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify $s; raise $s"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry $s "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient $s $w
  } else {
    ::tk::unsupported::MacWindowStyle style $s document {closeBox}
  }
  grid [label $s.label1 -text [mc "Window"]] -row 1 -column 1 -sticky ne
  menubutton $s.win_button1
    menu $s.win_button1.menu
    foreach window $info(dnawindows_list) {
      $s.win_button1.menu add radiobutton -command "$s.win_button1 configure -text \{[wm title $window]\}" -label [wm title $window] -variable align_select_window1 -value $window 
    }
    set abi_list [lsort -unique [regexp -inline -all {\.abi_window[0-9]*} "[winfo children .] "]]
    if {[llength $abi_list] > 0} {
      $s.win_button1.menu add separator
      foreach window $abi_list {
        $s.win_button1.menu add radiobutton -command "$s.win_button1 configure -text \{[wm title $window]\}" -label [wm title $window] -variable align_select_window1 -value $window 
      }
    }
  $s.win_button1 configure -text [wm title $w] -menu $s.win_button1.menu -indicatoron 1 -relief raised -width 60 
  bind $s.win_button1.menu <<MenuSelect>> "focus $s"
  set align_select_window1 $w
  grid $s.win_button1 -row 1 -column 2 -columnspan 3

  #grid [checkbutton $s.local1 -selectcolor $info(bg_color) -width 10 -variable info(align_select_region1) -textvariable info(align_select_region1) -onvalue "selection" -offvalue "all" -indicator off] -row 1 -column 5
  #grid [checkbutton $s.rc1 -selectcolor $info(bg_color) -width 8 -variable info(align_select_rc1) -textvariable info(align_select_rc1) -offvalue "forward" -onvalue "rev/com" -indicator off] -row 1 -column 6
  grid [checkbutton $s.local1 -width 10 -variable info(align_select_region1) -text [mc "Selection Only"] -onvalue "selection" -offvalue "all" -indicator on -selectcolor white] -row 1 -column 5
  grid [checkbutton $s.rc1 -width 8 -variable info(align_select_rc1) -text [mc "Rev-Com"] -offvalue "forward" -onvalue "rev/com" -indicator on -selectcolor white] -row 1 -column 6
  grid [label $s.label2 -text [mc "Window"]] -row 2 -column 1 -sticky ne
  menubutton $s.win_button2
    menu $s.win_button2.menu
    foreach window $info(dnawindows_list) {
      $s.win_button2.menu add radiobutton -command "$s.win_button2 configure -text \{[wm title $window]\}" -label [wm title $window] -variable align_select_window2 -value $window 
    }
    if {[llength $abi_list] > 0} {
      $s.win_button2.menu add separator
      foreach window $abi_list {
        $s.win_button2.menu add radiobutton -command "$s.win_button2 configure -text \{[wm title $window]\}" -label [wm title $window] -variable align_select_window2 -value $window 
      }
    }
  bind $s.win_button2.menu <<MenuSelect>> "focus $s"
  if {[winfo exists $info(align_select_window2)]} {
    set align_select_window2 $info(align_select_window2)
  } else {
    set align_select_window2 $w
  }
  $s.win_button2 configure -text [wm title $align_select_window2] -menu $s.win_button2.menu -indicatoron 1 -relief raised -width 60 
  grid $s.win_button2 -row 2 -column 2 -columnspan 3

  #grid [checkbutton $s.local2 -selectcolor $info(bg_color) -width 10 -variable info(align_select_region2) -textvariable info(align_select_region2) -onvalue "selection" -offvalue "all" -indicator off -selectcolor white] -row 2 -column 5
  #grid [checkbutton $s.rc2 -selectcolor $info(bg_color) -width 8 -variable info(align_select_rc2) -textvariable info(align_select_rc2) -offvalue "forward" -onvalue "rev/com" -indicator off -selectcolor white] -row 2 -column 6

  grid [checkbutton $s.local2 -width 10 -variable info(align_select_region2) -text [mc "Selection Only"]  -onvalue "selection" -offvalue "all" -indicator on -selectcolor white] -row 2 -column 5
  grid [checkbutton $s.rc2 -width 8 -variable info(align_select_rc2) -text [mc "Rev-Com"] -offvalue "forward" -onvalue "rev/com" -indicator on -selectcolor white] -row 2 -column 6

  grid [label $s.blockslabel -text [mc "Blocks:"]] -row 4 -column 1 -sticky ne
  menubutton $s.blocksbut -indicatoron 1 -relief raised -width 10 -textvariable info(align_blocksize)
  menu $s.blocksbut.blocks
    $s.blocksbut.blocks add radiobutton -label "20" -value 20 -variable info(align_blocksize)
    $s.blocksbut.blocks add radiobutton -label "15" -value 15 -variable info(align_blocksize)
    $s.blocksbut.blocks add radiobutton -label "10" -value 10 -variable info(align_blocksize)
    $s.blocksbut.blocks add radiobutton -label [mc "N-W align all"] -value "N-W align all" -variable info(align_blocksize)
  $s.blocksbut configure -menu $s.blocksbut.blocks
  bind $s.blocksbut <<MenuSelect>> "focus $s"

  grid $s.blocksbut -row 4 -column 2 -sticky nw

  grid [label $s.nwmaxlabel -text [mc "N-W max:"]] -row 4 -column 3 -sticky ne
  grid [entry $s.nwmaxentry -validate key -width 4 -vcmd "check_char %S" -textvariable info(NWmax)] -row 4 -column 4 -sticky nw

  grid [label $s.mmplabel -text [mc "Mismatch Penalty:"]] -row 5 -column 1 -sticky nw
  menubutton $s.mmpbut -indicatoron 1 -relief raised -width 10 -textvariable info(mm_penalty)
  menu $s.mmpbut.mmpmenu
    foreach val {0 -0.1 -0.2 -0.3 -0.4 -0.5 -0.6 -0.7 -0.8 -0.9 -1 -1.1 -1.2 -1.3 -1.4 -1.5 -1.6 -1.7 -1.8 -1.9 -2} {
       $s.mmpbut.mmpmenu add radiobutton -label " $val" -value $val -variable info(mm_penalty)
    }
  $s.mmpbut configure -menu $s.mmpbut.mmpmenu
  bind $s.mmpbut.mmpmenu <<MenuSelect>> "focus $s"
  grid $s.mmpbut -row 5 -column 2 -sticky nw

  grid [label $s.gapplabel -text [mc "Gap Penalty:"]] -row 5 -column 3 -sticky ne
  menubutton $s.gappbut -indicatoron 1 -relief raised -width 10 -textvariable info(gap_penalty)
  menu $s.gappbut.gapp
    foreach val {0 -0.1 -0.2 -0.3 -0.4 -0.5 -0.6 -0.7 -0.8 -0.9 -1 -1.1 -1.2 -1.3 -1.4 -1.5 -1.6 -1.7 -1.8 -1.9 -2} {
       $s.gappbut.gapp add radiobutton -label " $val" -value $val -variable info(gap_penalty)
    }
  $s.gappbut configure -menu $s.gappbut.gapp
  bind $s.gappbut.gapp <<MenuSelect>> "focus $s"
  grid $s.gappbut -row 5 -column 4 -sticky nw

  grid [label $s.gapeplabel -text [mc "Gap Ext. Penalty:"]] -row 5 -column 5 -sticky ne
  menubutton $s.gapepbut -indicatoron 1 -relief raised -width 10 -textvariable info(gap_extension_penalty)
  menu $s.gapepbut.gapep
    foreach val {0 -0.1 -0.2 -0.3 -0.4 -0.5 -0.6 -0.7 -0.8 -0.9 -1} {
      $s.gapepbut.gapep add radiobutton -label " $val" -value $val -variable info(gap_extension_penalty)
    }
  $s.gapepbut configure -menu $s.gapepbut.gapep
  bind $s.gapepbut.gapep <<MenuSelect>> "focus $s"
  grid $s.gapepbut -row 5 -column 6 -sticky nw

  grid [label $s.widthentrylabel -text [mc "Line Width:"]] -row 6 -column 1 -sticky ne
  grid [entry $s.widthentry -width 5 -validate key -vcmd "check_char %S" -textvariable info(align_linewidth)] -row 6 -column 2 -sticky nw
  grid [checkbutton $s.highlight -selectcolor white -text [mc "Copy Highlighting from Sequence"] -onvalue 1 -offvalue 0 -variable info(align_copy_highlight)] -row 6 -column 3 -columnspan 2

  grid [label $s.phredtrimlabel -text [mc "Trim ends with Phred <:"]] -row 7 -column 1 -sticky ne
  grid [entry $s.phredtrim -width 5 -validate key -vcmd "check_char %S" -textvariable info(align_phredtrim)] -row 7 -column 2 -sticky nw

  grid [button $s.ok -text [mc "OK"] -command "set ok 1" -default active] -row 8 -column 1 -columnspan 2 -padx 10 -pady 3
  bind $s <Key-Return> "set ok 1"
  grid [button $s.cancel -text [mc "Cancel"] -command "set ok -1"] -row 8 -column 2 -columnspan 2 -padx 10 -pady 3
  #grab $s
  focus $s

  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $s] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry $s "+$winx+$winy"

  vwait ok
  set dialogblock 0
  if {$info(NWmax) == ""} {set info(NWmax) 300}
  if {$info(align_linewidth) == ""} {set info(align_linewidth) 100}
  set info(align_select_window2) $align_select_window2
  #grab release $s
  destroy $s
  bind . <<RaiseDialogs>> ""
  if {$ok == 1} {output_alignment}
  unset ok 
}

################
## align DNA sequences and make a window with the output- used for align two sequences
################
proc output_alignment {} {
  global align_select_window1
  global align_select_window2
  global info abi_info
  global modifier
  global modstring

  $align_select_window1 configure -cursor watch
  $align_select_window2 configure -cursor watch
  set xdir 1; set ydir 1

  if {[string first .abi_window $align_select_window1] == -1} {
    ###window1 is a sequence window
    #$align_select_window1.textarea configure -cursor watch
    set window_type1 "sequence"
    if {($info(align_select_region1) == "selection") && ([$align_select_window1.textarea tag nextrange tempsel 1.0] != "")} {
      set xdna [textarea_get $align_select_window1.textarea tempsel.first tempsel.last]
      if {$info(align_select_rc1) == "rev/com"} {
        set xfirst [expr {1+[ix2bp $align_select_window1.textarea [$align_select_window1.textarea index tempsel.last]]}]
        set xdna [revcom $xdna]
        set xdir -1
      } else {
        set xfirst [ix2bp $align_select_window1.textarea [$align_select_window1.textarea index tempsel.first]]
      }
    } else {
      set xdna [textarea_get $align_select_window1.textarea 1.0 end-1chars]
      if {$info(align_select_rc1) == "rev/com"} {
        set xfirst [expr {1+[ix2bp $align_select_window1.textarea [$align_select_window1.textarea index end-1c]]}]
        set xdna [revcom $xdna]
        set xdir -1
      } else {
        set xfirst 0
      }
    }
  } else {
    ###window1 is an abi window
    #$align_select_window1.c configure -cursor watch
    set window_type1 "abi"
    if {($info(align_select_region1) == "selection")} {
      set abi_seq [abi_get_seq $align_select_window1 sel.first sel.last]
      if {$abi_seq == ""} {
        set abi_seq [abi_get_seq $align_select_window1 start end]
      }
    } else {
      set abi_seq [abi_get_seq $align_select_window1 start end]
    }
    if {$info(align_select_rc1) == "rev/com"} {
      set xdna [revcom [lindex $abi_seq 1]]
      if {!$abi_info($align_select_window1,rev_com)} {
        set xdir -1
        set xfirst [expr {1+[lindex $abi_seq 0]+[string length [lindex $abi_seq 1]]}]
      } else {
        set xfirst [expr {[llength [$align_select_window1.c find withtag basecall]]-[lindex $abi_seq 0]-[string length [lindex $abi_seq 1]]}]
      }
    } else {
      set xdna [lindex $abi_seq 1]
      if {$abi_info($align_select_window1,rev_com)} {
        set xdir -1
        set xfirst [expr {1+[llength [$align_select_window1.c find withtag basecall]]-[lindex $abi_seq 0]}]
      } else  {
        set xfirst [expr {[lindex $abi_seq 0]}]
      }
    }
  }

  if {[string first .abi_window $align_select_window2] == -1} {
    ###window2 is a sequence window
    #$align_select_window2.textarea configure -cursor watch
    set window_type2 "sequence"
    if {($info(align_select_region2) == "selection") && ([$align_select_window2.textarea tag nextrange tempsel 1.0] != "")} {
      set ydna [textarea_get $align_select_window2.textarea tempsel.first tempsel.last]
      if {$info(align_select_rc2) == "rev/com"} {
        set yfirst [expr {1+[ix2bp $align_select_window2.textarea [$align_select_window2.textarea index tempsel.last]]}]
        set ydna [revcom $ydna]
        set ydir -1
      } else {
        set yfirst [ix2bp $align_select_window2.textarea [$align_select_window2.textarea index tempsel.first]]
      }
    } else {
      set ydna [textarea_get $align_select_window2.textarea 1.0 end-1chars]
      if {$info(align_select_rc2) == "rev/com"} {
        set yfirst [expr {1+[ix2bp $align_select_window2.textarea [$align_select_window2.textarea index end-1c]]}]
        set ydna [revcom $ydna]
        set ydir -1
      } else {
        set yfirst 0
      }
    }
  } else {
    ###window2 is an abi window
    #$align_select_window2.c configure -cursor watch
    set window_type2 "abi"
    if {($info(align_select_region2) == "selection")} {
      set abi_seq [abi_get_seq $align_select_window2 sel.first sel.last]
      if {$abi_seq == ""} {
        set abi_seq [abi_get_seq $align_select_window2 start end]
      }
    } else {
      set abi_seq [abi_get_seq $align_select_window2 start end]
    }
    if {$info(align_select_rc2) == "rev/com"} {
      set ydna [revcom [lindex $abi_seq 1]]
      if {!$abi_info($align_select_window2,rev_com)} {
        set ydir -1
        set yfirst [expr {1+[lindex $abi_seq 0]+[string length [lindex $abi_seq 1]]}]
      } else {
        set yfirst [expr {[llength [$align_select_window2.c find withtag basecall]]-[lindex $abi_seq 0]-[string length [lindex $abi_seq 1]]}]
      }
    } else {
      set ydna [lindex $abi_seq 1]
      if {$abi_info($align_select_window2,rev_com)} {
        set ydir -1
        set yfirst [expr {1+[llength [$align_select_window2.c find withtag basecall]]-[lindex $abi_seq 0]}]
      } else  {
        set yfirst [expr {[lindex $abi_seq 0]}]
      }
    }
  }
  
  update

  if {$info(align_blocksize) != "N-W align all"} {
    #set resultlist [block_align $xdna $ydna]
    set resultlist [block_align3 $xdna $ydna $info(align_blocksize)]
  } else {
    set resultlist [NW_affine_align $xdna $ydna 1]
  }

  set xout [lindex $resultlist 0]
  set yout [lindex $resultlist 1]
  set lineout [lindex $resultlist 2]

  ###make the top index line
  set spacing [expr {($xdir==-1)? (1 + ($xfirst-1) % 10) : (10 - ($xfirst % 10))}]
  #sputs "$xfirst $spacing"
  set dot 0
  set x 0
  set xdots ""
  while {[set dot [string length [regexp -inline "(?:-*\[^-\]){$spacing}" [string range $xout $x end]]]] != 0} {
    set xdots "$xdots[string repeat " " [expr {$dot-1}]]*"
    set spacing 10
    incr x $dot
  }
  set spacing [expr {($ydir == -1) ? (1 + ($yfirst-1) % 10) : (10 - $yfirst%10)}]
  set dot 0
  set x 0
  set ydots ""
  while {[set dot [string length [regexp -inline "(?:-*\[^-\]){$spacing}" [string range $yout $x end]]]] != 0} {
    set ydots "$ydots[string repeat " " [expr {$dot-1}]]*"
    set spacing 10
    incr x $dot
  }
  if {$align_select_window1 != $align_select_window2} {
    set winlist [list $align_select_window1 $align_select_window2]
  } else {
    set winlist [list $align_select_window1]
  }
  set a [new_analysis_window $winlist "[mc {Alignment to}] [wm title $align_select_window2]"]

  ##make output
  create_textframe $a [expr {$info(align_linewidth)+15}]
  #summary info
  catch {$a.textframe.text insert end "[clock format [clock seconds] -format $info(clock_format)]\n"}
  $a.textframe.text insert end "[wm title $align_select_window1] from [expr {$xfirst + $xdir}] to [expr {$xfirst + $xdir*[string length $xdna]}]\n"
  $a.textframe.text insert end "[mc {Alignment to}]\n"
  $a.textframe.text insert end "[wm title $align_select_window2] from [expr {$yfirst + $ydir}] to [expr {$yfirst + $ydir*[string length $ydna]}]\n\n"
  $a.textframe.text insert end "[mc Matches](|):[string length [string map {" " "" # "" . ""} $lineout]] \n"
  $a.textframe.text insert end "[mc Mismatches](#):[string length [string map {" " "" | "" . ""} $lineout]] \n"
  $a.textframe.text insert end "[mc Gaps]( ):[string length [string map {"|" "" # "" . ""} $lineout]] \n"
  $a.textframe.text insert end "[mc Unattempted](.):[string length [string map {" " "" # "" | ""} $lineout]] \n\n"

  ##replace leading and trailing -'s
  regexp {(^-*)(.*?)(-*$)} $xout fill leading body trailing
  set xout "[string repeat "~" [string length $leading]]$body[string repeat "~" [string length $trailing]]"
  regexp {(^-*)(.*?)(-*$)} $yout fill leading body trailing
  set yout "[string repeat "~" [string length $leading]]$body[string repeat "~" [string length $trailing]]"

  set xdnastarted 0
  set ydnastarted 0

  for {set x 0} {$x < [expr {[string length $xout]}]} {incr x $info(align_linewidth)} {
    set linelength [expr {[string length $xout]-$x-1}]
    if {$linelength > [expr {$info(align_linewidth)-1}]} {set linelength [expr {$info(align_linewidth)-1}]}
    set xchars [regexp -all  {[^- ~]} [string range $xout $x [expr {$x+$linelength}]]]
    set ychars [regexp -all  {[^- ~]} [string range $yout $x [expr {$x+$linelength}]]]
    if {$xchars > 0} {
      set xdnastarted 1
      $a.textframe.text insert end "[string repeat { } 7][string range $xdots $x [expr {$x+$linelength}]]\n"
      $a.textframe.text insert end "[format {%6u } [incr xfirst $xdir]]"
      set dnastarts [$a.textframe.text index end-1char]
      $a.textframe.text insert end "[string range $xout $x [expr {$x+$linelength}]]" w1tag
      if {($info(align_copy_highlight)) && ($window_type1 eq "sequence")} {
        copy_tags $align_select_window1.textarea [list [bp2ix $align_select_window1.textarea [expr {$xfirst-1}]] [bp2ix $align_select_window1.textarea [expr {$xfirst-1+$xdir*($xchars-1)}]]] $a.textframe.text $dnastarts [expr {($xdir==1)?"forward":"reverse"}] "w1"
      }
      $a.textframe.text insert end "[format { %-6u} [incr xfirst [expr {$xdir*($xchars-1)}]]]\n"
    } else {
      #for lines that are all gap
      if {$xdnastarted && ([string index $xout $x] == "~")} {
        $a.textframe.text insert end "[format {%6u } [expr {$xfirst}]]" {} "[string range $xout $x [expr {$x+$linelength}]]" w1tag "[format { %-6u} [expr {$xfirst}]]\n" {}
      } else {
        $a.textframe.text insert end "[format {%6u } [expr {$xfirst+$xdir}]]" {} "[string range $xout $x [expr {$x+$linelength}]]" w1tag "[format { %-6u} [expr {$xfirst+$xdir}]]\n" {}
      }
    }
    set lineout_sub [string range $lineout $x [expr {$x+$linelength}]]
    $a.textframe.text insert end "[string repeat { } 7]$lineout_sub[string repeat { } 7]\n"
    ##add highlight tag to mismatches and gaps
    if {[regexp {[^\.\ ]} $lineout_sub]} {
      set ls [$a.textframe.text index "end-2char linestart"]
      foreach highliterange [regexp -inline -indices -all {[^|]+} $lineout_sub] {
        $a.textframe.text tag add mmhighlite [$a.textframe.text index $ls+[expr {7+[lindex $highliterange 0]}]chars] [$a.textframe.text index $ls+[expr {[lindex $highliterange 1]+8}]chars]
      }
    }
    if {$ychars > 0} {
      set ydnastarted 1
      $a.textframe.text insert end "[format {%6u } [incr yfirst $ydir]]"
      set dnastarts [$a.textframe.text index end-1char]
      $a.textframe.text insert end "[string range $yout $x [expr {$x+$linelength}]]" w2tag
      if {($info(align_copy_highlight)) && ($window_type2 eq "sequence")} {
        copy_tags $align_select_window2.textarea [list [bp2ix $align_select_window2.textarea [expr {$yfirst-1}]] [bp2ix $align_select_window2.textarea [expr {$yfirst-1+$ydir*($ychars-1)}]]] $a.textframe.text $dnastarts [expr {($ydir==1)?"forward":"reverse"}] "w2"
      }
      $a.textframe.text insert end "[format { %-6u} [incr yfirst [expr {$ydir*($ychars-1)}]]]\n"
      $a.textframe.text insert end "[string repeat { } 7][string range $ydots $x [expr {$x+$linelength}]]\n\n"
    } else {
      if {$ydnastarted && ([string index $yout $x] == "~")} {
        $a.textframe.text insert end "[format {%6u } [expr {$yfirst}]]" {} "[string range $yout $x [expr {$x+$linelength}]]" w2tag "[format { %-6u} [expr {$yfirst}]]\n\n"
      } else {
        $a.textframe.text insert end "[format {%6u } [expr {$yfirst+$ydir}]]" {} "[string range $yout $x [expr {$x+$linelength}]]" w2tag "[format { %-6u} [expr {$yfirst+$ydir}]]\n\n"
      }

    }
  }

  if {$window_type2 eq "sequence"} {
    foreach tag [$align_select_window2.textarea tag names] {
      if {[$a.textframe.text tag ranges "$tag\w2"] != "" } {
        $a.textframe.text tag raise "$tag\w2"
      }
    }
  }

  if {$window_type1 eq "sequence"} {
    foreach tag [$align_select_window1.textarea tag names] {
      if {[$a.textframe.text tag ranges "$tag\w1"] != "" } {
        $a.textframe.text tag raise "$tag\w1"
      }
    }
  }

  $a.textframe.text tag bind w1tag <Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink $a.textframe.text $align_select_window1 \[$a.textframe.text index @%x,%y\] $xdir goto 1; break"
  $a.textframe.text tag bind w2tag <Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink $a.textframe.text $align_select_window2 \[$a.textframe.text index @%x,%y\] $ydir goto 1; break"
  $a.textframe.text tag bind w1tag <Shift-Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink $a.textframe.text $align_select_window1 \[$a.textframe.text index @%x,%y\] $xdir select 1; break"
  $a.textframe.text tag bind w2tag <Shift-Double-Button-1> "$a.textframe.text tag add sel @%x,%y; alignlink $a.textframe.text $align_select_window2 \[$a.textframe.text index @%x,%y\] $ydir select 1; break"
  $a.textframe.text tag bind w1tag <$modifier-Button-1> "alignlink $a.textframe.text $align_select_window1 \[$a.textframe.text index @%x,%y\] $xdir goto 0; break"
  $a.textframe.text tag bind w2tag <$modifier-Button-1> "alignlink $a.textframe.text $align_select_window2 \[$a.textframe.text index @%x,%y\] $ydir goto 0; break"
  $a.textframe.text tag bind w1tag <Shift-$modifier-Button-1> "alignlink $a.textframe.text $align_select_window1 \[$a.textframe.text index @%x,%y\] $xdir select 0; break"
  $a.textframe.text tag bind w2tag <Shift-$modifier-Button-1> "alignlink $a.textframe.text $align_select_window2 \[$a.textframe.text index @%x,%y\] $ydir select 0; break"
  lappend info($align_select_window1,linked_events) [list $a.textframe.text w1tag <Double-Button-1>]
  lappend info($align_select_window2,linked_events) [list $a.textframe.text w2tag <Double-Button-1>]
  lappend info($align_select_window1,linked_events) [list $a.textframe.text w1tag <Shift-Double-Button-1>]
  lappend info($align_select_window2,linked_events) [list $a.textframe.text w2tag <Shift-Double-Button-1>]
  lappend info($align_select_window1,linked_events) [list $a.textframe.text w1tag <$modifier-Button-1>]
  lappend info($align_select_window2,linked_events) [list $a.textframe.text w2tag <$modifier-Button-1>]
  lappend info($align_select_window1,linked_events) [list $a.textframe.text w1tag <Shift-$modifier-Button-1>]
  lappend info($align_select_window2,linked_events) [list $a.textframe.text w2tag <Shift-$modifier-Button-1>]
  $a.textframe.text tag bind w1tag <Any-Leave> {%W tag remove highlite 1.0 end}
  $a.textframe.text tag bind w1tag <Any-Motion> {%W tag remove highlite 1.0 end; %W tag add highlite current}
  $a.textframe.text tag bind w2tag <Any-Leave> {%W tag remove highlite 1.0 end}
  $a.textframe.text tag bind w2tag <Any-Motion> {%W tag remove highlite 1.0 end; %W tag add highlite current}
  $a.textframe.text tag configure highlite -background red -foreground white
  $a.textframe.text tag configure mmhighlite -background red -foreground white

  bind $a.textframe.text <Double-Button-1> break
  bind $a.textframe.text <Shift-Double-Button-1> break

  bind $a <Button-1> "focus $a.textframe.text"
  set outputmenu [add_output_menu $a.textframe.text "Text" text $align_select_window1]
  bind $a.textframe.text <Double-Button-1> ""
  $outputmenu entryconfigure [mc "Raise Parent"] -label [mc "Raise Window 1"]
  $outputmenu insert [expr {1+[$outputmenu index [mc "Raise Window 1"]]}] command -label [mc "Raise Window 2"] -accelerator "$modstring+Shift+Space" -command "event generate $a.textframe.text <<Return2>>"
  bind $a.textframe.text <Shift-$modifier-KeyPress-space> "event generate $a.textframe.text <<Return2>>"
  if {$window_type1 eq "abi"} {
    bind $a.textframe.text <<Return>> "wm deiconify $align_select_window1; raise $align_select_window1; focus $align_select_window1.c"
  }
  if {$window_type2 eq "sequence"} {
    bind $a.textframe.text <<Return2>> "wm deiconify $align_select_window2; raise $align_select_window2; focus $align_select_window2.textarea"
  } else {
    bind $a.textframe.text <<Return2>> "wm deiconify $align_select_window2; raise $align_select_window2; focus $align_select_window2.c"
  }
  lappend info($align_select_window2,linked_events) [list $a.textframe.text <<Return2>>]
  bindtags $a.textframe.text [list $a.textframe.text AnalysisText . all]
  wm deiconify $a
  window_on_screen $a
  focus $a.textframe.text

  $align_select_window1 configure -cursor arrow
  #$align_select_window1.textarea configure -cursor xterm
  $align_select_window2 configure -cursor arrow
  #$align_select_window2.textarea configure -cursor xterm
}

################
## align dna sequences starting with blocks, then NW align
################
proc block_align {xdna ydna} {
  global info
    set xseq [string toupper $xdna]
    set yseq [string toupper $ydna]
    set i 0
    set j 0
    set xout ""
    set yout ""
    set xend [expr {[string length $xseq]-$info(align_blocksize)+1}]
    while {$i < [string length $xseq]} {
      set xun ""
      set yun ""
    #find a match
      while {($i < $xend) && ([set found [string first [string range $xseq $i [expr {$i+$info(align_blocksize)-1}]] $yseq $j]] == -1)} {
        append xun [string range $xdna $i [expr {$i+$info(align_blocksize)-1}]]
        incr i $info(align_blocksize)
      }
      if {($i >= $xend)} {
        set found [string length $ydna]
        append xun [string range $xdna $i end]
      }
      set yun [string range $ydna $j [expr {$found-1}]]
 ###align the unaligned regions between matches: xun and yun here
      if {($xun != "") || ($yun != "")} {
        set alignlist [finealign $xun $yun]
        append xout [lindex $alignlist 0]
        append yout [lindex $alignlist 1]
        append lineout [lindex $alignlist 2]
      }
##now add in the match
      if {($i < $xend)} {
        append xout [string range $xdna $i [expr {$i+$info(align_blocksize)-1}]]
        append yout [string range $ydna $found [expr {$found+$info(align_blocksize)-1}]]
        append lineout [string repeat "|" $info(align_blocksize)]
        set j [expr {$found+$info(align_blocksize)}]
      }
      incr i $info(align_blocksize)
    }
    if {$i == [string length $xseq]} {
        set yextra [string range $ydna $j end]
        append xout [string repeat "-" [string length $yextra]]
        append yout $yextra
        append lineout [string repeat " " [string length $yextra]]
    }
  return [list $xout $yout $lineout]
}

################
## sub-procedure of blockalign- expand the blocks and then N-W align the unaligned
################
proc finealign {xdna ydna} {
  set xseq [string toupper $xdna]
  set yseq [string toupper $ydna]
  set i 0
  set j 0
  if {[string length $xseq] > [string length $yseq]} {
    set max [string length $yseq]
  } else {
    set max [string length $xseq]
  }
  while {([string index $xseq $i] == [string index $yseq $i]) && ($i < $max)} {incr i}
  incr i -1
  set maxj [expr $max - $i -2]
  while {([string index $xseq end-$j] == [string index $yseq end-$j]) && ($j <= $maxj)} {incr j}
  incr j -1
  set NWlist [NW_affine_align [string range $xdna [expr $i+1] end-[expr $j +1]] [string range $ydna [expr $i+1] end-[expr $j +1]]]
  append xout [string range $xdna 0 $i] [lindex $NWlist 0] [string range $xdna end-$j end]
  append yout [string range $ydna 0 $i] [lindex $NWlist 1] [string range $ydna end-$j end]
  append lineout [string repeat | [expr $i+1]] [lindex $NWlist 2] [string repeat | [expr $j+1]]
  return [list $xout $yout $lineout]
}

################
## sub-procedure of finealing or blockalign - Needleman-Wunsch Alignment (affine gap penalty)
################
#Needleman-Wunsch Alignment
#n*m/320 ms
proc NW_affine_align {xdna ydna {ignoremax 0}} {
  set atime [clock clicks]
  global info
  if {(!$ignoremax) && ([expr {sqrt([string length $xdna]* [string length $ydna])}] > $info(NWmax))} {
    if {[set diff [expr {[string length $xdna] - [string length $ydna]}]] > 0} {
      return [list $xdna "[string repeat - $diff]$ydna" [string repeat . [string length $xdna]]]
    } else {
      return [list "[string repeat - [expr {-$diff}]]$xdna" $ydna [string repeat . [string length $ydna]]]
    }
  }

  set d $info(gap_penalty)
  set e $info(gap_extension_penalty)
  set mm $info(mm_penalty)

  set seqx [string toupper $xdna]
  set seqy [string toupper $ydna]

  #mttable list of strings mtlist
  #ittable list of strings itlist
  #same level
  #  6 2
  # 4-\|
  #switch level
  #  7 3
  # 5-\|
  ###test with NW_affine_align AAA AA
  ###test with NW_affine_align ATA AA

  #initialize 0,0 
  set mlist [list [expr {[string index $seqx 0] eq [string index $seqy 0]?1:$mm}]]
  set mtlist 7
  set ilist [list -10000000]
  set itlist 4
  #rest of row 0
  for {set i 1} {$i < [string length $seqx]} {incr i} {
    set s [expr {[string index $seqx $i] eq [string index $seqy 0]?1:$mm}]
    lappend mlist [expr {$s+$d+$e*($i-1)}] 
    append mtlist 7
    if {[lindex $mlist [expr {$i-1}]] > [lindex $ilist [expr {$i-1}]]} {
      lappend ilist [expr {[lindex $mlist [expr {$i-1}]]+$d}]
      append itlist 5
    } else {
      lappend ilist [expr {[lindex $ilist [expr {$i-1}]]+$e}]
      append itlist 4
    }
  } 
  set mttable [list $mtlist]
  set ittable [list $itlist]
  set mstor $mlist
  set istor $ilist
#sputs m:$mstor
#sputs i:$istor
  #do rows 1 through end
  for {set j 1} {$j < [string length $seqy]} {incr j} {
    #initialize 0,j
    set mlist [list [expr {([string index $seqx 0] eq [string index $seqy $j]?1:$mm) + $d + $e* ($j -1)}]]
    set mtlist 7
    if {[lindex $mstor 0] >= [lindex $istor 0]} {
      set ilist [list [expr {[lindex $mstor 0] + $d}]]
      set itlist 3
    } else {
      set ilist [list [expr {[lindex $istor 0] + $e}]]
      set itlist 2
    }
    for {set i 1} {$i < [string length $seqx]} {incr i} {
      #lappend mlist [max [lindex mstor ($i-1)] [lindex istor ($i-1)]]
      #lappend itlist 6 7
      set s [expr {[string index $seqx $i] eq [string index $seqy $j]?1:$mm}]
      if {[lindex $mstor [expr {$i-1}]] >= [lindex $istor [expr {$i-1}]]} {
        lappend mlist [expr {[lindex $mstor [expr {$i-1}]] + $s}]
        append mtlist 6
      } else {
        lappend mlist [expr {[lindex $istor [expr {$i-1}]] + $s}]
        append mtlist 7
      }
      #lappend ilist [max [lindex mlist ($i-1)] [lindex ilist ($i-1)] [lindex mstor $i] [lindex istor $i]]
      #lappend itlist 5 4 3 2
      if {[set mleft [lindex $mlist end-1]] > [set mup [lindex $mstor $i]]} {
        if {[set ileft [lindex $ilist end]] > [set iup [lindex $istor $i]]} {
          if {[expr {$mleft + $d}] > [expr {$ileft + $e}]} {
            lappend ilist [expr {$mleft + $d}]
            append itlist 5
          } else {
            lappend ilist [expr {$ileft + $e}]
            append itlist 4
          }
        } else {
          if {[expr {$mleft + $d}] > [expr {$iup + $e}]} {
            lappend ilist [expr {$mleft + $d}]
            append itlist 5
          } else {
            lappend ilist [expr {$iup + $e}]
            append itlist 2
          }
        }
      } else {
        if {[set ileft [lindex $ilist end]] > [set iup [lindex $istor $i]]} {
          if {[expr {$mup + $d}] > [expr {$ileft + $e}]} {
            lappend ilist [expr {$mup + $d}]
            append itlist 3
          } else {
            lappend ilist [expr {$ileft + $e}]
            append itlist 4
          }
        } else {
          if {[expr {$mup + $d}] > [expr {$iup + $e}]} {
            lappend ilist [expr {$mup + $d}]
            append itlist 3
          } else {
            lappend ilist [expr {$iup + $e}]
            append itlist 2
          }
        }
      }
    }
    lappend mttable $mtlist
    lappend ittable $itlist
    set mstor $mlist
    set istor $ilist
#sputs m:$mstor
#sputs i:$istor
  }

  #sputs mttable:
  #foreach row $mttable {
  #  sputs $row
  #}
  #sputs ittable:
  #foreach row $ittable {
  #  sputs $row
  #}
  ### do traceback
  set x [expr {[string length $xdna]-1}] 
  set y [expr {[string length $ydna]-1}] 
  set yout ""
  set xout ""
  set lineout ""
  if {[lindex $mstor end] >= [lindex $istor end]} {
    set z 0
  } else {
    set z 1
  }
  while {($x > -1) && ($y > -1)} {
    if {$z} {
      set v [string index [lindex $ittable $y] $x]
    } else {
      set v [string index [lindex $mttable $y] $x]
    }
    switch $v {
      4  {
        set yout "-$yout"
        set xout "[string index $xdna $x]$xout"
        set lineout " $lineout"
        incr x -1 
        set z 1
      }
      5 {
        set yout "-$yout"
        set xout "[string index $xdna $x]$xout"
        set lineout " $lineout"
        incr x -1 
        set z 0
      }
      6 {
        set yout "[string index $ydna $y]$yout"
        set xout "[string index $xdna $x]$xout"
        if {[string toupper [string index $ydna $y]] eq [string toupper [string index $xdna $x]]} {
          set lineout "|$lineout"
        } else {
          set lineout "#$lineout"
        }
        incr x -1 
        incr y -1
        set z 0
      }
      7 {
        set yout "[string index $ydna $y]$yout"
        set xout "[string index $xdna $x]$xout"
        if {[string toupper [string index $ydna $y]] eq [string toupper [string index $xdna $x]]} {
          set lineout "|$lineout"
        } else {
          set lineout "#$lineout"
        }
        incr x -1 
        incr y -1
        set z 1
      }
      3 {
        set yout "[string index $ydna $y]$yout"
        set xout "-$xout" 
        set lineout " $lineout"
        incr y -1
        set z 0
      }
      2 {
        set yout "[string index $ydna $y]$yout"
        set xout "-$xout" 
        set lineout " $lineout"
        incr y -1
        set z 1
      }
    }
  }
  if {$x > -1} {
    set yout "[string repeat - [expr {1+$x}]]$yout"
    set xout "[string range $xdna 0 $x]$xout"
    set lineout "[string repeat " " [expr {1+$x}]]$lineout"
  } else {
    set xout "[string repeat - [expr {1+$y}]]$xout"
    set yout "[string range $ydna 0 $y]$yout"
    set lineout "[string repeat " " [expr {1+$y}]]$lineout"
  }
  set ctime [clock clicks]

  return [list $xout $yout $lineout]
sputs here1 $xout $yout $lineout
}

################
## sub-procedure of finealing or blockalign - Needleman-Wunsch Alignment
################
#Needleman-Wunsch Alignment
#for comparisons:
#g f
#m ?
# for veclist: 0=left 1=diag 2=up 3=diag,mismatch
#time= 56usec * len(x) * len(y)
proc NWalign {xdna ydna {ignoremax 0}} {
  set atime [clock clicks]
  global info

  if {(!$ignoremax) && ([expr {sqrt([string length $xdna]* [string length $ydna])}] > $info(NWmax))} {
    if {[set diff [expr {[string length $xdna] - [string length $ydna]}]] > 0} {
      return [list $xdna "[string repeat - $diff]$ydna" [string repeat . [string length $xdna]]]
    } else {
      return [list "[string repeat - [expr {-$diff}]]$xdna" $ydna [string repeat . [string length $ydna]]]
    }
  }

  set gp $info(gap_penalty)
  set mp $info(mm_penalty)
  set scorelist1 [list]

  for {set i 1} {$i <= [string length $xdna]} {incr i} {lappend scorelist1 [expr {$i*$gp}]}
  set i 0
  set allvecs [list]
  set ylist [split [string toupper $ydna] ""]
  set xlist [split [string toupper $xdna] ""]
  foreach ychar $ylist {
    set veclist [list]
    set scorelist [list]
    set g $i
    set m [incr i $gp]
    foreach xchar $xlist f $scorelist1 {
      if {$xchar == $ychar} {
        set s [expr {$g+1}]
        set v 1
      } else {
        set s [expr {$g+$mp}]
        set v 3
      }
      if {[expr {$f+$gp}] > $s} {
        set s [expr {$f+$gp}]
        set v 2
      }
      if {[expr {$m+$gp}] > $s} {
        set m [expr {$m+$gp}]
        lappend veclist 0
      } else {
        set m $s
        lappend veclist $v
      }
      lappend scorelist $m
      set g $f

    } 
    set scorelist1 $scorelist
    lappend allvecs $veclist
  }
  set btime [clock clicks]
  set x [expr {[string length $xdna]-1}] 
  set y [expr {[string length $ydna]-1}] 
  set yout ""
  set xout ""
  set lineout ""
  while {($x >-1) && ($y > -1)} {
    switch [lindex [lindex $allvecs $y] $x] {
      0 {
        set yout "-$yout"
        set xout "[string index $xdna $x]$xout"
        set lineout " $lineout"
        incr x -1 
      }
      1 {
        set yout "[string index $ydna $y]$yout"
        set xout "[string index $xdna $x]$xout"
        set lineout "|$lineout"
        incr x -1 
        incr y -1
      }
      3 {
        set yout "[string index $ydna $y]$yout"
        set xout "[string index $xdna $x]$xout"
        set lineout "#$lineout"
        incr x -1 
        incr y -1
      }
      2 {
        set yout "[string index $ydna $y]$yout"
        set xout "-$xout" 
        set lineout " $lineout"
        incr y -1
      }
    }
  }
  if {$x > -1} {
    set yout "[string repeat - [expr {1+$x}]]$yout"
    set xout "[string range $xdna 0 $x]$xout"
    set lineout "[string repeat " " [expr {1+$x}]]$lineout"
  } else {
    set xout "[string repeat - [expr {1+$y}]]$xout"
    set yout "[string range $ydna 0 $y]$yout"
    set lineout "[string repeat " " [expr {1+$y}]]$lineout"
  }
  set ctime [clock clicks]
  return [list $xout $yout $lineout]
sputs here1 $xout $yout $lineout
}


################
## link a double click in an analysis window to the original wndow
################
proc alignlink {textbox window index dir mode {raise 1}} {
  #set text [split [$textbox get [$textbox index "$index linestart"] [$textbox index $index]] "\t"]
  #set linestart [lindex $text 0]
  #set chars [regexp -all {[^-]} [lindex $text 1]]

  if {[regexp {([0-9]+)(?:[[:blank:]~]*)(.*)} [$textbox get [$textbox index "$index linestart"] [$textbox index $index]] line linestart text]} {
    set chars [regexp -all {[^-\~\ ]} $text]

    if {[string first ".abi_window" $window] == -1} {
      #####sequence window
      if {([$textbox get $index] == "-") || ([$textbox get $index] == " ")} {
        if {$mode == "select"} {
          select_region $window [$window.textarea index insert] [bp2ix $window.textarea [expr {$linestart-1+$dir*$chars}]]
        } else {
          select_region $window [bp2ix $window.textarea [expr {$linestart-1+$dir*$chars}]] [bp2ix $window.textarea [expr {$linestart-1+$dir*$chars}]]
        }
      } else {
        if {$mode == "select"} {
          if {[$window.textarea compare [$window.textarea index insert] > [bp2ix $window.textarea [expr {$linestart+$dir*$chars}]]]} {
            select_region $window [$window.textarea index insert] [bp2ix $window.textarea [expr {$linestart-1+$dir*$chars}]]
          } else {
            select_region $window [$window.textarea index insert] [bp2ix $window.textarea [expr {$linestart+$dir*$chars}]]
          }
        } else {
          select_region $window [bp2ix $window.textarea [expr {$linestart-1+$dir*$chars}]] [bp2ix $window.textarea [expr {$linestart-1+$dir*$chars}]]
        }
      }
      if {$raise} {
        wm deiconify $window
        raise $window
        focus $window.textarea
      }
    } else {
      ####abi window
      if {$mode == "select"} {
        abi_select_region $window [expr {$linestart-1+$dir*$chars}] select
      } else {
        abi_select_region $window [expr {$linestart-1+$dir*$chars}] [expr {$linestart-1+$dir*$chars}]
      }
      if {$raise} {
        wm deiconify $window
        raise $window
        focus $window.c
      }
    }
  } else {
    bell
  }
}

#############
##align ling that uses lsxx_yy tag to find line start index(xx) and spacing(yy) for linking translated sequences, or DNA without indexes 
#############
proc alignlink2 {textbox window index mode {raise 1}} {
 if {([set lstag [lsearch -inline  [$textbox tag names $index] ls*]] != "") && [regexp {ls(-?[0-9]+)_(-?[0-9]+)} $lstag blank linestart spacing]} {
    set text [$textbox get [$textbox index "$index linestart"] [$textbox index $index]]
    regsub -all {[0-9]|[[:blank:]~]} $text "" text
    set chars [regexp -all {[^-]} $text]
    if {[string first ".abi_window" $window] == -1} {
      #sequence window
      if {[$textbox get $index] == "-"} {
        if {$mode == "select"} {
          select_region $window [$window.textarea index insert] [bp2ix $window.textarea [expr {$linestart+$spacing*($chars-1)}]]
        } else {
          select_region $window [bp2ix $window.textarea [expr {$linestart+$spacing*($chars-1)}]] [bp2ix $window.textarea [expr {$linestart+1+$spacing*($chars-1)}]]
        }
      } else {
        if {$mode == "select"} {
          if {[$window.textarea compare [$window.textarea index insert] > [bp2ix $window.textarea [expr {$linestart+$spacing*($chars-1)}]]]} {
            select_region $window [$window.textarea index insert] [bp2ix $window.textarea [expr {$linestart+$spacing*($chars-1)}]]
          } else {
            select_region $window [$window.textarea index insert] [bp2ix $window.textarea [expr {$linestart+1+$spacing*($chars-1)}]]
          }
        } else {
            select_region $window [bp2ix $window.textarea [expr {$linestart+$spacing*($chars-1)}]] [bp2ix $window.textarea [expr {$linestart+1+$spacing*($chars-1)}]]
        }
      }
    } else {
      #abi window
      if {$mode == "select"} {
        abi_select_region $window [expr {$linestart+$spacing*($chars-1)}] select
      } else {
        abi_select_region $window [expr {$linestart+$spacing*($chars-1)}] [expr {$linestart+$spacing*($chars-1)}]
      }
    }
    if {$raise} {
      wm deiconify $window
      raise $window
      if {[string first ".abi_window" $window] == -1} {
        focus $window.textarea
      } else {
        focus $window.c
      }
    }
  } else {
    sputs cant get lstag info from $textbox $window $mode $index $lstag
  }
}


################
## alignment window, create abi tooltip window
################
proc abi_tooltip_create {dir} {
  if {[winfo exists .abitooltip]} {
    return
  }
  toplevel .abitooltip  -borderwidth 1 -background black
  if {([tk windowingsystem] == "aqua")} {
    tk::unsupported::MacWindowStyle style .abitooltip help {}
  } else { 
    wm overrideredirect .abitooltip 1
  }
  catch {wm attributes .abitooltip -alpha .7}
  pack [canvas .abitooltip.c -background white]
#if revcom, need to configure item colors to match
  if {$dir < 0} {
    foreach color [list blue red green black] {
      .abitooltip.c create line 0 0 0 0 -fill $color -tags trace
    }
  } else {
    foreach color [list black green red blue] {
      .abitooltip.c create line 0 0 0 0 -fill $color -tags trace
    }
  }
  .abitooltip.c create text 0 0 -fill black -tags label
  .abitooltip.c create text 0 0 -fill black -tags [list seq1 seq] -anchor n -text A
  .abitooltip.c create text 0 0 -fill black -tags [list seq2 seq] -anchor n  -text B
  .abitooltip.c create text 0 0 -fill black -tags [list seq3 seq] -anchor n  -text C
  .abitooltip.c create text 0 0 -fill black -tags trans -anchor n  -text trans
}

################
## alignment window, copy data into abi tooltip window
################
proc abi_tooltip_update {abi_window from_base to_base to_canvas} {
  global abi_info

  set abi_canvas "$abi_window.c"
  set rev 1
  if {$from_base > $to_base} {
    set t $from_base
    set from_base $to_base
    set to_base $t
    set rev -1
  }

  set mid_base [expr {$from_base + 2}]
  if {$from_base <= -2} {
    set mid_base 1
  }
  if {$to_base >=[expr {[llength $abi_info($abi_window,basecall_loc,edited)]+1}]} {
    set mid_base [expr {$mid_base - 1}]
  }
  
  if {$from_base <0} {set from_base 0}
  set from_index [expr {[lindex $abi_info($abi_window,basecall_loc,edited) $from_base]}]

  if {$to_base >=[llength $abi_info($abi_window,basecall_loc,edited)]} {set to_base [expr {[llength $abi_info($abi_window,basecall_loc,edited)] - 1}]}
  set to_index [expr {[lindex $abi_info($abi_window,basecall_loc,edited) $to_base]}]
  foreach base [list 1 2 3 4] {
    set coords [lrange [$abi_canvas coords $base] [expr {$from_index * 2}] [expr {$to_index * 2 + 1}]]
    $to_canvas coords $base {*}$coords
    $to_canvas move $base [expr {-[lindex $coords 0]}] 0
    if {$rev == -1} {
      $to_canvas scale $base 0 0 -1 1
      set left_x [lindex $coords end-1]
    } else {
      set left_x [lindex $coords 0]
    }
  }

  set ix [expr {min($mid_base-1, [llength $abi_info($abi_window,basecall_loc,edited)]-1)}]
  $to_canvas coords seq1 [expr {[lindex $abi_info($abi_window,basecall_loc,edited) $ix]-$left_x}] [lindex [$to_canvas bbox 1] 3]
  $to_canvas coords seq2 [expr {[lindex $abi_info($abi_window,basecall_loc,edited) [expr {$mid_base}]]-$left_x}] [lindex [$to_canvas bbox 1] 3]
  set ix [expr {min($mid_base+1, [llength $abi_info($abi_window,basecall_loc,edited)]-1)}]
  $to_canvas coords seq3 [expr {[lindex $abi_info($abi_window,basecall_loc,edited) $ix]-$left_x}] [lindex [$to_canvas bbox 1] 3]
  $to_canvas coords trans [expr {[lindex $abi_info($abi_window,basecall_loc,edited) [expr {min($mid_base,[llength $abi_info($abi_window,basecall_loc,edited)]-1)}]]-$left_x}] [lindex [$to_canvas bbox seq] 3]
  set seq [string toupper [string range $abi_info($abi_window,basecall,edited) [expr {$mid_base-1}] [expr {$mid_base+1}]]]
  if {$rev == -1} {
    set seq [revcom $seq]
    $to_canvas itemconfigure trans -text [translate $seq]
  }
  $to_canvas itemconfigure seq1 -text [string index $seq 0]
  $to_canvas itemconfigure seq2 -text [string index $seq 1]
  $to_canvas itemconfigure seq3 -text [string index $seq 2]
  $to_canvas itemconfigure trans -text [translate $seq]
  $to_canvas itemconfigure label -state hidden
  $to_canvas itemconfigure seq -state normal
  $to_canvas itemconfigure trace -state normal
  $to_canvas itemconfigure trans -state normal
  set bbox [$to_canvas bbox all]
  $to_canvas configure -scrollregion [$to_canvas bbox all] -width [expr {[lindex $bbox 2]-[lindex $bbox 0]}] -height [expr {[lindex $bbox 3]-[lindex $bbox 1]}]
  return [expr {[lindex $bbox 3]-[lindex $bbox 1]}]
}

################
##
################
proc abi_tooltip_seq_update {window base to_canvas} {
  $to_canvas itemconfigure label -state normal -text "[wm title $window]:$base"
  $to_canvas itemconfigure seq -state hidden
  $to_canvas itemconfigure trace -state hidden
  $to_canvas itemconfigure trans -state hidden
  set bbox [$to_canvas bbox all]
  $to_canvas configure -scrollregion [$to_canvas bbox all] -width [expr {[lindex $bbox 2]-[lindex $bbox 0]}] -height [expr {[lindex $bbox 3]-[lindex $bbox 1]}]
  return [expr {[lindex $bbox 3]-[lindex $bbox 1]}]
#need to scale and move the items to fit in canvas
}

################
##
################
#$a.textframe.text tag bind $ywindow\_tag <Motion> "+;abi_tooltip_post $a.textframe.text $ywindow %x %y"
#$a.textframe.text tag bind $ywindow\_tag <Enter> "+;abi_tooltip_post $a.textframe.text $ywindow %x %y"
#$a.textframe.text tag bind $ywindow\_tag <Leave> "+;destroy .abitooltip"
#bind $a.textframe <FocusOut> "destroy .abitooltip"
#needs to deal with rev-com abi window and rev-com alignment
proc abi_tooltip_post {textbox window x y} {
  if {![winfo exists $window]} return
  set index [$textbox index @$x,$y]  
  if {([set lstag [lsearch -inline  [$textbox tag names $index] ls*]] != "") && [regexp {ls(-?[0-9]+)_(-?[0-9]+)} $lstag blank linestart spacing]} {
    set text [$textbox get [$textbox index "$index linestart"] [$textbox index $index]]
    regsub -all {[0-9]|[[:blank:]~]} $text "" text
    set chars [regexp -all {[^-]} $text]
    if {[string first ".abi_window" $window] == -1} {
      abi_tooltip_create $spacing
      set tt_height [abi_tooltip_seq_update $window [expr {$linestart+$spacing*($chars)}] .abitooltip.c]
      wm geometry .abitooltip "+[expr {[winfo rootx $textbox]+$x- ([winfo width .abitooltip]/2)+7 }]+[expr {[winfo rooty $textbox]+$y- $tt_height-19}]"
      return
    } else {
      #abi window
      abi_tooltip_create $spacing
      set tt_height [abi_tooltip_update $window [expr {$linestart+$spacing*($chars-1-2)}] [expr {$linestart+$spacing*($chars-1+2)}] .abitooltip.c]
      wm geometry .abitooltip "+[expr {[winfo rootx $textbox]+$x- ([winfo reqwidth .abitooltip]/2)}]+[expr {[winfo rooty $textbox]+$y- $tt_height-19}]"
    }
  } else {
    sputs abi_tooltip_post cant get lstag info from $textbox $window $index
  }
}





################
## Send DNA to the NCBI BLAST server and open results in a browser
################
proc NCBI_Blast {w} {
  ####http://www.ncbi.nlm.nih.gov/BLAST/Doc/urlapi.html
  global ok
  global info dialogblock ncbi_select_window
  if {$dialogblock == 1} {return}
  set dialogblock 1



  if {1} {
    toplevel .dialog 
    wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
    bind .dialog <KeyPress-Escape>  "set ok -1"
    wm title .dialog [mc "BLAST DNA at NCBI..."]
    set raisedialog_store [bind . <<RaiseDialogs>>]
    bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient .dialog $w
    } else {
      ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
    }
    set ok 0

    grid [frame .dialog.frame1] -row 1 -column 0
    grid [label .dialog.frame1.label -text [mc "Window:"] -font boldlabelfont] -row 0 -column 0 -sticky ens
    menubutton .dialog.frame1.win_button
    menu .dialog.frame1.win_button.menu 
    foreach window $info(dnawindows_list) {
      .dialog.frame1.win_button.menu add radiobutton -label $info($window,win_title) -variable ncbi_select_window -value $window  -command ".dialog.frame1.win_button configure -text \$info($window,win_title)"
    }
    .dialog.frame1.win_button configure -text $info($w,win_title) -menu .dialog.frame1.win_button.menu -indicatoron 1 -relief raised -width 25
    bind .dialog.frame1.win_button <<MenuSelect>> "focus .dialog"
    set ncbi_select_window $w
    grid .dialog.frame1.win_button -row 0 -column 1 -sticky wens

    grid [checkbutton .dialog.frame1.local -height 1 -width 10 -variable info(analyze_selection) -text [mc "Selection Only"] -onvalue "selection" -offvalue "all" -indicator on -selectcolor white] -row 0 -column 2 -sticky wns 



    grid [label .dialog.frame1.proglabel -text [mc "BLAST Program:"] -font boldlabelfont] -row 1 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.prog -textvariable info(ncbi_blast,program) -menu .dialog.frame1.prog.menu -indicatoron 1 -relief raised] -row 1 -column 1 -sticky w
    menu .dialog.frame1.prog.menu
     foreach bprog [list blastn blastp blastx tblastn tblastx] {
      .dialog.frame1.prog.menu add radiobutton -label $bprog -indicatoron 1 -value $bprog -variable info(ncbi_blast,program)
    }
    bind .dialog.frame1.prog.menu <<MenuSelect>> "focus .dialog"
    grid [label .dialog.frame1.expectlabel -text [mc "Expect:"] -font boldlabelfont] -row 2 -column 0 -sticky nse
    grid [entry .dialog.frame1.expect -textvariable info(ncbi_blast,expect)] -row 2 -column 1 -sticky w
    grid [checkbutton .dialog.frame1.filter -text [mc "Low Complexity Filter"] -font boldlabelfont -onvalue 1 -offvalue 0 -variable info(ncbi_blast,low_filter)] -row 3 -column 0 -columnspan 2

    grid [frame .dialog.frame2] -row 2 -column 0
    grid [button .dialog.frame2.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 0 -sticky ns -padx 10 -pady 3
    bind .dialog <Key-Return> "set ok 1"
    grid [button .dialog.frame2.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 1 -sticky ns -padx 10 -pady 3

    grid columnconfigure .dialog 0 -weight 1
    grid rowconfigure .dialog 1 -weight 1
    grid rowconfigure .dialog 2 -weight 0

    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .dialog "+$winx+$winy"
    update

    focus .dialog
    vwait ok 
    set dialogblock 0
    destroy .dialog
    bind . <<RaiseDialogs>> ""
    if {$ok == 1} {
      if {([$ncbi_select_window.textarea tag ranges sel] == "") || ($info(analyze_selection) == "all")} {
        set first 1.0
        set last [$w.textarea index end-1chars]
      } else {
        set first [$w.textarea index sel.first]
        set last [$w.textarea index sel.last]
      }
      set text [textarea_get $w.textarea $first $last]
      if {($info(ncbi_blast,program) == "blastp") || ($info(ncbi_blast,program) == "tblastn")} {
        set text [translate $text]
      }
      if {[string length $text] > 15} {
        set url "http://www.ncbi.nlm.nih.gov/blast/Blast.cgi?[::http::formatQuery QUERY $text DATABASE $info(ncbi_blast,database) EXPECT $info(ncbi_blast,expect) PROGRAM $info(ncbi_blast,program) SERVICE plain CMD Put]"
        if {$info(ncbi_blast,low_filter)} {append url "&FILTER=L"}

        set x [::http::geturl $url -blocksize 4096 -timeout 20000 -command blast_callback]
      } else {
        tk_messageBox -message [mc "Not enough sequence selected for BLASTing"] -type ok -icon warning -default ok
      }
    }
  }
  unset ncbi_select_window
}


################
## called by blast to open the browser to display results
################
proc blast_callback {token} {
  global info


  if {[::http::status $token] == "timeout"} {
    warning_dialog "Command timed out- possibly a firewall issue?"
  } else {
    set html  [::http::data $token]

    #get the RID:
    if {[regexp {.*RID = (.*?)\n.*} $html fill RID]} {
     #set the web page URL
      set url "http://www.ncbi.nlm.nih.gov/blast/Blast.cgi?[::http::formatQuery CMD Get RID $RID FORMAT_OBJECT Alignment FORMAT_TYPE HTML DESCRIPTIONS 100 ALIGNMENTS 200 ALIGNMENT_TYPE Pairwise SHOW_OVERVIEW yes]"
      sputs $RID
      sputs $url
      #open browser and display

      if {[set error [open_url $url]] != ""} {
        tk_messageBox -icon error -message "$error Your RID is:$RID"
      }
    } else {
      sputs bcab $html
      tk_messageBox -icon error -message "There was an unknown error with the server."
    }
  }  
  ::http::cleanup $token
}

################
## Align two sequences using NCBI blast2seq
################
proc NCBI_align {t1 t2} {

  set url "http://www.ncbi.nlm.nih.gov/blast/BlastAlign.cgi?[::http::formatQuery QUERY $t1 SUBJECTS $t2 BL2SEQ checked PROGRAM blastn FILTER no SERVICE plain CMD Put]"

  set token [::http::geturl $url -blocksize 4096 -timeout 4000]
  if {[::http::status $token] == "timeout"} {
    warning_dialog "Command timed out- possibly a firewall issue?"
  } else {
    set html  [::http::data $token]

    #get the RID:
    if {[regexp {.*RID = (.*?)\n.*} $html fill RID]} {
     #set the web page URL
      set url "http://www.ncbi.nlm.nih.gov/blast/Blast.cgi?[::http::formatQuery CMD Get RID $RID FORMAT_OBJECT Alignment FORMAT_TYPE Text DESCRIPTIONS 0 ALIGNMENTS 2 ALIGNMENT_VIEW PairwiseWithIdentities SHOW_OVERVIEW no]"
        #ALIGNMENT_VIEW: Pairwise PairwiseWithIdentities QueryAnchored QueryAnchoredNoIdentities FlatQueryAnchored FlatQueryAnchoredNoIdentities
      set i 0
      set status "WAITING"
      while {$status == "WAITING" && $i < 20} {
        set token2 [::http::geturl $url -blocksize 4096 -timeout 4000]
        if {[::http::status $token2] == "timeout"} {
          warning_dialog "Command timed out- possibly a firewall issue?"
        } else {
          set html2  [::http::data $token2]
        }
        if {[regexp {.*Status=(.*?)\n.*} $html2 fill status]} {
          sputs $status
          incr i
        } else {
          set i 20
        }
      }
    }  
  }  
  ::http::cleanup $token
  ::http::cleanup $token2
  return $html2
}

################
## *OLD* Send DNA to the wormbase BLAST server and open results in a browser
################
proc old_Wormbase_Blast {w} {
  global ok
  global info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {1} {
    toplevel .dialog
    wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
    wm title .dialog [mc "BLAST DNA at Wormbase..."]
    set raisedialog_store [bind . <<RaiseDialogs>>]
    bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient .dialog $w
    } else {
      ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
    }
    set ok 0


    grid [frame .dialog.frame1] -row 0 -column 0
    grid [label .dialog.frame1.proglabel -text [mc "BLAST Program:"]] -row 0 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.prog -textvariable info(wb_blast,program) -menu .dialog.frame1.prog.menu -indicatoron 1 -relief raised] -row 0 -column 1 -sticky w
    menu .dialog.frame1.prog.menu
     foreach label [list blastn blastp blastx tblastn tblastx BLAT] {
      .dialog.frame1.prog.menu add radiobutton -label $label -indicatoron 1 -value $label -variable info(wb_blast,program)
    }
    bind .dialog.frame1.prog.menu <<MenuSelect>> "focus .dialog"

    grid [label .dialog.frame1.databaselabel -text [mc "Database:"]] -row 1 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.database -textvariable info(wb_blast,database) -menu .dialog.frame1.database.menu -indicatoron 1 -relief raised] -row 1 -column 1 -sticky w
    menu .dialog.frame1.database.menu
     foreach bprog [list {C. elegans genomic} {C. elegans proteins (WormPep)} {C. briggsae genomic} {C. elegans ESTs} {C. briggsae proteins (Brigpep)}] {
      .dialog.frame1.database.menu add radiobutton -label $bprog -indicatoron 1 -value $bprog -variable info(wb_blast,database)
    }

    grid [label .dialog.frame1.expectlabel -text [mc "Expect Threshold:"]] -row 2 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.expect -textvariable info(wb_blast,expect) -menu .dialog.frame1.expect.menu -indicatoron 1 -relief raised] -row 2 -column 1 -sticky w
    menu .dialog.frame1.expect.menu
     foreach bprog [list .0001 .01 1 10 100 1000 BLAT] {
      .dialog.frame1.expect.menu add radiobutton -label $bprog -indicatoron 1 -value $bprog -variable info(wb_blast,expect)
    }

    set info(wb_blast,maxhits) 100

    grid [frame .dialog.frame2] -row 1 -column 0
    grid [button .dialog.frame2.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 0 -sticky ns -padx 10 -pady 3
    bind .dialog <Key-Return> "set ok 1"
    grid [button .dialog.frame2.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 1 -sticky ns -padx 10 -pady 3

    grid columnconfigure .dialog 0 -weight 1
    grid rowconfigure .dialog 0 -weight 1
    grid rowconfigure .dialog 1 -weight 0

    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .dialog "+$winx+$winy"
    update

    focus .dialog
    vwait ok
    set dialogblock 0
    destroy .dialog
    bind . <<RaiseDialogs>> ""
    if {$ok == 1} {

      array set dblookup [list {C. elegans genomic} Elegans {C. elegans proteins (WormPep)} WormPep {C. briggsae genomic} Briggsae_genomic {C. elegans ESTs} EST_Elegans {C. briggsae proteins (Brigpep)} Briggpep]
      if {[$w.textarea tag ranges sel] == ""} {
        set first 1.0
        set last [$w.textarea index end-1chars]
      } else {
        set first [$w.textarea index sel.first]
        set last [$w.textarea index sel.last]
      }
      set text [textarea_get $w.textarea $first $last]

      if {($info(wb_blast,program) == "blastp") || ($info(wb_blast,program) == "tblastn")} {
        set text [translate $text]
      }

      set url "http://blast.wormbase.org/db/searches/blat?sequence=$text&db=$dblookup($info(wb_blast,database))&cutoff=$info(wb_blast,expect)&program=$info(wb_blast,program)&max_hits=$info(wb_blast,maxhits)&name=&action=Run%20BLAST%20or%20BLAT"

      set htmlfile [open [file join [tempdir] "last_WB_BLAST.html"] w]
      puts $htmlfile "<form name=\"myform\" method=\"post\" action=\"http://blast.wormbase.org/db/searches/blat\" enctype=\"application/x-www-form-urlencoded\">"
      puts $htmlfile "<input type=\"hidden\" name=\"sequence\" value=\"$text\">"
      puts $htmlfile "<input type=\"hidden\" name=\"db\" value=\"$dblookup($info(wb_blast,database))\">"
      puts $htmlfile "<input type=\"hidden\" name=\"cutoff\" value=\"$info(wb_blast,expect)\">"
      puts $htmlfile "<input type=\"hidden\" name=\"max_hits\" value=\"$info(wb_blast,maxhits)\">"
      puts $htmlfile "<input type=\"hidden\" name=\"program\" value=\"$info(wb_blast,program)\">"
      puts $htmlfile "<input type=\"hidden\" name=\"name\" value=\"\">"
      puts $htmlfile "<input type=\"hidden\" name=\"action\" value=\"Run BLAST or BLAT\">"
      puts $htmlfile "<h1>If Javascript is disabled, click here</h1>"
      puts $htmlfile "<INPUT TYPE=SUBMIT VALUE=\"Get results\"> "
      puts $htmlfile "</form>" 
      puts $htmlfile "<SCRIPT language=\"JavaScript1.2\">"
      puts $htmlfile " document.myform.submit();"
      puts $htmlfile "</SCRIPT>"
      close $htmlfile

      if {[tk windowingsystem] == "win32"} {
        after 500
        set htmlfile "[file join [tempdir] "last_WB_BLAST.html"]"
sputs $htmlfile

        if {($info(browser) != "")} {
          if {[catch {dde request $info(browser) WWW_OpenURL \"file://$htmlfile\",,0x0}]} {
            sputs "No dde, using exec"
            if {[string first %1 $info(appCmd)] > -1} {
              eval exec [regsub {"%1"} $info(appCmd) \"file://$htmlfile\"] &
            } else {
              eval exec $info(appCmd) \"file://$htmlfile\" &
            }
          }
        } else {
          warning_dialog "Sorry, I don't know how to open your browser."
        }

      } elseif {[tk windowingsystem] == "aqua"} {
        exec open "[file join [tempdir] "last_WB_BLAST.html"]"
      } elseif {[tk windowingsystem] == "x11"} {
        foreach executable {sensible-browser mozilla netscape iexplorer opera lynx w3m links galeon konquerer mosaic firefox amaya browsex elinks} {
          set executable [auto_execok $executable]
          if [string length $executable] {
            set command [list $executable "[file join [tempdir] "last_WB_BLAST.html"]" &]
            break
          }
        }
        if [info exists command] {
          if [catch {eval exec $command} err] {
            tk_messageBox -icon error -message "error '$err' with '$command'"
          }
        } else {
          warning_dialog "Sorry, I don't know how to open a browser in your OS."
        }
      } else {
        warning_dialog "Sorry, I don't know how to open a browser in your OS."
      }
    }
  } else {
    tk_messageBox -message [mc "Not enough sequence selected for BLASTing"] -type ok -icon warning -default ok
  }
}

################
## Send DNA to the wormbase BLAST server and open results in a browser
################
proc Wormbase_Blast2 {w} {
  global ok
  global info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {1} {
    toplevel .dialog
    wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
    wm title .dialog [mc "BLAST DNA at Wormbase..."]
    set raisedialog_store [bind . <<RaiseDialogs>>]
    bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient .dialog $w
    } else {
      ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
    }
    set ok 0


    grid [frame .dialog.frame1] -row 0 -column 0
    grid [label .dialog.frame1.proglabel -text [mc "BLAST Program:"]] -row 0 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.prog -textvariable info(wb_blast,program) -menu .dialog.frame1.prog.menu -indicatoron 1 -relief raised] -row 0 -column 1 -sticky w
    menu .dialog.frame1.prog.menu
     foreach label [list blastn blastp blastx tblastn BLAT] {
      .dialog.frame1.prog.menu add radiobutton -label $label -indicatoron 1 -value $label -variable info(wb_blast,program)
    }
    bind .dialog.frame1.prog.menu <<MenuSelect>> "focus .dialog"

    grid [label .dialog.frame1.databaselabel -text [mc "Database:"]] -row 1 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.database -textvariable info(wb_blast,database) -menu .dialog.frame1.database.menu -indicatoron 1 -relief raised] -row 1 -column 1 -sticky w
    menu .dialog.frame1.database.menu
     foreach bprog [list {C. elegans genomic} {C. elegans proteins (WormPep)} {C. elegans ESTs} {C. briggsae genomic} {C. briggsae proteins (Brigpep)}] {
      .dialog.frame1.database.menu add radiobutton -label $bprog -indicatoron 1 -value $bprog -variable info(wb_blast,database)
    }

    grid [label .dialog.frame1.expectlabel -text [mc "Expect Threshold:"]] -row 2 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.expect -textvariable info(wb_blast,expect) -menu .dialog.frame1.expect.menu -indicatoron 1 -relief raised] -row 2 -column 1 -sticky w
    menu .dialog.frame1.expect.menu
     foreach bprog [list 1E-32 1E-16 1E-8 1E-4 1E-2 1E+0 1E+1 1E+2 1E+4] {
      .dialog.frame1.expect.menu add radiobutton -label $bprog -indicatoron 1 -value $bprog -variable info(wb_blast,expect)
    }

    set info(wb_blast,maxhits) 100

    grid [frame .dialog.frame2] -row 1 -column 0
    grid [button .dialog.frame2.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 0 -sticky ns -padx 10 -pady 3
    bind .dialog <Key-Return> "set ok 1"
    grid [button .dialog.frame2.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 1 -sticky ns -padx 10 -pady 3

    grid columnconfigure .dialog 0 -weight 1
    grid rowconfigure .dialog 0 -weight 1
    grid rowconfigure .dialog 1 -weight 0

    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .dialog "+$winx+$winy"
    update

    focus .dialog
    vwait ok
    set dialogblock 0
    destroy .dialog
    bind . <<RaiseDialogs>> ""
    if {$ok == 1} {

      array set dblookup [list {C. elegans genomic} elegans_genome {C. elegans proteins (WormPep)} elegans_protein {C. briggsae genomic} briggsae_cb3_genome {C. elegans ESTs} elegans_est {C. briggsae proteins (Brigpep)} briggsae_protein]
      if {[$w.textarea tag ranges sel] == ""} {
        set first 1.0
        set last [$w.textarea index end-1chars]
      } else {
        set first [$w.textarea index sel.first]
        set last [$w.textarea index sel.last]
      }
      set text [textarea_get $w.textarea $first $last]

      if {($info(wb_blast,program) == "blastp") || ($info(wb_blast,program) == "tblastn")} {
        set text [translate $text]
      }


      set htmlfile [open [file join [tempdir] "last_WB_BLAST.html"] w]
      puts $htmlfile "<form name=\"myform\" method=\"post\" action=\"http://www.wormbase.org/db/searches/blast_blat\" enctype=\"application/x-www-form-urlencoded\">"
      puts $htmlfile "<input type=\"hidden\" name=\"query_sequence\" value=\"$text\">"
      if {$info(wb_blast,program) != "BLAT"} {
        puts $htmlfile "<input type=\"hidden\" name=\"search_type\" value=\"blast\">"
        puts $htmlfile "<input type=\"hidden\" name=\"blast_app\" value=\"$info(wb_blast,program)\">"
      } else {
        puts $htmlfile "<input type=\"hidden\" name=\"search_type\" value=\"blat\">"
      }
      puts $htmlfile "<input type=\"hidden\" name=\"blast_e_value\" value=\"$info(wb_blast,expect)\">"
      puts $htmlfile "<input type=\"hidden\" name=\"database\" value=\"$dblookup($info(wb_blast,database))\">"
      puts $htmlfile "<h1>If Javascript is disabled, click here</h1>"
      puts $htmlfile "<INPUT TYPE=SUBMIT VALUE=\"Submit\"> "
      puts $htmlfile "</form>" 
      puts $htmlfile "<SCRIPT language=\"JavaScript1.2\">"
      puts $htmlfile " document.myform.submit();"
      puts $htmlfile "</SCRIPT>"
      close $htmlfile

      if {[tk windowingsystem] == "win32"} {
        after 500
        set htmlfile "[file join [tempdir] "last_WB_BLAST.html"]"
sputs $htmlfile

        if {($info(browser) != "")} {
          if {[catch {dde request $info(browser) WWW_OpenURL \"file://$htmlfile\",,0x0}]} {
            sputs "No dde, using exec"
            if {[string first %1 $info(appCmd)] > -1} {
              eval exec [regsub {"%1"} $info(appCmd) \"file://$htmlfile\"] &
            } else {
              eval exec $info(appCmd) \"file://$htmlfile\" &
            }
          }
        } else {
          warning_dialog "Sorry, I don't know how to open your browser."
        }

      } elseif {[tk windowingsystem] == "aqua"} {
        exec open "[file join [tempdir] "last_WB_BLAST.html"]"
      } elseif {[tk windowingsystem] == "x11"} {
        foreach executable {sensible-browser mozilla netscape iexplorer opera lynx w3m links galeon konquerer mosaic firefox amaya browsex elinks} {
          set executable [auto_execok $executable]
          if [string length $executable] {
            set command [list $executable "[file join [tempdir] "last_WB_BLAST.html"]" &]
            break
          }
        }
        if [info exists command] {
          if [catch {eval exec $command} err] {
            tk_messageBox -icon error -message "error '$err' with '$command'"
          }
        } else {
          warning_dialog "Sorry, I don't know how to open a browser in your OS."
        }
      } else {
        warning_dialog "Sorry, I don't know how to open a browser in your OS."
      }
    }
  } else {
    tk_messageBox -message [mc "Not enough sequence selected for BLASTing"] -type ok -icon warning -default ok
  }
}

################
## Send DNA to the wormbase BLAST server and open results in a browser
################
proc Wormbase_Blast {w} {
  global ok
  global info dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  if {1} {
    toplevel .dialog
    wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
    wm title .dialog [mc "BLAST DNA at Wormbase..."]
    set raisedialog_store [bind . <<RaiseDialogs>>]
    bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient .dialog $w
    } else {
      ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
    }
    set ok 0


    grid [frame .dialog.frame1] -row 0 -column 0
    grid [label .dialog.frame1.proglabel -text [mc "BLAST Program:"]] -row 0 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.prog -textvariable info(wb_blast,program) -menu .dialog.frame1.prog.menu -indicatoron 1 -relief raised] -row 0 -column 1 -sticky w
    menu .dialog.frame1.prog.menu
     foreach label [list blastn blastp blastx tblastn] {
      .dialog.frame1.prog.menu add radiobutton -label $label -indicatoron 1 -value $label -variable info(wb_blast,program)
    }
    bind .dialog.frame1.prog.menu <<MenuSelect>> "focus .dialog"

    grid [label .dialog.frame1.databaselabel -text [mc "Database:"]] -row 1 -column 0 -sticky nse
    grid [menubutton .dialog.frame1.database -textvariable info(wb_blast,database) -menu .dialog.frame1.database.menu -indicatoron 1 -relief raised] -row 1 -column 1 -sticky w
    menu .dialog.frame1.database.menu
     foreach bprog [list {C. elegans genomic} {C. elegans proteins (WormPep)} {C. elegans ESTs} {C. briggsae genomic} {C. briggsae proteins (Brigpep)}] {
      .dialog.frame1.database.menu add radiobutton -label $bprog -indicatoron 1 -value $bprog -variable info(wb_blast,database)
    }


    grid [frame .dialog.frame2] -row 1 -column 0
    grid [button .dialog.frame2.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 0 -sticky ns -padx 10 -pady 3
    bind .dialog <Key-Return> "set ok 1"
    grid [button .dialog.frame2.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 1 -sticky ns -padx 10 -pady 3

    grid columnconfigure .dialog 0 -weight 1
    grid rowconfigure .dialog 0 -weight 1
    grid rowconfigure .dialog 1 -weight 0

    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .dialog "+$winx+$winy"
    update

    focus .dialog
    vwait ok
    set dialogblock 0
    destroy .dialog
    bind . <<RaiseDialogs>> ""
    if {$ok == 1} {

      array set dblookup [list {C. elegans genomic} elegans_genome {C. elegans proteins (WormPep)} elegans_protein {C. briggsae genomic} briggsae_genome {C. elegans ESTs} elegans_est {C. briggsae proteins (Brigpep)} briggsae_protein]
      if {[$w.textarea tag ranges sel] == ""} {
        set first 1.0
        set last [$w.textarea index end-1chars]
      } else {
        set first [$w.textarea index sel.first]
        set last [$w.textarea index sel.last]
      }
      set text [textarea_get $w.textarea $first $last]

      if {($info(wb_blast,program) == "blastp") || ($info(wb_blast,program) == "tblastn")} {
        set text [translate $text]
        set query_type "prot"
      } else {
         set query_type "nucl"
      }

      set htmlfile [open [file join [tempdir] "last_WB_BLAST.html"] w]
      puts $htmlfile "<form name=\"myform\" method=\"post\" action=\"http://www.wormbase.org/db/searches/blast_blat\" enctype=\"application/x-www-form-urlencoded\">"
      puts $htmlfile "<input type=\"hidden\" name=\"query_sequence\" value=\"$text\">"
      if {$info(wb_blast,program) != "BLAT"} {
        puts $htmlfile "<input type=\"hidden\" name=\"query_type\" value=\"$query_type\">"
        puts $htmlfile "<input type=\"hidden\" name=\"blast_app\" value=\"$info(wb_blast,program)\">"
      } else {
        puts $htmlfile "<input type=\"hidden\" name=\"search_type\" value=\"blat\">"
      }
      puts $htmlfile "<input type=\"hidden\" name=\"database\" value=\"$dblookup($info(wb_blast,database))\">"
      puts $htmlfile "<h1>If you would like more integration with ApE, ask the wormbase webmaster to write an API to their blast server.</h1>"
      puts $htmlfile "<h1>Click here to go to wormbase page.</h1>"
      puts $htmlfile "<INPUT TYPE=SUBMIT VALUE=\"Submit\"> "
      puts $htmlfile "</form>" 
      close $htmlfile

      if {[tk windowingsystem] == "win32"} {
        after 500
        set htmlfile "[file join [tempdir] "last_WB_BLAST.html"]"
sputs $htmlfile

        if {($info(browser) != "")} {
          if {[catch {dde request $info(browser) WWW_OpenURL \"file://$htmlfile\",,0x0}]} {
            sputs "No dde, using exec"
            if {[string first %1 $info(appCmd)] > -1} {
              eval exec [regsub {"%1"} $info(appCmd) \"file://$htmlfile\"] &
            } else {
              eval exec $info(appCmd) \"file://$htmlfile\" &
            }
          }
        } else {
          warning_dialog "Sorry, I don't know how to open your browser."
        }

      } elseif {[tk windowingsystem] == "aqua"} {
        exec open "[file join [tempdir] "last_WB_BLAST.html"]"
      } elseif {[tk windowingsystem] == "x11"} {
        foreach executable {sensible-browser mozilla netscape iexplorer opera lynx w3m links galeon konquerer mosaic firefox amaya browsex elinks} {
          set executable [auto_execok $executable]
          if [string length $executable] {
            set command [list $executable "[file join [tempdir] "last_WB_BLAST.html"]" &]
            break
          }
        }
        if [info exists command] {
          if [catch {eval exec $command} err] {
            tk_messageBox -icon error -message "error '$err' with '$command'"
          }
        } else {
          warning_dialog "Sorry, I don't know how to open a browser in your OS."
        }
      } else {
        warning_dialog "Sorry, I don't know how to open a browser in your OS."
      }
    }
  } else {
    tk_messageBox -message [mc "Not enough sequence selected for BLASTing"] -type ok -icon warning -default ok
  }
}

################
## Generic function to get info from a web post operation
################
proc URL_Post {base_url function vars_list} {
  global info

      if {[tk windowingsystem] == "win32" } {
        set htmlfile [open [file join [tempdir] "last_$function.html"] w]
        puts $htmlfile "<form name=\"myform\" method=\"post\" action=\"$base_url\" enctype=\"application/x-www-form-urlencoded\">"
        foreach name $vars_list {
          puts $htmlfile "<input type=\"hidden\" name=\"$name\" value=\"$info($function,$name)\">"
        }
        puts $htmlfile "<h1>If Javascript is disabled, click here</h1>"
        puts $htmlfile "<INPUT TYPE=SUBMIT VALUE=\"Get results\"> "
        puts $htmlfile "</form>" 
        puts $htmlfile "<SCRIPT language=\"JavaScript1.2\">"
        puts $htmlfile " document.myform.submit();"
        puts $htmlfile "</SCRIPT>"

        close $htmlfile
        after 500
        set htmlfile "[file join [tempdir] "last_$function.html"]"
#sputs $htmlfile

        if {($info(browser) != "")} {
          if {[catch {dde request $info(browser) WWW_OpenURL \"file://$htmlfile\",,0x0}]} {
            sputs "No dde, using exec"
            if {[string first %1 $info(appCmd)] > -1} {
              eval exec [regsub {"%1"} $info(appCmd) \"file://$htmlfile\"] &
            } else {
              eval exec $info(appCmd) \"file://$htmlfile\" &
            }
          }
        } else {
          warning_dialog "Sorry, I don't know how to open your browser."
        }
      } elseif {[tk windowingsystem] == "aqua"} {
        set url "$base_url"
        set div "?"
        foreach name $vars_list {
          set url "$url$div$name=$info($function,$name)"
          set div "&"
        }
        exec open $url
      } elseif {[tk windowingsystem] == "x11"} {
        foreach name $vars_list {
          set url "$url$div$name=$info($function,$name)"
          set div "&"
        }
        foreach executable {sensible-browser mozilla netscape iexplorer opera lynx w3m links galeon konquerer mosaic firefox amaya browsex elinks} {
          set executable [auto_execok $executable]
          if [string length $executable] {
            set command [list $executable $url &]
            break
          }
        }
        if [info exists command] {
          if [catch {eval exec $command} err] {
            tk_messageBox -icon error -message "error '$err' with '$command'"
          }
        } else {
          warning_dialog "Sorry, I don't know how to open a browser in your OS."
        }
      } else {
        warning_dialog "Sorry, I don't know how to open a browser in your OS."
      }

}

################
## open a given URL in a browser window
################
proc open_url {url} {
  global info
  #sputs $url
  #open browser and display
  set error ""
  if {[tk windowingsystem] == "win32" } {
    if {($info(browser) != "")} {
      if {[catch {dde request $info(browser) WWW_OpenURL $url,,0x0}]} {
        sputs "No dde, using exec"
        regsub -all {&} $url {\\\&} url
        if {[string first %1 $info(appCmd)] > -1} {
          eval exec [regsub {"%1"} $info(appCmd) \"$url\"] &
        } else {
          eval exec $info(appCmd) \"$url\" &
        }
      }
    } else {
      if {[string first %1 $info(appCmd)] > -1} {
        eval exec [regsub {"%1"} $info(appCmd) \"$url\"] &
      } else {
        eval exec $info(appCmd) \"$url\" &
      }
    }
  } elseif {[tk windowingsystem] == "aqua"} {
    exec open $url
  } elseif {[tk windowingsystem] == "x11"} {
    foreach executable {sensible-browser mozilla netscape iexplorer opera lynx w3m links galeon konquerer mosaic firefox amaya browsex elinks} {
      set executable [auto_execok $executable]
      if {[string length $executable]} {
        set command [list $executable $url &]
        break
      }
    }
    if {[info exists command]} {
      if {[catch {eval exec $command} err]} {
        set error "error '$err' with '$command'"
      }
    } else {
      set error "Sorry, I don't know how to open a browser in your OS."
    }
  } else {
     set error "Sorry, I don't know how to open a browser in your OS."
  }
  return $error
}

################
## Query the Entrez nucleotide database
################
proc entrez_dialog {w} {
  global info modifier ok dialogblock field bool query

  set term_map [list {[ALL]} {All Fields} {[AUTH]} {Author Name} {[ECNO]} {EC/RN Number} {[FKEY]} {Feature Key} {[GENE]} {Gene Name} {[JOUR]} {Journal Name} {[KYWD]} Keyword {[MDAT]} {Modification Date} {[ORGN]} Organism {[PACC]} {Primary Accession} {[PROP]} Properties {[PDAT]} {Publication Date} {[SQID]} {SeqID String} {[SLEN]} {Sequence Length} {[WORD]} {Text Word} {[TITL]} {Title Word}]

  if {$dialogblock == 1} {return}
  set dialogblock 1
 
  set menu_list [list]
  foreach {x y} $term_map {
    lappend menu_list $y
  }
  set a [toplevel .dialog]
  wm title .dialog [mc "Entrez Query..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  if {$w != "."} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  }
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
  ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0

  grid [labelframe $a.queryframe -text [mc "Query"] -relief ridge] -row 1 -column 1 -sticky nswe
  grid [entry $a.queryframe.query0 -textvariable query(0) -width 20] -row 0 -column 0 -columnspan 2 -sticky we

  eval [concat tk_optionMenu $a.queryframe.field0 field(0) $menu_list {{Advanced Query}}]
  set field(0) [lindex $menu_list 0]
  grid $a.queryframe.field0 -row 0 -column 2
  for {set i 1} {$i < 5} {incr i} {
    tk_optionMenu $a.queryframe.bool$i bool($i) "AND" "OR" "NOT"
    set bool($i) "AND"
    grid $a.queryframe.bool$i -row $i -column 0
    grid [entry $a.queryframe.query$i  -textvariable query($i) -width 15] -row $i -column 1 -sticky we
    eval [concat tk_optionMenu $a.queryframe.field$i field($i) $menu_list]
    set field($i) [lindex $menu_list 0]
    grid $a.queryframe.field$i -row $i -column 2
  }
  grid [frame $a.queryframe.butonframe -relief flat] -row $i -column 0 -columnspan 3
  grid [button $a.queryframe.butonframe.run -text [mc "Run Query"] -command "entrez_do_query $a" -default active] -row 0 -column 1 -padx 10 -pady 3
  bind $a <Key-Return> "$a.queryframe.butonframe.run invoke"
  grid [label $a.queryframe.butonframe.max_label -text [mc "Max hits:"]] -row 0 -column 2
  grid [entry $a.queryframe.butonframe.max_hits -width 4 -textvariable info(entrez,max_hits) -validate key -vcmd "check_char %S"] -row 0 -column 3
  grid columnconfigure $a.queryframe 1 -weight 1

  grid [labelframe $a.resultframe -text [mc "Query Result"] -relief ridge -height 200] -row 2 -column 1 -sticky nswe
  grid [text $a.resultframe.result -xscrollcommand "optionscrollbar $a.resultframe.scrollx" -yscrollcommand "optionscrollbar $a.resultframe.scrolly" -height 20 -background white -foreground black -font labelfont -wrap none] -row 0 -column 0 -sticky nswe
  grid [scrollbar $a.resultframe.scrollx -orient horizontal -command "$a.resultframe.result xview"] -row 1 -column 0 -sticky we
  grid [scrollbar $a.resultframe.scrolly -orient vertical -command "$a.resultframe.result yview"] -row 0 -column 1 -sticky ns
  grid [frame $a.resultframe.spacer -width 1 -height 17] -row 1 -column 1
  grid columnconfigure $a.resultframe 0 -weight 1
  grid rowconfigure $a.resultframe 0 -weight 1

  grid [frame $a.buttonframe -relief ridge] -row 3 -column 1 -sticky nswe

  grid [frame $a.buttonframe.okframe] -row 2 -column 1 -columnspan 2 -sticky we

  grid [button $a.buttonframe.okframe.ok -text [mc "Done"] -command "set ok 1"] -row 0 -column 1
  grid columnconfigure $a.buttonframe.okframe 1 -weight 1
  grid columnconfigure $a.buttonframe 2 -weight 1
  
  grid columnconfigure $a 1 -weight 1
  grid rowconfigure $a 2 -weight 1
  focus $a.queryframe.query0

  vwait ok

  destroy .dialog
  set dialogblock 0
  bind . <<RaiseDialogs>> ""
  unset ok query field bool

}

################
## Fill in the Entrez query text box 
################
proc entrez_do_query {a} {
  global info query field bool
  if {![string is integer $info(entrez,max_hits)]} {
    set info(entrez,max_hits) 25
  }
  if {$field(0) == {Advanced Query}} {
    set query_string $query(0)
  } else {
    set query_string "$query(0)[string map {{All Fields} {[ALL]} {Author Name} {[AUTH]} {EC/RN Number} {[ECNO]} {Feature Key} {[FKEY]} {Gene Name} {[GENE]} {Journal Name} {[JOUR]} Keyword {[KYWD]} {Modification Date} {[MDAT]} Organism {[ORGN]} {Primary Accession} {[PACC]} Properties {[PROP]} {Publication Date} {[PDAT]} {SeqID String} {[SQID]} {Sequence Length} {[SLEN]} {Text Word} {[WORD]} {Title Word} {[TITL]}} $field(0)]"
    for {set i 1} {$i < 5} {incr i} {
      if {$query($i) != ""} {
        append query_string " $bool($i) " "$query($i)[string map {{All Fields} {[ALL]} {Author Name} {[AUTH]} {EC/RN Number} {[ECNO]} {Feature Key} {[FKEY]} {Gene Name} {[GENE]} {Journal Name} {[JOUR]} Keyword {[KYWD]} {Modification Date} {[MDAT]} Organism {[ORGN]} {Primary Accession} {[PACC]} Properties {[PROP]} {Publication Date} {[PDAT]} {SeqID String} {[SQID]} {Sequence Length} {[SLEN]} {Text Word} {[WORD]} {Title Word} {[TITL]}} $field($i)]"
      }
    }
  }
  $a.resultframe.result delete 1.0 end
  foreach tag [$a.resultframe.result tag names] {
    if {[regexp {REF[0-9]*} $tag]} {
      $a.resultframe.result tag delete $tag
    }
  }
  $a.resultframe.result insert 1.0 "Query: $query_string\n"
  
  #get the query from NCBI
  set url "http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi?[http::formatQuery tool ApE db nucleotide term $query_string retmax $info(entrez,max_hits)]"

  set x [::http::geturl $url -timeout 4000]
  set html  [::http::data $x]
  ::http::cleanup $x

  #parse result
  set count_list [list]
  foreach termset [regexp -inline -all "<TermSet>.*?</TermSet>" $html] {
    if {[regexp ".*<Term>(.*?)</Term>.*<Count>(.*?)</Count>.*" $termset termset term count]} { 
      lappend count_list [list $term $count]
    } elseif {[regexp ".*<Count>(.*?)</Count>.*<Term>(.*?)</Term>.*" $termset termset count term]} { 
      lappend count_list [list $term $count]
    }
  }
  foreach {line term} [regexp -inline -all "<PhraseNotFound>(.*?)</PhraseNotFound>" $html] {
      lappend count_list [list $term 0]
  }

  foreach count $count_list {
    $a.resultframe.result insert end "[lindex $count 0] : [lindex $count 1] hits.\n"
  }
  set id_list [list]
  foreach {id_line id} [regexp -inline -all "<Id>(.*?)</Id>" $html] { 
      lappend id_list $id
  }
  $a.resultframe.result insert end "[llength $id_list] references returned."
  if {[llength $id_list] == $info(entrez,max_hits)} {
    $a.resultframe.result insert end " (Max Hits limit reached)\n"
  } else {
    $a.resultframe.result insert end "\n" 
  }
    $a.resultframe.result insert end "-------------------\n"
  foreach ref $id_list {
    foreach field_name {ID Caption Title Extra CreateDate UpdateDate Gi TaxId Flags} {
      set j($field_name) ""
    }
    foreach sum_item [entrez_summary $ref] {
      set j([lindex $sum_item 0]) [lindex $sum_item 2]
    }

    $a.resultframe.result insert end "$j(Gi):$j(Title)\n" "REF$ref"
    $a.resultframe.result tag configure "REF$ref" -foreground blue
    if {[tk windowingsystem] != "aqua"} {
    $a.resultframe.result tag bind "REF$ref" <Any-Enter> "$a.resultframe.result tag configure REF$ref -underline 1; $a.resultframe.result configure -cursor hand2"
     } else {
    $a.resultframe.result tag bind "REF$ref" <Any-Enter> "$a.resultframe.result tag configure REF$ref -underline 1; $a.resultframe.result configure -cursor pointinghand"
    }
    $a.resultframe.result tag bind "REF$ref" <Any-Leave> "$a.resultframe.result tag configure REF$ref -underline 0; $a.resultframe.result configure -cursor xterm" 
    $a.resultframe.result tag bind "REF$ref" <Button-1> "entrez_download $ref {$j(Title)}"

    array unset j
  }
  $a.resultframe.result tag raise sel
}

################
## Utility function to query NCBI for summary info about a nucleotide record
################
proc entrez_summary {id_list} {
  set url "http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esummary.fcgi?[http::formatQuery tool ApE db nucleotide id [join $id_list ","]]"

  set x [::http::geturl $url -timeout 4000]
  set html  [::http::data $x]
  ::http::cleanup $x
  #sputs $html
  set data_list [list]
  foreach {doc_data} [regexp -inline -all "<DocSum>.*?</DocSum>" $html] { 
    set data_list [list]
    if {[regexp "<Id>(.*?)</Id>" $doc_data id_line id]} {
      set data_list [list [list ID Integer $id]]
      foreach {data_line name type data} [regexp -inline -all {<Item Name="(.*?)"[\n ]Type="(.*?)">(.*?)</Item>} $doc_data] { 
        lappend data_list [list $name $type [regsub \n $data " "]]
      }
    }
  }
  return $data_list
}

################
## Utility function to download a file using Entrez id number
################
proc entrez_download {id title} {
  global info

  while { (![file isdirectory $info(default_dnadir)])} {
    set info(default_dnadir) [file dirname $info(default_dnadir)]
    if {[file dirname $info(default_dnadir)] == $info(default_dnadir)} {
      set info(default_dnadir) [valid_default_dir]
    }
  }

  set filename [tk_getSaveFile -title "Save $title" -parent .dialog  -initialfile "$id$info(default_file_extension)" -initialdir $info(default_dnadir) -defaultextension $info(default_file_extension) -filetypes {{"All files" {"*.*"}} {"ApE" {.str .ape .dna .seq .gb}}}]
  if {([file extension $filename] == "") && ($filename != "")} {set filename "$filename$info(default_file_extension)"}

  while {([file isfile $filename] && ![file writable $filename]) && ($filename != "") } {
    set response [tk_messageBox -title [mc "File is not writable."] -message "$filename \n[mc {File is locked. Do you want to unlock it (Yes), save it with a different name (No) or cancel save (Cancel?)}]" -type "yesnocancel"  -icon warning -default no]
    if {$response == "yes"} {
      set info($w,filename) $filename
      toggle_locked $w
      if {![file writable $filename]} {
        set filename [tk_getSaveFile -title [mc "Sorry, couldn't unlock. Save File As..."] -initialdir $info(default_dnadir) -parent .dialog -defaultextension $info(default_file_extension) -filetypes { {"All files" {"*.*"}} {"genbank" {.gb}}}]
        set info($w,filename) $filename
      }
    } elseif {$response == "no"} {
      set filename [tk_getSaveFile -title [mc "Save File As..."] -initialdir $info(default_dnadir) -parent .dialog -defaultextension $info(default_file_extension) -filetypes { {"All files" {"*.*"}} {"genbank" {.gb}}}]
    } else {
      set filename ""
    }
  }
  if {$filename == ""} {return}

  if {$info(dnadir_follows_open)} {
    set info(default_dnadir) [file dirname $filename]
  }
  set url "http://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?[http::formatQuery tool ApE db nucleotide id $id retmode text rettype gb]"
  set x [::http::geturl $url -timeout 4000]
  set html  [::http::data $x]
  ::http::cleanup $x
  set fid [open $filename w]
  puts $fid $html
  close $fid
  open_file $filename
}

################
## recombination reaction window
################
#prototypes:
# name of prototype
# 2 element list of labels and sites
# labels list of labels foreach incomming fragment
# sites is a list of site names and directions for each site in the final product
# use the site name "end" if the final product is linear (this only has to be put as the first site, NOT first and last
# site names have to be found in the following info(recomb,sites) list
set info(recomb,prototypes) [list \
"BP Reaction (1-2)" [list [list "Insert" "Backbone"] [list attL1 0 attL2 1]] \
"Single-site LR Reaction (1-2)" [list [list "Insert" "Backbone"] [list attB1 0 attB2 1]] \
"BP Reaction (4-1)" [list [list "Insert" "Backbone"] [list attL4 0 attR1 0]] \
"BP Reaction (2-3)" [list [list "Insert" "Backbone"] [list attR2 1 attL3 1]] \
"Mutlti-site LR Reaction (4-1-2-3)" [list [list "Promoter" "Gene" "UTR" "Backbone"] [list attB4 0 attB1 0 attB2 1 attB3 1]] \
"BP Reaction (1-5)" [list [list "Insert" "Backbone"] [list attL1 0 attR5 0]] \
"BP Reaction (5-2)" [list [list "Insert" "Backbone"] [list attL5 0 attL2 1]] \
"Multi-site Pro LR Reaction (1-5-2)" {{"Fragment 1" "Fragment 2" Backbone} {attB1 0 attB5 0 attB2 1}} \
"BP Reaction (1-4)" [list [list "Insert" "Backbone"] [list attL1 0 attL4 1]] \
"BP Reaction (4-3)" [list [list "Insert" "Backbone"] [list attR4 1 attR3 0]] \
"BP Reaction (3-2)" [list [list "Insert" "Backbone"] [list attL3 0 attL2 1]] \
"Multi-site Pro LR Reaction (1-4-3-2)" {{"Fragment 1" "Fragment 2" "Fragment 3" Backbone} {attB1 0 attB4 1 attB3 0 attB2 1}} \
"BP Reaction (5-4)" [list [list "Insert" "Backbone"] [list attL5 0 attL4 1]] \
"Multi-site Pro LR Reaction (1-5-4-3-2)" {{"Fragment 1" "Fragment 2" "Fragment 3"  "Fragment 4" Backbone} {attB1 0 attB5 0 attB4 1 attB3 0 attB2 1}} \
"Multi-site LR Reaction (4-1-2)" {{Promoter Gene Backbone} {attB4 0 attB1 0 attB2 1}}\
"BP Reaction (1-2-2-1)" {{Insert Intron Insert(rev) Backbone} {attL1 0 attL2 1 attL2 0 attL1 1}}\
"Two part LoxP" [list [list "Accetor" "Donor"] [list loxP 0 loxP 0]] \
]

## recombination sites list
# list of left, overlapping and right side of the recombination site, then the left and right sides of the site that it recombines with (ex. these will be the left and right sides of the attP1 site for an attB1 site)
set info(recomb,sites) [list attP1 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTACAAA AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG CMASTWT AAAGYWG]]
lappend info(recomb,sites) attP2 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTACAAG AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG CMASTWT AAAGYWG]
lappend info(recomb,sites) attP3 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTATAAT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG CMASTWT AAAGYWG]
lappend info(recomb,sites) attP4 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTATAGA AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG CMASTWT AAAGYWG]
lappend info(recomb,sites) attP5 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTATACA AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG CMASTWT AAAGYWG]

lappend info(recomb,sites) attB1 [list CMASTWT GTACAAA AAAGYWG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attB2 [list CMASTWT GTACAAG AAAGYWG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attB3 [list CMASTWT GTATAAT AAAGYWG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attB4 [list CMASTWT GTATAGA AAAGYWG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attB5 [list CMASTWT GTATACA AAAGYWG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]

lappend info(recomb,sites) attR1 [list CMASTWT GTACAAA AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWG]
lappend info(recomb,sites) attR2 [list CMASTWT GTACAAG AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWG]
lappend info(recomb,sites) attR3 [list CMASTWT GTATAAT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWG]
lappend info(recomb,sites) attR4 [list CMASTWT GTATAGA AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWG]
lappend info(recomb,sites) attR5 [list CMASTWT GTATACA AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT AAAGYWG]

lappend info(recomb,sites) attL1 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTACAAA AAAGYWG CMASTWT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attL2 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTACAAG AAAGYWG CMASTWT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attL3 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTATAAT AAAGYWG CMASTWT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attL4 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTATAGA AAAGYWG CMASTWT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]
lappend info(recomb,sites) attL5 [list AAATAATGATTTTATTTTGACTGATAGTGACCTGTTCGTTGCAACAMATTGATRAGCAATKMTTTYTTATAATGCCMASTTT GTATACA AAAGYWG CMASTWT AAAGYWGAACGAGAAACGTAAAATGATATAAATATCAATATATTAAATTAGATTTTGCATAAAAAACAGACTACATAATRCTGTAAAACACAACATATSCAGTCAYWWTG]

lappend info(recomb,sites) FRT [list GAAGTTCCTATTC TCTAGAAA GAATAGGAACTTC GAAGTTCCTATTC GAATAGGAACTTC]
lappend info(recomb,sites) loxP [list ATAACTTCGTATA GCATACAT TATACGAAGTTAT ATAACTTCGTATA TATACGAAGTTAT]


proc recombination_window {w} {
  global info modifier dialogblock 
  global ok recomb_prototype recomb_window recomb_data

  if {$dialogblock == 1} {return}
  set dialogblock 1
 

  set a [toplevel .dialog]
  wm title .dialog [mc "Recombination Reaction..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  if {$w != "."} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  }
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0

  grid [frame $a.typeframe -relief ridge -borderwidth 2] -row 1 -column 1 -sticky nswe
  grid [menubutton $a.typeframe.menubutton -textvariable recomb_prototype -menu $a.typeframe.menubutton.menu -indicator on -relief raised] -row 1 -column 1
  set recomb_prototype [mc "Chose a Recombination Prototype"]
  menu $a.typeframe.menubutton.menu
  set maxwidth 15
  foreach {name proto_info} $info(recomb,prototypes) {
    $a.typeframe.menubutton.menu add radiobutton -label [mc $name] -variable recomb_prototype -value $name -command fill_recomb_reation_frame
    if {[string length $name] > $maxwidth} {set maxwidth [string length $name]}   
  }
  incr maxwidth 3
  if {$maxwidth > 200} {set maxwidth 200}
  $a.typeframe.menubutton configure -width $maxwidth
  grid [labelframe $a.reactionframe -relief ridge -borderwidth 2 -text [mc "Recombination Reaction Product"]] -row 2 -column 1 -sticky nswe
  grid [frame $a.okframe] -row 3 -column 1 -sticky nswe
  grid [button $a.okframe.cancel -text [mc "Cancel"] -command "set ok -1"] -row 1 -column 0 -sticky nw -padx 10 -pady 3
  grid [button $a.okframe.ok -text [mc "OK"] -command "set ok 1" -default active] -row 1 -column 1 -sticky nw -padx 10 -pady 3
  grid [checkbutton $a.okframe.keep_open -text [mc "Keep Recombination Dialog Open"] -variable info(recomb_keep_open)] -row 2 -column 0 -columnspan 2 -sticky w
  set info(recomb_keep_open) 0

  set continue 1
  while  {$continue} {

    vwait ok

    if {$recomb_prototype == [mc "Chose a Recombination Prototype"]} {
      set ok -1
    }
    if {$ok == 1} {
      set continue $info(recomb_keep_open)
    } else {
      set continue 0
    }



    if {!($info(recomb_keep_open) && ($ok==1))} {
      destroy $a
      set dialogblock 0
      bind . <<RaiseDialogs>> ""
    }
  if {$ok == 1} {
    set w1 [create_window]
    array set proto_list $info(recomb,prototypes)
    set label_list [lindex $proto_list($recomb_prototype) 0]
    set sites_list [lindex $proto_list($recomb_prototype) 1]
    if {[lindex [lindex $proto_list($recomb_prototype) 1] 0] != "end"} {
      set info($w1,circular) "circular"
    }
    set comment_text ""

    foreach fragment [lsort -integer [array names recomb_data]] label $label_list {
###bug: need to generate dna and tags to pass to create window, NOT create window and add dna and tags
      set rev_com [lindex $recomb_data($fragment) 0]
      set source [lindex $recomb_data($fragment) 1]
      set start [lindex $recomb_data($fragment) 2]
      set end [lindex $recomb_data($fragment) 3]
      set prev_end [$w1.textarea index end-1c]
      if {($info($source,filename) ne "")} {
        append comment_text "$label from [file root [file tail $info($source,filename)]] [expr {$start+1}] to [expr {$end+1}]\n"
      }
      incr end
      if {$start < $end} {
        if {!$rev_com} {
          textarea_insert $w1.textarea [$w1.textarea index end-1c] [textarea_get $source.textarea [bp2ix $source.textarea $start] [bp2ix $source.textarea $end]]
          put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list [bp2ix $source.textarea $start] [bp2ix $source.textarea $end]]]
        } else {
          textarea_insert $w1.textarea [$w1.textarea index end-1c] [revcom [textarea_get $source.textarea [bp2ix $source.textarea $start] [bp2ix $source.textarea $end]]]
          put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list [bp2ix $source.textarea $start] [bp2ix $source.textarea $end]] reverse]
        }
      } else {
        if {($fragment == [lindex [lsort -integer [array names recomb_data]] end]) && ($info($w1,circular) == "circular")} {
          #if last fragment && circular product, put the fragment 1.0-end at the beginning of the file, not the end
          if {!$rev_com} {
            textarea_insert $w1.textarea [$w1.textarea index end-1c] [textarea_get $source.textarea [bp2ix $source.textarea $start] end-1c]
            put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list [bp2ix $source.textarea $start] [$source.textarea index end-1c]]]
            textarea_insert $w1.textarea [$w1.textarea index 1.0] [textarea_get $source.textarea 1.0 [bp2ix $source.textarea $end]]
            put_tags $w1.textarea [list 1.0 [bp2ix $source.textarea $end]] [get_tags $source.textarea [list 1.0 [bp2ix $source.textarea $end]]]
          } else {
            textarea_insert $w1.textarea [$w1.textarea index end-1c] [revcom [textarea_get $source.textarea 1.0 [bp2ix $source.textarea $end]]]
            put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list 1.0 [bp2ix $source.textarea $end]] reverse]
            textarea_insert $w1.textarea [$w1.textarea index 1.0] [revcom [textarea_get $source.textarea [bp2ix $source.textarea $start] end-1c]]
            put_tags $w1.textarea [list 1.0 [bp2ix $source.textarea $start]] [get_tags $source.textarea [list [bp2ix $source.textarea $start] end-1c] reverse]
          }
        } else {
          if {!$rev_com} {
            textarea_insert $w1.textarea [$w1.textarea index end-1c] [textarea_get $source.textarea [bp2ix $source.textarea $start] end-1c]
            put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list [bp2ix $source.textarea $start] [$source.textarea index end-1c]]]
            set prev_end [$w1.textarea index end-1c]
            textarea_insert $w1.textarea [$w1.textarea index end-1c] [textarea_get $source.textarea 1.0 [bp2ix $source.textarea $end]]
            put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list 1.0 [bp2ix $source.textarea $end]]]
          } else {
            textarea_insert $w1.textarea [$w1.textarea index end-1c] [revcom [textarea_get $source.textarea 1.0 [bp2ix $source.textarea $end]]]
            put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list 1.0 [bp2ix $source.textarea $end]] reverse]
            set prev_end [$w1.textarea index end-1c]
            textarea_insert $w1.textarea [$w1.textarea index end-1c] [revcom [textarea_get $source.textarea [bp2ix $source.textarea $start] end-1c]]
            put_tags $w1.textarea [list $prev_end end-1c] [get_tags $source.textarea [list [bp2ix $source.textarea $start] end-1c] reverse]
          }
        }
      }
    }

    $w1.comframe.comtextframe.text insert 1.0 $comment_text
    set info($w1,scanned) 0
    set info($w1,saved) 0
    if {[tk windowingsystem] == "aqua"} {wm attributes $w1 -modified 1}
    $w1.textarea tag remove sel 1.0 end-1c
    $w1.textarea tag remove tempsel 1.0 end-1c
    vertindexbalancer $w1
    selection_manager $w1
  }
  } ;# while keep open
  array unset recomb_data
  array unset recomb_window 
  unset ok recomb_prototype
}

################
## utility function of recombination_window
################
proc fill_recomb_reation_frame {} {
  global info recomb_prototype recomb_window recomb_data
  set a .dialog
  array set proto_list $info(recomb,prototypes)
  array set all_sites_list $info(recomb,sites) 

  set label_list [lindex $proto_list($recomb_prototype) 0]
  set sites_list [lindex $proto_list($recomb_prototype) 1]
  set site_count 0
  foreach element [winfo children $a.reactionframe] {
    destroy $element
  }
  array unset recomb_window



  lappend sites_list [lindex $sites_list 0] [lindex $sites_list 1]

  set found_all 1
  for {set i 0} {$i < [expr {[llength $sites_list]-2}]} {incr i 2} {
    set name [lindex $label_list [expr {$i/2}]] 
    set site1 [lindex $sites_list $i]
    set dir1 [lindex $sites_list [expr {$i+1}]]
    set site2 [lindex $sites_list [expr {$i+2}]]
    set dir2 [lindex $sites_list [expr {$i+3}]]
    #label for the fragment type
    grid [label $a.reactionframe.l0$site_count -text $name] -row $site_count -column 0 
    #label for the site on the left side
    #grid [label $a.reactionframe.l1$site_count -text $site1] -row $site_count -column 1 
    grid [menubutton $a.reactionframe.mb$site_count -menu $a.reactionframe.mb$site_count.menu -textvariable recomb_window($site_count) -indicator on -relief raised] -row $site_count -column 2 
    set recomb_window($site_count) $site_count
    menu $a.reactionframe.mb$site_count.menu
    #fill the menu with radiobutton items sequences between sites
    if {$dir1} {
      set site_reg1 [regsubpattern "[lindex $all_sites_list($site1) 0]([lindex $all_sites_list($site1) 1])[lindex $all_sites_list($site1) 4]"]
      set site_rc_reg1 $site_reg1
      set site_reg1 [revcom_regexp $site_reg1]
    } else {
      set site_reg1 [regsubpattern "[lindex $all_sites_list($site1) 3]([lindex $all_sites_list($site1) 1])[lindex $all_sites_list($site1) 2]"]
      set site_rc_reg1 [revcom_regexp $site_reg1]
    }
    if {$dir2} {
      set site_reg2 [regsubpattern "[lindex $all_sites_list($site2) 3]([lindex $all_sites_list($site2) 1])[lindex $all_sites_list($site2) 2]"]
      set site_rc_reg2 $site_reg2
      set site_reg2 [revcom_regexp $site_reg2]
    } else {
      set site_reg2 [regsubpattern "[lindex $all_sites_list($site2) 0]([lindex $all_sites_list($site2) 1])[lindex $all_sites_list($site2) 4]"]
      set site_rc_reg2 [revcom_regexp $site_reg2]
    }


    foreach window [regexp -all -inline ".dna_window\[0-9\]* " "[winfo children .] "] {
      set window [string range $window 0 end-1]
      set text [textarea_get $window.textarea 1.0 end-1c]
      set len [string length $text]
      if {$info($window,circular) == "circular"} {
        append text $text
      }

      set index_list1 [regexp -all -indices -nocase -inline $site_reg1 $text]
      set index1 [lindex [lindex $index_list1 1] 0]
      if {$index1 != ""} {
        set index1 [expr {$index1 % $len}]
        set index_list2 [regexp -all -indices -nocase -inline $site_reg2 $text]
        set index2 [lindex [lindex $index_list2 1] 0]

        if {$index2 != ""} {
          set index2 [expr {($index2 % $len) -1}]
          if {($index1 != "") && ($index2 != "") && (($info($window,circular) == "circular") || ($index1 < $index2))} {
            $a.reactionframe.mb$site_count.menu add radiobutton -label $info($window,win_title) -variable recomb_window($site_count) -value $info($window,win_title) -command "set recomb_data($site_count) {0 $window $index1 $index2}"
          }
        }
      }

      set index_list1 [regexp -all -indices -nocase -inline $site_rc_reg1 $text]
      set index1 [lindex [lindex $index_list1 1] 1]

      if {$index1 != ""} {
        set index1 [expr {$index1 % $len}]
        set index_list2 [regexp -all -indices -nocase -inline $site_rc_reg2 $text]
        set index2 [lindex [lindex $index_list2 1] 1]

        if {$index2 != ""} {
          set index2 [expr {($index2 % $len) + 1}]
          if {($info($window,circular) == "circular") || ($index2 < $index1)} {
            $a.reactionframe.mb$site_count.menu add radiobutton -label $info($window,win_title) -variable recomb_window($site_count) -value $info($window,win_title) -command "set recomb_data($site_count) {1 $window $index2 $index1}"       
          }
        }
      }
    }
    if {[$a.reactionframe.mb$site_count.menu index end] == "none"} {
      set recomb_window($site_count) "None Found"
      set found_all 0
    } else {
      $a.reactionframe.mb$site_count.menu invoke 0
    }
    #label for the site on the right side
    #grid [label $a.reactionframe.l2$site_count -text $site2] -row $site_count -column 3
    incr site_count
  }
  if {!$found_all} {
    $a.okframe.ok configure -state disabled -default disabled
    while {[lindex [time {tk_messageBox -message [mc "Some sequences required for this prototype were not found. Check all of your sequences that you think are circular, some might be linear. ApE can only recombine sequences in open files."] -type ok -icon info}] 0] < 1500000} {
      tk_messageBox -message [mc "Read the dialogs, you'll learn something."] -type ok -icon info
    }
  } else {
    $a.okframe.ok configure -state normal -default active
  }
}

################
## initialize some info for MS Windows
################
proc initialize_win32 {} {
  package require registry
  global info possible_extensions tcl_platform env

  ##set browser info
  set root HKEY_CLASSES_ROOT
  if {![catch {set appKey [registry get $root\\.html ""]} err1]} {
    if {(![catch {registry get $root\\$appKey\\shell\\open\\command ""} err1 ]) && (![catch {set appCmd [registry get $root\\$appKey\\shell\\open\\command ""]} err1])} {
      regsub -all {\\} $appCmd  {\\\\} info(appCmd)
      if {[string match -nocase *iexplore.exe* $info(appCmd)]} {
        set info(browser) iexplore
      } elseif {[string match -nocase *netscape.exe* $info(appCmd)]} {
        set info(browser) NETSCAPE
      } elseif {[string match -nocase *mozilla.exe* $info(appCmd)]} {
        set info(browser) Mozilla
      } elseif {[string match -nocase *opera.exe* $info(appCmd)]} {
        set info(browser) Opera
      } elseif {[string match -nocase *firefox.exe* $info(appCmd)]} {
        set info(browser) Firefox
      } else {
        sputs "Sorry, I don't recognize the browser: [file tail $info(appCmd)]"
        set info(browser) ""
      } 
    } else {
      sputs "Sorry, no shell command registered for .html files" $appKey $err1
      set info(browser) ""
    }
  } else {
      sputs "Sorry, no application registered for .html files" $err1
      set info(browser) ""
  }

  ##set system colors info
  set info(tk_ps_fonts) [list helvetica Helvetica arial Helvetica times TimesNewRomanPSMT {news gothic mt} TimesNewRomanPSMT {times new roman} TimesNewRomanPSMT courier Courier {courier new} Courier]

  ##set window icon
  if {[file exists [file join $info(Accdir) "Icons and images" "APE_icon.ico"]]} {
    set window_icon [file join $info(Accdir) "Icons and images" "APE_icon.ico"]
    catch {wm iconbitmap . -default $window_icon}
  }
  
  ##load the wmf, gdi, hdc and printer dlls
  if {[file exists [file join $info(Accdir) "lib" "printer.dll"]]} {
    if {[file exists [file join $info(Accdir) "lib" "hdc.dll"]]} {
      if {[file exists [file join $info(Accdir) "lib" "gdi.dll"]]} {
        if {[file exists [file join $info(Accdir) "lib" "wmf.dll"]]} {
          load [file join $info(Accdir) "lib" "hdc.dll"]
          load [file join $info(Accdir) "lib" "printer.dll"]
          load [file join $info(Accdir) "lib" "gdi.dll"]
          load [file join $info(Accdir) "lib" "wmf.dll"]
        }
      }
    }
  }

  ##load the drag and drop dll
  if {[file exists [file join $info(Accdir) "lib" "libtkdnd.dll"]]} {
    load [file join $info(Accdir) "lib" "libtkdnd.dll"]
    proc HandleFileDrop {data type} {
      sputs "data:$data type:$type"
      if {$type == "Files"} {
        foreach filename $data {
          if {[file extension $filename] == ".lnk"} {
            if {[file exists [set filename [find_link_target $filename]]]} {
              open_file $filename
            }
          } else {
            open_file $filename
          }
        }
      }
    }
    proc find_link_target {filename} {
      set fileid [open $filename r]
 
      if {[read $fileid 1] != "L"} {close $fileid; return ""}
      #read flags
      seek $fileid 0x14
      binary scan [read $fileid 4] b7 flags
      set has_id_list [string index $flags 0]
      set is_file [string index $flags 1]
      set has_desc [string index $flags 2]
      set has_rel_path [string index $flags 3]
      set has_working_dir [string index $flags 4]
      set has_command_line [string index $flags 5]
      set has_custom_icon [string index $flags 6]


      if {!$is_file} {close $fileid; return ""}

      #if item id list, skip it
      if {$has_id_list} {
        #read the item ID list size
        seek $fileid 0x4C
        binary scan [read $fileid 2] s id_size
        set file_loc_off [expr (0x4E+$id_size)]
      } else {
        set file_loc_off 0x4E
      }

      #read the location info_header
      seek $fileid $file_loc_off
      set x [read $fileid 28]
      binary scan $x iiiiiii structure_len offset_last_item location_flags local_v_off   local_path_off net_v_off final_path_off
      set has_local [expr {$location_flags % 2}]
      set has_net [expr {$location_flags >> 1}]


      if {$has_local} {
        #read local_volume_table_header
        seek $fileid [expr {$file_loc_off+$local_v_off}]
        binary scan [read $fileid 16] iiii len_loc_v_table fixed_disk vol_ser vol_label_off
        set vol_label ""
        while {(![string equal [set c [read $fileid 1]] \0]) && (![eof $fileid])} {
          set vol_label "$vol_label$c"
        }

        seek $fileid [expr {$file_loc_off+$local_path_off}]
        set local_path ""
        while {(![string equal [set c [read $fileid 1]] \0]) && (![eof $fileid])} {
          set local_path "$local_path$c"
        }
      }
 
      if {$has_net} {
        #read net_volume_table_header
        seek $fileid [expr {$file_loc_off+$net_v_off}]
        binary scan [read $fileid 20] iiiii len_net_v_table x share_name_off x x

        set share_name ""
        while {(![string equal [set c [read $fileid 1]] \0]) && (![eof $fileid])} {
          set share_name "$share_name$c"
        }
      }

      seek $fileid [expr {$file_loc_off+$final_path_off}]
      set final_path ""
      while {(![string equal [set c [read $fileid 1]] \0]) && (![eof $fileid])} {
        set final_path "$final_path$c"
      }

      close $fileid
      if {$has_local} {
        set leader $local_path
      } elseif {$has_net} {
        set leader $share_name
      }

      if {$final_path != ""} {
        return "$leader[file separator]$final_path"
      } else {
        return $leader
      }
    }
  }
}

################
## try to set up the users default directory on a windows system- return 1 if successful, 0 if not, and report the error to the user
################
proc initilize_windows_user_defauts {dir {msg ""}} {
  global info

  if {![file isdirectory $dir]} {
    if {[catch {file mkdir $dir} err]} {
     sputs "Can't create users directory $dir, $err. $msg" -type ok -icon info
     return 0
    }
  }
  if {![file writable $dir]} {
    sputs "Can't write to users directory $dir. $msg" -type ok -icon info
    return 0
  }

  set info(user_defaults_dir) [file join $dir Ape]
  #tk_messageBox -message "Users directory $dir" -type ok -icon info
  if {![file isdirectory $info(user_defaults_dir)]} {
    if {[catch {file mkdir $info(user_defaults_dir)} err]} {
     sputs "Can't create ApE directory in $dir, $err. $msg" -type ok -icon info
     return 0
    }
  }
  return 1
}


################
## initialize some info for Aqua (OS X)
################
proc initialize_aqua {} {
  global info tk_patchLevel

  set modstring "Cmd"
  if {[catch {load [file join $info(Accdir) lib MacCarbonPrint.dylib]} errmsg]} {
    sputs $errmsg
  }
#for doing hide shortcut- bug in intel macs
  #if {[catch {load [file join $info(Accdir) lib tclCarbonHICommand.dylib]} errmsg]} {
  #  sputs $errmsg
  #}
  if {[catch {load [file join $info(Accdir) lib TclSpeech2.0.dylib]} errmsg]} {
    sputs $errmsg
  }

  if {[catch {load [file join $info(Accdir) lib Img1.4 libzlibtcl1.2.3.dylib]} errmsg]} {
    sputs $errmsg
  } else {
    if {[catch {load [file join $info(Accdir) lib Img1.4 libtkimg1.4.dylib]} errmsg]} {
      sputs $errmsg
    }
    if {[catch {load [file join $info(Accdir) lib Img1.4 libpngtcl1.2.34.dylib]} errmsg]} {
      sputs $errmsg
    }
    if {[catch {load [file join $info(Accdir) lib Img1.4 libtkimgpng1.4.dylib]} errmsg]} {
      sputs $errmsg
    }
  }

  if {0} {
#loads Img png support for loading png files- with windows version, can load png files for toolbars
    if {[catch {load [file join $info(Accdir) lib Img1.3 libzlibtcl1.2.3.dylib]} errmsg]} {
      sputs $errmsg
    }
    if {[catch {load [file join $info(Accdir) lib Img1.3 libtkimg1.3.dylib]} errmsg]} {
      sputs $errmsg
    }
    if {[catch {load [file join $info(Accdir) lib Img1.3 libpngtcl1.2.6.dylib]} errmsg]} {
      sputs $errmsg
    }
    if {[catch {load [file join $info(Accdir) lib Img1.3 libtkimgpng1.3.dylib]} errmsg]} {
      sputs $errmsg
    }
  }



  #add menubar to the window
  . configure -menu [menu .menubar]
  menu .menubar.filemenu
  .menubar add cascade -menu .menubar.filemenu -label "File"
  .menubar.filemenu add command -label "New" -accelerator "$modstring+N"  -command "create_window" -state disabled

  .menubar.filemenu add command -label "Open..." -accelerator "$modstring+O" -command "open_file_dialog" -state disabled
  menu .menubar.filemenu.open_previous
  .menubar.filemenu add cascade -label [mc "Open Recent Files"] -menu .menubar.filemenu.open_previous
  .menubar.filemenu add command -label "Duplicate Selection"  -accelerator "$modstring+D"  -state disabled
  .menubar.filemenu add command -label "Duplicate All"  -accelerator "$modstring+Shift+D"  -state disabled

  .menubar.filemenu add command -label "Close"  -accelerator "$modstring+W" -state disabled
  .menubar.filemenu add separator
  .menubar.filemenu add command -label "Save"  -accelerator "$modstring+S" -state disabled
  .menubar.filemenu add command -label "Save As..." -state disabled

#define edit menu
  menu .menubar.edit
  .menubar add cascade -menu .menubar.edit -label "Edit"
  .menubar.edit add command -label "Can't Undo" -state disabled -accelerator "$modstring+Z"
  .menubar.edit add command -label "Cut"  -accelerator "$modstring+X" -state disabled
  .menubar.edit add command -label "Copy"  -accelerator "$modstring+C" -state disabled
  .menubar.edit add command -label "Paste"  -accelerator "$modstring+V" -state disabled
  .menubar.edit add separator
  .menubar.edit add command -label "Cut Rev-Com"  -accelerator "$modstring+Shift+X" -state disabled
  .menubar.edit add command -label "Copy Rev-Com"  -accelerator "$modstring+Shift+C" -state disabled
  .menubar.edit add command -label "Paste Rev-Com"  -accelerator "$modstring+Shift+V" -state disabled
  .menubar.edit add separator
  .menubar.edit add command -label "Select All"  -accelerator "$modstring+A" -state disabled
  .menubar.edit add command -label "Select From-To..."  -accelerator "$modstring+H"  -state disabled
  .menubar.edit add command -label "Jump To..."  -accelerator "$modstring+J" -state disabled
  .menubar.edit add separator
  .menubar.edit add command -label "Find..."  -accelerator "$modstring+F" -state disabled
  .menubar.edit add command -label "Find Again"  -accelerator "$modstring+G" -state disabled
  .menubar.edit add command -label "Clear Find Highlighting"  -state disabled
  .menubar.edit add separator
  .menubar.edit add command -label "Convert to UPPERCASE"  -accelerator "$modstring+Shift+U" -state disabled
  .menubar.edit add command -label "Convert to lowercase"  -accelerator "$modstring+L" -state disabled
  .menubar.edit add command -label "UPPER<->lower" -accelerator "$modstring+="  -state disabled
  .menubar.edit add separator
  .menubar.edit add command -label "Reverse-Complement"  -accelerator "$modstring+/" -state disabled
  .menubar.edit add separator
  .menubar.edit add command -label "Circular<->Linear" -accelerator "$modstring+U" -state disabled
  .menubar.edit add command -label "Set Origin"  -accelerator "$modstring+I" -state disabled
  .menubar.edit add command -label "Linearize @ insert site" -state disabled

#add enzymes menu
menu .menubar.enzymes
  .menubar add cascade -menu .menubar.enzymes -label "Enzymes"
  .menubar.enzymes add command -label "Enzyme Selector..." -state disabled
  .menubar.enzymes add separator
  .menubar.enzymes add checkbutton -label "Selection Only" -onvalue "selection" -offvalue "all" -variable info(analyze_selection) -state disabled
  .menubar.enzymes add separator
  .menubar.enzymes add command -label "Graphic Map" -state disabled
  .menubar.enzymes add command -label "Graphic Map +U" -state disabled
  .menubar.enzymes add separator
  .menubar.enzymes add command -label "Highlight" -state disabled
  .menubar.enzymes add command -label "Clear Highlighting" -state disabled
  .menubar.enzymes add separator
  .menubar.enzymes add command -label "Digestion" -state disabled
  .menubar.enzymes add cascade -label "Ladder"  -state disabled
  .menubar.enzymes add separator
  .menubar.enzymes add command -label "List Enzymes..."  -state disabled
  .menubar.enzymes add cascade -label "Quick Lists"  -state disabled
  .menubar.enzymes add separator
  .menubar.enzymes add command -label "Silent Sites" -state disabled
  .menubar.enzymes add separator
  .menubar.enzymes add command -label "Text Map..." -state disabled

#add ORFs menu
menu .menubar.orf
  .menubar add cascade -menu .menubar.orf -label "ORFs"
    .menubar.orf add command -label "Find Next" -accelerator "$modstring+>" -state disabled
    .menubar.orf add command -label "Find Previous" -accelerator "$modstring+<"  -state disabled

    .menubar.orf add separator
    .menubar.orf add command -label "Translate..." -state disabled
    .menubar.orf add separator
    .menubar.orf add command -label "ORF map"  -state disabled
    .menubar.orf add separator
    .menubar.orf add radiobutton -label "Selection Translate" -variable info(selection_shows) -value "Translate" -state disabled
    #.menubar.orf add radiobutton -label "Selection None" -variable info(selection_shows) -value "None"  -state disabled

#add features menu
menu .menubar.features
  .menubar add cascade -menu .menubar.features -label "Features"
  .menubar.features add command -label [mc "New Feature..."] -state disabled
  .menubar.features add command -label [mc "List Features"] -state disabled
  .menubar.features add command -label [mc "Edit Features..."]  -state disabled
  .menubar.features add command -label [mc "Clear Features"] -accelerator "$modstring+Shift+K"  -state disabled
  .menubar.features add separator
  .menubar.features add command -label [mc "Edit Feature Library..."]  -state disabled
  .menubar.features add command -label [mc "New Feature in Library..."] -state disabled
  .menubar.features add command -label [mc "Open Feature Library..."]  -state disabled
  .menubar.features add command -label [mc "Annotate Features using Library"] -accelerator "$modstring+K"  -state disabled



#add Tools menu
menu .menubar.tools
  .menubar add cascade -menu .menubar.tools -label "Tools"
    .menubar.tools add command -label [mc "Find Primers..."]  -state disabled
    .menubar.tools add separator
    .menubar.tools add command -label [mc "Align Sequences..."]  -state disabled
    .menubar.tools add separator
    .menubar.tools add command -label [mc "BLAST Sequences at NCBI..."]  -state disabled
  # .menubar.tools add command -label [mc "BLAST Sequences at Wormbase..."] -state disabled
    .menubar.tools add separator
    .menubar.tools add command -label [mc "Download sequences from NCBI..."] -state disabled

#add Windows menu stub (menu items are maintained by update_windows_menu procedure)
menu .menubar.windows
    .menubar add cascade -menu .menubar.windows -label [mc "Window"]

#add Help menu
menu .menubar.help1
  .menubar add cascade -menu .menubar.help1 -label "Help"
    .menubar.help1 add command -label "Standard Genetic Code" -state disabled
    .menubar.help1 add command -label "AA Info" -state disabled


   #define the apple menu
    menu .menubar.apple
      .menubar add cascade -menu .menubar.apple
      .menubar.apple add command -label [mc "About ApE"] -command "about_dialog ." 
      .menubar.apple add separator
      #.menubar.apple add command -label [mc "Preferences..."]  -command "configure_preferences ." -accelerator "$modstring+,"
  set info(newaquax) 20
  set info(newaquay) 20
  set info(aqua_page_setup) {}
  set tk::mac::CGAntialiasLimit $info(mac_antialias_limit)
  bind Text

  ##to fix huge bug introduced in OS 10.5
  if {[info exists info(leopard_dialog_bug)] && $info(leopard_dialog_bug)} {
    rename tk_chooseColor old_tk_chooseColor
    proc ::tk_chooseColor {args} {
        return [eval tk::dialog::color:: $args]
    }
    rename tk_getOpenFile old_tk_getOpenFile
    proc ::tk_getOpenFile {args} {
      return [eval ::tk::dialog::file:: open $args]
    }
    rename tk_getSaveFile old_tk_getSaveFile
    proc ::tk_getSaveFile {args} {
      return [eval ::tk::dialog::file:: save $args]
    }
    rename tk_chooseDirectory old_tk_chooseDirectory
    proc ::tk_chooseDirectory {args} {
      return [eval ::tk::dialog::file::chooseDir:: $args]
    }
  }


  proc aqua_minimize {w} {
      wm iconify $w
  }
}

################
## insert text into a text window
################
#needs to check tags and break them, register the info into the undo queue, then call a do_text_insert proc that does the insertion
proc textarea_insert {text index seq {tags {}}} {
  global info
  $text insert $index $seq $tags
  set w [winfo toplevel $text]
  if {([info exists info($w,textwidth)]) && ($info($w,textwidth) > 1)} {
    reline $text [expr {$info($w,textwidth)}]
  }
}

################
## get text from a text window, remove line breaks
################
proc textarea_get {text index1 index2} {
  return [regsub -all \n [$text get $index1 $index2] ""]
}

################
## delete text from a text window, reline
################
proc textarea_delete {text index1 {index2 ""}} {
  global info
  if {$index2 == ""} {set index2 [$text index $index1+1c]}
  $text delete $index1 $index2
  set w [winfo toplevel $text]
  if {[tk windowingsystem] == "aqua"} {
    set width [expr {int(([winfo width $w.textarea]-4)/[lindex [wm grid $w] 2])}]
  } else {
    set width [expr {int(([winfo width $w.textarea]-2.0*[$w.textarea cget -borderwidth])/[lindex [wm grid $w] 2])}]
  }
  #if {([info exists info($w,textwidth)]) && ($info($w,textwidth) > 1)} {
    reline $text [expr {$info($w,textwidth)}]
  #}
}

################
## Make new widget type: wrapped_text, based on text box, but that rewraps to give hard line endings. required for long DNAs becuse of stupid B-tree handling and display line calculations in standard text box
################
proc wrapped_text {name args} {
sputs $name $args
  eval text $name $args
  rename $name $name\_wrapped
  proc $name {command args} "
    #sputs $name \$command \$args
    uplevel #0 $name\_wrapped \$command \$args
  "
  return $name
}

############
## quick cr inserter for a text window
############
proc reline {w newwidth} {
  set i 1
  while {[$w compare $i.end < end]} {
    set linelength [expr {[lindex [split [$w index $i.end] .] 1]}]
    if {($linelength < $newwidth)} {
      if {[$w compare $i.end+1c < end]} {
        $w delete $i.end
      } else {
        break
      }
    } elseif {$linelength > $newwidth}  {
      for {set j $i} {$j < [expr {$i+ $linelength/ $newwidth}]} {incr j} {
        $w insert $j.$newwidth \n
      }
      set i $j
    } else {
      incr i
    }
  }
}




proc bp2ix {t base_position} {
    if {$base_position == 0} {
      return 1.0
    }
    set width [lindex [split [$t index 1.end] .] 1]
    if {$width == 0} {return 0}
    return [expr {($base_position-1)/($width)+1}].[expr {(($base_position-1) % ($width)) +1}]
}

proc ix2bp {t index} {
    set width [lindex [split [$t index 1.end] .] 1]
    set index [$t index $index]
    if {[$t compare $index == end]} {set index [$t index end-1c]}
    return [expr {$width*([lindex [split $index .] 0]-1)+[lindex [split $index .] 1]}]
}


################
## try to use tile widgets where possible
################
set info(use_tile) 0
proc use_tile {} {
  global info
  if {(([tk windowingsystem] == "aqua") || ([tk windowingsystem] == "win32")) && (![catch {package require tile}])} {
    set info(use_tile) 1
  } else {
    if {[catch {ttk::notebook .blank_notebook}]} {
      #sputs tile not used- using standard widgets
      rename configure_preferences tile_configure_preferences
      rename non_tile_configure_preferences configure_preferences
      set info(use_tile) 0
    } else {
      destroy .blank_notebook
      set info(use_tile) 1
    }
  }

  if {$info(use_tile)} {
    ###use tile scale widgets (only used in abi window for now)
    ###
    rename scale tk_scale
    proc scale {name args} {
     set new_args [list]
     foreach {arg value} $args {
       if {[lsearch {-from -to -command -variable -value -length -orient} $arg] > -1} {
         lappend new_args $arg $value
       } else {
         sputs ttk::scale doesn't accept $arg $value
       }
     }
     eval ttk::scale $name $new_args
    }


      ###use tile button, checkbutton and radiobutton widgets in windows

    if {([tk windowingsystem] eq "win32")} {
      ###
      ### ok to use these on aqua, but info(bg_color) has to be set to gray91
      if {([tk windowingsystem] eq "aqua")} {
        set info(bg_color) gray91
      }
      ## need to set takefocus values back to default of 0- tile sets the default to true via a procedure ttk::takefocus
      rename ttk::takefocus ttk::takefocus_old
      proc ttk::takefocus {w} {return 0}

      rename button tk_button
      proc button {name args} {
        set new_args [list]
        foreach {arg value} $args {
          if {[lsearch {-text -cursor -image -default -width -command -textvariable -state} $arg] > -1} {
            lappend new_args $arg $value
          } else {
          # sputs ttk::button doesn't accept $arg $value
          }
        }
        eval ttk::button $name $new_args
        rename $name tk_$name
        proc $name {command args} "
          if {(\[string range \$command 0 3\] == \"conf\")} {
            if {\[llength \$args\] == 1} {
              if {\[lsearch {-text -cursor -image -default -width -command -textvariable -takefocus -style -state} \[lindex \$args 0\]\] > -1} {
                return \[tk_$name configure \$args\]
              } else {
                foreach i {{-activebackground activeBackground Foreground systemButtonText gray85} {-activeforeground activeForeground Background systemButtonFace black} {-anchor anchor Anchor center center} {-background background Background White gray85} {-bd -borderwidth} {-bg -background} {-bitmap bitmap Bitmap {} {}} {-borderwidth borderWidth BorderWidth 2 2} {-command command Command {} {}} {-compound compound Compound none none} {-cursor cursor Cursor {} {}} {-default default Default disabled disabled} {-disabledforeground disabledForeground DisabledForeground #a3a3a3 #a3a3a3} {-fg -foreground} {-font font Font system labelfont} {-foreground foreground Foreground Black black} {-height height Height 0 0} {-highlightbackground highlightBackground HighlightBackground White gray85} {-highlightcolor highlightColor HighlightColor systemButtonFrame black} {-highlightthickness highlightThickness HighlightThickness 4 4} {-image image Image {} {}} {-justify justify Justify center center} {-overrelief overRelief OverRelief {} {}} {-padx padX Pad 12 12} {-pady padY Pad 3 3} {-relief relief Relief flat flat} {-repeatdelay repeatDelay RepeatDelay 0 0} {-repeatinterval repeatInterval RepeatInterval 0 0} {-state state State normal normal} {-takefocus takeFocus TakeFocus {} {}} {-text text Text {} {}} {-textvariable textVariable Variable {} {}} {-underline underline Underline -1 -1} {-width width Width 0 0} {-wraplength wrapLength WrapLength 0 0}} {
                  if {\[lsearch \$i \[lindex \$args 0\]\] > -1} {
                    return \$i
                  }
                }
                ##config otion not found- return an error
                error \"\[lindex \$args 0\] isn't an option for tk_$name\"
              }
            } else {
              set new_args \[list\]
              foreach {arg value} \$args {
                if {\[lsearch {-text -cursor -image -default -width -command -textvariable -takefocus -style -state} \$arg] > -1} {
                  lappend new_args \$arg \$value
                 #sputs $name \$arg \$value
                } else {
                 sputs **reject** $name \$arg \$value
                } 
              }
              #sputs * $name configure \$new_args
              eval tk_$name configure \$new_args
            }
          } elseif {\$command == \"invoke\"} {
            uplevel #0 tk_$name invoke
          } elseif  {(\[string range \$command 0 3\] == \"cget\")} {
            uplevel #0 tk_$name \$command \$args
          } else {
            #sputs $name \$command \$args
            uplevel #0 tk_$name \$command \$args
          } 
        "
        return $name
      }
      ###use tile checkbutton widgets (not in aqua)
      ###
      rename checkbutton tk_checkbutton
      proc checkbutton {name args} {
        set new_args [list]
        foreach {arg value} $args {
          if {[lsearch {-text -image -cursor -width -command -textvariable  -onvalue -offvalue -variable  -takefocus -style} $arg] > -1} {
            lappend new_args $arg $value
          } else {
          # sputs ttk::button doesn't accept $arg $value
          }
        }
        eval ttk::checkbutton $name $new_args
        rename $name tk_$name
        proc $name {command args} "
          if {\[string range \$command 0 3\] == \"conf\"} {
            if {\[llength \$args\] == 1} {
              if {\[lsearch {-text -cursor -image -default -width -command -textvariable  -takefocus -style} \[lindex \$args 0\]\] > -1} {
                return \[tk_$name configure \$args\]
              } else {
                foreach i {{-activebackground activeBackground Foreground systemButtonText gray85} {-activeforeground activeForeground Background systemButtonFace black} {-anchor anchor Anchor center center} {-background background Background White gray85} {-bd -borderwidth} {-bg -background} {-bitmap bitmap Bitmap {} {}} {-borderwidth borderWidth BorderWidth 2 2} {-command command Command {} {}} {-compound compound Compound none none} {-cursor cursor Cursor {} {}} {-disabledforeground disabledForeground DisabledForeground #a3a3a3 #a3a3a3} {-fg -foreground} {-font font Font system labelfont} {-foreground foreground Foreground Black black} {-height height Height 0 0} {-highlightbackground highlightBackground HighlightBackground White gray85} {-highlightcolor highlightColor HighlightColor systemButtonFrame black} {-highlightthickness highlightThickness HighlightThickness 4 4} {-image image Image {} {}} {-indicatoron indicatorOn IndicatorOn 1 1} {-justify justify Justify center center} {-offrelief offRelief OffRelief flat flat} {-offvalue offValue Value 0 0} {-onvalue onValue Value 1 1} {-overrelief overRelief OverRelief {} {}} {-padx padX Pad 1 1} {-pady padY Pad 1 1} {-relief relief Relief flat flat} {-selectcolor selectColor Background #b03060 #b03060} {-selectimage selectImage SelectImage {} {}} {-state state State normal normal} {-takefocus takeFocus TakeFocus {} {}} {-text text Text {} {}} {-textvariable textVariable Variable {} {}} {-underline underline Underline -1 -1} {-variable variable Variable {} c} {-width width Width 0 0} {-wraplength wrapLength WrapLength 0 0}} {
                  if {\[lsearch \$i \[lindex \$args 0\]\] > -1} {
                    return \$i
                  }
                }
              }
            } else {
              set new_args \[list\]
              foreach {arg value} \$args {
                if {\[lsearch {-text -image -cursor -width -command -textvariable  -onvalue -offvalue -variable} \$arg] > -1} {
                  lappend new_args \$arg \$value
                 #sputs $name \$arg \$value
                } else {
                 #sputs **reject** $name \$arg \$value
                } 
              }
              #sputs * $name configure \$new_args
              eval tk_$name configure \$new_args
            }
          } elseif {\$command == \"invoke\"} {
            #sputs doing:tk_$name \$command \$args
            uplevel #0 tk_$name invoke
          } else {
            uplevel #0 tk_$name \$command \$args
          } 
        "
        return $name
      }
      ###use tile radiobutton widgets (not in aqua)
      ###
      rename radiobutton tk_radiobutton
      proc radiobutton {name args} {
        set new_args [list]
        foreach {arg value} $args {
          if {[lsearch {-text -image -cursor -width -command -textvariable -value -variable} $arg] > -1} {
            lappend new_args $arg $value
          } else {
          # sputs ttk::button doesn't accept $arg $value
          }
        }
        eval ttk::radiobutton $name $new_args
        rename $name tk_$name
        proc $name {command args} "
          if {\[string range \$command 0 3\] == \"conf\"} {
            if {\[llength \$args\] == 1} {
              if {\[lsearch {-text -cursor -image -default -width -command -textvariable} \[lindex \$args 0\]\] > -1} {
                return \[tk_$name configure \$args\]
              } else {
                foreach i {{-activebackground activeBackground Foreground systemButtonText gray85} {-activeforeground activeForeground Background systemButtonFace black} {-anchor anchor Anchor center center} {-background background Background White gray85} {-bd -borderwidth} {-bg -background} {-bitmap bitmap Bitmap {} {}} {-borderwidth borderWidth BorderWidth 2 2} {-command command Command {} {}} {-compound compound Compound none none} {-cursor cursor Cursor {} {}} {-disabledforeground disabledForeground DisabledForeground #a3a3a3 #a3a3a3} {-fg -foreground} {-font font Font system labelfont} {-foreground foreground Foreground Black black} {-height height Height 0 0} {-highlightbackground highlightBackground HighlightBackground White gray85} {-highlightcolor highlightColor HighlightColor systemButtonFrame black} {-highlightthickness highlightThickness HighlightThickness 4 4} {-image image Image {} {}} {-indicatoron indicatorOn IndicatorOn 1 1} {-justify justify Justify center center} {-offrelief offRelief OffRelief flat flat} {-overrelief overRelief OverRelief {} {}} {-padx padX Pad 1 1} {-pady padY Pad 1 1} {-relief relief Relief flat flat} {-selectcolor selectColor Background #b03060 #b03060} {-selectimage selectImage SelectImage {} {}} {-state state State normal normal} {-takefocus takeFocus TakeFocus {} {}} {-text text Text {} {}} {-textvariable textVariable Variable {} {}} {-underline underline Underline -1 -1} {-value value Value {} {}} {-variable variable Variable selectedButton selectedButton} {-width width Width 0 0} {-wraplength wrapLength WrapLength 0 0}} {
                  if {\[lsearch \$i \[lindex \$args 0\]\] > -1} {
                    return \$i
                  }
                }
              }
            } else {
              set new_args \[list\]
              foreach {arg value} \$args {
                if {\[lsearch {-text -image -cursor -width -command -textvariable -value -variable} \$arg] > -1} {
                  lappend new_args \$arg \$value
                 #sputs $name \$arg \$value
                } else {
                 #sputs **reject** $name \$arg \$value
                } 
              }
              #sputs * $name configure \$new_args
              eval tk_$name configure \$new_args
            }
          } elseif {\$command == \"invoke\"} {
            #sputs doing:tk_$name \$command \$args
            uplevel #0 tk_$name invoke
          } else {
            uplevel #0 tk_$name \$command \$args
          } 
        "
        return $name
      }
    }
  }
}

################
## set up file type associations on Windows
################
proc file_typer {{on_extensions {}} {off_extensions {}} {clear_type 0}} {
  global possible_extensions
  global info argv0

  if {($clear_type) && ([registry keys "HKEY_LOCAL_MACHINE\\Software\\Classes\\" ApE.DNA.file] != "")} {
    #remove all extensions
    registry delete HKEY_LOCAL_MACHINE\\ApE.DNA.file
  } elseif {($on_extensions != [list]) && ([registry keys "HKEY_LOCAL_MACHINE\\Software\\Classes\\" "ApE.DNA.file"] == "")} {
      #set up file description
      set classpath "HKEY_LOCAL_MACHINE\\Software\\Classes\\ApE.DNA.file"
      if {(![catch {registry set $classpath {} "ApE DNA File" sz}]} {
        registry set "$classpath\\DefaultIcon" {} "[file nativename [file join $info(Accdir) "Icons and images" "APE_icon.ico"]],0" sz
        if {(![catch {package require starkit}]) && ($::starkit::mode == "starpack")} {
          registry set "$classpath\\Shell\\open\\command" {} "\"[file nativename [info nameofexecutable]]\" \"%1\"" sz
        } else {
          registry set "$classpath\\Shell\\open\\command" {} "\"[file nativename [info nameofexecutable]]\" \"[file nativename $argv0]\" \"%1\"" sz
        }
        registry set $classpath\\Shell\\open\\ddeexec {} "open_file {%1}" sz
        registry set $classpath\\Shell\\open\\ddeexec\\ifexec {} "#" sz
        registry set $classpath\\Shell\\open\\ddeexec\\Application {} "TclEval" sz
        registry set $classpath\\Shell\\open\\ddeexec\\topic {} "readDNAfiles" sz
        if {![catch {registry get HKEY_LOCAL_MACHINE\\Software\\Classes\\txtfile\\Shell\\open\\command {}} eCmd]} {
          registry set $classpath\\Shell\\edit\\command {} $eCmd sz
          registry set $classpath\\Shell\\edit {} &Edit sz
        }
      } else {
        if {[tk_messageBox -message "There was an error writing to the registry. You may need administrator priveledges." -type ok] == "ok} {
          return
        }
      }
  }
  foreach extension $on_extensions {
    if {([registry keys "HKEY_LOCAL_MACHINE\\Software\\Classes\\" $extension] == "")} {
      registry set "HKEY_LOCAL_MACHINE\\Software\\Classes\\$extension" {} "ApE.DNA.file" sz
    } else {
      set type [registry get "HKEY_LOCAL_MACHINE\\Software\\Classes\\[registry get "HKEY_LOCAL_MACHINE\\Software\\Classes\\$extension" {}]" {}]
      if {[tk_messageBox -message "The extension $extension is already registered as type: $type.\n Are you sure you want to replace it?" -type okcancel -default cancel] == "ok"} {
        registry set "HKEY_LOCAL_MACHINE\\Software\\Classes\\$extension" {} "ApE.DNA.file" sz
      }
    }
  }
  foreach extension $off_extensions {
    registry delete "HKEY_LOCAL_MACHINE\\Software\\Classes\\$extension"
  }
}

################
## returns filetypes that are registered on windows as ApE.DNA.file and files that are registered as other types
################
proc get_registered_types {{file_descriptor ApE.DNA.file}} {
  global possible_extensions

  set r [list]
  set b [list]
  set a [list]
  foreach extension $possible_extensions {
    set hive ""
    if {([registry keys "HKEY_CURRENT_USER\\Software\\Classes\\" $extension] != [list]) && (![catch {registry get  "HKEY_CURRENT_USER\\Software\\Classes\\$extension" {}}]) && ([registry get  "HKEY_CURRENT_USER\\Software\\Classes\\$extension" {}] != [list])} {
      set hive HKEY_CURRENT_USER
    } elseif {([registry keys "HKEY_LOCAL_MACHINE\\Software\\Classes\\" $extension] != [list]) && (![catch {registry get  "HKEY_LOCAL_MACHINE\\Software\\Classes\\$extension" {}}]) && ([registry get  "HKEY_LOCAL_MACHINE\\Software\\Classes\\$extension" {}] != [list])} {
      set hive HKEY_LOCAL_MACHINE
    }
    if {$hive != ""} {
      if {[set descript [registry get "$hive\\Software\\Classes\\$extension" {}]] == $file_descriptor} {
        lappend r $extension
      } else {
        lappend a $extension 
        if {![catch {set temp [registry get "$hive\\Software\\Classes\\$descript" {}]}]} {
          lappend b $temp
        } else {
          lappend b "Unknown Program:$descript"
        }
      }
    }
  }
  return [list $r $a $b]
}

################
## maintain the windows menu
################
proc update_windows_menu {} {
  global info tk_patchLevel
  global toolbar_images global_true modstring

  set global_true 1
  foreach window [winfo children .] {
    if {[winfo exists $window.menubar.windows] || ($window == ".menubar")} {
      if {($window == ".menubar")} {
        set window ""
      }
      $window.menubar.windows delete 0 end

    ####add in the window management commands
    if {[tk windowingsystem] == "aqua"} {
      $window.menubar.windows add command -label [mc "Minimize"] -command "catch {aqua_minimize $window}" -accelerator "$modstring+M"
      if {( $window == "")} {
        $window.menubar.windows entryconfigure 0 -state disabled 
      }
      $window.menubar.windows add separator
      $window.menubar.windows add command -label [mc "Bring All to Front"] -command "catch {foreach wx \[wm stackorder .\] {raise \$wx}}"
      $window.menubar.windows add separator
    }
      ####add in the sequence windows
      foreach windowelement [lsearch -all -inline -regexp [winfo children .] {.dna_window[0-9]+$}] {
        #for PATC tool
        if {([llength [info proc patc_make_features]] > 0) && [catch {$windowelement.menubar.tools index "Highlight PATC Features"}]} {
          $windowelement.menubar.tools add command -label "Highlight PATC Features" -command "patc_make_features $windowelement"
        }
        if {([wm state $windowelement] == "withdrawn")} {
          continue
        }
        if {($windowelement != $window)} {
          $window.menubar.windows add command -label [wm title $windowelement] -command "wm deiconify $windowelement; raise $windowelement; focus $windowelement.textarea";# -compound left -image $toolbar_images(dna_win)  
        } else {
          $window.menubar.windows add checkbutton -variable global_true -label [wm title $windowelement] -command "set global_true 1;wm deiconify $windowelement; raise $windowelement; focus $windowelement.textarea";# -compound left -image $toolbar_images(dna_win)  
        }
        ##add the analysis children of the window
        set analysiswindows [regexp -all -inline "$windowelement\_analysis\[0-9\]+" [winfo children .]]
        foreach awindow $analysiswindows {
          if {$window != $awindow} {
            $window.menubar.windows add command -label "     [wm title $awindow]" -command "wm deiconify $awindow; raise $awindow; focus $awindow; event generate $awindow <Button-1> ";#  -compound left -image $toolbar_images(ana_win)
          } else {
            $window.menubar.windows add checkbutton -variable global_true -label "     [wm title $awindow]" -command "set global_true 1;wm deiconify $awindow; raise $awindow; event generate $awindow <Button-1> ";#  -compound left -image $toolbar_images(ana_win)
          }
        }
      }

      ####add in the abi windows
      set abiwindows [regexp -all -inline ".abi_window\[0-9\]* " "[winfo children .] "]
      if {$abiwindows != [list]} {
        $window.menubar.windows add separator
      }
      foreach abwindow $abiwindows {
        set abwindow [string range $abwindow 0 end-1]
        if {($abwindow != $window)} {
          $window.menubar.windows add command -label "[wm title $abwindow]" -command "wm deiconify $abwindow; raise $abwindow; focus $abwindow";#-compound left -image $toolbar_images(abi_win)
        }  else {
          $window.menubar.windows add checkbutton -variable global_true -label [wm title $abwindow] -command "set global_true 1;wm deiconify $abwindow; raise $abwindow; focus $abwindow.c";# -compound left -image $toolbar_images(abi_win)  
        }
        ##add the analysis children of the window
        set analysiswindows [regexp -all -inline "$abwindow\_analysis\[0-9\]+" [winfo children .]]
        foreach awindow $analysiswindows {
          if {$window != $awindow} {
            $window.menubar.windows add command -label "     [wm title $awindow]" -command "wm deiconify $awindow; raise $awindow; focus $awindow; event generate $awindow <Button-1> ";#  -compound left -image $toolbar_images(ana_win)
          } else {
            $window.menubar.windows add checkbutton -variable global_true -label "     [wm title $awindow]" -command "set global_true 1;wm deiconify $awindow; raise $awindow; event generate $awindow <Button-1> ";#  -compound left -image $toolbar_images(ana_win)
          }
        }
      }
      
      ###add orphaned analysis windows
      set ping 0
      set awindows [regexp -all -inline {([^[:space:]]+)_analysis[0-9]+} [winfo children .]]
      foreach {awindow parent} $awindows {
        if {![winfo exists $parent]} {
          if {!$ping} {
            $window.menubar.windows add separator
            set ping 1
          }
          if {$window != $awindow} {
            $window.menubar.windows add command -label "     [wm title $awindow]" -command "wm deiconify $awindow; raise $awindow; focus $awindow; event generate $awindow <Button-1> ";#  -compound left -image $toolbar_images(ana_win)
          } else {
            $window.menubar.windows add checkbutton -variable global_true -label "     [wm title $awindow]" -command "set global_true 1;wm deiconify $awindow; raise $awindow; event generate $awindow <Button-1> ";#  -compound left -image $toolbar_images(ana_win)
          }
        }
      }
    }
  }
}

################
## maintain the open_previous menu
################
proc update_open_previous_menu {} {
  global info
  set templist [list]
  set i 0
  if {![string is list $info(open_previous)]} {set info(open_previous) [list]}
  foreach entry $info(open_previous) {
    if {$i == $info(max_open_previous)} {break}
    if {[file exists $entry] && ([lsearch -exact $templist $entry] == -1)} {
      lappend templist $entry
      incr i
    }
  }
  set info(open_previous) $templist

  foreach w [winfo children .] {

    if {$w == ".menubar"} {set w ""}
    if {[winfo exists $w.menubar.filemenu.open_previous]} {
      $w.menubar.filemenu.open_previous delete 0 end
      foreach entry $info(open_previous) {
          $w.menubar.filemenu.open_previous add command -label $entry -command "open_file {$entry}"
      }
      if {[llength $info(open_previous)] == 0} {
        catch {$w.menubar.filemenu entryconfigure [mc "Open Recent Files"] -state disabled}
      } else {
        catch {$w.menubar.filemenu entryconfigure [mc "Open Recent Files"] -state normal}
      }
    }
  }
  save_defaults
}

###########
##About ApE dialog
###########
proc about_dialog {w} {
  global ok
  global info tcl_platform modifier
  global version dialogblock menu_temp_text
  if {$dialogblock == 1} {return}
  set dialogblock 1

  toplevel .about_dialog 
  wm withdraw .about_dialog
  wm title .about_dialog [mc "About ApE"]
  wm protocol .about_dialog WM_DELETE_WINDOW "set ok -1"
  bind .about_dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .about_dialog; raise .about_dialog"
  update
  if {[winfo ismapped $w]} {
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .about_dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
    if {[tk windowingsystem] != "aqua"} {
      wm transient .about_dialog $w
    } else {
      ::tk::unsupported::MacWindowStyle style .about_dialog document {closeBox}
    }
  } else {
    wm transient .about_dialog
  }
  #wm deiconify .about_dialog
  #raise .about_dialog
  set ok 0

  #load images here
  foreach {filename image_name} [list "gibbons.gif" "gibbons_image" "pwrdLogo75.gif" "Tcl_image" "paypal.gif" "paypal_image"] {
    set filename [file join $info(Accdir) "Icons and images" $filename]
    if {[file exists $filename]} {
      image create photo $image_name -file $filename
    } else {
      image create photo $image_name -height 1 -width 1
    }
    lappend image_list $image_name
  }

  ##add frames to window here
  grid [canvas .about_dialog.t -relief flat -bg {light steel blue} -width 550 -height 250 -highlightthickness 0] -row 1 -column 0  -sticky nwe

  grid [frame .about_dialog.f3 -relief ridge -bd 0 -bg {light steel blue}] -row 2 -column 0 -sticky nswe
  ##update check frame here
  grid [frame .about_dialog.f3.f1 -relief flat -bd 0 -bg {light steel blue}] -row 0 -column 0 -sticky nswe
  #grid [label .about_dialog.f3.f1.last_check -text [mc "Last update check: %1\$s" [expr {($info(last_update_check) != "")?[clock format $info(last_update_check) -format $info(clock_format)]:[mc "Never"]}]]  -background {light steel blue}] -row 0 -column 0 -columnspan 2
  #grid [button .about_dialog.f3.f1.check_now -command {web_version_check 1; .about_dialog.f3.f1.last_check configure -text [mc "Last update check: %1\$s" [expr {($info(last_update_check) != "")?[clock format $info(last_update_check) -format $info(clock_format)]:[mc "Never"]}]]} -text [mc "Check for Updates Now"] -highlightbackground {light steel blue} -width 20] -pady 2 -row 0 -column 2 -padx 10
  #grid [label .about_dialog.f3.f1.check_l1 -text [mc "Check for updates:"] -background {light steel blue}] -row 1 -column 0
  #grid [menubutton .about_dialog.f3.f1.check_freq -menu .about_dialog.f3.f1.check_freq.menu -textvariable menu_temp_text -background {light steel blue} -activebackground {light steel blue} -width 9 -indicator on] -row 1 -column 1
  #set menu_temp_text [string map [list -1 [mc "Never"] 0 [mc "On Startup"] 86400 [mc "Daily"] 604800 [mc "Weekly"] 18144000 [mc "Monthly"]] $info(update_check_interval)]
  #menu .about_dialog.f3.f1.check_freq.menu
  #.about_dialog.f3.f1.check_freq.menu add radiobutton -label [mc "Never"] -variable info(update_check_interval) -value -1 -command {set menu_temp_text  [mc "Never"]}
  #.about_dialog.f3.f1.check_freq.menu add radiobutton -label [mc "On Startup"] -variable info(update_check_interval) -value 0 -command {set menu_temp_text  [mc "On Startup"]}
  #.about_dialog.f3.f1.check_freq.menu add radiobutton -label [mc "Daily"] -variable info(update_check_interval) -value 86400 -command {set menu_temp_text  [mc "Daily"]}
  #.about_dialog.f3.f1.check_freq.menu add radiobutton -label [mc "Weekly"] -variable info(update_check_interval) -value 604800 -command {set menu_temp_text  [mc "Weekly"]}
  #.about_dialog.f3.f1.check_freq.menu add radiobutton -label [mc "Monthly"] -variable info(update_check_interval) -value 18144000 -command {set menu_temp_text  [mc "Monthly"]}
  set info(update_check_interval) -1
  if {([tk windowingsystem] == "aqua") && ([info commands tk_button] != {})} {
    grid [tk_button .about_dialog.f3.ok -command "set ok 1" -text [mc "OK"] -highlightbackground {light steel blue} -width 10 -default active] -pady 10 -row 1 -column 0 -padx 10
  } else {
    grid [button .about_dialog.f3.ok -command "set ok 1" -text [mc "OK"] -highlightbackground {light steel blue} -width 10 -default active] -pady 10 -row 1 -column 0 -padx 10
  }
  grid columnconfigure .about_dialog.f3 0 -weight 1
  bind .about_dialog <Key-Return> ".about_dialog.f3.ok invoke"
  bind .about_dialog <$modifier-KeyPress-w> ".about_dialog.f3.ok invoke"

  ##draw canvas items here
  set y 10
  .about_dialog.t create text 250 $y -text "ApE- A plasmid Editor v$version" -anchor n -font "Helvetica 24 bold" -justify center -tag title
  incr y 36
  .about_dialog.t create image [lindex [.about_dialog.t bbox title] 2] [lindex [.about_dialog.t bbox title] 1] -image "Tcl_image" -anchor nw
  .about_dialog.t create text 250 $y -text "Copyright  2003-2009 by M. Wayne Davis" -anchor n  -font boldlabelfont -justify center
  incr y [expr {[font metrics labelfont -linespace]+5}]

  if {[mc "Translation by:"] != "Translation by:"} {
    .about_dialog.t create text 250 $y -text "[mc Locale:][mclocale].  [mc "Translation by:"]" -anchor n  -font labelfont -justify center
  } else {
    .about_dialog.t create text 250 $y -text "[mc Locale:][mclocale]." -anchor n  -font labelfont -justify center
  }
  incr y [font metrics labelfont -linespace]


  .about_dialog.t create text 250 $y -text "Running with Tclkit([info patchlevel]) by Jean-Claude Wippler (equi4 software) \nusing Tcl/Tk, IncrTcl, TclVFS, Zlib, and Metakit software." -anchor n  -font labelfont -justify center
  incr y [expr {2*[font metrics labelfont -linespace]}]
  .about_dialog.t create text 250 $y -text "Tcl/Tk  Regents of the University of California, Sun Microsystems, Inc., \nScriptics Corporation, ActiveState Corporation and other parties." -anchor n  -font labelfont -justify center
  incr y [expr {2*[font metrics labelfont -linespace]}]
  .about_dialog.t create text 250 $y -text "IncrTcl  Cadence Design Systems, Inc., and other parties." -anchor n  -font labelfont -justify center
  incr y [font metrics labelfont -linespace]
  .about_dialog.t create text 250 $y -text "TclVFS  Vince Darley, and other parties." -anchor n  -font labelfont -justify center
  incr y [font metrics labelfont -linespace]
  .about_dialog.t create text 250 $y -text "Zlib  1995-2003 Jean-loup Gailly and Mark Adler" -anchor n  -font labelfont -justify center
  incr y [font metrics labelfont -linespace]
  .about_dialog.t create text 250 $y -text "Metakit  1996-2004 Jean-Claude Wippler " -anchor n  -font labelfont -justify center
  incr y [font metrics labelfont -linespace]
  if {[tk windowingsystem] == "aqua"} {
    .about_dialog.t create text 250 $y -text "Tcl/Tk Aqua port by Jim Ingham & Ian Reid  2001-2002 Apple Computer" -anchor n  -font labelfont -justify center
    incr y [font metrics labelfont -linespace]
    .about_dialog.t create text 250 $y -text "Wiskit for Aqua  2003-2004, Daniel A. Steffen" -anchor n  -font labelfont -justify center
    incr y [font metrics labelfont -linespace]
    if  {([lsearch -glob [info loaded] "*MacCarbonPrint.dylib*"] > -1)} {
      .about_dialog.t create text 250 $y -text "OSX carbon printing extensions  Mats Bengtsson and other parties." -anchor n -font labelfont -justify center
      incr y [font metrics labelfont -linespace]
    }
  } else {
    if  {([lsearch -exact [package names] "printer"] > -1)} {
      .about_dialog.t create text 250 $y -text "Windows printing and metafile extensions  Michael I. Schwartz" -anchor n -font labelfont -justify center
      incr y [font metrics labelfont -linespace]
    }
    if  {([lsearch -exact [package names] "tkdnd"] > -1)} {
      .about_dialog.t create text 250 $y -text "Windows drag and drop extensions  George Petasis and Laurent Riesterer" -anchor n -font labelfont -justify center
      incr y [font metrics labelfont -linespace]
    }
  }
  .about_dialog.t create text 250 $y -text "Toolbar icons from http://www.famfamfam.com/lab/icons/silk/" -anchor n  -font labelfont -justify center
  incr y [expr {2*[font metrics labelfont -linespace]}]

  .about_dialog.t create image 250 $y -image "gibbons_image" -anchor n -tag gibbons
  foreach {gib_x0 gib_y0 gib_x1 gib_y1} [.about_dialog.t bbox gibbons] {}
  incr y [expr {$gib_y1-$gib_y0}]

  if {(![file exists [file join $info(Accdir) "I donated.txt"]]) && (![file exists [file join $info(user_defaults_dir) "I donated.txt"]])} {
    .about_dialog.t create image 250 $y -image "paypal_image" -anchor n -tag {paypal_image d_mouseover}
    foreach {payp_x0 payp_y0 payp_x1 payp_y1} [.about_dialog.t bbox paypal_image] {}
    .about_dialog.t create rectangle [expr {$payp_x0-2}] [expr {$payp_y0-2}] [expr {$payp_x1+2}] [expr {$payp_y1+2}] -outline blue -width 2 -tag {donate_box d_mouseover}
    foreach {payp_x0 payp_y0 payp_x1 payp_y1} [.about_dialog.t bbox donate_box] {}
    incr y [expr {$payp_y1-$payp_y0}]
    .about_dialog.t create text 250 $y -text "Click here to donate and support the development of ApE" -anchor n -font boldlabelfont -justify center -fill blue -tag {donate_text d_mouseover}
    incr y [font metrics boldlabelfont -linespace]
    .about_dialog.t bind d_mouseover <Enter> {
      .about_dialog.t itemconfigure donate_box -outline red
      .about_dialog.t itemconfigure donate_text -fill red
      if {[tk windowingsystem] == "aqua"} {
        .about_dialog.t configure -cursor pointinghand
      } else {
        .about_dialog.t configure -cursor hand2
      }
    }
    .about_dialog.t bind d_mouseover <Leave> {
      .about_dialog.t itemconfigure donate_box -outline blue
      .about_dialog.t itemconfigure donate_text -fill black
      .about_dialog.t configure -cursor arrow
    }
    .about_dialog.t bind d_mouseover <Any-Button> {
      open_url {http://www.biology.utah.edu/jorgensen/wayned/ape/Donations.html}
    }
  } else {
    .about_dialog.t create text 250 $y -text "This user is a generous suporter of ApE- Thank you." -anchor n -font boldlabelfont -justify center -fill blue -tag {donate_text d_mouseover}
    incr y [font metrics boldlabelfont -linespace]
  }

  .about_dialog.t configure -width [expr {10+[lindex [.about_dialog.t bbox all] 2]}] -height [expr {10+[lindex [.about_dialog.t bbox all] 3]}]
  wm resizable .about_dialog 0 0
  update idletasks
  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .about_dialog] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry .about_dialog "+$winx+$winy"

  catch {wm attributes .about_dialog -alpha 0.0}
  wm deiconify .about_dialog
  raise .about_dialog
  focus .about_dialog.f3.ok

  for {set alpha 1} {$alpha <= 10} {incr alpha 1} {
    if {(![catch {wm attributes .about_dialog -alpha [expr {0.1 * $alpha-.00001}]}]) && ($tcl_platform(os) != "Windows 95" )} {
      after 50
      update
    }
  }

  vwait ok
  set dialogblock 0
  #grab release .about_dialog
  destroy .about_dialog
  #uncomment this line if update is reinstalled
  #unset menu_temp_text
  foreach image $image_list {
    image delete $image
  }
  bind . <<RaiseDialogs>> ""
}

###########
##Codon Table Help Window
###########
proc genetic_code_dialog {w} {
  if {[winfo exists .gen_code]} {
    wm deiconify .gen_code
    raise .gen_code
  } else {
    toplevel .gen_code 
    wm title .gen_code [mc "Standard Genetic Code..."]
    wm protocol .gen_code WM_DELETE_WINDOW ".gen_code.f3.ok invoke"
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .gen_code "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"

    grid [text .gen_code.t -bg white -wrap none -width 55 -height 25 -font dnafont -setgrid 1] -row 1 -column 0  -sticky nwe
    grid columnconfigure .gen_code 0 -weight 1
    grid rowconfigure .gen_code 1 -weight 1

    grid [frame .gen_code.f3 -relief flat] -row 2 -column 0 -sticky nswe
    grid [button .gen_code.f3.ok -command "destroy .gen_code" -text "OK"] -row 0 -column 0 -sticky n
    grid columnconfigure .gen_code.f3 0 -weight 1

    .gen_code.t insert end "               Second Position\n" topline
    .gen_code.t insert end "        T         C         A          G\n" midlines
    .gen_code.t insert end "   T | TTT Phe | TCT Ser | TAT Tyr  | TGT Cys  | T\n" midlines
    .gen_code.t insert end "F  T | TTC Phe | TCC Ser | TAC Tyr  | TGC Cys  | C  T\n" midlines
    .gen_code.t insert end "i  T | TTA Leu | TCA Ser | TAA Stop | TGA Stop | A  h\n" midlines
    .gen_code.t insert end "r  T | TTG Leu | TCG Ser | TAG Stop | TGG Trp  | G  i\n" midlines
    .gen_code.t insert end "s    +---------+---------+----------+----------+--- r\n" midlines

    .gen_code.t insert end "t  C | CTT Leu | CCT Pro | CAT His  | CGT Arg  | T  d\n" midlines
    .gen_code.t insert end "   C | CTC Leu | CCC Pro | CAC His  | CGC Arg  | C   \n" midlines
    .gen_code.t insert end "P  C | CTA Leu | CCA Pro | CAA Gln  | CGA Arg  | A  P\n" midlines
    .gen_code.t insert end "o  C | CTG Leu | CCG Pro | CAG Gln  | CGG Arg  | G  o\n" midlines
    .gen_code.t insert end "s    +---------+---------+----------+----------+--- s\n" midlines

    .gen_code.t insert end "i  A | ATT Ile | ACT Thr | AAT Asn  | AGT Ser  | T  i\n" midlines
    .gen_code.t insert end "t  A | ATC Ile | ACC Thr | AAC Asn  | AGC Ser  | C  t\n" midlines
    .gen_code.t insert end "i  A | ATA Ile | ACA Thr | AAA Lys  | AGA Arg  | A  i\n" midlines
    .gen_code.t insert end "o  A | ATG Met | ACG Thr | AAG Lys  | AGG Arg  | G  o\n" midlines
    .gen_code.t insert end "n    +---------+---------+----------+----------+--- n\n" midlines

    .gen_code.t insert end "   G | GTT Val | GCT Ala | GAT Asp  | GGT Gly  | T   \n" midlines
    .gen_code.t insert end "   G | GTC Val | GCC Ala | GAC Asp  | GGC Gly  | C   \n" midlines
    .gen_code.t insert end "   G | GTA Val | GCA Ala | GAA Glu  | GGA Gly  | A   \n" midlines
    .gen_code.t insert end "   G | GTG Val | GCG Ala | GAG Glu  | GGG Gly  | G   \n" midlines

    .gen_code.t insert end "\nTAA=Ochre, TAG=Amber, TGA=Opal"

    .gen_code.t tag configure topline -font dnafont -tabs {5c center}
    .gen_code.t tag configure midlines -font dnafont -tabs {1c 2c center 3c 4c center 5c 6c center 7c 8c center 9c 10c}

    .gen_code.t configure -state disabled

    #wm resizable .gen_code 0 0
    bind .gen_code <Key-Return> ".gen_code.f3.ok invoke"
    update idletasks
    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .gen_code] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .gen_code "+$winx+$winy"
  }
}

###########
##AA Info help window
###########
proc aa_info_dialog {w} {
  global info

  if {[winfo exists .aa_data]} {
    wm deiconify .aa_data
    raise .aa_data
  } else {
    set aa_names [list Glycine Alanine Serine Threonine Cysteine Valine Leucine Isoleucine Methionine Proline Phenylalanine Tyrosine Tryptophan "Aspartic Acid" "Glutamic Acid" Asparagine Glutamine Histidine Lysine Arginine]
    set aa_3let [list Gly Ala Ser Thr Cys Val Leu Ile Met Pro Phe Tyr Trp Asp Glu Asn Gln His Lys Arg]
    set aa_1let [list G A S T C V L I M P F Y W D E N Q H K R]
    set aa_MW [list 57.05 71.09 87.08 101.11 103.15 99.14 113.16 113.16 131.19 97.12 147.18 163.18 186.21 115.09 129.12 114.11 128.14 137.14 128.17 156.19]

   #read in gif images if available. If not, make blank images
    if {[lsearch [image names] Glycine_image] == -1} {
      set dirname [file join $info(Accdir) "Icons and images" "Amino Acids"]
      foreach aa $aa_names {
        set filename [file join $dirname "$aa.gif"]
        if {[file exists $filename] == 1} {
          image create photo "$aa\_image" -file $filename
        } else {
          image create photo "$aa\_image" -height 1 -width 1
        }
      }
    }
    toplevel .aa_data 
    wm title .aa_data [mc "Amino Acids Data..."]
    wm protocol .aa_data WM_DELETE_WINDOW ".aa_data.f3.ok invoke"
    regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
    wm geometry .aa_data "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"

    grid [canvas .aa_data.c -bg wheat -bd 0 -highlightthickness 0 -width 200 -height 300 -yscrollcommand ".aa_data.ys set" ] -row 1 -column 0  -sticky nswe
    grid [scrollbar .aa_data.ys -command ".aa_data.c yview"] -row 1 -column 1 -rowspan 1 -sticky nsw

    grid [frame .aa_data.f3 -relief flat -bg wheat -bd 0] -row 2 -column 0 -columnspan 2 -sticky nswe
    grid [button .aa_data.f3.ok -bg {light steel blue} -command "destroy .aa_data" -text "OK"] -row 0 -column 0 -sticky nswe

    grid rowconfigure .aa_data 1 -weight 1
    grid columnconfigure .aa_data 0 -weight 1

    set y 10
    foreach aa $aa_names 3let $aa_3let 1let $aa_1let MW $aa_MW {
    set img [.aa_data.c create image 10 $y -image "$aa\_image" -anchor nw]
    set imgy [lindex [.aa_data.c bbox $img] 3]
    set imgx [lindex [.aa_data.c bbox $img] 0]
    .aa_data.c create text $imgx $imgy -text "$aa ($3let, $1let)\nMW: $MW" -anchor nw -font "Helvetica 10 bold" 
    set y [expr {$imgy+50}]
    }

    .aa_data.c configure -scrollregion [.aa_data.c bbox all]
    bindtags .aa_data.c .aa_data.c
    bind .aa_data.c <MouseWheel> {.aa_data.c yview scroll [expr {int(1.0 * %D / $info(mousewheelunits)) * -4}] units}
    bind .aa_data <MouseWheel> {.aa_data.c yview scroll [expr {int(1.0 * %D / $info(mousewheelunits)) * -4}] units}

   # wm resizable .aa_data 0 1
    bind .aa_data <Key-Return> ".aa_data.f3.ok invoke"
    update idletasks
    regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .aa_data] wgeom winw winh winx winy
    if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
    if {$winx < 0} {set winx 0}
    if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
    if {$winy < 0} {set winy 0}
    wm geometry .aa_data "+$winx+$winy"
    wm deiconify .aa_data
  }
}

#################
## initialize special bindings 
#################
proc setup_special_bindings {} {
  global modifier modstring info tcl_platform

  if {$tcl_platform(platform) == "windows"} {
    set modifier Control
    set modstring "Ctrl"
    if {($tcl_platform(os) == "Windows NT") && ($tcl_platform(osVersion) == "6.1")} {
      # Windows 7 has mousewheel delta of 30
      set info(mousewheelunits) 30
    }
  } elseif {$tcl_platform(platform) == "unix"} {
      set modstring "Meta"
      set modifier Meta
      if {$tcl_platform(os) == "Linux"} {
        set modifier Control
        set modstring "Ctrl"
      }
      if {[tk windowingsystem] == "aqua"} {
        set modifier "Command"
        set modstring "Cmd"
        set info(mousewheelunits) 4
        if {[string is integer [regexp -inline {[0-9]*} $tcl_platform(osVersion)]] && ([regexp -inline {[0-9]*} $tcl_platform(osVersion)] > 11)} {
          set info(mousewheelunits) 1
        }
        bind Listbox <Command-Button-1> [bind Listbox <Control-Button-1>]
        bind Text <Control-Button-1> "event generate %W <Button-2> -rootx %X -rooty %Y -x %x -y %y"
        bind AnalysisText <Control-Button-1> "event generate %W <Button-2> -rootx %X -rooty %Y -x %x -y %y"
        bind Entry <Button-2> ""
        bind Treeview <Command-Button-1> [bind Treeview <Control-Button-1>]
        set ttk::Cursors(hresize) resizeleftright
        set ttk::Cursors(vresize) resizeupdown
      }
      bind Entry <$modifier-Key-v> "event generate %W <<Paste>>"
      bind Text <$modifier-Key-v> "event generate %W <<Paste>>"
      #bind Text <Button-5> [list %W yview scroll 1 units]
      #bind Text <Button-4> [list %W yview scroll -1 units]
      bind all <Button-4> {event generate [focus -displayof %W] <MouseWheel> -delta  120}
      bind all <Button-5>  {event generate [focus -displayof %W] <MouseWheel> -delta -120}
  } else {
      set modifier Control
      set modstring "Ctrl"
      #sputs "tcl_platform(os):$tcl_platform(os)"
      #sputs "tcl_platform(machine):$tcl_platform(machine)"
  }


  bind Entry <$modifier-Key-V> "event generate %W <<Paste>>"
  bind Entry <$modifier-Key-a> "%W selection range 0 end"
  bind Entry <<Paste>> {
    global tcl_platform
    catch {
	    catch {
		%W delete sel.first sel.last
	    }
	%W insert insert [regsub -all {\n} [::tk::GetSelection %W CLIPBOARD] ""]
	tk::EntrySeeInsert %W
    }
  }

  bind . <$modifier-Key-q> "exit"
  bind . <$modifier-Key-o> open_file_dialog
  bind . <$modifier-Key-n> create_window


  #set default binding for Button-Mouse wheel events for all text boxes
  if {[tk windowingsystem] != "aqua"} {
    bind Text <B1-MouseWheel> "[bind Text <MouseWheel>]
      [bind Text <Shift-Button-1>]"
  } else {
    bind Text <B1-MouseWheel> [bind Text <MouseWheel>]
  }

  #setup AnalysisText bindigs
  bind AnalysisText <$modifier-Key-a> "%W tag add sel 1.0 end"
  bind AnalysisText <Double-Button-1> "%W tag add sel @%x,%y"
  foreach action [list <B1-MouseWheel> <MouseWheel> <<Copy>> <B1-Motion> <Button-1> <B1-Leave> <B1-Enter> <Shift-Button-1> <ButtonRelease-1> <Key-Next> <Key-Prior> <$modifier-Key-Home>  <$modifier-Key-End>] {
    bind AnalysisText $action [bind Text $action]
  }

  #eliminate scan-dragging in listboxes, so item drag and drop can work
  # could do it with Button-1 looking for selection- if button-1 event happens on selected element, don't change selection- wait for button-up or Button-Motion, button up does select only that element, motion moves the elements.
  bind Listbox <B1-Motion> {}
  #take the ListboxMotion out so that there is no selection scannig on button-1-leave
  proc tk::ListboxAutoScan {w} {
    variable ::tk::Priv
    if {![winfo exists $w]} return
    set x $Priv(x)
    set y $Priv(y)
    if {$y >= [winfo height $w]} {
	$w yview scroll 1 units
    } elseif {$y < 0} {
	$w yview scroll -1 units
    } elseif {$x >= [winfo width $w]} {
	$w xview scroll 2 units
    } elseif {$x < 0} {
	$w xview scroll -2 units
    } else {
	return
    }
    #ListboxMotion $w [$w index @$x,$y]
    set Priv(afterId) [after 50 [list tk::ListboxAutoScan $w]]
  }
  ttk::style configure Heading -font {Helvetica 11 bold} -foreground gray40
  ttk::style configure Treeview -rowheight 15

}
#################
## if a process is already running, pass off to it (only on windows so far)
#################
proc check_for_running_process {} {
  global argv tcl_platform

  ##if on windows, check for running version and pass the file off, else register dde to catch new instances
  if {$tcl_platform(platform) == "windows"} {
    package require dde 1.1
    if {[dde services TclEval readDNAfiles] != ""} {
      if {[llength $argv] == 0} {
        dde execute TclEval readDNAfiles "create_window"
      } else {
        dde execute TclEval readDNAfiles "uplevel #0 \{open_file \{[lindex $argv 0]\}\}"
      }
      final_exit
    } else {
      dde servername "readDNAfiles"
    }
  } elseif {($tcl_platform(platform) == "unix") && ([tk windowingsystem] != "aqua")} {
sputs checking for running process
    if {[set aname [tk appname "dna_ape"]] != "dna_ape"} {
sputs I'm #2 appname: $aname
      if {[llength $argv] == 0} {
        sputs send1 [send dna_ape "create_window"]
      } else {
        sputs send2 [send dna_ape "uplevel #0 \{open_file \{[lindex $argv 0]\}\}"]
      }
      final_exit
    } else {
sputs I'm #1
    }
  }
}

#################
##returns a 3 byte hex number (24 bits), each base has 4 bits a=0111, c=1011, g=1101, t=1110 , n=0000
#################
proc validation_code {p} {
  set p [string map {" " "" ^ "" ( "" - "" ) "" / ""} $p]
  regsub -all {([0-9])*} $p "" p
  set p [string trim $p "N"] 
  if {[string length $p] < 7} {
    if {$p eq [revcom $p]} {
      return [list [expr {"0x[string map "A 7 B 8 C b D 4 G d H 2 K c M 3 N 0 R 5 S 9 T e V 1 W 6 Y a" [string range [append p "NNNNN"] 0 5]]"}]]
    } else {
      set q [revcom $p]
      set fwd [expr {"0x[string map "A 7 B 8 C b D 4 G d H 2 K c M 3 N 0 R 5 S 9 T e V 1 W 6 Y a" [string range [append p "NNNNN"] 0 5]]"}]
      set rev [expr {"0x[string map "A 7 B 8 C b D 4 G d H 2 K c M 3 N 0 R 5 S 9 T e V 1 W 6 Y a" [string range [append q "NNNNN"] 0 5]]"}]
      return [list $fwd $rev]
    }
  } else {
    return {}
  }
}

#################
##adds compatible enzymes to a list at enzinfo(compat,$enzyme)
#################
proc add_compatibles {} {
  global enzymes
  global enzinfo

  foreach enzyme $enzymes {
    set enzinfo(compat,$enzyme) ""
    set len [string length $enzinfo(flatpat,$enzyme)]
    set caret [string first ^ $enzinfo(enz_pattern,$enzyme)]
    if {($caret != -1) && ([set oh [expr {$len/2.0-$caret}]] != 0)} {
      if {$oh > 0} {
        set overhang [string range $enzinfo(flatpat,$enzyme) $caret [expr {$len-$caret-1}]]
        if {([regexp {[^ACGT]} $overhang] == 0)} {
          lappend h(+$overhang) $enzyme
        }
      } else {
        set overhang [string range $enzinfo(flatpat,$enzyme) [expr {$len-$caret}] [expr {$caret-1}]]
        if {([regexp {[^ACGT]} $overhang] == 0)} {
          lappend h(-$overhang) $enzyme 
        }  
      }
    } 
  }

  foreach ov [array names h] {
    if {[llength $h($ov)] > 1} {
      set i 0
      foreach enz $h($ov) {
        #sputs "$enz:[lreplace $h($ov) $i $i]"
        set enzinfo(compat,$enz) [lreplace $h($ov) $i $i]
        incr i
      }
    }
  }
}

#############
## return all aa encoded by a potentially degenerate 3 base sequence
#############
proc triplet_transl {t} {
  set s [string map {b [cgt] d [agt] h [act] k [gt] m [ac] n ? r [ag] s [gc] v [acg] w [at] y [ct]} $t] 
  array set aa {ttt F ttc F tta L ttg L tct S tcc S tca S tcg S tat Y tac Y taa * tag * tgt C tgc C tga * tgg W ctt L ctc L cta L ctg L cct P ccc P cca P ccg P cat H cac H caa Q cag Q cgt R cgc R cga R cgg R att I atc I ata I atg M act T acc T aca T acg T aat N aac N aaa K aag K agt S agc S aga R agg R gtt V gtc V gta V gtg V gct A gcc A gca A gcg A gat D gac D gaa E gag E ggt G ggc G gga G ggg G}
  set result [list]
  foreach i [array names aa $s] {
    lappend result $aa($i)
  }
  set result [lsort -unique $result]
  if {[llength $result] < 21} {
    return "\[[join $result ""]\]"
  } else {
    return .
  }
}

#############
## return all possible peptides encoded in all three frames of a sequence
#############
proc degen_transl {p} {
  set p [string tolower $p]
  regsub -all -- {[^abcdghkmnrstvwy]} $p {} p
  set p "nn$p"
  append p "nn"
  set r [list]
  for {set i 0} {$i < 3} {incr i} {
    set k ""
    for {set j $i} {$j < [expr [string length $p]-2]} {incr j 3} {
      append k "[triplet_transl [string range $p $j [expr $j+2]]]"
    }
  lappend r $k
  }
return $r
}

#############
## read the enzymes file
#############
proc read_enzymes {enzfilename} {
  global longnamelist
  global hexlist
  global enzymes
  global enzinfo
  global info

  set error 0
  if {($enzfilename == "") || ([file exists $enzfilename] == 0)} {
    warning_dialog "Can't find the enzymes file"
    set error 1
  } else {
    set fileid [open $enzfilename r]
    set header [gets $fileid]
    if {$header == "tkDNAview enzymes file type 2"} {
      array unset enzinfo
      set enzinfo(enz_groups_list) {All {Mem Recall} {Difference...}}
      set enzinfo(enz_groups,All) [list]
      set enzinfo(enz_groups,Mem\ Recall) [list]
      set enzinfo(enz_groups,Difference...) "Difference..."

      set templongnamelist [gets $fileid]
      set longnamelist [list]
      foreach e $templongnamelist {
        if {[string first | [lindex $e 1]] > -1} {
          lappend longnamelist [list [lindex $e 0] {*}[split [lindex $e 1] |]]
        } else {
          lappend longnamelist [list [lindex $e 0] [lindex $e 1] {}]
        }
      }
      set hexlist [gets $fileid]
      set enzymes [gets $fileid]
      set pats [gets $fileid]
      set enzcomments [gets $fileid]

      set enzinfo(enz_groups_list) {All {Mem Recall} {Difference...}}
      set enzinfo(enz_groups,All) $enzymes
      set enzinfo(enz_groups,Mem\ Recall) [list]
      set enzinfo(enz_groups,Difference...) "Difference..."
      set newgroups [gets $fileid]
      set enzinfo(enz_groups_list) [concat $enzinfo(enz_groups_list) $newgroups]
      foreach group $newgroups {
        set enzinfo(enz_groups,$group) [gets $fileid] 
      }
      unset newgroups

      #read list of Dam and Dcm blocked enzymes
      set enzinfo(enz_methylaselist) [gets $fileid]

      #make list of all enzymes blocked by any methylase
      set info(blocked_enzymes) [list]
      foreach methylase $enzinfo(enz_methylaselist) {
        foreach blocked_enzyme [lindex $methylase 1] {
          lappend info(blocked_enzymes) [lindex $blocked_enzyme 0]
        }
      }
      #add DpnI specifically
      foreach z [list BisI BlsI GlaI GluI KroI MalI PcsI DpnI SgeI FspEI LpnPI MspJI] {
        if {[lsearch -exact $enzymes $z] > -1} {
          lappend info(blocked_enzymes) $z
        }
      }

      set info(blocked_enzymes) [lsort -unique $info(blocked_enzymes)]

      set info(enz_currently_selected) [list]

      foreach enzyme $enzymes pattern $pats comment $enzcomments {
        set pattern [string toupper $pattern]
        set enzinfo(enz_vcode,$enzyme) [validation_code $pattern]
        set enzinfo(enz_pattern,$enzyme) $pattern
        set enzinfo(enz_comment,$enzyme) $comment
        regsub -all {[^ACGTNWSYRKMBDHV]} $pattern "" flatpattern
        set flatpattern [string trim $flatpattern "N"]
        set enzinfo(flatpat,$enzyme) $flatpattern

        if {[regexp {(-?[0-9]+)[[:space:]]*.[[:space:]]*(-?[0-9]+)} $pattern x d1 d2]} {
          set enzinfo(enz_cut_sites,$enzyme) [list [expr {[string length $flatpattern]+$d1}] [expr {[string length $flatpattern]+$d2}]]
        } elseif {[regexp -all {[|^/\\]} $pattern] > 0} {
          if {[revcom $flatpattern] == $flatpattern} {
            set char [lindex [lindex [regexp -inline -indices {[|^/\\]} $pattern] 0] 0]
            set enzinfo(enz_cut_sites,$enzyme) [list $char [expr {[string length $flatpattern]-$char}]]
          } else {
            set bottom [lindex [lindex [regexp -inline -indices {[_/\\]} $pattern] 0] 0]
            set top [lindex [lindex [regexp -inline -indices {[^|]} $pattern] 0] 0]
            set enzinfo(enz_cut_sites,$enzyme) [list 0 0]
            sputs read_enzymes $pattern $enzinfo(enz_cut_sites,$enzyme)
          }
        } else {
          set enzinfo(enz_cut_sites,$enzyme) [list 0 0]
          sputs read_enzymes $pattern $enzinfo(enz_cut_sites,$enzyme)
        }

      }
      add_compatibles
      set enzinfo(enz_vcode,MDam) [validation_code GATC]
      set enzinfo(enz_vcode,MDcm) [validation_code CCWGG]
      set enzinfo(flatpat,MDam) "GATC"
      set enzinfo(flatpat,MDcm) "CCWGG"
      set info(enzymes_saved) 1
    } else {
      tk_messageBox -message "Wrong enzyme file type- no enzymes read" -type ok -icon warning -default ok
      set error 1
    }
    close $fileid
  }
  return $error
}

#############
## reload the enzymes file
#############
proc reload_enzymes {} {
  global enz_select_window
  global info
  global enz_select_window

  if {$info(enzymes_saved) != 1} {
    if {[tk_messageBox -message "Do you want to save changes to the enzyme set?" -type yesno -icon question] == "yes"} {
      save_enzymes "" 0
    }
  }
    if {[file isdir $info(default_enzymedir)]} {
      set filename [tk_getOpenFile -initialdir $info(default_enzymedir) -title [mc "Open An Enzyme File"] -defaultextension ".txt"]
    } else {
      set filename [tk_getOpenFile -title "Open An Enzyme File" -defaultextension ".txt"]
    }

  if {($filename != "") && ([file exists $filename] == 1)} {
    set error [read_enzymes $filename]
    if {($error == 0)} {
      foreach window $info(dnawindows_list) {
        set info($window,scanned) 0
        findenzymes $window
      }

      if {[winfo exists .enz_selector.textframe.textbox] == 1} {
        fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window
        wm deiconify .enz_selector
      }
    }
  }
}

#############
## save a copy of the enzymes file
#############
proc save_enzymes {{filename ""} {default 0}} {
  global longnamelist
  global hexlist
  global enzymes
  global enzinfo
  global info

  if {[winfo exists .enz_selector]} {
    set parent_win .enz_selector
  } else {
    set parent_win .
  }

  if {$default} {set filename [file join $info(default_enzymedir) Default_Enzymes.txt]}
  if {($filename == "")} {
    if {[file isdir $info(default_enzymedir)]} {
      set filename [tk_getSaveFile -title [mc "Save Enzymes File"] -parent $parent_win -initialdir $info(default_enzymedir) -defaultextension ".txt"]
    } else {
      set filename [tk_getSaveFile -title [mc "Save Enzymes File"] -parent $parent_win -defaultextension ".txt"]
    }
  }
  while {($filename != "") && ([catch {set fileid [open $filename w]}])} {
    catch {close $fileid}
    warning_dialog "$filename\nFile isn't writable"
    if {[file isdir $info(default_enzymedir)]} {
      set filename [tk_getSaveFile -title [mc "Save Enzymes File"] -parent $parent_win -initialdir $info(default_enzymedir) -defaultextension ".txt"]
    } else {
      set filename [tk_getSaveFile -title [mc "Save Enzymes File"] -parent $parent_win -defaultextension ".txt"]
    }

  }

  if {$filename == ""} return

  puts $fileid "tkDNAview enzymes file type 2"
  set templongnamelist [list]
  foreach e $longnamelist {
    foreach {na pf pr} $e {}
    if {$pr != {}} {
      lappend templongnamelist [list $na "$pf|$pr"]
    } else {
      lappend templongnamelist [list $na $pf]
    } 
  }
  puts $fileid $templongnamelist 
  puts $fileid $hexlist
  puts $fileid $enzymes

  foreach enzyme $enzymes {
    lappend pats $enzinfo(enz_pattern,$enzyme)
    lappend enzcomments $enzinfo(enz_comment,$enzyme)
  }
  puts $fileid $pats
  puts $fileid $enzcomments

  set groupslist [list]
  foreach group $enzinfo(enz_groups_list) {
    if {($group != "All") && ($group != "Mem Recall") && ($group != "Difference...")} {
      lappend groupslist $group
    }
  }
  puts $fileid $groupslist
  foreach group $groupslist {
    puts $fileid $enzinfo(enz_groups,$group)
      }

  puts $fileid $enzinfo(enz_methylaselist)
  close $fileid
  set info(enzymes_saved) 1
}

#################
##return the hexlist address for a pattern
#################
proc hexmult {pattern} {
set n [list 0]
foreach c [split $pattern ""] {
  set newlist [list]
  switch $c {
    "A" {foreach m $n {set newlist [concat $newlist [expr $m*4]]}}
    "B" {foreach m $n {set newlist [concat $newlist  [expr $m*4+1] [expr $m*4+2] [expr $m*4+3]]}}
    "C" {foreach m $n {set newlist [concat $newlist  [expr $m*4+1]]}}
    "D" {foreach m $n {set newlist [concat $newlist [expr $m*4]  [expr $m*4+2] [expr $m*4+3]]}}
    "G" {foreach m $n {set newlist [concat $newlist  [expr $m*4+2]]}}
    "H" {foreach m $n {set newlist [concat $newlist [expr $m*4] [expr $m*4+1] [expr $m*4+3]]}}
    "K" {foreach m $n {set newlist [concat $newlist  [expr $m*4+2] [expr $m*4+3]]}}
    "M" {foreach m $n {set newlist [concat $newlist [expr $m*4] [expr $m*4+1]] }}
    "N" {foreach m $n {set newlist [concat $newlist [expr $m*4] [expr $m*4+1] [expr $m*4+2] [expr $m*4+3]]}}
    "R" {foreach m $n {set newlist [concat $newlist [expr $m*4]  [expr $m*4+2]]}}
    "S" {foreach m $n {set newlist [concat $newlist [expr $m*4+1]  [expr $m*4+2]]}}
    "T" {foreach m $n {set newlist [concat $newlist [expr $m*4+3]]}}
    "V" {foreach m $n {set newlist [concat $newlist [expr $m*4] [expr $m*4+1] [expr $m*4+2]]}}
    "W" {foreach m $n {set newlist [concat $newlist [expr $m*4] [expr $m*4+3]]}}
    "Y" {foreach m $n {set newlist [concat $newlist [expr $m*4+1] [expr $m*4+3]]}}
   }
  set n $newlist
}
return $n
}

#################
##return a pattern with degenerate code substituted with regexp equivalents
#################
proc regsubpattern {pattern} {
  regsub -all " " $pattern "" pattern
  regsub -all {[\,\;\|]} $pattern "|" pattern
  return [string map {b [cgtbsky] d [agdtkrw] h [acthryw] k [gtk] m [acm] n . r [agr] s [cgs] v [acgvmrs] w [atw] y [cty] B [CGTBSKY] D [AGDTKRW] H [ACTHRYW] K [GTK] M [ACM] N . R [AGR] S [CGS] V [ACGVMRS] W [ATW] Y [CTY]} $pattern]
}

#################
##proc K returns a variable and allows it to be deleted at the same time
##by calling "[K $var [set var ""]]
#################
proc K { x y } { set x }


#################
##add a pattern to either the longnamelist or hexlist
#################
proc addhexarray {name pattern} {
  global longnamelist
  global hexlist


  regsub -all {\(([0-9]|[/-])*\)} $pattern "" spattern
  regsub "\\^" $spattern "" spattern
  set spattern [string trim $spattern "N"] 
  set rpattern [revcom $spattern]
  if {[string length $spattern] >6} {
    if {$rpattern == $spattern} {
      lappend longnamelist [list $name [regsubpattern $spattern] {}]
    } else {
      ###other option is to add the enzyme twice, same name both patterns
      lappend longnamelist [list $name [regsubpattern $spattern] [regsubpattern $rpattern]]
    }
  } else {
    if {$rpattern == $spattern} {
      set spattern [string range [join "$spattern NNNNN" ""] 0 5]
      set patternlist [hexmult $spattern]
    } else {
      set spattern [string range [join "$spattern NNNNN" ""] 0 5]
      set rpattern [string range [join "$rpattern NNNNN" ""] 0 5]
      set patternlist [concat [hexmult $spattern] [hexmult $rpattern]]
    }
    foreach location $patternlist {
      set newlist [concat [lindex $hexlist $location] [list $name]]
      set hexlist [lreplace [K $hexlist [set hexlist {}]] $location $location $newlist]
    }
  }
}

###############
## delete an enzyme
###############
proc delete_enzyme {enzyme} {
  proc K { x y } { set x }
  global longnamelist
  global hexlist
  global enzymes
  global enzinfo
  global info
  global enz_select_window

  set listpos [lsearch -exact $enzymes $enzyme]
  if {$listpos == -1} {return}

  ##take the enzyme out of the enzyme list
  set enzymes [lreplace [K $enzymes [set enzymes {}]] $listpos $listpos]

  
  ##take the enzyme out of the currently selected list
  set info(enz_currently_selected) [lsearch -exact -not -inline -all $info(enz_currently_selected) $enzyme]

  ##take the enzyme out of the longname list or hexlist
  set spattern $enzinfo(flatpat,$enzyme)
  if {[string length $spattern] >6} {
    set longlistpos [lsearch -glob $longnamelist "$enzyme *"]
    set longnamelist [lreplace [K $longnamelist [set longnamelist {}]] $longlistpos $longlistpos]
  } else {
    set rpattern [revcom $spattern]
    if {$rpattern == $spattern} {
      set spattern [string range [join "$spattern NNNNN" ""] 0 5]
      set patternlist [hexmult $spattern]
    } else {
      set spattern [string range [join "$spattern NNNNN" ""] 0 5]
      set rpattern [string range [join "$rpattern NNNNN" ""] 0 5]
      set patternlist [concat [hexmult $spattern] [hexmult $rpattern]]
    }
    foreach location $patternlist {
      set newlist [lindex $hexlist $location]
      set pos [lsearch -exact $newlist $enzyme]
      set newlist [lreplace [K $newlist [set newlist {}]] $pos $pos]
      set hexlist [lreplace [K $hexlist [set hexlist {}]] $location $location $newlist] 
    }
  }

  ##take the enzyme out of the info and enzinfo arrays
  #array unset enzinfo "enz_vcode,$enzyme"
  #array unset enzinfo "enz_pattern,$enzyme"
  #array unset enzinfo "enz_comment,$enzyme"
  #array unset enzinfo "flatpat,$enzyme"
  foreach element [array names enzinfo "*,$enzyme"] {
    array unset enzinfo $element
  }
  foreach element [array names info "*,$enzyme"] {
    array unset info $element
  }

  ##take the enzyme out of the groups list
  foreach group $enzinfo(enz_groups_list) {
    set pos [lsearch -exact $enzinfo(enz_groups,$group) $enzyme]
    if {$pos > -1} {
      set enzinfo(enz_groups,$group) [lreplace [K $enzinfo(enz_groups,$group) [set enzinfo(enz_groups,$group) {}]] $pos $pos]
    }
  }

  ##take the enzyme out of the metlist
  set newmetlists [list]
  foreach metlist $enzinfo(enz_methylaselist) {
    set tempmetlist1 [list]   
    foreach enz_met_set [lindex $metlist 1] {
      if {[lindex $enz_met_set 0] != $enzyme} {
        lappend  tempmetlist1 $enz_met_set
      }
    }
    lappend newmetlists [list [lindex $metlist 0]  $tempmetlist1]
  }
  set enzinfo(enz_methylaselist) $newmetlists
  set info(blocked_enzymes) [list]
  foreach methylase $enzinfo(enz_methylaselist) {
    foreach blocked_enzyme [lindex $methylase 1] {
      lappend info(blocked_enzymes) [lindex $blocked_enzyme 0]
    }
  }
  #add DpnI specifically
  foreach z [list BisI BlsI GlaI GluI KroI MalI PcsI DpnI SgeI FspEI LpnPI MspJI] {
    if {[lsearch -exact $enzymes $z] > -1} {
      lappend info(blocked_enzymes) $z
    }
  }
  set info(blocked_enzymes) [lsort -unique $info(blocked_enzymes)]

  ##remake the compatibles elements 
  add_compatibles

  foreach window $info(dnawindows_list) {
    set info($window,scanned) 0
    findenzymes $window
  }

  if {[winfo exists .enz_selector.textframe.textbox] == 1} {
    .enz_selector.textframe.textbox tag delete $enzyme
    fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window
  }

}

#################
## return which groups pattern belogs to
#################
proc pattern_groups {pattern} {
  set result [list All]
  regsub  {^[^ABCDGHKMNRSTVWY]*?\)} $pattern "" pattern ;#remove leading parens
  set caret [string first ^ $pattern]
  if {$caret > -1} {
    set length [expr {[string length $pattern] -1.0}]    
    set site [expr {$caret * 2 - $length}]
    if {[regexp -nocase "\[bdhkmnrsvwy\]" [string range $pattern [expr {int($length/2 - abs($caret-$length/2))}] [expr {int($length/2 + abs($caret-$length/2))}]]] == 1} {lappend result "degenerate cut"}
  } else {
    if {[regexp {(.*)\(([\-0-9]*)/([\-0-9]*)} $pattern a pattern top bottom] == 1} {
      if {$top != $bottom} {lappend result "degenerate cut"}
      set site [expr {$top -$bottom} ]
    } else {
      set site nosite
      #sputs "Can't understand pattern: $pattern, no groups added."
    }
    set length [string length $pattern]
  }

  if {[string first N $pattern] > -1} {set length -1}
  if {[regexp -nocase "\[bdhkmnrsvwy\]" $pattern] == 1} {lappend result "degenerate"}
  if {$length == 4} {lappend result "four cutter"}
  if {$length  == 5} {lappend result "five cutter"}
  if {$length  == 6} {lappend result "six cutter"}
  if {$length  > 6} {lappend result ">six cutter"}

  if {$site != "nosite"} {  
    if {$site < 0} {
      lappend result "5 prime"
    } elseif {$site == 0} {
      lappend result "blunt"
    } else {
      lappend result "3 prime"
    }
  }

  return $result
}

#################
## dialog window for adding a new enzyme
#################
proc add_enzyme_dialog {parent_win} {
  global enzymes 
  global info
  global enz_select_window
  global edit_new_enz
  global ok2

  set edit_new_enz 1
  toplevel .new_enzyme
  wm protocol .new_enzyme WM_DELETE_WINDOW "set ok2 -1"
  bind .new_enzyme <KeyPress-Escape>  "set ok2 -1"
  wm title .new_enzyme [mc "New Enzyme"]
  set raisedialog_store [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify .new_enzyme; raise .new_enzyme"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $parent_win] wgeom winx winy
  wm geometry .new_enzyme "+[expr (($winx<0)?0:$winx)+20]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .new_enzyme $parent_win
  } else {
    ::tk::unsupported::MacWindowStyle style .new_enzyme document {closeBox}
  }
  wm deiconify .new_enzyme
  set ok2 0

  label .new_enzyme.namelabel -text [mc "Name:"]
  entry .new_enzyme.name
  label .new_enzyme.patternlabel -text [mc "Site:"]
  entry .new_enzyme.pattern
  label .new_enzyme.commentlabel -text [mc "Comment:"]
  entry .new_enzyme.comment
  grid columnconfigure .new_enzyme 1 -weight 1
  grid .new_enzyme.namelabel -row 0 -column 0 -sticky w
  grid .new_enzyme.name -row 0 -column 1 -sticky ew
  grid .new_enzyme.patternlabel -row 1 -column 0 -sticky w
  grid .new_enzyme.pattern -row 1 -column 1 -sticky ew
  grid .new_enzyme.commentlabel -row 2 -column 0 -sticky w
  grid .new_enzyme.comment -row 2 -column 1 -sticky ew
  grid [checkbutton .new_enzyme.edit_check -text [mc "Edit Groups and Methylation"] -variable edit_new_enz -selectcolor white] -row 3 -column 1 -columnspan 2 -sticky nw
  grid [frame .new_enzyme.okframe -relief ridge] -row 4 -column 0 -columnspan 2
  grid [button .new_enzyme.okframe.cancel -text [mc "Cancel"] -command "set ok2 -1"] -row 0 -column 1 -padx 12 -pady 3 -sticky nw
  grid [button .new_enzyme.okframe.ok -text [mc "OK"] -command "set ok2 1" -default active] -row 0 -column 0 -padx 12 -pady 3 -sticky nw
  bind .new_enzyme <Key-Return> ".new_enzyme.okframe.ok invoke"
  #grab set .new_enzyme
  wm deiconify .new_enzyme
  vwait ok2
 

  if {$ok2 == 1} {
    set enzyme [.new_enzyme.name get]
    set comment [.new_enzyme.comment get]
    set pattern [string toupper [.new_enzyme.pattern get]]
    regsub -all {\s} $pattern "" pattern
    if {[lsearch -exact $enzymes $enzyme] != -1} {
      tk_messageBox -message "An enzyme with that name already exists" -type ok -icon warning -default ok
    } elseif {($enzyme != "" ) && ([string length [.new_enzyme.pattern get]] > 3)} {
      if {$comment == ""} {
        set comment $pattern
      }
      add_enzyme $enzyme [string toupper $pattern] $comment

      if {($edit_new_enz == 1)} {
        edit_enzyme [.new_enzyme.name get] .new_enzyme
      }

      add_compatibles

      foreach window $info(dnawindows_list) {
        set info($window,scanned) 0
        findenzymes $window
      }

      if {[winfo exists .enz_selector.textframe.textbox] == 1} {
        fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window
      }
      set info(enzymes_saved) 0
    }
  }
  #grab release .new_enzyme
  destroy .new_enzyme
  bind . <<RaiseDialogs>> $raisedialog_store
  wm deiconify $parent_win
  return $ok2
}

###############
## add an enzyme 
###############
proc add_enzyme {enzyme pattern comment} {
  global enzymes
  global enzinfo
  global info


  ##add enzyme to the enzymes list
  set enzymes [lsort [lappend enzymes $enzyme]]
  set pattern [string toupper $pattern]

  ##add enzyme to the info array
  set enzinfo(enz_vcode,$enzyme) [validation_code $pattern]
  set enzinfo(enz_pattern,$enzyme) $pattern
  set enzinfo(enz_comment,$enzyme) $comment
  set p [string map {^ "" ( "" - "" ) "" / ""} $pattern]
  regsub -all {([0-9])*} $p "" p
  set p [string trim $p "N"] 
  set enzinfo(flatpat,$enzyme) $p
  set flatpattern $p
  if {[regexp {(-?[0-9]+)[[:space:]]*.[[:space:]]*(-?[0-9]+)} $pattern x d1 d2]} {
    set enzinfo(enz_cut_sites,$enzyme) [list [expr {[string length $flatpattern]+$d1}] [expr {[string length $flatpattern]+$d2}]]
  } elseif {[regexp -all {[|^/\\]} $pattern] > 0} {
    if {[revcom $flatpattern] == $flatpattern} {
      set char [lindex [lindex [regexp -inline -indices {[|^/\\]} $pattern] 0] 0]
      set enzinfo(enz_cut_sites,$enzyme) [list $char [expr {[string length $flatpattern]-$char}]]
    } else {
      set bottom [lindex [lindex [regexp -inline -indices {[_/\\]} $pattern] 0] 0]
      set top [lindex [lindex [regexp -inline -indices {[^|]} $pattern] 0] 0]
      set enzinfo(enz_cut_sites,$enzyme) [list 0 0]
      sputs read_enzymes $pattern $enzinfo(enz_cut_sites,$enzyme)
    }
  } else {
    set enzinfo(enz_cut_sites,$enzyme) [list 0 0]
    sputs read_enzymes $pattern $enzinfo(enz_cut_sites,$enzyme)
  }



  ##add enzyme to the longname list or hexlist
  addhexarray $enzyme $p

  ##add enzyme to the groups list
  set grouplist [pattern_groups $pattern]
  foreach group $grouplist {
    if {[array names enzinfo "enz_groups,$group"] != {}} {
      set enzinfo(enz_groups,$group) [lsort [lappend enzinfo(enz_groups,$group) $enzyme]]
    }
  }
}

###############
## edit an enzyme (comment, groups, methylation)
###############
proc edit_enzyme {enzyme parent_win} {
  global ok2
  global enzinfo
  global info
  global g
  global dam
  global dcm
  global new_comment
  global enz_select_window

  set maxcols 4
  toplevel .edit_enzyme 
  wm protocol .edit_enzyme WM_DELETE_WINDOW "set ok2 -1"
  bind .edit_enzyme <KeyPress-Escape>  "set ok2 -1"
  wm title .edit_enzyme "[mc "Edit enzyme:"] $enzyme"
  set raisedialog_store [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify .edit_enzyme; raise .edit_enzyme"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $parent_win] wgeom winx winy
  wm geometry .edit_enzyme "+[expr (($winx<0)?0:$winx)+20]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .edit_enzyme $parent_win
  } else {
    ::tk::unsupported::MacWindowStyle style .edit_enzyme document {closeBox}
  }
  wm deiconify .edit_enzyme
  set ok2 0

  grid [label .edit_enzyme.enzlabel -text "[mc Enzyme:] $enzyme"] -row 0 -column 0 -columnspan 2 -sticky nw
  grid [label .edit_enzyme.patlabel -text "[mc Site:] $enzinfo(enz_pattern,$enzyme)"] -row 1 -column 0 -columnspan 2 -sticky nw
  grid [label .edit_enzyme.comlabel -text "[mc Comment:]"] -row 2 -column 0 -sticky nw
  grid [entry .edit_enzyme.comentry -textvariable new_comment] -row 2 -column 1 -sticky nwe
  set new_comment $enzinfo(enz_comment,$enzyme)
  grid columnconfigure .edit_enzyme 1 -weight 1

  #groups frame
  grid [labelframe .edit_enzyme.groups -text Groups] -row 3 -column 0 -columnspan 2 -sticky nwe
  set r 0
  set c 0
  set gcb 0
  foreach group $enzinfo(enz_groups_list) {
    if {($group != "Mem Recall") && ($group != "All") && ($group != "Difference...")} {
      incr gcb
      grid [checkbutton .edit_enzyme.groups.cb$gcb -text $group -variable g($group) -selectcolor white] -row $r -column $c -sticky w
      set g($group) [expr {([lsearch $enzinfo(enz_groups,$group) $enzyme]>-1)}]
      incr c
      if {$c >= $maxcols} {
        set c 0
        incr r
      }
    }
  }

  #Dam/Dcm metylation frame
  grid [labelframe .edit_enzyme.met -text "[mc Methylation]"] -row 4 -column 0 -columnspan 2 -sticky nwe
  set r 0
  set pattern $enzinfo(enz_pattern,$enzyme)
  regsub -all {\(([0-9]|[/-])*\)} $pattern "" pattern
  regsub "\\^" $pattern "" pattern
  set pattern [string trim $pattern "N"]
  set pattern "NN[append pattern NN]"
  set metlist [list]
  set damlist [lindex [lindex $enzinfo(enz_methylaselist) 0] 1]
  set dcmlist [lindex [lindex $enzinfo(enz_methylaselist) 1] 1]
  if {[set found [regexp -all -inline -indices {(?:[GBDKNRSV][ADHMRVW][TBDHKNWY][CBHMNSVY])|(?:[GBDKNRSV][ADHMNRVW][TBDHKWY][CBHMNSVY])} $pattern]] != "" } {
    set metlist [list]
    foreach index $found {
      lappend metlist [lsort -integer [list [expr {[lindex $index 0]-2}] [expr {[string length $pattern]-[lindex $index 0]-6}]]]
    }
    set metlist [lsort -unique $metlist]
    #sputs $metlist
    grid [label .edit_enzyme.met.damlabel -text "[mc Potential] Dam(GATC) [mc Methylation]:"] -row $r -column 0 -columnspan 2 -sticky nw
    incr r
    foreach met $metlist {
      grid [checkbutton .edit_enzyme.met.m$r -variable dam($met) -selectcolor white] -row $r -column 0 -sticky nw
      if {[lsearch $damlist [list $enzyme [lindex $met 0] [lindex $met 1]]] > -1} {set dam($met) 1}
      grid [text .edit_enzyme.met.t$r -height 1 -relief flat -wrap none -background $info(bg_color)] -row $r -column 1 -sticky nw
      .edit_enzyme.met.t$r insert 1.0 $pattern
      .edit_enzyme.met.t$r tag add bold 1.[expr {[lindex $met 0]+2}] 1.[expr {[lindex $met 0]+6}] 1.[expr {[lindex $met 1]+2}] 1.[expr {[lindex $met 1]+6}]
      .edit_enzyme.met.t$r tag configure bold -background red 
      bindtags .edit_enzyme.met.t$r [list all .]
      incr r
    }

    
  }
  set pattern "N[append pattern N]"
  set metlist [list]
  if {[set found [regexp -inline -all -indices {(?:[CBHMNSVY][CBHMSVY][ATBDHKMNRVWY][GBDKNRSV][GBDKNRSV])|(?:[CBHMNSVY][CBHMNSVY][ATBDHKMNRVWY][GBDKRSV][GBDKNRSV])} $pattern]] != ""} {
    foreach index $found {
      lappend metlist [lsort -integer [list [expr {[lindex $index 0]-3}] [expr {[string length $pattern]-[lindex $index 0]-8}]]]
    }
    set metlist [lsort -unique $metlist]
    grid [label .edit_enzyme.met.dcmlabel -text "[mc Potential] Dcm(CCWGG) [mc Methylation]:"] -row $r -column 0 -columnspan 2 -sticky nw
    incr r
    foreach met $metlist {
      grid [checkbutton .edit_enzyme.met.m$r -variable dcm($met) -selectcolor white] -row $r -column 0 -sticky nw
      if {[lsearch $dcmlist  [list $enzyme [lindex $met 0] [lindex $met 1]]] >-1} {set dcm($met) 1}
      grid [text .edit_enzyme.met.t$r -height 1 -relief flat -wrap none -background $info(bg_color)] -row $r -column 1 -sticky nw
      .edit_enzyme.met.t$r insert 1.0 $pattern
      .edit_enzyme.met.t$r tag add bold 1.[expr {[lindex $met 0]+3}] 1.[expr {[lindex $met 0]+8}] 1.[expr {[lindex $met 1]+3}] 1.[expr {[lindex $met 1]+8}] 
      .edit_enzyme.met.t$r tag configure bold -background red 
      bindtags .edit_enzyme.met.t$r [list all .]
      incr r
    }
  }

  grid [button .edit_enzyme.cancel -text [mc "Cancel"] -command "set ok2 -1"] -row 5 -column 1 -sticky nw -padx 10 -pady 3
  grid [button .edit_enzyme.ok -text [mc "OK"] -command "set ok2 1" -default active] -row 5 -column 0 -sticky nw -padx 10 -pady 3
  bind .edit_enzyme <Key-Return> ".edit_enzyme.ok invoke"
  #grab set .edit_enzyme
  wm deiconify .edit_enzyme
  vwait ok2
 
  #grab release .edit_enzyme
  destroy .edit_enzyme
  bind . <<RaiseDialogs>> $raisedialog_store

##if ok button pressed, accept changes
  if {$ok2 == 1} {
    #change comment
    set enzinfo(enz_comment,$enzyme) $new_comment

    #change groups
    foreach group $enzinfo(enz_groups_list) {
      if {($group != "Mem Recall") && ($group != "All") && ($group != "Difference...")} {
        if {$g($group) == 1} {
          if {[lsearch -exact $enzinfo(enz_groups,$group) $enzyme] == -1} {
            lappend enzinfo(enz_groups,$group) $enzyme
          }
        } else {
          set pos [lsearch -exact $enzinfo(enz_groups,$group) $enzyme]
          if {$pos > -1} {
            set enzinfo(enz_groups,$group) [lreplace $enzinfo(enz_groups,$group) $pos $pos]
          }
        }
      }
    }

    #change methylation 
    foreach dam_index [array names dam] {
      set pos [lsearch $damlist [list $enzyme [lindex $dam_index 0] [lindex $dam_index 1]]]
      if {($dam($dam_index) == 0) && ($pos > -1)} {
        set damlist [lreplace $damlist $pos $pos]
      } elseif {($dam($dam_index) == 1) && ($pos == -1)} {
        lappend damlist [list $enzyme [lindex $dam_index 0] [lindex $dam_index 1]]
      }
    }
    set damlist [lsort -index 0 $damlist]
    foreach dcm_index [array names dcm] {
      set pos [lsearch $dcmlist [list $enzyme [lindex $dcm_index 0] [lindex $dcm_index 1]]]
      if {($dcm($dcm_index) == 0) && ($pos > -1)} {
        set dcmlist [lreplace $dcmlist $pos $pos]
      } elseif {($dcm($dcm_index) == 1) && ($pos == -1)} {
        lappend dcmlist [list $enzyme [lindex $dcm_index 0] [lindex $dcm_index 1]]
      }
    }
    set dcmlist [lsort -index 0 $dcmlist]
    set enzinfo(enz_methylaselist) [list [list MDam $damlist] [list MDcm $dcmlist]] 
    set info(blocked_enzymes) [list]
    foreach methylase $enzinfo(enz_methylaselist) {
      foreach blocked_enzyme [lindex $methylase 1] {
        lappend info(blocked_enzymes) [lindex $blocked_enzyme 0]
      }
    }
    #add DpnI specifically
    foreach z [list BisI BlsI GlaI GluI KroI MalI PcsI DpnI SgeI FspEI LpnPI MspJI] {
      if {[array names enzinfo "enz_pattern,$z"] != ""} {
        lappend info(blocked_enzymes) $z
      }
    }
    set info(blocked_enzymes) [lsort -unique $info(blocked_enzymes)]
    #rescan
    foreach window $info(dnawindows_list) {
      set info($window,scanned) 0
      findenzymes $window
    }
    #re-fill the selector box
    if {([winfo exists .enz_selector.textframe.textbox]) && ($parent_win == ".enz_selector")} {
      fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window
    }
  }

  array unset g
  array unset dam
  array unset dcm
  unset new_comment
  return $ok2
}

###############
## add an enzyme group
###############
proc add_enz_group {parent_win enzyme_list} {
  global enz_select_groups
  global info
  global enzinfo
  global ok2

  toplevel .new_group
  wm title .new_group [mc "New Enzyme Group..."]
  wm protocol .new_group WM_DELETE_WINDOW "set ok2 -1"
  bind .new_group <KeyPress-Escape>  "set ok2 -1"
  set raisedialog_store [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify .new_group; raise .new_group"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $parent_win] wgeom winx winy
  wm geometry .new_group "+[expr (($winx<0)?0:$winx)+20]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .new_group $parent_win
  } else {
    ::tk::unsupported::MacWindowStyle style .new_group document {closeBox}
  }
  set ok2 0

  label .new_group.namelabel -text [mc "Name:"]
  entry .new_group.name
  grid columnconfigure .new_group 1 -weight 1
  grid .new_group.namelabel -row 0 -column 0 -sticky w
  grid .new_group.name -row 0 -column 1 -sticky ew
 
  grid [button .new_group.cancel -text [mc "Cancel"] -command "set ok2 -1"] -row 3 -column 1 -sticky nw -padx 10 -pady 3
  grid [button .new_group.ok -text [mc "OK"] -command "set ok2 1" -default active] -row 3 -column 0 -sticky nw -padx 10 -pady 3
  bind .new_group <Key-Return> ".new_group.ok invoke"
  #grab set .new_group
  wm deiconify .new_group
  focus .new_group.name

  vwait ok2
  
  if {$ok2 == 1} {
    set newname [.new_group.name get]
    if {($newname == "All") || ($newname == "Mem Recall") || ($newname == "Difference...")} {
      tk_messageBox -default ok -title "Unmodifyable Group..." -message "The group \"$newname\" can't be modified." -type ok -icon warning -default ok
    } elseif {[lsearch -exact $enzinfo(enz_groups_list) $newname] > -1} {
      if {[tk_messageBox -default no -title "Group Exists..." -message "The group \"$newname\" already exists. Should I replace the contents of the group with the curently selected enzymes?" -type yesno -icon warning -default no] == "yes" } {
        set enzinfo(enz_groups,$newname) $enzyme_list
      }  
    } else {
      set enzinfo(enz_groups_list) [lappend enzinfo(enz_groups_list) $newname]
      set enzinfo(enz_groups,$newname) $enzyme_list
      if {[winfo exists .enz_selector.groupsframe.groups_button] == 1} {
        .enz_selector.groupsframe.groups_button.menu delete 0 end
        foreach element $enzinfo(enz_groups_list) {
          .enz_selector.groupsframe.groups_button.menu add radiobutton -label $element -variable enz_select_groups -value $element 
        }
      }
      set info(enzymes_saved) 0
    }
  }

  destroy .new_group
  unset ok2
  wm deiconify $parent_win
  bind . <<RaiseDialogs>> $raisedialog_store
} 

###############
## delete an enzyme group
###############
proc delete_enz_group {parent_win} {
  global enz_select_groups
  global info
  global enzinfo
  global ok2

  toplevel .dialog
  wm protocol .dialog WM_DELETE_WINDOW "set ok2 -1"
  bind .dialog <KeyPress-Escape>  "set ok2 -1"
  wm title .dialog [mc "Delete Enzyme Groups..."]
  set raisedialog_store [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $parent_win] wgeom winx winy
  wm geometry .dialog "+[expr (($winx<0)?0:$winx)+20]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $parent_win
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok2 0

  label .dialog.namelabel -text [mc "Groups:"]
  set h [llength $enzinfo(enz_groups_list)]
  if {$h > 10} {set h 10}
  listbox .dialog.grouplistbox -height $h -activestyle none -exportselection false -selectmode multiple -yscrollcommand ".dialog.groupscroll set"
  scrollbar .dialog.groupscroll -command ".dialog.grouplistbox yview"
  grid columnconfigure .dialog 0 -weight 1
  grid rowconfigure .dialog 1 -weight 1
  grid .dialog.namelabel -row 0 -column 0 -sticky w
  grid .dialog.grouplistbox -row 1 -column 0 -sticky nsew -columnspan 2
  grid .dialog.groupscroll -row 1 -column 2 -sticky nsw
 
  grid [button .dialog.cancel -text [mc "Cancel"] -command "set ok2 -1"] -row 2 -column 1 -sticky nw
  grid [button .dialog.ok -text [mc "Delete"] -command "set ok2 1"] -row 2 -column 0 -sticky nw

  foreach element $enzinfo(enz_groups_list) {
    if {($element != "All") && ($element != "Mem Recall") && ($element != "Difference...")} {
      .dialog.grouplistbox insert end $element 
    }
  }
  #grab set .dialog
  wm deiconify .dialog
  focus .dialog.grouplistbox

  vwait ok2
 
  #grab release .dialog
  
  if {$ok2 == 1} {
    set selection [.dialog.grouplistbox curselection]
    if {[llength $selection] > 0} {
      if {[llength $selection] > 1} {
        if {[tk_messageBox -default no -title [mc "Multiple Group Delete"] -message [format [mc {Are you sure you want to delete these %1$s groups?}] [llength $selection]]" -type yesno -icon warning -default no] == "yes" } {
          foreach element $selection {  
            set groupname [.dialog.grouplistbox get $element]
            set index [lsearch -exact $enzinfo(enz_groups_list) $groupname]
            array unset enzinfo "enz_groups,$groupname" 
            set enzinfo(enz_groups_list) [lreplace $enzinfo(enz_groups_list) $index $index]
          }
        }  
      } else {
        set groupname [.dialog.grouplistbox get [lindex $selection 0]]
        set index [lsearch -exact $enzinfo(enz_groups_list) $groupname]
        array unset enzinfo "enz_groups,$groupname" 
        set enzinfo(enz_groups_list) [lreplace $enzinfo(enz_groups_list) $index $index]
      }
      if {[winfo exists .enz_selector.groupsframe.groups_button]} {
        .enz_selector.groupsframe.groups_button.menu delete 0 end
        foreach element $enzinfo(enz_groups_list) {
          .enz_selector.groupsframe.groups_button.menu add radiobutton -label $element -variable enz_select_groups -value $element 
        }
      }
      set info(enzymes_saved) 0
    }
  }

  destroy .dialog
  unset ok2
  wm deiconify $parent_win
  bind . <<RaiseDialogs>> $raisedialog_store
} 

###############
## load enzyme groups from file
###############
proc read_enz_groups {parent_win {filename ""}} {
  global info enzinfo enzymes

  if {$filename == ""} {
    if {[file isdir $info(default_enzymedir)]} {
    set filename [tk_getOpenFile -title [mc "Open Group List File"] -initialdir $info(default_enzymedir) -parent $parent_win]
    } else {
    set filename [tk_getOpenFile -title [mc "Open Group List File"] -parent $parent_win]
    }

    wm deiconify $parent_win; raise $parent_win
  }
  if {[file exists $filename]} {
    set f [open $filename r]
    set error 0
    while {([gets $f nextline] !=-1) && (!$error)} {
      if {([llength $nextline] == 2)} {
        set newname [lindex $nextline 0]
        set enzyme_list [lindex $nextline 1]
        
        set not_found [list]
        set found [list]
        foreach enz $enzyme_list {
          if {[lsearch -exact $enzymes $enz] == -1} {
            lappend not_found $enz
          } else {
            lappend found $enz
          }
        }
        if {[llength $not_found]} {
          tk_messageBox -title "Enzymes Not Found..." -message "Group: $newname \nThe enzymes: $not_found\nare not currently in the set of known enzymes." -type ok -icon warning
        }
        if {($newname == "All") || ($newname == "Mem Recall") || ($newname == "Difference...")} {
          tk_messageBox -default ok -title "Unmodifyable Group..." -message "The group \"$newname\" can't be modified." -type ok -icon warning -default ok
        } elseif {[lsearch -exact $enzinfo(enz_groups_list) $newname] > -1} {
          if {[tk_messageBox -title "Group Exists..." -message "The group \"$newname\" already exists. Should I replace the contents of the group with the curently selected enzymes?" -type yesno -icon warning -default no] == "yes" } {
            set enzinfo(enz_groups,$newname) $found
          }  
        } else {
          set enzinfo(enz_groups_list) [lappend enzinfo(enz_groups_list) $newname]
          set enzinfo(enz_groups,$newname) $found
          set info(enzymes_saved) 0
        }
      } elseif {[regexp {[^[:space:]]} $nextline]} {
        set errorline $nextline
        set error 1
      }
    }
    if {(!$error)} {
      if {([winfo exists .enz_selector.groupsframe.groups_button])} {
        .enz_selector.groupsframe.groups_button.menu delete 0 end
        foreach element $enzinfo(enz_groups_list) {
          .enz_selector.groupsframe.groups_button.menu add radiobutton -label $element -variable enz_select_groups -value $element 
        }
      }
    } else {
      tk_messageBox -title "Bad Group File Format" -message "The file is improperly formatted starting at line:[string range $errorline 0 15]...\nThe file should contain a group name (with quotes if the name has spaces), a space, a brace {, a list of enzymes with spaces between, a brace }, a return. No tabs, no returns, except between groups.\nFor example: \n\"test group\" {EcoRI XbaI BamHI}\n\"test group2\" {SalI XmaI}" -type ok -icon warning
    }
  }
}

###############
## import enzymes from a DNA Strider format enzyme file
###############
proc import_strider_enzymes {parent_win {filename ""}} {
  global info
  global enzymes
  global enzinfo
  global enz_select_window

  set newenz [list]

  if {$filename == ""} {
    if {[file isdir $info(default_enzymedir)]} {
      set filename [tk_getOpenFile -title [mc "Open DNA Strider enzymes file"] -initialdir $info(default_enzymedir) -parent $parent_win]
    } else {
      set filename [tk_getOpenFile -title [mc "Open DNA Strider enzymes file"] -parent $parent_win]
    }
    wm deiconify $parent_win; raise $parent_win
  }
  if {[file exists $filename]} {
    set f [open $filename r]
    while {([gets $f nextline] !=-1) && ([string index $nextline 0] !="%")} {
      if {([string index $nextline 0]!= ";") && ([regexp  {([^,]*),([^,]*),(.*)} $nextline line enzyme pattern comment] == 1)} {
        set enzyme [string trimleft $enzyme "#"]
        set pattern [string toupper $pattern]
        set pattern [string trimleft $pattern " N"]
        set pattern [string map "/ ^" $pattern]
        if {[regexp  {([-0-9]*),([-0-9]*),(.*)} $comment fill top bottom comment]} {
          set pattern "$pattern\($top/$bottom\)"
        }
        set comment "$comment $pattern"
        if {[lsearch $enzymes $enzyme] == -1} {
          add_enzyme $enzyme $pattern $comment
          lappend newenz $enzyme
        }
       
      }
    }
    tk_messageBox -message "[llength $newenz] enzymes added." -type ok -icon info -default ok
    wm deiconify $parent_win; raise $parent_win
    if {[llength $newenz] > 0} {
      add_compatibles
      set enzinfo(enz_methylaselist) [met_list $enzymes $parent_win] 
      set info(blocked_enzymes) [list]
      foreach methylase $enzinfo(enz_methylaselist) {
        foreach blocked_enzyme [lindex $methylase 1] {
          lappend info(blocked_enzymes) [lindex $blocked_enzyme 0]
        }
      }
      #add DpnI specifically
      foreach z [list BisI BlsI GlaI GluI KroI MalI PcsI DpnI SgeI FspEI LpnPI MspJI] {
        if {[lsearch -exact $enzymes $z] > -1} {
          lappend info(blocked_enzymes) $z
        }
      }
      set info(blocked_enzymes) [lsort -unique $info(blocked_enzymes)]
      #rescan
      foreach window $info(dnawindows_list) {
        set info($window,scanned) 0
        findenzymes $window
      }
      #re-fill the selector box
      if {[winfo exists .enz_selector.textframe.textbox] == 1} {
        fill_enzymes_box .enz_selector.textframe.textbox .enz_selector.enz_comment $enz_select_window
      }
      set info(enzymes_saved) 0
    }
    close $f
  }
  return $newenz
}


#################
## take selection and list those that overlap methylation sites
#################
proc met_list {selectedenzymes parent_win} {
  global enzymes
  global info
  global enzinfo
  global ok2

  set damenz [list AccIII AlwI BcgI BclI Bsa29I BsaBI BscFI BscI BseAI BseCI Bsh1365I BsiBI BsiMI BsiQI BsiXI Bsp106I BspDI BspEI BspHI BspPI BspXi BsrBRI BstENII BstKTI Bsu15I ClaI DpnII FbaI HphI Hpy188I Hpy188III Ksp22I MamI MboI MboII MflI NdeII NruI TaqI TthHB8I XbaI]
  set dcmenz [list AatI Acc65I AccB7I AlwNI ApaI Asp718I AvaII BalI BanI Bme1390I BpmI BsaI BsaHI BseLI BshNI BslI BsmFI Bsp120I BssKI BstXI CaiI Cfr13I CfrI DraII EaeI Eco31I Eco47I EcoO109I EcoRII GsuI MlsI MscI MspR9I NlaIV PflMI PpuMI PspGI PspOMI PspPI Sau96I ScrFI SexAI SfoI StuI StyD4I VpaK11BI]

  set a [toplevel .methylation_dialog]
  wm protocol .methylation_dialog WM_DELETE_WINDOW "set ok2 1"
  bind .methylation_dialog <KeyPress-Escape>  "set ok2 -1"
  wm title .methylation_dialog [mc "Verify Methylation..."]
  set raisedialog_store [bind . <<RaiseDialogs>>]
  bind . <<RaiseDialogs>> "wm deiconify .methylation_dialog; raise .methylation_dialog"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $parent_win] wgeom winx winy
  wm geometry .methylation_dialog "+[expr (($winx<0)?0:$winx)+20]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .methylation_dialog $parent_win
  } else {
    ::tk::unsupported::MacWindowStyle style .methylation_dialog document {closeBox}
  }

  set ok2 0


  grid [label .methylation_dialog.label1 -text [mc {Dam blocked:}]] -row 0 -column 1 -sticky nw
  grid [listbox $a.damlist -yscrollcommand "$a.damscroll set" -selectmode multiple -exportselection 0] -row 1 -column 1 -sticky nwe
  grid [scrollbar $a.damscroll -command "$a.damlist yview" -orient vertical] -row 1 -column 2 -sticky nswe
 # bind $a <MouseWheel> "event generate $a.damlist <MouseWheel> -delta %D"
  grid [label .methylation_dialog.label2 -text [mc {Dcm blocked:}]] -row 0 -column 4 -sticky nw
  grid [listbox $a.dcmlist -yscrollcommand "$a.dcmscroll set" -selectmode multiple -exportselection 0] -row 1 -column 4 -sticky nwe
  grid [scrollbar $a.dcmscroll -command "$a.dcmlist yview" -orient vertical] -row 1 -column 5 -sticky nswe
  grid [button $a.ok -text [mc OK] -command "set ok2 1"] -row 2 -column 1 -sticky n
  grid columnconfigure $a.damlist 0 -weight 0
  grid columnconfigure $a.damlist 1 -weight 1
  grid columnconfigure $a.damlist 2 -weight 0
  grid columnconfigure $a.damlist 3 -weight 0
  grid columnconfigure $a.damlist 4 -weight 1
  grid columnconfigure $a.damlist 5 -weight 0

  foreach element $selectedenzymes {
    set pattern $enzinfo(flatpat,$element) 
    #regsub -all {\(([0-9]|[/-])*\)} $pattern "" pattern
    #regsub "\\^" $pattern "" pattern
    #set pattern [string trim $pattern "N"]

    set pattern "NN[append pattern NN]"
    set metlist [list]
    if {[set found [regexp -all -inline -indices {(?:[GBDKNRSV][ADHMRVW][TBDHKNWY][CBHMNSVY])|(?:[GBDKNRSV][ADHMNRVW][TBDHKWY][CBHMNSVY])} $pattern]] != 0 } {
      foreach index $found {
        set metlist [list]
        lappend metlist [expr {[lindex $index 0]-2}] [expr {[string length $pattern]-[lindex $index 0]-6}]
        set metlist [lsort -integer $metlist]
        if {[$a.damlist get end] != "$element $metlist" } {
          $a.damlist insert end "$element $metlist"
          if {[lsearch $damenz $element] > -1} {$a.damlist selection set end}
        }
      }
    }
    set pattern "N[append pattern N]"
    set metlist [list]
    if {[set found [regexp -inline -all -indices {(?:[CBHMNSVY][CBHMSVY][ATBDHKMNRVWY][GBDKNRSV][GBDKNRSV])|(?:[CBHMNSVY][CBHMNSVY][ATBDHKMNRVWY][GBDKRSV][GBDKNRSV])} $pattern]] !=0} {
      foreach index $found {
        set metlist [list]
        lappend metlist [expr {[lindex $index 0]-3}] [expr {[string length $pattern]-[lindex $index 0]-8}]
        set metlist [lsort -integer $metlist]
        if {[$a.dcmlist get end] != "$element $metlist" } {
          $a.dcmlist insert end "$element $metlist"
          if {[lsearch $dcmenz $element] > -1} {$a.dcmlist selection set end}
        }
      }
    }
  }

  #grab set $a
  wm deiconify $a; raise $a
  focus $a.damlist

  vwait ok2

  #grab release $a
  foreach element [$a.damlist curselection] {
    lappend dam_methylated_enzymes [$a.damlist get $element]
  }
  foreach element [$a.dcmlist curselection] {
    lappend dcm_methylated_enzymes [$a.dcmlist get $element]
  }
  set methylated_enzymes [list [list MDam $dam_methylated_enzymes] [list MDcm $dcm_methylated_enzymes]]
  destroy .methylation_dialog
  set ok2 0
  bind . <<RaiseDialogs>> $raisedialog_store
  return $methylated_enzymes
}

###############
## edit the DNA ladders file
###############
proc edit_ladders {w} {
  global info temp_info ok dialogblock
  if {$dialogblock == 1} {return}
  set dialogblock 1

  set temp_info(current_ladder) $info(current_ladder)
  set temp_info(ladderlist) $info(ladderlist)

  toplevel .dialog
  wm title .dialog [mc "Ladders..."]
  wm protocol .dialog WM_DELETE_WINDOW "set ok -1"
  bind .dialog <KeyPress-Escape>  "set ok -1"
  bind . <<RaiseDialogs>> "wm deiconify .dialog; raise .dialog"
  regexp {[0-9]*x[0-9]*\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry $w] wgeom winx winy
  wm geometry .dialog "+[expr (($winx<0)?0:$winx)+3]+[expr (($winy<0)?0:$winy)+50]"
  if {[tk windowingsystem] != "aqua"} {
    wm transient .dialog $w
  } else {
    ::tk::unsupported::MacWindowStyle style .dialog document {closeBox}
  }
  set ok 0

  grid [frame .dialog.listframe -relief ridge -borderwidth 2] -row 0 -column 1 -sticky nswe
  grid [frame .dialog.ladderframe -relief ridge -borderwidth 2] -row 0 -column 2 -sticky nswe
  grid [frame .dialog.okframe -relief ridge -borderwidth 2] -row 1 -column 1 -columnspan 2 -sticky nswe
  grid rowconfigure .dialog 0 -weight 1
  grid columnconfigure .dialog 1 -weight 1

  grid [listbox .dialog.listframe.list -selectmode single -bg white -yscrollcommand "optionscrollbar .dialog.listframe.scroll" -exportselection 0 -width 40] -row 0 -column 0 -columnspan 2 -sticky nswe
  grid [scrollbar .dialog.listframe.scroll -command ".dialog.listframe.list yview"] -row 0 -column 2 -sticky nsw
  grid [button .dialog.listframe.add -text [mc "Add New"] -command "event generate .dialog.listframe.list <<add>>"] -row 1 -column 0 -sticky we
  grid [button .dialog.listframe.delete -text [mc "Delete"] -command "event generate .dialog.listframe.list <<delete>>"] -row 1 -column 1 -sticky we
  grid [button .dialog.listframe.raise -text [mc "Raise"] -command "event generate .dialog.listframe.list <<raise>>"] -row 2 -column 0 -sticky we
  grid [button .dialog.listframe.lower -text [mc "Lower"] -command "event generate .dialog.listframe.list <<lower>>"] -row 2 -column 1 -sticky we
  grid [button .dialog.listframe.load -text [mc "Load..."] -command "event generate .dialog.listframe.list <<load>>"] -row 3 -column 0 -sticky we
  grid [button .dialog.listframe.save_as -text [mc "Save As"] -command "event generate .dialog.listframe.list <<save_as>>"] -row 3 -column 1 -sticky we
  grid rowconfigure .dialog.listframe 0 -weight 1
  grid columnconfigure .dialog.listframe 0 -weight 1
  grid columnconfigure .dialog.listframe 1 -weight 1

  grid [label .dialog.ladderframe.l1 -text [mc "Ladder:"]] -row 0 -column 0 -columnspan 2 -stick nwe
  grid [entry .dialog.ladderframe.ladd_name -bg white -textvariable temp_info(ladder_entry) -width 40] -row 1 -column 0 -columnspan 2 -stick nwe
  grid [canvas .dialog.ladderframe.ladder -bg white -height 300 -width 10] -row 2 -column 0 -columnspan 2 -sticky nsew
  grid [label .dialog.ladderframe.l2 -text [mc "Band:"]] -row 3 -column 0 -columnspan 2 -stick nwe
  grid [entry .dialog.ladderframe.band -bg white -validate key -validatecommand {expr {![regexp {[^0-9]} %P]}}] -row 4 -column 0 -columnspan 2 -sticky nwe
  grid [button .dialog.ladderframe.add -text [mc "Add"] -command {if {[.dialog.ladderframe.band get] != ""} {set temp_info(ladder,$temp_info(current_ladder)) [lsort -decreasing -integer [lappend temp_info(ladder,$temp_info(current_ladder)) [.dialog.ladderframe.band get]]]; event generate .dialog <<update_ladder>>}}] -row 5 -column 0 -sticky we
  grid [button .dialog.ladderframe.delete -text [mc "Delete"] -command {set temp_info(ladder,$temp_info(current_ladder)) [lsort -decreasing -integer [lsearch -inline -not -all $temp_info(ladder,$temp_info(current_ladder)) [.dialog.ladderframe.band get]]]; event generate .dialog <<update_ladder>>}] -row 5 -column 1 -sticky we
  grid rowconfigure .dialog.ladderframe 2 -weight 1



  bind .dialog.ladderframe.band <Key-Return> {if {[.dialog.ladderframe.band get] != ""} {set temp_info(ladder,$temp_info(current_ladder)) [lsort -decreasing -integer [lappend temp_info(ladder,$temp_info(current_ladder)) [.dialog.ladderframe.band get]]]; event generate .dialog <<update_ladder>>}}

  grid [button .dialog.okframe.ok -text [mc "OK"] -command "set ok 1"] -row 0 -column 0 -sticky n
  grid columnconfigure .dialog.okframe 0 -weight 1

##binding to re-draw the ladder
  bind .dialog <<update_ladder>> {
    .dialog.ladderframe.ladder delete bands
    if {([.dialog.listframe.list size] > 0)} {
      if {($temp_info(ladder,$temp_info(current_ladder)) != "")} {
        .dialog.ladderframe.delete configure -state normal
        #redraw the current ladder in the canvas
        set longfrag [lindex $temp_info(ladder,$temp_info(current_ladder)) 0]
        set shortfrag [lindex $temp_info(ladder,$temp_info(current_ladder)) end]
        while {$shortfrag < 1} {
          set temp_info(ladder,$temp_info(current_ladder)) [lrange $temp_info(ladder,$temp_info(current_ladder)) 0 end-1]
          set shortfrag [lindex $temp_info(ladder,$temp_info(current_ladder)) end]
        }
        if {$shortfrag != ""} {
          if {$shortfrag != $longfrag} {
            set gelscale [expr {210.0/(log10($longfrag)- log10($shortfrag))}]
            set gelorigin [expr {30.0 + $gelscale * log10($longfrag) }]
          } else {
            set gelscale 0
            set gelorigin 30
          }

          #draw ladder
          set lastladderband 0

          foreach band $temp_info(ladder,$temp_info(current_ladder)) {
            if {$lastladderband != $band} {
              if {[lindex $band 0] > 0} {
                .dialog.ladderframe.ladder create line [expr {5}] [expr {$gelorigin - $gelscale * log10($band)}] [expr {55}] [expr {$gelorigin - $gelscale *log10($band)}] -width 3 -capstyle round -tags [list bands ladderband$band scalable]
              }
              .dialog.ladderframe.ladder bind ladderband$band <Any-Enter> ".dialog.ladderframe.ladder itemconfigure laddertext -text [string range $band 0 end-3][expr {([string length $band]>3)?",":{}}][string range $band end-2 end]"
              .dialog.ladderframe.ladder bind ladderband$band <Any-Leave> ".dialog.ladderframe.ladder itemconfigure laddertext -text {}"
              .dialog.ladderframe.ladder bind ladderband$band <Button-1> ".dialog.ladderframe.band delete 0 end;.dialog.ladderframe.band insert 0 $band"
              set lastladderband $band
            } else {
              .dialog.ladderframe.ladder itemconfigure ladderband$band -width [expr {[.dialog.ladderframe.ladder itemcget ladderband$band -width]+1}]
            }
          }
        }
      } else {
        .dialog.ladderframe.delete configure -state disabled
      }
    }     
  } 

##binding to change to a different ladder in listbox
  bind .dialog.listframe.list <<ListboxSelect>> {
    if {[.dialog.listframe.list curselection] != ""} {
      set temp_info(ladder_entry) [.dialog.listframe.list get [.dialog.listframe.list curselection]]
    } else {
      set temp_info(ladder_entry) ""
    }
    set temp_info(current_ladder) $temp_info(ladder_entry)
    event generate .dialog <<update_ladder>> 
  }

##binding to raise a ladder in the list
  bind .dialog.listframe.list <<raise>> {
    if {[.dialog.listframe.list size] > 0} {
      set i [.dialog.listframe.list curselection]
      if {$i > 0} {
        set item1 [.dialog.listframe.list get $i]
        .dialog.listframe.list delete $i
        incr i -1
        set item2 [.dialog.listframe.list get $i]
        .dialog.listframe.list insert $i $item1
        .dialog.listframe.list selection set $i
        set temp_info(ladderlist) [lreplace $temp_info(ladderlist) $i [expr {$i+1}] $item1 $item2]
        event generate .dialog <<update_ladder>>
      } else {bell}
    }
  }
##binding to lower a ladder in the list
  bind .dialog.listframe.list <<lower>> {
    if {[.dialog.listframe.list size] > 0} {
      set i [.dialog.listframe.list curselection]
      if {$i < [expr {[.dialog.listframe.list size]-1}]} {
        set item1 [.dialog.listframe.list get $i]
        .dialog.listframe.list delete $i
        set item2 [.dialog.listframe.list get $i]
        incr i 1
        .dialog.listframe.list insert $i $item1
        .dialog.listframe.list selection set $i
        set temp_info(ladderlist) [lreplace $temp_info(ladderlist) [expr {$i-1}] $i $item2 $item1]
        event generate .dialog <<update_ladder>>
      } else {bell}
    }
  }
##binding to delete a ladder in the list
  bind .dialog.listframe.list <<delete>> {
    if {[.dialog.listframe.list size] > 0} {
      set i [.dialog.listframe.list curselection]
      .dialog.listframe.list delete $i
      set temp_info(ladderlist) [lreplace $temp_info(ladderlist) $i $i]
      array unset temp_info "ladder,$temp_info(current_ladder)"
      if {$i == [.dialog.listframe.list size]} {incr i -1}
      .dialog.listframe.list selection set $i
      set temp_info(ladder_entry) [.dialog.listframe.list get $i]
      set temp_info(current_ladder) $temp_info(ladder_entry)
      event generate .dialog <<update_ladder>>
    }
    if {[.dialog.listframe.list size] == 0} {
      .dialog.listframe.delete configure -state disabled
      .dialog.ladderframe.add configure -state disabled
      .dialog.ladderframe.delete configure -state disabled
      .dialog.ladderframe.ladd_name configure -state disabled
      .dialog.ladderframe.band configure -state disabled
    }
    if {[.dialog.listframe.list size] <= 1} {
      .dialog.listframe.raise configure -state disabled
      .dialog.listframe.lower configure -state disabled
    }
  }
##binding to add a new ladder to the list
  bind .dialog.listframe.list <<add>> {
    if {[.dialog.listframe.list size] == 0} {
      .dialog.listframe.delete configure -state normal
      .dialog.ladderframe.add configure -state normal
      .dialog.ladderframe.delete configure -state normal
      .dialog.ladderframe.ladd_name configure -state normal
      .dialog.ladderframe.band configure -state normal
      set i 0
    } else {
      set i [.dialog.listframe.list curselection]
    }
    set new_name "New Ladder"
    set j 0
    while {[lsearch -exact $temp_info(ladderlist) $new_name] > -1} {incr j; set new_name "New Ladder($j)"}
    .dialog.listframe.list insert $i $new_name
    .dialog.listframe.list selection clear 0 end
    .dialog.listframe.list selection set $i
    set temp_info(ladder_entry) $new_name
    set temp_info(current_ladder) $new_name
    set temp_info(ladderlist) [linsert $temp_info(ladderlist) $i $new_name]
    set temp_info(ladder,$new_name) [list]
    event generate .dialog <<update_ladder>>
    if {[.dialog.listframe.list size] > 1} {
      .dialog.listframe.raise configure -state normal
      .dialog.listframe.lower configure -state normal
    }
  }
##binding to load ladders from a file
  bind .dialog.listframe.list <<load>> {
    set was_empty 0
    if {[.dialog.listframe.list size] == 0} {
      set was_empty 1
    }
    if {[file exists [file join $info(user_defaults_dir) "DNA_ladders"]]} {set initdir [file join $info(user_defaults_dir) "DNA_ladders"]} else {set initdir $info(user_defaults_dir)}
    set filename [tk_getOpenFile -parent .dialog -title [mc "Load ladder file"] -initialdir $initdir]
    if {[file exists $filename] == 1} {
      set fileid [open $filename r]
      set i [.dialog.listframe.list size]
      while {[eof $fileid] != 1} {
        set a [gets $fileid]
        if {([string index $a 0] != "#") && ($a !="")} {
          set name [lindex [split $a "\t"] 0]
          set new_name $name
          set j 0
          while {[lsearch -exact $temp_info(ladderlist) $new_name] > -1} {incr j; set new_name "$name\($j)"}
          .dialog.listframe.list insert $i $new_name
          set sizes [lindex [split $a "\t"] 1]
          if {[llength $sizes] > 0} {
            if {[catch {set sizes [lsort -decreasing -integer $sizes]}] != 0} {
              warning_dialog "Misformatted ladder file" $name $sizes
            } else {
              lappend temp_info(ladderlist) $new_name
              set temp_info(ladder,$new_name) $sizes
              incr i
            }
          }
        }
      }
      close $fileid
    } 
    event generate .dialog <<update_ladder>>
    if {[.dialog.listframe.list size] > 1} {
      .dialog.listframe.delete configure -state normal
      .dialog.ladderframe.add configure -state normal
      .dialog.ladderframe.delete configure -state normal
      .dialog.ladderframe.ladd_name configure -state normal
      .dialog.ladderframe.band configure -state normal
      .dialog.listframe.raise configure -state normal
      .dialog.listframe.lower configure -state normal
      if {$was_empty == 1} {
        .dialog.listframe.list selection set 0
        set temp_info(ladder_entry) [.dialog.listframe.list get 0]
        set temp_info(current_ladder) [.dialog.listframe.list get 0]
      }
    }
  }
##binding to save current state into a file
  bind .dialog.listframe.list <<save_as>> {
    set filename [tk_getSaveFile -parent .dialog]
    if {$filename == ""} break
    set err [catch {set temp_ladder_file [open $filename w]} save_err]  
    if {![file writable $filename] || $err} {close $filename; tk_messageBox -message "Can't save the ladders file- possibly locked." -type ok -icon error; break}
    puts $temp_ladder_file "#comment lines start with #"
    puts $temp_ladder_file "#enter each new ladder on a new line"
    puts $temp_ladder_file "#start with the name of the ladder"
    puts $temp_ladder_file "#THEN A TAB"
    puts $temp_ladder_file "#then the fragment sizes (decreasing order), separated by a space"
    puts $temp_ladder_file "#no commas in the sizes."
    puts $temp_ladder_file "#enter a band twice or more to make it drawn thicker"
    foreach ladder $temp_info(ladderlist) {
      puts $temp_ladder_file "$ladder\t$temp_info(ladder,$ladder)"
    }
    close $temp_ladder_file
  }
##binding to change the name of a ladder
  bind .dialog.ladderframe.ladd_name <Key-Return> {
    if {[.dialog.listframe.list size] > 0} {
      set pos [.dialog.listframe.list curselection]
      if {[.dialog.listframe.list get $pos] != $temp_info(ladder_entry)} {
        if {[lsearch -exact $temp_info(ladderlist) $temp_info(ladder_entry)] == -1} {
          .dialog.listframe.list delete $pos
          .dialog.listframe.list insert $pos $temp_info(ladder_entry)
          .dialog.listframe.list selection set $pos
          set temp_info(ladderlist) [lreplace $temp_info(ladderlist) $pos $pos $temp_info(ladder_entry)]

          set temp_info(ladder,$temp_info(ladder_entry)) $temp_info(ladder,$temp_info(current_ladder))
          array unset temp_info "ladder,$temp_info(current_ladder)"
          set temp_info(current_ladder) $temp_info(ladder_entry)
        } else {
          bell
          set temp_info(ladder_entry) [.dialog.listframe.list get $pos]
        }
      }
    }
  }

  bind .dialog.ladderframe.ladd_name <FocusOut> [bind .dialog.ladderframe.ladd_name <Key-Return>]

  .dialog.ladderframe.ladder create text 10 10 -text "" -tags laddertext -anchor nw

  foreach ladder $temp_info(ladderlist) {
    .dialog.listframe.list insert end $ladder
    set temp_info(ladder,$ladder) $info(ladder,$ladder)
  }
  .dialog.listframe.list selection set [lsearch $temp_info(ladderlist) $temp_info(current_ladder)]
  update
  event generate .dialog.listframe.list <<ListboxSelect>>
  if {[.dialog.listframe.list size] == 0} {
    .dialog.listframe.delete configure -state disabled
    .dialog.ladderframe.add configure -state disabled
    .dialog.ladderframe.delete configure -state disabled
    .dialog.ladderframe.ladd_name configure -state disabled
    .dialog.ladderframe.band configure -state disabled
  }
  if {[.dialog.listframe.list size] <= 1} {
    .dialog.listframe.raise configure -state disabled
    .dialog.listframe.lower configure -state disabled
  }

  regexp {([0-9]*)x([0-9]*)\+(-?[0-9]*)\+(-?[0-9-]*)} [wm geometry .dialog] wgeom winw winh winx winy
  if {[expr {$winx+$winw}] > [winfo screenwidth .]} {set winx [expr {[winfo screenwidth .]-$winw}]}
  if {$winx < 0} {set winx 0}
  if {[expr {$winy+$winh}] > [winfo screenheight .]} {set winy [expr {[winfo screenheight .]-$winh}]}
  if {$winy < 0} {set winy 0}
  wm geometry .dialog "+$winx+$winy"
  update

  focus .dialog
  vwait ok 
  set dialogblock 0
  destroy .dialog
  bind . <<RaiseDialogs>> ""

  ###execute changes
  if {$ok == 1} {
    set info(current_ladder) $temp_info(current_ladder)
    set info(ladderlist) $temp_info(ladderlist)
    array unset info "ladder,*"
    foreach ladder $temp_info(ladderlist) {
      set info(ladder,$ladder) $temp_info(ladder,$ladder)
    }
    ###need to update the ladder menus on all dna windows
    update_ladders_menu
    ###need to save the new ladder list
    set temp_ladder_file [open [file join $info(user_defaults_dir) temp_ladderq_qqrx.txt] w]
    
    puts $temp_ladder_file "#comment lines start with #"
    puts $temp_ladder_file "#enter each new ladder on a new line"
    puts $temp_ladder_file "#start with the name of the ladder"
    puts $temp_ladder_file "#THEN A TAB"
    puts $temp_ladder_file "#then the fragment sizes (decreasing order), separated by a space"
    puts $temp_ladder_file "#no commas in the sizes."
    puts $temp_ladder_file "#enter a band twice or more to make it drawn thicker"
    foreach ladder $info(ladderlist) {
      puts $temp_ladder_file "$ladder\t$info(ladder,$ladder)"
    }
    close $temp_ladder_file
    if {[file exists [file join $info(user_defaults_dir) DNA_ladders.txt]]} {
      file delete [file join $info(user_defaults_dir) DNA_ladders.txt]
      file rename [file join $info(user_defaults_dir) temp_ladderq_qqrx.txt] [file join $info(user_defaults_dir) DNA_ladders.txt]
    }
  }
  unset ok
  array unset temp_info
}

proc update_ladders_menu {{window_list {}}} {
  global info modstring
  if {$window_list == {}} {
    set window_list [lsearch -inline -all -regexp -not [winfo children .] {abi|analysis|menubar|dialog}]
  }
  foreach win $window_list {
    if {[catch {$win.menubar.enzymes.ladders delete 0 end} err]} {
      sputs ladder menu error $err
      continue
    }
    foreach entry $info(ladderlist) {
      $win.menubar.enzymes.ladders add radiobutton -label $entry -value $entry -variable info(current_ladder)
    }
    $win.menubar.enzymes.ladders add separator
    $win.menubar.enzymes.ladders add command -label [mc "Edit Ladders..."] -command "edit_ladders $win"
  }
}

###############
## read the DNA ladders file
###############
proc read_ladders {{filename ""}} {
  global info
  set info(ladderlist) [list]

  if {$filename == ""} {
    set filename [file join $info(user_defaults_dir) "DNA_ladders.txt"]
  }
  if {[file exists $filename] == 1} {
    set fileid [open $filename r]
    while {[eof $fileid] != 1} {
      set a [gets $fileid]
      if {([string index $a 0] != "#") && ($a !="")} {
        set name [lindex [split $a "\t"] 0]
        set sizes [lindex [split $a "\t"] 1]
        if {[llength $sizes] > 0} {
          if {[catch {set sizes [lsort -decreasing -integer $sizes]}] != 0} {
            warning_dialog "Misformatted ladder file" $name $sizes
          } else {
            lappend info(ladderlist) $name
            set info(ladder,$name) $sizes
          }
        }
      }
    }
    close $fileid
  } 
  if {[llength $info(ladderlist)] == 0} {
    set info(ladderlist) [list]
    set info(ladder,) [list]
    set info(current_ladder) ""
  } else {
    set info(current_ladder) [lindex $info(ladderlist) 0]
  }
}

###############
## read the global defaults file
###############
proc read_defaults {} {
  global info

  set filename [file join $info(user_defaults_dir) "ApE_Defaults.txt"]
  if {[file exists $filename] == 1} {
    set fileid [open $filename r]
    while {[eof $fileid] != 1} {
      set a [gets $fileid]
      if {([string index $a 0] != "#") && ([llength [set b [split $a \t]]] == 2)} {
        set info([lindex $b 0]) [lindex $b 1]
      } elseif {([string index $a 0] != "#") && ($a != "")} {
        sputs error in defaults file: $a
      }
    }
    close $fileid
  } 

  if ![font metrics \{$info(textfontfamily)\} -fixed] {
   set info(textfontfamily) [font actual courier -family]
  }
  if {[expr {[llength $info(keysubstmap)] % 2}] != 0} {
    set info(keysubstmap) [list]
  }
}

###############
## shows a msg box for debugging values
###############
proc warning_dialog {args} { 
  tk_messageBox -message [join [join [list $args] ""] ""] -icon warning -type ok
}

#################################
## main ########################
#################################

## initialize globals
set winum 0
set abiwinum 0
set longnamelist [list]
set hexlist [list]
set enzymes [list]
set info(empty_genbank_header) [list {LOCUS       } {} {DEFINITION  } {.} {ACCESSION   } {} {VERSION     } {} {SOURCE      } {.} {  ORGANISM  } {.}]

array set info [list]
set info(enzymes_saved) 1
set info(mac_antialias_limit) 1
set info(cancel_scroll) ""
set info(mousewheelunits) 120
set info(clock_format) "%a %b %d, %Y %k:%M %Z"
set info(last_update_check) {}
##bug in file writable for windows - set to 1 if windows is reporting wrong values for file writable
set info(lock_bug) 0
set info(update_check_interval) -1
#set info(clock_format) "%c"
set info(dnawindows_list) [list]
set info(dnatitles_list) [list]
set info(max_open_previous) 5
set info(open_previous) [list]
if {[tk windowingsystem] != "aqua"} {
  set info(bg_color) [. cget -background]
} else {
  set info(bg_color) gray91
}
menu .m
set info(menu_bg_color) [.m cget -background]
set info(menu_fg_color) [.m cget -foreground]
set info(menu_select_bg_color) [.m cget -activebackground]
set info(menu_select_fg_color) [.m cget -activeforeground]
destroy .m
text .t
set info(text_bg_color) [.t cget -background]
set info(text_fg_color) [.t cget -foreground]
set info(text_select_bg_color) [.t tag cget sel -background]
set info(text_select_fg_color) #FFFFFF
set info(text_select2_bg_color)  [.t tag cget sel -background]
if {[tk windowingsystem] == "aqua"} {
  set info(text_select2_bg_color) systemHighlightSecondary
} 
set info(text_select2_fg_color) #FFFFFF
destroy .t
label .temp
set info(label_fg_color) [.temp cget -foreground]
destroy .temp
set info(system_default_colors) [list]
foreach value [list bg_color menu_bg_color menu_fg_color menu_select_bg_color menu_select_fg_color text_bg_color text_fg_color text_select_bg_color text_select_fg_color text_select2_bg_color text_select2_fg_color label_fg_color] {
  lappend info(system_default_colors) $value $info($value)
}
unset value
set info(graphic_bg_color) seashell
set info(graphic_fg_color) blue
set info(default_textarea_width) 75
set info(seq_tooltip_alpha) .8
set info(enzyme_highlight_color) red
set info(enzyme_highlight_font) dnafont
set info(enzyme_highlight_underline) 0
set info(enzyme_highlight_transparent) 0
set info(sequence_transparency_mode) overlap
set info(sequence_transparency) 0
set info(find_forward_highlight) gray75
set info(find_reverse_highlight) gray50
set info(find_wrap) 1
set info(show_comment) 1
set info(comment_height) 3
set info(graphic_map_text_properties) ""
set info(circ_map_radius) 100
set info(circ_map_feature_names_centered) 1
set info(circ_map_show_title) 1
set info(circ_map_show_seq_length) 1
set info(circ_map_show_file_comment) 0
set info(circ_map_show_enz_list) 0
set info(circ_map_show_feature_list) 0
set info(linear_map_bump_label) 0
set info(enz_currently_selected) [list]
set info(enz_selector_keep_open) 0
set info(recomb_keep_open) 0
set info(enz_text_dialog_order) [list index enzymes dna translation sec_strand genes features]
set info(enz_text_dna_numbers) "Both"
set info(enz_text_show_index) 1
set info(enz_text_index_char1) "*"
set info(enz_text_index_spacing1) 10
set info(enz_text_index_nums) 1
set info(enz_text_index_char2) "*"
set info(enz_text_index_spacing2) 5
set info(enz_text_index_char3) " "
set info(enz_text_show_features) 1
set info(enz_text_2nd) 0
set info(enz_text_genes) 0
set info(enz_text_show_trans) 0
set info(enz_text_trans) "1_1"
set info(enz_text_show_enz) 0
set info(enz_text_enz) "all"
set info(enz_text_width) 100
set info(enz_text_copy_highlight) 1
set info(enz_list_enz) "all"
set info(enz_list_mode_number) 0
set info(enz_list_columns) 6
set info(find_casens) 0
set info(find_revcom) 1
set info(find_as_aa) 0
set info(find_as_literal) 0
set info(find_pattern) ""
set info(find_allow_mm_number) 0
set info(find_action) "next"
set info(allowedkeys) "ACGTNacgtn*"
set info(graphicfontfamily) [font actual helvetica -family]
set info(textfontfamily) [font actual courier -family]
set info(fixedfontlist) [list]
set info(allfontlist) [lsearch -inline -all -regexp -not [lsort -dictionary [font families]] {[^a-z,0-9,A-Z,\ ,\}\{\_\(\)\-]}]
label .temp
set info(dnafontsize) [lindex [font actual [.temp cget -font]] 3] ;#[lindex [.temp cget -font] 0]
destroy .temp
set info(graphicfontsize) $info(dnafontsize); #10
set info(print_font_size) 8
set info(print_formatted) 0
set info(tk_ps_fonts) [list] 
set info(draw_graphic_connectors) 1
set info(strider_incompatible_warning) 1
set info(methylated_default) 1
set info(translation_window_code) 1
set info(translation_window_spacing) 0
set info(translation_window_revcom) 0
set info(translation_window_width) 20
set info(translation_window_line_numbers) none
set info(translation_window_index_line) 0
set info(translation_window_dna_line) none
set info(translation_window_copy_highlight) 1
set info(clipboard_tags) [list]
set info(show_FeatureTable) 1
set info(selection_shows_Trans) 0
set info(selection_shows_Tm) 0
#setinfo(selection_shows) "None"
set info(clipboard_text) ""
set info(keysubstmap) {}
set info(find_orf_starts) "Met"
set info(find_orf_strand) 1
set info(feature_default_fcolor) cyan
set info(feature_default_rcolor) green
set info(feature_default_gformat) [list arrow_data [list [list 0 1 2 0 0 -1] [list] 0] width 5 offset 0]
set info(feature_default_type_colors) [list]
set info(feature_default_type_gformat) [list]
set info(feature_color_favorites) [list]
set info(transp_feature_color) "#FFFFFF"
set info(feature_scan_on_close) 1
set info(align_select_window2) ""
set info(align_select_region1) all
set info(align_select_region2) all
set info(align_select_rc1) "forward"
set info(align_select_rc2) "forward"
set info(align_linewidth) 100
set info(align_phredtrim) 0
set info(align_trim_to_alignment) 0
set info(mm_penalty) 0
set info(gap_penalty) 0
set info(gap_extension_penalty) 0
set info(NWmax) 300
set info(align_blocksize) 15
set info(align_copy_highlight) 0
set info(default_dnadir) [valid_default_dir]
set info(dnadir_follows_open) 1
set info(default_featuredir) ""
set info(featuredir_follows_open) 1
set info(default_file_extension) .ape
set info(default_file_format) Genbank
set info(genbank_strict_genbank) 0
set info(genbank_skip_blank) 0
set info(save_file_format_warning) 1
set info(ApE_version) ""
set info(suppress_output) 0
set info(leopard_dialog_bug) 0
set info(aqua_active_bg_color) gray78

set info(ncbi_blast,program) "blastn"
set info(ncbi_blast,low_filter) 1
set info(ncbi_blast,expect) 100
set info(ncbi_blast,database) "nr"

set info(wb_blast,program) "blastn"

set info(speak_use_aqua) 1
set info(speak_use_words) 0
set info(speak_voice) {}
set info(speak_delay) 500

set info(entrez,max_hits) 25

set info(wb_blast,expect) 0.01
set info(wb_blast,database) "C. elegans genomic"

set info(NCBI_translation_code_list) {{The Standard Code} FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG {The Vertebrate Mitochondrial Code} FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSS**VVVVAAAADDEEGGGG
{The Yeast Mitochondrial Code} FFLLSSSSYY**CCWWTTTTPPPPHHQQRRRRIIMMTTTTNNKKSSRRVVVVAAAADDEEGGGG {The Mold, Protozoan, and Coelenterate Mitochondrial Code and the Mycoplasma/Spiroplasma Code} FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG {The Invertebrate Mitochondrial Code} FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSSSVVVVAAAADDEEGGGG
 {The Ciliate, Dasycladacean and Hexamita Nuclear Code} FFLLSSSSYYQQCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
 {The Echinoderm and Flatworm Mitochondrial Code} FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNNKSSSSVVVVAAAADDEEGGGG
 {The Euplotid Nuclear Code} FFLLSSSSYY**CCCWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
 {The Bacterial, Archaeal and Plant Plastid Code} FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
 {The Alternative Yeast Nuclear Code} FFLLSSSSYY**CC*WLLLSPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
 {The Ascidian Mitochondrial Code} FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSGGVVVVAAAADDEEGGGG
 {The Alternative Flatworm Mitochondrial Code} FFLLSSSSYYY*CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNNKSSSSVVVVAAAADDEEGGGG
 {Blepharisma Nuclear Code} FFLLSSSSYY*QCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
 {Chlorophycean Mitochondrial Code} FFLLSSSSYY*LCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
 {Trematode Mitochondrial Code} FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNNKSSSSVVVVAAAADDEEGGGG
 {Scenedesmus Obliquus Mitochondrial Code} FFLLSS*SYY*LCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
 {Thraustochytrium Mitochondrial Code} FF*LSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG}
set info(translation_code) FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG
set info(start_codons) ATG
set dialogblock 0

array set info {primer_len_min 20 primer_len_max 25 primer_Tm_min 55 primer_Tm_max 60 primer_gc_min 45 primer_gc_max 60 primer_clamp_min 1 primer_clamp_max 2 primer_consec_max 3 primer_scomp_tot_max 10 primer_scomp_adj_max 5 primer_scomp_3_max 3 primer_hcomp_tot_max 10 primer_hcomp_adj_max 5 primer_hcomp_3_max 3 primer_hcomp_oligo "" primer_check_sc 1 primer_salt 50 primer_dna 250 primer_scan "5'-->3'"}
set abi_info(last_find) ""
set abi_info(find_literal) 0
set abi_info(find_wrap) 0
set abi_info(find_revcom) 0
array set abi_info {colors,C blue colors,T red colors,A green colors,G black colors,N magenta colors,B magenta colors,D magenta colors,H magenta colors,K magenta colors,M magenta colors,R magenta colors,S magenta colors,V magenta colors,W magenta colors,Y magenta}
set info(print_abi_lines_per_page) 5
set info(abi_default_canvas_height) 400
set info(abi_default_canvas_width) 650
set possible_extensions [list .ape .dna .str .seq .abi .ab1 .scf .gb .embl .gcc .gcs .gck]


set toolbarlist [list new open save separator cut copy paste separator select find separator uppercase lowercase separator reverse_com separator enzymes separator graphic_map highlight_enzymes digest text_map separator find_primers align]


check_for_running_process

##FIND ACCESSORY DIRECTORIES

set info(Accdir) [file join [file dirname $argv0] "Accessory Files"]
while {![file isdirectory $info(Accdir)]} {
  set info(Accdir)  [tk_chooseDirectory -title "Please locate the Accessory Files Directory"]
  if {$info(Accdir) == ""} {
    final_exit
  }
}

###need to: set these to null
##SET PROGRAM DEFAULT ENZYME AND FEATURE DIRECTORIES
set info(default_enzymedir) [file join $info(Accdir) "Enzymes"]
set info(default_featuredir) [file join $info(Accdir) "Features"]


##set program default language locale (may be read from default file later)
namespace import msgcat::mclocale
if {[string match -nocase c [mclocale]]} {mclocale en_US}
if {1} {mclocale en_US}
set info(locale) [mclocale]

##initialize http package
package require http
::http::config -useragent "Mozilla/4.75 (X11; U; Linux 2.2.17; i586; Nav)"

set err "no errors"
###INITIALIZE LOCATION OF USER DEFAULTS DIRECTORY
if {$tcl_platform(platform) == "windows"} {
  ##set user defaults directory
  if {$tcl_platform(os) == "Windows 95"} {
   ##Windows 95/98
    if {![initilize_windows_user_defauts [registry get {HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders} AppData]]} {
      sputs "Can't get the user defaults dir from registry, using internal: $err"
      set info(user_defaults_dir) $info(Accdir)
    }
  } else {
   ##NT, XP and Vista
    if {(![catch {set env(APPDATA)}]) && ([initilize_windows_user_defauts $env(APPDATA) "env var"])} {
      #APPDATA env gave a succssful result
    } elseif {(![catch {registry get {HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders} AppData}]) && ([initilize_windows_user_defauts [registry get {HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders} AppData] "registry"])} {
      #APPDATA registry gave a succssful result
    } elseif {(![catch {exec cmd.exe /c echo %APPDATA%}]) && ([initilize_windows_user_defauts [exec cmd.exe /c echo %APPDATA%] "cmd"])} {
      #APPDATA shell cmd gave a succssful result
    } else {
      sputs "Can't get the user defaults dir from environment variables, using internal"
      set info(user_defaults_dir) $info(Accdir)
    }
  }
} elseif {$tcl_platform(platform) == "unix"} {
    if {$tcl_platform(os) == "Linux"} {
      set info(user_defaults_dir) "~/.ApE/"
    } elseif {[tk windowingsystem] == "aqua"} {
      set info(user_defaults_dir) "~/Library/Preferences/ApE/"
    }
}



##Create user defaults directory if it doesn't exist
if {![file isdirectory $info(user_defaults_dir)]} {
  if {[catch {file mkdir $info(user_defaults_dir)} err]} {
     tk_messageBox -message "Can't create users directory in $info(user_defaults_dir), $err" -type ok -icon info
  }
}
####make an empty user defaults file instead??
if {(![file exists [file join $info(user_defaults_dir) ApE_Defaults.txt]]) && ([file exists [file join $info(Accdir) ApE_Defaults.txt]])} {
  while {($info(user_defaults_dir) !="") && ([catch {file copy [file join $info(Accdir) ApE_Defaults.txt] [file join $info(user_defaults_dir) ApE_Defaults.txt]} err])} {
    tk_messageBox -message "Can't create default user preferences" -detail $err -type ok -icon error
    set info(user_defaults_dir) [tk_chooseDirectory -mustexist 1 -title "Choose a user defaults directory"]
  }
  if {$info(user_defaults_dir) == ""} {
    tk_messageBox -message "User preferences cancelled" -type ok -icon error
    final_exit
  }
}
if {(![file exists [file join $info(user_defaults_dir) DNA_ladders.txt]]) && ([file exists [file join $info(Accdir) DNA_ladders.txt]])} {
  catch {file copy [file join $info(Accdir) DNA_ladders.txt] [file join $info(user_defaults_dir) DNA_ladders.txt]}
}

#####READ DEFAULTS (REPLACE PROGRAM DEFAULTS WITH VALUES FROM FILE)
read_defaults

####need to: check for valid $info(default_enzymedir), if doesn't exist then copy from Accdir
#FIND VALID DEFAULT ENZYME DIRECTORY
#check for valid default_enzymedir from defaults file
#then copy $info(Accdir)/Enzymes to user preferences directory if that is valid
#else try asking 
if {$info(default_enzymedir) == [file join $info(Accdir) "Enzymes"]} {
  if {![file exists [file join $info(user_defaults_dir) "Enzymes"]]} {
    catch {file copy [file join $info(Accdir) "Enzymes"] $info(user_defaults_dir)}
  }
  set info(default_enzymedir) [file join $info(user_defaults_dir) "Enzymes"]
}
if {(![file exists [file join $info(default_enzymedir) "Default_Enzymes.txt"]])} {
  if {(![file exists [file join $info(Accdir) "Enzymes" "Default_Enzymes.txt"]])} {
    while {![file isdirectory $info(default_enzymedir)]} {
      set info(default_enzymedir)  [tk_chooseDirectory -title "Please locate the Enzyme Files Directory"]
      if {$info(default_enzymedir) == ""} {
        final_exit
      }
    }
  } elseif {![file isdirectory [set info(default_enzymedir) [file join $info(user_defaults_dir) "Enzymes"]]]} {
    file copy [file join $info(Accdir) "Enzymes"] $info(user_defaults_dir)
  } elseif {![file exist [file join $info(default_enzymedir) "Default_Enzymes.txt"]]} {
    file copy [file join $info(Accdir) "Enzymes" "Default_Enzymes.txt"] [file join $info(default_enzymedir) "Default_Enzymes.txt"]
  }
}

####need to: check for valid $info(default_enzymedir), if doesn't exist then copy from Accdir to user_defaults_dir and set it to be in user_defaults_dir
#FIND VALID DEFAULT FEATURE DIRECTORY
#check for defaults from file
#else copy info(Accdir)/Features to user pref folder 
if {$info(default_featuredir) == [file join $info(Accdir) "Features"]} {
  if {![file exists [file join $info(user_defaults_dir) "Features"]]} {
    file copy [file join $info(Accdir) "Features"] $info(user_defaults_dir)
  }
  set info(default_featuredir) [file join $info(user_defaults_dir) "Features"]
}
if {(![file isdirectory $info(default_featuredir)]) || (![file exists [file join $info(default_featuredir) "Default_Features.txt"]])} {
  if {(![file exists [file join $info(Accdir) "Features" "Default_Features.txt"]])} {
    while {![file isdirectory $info(default_featuredir)]} {
      set info(default_featuredir)  [tk_chooseDirectory -title "Please locate the Feature Files Directory"]
      if {$info(default_featuredir) == ""} {
        final_exit
      }
    }
  } elseif {![file isdirectory [set info(default_featuredir) [file join $info(user_defaults_dir) "Features"]]]} {
    #user_pref_dir/Features dir doesn't exist
    file copy [file join $info(Accdir) "Features"] $info(user_defaults_dir)
  } elseif {![file exist [file join $info(default_featuredir) "Default_Features.txt"]]} {
    #user_pref_dir/Features dir exists, but user_pref_dir/Features/Default_Features file doesn't exist
    file copy [file join $info(Accdir) "Features" "Default_Features.txt"] [file join $info(default_featuredir) "Default_Features.txt"]
  }
}


##check default_dnadir
while { (![file isdirectory $info(default_dnadir)])} {
  set info(default_dnadir) [file dirname $info(default_dnadir)]
  if {[file dirname $info(default_dnadir)] == $info(default_dnadir)} {
    set info(default_dnadir) [valid_default_dir]
  }
}


##copy Ladder files into user preferences
if {(![file exists [file join $info(user_defaults_dir) "DNA_ladders"]]) && ([file exists [file join $info(Accdir) "DNA_ladders"]])} {
  file copy [file join $info(Accdir) "DNA_ladders"] $info(user_defaults_dir)
}

read_ladders

#add recombination prototypes to the default list, if additional prototypes are added to the user defaults
if {[info exists info(recomb,prototypes,additional)]} {
  set info(recomb,prototypes) [concat $info(recomb,prototypes) $info(recomb,prototypes,additional)]
}



read_enzymes [file join $info(default_enzymedir) "Default_Enzymes.txt"]

#read default feature library
if {[file exists [file join $info(default_featuredir) "Default_Features.txt"]]} {
  open_feature_library [file join $info(default_featuredir) "Default_Features.txt"] new 0
} else {
  set fea_info(library) [list]
  set fea_info(library_file) ""
}

#verify all elements in enz_text_dialog_order (if upgrading from previous version)
foreach item [list index enzymes dna translation sec_strand genes features] {
  if {[lsearch -exact $info(enz_text_dialog_order) $item] == -1} {
    lappend info(enz_text_dialog_order) $item
  }
}


#check and correct default colors read from defaults file
#a windows pref file on mac looks awful
if {([tk windowingsystem] !="win32") && ($info(bg_color) == "SystemButtonFace")} {
  foreach {index color} $info(system_default_colors) {
    set info($index) $color
  }
}
#a bad color added by hand or something
foreach {index color} $info(system_default_colors) {
  if {[catch {winfo rgb . $info($index)}]} {
    sputs bad color in defaults:$index $info($index), set to: $color
    set info($index) $color
  }
}
unset index color


#set up graphic map text element properties (needs to be after read_defaults)- only sets defaults if they are not read in from defaults file
if {$info(graphic_map_text_properties) == ""} {
  foreach tag {title seq_length file_comment enz_list feature_list} show {normal normal hidden hidden hidden} x {0 0 0 -500 500} y {-20 0 500 500 500} {
    dict set info(graphic_map_text_properties) circular $tag font [list $info(graphicfontfamily) $info(graphicfontsize)]
    dict set info(graphic_map_text_properties) circular $tag color black
    dict set info(graphic_map_text_properties) circular $tag state $show
    dict set info(graphic_map_text_properties) circular $tag x $x
    dict set info(graphic_map_text_properties) circular $tag y $y
    dict set info(graphic_map_text_properties) circular $tag width 0
  } 
}

if {$info(use_tile)} {

}

##LOAD LANGUAGE FILE
proc mcload {langdir} {
  set x 0
  foreach p [::msgcat::mcpreferences] {
    set langfile [file join $langdir $p.msg]
    if {[file exists $langfile]} {
      incr x
      set fid [open $langfile "r"]
      gets $fid line
      if {[regexp \xFE\xFF $line]||[regexp \xFF\xFE $line]} {
        sputs "reading unicode msg file"
        fconfigure $fid -encoding unicode
        seek $fid 0 start ;# rewind -- real reading is still to come
        set text [read $fid [file size $langfile]]
        regsub -all "\uFEFF|\uFFFE" $text "" text
        uplevel 1 $text
      } else {
        fconfigure $fid -encoding utf-8
        seek $fid 0 start
        set text [read $fid [file size $langfile]]
        if {[llength $text] != 3} {
          sputs "mcload err: not 3 parts in file"
        } elseif {[expr {[llength [lindex $text 2]] % 2}] != 0} {
          sputs "mcload err: translation list not even"
        } elseif {[catch {uplevel 1 $text} err]} {
          sputs error in mcload:$err
        }
      }
      close $fid
    } else {
    }
  }
  ::msgcat::mcset en_us {"insert@" "Insert@" linear Linear circular Circular}
  return $x
}

#if a locale exists in the preferences file, set that locale using mclocale
if {[array names info locale] eq "locale"} {
  mclocale $info(locale)
  #sputs setting locale using mclocale [file join $info(Accdir) Msgs]
} 

#######
#utility proc to convert msg files to tab separated lines msg 
#######
proc mcformatLangFile {} {
 global text
  set langfile [tk_getOpenFile]
  set fid [open $langfile "r"]
  fconfigure $fid -encoding utf-8
  seek $fid 0 start
  set text [read $fid [file size $langfile]]
  if {[llength $text] != 3} {
    sputs "mcload err: not 3 parts in file"
  } elseif {[expr {[llength [lindex $text 2]] % 2}] != 0} {
    sputs "mcload err: translation list not even"
    set testlist [lindex $text 2]
    lappend testlist {}
    foreach {a b} $testlist {
      sputs $a $b
    }
  } else {
    set outfile  [tk_getSaveFile]
    set fid2 [open $outfile "w"]
    fconfigure $fid2 -encoding utf-8
    foreach {a b} [lindex $text 2] {
      puts $fid2 "$a\t$b"
sputs $b
    }
    close $fid2
  }
  close $fid
}


#######
#utility proc to convert tab separated text files to msg files
#######
proc mcreformatLangFile {typestring} {
 global text
  set langfile [tk_getOpenFile]
  set fid [open $langfile "r"]
  fconfigure $fid -encoding utf-8
  seek $fid 0 start
  set text [read $fid [file size $langfile]]
  close $fid
    set outfile  [tk_getSaveFile]
    set fid2 [open $outfile "w"]
    fconfigure $fid2 -encoding utf-8
    puts $fid2 "::msgcat::mcmset $typestring [list [split $text "\t\n"]]"
    close $fid2
}

###INITIALIZE PLATFORM SPECIFIC PROCEDURES (aqua requires mc procedure be defined)
#loads png libraries, so needs to be before read_toolbar_images
if {$tcl_platform(platform) == "windows"} {
    initialize_win32
} elseif {$tcl_platform(platform) == "unix"} {
    if {$tcl_platform(os) == "Linux"} {
    } elseif {[tk windowingsystem] == "aqua"} {
      initialize_aqua
    }
}

#need to add the more arrow buton to the toolbar list after possibly reading it from defaults
read_toolbar_images


setup_special_bindings



  #load the Msgs file (not required for en_us default)
  if {[catch {mcload [file join $info(Accdir) Msgs]} err]} {sputs "mcload err:$err"}

###CREATE DNAFONT AND LABELFONT
if {[lsearch -exact [font names] dnafont] == -1} {
 button .b
  font create labelfont -family [lindex [font actual [.b cget -font]] 1] -size $info(dnafontsize)
  font create boldlabelfont -family [lindex [font actual [.b cget -font]] 1] -size $info(dnafontsize) -weight bold
  destroy .b
  entry .e
  font create entryfont -family [lindex [font actual [.e cget -font]] 1] -size $info(dnafontsize)
  destroy .e
  font create dnafont -family $info(textfontfamily) -size $info(dnafontsize)
  font create bolddnafont -family $info(textfontfamily) -size $info(dnafontsize) -weight bold
}
if {[lsearch -exact [font names] graphicfont] == -1} {
  font create graphicfont -family $info(graphicfontfamily) -size $info(graphicfontsize)
}

####list of tk font names to convert to postscript font names
set tk_fonts ""
set ps_fonts ""
foreach {tk_font ps_font} $info(tk_ps_fonts) {
  lappend tk_fonts "[string tolower $tk_font]_normal" "[string tolower $tk_font]_bold"
  lappend ps_fonts "$ps_font" "$ps_font\-Bold"
}

###comment this out to not use tile widgets (scale, checkbutton, button)
#this has to come before the option database is set up with colors- tile on aqua changes the default bg color
use_tile

####SET WIDGET DEFAULTS
option add *Checkbutton.font labelfont 40
option add *Radiobutton.font labelfont 40
option add *Label.font labelfont 40
option add *Labelframe.font labelfont 40
option add *Button.font labelfont 40
#option add *Menu.font labelfont 40
#option add *Menubutton.font labelfont 40
option add *Listbox.font labelfont 40
option add *Entry.font entryfont 40
if {[tk windowingsystem] eq "aqua"} {
option add *Button.padx 15 40
option add *Button.pady 15 40
}

##Setup default colors
#tk_setPalette background $info(bg_color) troughColor gray50 activeBackground $info(bg_color) activeForeground black selectForeground $info(text_select_fg_color) selectBackground $info(text_select_bg_color);#selectColor white
##bug in tk_setPalette
#unset checkbutton

foreach {option color} [list background $info(bg_color) highlightBackground $info(bg_color) troughColor gray50 activeBackground $info(bg_color) activeForeground black selectForeground $info(text_select_fg_color) selectBackground $info(text_select_bg_color)] {
  option add *$option $color
}
unset option color

option add *Label.foreground $info(label_fg_color)
option add *Checkbutton.foreground $info(label_fg_color)
option add *Radiobutton.foreground $info(label_fg_color)
option add *Labelframe.foreground $info(label_fg_color)

option add *Text.background $info(text_bg_color)
option add *Text.foreground $info(text_fg_color)
option add *Entry.background $info(text_bg_color)
option add *Entry.foreground $info(text_fg_color)

option add *Menu*tearOff 0
option add *Menu*foreground $info(menu_fg_color)
option add *Menu*background $info(menu_bg_color)
option add *Menu*activeBackground $info(menu_select_bg_color)
option add *Menu*activeForeground $info(menu_select_fg_color)

option add *Checkbutton.activeBackground $info(bg_color)
#option add *Button*selectColor white
option add *Radiobutton.activeBackground $info(bg_color)

###Generate the translation maps
set info(translation_map_lists) [gen_translation_map $info(translation_code)]



###if running as a starpack in windows, check for old style shortcut and file associations
if {([tk windowingsystem] == "win32") && (![catch {package require starkit}]) && ($::starkit::mode == "starpack")} {
  if {![catch {set regdata [registry get "HKEY_LOCAL_MACHINE\\Software\\Classes\\ApE.DNA.file\\Shell\\open\\command" ""]}]} {
    regsub -all \\\\ $regdata / regdata
    if {([llength $regdata] == 3)} {
      if {![catch {registry set "HKEY_LOCAL_MACHINE\\Software\\Classes\\ApE.DNA.file\\Shell\\open\\command" {} "\"[file nativename [info nameofexecutable]]\" \"%1\"" sz} errmsg]} {
        tk_messageBox -message "The application file associations have been updated to the new format." -type ok -icon info
      } else {
        tk_messageBox -message $errmsg
      }
    } elseif {[llength $regdata] == 2 && ([lindex $regdata 0] != [info nameofexecutable])} {
      if {![catch {registry set "HKEY_LOCAL_MACHINE\\Software\\Classes\\ApE.DNA.file\\Shell\\open\\command" {} "\"[file nativename [info nameofexecutable]]\" \"%1\"" sz} errmsg]} {
        tk_messageBox -message "The application file associations have been updated to point to a new location of ApE." -type ok -icon info
      } else {
        tk_messageBox -message $errmsg
      }
    }
  }
  if {[string first "AppMain.tcl" [lindex $argv 0]] > -1} {
    tk_messageBox -message "The application shortcut needs to be changed. Try deleting the shortcut and making a new one." -type ok -icon warning
    set argv [lrange $argv 1 end]
  }
}

##do update checks if set to run on startup
##take out the set to -1 if update is reinstalled
set info(update_check_interval) -1
if {($info(update_check_interval) >= 0) && ( ($info(last_update_check) == "")||([expr {[clock seconds] - $info(last_update_check)}] > $info(update_check_interval)))} web_version_check 
if {$info(ApE_version) != $version} {
  set info(ApE_version) $version
  about_dialog .
}


## create the first window (unless a window has been created by Apple open event)
update 

if {([lsearch [winfo children .] ".dna_window*"] == -1) && ([lsearch [winfo children .] ".abi_window*"] == -1)} {
  if {([llength $argv] == 0) || ($tcl_interactive == 1) || ([string index [lindex $argv 0] 0] == "-")} {

    create_window -1
  } else {
    foreach filename $argv {

      if {([file extension $filename] != ".tcl") && ([file extension $filename] != ".exe")} {
        open_file [file nativename $filename]
      }
    }
  }
}

sputs "ApE version $version"
set time1 [clock clicks -milliseconds]
unset time0
unset time1
